/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Oe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ne=function(we){for(var e=[],v=0,P=we.length;v<P;v++)e[v]=Oe[we[v]];return e};define(Oe[71],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=P,e.$8h=I,e.$9h=O;function v(A){return(T,$,a)=>{let R=null,y=null;if(typeof a.value=="function"?(R="value",y=a.value):typeof a.get=="function"&&(R="get",y=a.get),!y)throw new Error("not supported");a[R]=A(y,$)}}function P(A,T,$){let a=null,R=null;if(typeof $.value=="function"?(a="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(a="get",R=$.get),!R)throw new Error("not supported");const y=`$memoize$${T}`;$[a]=function(...c){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,c)}),this[y]}}function I(A,T,$){return v((a,R)=>{const y=`$debounce$${R}`,c=`$debounce$result$${R}`;return function(...D){this[c]||(this[c]=$?$():void 0),clearTimeout(this[y]),T&&(this[c]=T(this[c],...D),D=[this[c]]),this[y]=setTimeout(()=>{a.apply(this,D),this[c]=$?$():void 0},A)}})}function O(A,T,$){return v((a,R)=>{const y=`$throttle$timer$${R}`,c=`$throttle$result$${R}`,D=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...n){if(this[c]||(this[c]=$?$():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),T&&(this[c]=T(this[c],...n)),this[f])return;const o=this[D]+A;o<=Date.now()?(this[D]=Date.now(),a.apply(this,[this[c]]),this[c]=$?$():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[D]=Date.now(),a.apply(this,[this[c]]),this[c]=$?$():void 0},o-Date.now()))}})}});var qn=this&&this.__createBinding||(Object.create?function(we,e,v,P){P===void 0&&(P=v);var I=Object.getOwnPropertyDescriptor(e,v);(!I||("get"in I?!e.__esModule:I.writable||I.configurable))&&(I={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(we,P,I)}:function(we,e,v,P){P===void 0&&(P=v),we[P]=e[v]}),Vn=this&&this.__setModuleDefault||(Object.create?function(we,e){Object.defineProperty(we,"default",{enumerable:!0,value:e})}:function(we,e){we.default=e}),qe=this&&this.__importStar||function(we){if(we&&we.__esModule)return we;var e={};if(we!=null)for(var v in we)v!=="default"&&Object.prototype.hasOwnProperty.call(we,v)&&qn(e,we,v);return Vn(e,we),e};define(Oe[135],Ne([1,0,17]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$6c=I,e.$7c=O,e.$8c=A,e.$9c=T,e.$0c=$,e.$$c=a,v=qe(v);const P=(D,f)=>D===f;e.$5c=P;function I(D=e.$5c){return(f,n)=>v.$tb(f,n,D)}function O(){return(D,f)=>JSON.stringify(D)===JSON.stringify(f)}function A(){return(D,f)=>D.equals(f)}function T(D,f,n){if(n!==void 0){const o=D;return o==null||f===void 0||f===null?f===o:n(o,f)}else{const o=D;return(s,l)=>s==null||l===void 0||l===null?l===s:o(s,l)}}function $(D,f){if(D===f)return!0;if(Array.isArray(D)&&Array.isArray(f)){if(D.length!==f.length)return!1;for(let n=0;n<D.length;n++)if(!$(D[n],f[n]))return!1;return!0}if(D&&typeof D=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(D)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const n=D,o=f,s=Object.keys(n),l=Object.keys(o),i=new Set(l);if(s.length!==l.length)return!1;for(const r of s)if(!i.has(r)||!$(n[r],o[r]))return!1;return!0}return!1}function a(D){return JSON.stringify(c(D))}let R=0;const y=new WeakMap;function c(D){if(Array.isArray(D))return D.map(c);if(D&&typeof D=="object")if(Object.getPrototypeOf(D)===Object.prototype){const f=D,n=Object.create(null);for(const o of Object.keys(f).sort())n[o]=c(f[o]);return n}else{let f=y.get(D);return f===void 0&&(f=R++,y.set(D,f)),f+"----2b76a038c20c4bcc"}return D}}),define(Oe[96],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=void 0;class v{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$$P=v,e.$_P=new v("id#")}),define(Oe[136],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=A,e.$Un=y,e.$Vn=c,e.$Wn=D,e.$Xn=f,e.$Yn=n,e.$Zn=o,e.$1n=s,e.$2n=l,e.$3n=i,e.$4n=r;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,g=!1){let u=0;const p=t.length;let m="",h=0,E=P.Unknown,S=v.None;function w(M){let V=0,W=0;for(;V<M;){const L=t.charCodeAt(u);if(L>=R._0&&L<=R._9)W=W*16+L-R._0;else if(L>=R.A&&L<=R.F)W=W*16+L-R.A+10;else if(L>=R.a&&L<=R.f)W=W*16+L-R.a+10;else break;u++,V++}return V<M&&(W=-1),W}function k(M){u=M,m="",h=0,E=P.Unknown,S=v.None}function C(){const M=u;if(t.charCodeAt(u)===R._0)u++;else for(u++;u<t.length&&a(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===R.dot)if(u++,u<t.length&&a(t.charCodeAt(u)))for(u++;u<t.length&&a(t.charCodeAt(u));)u++;else return S=v.UnexpectedEndOfNumber,t.substring(M,u);let V=u;if(u<t.length&&(t.charCodeAt(u)===R.E||t.charCodeAt(u)===R.e))if(u++,(u<t.length&&t.charCodeAt(u)===R.plus||t.charCodeAt(u)===R.minus)&&u++,u<t.length&&a(t.charCodeAt(u))){for(u++;u<t.length&&a(t.charCodeAt(u));)u++;V=u}else S=v.UnexpectedEndOfNumber;return t.substring(M,V)}function d(){let M="",V=u;for(;;){if(u>=p){M+=t.substring(V,u),S=v.UnexpectedEndOfString;break}const W=t.charCodeAt(u);if(W===R.doubleQuote){M+=t.substring(V,u),u++;break}if(W===R.backslash){if(M+=t.substring(V,u),u++,u>=p){S=v.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case R.doubleQuote:M+='"';break;case R.backslash:M+="\\";break;case R.slash:M+="/";break;case R.b:M+="\b";break;case R.f:M+="\f";break;case R.n:M+=`
`;break;case R.r:M+="\r";break;case R.t:M+="	";break;case R.u:{const Y=w(4);Y>=0?M+=String.fromCharCode(Y):S=v.InvalidUnicode;break}default:S=v.InvalidEscapeCharacter}V=u;continue}if(W>=0&&W<=31)if($(W)){M+=t.substring(V,u),S=v.UnexpectedEndOfString;break}else S=v.InvalidCharacter;u++}return M}function b(){if(m="",S=v.None,h=u,u>=p)return h=p,E=P.EOF;let M=t.charCodeAt(u);if(T(M)){do u++,m+=String.fromCharCode(M),M=t.charCodeAt(u);while(T(M));return E=P.Trivia}if($(M))return u++,m+=String.fromCharCode(M),M===R.carriageReturn&&t.charCodeAt(u)===R.lineFeed&&(u++,m+=`
`),E=P.LineBreakTrivia;switch(M){case R.openBrace:return u++,E=P.OpenBraceToken;case R.closeBrace:return u++,E=P.CloseBraceToken;case R.openBracket:return u++,E=P.OpenBracketToken;case R.closeBracket:return u++,E=P.CloseBracketToken;case R.colon:return u++,E=P.ColonToken;case R.comma:return u++,E=P.CommaToken;case R.doubleQuote:return u++,m=d(),E=P.StringLiteral;case R.slash:{const V=u-1;if(t.charCodeAt(u+1)===R.slash){for(u+=2;u<p&&!$(t.charCodeAt(u));)u++;return m=t.substring(V,u),E=P.LineCommentTrivia}if(t.charCodeAt(u+1)===R.asterisk){u+=2;const W=p-1;let L=!1;for(;u<W;){if(t.charCodeAt(u)===R.asterisk&&t.charCodeAt(u+1)===R.slash){u+=2,L=!0;break}u++}return L||(u++,S=v.UnexpectedEndOfComment),m=t.substring(V,u),E=P.BlockCommentTrivia}return m+=String.fromCharCode(M),u++,E=P.Unknown}case R.minus:if(m+=String.fromCharCode(M),u++,u===p||!a(t.charCodeAt(u)))return E=P.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return m+=C(),E=P.NumericLiteral;default:for(;u<p&&F(M);)u++,M=t.charCodeAt(u);if(h!==u){switch(m=t.substring(h,u),m){case"true":return E=P.TrueKeyword;case"false":return E=P.FalseKeyword;case"null":return E=P.NullKeyword}return E=P.Unknown}return m+=String.fromCharCode(M),u++,E=P.Unknown}}function F(M){if(T(M)||$(M))return!1;switch(M){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function N(){let M;do M=b();while(M>=P.LineCommentTrivia&&M<=P.Trivia);return M}return{setPosition:k,getPosition:()=>u,scan:g?N:b,getToken:()=>E,getTokenValue:()=>m,getTokenOffset:()=>h,getTokenLength:()=>u-h,getTokenError:()=>S}}function T(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function $(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function a(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function y(t,g){const u=[],p=new Object;let m;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function S(w,k,C,d){h.value=w,h.offset=k,h.length=C,h.type=d,h.colonOffset=void 0,m=h}try{i(t,{onObjectBegin:(w,k)=>{if(g<=w)throw p;m=void 0,E=g>w,u.push("")},onObjectProperty:(w,k,C)=>{if(g<k||(S(w,k,C,"property"),u[u.length-1]=w,g<=k+C))throw p},onObjectEnd:(w,k)=>{if(g<=w)throw p;m=void 0,u.pop()},onArrayBegin:(w,k)=>{if(g<=w)throw p;m=void 0,u.push(0)},onArrayEnd:(w,k)=>{if(g<=w)throw p;m=void 0,u.pop()},onLiteralValue:(w,k,C)=>{if(g<k||(S(w,k,C,r(w)),g<=k+C))throw p},onSeparator:(w,k,C)=>{if(g<=k)throw p;if(w===":"&&m&&m.type==="property")m.colonOffset=k,E=!1,m=void 0;else if(w===","){const d=u[u.length-1];typeof d=="number"?u[u.length-1]=d+1:(E=!0,u[u.length-1]=""),m=void 0}}})}catch(w){if(w!==p)throw w}return{path:u,previousNode:m,isAtPropertyKey:E,matches:w=>{let k=0;for(let C=0;k<w.length&&C<u.length;C++)if(w[k]===u[C]||w[k]==="*")k++;else if(w[k]!=="**")return!1;return k===w.length}}}function c(t,g=[],u=O.DEFAULT){let p=null,m=[];const h=[];function E(w){Array.isArray(m)?m.push(w):p!==null&&(m[p]=w)}return i(t,{onObjectBegin:()=>{const w={};E(w),h.push(m),m=w,p=null},onObjectProperty:w=>{p=w},onObjectEnd:()=>{m=h.pop()},onArrayBegin:()=>{const w=[];E(w),h.push(m),m=w,p=null},onArrayEnd:()=>{m=h.pop()},onLiteralValue:E,onError:(w,k,C)=>{g.push({error:w,offset:k,length:C})}},u),m[0]}function D(t,g=[],u=O.DEFAULT){let p={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(w){p.type==="property"&&(p.length=w-p.offset,p=p.parent)}function h(w){return p.children.push(w),w}i(t,{onObjectBegin:w=>{p=h({type:"object",offset:w,length:-1,parent:p,children:[]})},onObjectProperty:(w,k,C)=>{p=h({type:"property",offset:k,length:-1,parent:p,children:[]}),p.children.push({type:"string",value:w,offset:k,length:C,parent:p})},onObjectEnd:(w,k)=>{p.length=w+k-p.offset,p=p.parent,m(w+k)},onArrayBegin:(w,k)=>{p=h({type:"array",offset:w,length:-1,parent:p,children:[]})},onArrayEnd:(w,k)=>{p.length=w+k-p.offset,p=p.parent,m(w+k)},onLiteralValue:(w,k,C)=>{h({type:r(w),offset:k,length:C,parent:p,value:w}),m(k+C)},onSeparator:(w,k,C)=>{p.type==="property"&&(w===":"?p.colonOffset=k:w===","&&m(k))},onError:(w,k,C)=>{g.push({error:w,offset:k,length:C})}},u);const S=p.children[0];return S&&delete S.parent,S}function f(t,g){if(!t)return;let u=t;for(const p of g)if(typeof p=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const h of u.children)if(Array.isArray(h.children)&&h.children[0].value===p){u=h.children[1],m=!0;break}if(!m)return}else{const m=p;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}function n(t){if(!t.parent||!t.parent.children)return[];const g=n(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;g.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&g.push(u)}return g}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const g=Object.create(null);for(const u of t.children){const p=u.children[1];p&&(g[u.children[0].value]=o(p))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,g,u=!1){return g>=t.offset&&g<t.offset+t.length||u&&g===t.offset+t.length}function l(t,g,u=!1){if(s(t,g,u)){const p=t.children;if(Array.isArray(p))for(let m=0;m<p.length&&p[m].offset<=g;m++){const h=l(p[m],g,u);if(h)return h}return t}}function i(t,g,u=O.DEFAULT){const p=A(t,!1);function m(ce){return ce?()=>ce(p.getTokenOffset(),p.getTokenLength()):()=>!0}function h(ce){return ce?$e=>ce($e,p.getTokenOffset(),p.getTokenLength()):()=>!0}const E=m(g.onObjectBegin),S=h(g.onObjectProperty),w=m(g.onObjectEnd),k=m(g.onArrayBegin),C=m(g.onArrayEnd),d=h(g.onLiteralValue),b=h(g.onSeparator),F=m(g.onComment),N=h(g.onError),M=u&&u.disallowComments,V=u&&u.allowTrailingComma;function W(){for(;;){const ce=p.scan();switch(p.getTokenError()){case v.InvalidUnicode:L(I.InvalidUnicode);break;case v.InvalidEscapeCharacter:L(I.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:L(I.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:M||L(I.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:L(I.UnexpectedEndOfString);break;case v.InvalidCharacter:L(I.InvalidCharacter);break}switch(ce){case P.LineCommentTrivia:case P.BlockCommentTrivia:M?L(I.InvalidCommentToken):F();break;case P.Unknown:L(I.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return ce}}}function L(ce,$e=[],oe=[]){if(N(ce),$e.length+oe.length>0){let Ce=p.getToken();for(;Ce!==P.EOF;){if($e.indexOf(Ce)!==-1){W();break}else if(oe.indexOf(Ce)!==-1)break;Ce=W()}}}function Y(ce){const $e=p.getTokenValue();return ce?d($e):S($e),W(),!0}function Z(){switch(p.getToken()){case P.NumericLiteral:{let ce=0;try{ce=JSON.parse(p.getTokenValue()),typeof ce!="number"&&(L(I.InvalidNumberFormat),ce=0)}catch{L(I.InvalidNumberFormat)}d(ce);break}case P.NullKeyword:d(null);break;case P.TrueKeyword:d(!0);break;case P.FalseKeyword:d(!1);break;default:return!1}return W(),!0}function ge(){return p.getToken()!==P.StringLiteral?(L(I.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(Y(!1),p.getToken()===P.ColonToken?(b(":"),W(),se()||L(I.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):L(I.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function _(){E(),W();let ce=!1;for(;p.getToken()!==P.CloseBraceToken&&p.getToken()!==P.EOF;){if(p.getToken()===P.CommaToken){if(ce||L(I.ValueExpected,[],[]),b(","),W(),p.getToken()===P.CloseBraceToken&&V)break}else ce&&L(I.CommaExpected,[],[]);ge()||L(I.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),ce=!0}return w(),p.getToken()!==P.CloseBraceToken?L(I.CloseBraceExpected,[P.CloseBraceToken],[]):W(),!0}function fe(){k(),W();let ce=!1;for(;p.getToken()!==P.CloseBracketToken&&p.getToken()!==P.EOF;){if(p.getToken()===P.CommaToken){if(ce||L(I.ValueExpected,[],[]),b(","),W(),p.getToken()===P.CloseBracketToken&&V)break}else ce&&L(I.CommaExpected,[],[]);se()||L(I.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),ce=!0}return C(),p.getToken()!==P.CloseBracketToken?L(I.CloseBracketExpected,[P.CloseBracketToken],[]):W(),!0}function se(){switch(p.getToken()){case P.OpenBracketToken:return fe();case P.OpenBraceToken:return _();case P.StringLiteral:return Y(!0);default:return Z()}}return W(),p.getToken()===P.EOF?u.allowEmptyContent?!0:(L(I.ValueExpected,[],[]),!1):se()?(p.getToken()!==P.EOF&&L(I.EndOfFileExpected,[],[]),!0):(L(I.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(we,e){typeof define=="function"&&define.amd?define(Oe[137],Ne([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(ae,be){for(var ue=0;ue<be.length;ue++){var J=be[ue];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ae,J.key,J)}}function v(ae,be,ue){return be&&e(ae.prototype,be),ue&&e(ae,ue),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function P(ae,be){if(ae){if(typeof ae=="string")return I(ae,be);var ue=Object.prototype.toString.call(ae).slice(8,-1);if(ue==="Object"&&ae.constructor&&(ue=ae.constructor.name),ue==="Map"||ue==="Set")return Array.from(ae);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return I(ae,be)}}function I(ae,be){(be==null||be>ae.length)&&(be=ae.length);for(var ue=0,J=new Array(be);ue<be;ue++)J[ue]=ae[ue];return J}function O(ae,be){var ue=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(ue)return(ue=ue.call(ae)).next.bind(ue);if(Array.isArray(ae)||(ue=P(ae))||be&&ae&&typeof ae.length=="number"){ue&&(ae=ue);var J=0;return function(){return J>=ae.length?{done:!0}:{done:!1,value:ae[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}we.defaults=A();function T(ae){we.defaults=ae}var $=/[&<>"']/,a=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(be){return c[be]};function f(ae,be){if(be){if($.test(ae))return ae.replace(a,D)}else if(R.test(ae))return ae.replace(y,D);return ae}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ae){return ae.replace(n,function(be,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var s=/(^|[^\[])\^/g;function l(ae,be){ae=typeof ae=="string"?ae:ae.source,be=be||"";var ue={replace:function(x,me){return me=me.source||me,me=me.replace(s,"$1"),ae=ae.replace(x,me),ue},getRegex:function(){return new RegExp(ae,be)}};return ue}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ae,be,ue){if(ae){var J;try{J=decodeURIComponent(o(ue)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}be&&!r.test(ue)&&(ue=h(be,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var g={},u=/^[^:]+:\/*[^/]*$/,p=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(ae,be){g[" "+ae]||(u.test(ae)?g[" "+ae]=ae+"/":g[" "+ae]=k(ae,"/",!0)),ae=g[" "+ae];var ue=ae.indexOf(":")===-1;return be.substring(0,2)==="//"?ue?be:ae.replace(p,"$1")+be:be.charAt(0)==="/"?ue?be:ae.replace(m,"$1")+be:ae+be}var E={exec:function(){}};function S(ae){for(var be=1,ue,J;be<arguments.length;be++){ue=arguments[be];for(J in ue)Object.prototype.hasOwnProperty.call(ue,J)&&(ae[J]=ue[J])}return ae}function w(ae,be){var ue=ae.replace(/\|/g,function(me,pe,Ae){for(var ze=!1,ke=pe;--ke>=0&&Ae[ke]==="\\";)ze=!ze;return ze?"|":" |"}),J=ue.split(/ \|/),x=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>be)J.splice(be);else for(;J.length<be;)J.push("");for(;x<J.length;x++)J[x]=J[x].trim().replace(/\\\|/g,"|");return J}function k(ae,be,ue){var J=ae.length;if(J===0)return"";for(var x=0;x<J;){var me=ae.charAt(J-x-1);if(me===be&&!ue)x++;else if(me!==be&&ue)x++;else break}return ae.slice(0,J-x)}function C(ae,be){if(ae.indexOf(be[1])===-1)return-1;for(var ue=ae.length,J=0,x=0;x<ue;x++)if(ae[x]==="\\")x++;else if(ae[x]===be[0])J++;else if(ae[x]===be[1]&&(J--,J<0))return x;return-1}function d(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(ae,be){if(be<1)return"";for(var ue="";be>1;)be&1&&(ue+=ae),be>>=1,ae+=ae;return ue+ae}function F(ae,be,ue,J){var x=be.href,me=be.title?f(be.title):null,pe=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){J.state.inLink=!0;var Ae={type:"link",raw:ue,href:x,title:me,text:pe,tokens:J.inlineTokens(pe)};return J.state.inLink=!1,Ae}return{type:"image",raw:ue,href:x,title:me,text:f(pe)}}function N(ae,be){var ue=ae.match(/^(\s+)(?:```)/);if(ue===null)return be;var J=ue[1];return be.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var pe=me[0];return pe.length>=J.length?x.slice(J.length):x}).join(`
`)}var M=function(){function ae(ue){this.options=ue||we.defaults}var be=ae.prototype;return be.space=function(J){var x=this.rules.block.newline.exec(J);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},be.code=function(J){var x=this.rules.block.code.exec(J);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:k(me,`
`)}}},be.fences=function(J){var x=this.rules.block.fences.exec(J);if(x){var me=x[0],pe=N(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:pe}}},be.heading=function(J){var x=this.rules.block.heading.exec(J);if(x){var me=x[2].trim();if(/#$/.test(me)){var pe=k(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},be.hr=function(J){var x=this.rules.block.hr.exec(J);if(x)return{type:"hr",raw:x[0]}},be.blockquote=function(J){var x=this.rules.block.blockquote.exec(J);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},be.list=function(J){var x=this.rules.block.list.exec(J);if(x){var me,pe,Ae,ze,ke,Pe,Te,U,B,K,G,ie,de=x[1].trim(),Ie=de.length>1,Ue={type:"list",raw:"",ordered:Ie,start:Ie?+de.slice(0,-1):"",loose:!1,items:[]};de=Ie?"\\d{1,9}\\"+de.slice(-1):"\\"+de,this.options.pedantic&&(de=Ie?de:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+de+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ie=!1,!(!(x=Ke.exec(J))||this.rules.block.hr.test(J)));){if(me=x[0],J=J.substring(me.length),U=x[2].split(`
`,1)[0],B=J.split(`
`,1)[0],this.options.pedantic?(ze=2,G=U.trimLeft()):(ze=x[2].search(/[^ ]/),ze=ze>4?1:ze,G=U.slice(ze),ze+=x[1].length),Pe=!1,!U&&/^ *$/.test(B)&&(me+=B+`
`,J=J.substring(B.length+1),ie=!0),!ie)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");J&&(K=J.split(`
`,1)[0],U=K,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(U)||et.test(U)||_e.test(U)||tt.test(J)));){if(U.search(/[^ ]/)>=ze||!U.trim())G+=`
`+U.slice(ze);else if(!Pe)G+=`
`+U;else break;!Pe&&!U.trim()&&(Pe=!0),me+=K+`
`,J=J.substring(K.length+1)}Ue.loose||(Te?Ue.loose=!0:/\n *\n *$/.test(me)&&(Te=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(G),pe&&(Ae=pe[0]!=="[ ] ",G=G.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:me,task:!!pe,checked:Ae,loose:!1,text:G}),Ue.raw+=me}Ue.items[Ue.items.length-1].raw=me.trimRight(),Ue.items[Ue.items.length-1].text=G.trimRight(),Ue.raw=Ue.raw.trimRight();var rt=Ue.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,Ue.items[ke].tokens=this.lexer.blockTokens(Ue.items[ke].text,[]);var mt=Ue.items[ke].tokens.filter(function(st){return st.type==="space"}),lt=mt.every(function(st){for(var ct=st.raw.split(""),ft=0,pt=O(ct),We;!(We=pt()).done;){var je=We.value;if(je===`
`&&(ft+=1),ft>1)return!0}return!1});!Ue.loose&&mt.length&&lt&&(Ue.loose=!0,Ue.items[ke].loose=!0)}return Ue}},be.html=function(J){var x=this.rules.block.html.exec(J);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(x[0]):f(x[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},be.def=function(J){var x=this.rules.block.def.exec(J);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},be.table=function(J){var x=this.rules.block.table.exec(J);if(x){var me={type:"table",header:w(x[1]).map(function(Te){return{text:Te}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var pe=me.align.length,Ae,ze,ke,Pe;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(pe=me.rows.length,Ae=0;Ae<pe;Ae++)me.rows[Ae]=w(me.rows[Ae],me.header.length).map(function(Te){return{text:Te}});for(pe=me.header.length,ze=0;ze<pe;ze++)me.header[ze].tokens=this.lexer.inline(me.header[ze].text);for(pe=me.rows.length,ze=0;ze<pe;ze++)for(Pe=me.rows[ze],ke=0;ke<Pe.length;ke++)Pe[ke].tokens=this.lexer.inline(Pe[ke].text);return me}}},be.lheading=function(J){var x=this.rules.block.lheading.exec(J);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},be.paragraph=function(J){var x=this.rules.block.paragraph.exec(J);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},be.text=function(J){var x=this.rules.block.text.exec(J);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},be.escape=function(J){var x=this.rules.inline.escape.exec(J);if(x)return{type:"escape",raw:x[0],text:f(x[1])}},be.tag=function(J){var x=this.rules.inline.tag.exec(J);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):f(x[0]):x[0]}},be.link=function(J){var x=this.rules.inline.link.exec(J);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=k(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Ae=C(x[2],"()");if(Ae>-1){var ze=x[0].indexOf("!")===0?5:4,ke=ze+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,ke).trim(),x[3]=""}}var Pe=x[2],Te="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);U&&(Pe=U[1],Te=U[3])}else Te=x[3]?x[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(me)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),F(x,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},be.reflink=function(J,x){var me;if((me=this.rules.inline.reflink.exec(J))||(me=this.rules.inline.nolink.exec(J))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=x[pe.toLowerCase()],!pe||!pe.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return F(me,pe,me[0],this.lexer)}},be.emStrong=function(J,x,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(J);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var ze=pe[0].length-1,ke,Pe,Te=ze,U=0,B=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,x=x.slice(-1*J.length+ze);(pe=B.exec(x))!=null;)if(ke=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!ke){if(Pe=ke.length,pe[3]||pe[4]){Te+=Pe;continue}else if((pe[5]||pe[6])&&ze%3&&!((ze+Pe)%3)){U+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+U),Math.min(ze,Pe)%2){var K=J.slice(1,ze+pe.index+Pe);return{type:"em",raw:J.slice(0,ze+pe.index+Pe+1),text:K,tokens:this.lexer.inlineTokens(K)}}var G=J.slice(2,ze+pe.index+Pe-1);return{type:"strong",raw:J.slice(0,ze+pe.index+Pe+1),text:G,tokens:this.lexer.inlineTokens(G)}}}}}},be.codespan=function(J){var x=this.rules.inline.code.exec(J);if(x){var me=x[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return pe&&Ae&&(me=me.substring(1,me.length-1)),me=f(me,!0),{type:"codespan",raw:x[0],text:me}}},be.br=function(J){var x=this.rules.inline.br.exec(J);if(x)return{type:"br",raw:x[0]}},be.del=function(J){var x=this.rules.inline.del.exec(J);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},be.autolink=function(J,x){var me=this.rules.inline.autolink.exec(J);if(me){var pe,Ae;return me[2]==="@"?(pe=f(this.options.mangle?x(me[1]):me[1]),Ae="mailto:"+pe):(pe=f(me[1]),Ae=pe),{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},be.url=function(J,x){var me;if(me=this.rules.inline.url.exec(J)){var pe,Ae;if(me[2]==="@")pe=f(this.options.mangle?x(me[0]):me[0]),Ae="mailto:"+pe;else{var ze;do ze=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ze!==me[0]);pe=f(me[0]),me[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},be.inlineText=function(J,x){var me=this.rules.inline.text.exec(J);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):f(me[0]):me[0]:pe=f(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},ae}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=l(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=l(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=l(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=l(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=l(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=l(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=S({},V),V.gfm=S({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=l(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=l(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=S({},V.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:l(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=l(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=l(V._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=l(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=l(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=l(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=l(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=l(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=l(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=l(W.reflink).replace("label",W._label).replace("ref",V._label).getRegex(),W.nolink=l(W.nolink).replace("ref",V._label).getRegex(),W.reflinkSearch=l(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=S({},W),W.pedantic=S({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=S({},W.normal,{escape:l(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=l(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=S({},W.gfm,{br:l(W.br).replace("{2,}","*").getRegex(),text:l(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(ae){var be="",ue,J,x=ae.length;for(ue=0;ue<x;ue++)J=ae.charCodeAt(ue),Math.random()>.5&&(J="x"+J.toString(16)),be+="&#"+J+";";return be}var Z=function(){function ae(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||we.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:V.normal,inline:W.normal};this.options.pedantic?(J.block=V.pedantic,J.inline=W.pedantic):this.options.gfm&&(J.block=V.gfm,this.options.breaks?J.inline=W.breaks:J.inline=W.gfm),this.tokenizer.rules=J}ae.lex=function(J,x){var me=new ae(x);return me.lex(J)},ae.lexInline=function(J,x){var me=new ae(x);return me.inlineTokens(J)};var be=ae.prototype;return be.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},be.blockTokens=function(J,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(Te,U,B){return U+"    ".repeat(B.length)});for(var pe,Ae,ze,ke;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(pe=Te.call({lexer:me},J,x))?(J=J.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.space(J)){J=J.substring(pe.raw.length),pe.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(pe);continue}if(pe=this.tokenizer.code(J)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(pe=this.tokenizer.fences(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.heading(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.hr(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.blockquote(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.list(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.html(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.def(J)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.lheading(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(ze=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,U=J.slice(1),B=void 0;me.options.extensions.startBlock.forEach(function(K){B=K.call({lexer:this},U),typeof B=="number"&&B>=0&&(Te=Math.min(Te,B))}),Te<1/0&&Te>=0&&(ze=J.substring(0,Te+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(ze))){Ae=x[x.length-1],ke&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe),ke=ze.length!==J.length,J=J.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(J)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(J){var Pe="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,x},be.inline=function(J,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:J,tokens:x}),x},be.inlineTokens=function(J,x){var me=this;x===void 0&&(x=[]);var pe,Ae,ze,ke=J,Pe,Te,U;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)B.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(Te||(U=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(G){return(pe=G.call({lexer:me},J,x))?(J=J.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.tag(J)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.link(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.emStrong(J,ke,U)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.codespan(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.br(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.del(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.autolink(J,Y)){J=J.substring(pe.raw.length),x.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(J,Y))){J=J.substring(pe.raw.length),x.push(pe);continue}if(ze=J,this.options.extensions&&this.options.extensions.startInline&&function(){var G=1/0,ie=J.slice(1),de=void 0;me.options.extensions.startInline.forEach(function(Ie){de=Ie.call({lexer:this},ie),typeof de=="number"&&de>=0&&(G=Math.min(G,de))}),G<1/0&&G>=0&&(ze=J.substring(0,G+1))}(),pe=this.tokenizer.inlineText(ze,L)){J=J.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(U=pe.raw.slice(-1)),Te=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(J){var K="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return x},v(ae,null,[{key:"rules",get:function(){return{block:V,inline:W}}}]),ae}(),ge=function(){function ae(ue){this.options=ue||we.defaults}var be=ae.prototype;return be.code=function(J,x,me){var pe=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(J,pe);Ae!=null&&Ae!==J&&(me=!0,J=Ae)}return J=J.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+f(pe,!0)+'">'+(me?J:f(J,!0))+`</code></pre>
`:"<pre><code>"+(me?J:f(J,!0))+`</code></pre>
`},be.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},be.html=function(J){return J},be.heading=function(J,x,me,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(me);return"<h"+x+' id="'+Ae+'">'+J+"</h"+x+`>
`}return"<h"+x+">"+J+"</h"+x+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(J,x,me){var pe=x?"ol":"ul",Ae=x&&me!==1?' start="'+me+'"':"";return"<"+pe+Ae+`>
`+J+"</"+pe+`>
`},be.listitem=function(J){return"<li>"+J+`</li>
`},be.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(J){return"<p>"+J+`</p>
`},be.table=function(J,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+x+`</table>
`},be.tablerow=function(J){return`<tr>
`+J+`</tr>
`},be.tablecell=function(J,x){var me=x.header?"th":"td",pe=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return pe+J+("</"+me+`>
`)},be.strong=function(J){return"<strong>"+J+"</strong>"},be.em=function(J){return"<em>"+J+"</em>"},be.codespan=function(J){return"<code>"+J+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(J){return"<del>"+J+"</del>"},be.link=function(J,x,me){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return me;var pe='<a href="'+f(J)+'"';return x&&(pe+=' title="'+x+'"'),pe+=">"+me+"</a>",pe},be.image=function(J,x,me){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return me;var pe='<img src="'+J+'" alt="'+me+'"';return x&&(pe+=' title="'+x+'"'),pe+=this.options.xhtml?"/>":">",pe},be.text=function(J){return J},ae}(),_=function(){function ae(){}var be=ae.prototype;return be.strong=function(J){return J},be.em=function(J){return J},be.codespan=function(J){return J},be.del=function(J){return J},be.html=function(J){return J},be.text=function(J){return J},be.link=function(J,x,me){return""+me},be.image=function(J,x,me){return""+me},be.br=function(){return""},ae}(),fe=function(){function ae(){this.seen={}}var be=ae.prototype;return be.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(J,x){var me=J,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[J];do pe++,me=J+"-"+pe;while(this.seen.hasOwnProperty(me))}return x||(this.seen[J]=pe,this.seen[me]=0),me},be.slug=function(J,x){x===void 0&&(x={});var me=this.serialize(J);return this.getNextSafeSlug(me,x.dryrun)},ae}(),se=function(){function ae(ue){this.options=ue||we.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new fe}ae.parse=function(J,x){var me=new ae(x);return me.parse(J)},ae.parseInline=function(J,x){var me=new ae(x);return me.parseInline(J)};var be=ae.prototype;return be.parse=function(J,x){x===void 0&&(x=!0);var me="",pe,Ae,ze,ke,Pe,Te,U,B,K,G,ie,de,Ie,Ue,Ke,_e,tt,nt,et,rt=J.length;for(pe=0;pe<rt;pe++){if(G=J[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[G.type]&&(et=this.options.extensions.renderers[G.type].call({parser:this},G),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(G.type))){me+=et||"";continue}switch(G.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(G.tokens),G.depth,o(this.parseInline(G.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(G.text,G.lang,G.escaped);continue}case"table":{for(B="",U="",ke=G.header.length,Ae=0;Ae<ke;Ae++)U+=this.renderer.tablecell(this.parseInline(G.header[Ae].tokens),{header:!0,align:G.align[Ae]});for(B+=this.renderer.tablerow(U),K="",ke=G.rows.length,Ae=0;Ae<ke;Ae++){for(Te=G.rows[Ae],U="",Pe=Te.length,ze=0;ze<Pe;ze++)U+=this.renderer.tablecell(this.parseInline(Te[ze].tokens),{header:!1,align:G.align[ze]});K+=this.renderer.tablerow(U)}me+=this.renderer.table(B,K);continue}case"blockquote":{K=this.parse(G.tokens),me+=this.renderer.blockquote(K);continue}case"list":{for(ie=G.ordered,de=G.start,Ie=G.loose,ke=G.items.length,K="",Ae=0;Ae<ke;Ae++)Ke=G.items[Ae],_e=Ke.checked,tt=Ke.task,Ue="",Ke.task&&(nt=this.renderer.checkbox(_e),Ie?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):Ue+=nt),Ue+=this.parse(Ke.tokens,Ie),K+=this.renderer.listitem(Ue,tt,_e);me+=this.renderer.list(K,ie,de);continue}case"html":{me+=this.renderer.html(G.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(G.tokens));continue}case"text":{for(K=G.tokens?this.parseInline(G.tokens):G.text;pe+1<rt&&J[pe+1].type==="text";)G=J[++pe],K+=`
`+(G.tokens?this.parseInline(G.tokens):G.text);me+=x?this.renderer.paragraph(K):K;continue}default:{var mt='Token with "'+G.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return me},be.parseInline=function(J,x){x=x||this.renderer;var me="",pe,Ae,ze,ke=J.length;for(pe=0;pe<ke;pe++){if(Ae=J[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(ze=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=ze||"";continue}switch(Ae.type){case"escape":{me+=x.text(Ae.text);break}case"html":{me+=x.html(Ae.text);break}case"link":{me+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{me+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{me+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{me+=x.codespan(Ae.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{me+=x.text(Ae.text);break}default:{var Pe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return me},ae}();function ce(ae,be,ue){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof be=="function"&&(ue=be,be=null),be=S({},ce.defaults,be||{}),d(be),ue){var J=be.highlight,x;try{x=Z.lex(ae,be)}catch(ke){return ue(ke)}var me=function(Pe){var Te;if(!Pe)try{be.walkTokens&&ce.walkTokens(x,be.walkTokens),Te=se.parse(x,be)}catch(U){Pe=U}return be.highlight=J,Pe?ue(Pe):ue(null,Te)};if(!J||J.length<3||(delete be.highlight,!x.length))return me();var pe=0;ce.walkTokens(x,function(ke){ke.type==="code"&&(pe++,setTimeout(function(){J(ke.text,ke.lang,function(Pe,Te){if(Pe)return me(Pe);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Ae(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+f(ke.message+"",!0)+"</pre>";throw ke}try{var ze=Z.lex(ae,be);if(be.walkTokens){if(be.async)return Promise.all(ce.walkTokens(ze,be.walkTokens)).then(function(){return se.parse(ze,be)}).catch(Ae);ce.walkTokens(ze,be.walkTokens)}return se.parse(ze,be)}catch(ke){Ae(ke)}}ce.options=ce.setOptions=function(ae){return S(ce.defaults,ae),T(ce.defaults),ce},ce.getDefaults=A,ce.defaults=we.defaults,ce.use=function(){for(var ae=arguments.length,be=new Array(ae),ue=0;ue<ae;ue++)be[ue]=arguments[ue];var J=S.apply(void 0,[{}].concat(be)),x=ce.defaults.extensions||{renderers:{},childTokens:{}},me;be.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ke=x.renderers?x.renderers[ze.name]:null;ke?x.renderers[ze.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),U=0;U<Pe;U++)Te[U]=arguments[U];var B=ze.renderer.apply(this,Te);return B===!1&&(B=ke.apply(this,Te)),B}:x.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ze.level]?x[ze.level].unshift(ze.tokenizer):x[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?x.startBlock?x.startBlock.push(ze.start):x.startBlock=[ze.start]:ze.level==="inline"&&(x.startInline?x.startInline.push(ze.start):x.startInline=[ze.start]))}ze.childTokens&&(x.childTokens[ze.name]=ze.childTokens)})),pe.renderer&&function(){var ze=ce.defaults.renderer||new ge,ke=function(U){var B=ze[U];ze[U]=function(){for(var K=arguments.length,G=new Array(K),ie=0;ie<K;ie++)G[ie]=arguments[ie];var de=pe.renderer[U].apply(ze,G);return de===!1&&(de=B.apply(ze,G)),de}};for(var Pe in pe.renderer)ke(Pe);J.renderer=ze}(),pe.tokenizer&&function(){var ze=ce.defaults.tokenizer||new M,ke=function(U){var B=ze[U];ze[U]=function(){for(var K=arguments.length,G=new Array(K),ie=0;ie<K;ie++)G[ie]=arguments[ie];var de=pe.tokenizer[U].apply(ze,G);return de===!1&&(de=B.apply(ze,G)),de}};for(var Pe in pe.tokenizer)ke(Pe);J.tokenizer=ze}(),pe.walkTokens){var Ae=ce.defaults.walkTokens;J.walkTokens=function(ze){var ke=[];return ke.push(pe.walkTokens.call(this,ze)),Ae&&(ke=ke.concat(Ae.call(this,ze))),ke}}me&&(J.extensions=x),ce.setOptions(J)})},ce.walkTokens=function(ae,be){for(var ue=[],J=function(){var Ae=me.value;switch(ue=ue.concat(be.call(ce,Ae)),Ae.type){case"table":{for(var ze=O(Ae.header),ke;!(ke=ze()).done;){var Pe=ke.value;ue=ue.concat(ce.walkTokens(Pe.tokens,be))}for(var Te=O(Ae.rows),U;!(U=Te()).done;)for(var B=U.value,K=O(B),G;!(G=K()).done;){var ie=G.value;ue=ue.concat(ce.walkTokens(ie.tokens,be))}break}case"list":{ue=ue.concat(ce.walkTokens(Ae.items,be));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ae.type]?ce.defaults.extensions.childTokens[Ae.type].forEach(function(de){ue=ue.concat(ce.walkTokens(Ae[de],be))}):Ae.tokens&&(ue=ue.concat(ce.walkTokens(Ae.tokens,be)))}},x=O(ae),me;!(me=x()).done;)J();return ue},ce.parseInline=function(ae,be){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");be=S({},ce.defaults,be||{}),d(be);try{var ue=Z.lexInline(ae,be);return be.walkTokens&&ce.walkTokens(ue,be.walkTokens),se.parseInline(ue,be)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+f(J.message+"",!0)+"</pre>";throw J}},ce.Parser=se,ce.parser=se.parse,ce.Renderer=ge,ce.TextRenderer=_,ce.Lexer=Z,ce.lexer=Z.lex,ce.Tokenizer=M,ce.Slugger=fe,ce.parse=ce;var $e=ce.options,oe=ce.setOptions,Ce=ce.use,Le=ce.walkTokens,X=ce.parseInline,q=ce,te=se.parse,ve=Z.lex;we.Lexer=Z,we.Parser=se,we.Renderer=ge,we.Slugger=fe,we.TextRenderer=_,we.Tokenizer=M,we.getDefaults=A,we.lexer=ve,we.marked=ce,we.options=$e,we.parse=q,we.parseInline=X,we.parser=te,we.setOptions=oe,we.use=Ce,we.walkTokens=Le,Object.defineProperty(we,"__esModule",{value:!0})}),define(Oe[138],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=v;function v(n){const o=O(n);if(o&&o.length>0)return new Uint32Array(o)}let P=0;const I=new Uint32Array(10);function O(n){if(P=0,A(n,y,$.InitialConsonant),P>0||(A(n,c,$.Vowel),P>0)||(A(n,D,$.FinalConsonant),P>0)||(A(n,f,$.CompatibilityJamo),P))return I.subarray(0,P);if(n>=44032&&n<=55203){const o=n-44032,s=o%588,l=Math.floor(o/588),i=Math.floor(s/28),r=s%28-1;if(l<y.length?A(l,y,0):$.InitialConsonant+l-$.CompatibilityJamo<f.length&&A($.InitialConsonant+l,f,$.CompatibilityJamo),i<c.length?A(i,c,0):$.Vowel+i-$.CompatibilityJamo<f.length&&A($.Vowel+i-$.CompatibilityJamo,f,$.CompatibilityJamo),r>=0&&(r<D.length?A(r,D,0):$.FinalConsonant+r-$.CompatibilityJamo<f.length&&A($.FinalConsonant+r-$.CompatibilityJamo,f,$.CompatibilityJamo)),P>0)return I.subarray(0,P)}}function A(n,o,s){n>=s&&n<s+o.length&&T(o[n-s])}function T(n){n!==a.NUL&&(I[P++]=n&255,n>>8&&(I[P++]=n>>8&255),n>>16&&(I[P++]=n>>16&255))}var $;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var a;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(a||(a={}));var R;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(R||(R={}));const y=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),c=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l]),D=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,R.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),f=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.E,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,a.Q,R.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l])}),define(Oe[139],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0,e.$Im=v,e.rot=P,e.$Nm=T;function v($,a,R){return Math.min(Math.max($,a),R)}function P($,a){return(a+$%a)%a}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Km=I;class O{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Lm=O;class A{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const R=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Mm=A;function T($,a,R,y,c,D,f,n){const o=f-R,s=n-y,l=c-R,i=D-y,r=$-R,t=a-y,g=o*o+s*s,u=o*l+s*i,p=o*r+s*t,m=l*l+i*i,h=l*r+i*t,E=1/(g*m-u*u),S=(m*p-u*h)*E,w=(g*h-u*p)*E;return S>=0&&w>=0&&S+w<1}}),define(Oe[140],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_c=void 0,e.$ad=O,e.$bd=c;class v{constructor(f,n,o){this.owner=f,this.debugNameSource=n,this.referenceFn=o}getDebugName(f){return O(f,this)}}e.$_c=v;const P=new Map,I=new WeakMap;function O(D,f){const n=I.get(D);if(n)return n;const o=A(D,f);if(o){let s=P.get(o)??0;s++,P.set(o,s);const l=s===1?o:`${o}#${s}`;return I.set(D,l),l}}function A(D,f){const n=I.get(D);if(n)return n;const o=f.owner?R(f.owner)+".":"";let s;const l=f.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(s=l(),s!==void 0)return o+s}else return o+l;const i=f.referenceFn;if(i!==void 0&&(s=c(i),s!==void 0))return o+s;if(f.owner!==void 0){const r=T(f.owner,D);if(r!==void 0)return o+r}}function T(D,f){for(const n in D)if(D[n]===f)return n}const $=new Map,a=new WeakMap;function R(D){const f=a.get(D);if(f)return f;const n=y(D);let o=$.get(n)??0;o++,$.set(n,o);const s=o===1?n:`${n}#${o}`;return a.set(D,s),s}function y(D){const f=D.constructor;return f?f.name:"Object"}function c(D){const f=D.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(o?o[1]:void 0)?.trim()}}),define(Oe[141],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=P,e.$Jd=I;let v;function P(n){v=n}function I(){return v}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([T(D("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[T(" "),a(R(o.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),a(R(o.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),a(R(o.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(o,s){console.log(...this.b([$("observable value changed"),a(o.debugName,{color:"BlueViolet"}),...this.c(s)]))}formatChanges(o){if(o.size!==0)return a(" (changed deps: "+[...o].map(s=>s.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(l,i)=>(this.d.get(o).add(l),s.apply(o,[l,i]))}handleDerivedRecomputed(o,s){const l=this.d.get(o);console.log(...this.b([$("derived recomputed"),a(o.debugName,{color:"BlueViolet"}),...this.c(s),this.formatChanges(l),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(o,s){console.log(...this.b([$("observable from event triggered"),a(o.debugName,{color:"BlueViolet"}),...this.c(s),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(l,i)=>(this.d.get(o).add(l),s.apply(o,[l,i]))}handleAutorunTriggered(o){const s=this.d.get(o);console.log(...this.b([$("autorun"),a(o.debugName,{color:"BlueViolet"}),this.formatChanges(s),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),s.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let s=o.getDebugName();s===void 0&&(s=""),console.log(...this.b([$("transaction"),a(s,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=O;function A(n){const o=new Array,s=[];let l="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(l+=`%c${t.text}`,o.push(t.style),t.data&&s.push(...t.data)):"data"in t&&s.push(...t.data)}i(n);const r=[l,...o];return r.push(...s),r}function T(n){return a(n,{color:"black"})}function $(n){return a(f(`${n}: `,10),{color:"black",bold:!0})}function a(n,o={color:"black"}){function s(i){return Object.entries(i).reduce((r,[t,g])=>`${r}${t}:${g};`,"")}const l={color:o.color};return o.strikeThrough&&(l["text-decoration"]="line-through"),o.bold&&(l["font-weight"]="bold"),{text:n,style:s(l)}}function R(n,o){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=o?`"${n}"`:`"${n.substr(0,o-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?y(n,o):c(n,o);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function y(n,o){let s="[ ",l=!0;for(const i of n){if(l||(s+=", "),s.length-5>o){s+="...";break}l=!1,s+=`${R(i,o-s.length)}`}return s+=" ]",s}function c(n,o){let s="{ ",l=!0;for(const[i,r]of Object.entries(n)){if(l||(s+=", "),s.length-5>o){s+="...";break}l=!1,s+=`${i}: ${R(r,o-s.length)}`}return s+=" }",s}function D(n,o){let s="";for(let l=1;l<=o;l++)s+=n;return s}function f(n,o){for(;n.length<o;)n+=" ";return n}}),define(Oe[142],Ne([1,0,135,140,141]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=A,e.$Ud=$,e.$Vd=R,e.$Yd=D,e.$Zd=n,e.$1d=o,e.$2d=s,e.$4d=i,e.$6d=t;let O;function A(u){O=u}let T;function $(u){T=u}let a;function R(u){a=u}class y{get TChange(){return null}reportChanges(){this.get()}read(p){return p?p.readObservable(this):this.get()}map(p,m){const h=m===void 0?void 0:p,E=m===void 0?p:m;return a({owner:h,debugName:()=>{const S=(0,P.$bd)(E);if(S!==void 0)return S;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:E},S=>E(this.read(S),S))}recomputeInitiallyAndOnChange(p,m){return p.add(O(this,m)),this}keepObserved(p){return p.add(T(this)),this}get a(){return this.get()}}e.$Wd=y;class c extends y{constructor(){super(...arguments),this.b=new Set}addObserver(p){const m=this.b.size;this.b.add(p),m===0&&this.c()}removeObserver(p){this.b.delete(p)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=c;function D(u,p){const m=new l(u,p);try{u(m)}finally{m.finish()}}let f;function n(u){if(f)u(f);else{const p=new l(u,void 0);f=p;try{u(p)}finally{p.finish(),f=void 0}}}async function o(u,p){const m=new l(u,p);try{await u(m)}finally{m.finish()}}function s(u,p,m){u?p(u):D(p,m)}class l{constructor(p,m){this._fn=p,this.b=m,this.a=[],(0,I.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,P.$bd)(this._fn)}updateObserver(p,m){this.a.push({observer:p,observable:m}),p.beginUpdate(m)}finish(){const p=this.a;for(let m=0;m<p.length;m++){const{observer:h,observable:E}=p[m];h.endUpdate(E)}this.a=null,(0,I.$Jd)()?.handleEndTransaction()}}e.$3d=l;function i(u,p){let m;return typeof u=="string"?m=new P.$_c(void 0,u,void 0):m=new P.$_c(u,void 0,void 0),new r(m,p,v.$5c)}class r extends c{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(p,m,h){super(),this.e=p,this.g=h,this.d=m}get(){return this.d}set(p,m,h){if(h===void 0&&this.g(this.d,p))return;let E;m||(m=E=new l(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(p),(0,I.$Jd)()?.handleObservableChanged(this,{oldValue:S,newValue:p,change:h,didChange:!0,hadValue:!0});for(const w of this.b)m.updateObserver(w,this),w.handleChange(this,h)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(p){this.d=p}}e.$5d=r;function t(u,p){let m;return typeof u=="string"?m=new P.$_c(void 0,u,void 0):m=new P.$_c(u,void 0,void 0),new g(m,p,v.$5c)}class g extends r{h(p){this.d!==p&&(this.d&&this.d.dispose(),this.d=p)}dispose(){this.d?.dispose()}}e.$7d=g}),function(){function we(I){const O=[];typeof I=="number"&&O.push("code/timeOrigin",I);function A($){O.push($,Date.now())}function T(){const $=[];for(let a=0;a<O.length;a+=2)$.push({name:O[a],startTime:O[a+1]});return $}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(I+A.startTime)});return O}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function v(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=v(P))}(),define(Oe[143],Ne([1,0,39]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=void 0;const P=Symbol("unset");class I{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert($,a,R){this.d($,y=>y._value=a,R)}mutate($,a){this.d($,R=>R._value=a(R._value===P?void 0:R._value))}mutatePath($,a){this.d($,()=>{},R=>a(R))}delete($){const a=this.c($);if(!a)return;let R=a.length-1;const y=a[R].node._value;if(y!==P){for(this.b--,a[R].node._value=P;R>0;R--){const{node:c,part:D}=a[R];if(c.children?.size||c._value!==P)break;a[R-1].node.children.delete(D)}return y}}*deleteRecursive($){const a=this.c($);if(!a)return;const R=a[a.length-1].node;for(let y=a.length-1;y>0;y--){const c=a[y-1];if(c.node.children.delete(a[y].part),c.node.children.size>0||c.node._value!==P)break}for(const y of O(R))y._value!==P&&(this.b--,yield y._value)}find($){let a=this.a;for(const R of $){const y=a.children?.get(R);if(!y)return;a=y}return a._value===P?void 0:a._value}hasKeyOrParent($){let a=this.a;for(const R of $){const y=a.children?.get(R);if(!y)return!1;if(y._value!==P)return!0;a=y}return!1}hasKeyOrChildren($){let a=this.a;for(const R of $){const y=a.children?.get(R);if(!y)return!1;a=y}return!0}hasKey($){let a=this.a;for(const R of $){const y=a.children?.get(R);if(!y)return!1;a=y}return a._value!==P}c($){const a=[{part:"",node:this.a}];let R=0;for(const y of $){const c=a[R].node.children?.get(y);if(!c)return;a.push({part:y,node:c}),R++}return a}d($,a,R){let y=this.a;for(const f of $){if(y.children)if(y.children.has(f))y=y.children.get(f);else{const n=new A;y.children.set(f,n),y=n}else{const n=new A;y.children=new Map([[f,n]]),y=n}R?.(y)}const c=y._value===P?0:1;a(y);const D=y._value===P?0:1;this.b+=D-c}*values(){for(const{_value:$}of O(this.a))$!==P&&(yield $)}}e.$TI=I;function*O(T){const $=[T];for(;$.length>0;){const a=$.pop();if(yield a,a.children)for(const R of a.children.values())$.push(R)}}class A{constructor(){this._value=P}get value(){return this._value===P?void 0:this._value}set value($){this._value=$===void 0?P:$}}}),define(Oe[144],Ne([1,0,48,19]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=T,e.$yr=$,e.$zr=a,e.$Ar=R,e.$Br=y,e.$Cr=c,e.$Dr=D,e.$Er=f,e.$Fr=n,e.$Gr=o,e.$Hr=h,e.$Ir=E,e.$Jr=S;const I=new v.$T(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),O=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(w,k,C=!1){const d=w||"",b=k||"",F=I.value.collator.compare(d,b);return I.value.collatorIsNumeric&&F===0&&d!==b?d<b?-1:1:F}function $(w,k){const C=O.value.collator;return w=w||"",k=k||"",r(C,w,k)}function a(w,k){const C=O.value.collator;return w=w||"",k=k||"",p(w,k)||r(C,w,k)}function R(w,k){const C=O.value.collator;return w=w||"",k=k||"",u(w,k)||r(C,w,k)}function y(w,k){return w=w||"",k=k||"",w===k?0:w<k?-1:1}function c(w,k){const[C,d]=l(w),[b,F]=l(k);let N=I.value.collator.compare(d,F);if(N===0){if(I.value.collatorIsNumeric&&d!==F)return d<F?-1:1;if(N=I.value.collator.compare(C,b),I.value.collatorIsNumeric&&N===0&&C!==b)return C<b?-1:1}return N}function D(w,k){w=w||"",k=k||"";const C=i(w),d=i(k),b=O.value.collator,F=A.value.collator;return r(F,C,d)||r(b,w,k)}function f(w,k){w=w||"",k=k||"";const C=i(w),d=i(k),b=O.value.collator,F=A.value.collator;return r(F,C,d)||p(w,k)||r(b,w,k)}function n(w,k){w=w||"",k=k||"";const C=i(w),d=i(k),b=O.value.collator,F=A.value.collator;return r(F,C,d)||u(w,k)||r(b,w,k)}function o(w,k){w=w||"",k=k||"";const C=i(w).toLowerCase(),d=i(k).toLowerCase();return C!==d?C<d?-1:1:w!==k?w<k?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function l(w,k=!1){const C=w?s.exec(w):[];let d=[C&&C[1]||"",C&&C[3]||""];return k&&(!d[0]&&d[1]||d[0]&&d[0].charAt(0)===".")&&(d=[d[0]+"."+d[1],""]),d}function i(w){const k=w?s.exec(w):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function r(w,k,C){const d=w.compare(k,C);return d!==0?d:k.length!==C.length?k.length<C.length?-1:1:0}function t(w){const k=w.charAt(0);return k.toLocaleUpperCase()!==k}function g(w){const k=w.charAt(0);return k.toLocaleLowerCase()!==k}function u(w,k){return t(w)&&g(k)?-1:g(w)&&t(k)?1:0}function p(w,k){return g(w)&&t(k)?-1:t(w)&&g(k)?1:0}function m(w,k,C=!1){return C||(w=w&&w.toLowerCase(),k=k&&k.toLowerCase()),w===k?0:w<k?-1:1}function h(w,k,C=!1){const d=w.split(P.sep),b=k.split(P.sep),F=d.length-1,N=b.length-1;let M,V;for(let W=0;;W++){if(M=F===W,V=N===W,M&&V)return T(d[W],b[W],C);if(M)return-1;if(V)return 1;const L=m(d[W],b[W],C);if(L!==0)return L}}function E(w,k,C){const d=w.toLowerCase(),b=k.toLowerCase(),F=S(w,k,C);if(F)return F;const N=d.endsWith(C),M=b.endsWith(C);if(N!==M)return N?-1:1;const V=T(d,b);return V!==0?V:d.localeCompare(b)}function S(w,k,C){const d=w.toLowerCase(),b=k.toLowerCase(),F=d.startsWith(C),N=b.startsWith(C);if(F!==N)return F?-1:1;if(F&&N){if(d.length<b.length)return-1;if(d.length>b.length)return 1}return 0}}),define(Oe[72],Ne([1,0,19]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=O,e.$0s=A,e.$$s=T,e.$_s=a,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(R){const y=(0,v.$nc)(R),c=P[y.toLowerCase()];return c!==void 0?c:A(R)}function A(R){const y=(0,v.$nc)(R);return I[y.toLowerCase()]}function T(R){for(const y in I)if(I[y]===R)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function a(R,y){const c=$.exec(R);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:y?void 0:R}}),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var P in v)(typeof exports=="object"?exports:we)[P]=v[P]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function v(P){if(e[P])return e[P].exports;var I=e[P]={i:P,l:!1,exports:{}};return we[P].call(I.exports,I,I.exports,v),I.l=!0,I.exports}return v.m=we,v.c=e,v.d=function(P,I,O){v.o(P,I)||Object.defineProperty(P,I,{enumerable:!0,get:O})},v.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},v.t=function(P,I){if(1&I&&(P=v(P)),8&I||4&I&&typeof P=="object"&&P&&P.__esModule)return P;var O=Object.create(null);if(v.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:P}),2&I&&typeof P!="string")for(var A in P)v.d(O,A,function(T){return P[T]}.bind(null,A));return O},v.n=function(P){var I=P&&P.__esModule?function(){return P.default}:function(){return P};return v.d(I,"a",I),I},v.o=function(P,I){return Object.prototype.hasOwnProperty.call(P,I)},v.p="",v(v.s=0)}([function(we,e,v){(function(P){var I;e=we.exports=Ce,I=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],$=e.src=[],a=0,R=a++;$[R]="0|[1-9]\\d*";var y=a++;$[y]="[0-9]+";var c=a++;$[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=a++;$[D]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var f=a++;$[f]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var n=a++;$[n]="(?:"+$[R]+"|"+$[c]+")";var o=a++;$[o]="(?:"+$[y]+"|"+$[c]+")";var s=a++;$[s]="(?:-("+$[n]+"(?:\\."+$[n]+")*))";var l=a++;$[l]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var i=a++;$[i]="[0-9A-Za-z-]+";var r=a++;$[r]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var t=a++,g="v?"+$[D]+$[s]+"?"+$[r]+"?";$[t]="^"+g+"$";var u="[v=\\s]*"+$[f]+$[l]+"?"+$[r]+"?",p=a++;$[p]="^"+u+"$";var m=a++;$[m]="((?:<|>)?=?)";var h=a++;$[h]=$[y]+"|x|X|\\*";var E=a++;$[E]=$[R]+"|x|X|\\*";var S=a++;$[S]="[v=\\s]*("+$[E]+")(?:\\.("+$[E]+")(?:\\.("+$[E]+")(?:"+$[s]+")?"+$[r]+"?)?)?";var w=a++;$[w]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[l]+")?"+$[r]+"?)?)?";var k=a++;$[k]="^"+$[m]+"\\s*"+$[S]+"$";var C=a++;$[C]="^"+$[m]+"\\s*"+$[w]+"$";var d=a++;$[d]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=a++;$[b]="(?:~>?)";var F=a++;$[F]="(\\s*)"+$[b]+"\\s+",T[F]=new RegExp($[F],"g");var N=a++;$[N]="^"+$[b]+$[S]+"$";var M=a++;$[M]="^"+$[b]+$[w]+"$";var V=a++;$[V]="(?:\\^)";var W=a++;$[W]="(\\s*)"+$[V]+"\\s+",T[W]=new RegExp($[W],"g");var L=a++;$[L]="^"+$[V]+$[S]+"$";var Y=a++;$[Y]="^"+$[V]+$[w]+"$";var Z=a++;$[Z]="^"+$[m]+"\\s*("+u+")$|^$";var ge=a++;$[ge]="^"+$[m]+"\\s*("+g+")$|^$";var _=a++;$[_]="(\\s*)"+$[m]+"\\s*("+u+"|"+$[S]+")",T[_]=new RegExp($[_],"g");var fe=a++;$[fe]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var se=a++;$[se]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var ce=a++;$[ce]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)I($e,$[$e]),T[$e]||(T[$e]=new RegExp($[$e]));function oe(B,K){if(B instanceof Ce)return B;if(typeof B!="string"||B.length>O||!(K?T[p]:T[t]).test(B))return null;try{return new Ce(B,K)}catch{return null}}function Ce(B,K){if(B instanceof Ce){if(B.loose===K)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Ce))return new Ce(B,K);I("SemVer",B,K),this.loose=K;var G=B.trim().match(K?T[p]:T[t]);if(!G)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var de=+ie;if(de>=0&&de<A)return de}return ie}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}e.parse=oe,e.valid=function(B,K){var G=oe(B,K);return G?G.version:null},e.clean=function(B,K){var G=oe(B.trim().replace(/^[=v]+/,""),K);return G?G.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(B){return I("SemVer.compare",this.version,this.loose,B),B instanceof Ce||(B=new Ce(B,this.loose)),this.compareMain(B)||this.comparePre(B)},Ce.prototype.compareMain=function(B){return B instanceof Ce||(B=new Ce(B,this.loose)),X(this.major,B.major)||X(this.minor,B.minor)||X(this.patch,B.patch)},Ce.prototype.comparePre=function(B){if(B instanceof Ce||(B=new Ce(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var K=0;do{var G=this.prerelease[K],ie=B.prerelease[K];if(I("prerelease compare",K,G,ie),G===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(G===void 0)return-1;if(G!==ie)return X(G,ie)}while(++K)},Ce.prototype.inc=function(B,K){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,K,G,ie){typeof G=="string"&&(ie=G,G=void 0);try{return new Ce(B,G).inc(K,ie).version}catch{return null}},e.diff=function(B,K){if(ae(B,K))return null;var G=oe(B),ie=oe(K);if(G.prerelease.length||ie.prerelease.length){for(var de in G)if((de==="major"||de==="minor"||de==="patch")&&G[de]!==ie[de])return"pre"+de;return"prerelease"}for(var de in G)if((de==="major"||de==="minor"||de==="patch")&&G[de]!==ie[de])return de},e.compareIdentifiers=X;var Le=/^[0-9]+$/;function X(B,K){var G=Le.test(B),ie=Le.test(K);return G&&ie&&(B=+B,K=+K),G&&!ie?-1:ie&&!G?1:B<K?-1:B>K?1:0}function q(B,K,G){return new Ce(B,G).compare(new Ce(K,G))}function te(B,K,G){return q(B,K,G)>0}function ve(B,K,G){return q(B,K,G)<0}function ae(B,K,G){return q(B,K,G)===0}function be(B,K,G){return q(B,K,G)!==0}function ue(B,K,G){return q(B,K,G)>=0}function J(B,K,G){return q(B,K,G)<=0}function x(B,K,G,ie){var de;switch(K){case"===":typeof B=="object"&&(B=B.version),typeof G=="object"&&(G=G.version),de=B===G;break;case"!==":typeof B=="object"&&(B=B.version),typeof G=="object"&&(G=G.version),de=B!==G;break;case"":case"=":case"==":de=ae(B,G,ie);break;case"!=":de=be(B,G,ie);break;case">":de=te(B,G,ie);break;case">=":de=ue(B,G,ie);break;case"<":de=ve(B,G,ie);break;case"<=":de=J(B,G,ie);break;default:throw new TypeError("Invalid operator: "+K)}return de}function me(B,K){if(B instanceof me){if(B.loose===K)return B;B=B.value}if(!(this instanceof me))return new me(B,K);I("comparator",B,K),this.loose=K,this.parse(B),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(B,K){return X(K,B)},e.major=function(B,K){return new Ce(B,K).major},e.minor=function(B,K){return new Ce(B,K).minor},e.patch=function(B,K){return new Ce(B,K).patch},e.compare=q,e.compareLoose=function(B,K){return q(B,K,!0)},e.rcompare=function(B,K,G){return q(K,B,G)},e.sort=function(B,K){return B.sort(function(G,ie){return e.compare(G,ie,K)})},e.rsort=function(B,K){return B.sort(function(G,ie){return e.rcompare(G,ie,K)})},e.gt=te,e.lt=ve,e.eq=ae,e.neq=be,e.gte=ue,e.lte=J,e.cmp=x,e.Comparator=me;var pe={};function Ae(B,K){if(B instanceof Ae)return B.loose===K?B:new Ae(B.raw,K);if(B instanceof me)return new Ae(B.value,K);if(!(this instanceof Ae))return new Ae(B,K);if(this.loose=K,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function ze(B){return!B||B.toLowerCase()==="x"||B==="*"}function ke(B,K,G,ie,de,Ie,Ue,Ke,_e,tt,nt,et,rt){return((K=ze(G)?"":ze(ie)?">="+G+".0.0":ze(de)?">="+G+"."+ie+".0":">="+K)+" "+(Ke=ze(_e)?"":ze(tt)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Ke)).trim()}function Pe(B,K){for(var G=0;G<B.length;G++)if(!B[G].test(K))return!1;if(K.prerelease.length){for(G=0;G<B.length;G++)if(I(B[G].semver),B[G].semver!==pe&&B[G].semver.prerelease.length>0){var ie=B[G].semver;if(ie.major===K.major&&ie.minor===K.minor&&ie.patch===K.patch)return!0}return!1}return!0}function Te(B,K,G){try{K=new Ae(K,G)}catch{return!1}return K.test(B)}function U(B,K,G,ie){var de,Ie,Ue,Ke,_e;switch(B=new Ce(B,ie),K=new Ae(K,ie),G){case">":de=te,Ie=J,Ue=ve,Ke=">",_e=">=";break;case"<":de=ve,Ie=ue,Ue=te,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(B,K,ie))return!1;for(var tt=0;tt<K.set.length;++tt){var nt=K.set[tt],et=null,rt=null;if(nt.forEach(function(mt){mt.semver===pe&&(mt=new me(">=0.0.0")),et=et||mt,rt=rt||mt,de(mt.semver,et.semver,ie)?et=mt:Ue(mt.semver,rt.semver,ie)&&(rt=mt)}),et.operator===Ke||et.operator===_e||(!rt.operator||rt.operator===Ke)&&Ie(B,rt.semver)||rt.operator===_e&&Ue(B,rt.semver))return!1}return!0}me.prototype.parse=function(B){var K=this.loose?T[Z]:T[ge],G=B.match(K);if(!G)throw new TypeError("Invalid comparator: "+B);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new Ce(G[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(B){return I("Comparator.test",B,this.loose),this.semver===pe||(typeof B=="string"&&(B=new Ce(B,this.loose)),x(B,this.operator,this.semver,this.loose))},me.prototype.intersects=function(B,K){if(!(B instanceof me))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new Ae(B.value,K),Te(this.value,G,K);if(B.operator==="")return G=new Ae(this.value,K),Te(B.semver,G,K);var ie=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ie=this.semver.version===B.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ke=x(this.semver,"<",B.semver,K)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),_e=x(this.semver,">",B.semver,K)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ie||de||Ie&&Ue||Ke||_e},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(B){var K=this.loose;B=B.trim(),I("range",B,K);var G=K?T[se]:T[fe];B=B.replace(G,ke),I("hyphen replace",B),B=B.replace(T[_],"$1$2$3"),I("comparator trim",B,T[_]),B=(B=(B=B.replace(T[F],"$1~")).replace(T[W],"$1^")).split(/\s+/).join(" ");var ie=K?T[Z]:T[ge],de=B.split(" ").map(function(Ie){return function(Ue,Ke){return I("comp",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){I("caret",et,rt);var mt=rt?T[Y]:T[L];return et.replace(mt,function(lt,st,ct,ft,pt){var We;return I("caret",et,lt,st,ct,ft,pt),ze(st)?We="":ze(ct)?We=">="+st+".0.0 <"+(+st+1)+".0.0":ze(ft)?We=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":pt?(I("replaceCaret pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),We=st==="0"?ct==="0"?">="+st+"."+ct+"."+ft+pt+" <"+st+"."+ct+"."+(+ft+1):">="+st+"."+ct+"."+ft+pt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+ft+pt+" <"+(+st+1)+".0.0"):(I("no pr"),We=st==="0"?ct==="0"?">="+st+"."+ct+"."+ft+" <"+st+"."+ct+"."+(+ft+1):">="+st+"."+ct+"."+ft+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+ft+" <"+(+st+1)+".0.0"),I("caret return",We),We})}(nt,tt)}).join(" ")}(Ue,Ke),I("caret",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var mt=rt?T[M]:T[N];return et.replace(mt,function(lt,st,ct,ft,pt){var We;return I("tilde",et,lt,st,ct,ft,pt),ze(st)?We="":ze(ct)?We=">="+st+".0.0 <"+(+st+1)+".0.0":ze(ft)?We=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":pt?(I("replaceTilde pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),We=">="+st+"."+ct+"."+ft+pt+" <"+st+"."+(+ct+1)+".0"):We=">="+st+"."+ct+"."+ft+" <"+st+"."+(+ct+1)+".0",I("tilde return",We),We})}(nt,tt)}).join(" ")}(Ue,Ke),I("tildes",Ue),Ue=function(_e,tt){return I("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var mt=rt?T[C]:T[k];return et.replace(mt,function(lt,st,ct,ft,pt,We){I("xRange",et,lt,st,ct,ft,pt,We);var je=ze(ct),ee=je||ze(ft),Q=ee||ze(pt);return st==="="&&Q&&(st=""),je?lt=st===">"||st==="<"?"<0.0.0":"*":st&&Q?(ee&&(ft=0),Q&&(pt=0),st===">"?(st=">=",ee?(ct=+ct+1,ft=0,pt=0):Q&&(ft=+ft+1,pt=0)):st==="<="&&(st="<",ee?ct=+ct+1:ft=+ft+1),lt=st+ct+"."+ft+"."+pt):ee?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":Q&&(lt=">="+ct+"."+ft+".0 <"+ct+"."+(+ft+1)+".0"),I("xRange return",lt),lt})}(nt,tt)}).join(" ")}(Ue,Ke),I("xrange",Ue),Ue=function(_e,tt){return I("replaceStars",_e,tt),_e.trim().replace(T[ce],"")}(Ue,Ke),I("stars",Ue),Ue}(Ie,K)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(Ie){return!!Ie.match(ie)})),de=de.map(function(Ie){return new me(Ie,K)})},Ae.prototype.intersects=function(B,K){if(!(B instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ie){return B.set.some(function(de){return de.every(function(Ie){return ie.intersects(Ie,K)})})})})},e.toComparators=function(B,K){return new Ae(B,K).set.map(function(G){return G.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new Ce(B,this.loose));for(var K=0;K<this.set.length;K++)if(Pe(this.set[K],B))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(B,K,G){var ie=null,de=null;try{var Ie=new Ae(K,G)}catch{return null}return B.forEach(function(Ue){Ie.test(Ue)&&(ie&&de.compare(Ue)!==-1||(de=new Ce(ie=Ue,G)))}),ie},e.minSatisfying=function(B,K,G){var ie=null,de=null;try{var Ie=new Ae(K,G)}catch{return null}return B.forEach(function(Ue){Ie.test(Ue)&&(ie&&de.compare(Ue)!==1||(de=new Ce(ie=Ue,G)))}),ie},e.validRange=function(B,K){try{return new Ae(B,K).range||"*"}catch{return null}},e.ltr=function(B,K,G){return U(B,K,"<",G)},e.gtr=function(B,K,G){return U(B,K,">",G)},e.outside=U,e.prerelease=function(B,K){var G=oe(B,K);return G&&G.prerelease.length?G.prerelease:null},e.intersects=function(B,K,G){return B=new Ae(B,G),K=new Ae(K,G),B.intersects(K)},e.coerce=function(B){if(B instanceof Ce)return B;if(typeof B!="string")return null;var K=B.match(T[d]);return K==null?null:oe((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,v(1))},function(we,e){var v,P,I=we.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(o){if(v===setTimeout)return setTimeout(o,0);if((v===O||!v)&&setTimeout)return v=setTimeout,setTimeout(o,0);try{return v(o,0)}catch{try{return v.call(null,o,0)}catch{return v.call(this,o,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:O}catch{v=O}try{P=typeof clearTimeout=="function"?clearTimeout:A}catch{P=A}})();var $,a=[],R=!1,y=-1;function c(){R&&$&&(R=!1,$.length?a=$.concat(a):y=-1,a.length&&D())}function D(){if(!R){var o=T(c);R=!0;for(var s=a.length;s;){for($=a,a=[];++y<s;)$&&$[y].run();y=-1,s=a.length}$=null,R=!1,function(l){if(P===clearTimeout)return clearTimeout(l);if((P===A||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(l);try{P(l)}catch{try{return P.call(null,l)}catch{return P.call(this,l)}}}(o)}}function f(o,s){this.fun=o,this.array=s}function n(){}I.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)s[l-1]=arguments[l];a.push(new f(o,s)),a.length!==1||R||T(D)},f.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=n,I.addListener=n,I.once=n,I.off=n,I.removeListener=n,I.removeAllListeners=n,I.emit=n,I.prependListener=n,I.prependOnceListener=n,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Oe[145],Ne([1,0,6,4]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.ScrollbarVisibility=void 0;var I;(function(D){D[D.Auto=1]="Auto",D[D.Hidden=2]="Hidden",D[D.Visible=3]="Visible"})(I||(e.ScrollbarVisibility=I={}));class O{constructor(f,n,o,s,l,i,r){this.c=f,this._scrollStateBrand=void 0,this.c&&(n=n|0,o=o|0,s=s|0,l=l|0,i=i|0,r=r|0),this.rawScrollLeft=s,this.rawScrollTop=r,n<0&&(n=0),s+n>o&&(s=o-n),s<0&&(s=0),l<0&&(l=0),r+l>i&&(r=i-l),r<0&&(r=0),this.width=n,this.scrollWidth=o,this.scrollLeft=s,this.height=l,this.scrollHeight=i,this.scrollTop=r}equals(f){return this.rawScrollLeft===f.rawScrollLeft&&this.rawScrollTop===f.rawScrollTop&&this.width===f.width&&this.scrollWidth===f.scrollWidth&&this.scrollLeft===f.scrollLeft&&this.height===f.height&&this.scrollHeight===f.scrollHeight&&this.scrollTop===f.scrollTop}withScrollDimensions(f,n){return new O(this.c,typeof f.width<"u"?f.width:this.width,typeof f.scrollWidth<"u"?f.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof f.height<"u"?f.height:this.height,typeof f.scrollHeight<"u"?f.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(f){return new O(this.c,this.width,this.scrollWidth,typeof f.scrollLeft<"u"?f.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof f.scrollTop<"u"?f.scrollTop:this.rawScrollTop)}createScrollEvent(f,n){const o=this.width!==f.width,s=this.scrollWidth!==f.scrollWidth,l=this.scrollLeft!==f.scrollLeft,i=this.height!==f.height,r=this.scrollHeight!==f.scrollHeight,t=this.scrollTop!==f.scrollTop;return{inSmoothScrolling:n,oldWidth:f.width,oldScrollWidth:f.scrollWidth,oldScrollLeft:f.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:f.height,oldScrollHeight:f.scrollHeight,oldScrollTop:f.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:s,scrollLeftChanged:l,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$at=O;class A extends P.$Tc{constructor(f){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$je),this.onScroll=this.j.event,this.c=f.smoothScrollDuration,this.f=f.scheduleAtNextAnimationFrame,this.g=new O(f.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(f){this.c=f}validateScrollPosition(f){return this.g.withScrollPosition(f)}getScrollDimensions(){return this.g}setScrollDimensions(f,n){const o=this.g.withScrollDimensions(f,n);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(f){const n=this.g.withScrollPosition(f);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(f,n){if(this.c===0)return this.setScrollPositionNow(f);if(this.h){f={scrollLeft:typeof f.scrollLeft>"u"?this.h.to.scrollLeft:f.scrollLeft,scrollTop:typeof f.scrollTop>"u"?this.h.to.scrollTop:f.scrollTop};const o=this.g.withScrollPosition(f);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let s;n?s=new R(this.h.from,o,this.h.startTime,this.h.duration):s=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=s}else{const o=this.g.withScrollPosition(f);this.h=R.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const f=this.h.tick(),n=this.g.withScrollPosition(f);if(this.n(n,!0),!!this.h){if(f.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(f,n){const o=this.g;o.equals(f)||(this.g=f,this.j.fire(this.g.createScrollEvent(o,n)))}}e.$bt=A;class T{constructor(f,n,o){this.scrollLeft=f,this.scrollTop=n,this.isDone=o}}e.$ct=T;function $(D,f){const n=f-D;return function(o){return D+n*c(o)}}function a(D,f,n){return function(o){return o<n?D(o/n):f((o-n)/(1-n))}}class R{constructor(f,n,o,s){this.from=f,this.to=n,this.duration=s,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(f,n,o){if(Math.abs(f-n)>2.5*o){let l,i;return f<n?(l=f+.75*o,i=n-.75*o):(l=f-.75*o,i=n+.75*o),a($(f,l),$(i,n),.33)}return $(f,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(f){this.to=f.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(f){const n=(f-this.startTime)/this.duration;if(n<1){const o=this.c(n),s=this.d(n);return new T(o,s,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(f,n,o){return R.start(f,n,o)}static start(f,n,o){o=o+10;const s=Date.now()-10;return new R(f,n,s,o)}}e.$dt=R;function y(D){return Math.pow(D,3)}function c(D){return 1-y(1-D)}}),define(Oe[146],Ne([1,0,13,4]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=I,e.$xe=O,e.$ye=A,e.$ze=T,e.$Ae=a,e.$Be=R,e.$Ce=y,e.$De=c,e.$Ee=D,e.$Fe=f,e.$Ge=n,e.$He=o,e.$Ie=s,e.$Je=l,e.$Ke=i;function I(r){const t=r;return t?typeof t.read=="function":!1}function O(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function A(r){const t=r;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(r,t){return new $(r,t)}class ${constructor(t,g){this.e=t,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(g=>g(t))}h(t){this.c.error.length===0?(0,v.$Y)(t):this.c.error.slice(0).forEach(g=>g(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,g){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(t,g){if(this.a.destroyed)return;let u;switch(t){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const p=u.indexOf(g);p>=0&&u.splice(p,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(r,t){const g=[];let u;for(;(u=r.read())!==null;)g.push(u);return t(g)}function R(r,t,g){const u=[];let p;for(;(p=r.read())!==null&&u.length<g;)u.push(p);return p===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof p<"u"){const m=p;return p=void 0,m}return r.read()}}}function y(r,t){return new Promise((g,u)=>{const p=[];c(r,{onData:m=>{t&&p.push(m)},onError:m=>{t?u(m):g(void 0)},onEnd:()=>{g(t?t(p):void 0)}})})}function c(r,t,g){r.on("error",u=>{g?.isCancellationRequested||t.onError(u)}),r.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),r.on("data",u=>{g?.isCancellationRequested||t.onData(u)})}function D(r,t){return new Promise((g,u)=>{const p=new P.$Sc,m=[],h=w=>{if(m.push(w),m.length>t)return p.dispose(),r.pause(),g({stream:r,buffer:m,ended:!1})},E=w=>(p.dispose(),u(w)),S=()=>(p.dispose(),g({stream:r,buffer:m,ended:!0}));p.add((0,P.$Rc)(()=>r.removeListener("error",E))),r.on("error",E),p.add((0,P.$Rc)(()=>r.removeListener("end",S))),r.on("end",S),p.add((0,P.$Rc)(()=>r.removeListener("data",h))),r.on("data",h)})}function f(r,t){const g=T(t);return g.end(r),g}function n(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}function o(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function s(r,t,g){const u=T(g);return c(r,{onData:p=>u.write(t.data(p)),onError:p=>u.error(t.error?t.error(p):p),onEnd:()=>u.end()}),u}function l(r,t,g){let u=!1;return{read:()=>{const p=t.read();return u?p:(u=!0,p!==null?g([r,p]):r)}}}function i(r,t,g){let u=!1;const p=T(g);return c(t,{onData:m=>u?p.write(m):(u=!0,p.write(g([r,m]))),onError:m=>p.error(m),onEnd:()=>{u||(u=!0,p.write(r)),p.end()}}),p}}),define(Oe[22],Ne([1,0,48,146]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=a,e.$Ne=R,e.$Oe=y,e.$Pe=c,e.$Qe=D,e.$Re=f,e.$Se=n,e.$Te=o,e.$Ue=s,e.$Ve=l,e.$We=i,e.$Xe=r,e.$Ye=t,e.$Ze=g,e.$1e=u,e.$2e=p,e.$3e=m,e.$4e=h,e.$5e=E,e.$6e=k,P=qe(P);const I=typeof Buffer<"u",O=new v.$T(()=>new Uint8Array(256));let A,T;class ${static alloc(d){return I?new $(Buffer.allocUnsafe(d)):new $(new Uint8Array(d))}static wrap(d){return I&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new $(d)}static fromString(d,b){return!(b?.dontUseNodeBuffer||!1)&&I?new $(Buffer.from(d)):(A||(A=new TextEncoder),new $(A.encode(d)))}static fromByteArray(d){const b=$.alloc(d.length);for(let F=0,N=d.length;F<N;F++)b.buffer[F]=d[F];return b}static concat(d,b){if(typeof b>"u"){b=0;for(let M=0,V=d.length;M<V;M++)b+=d[M].byteLength}const F=$.alloc(b);let N=0;for(let M=0,V=d.length;M<V;M++){const W=d[M];F.set(W,N),N+=W.byteLength}return F}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=$.alloc(this.byteLength);return d.set(this),d}toString(){return I?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(d,b){return new $(this.buffer.subarray(d,b))}set(d,b){if(d instanceof $)this.buffer.set(d.buffer,b);else if(d instanceof Uint8Array)this.buffer.set(d,b);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),b);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return c(this.buffer,d)}writeUInt32BE(d,b){D(this.buffer,d,b)}readUInt32LE(d){return f(this.buffer,d)}writeUInt32LE(d,b){n(this.buffer,d,b)}readUInt8(d){return o(this.buffer,d)}writeUInt8(d,b){s(this.buffer,d,b)}indexOf(d,b=0){return a(this.buffer,d instanceof $?d.buffer:d,b)}}e.$Le=$;function a(C,d,b=0){const F=d.byteLength,N=C.byteLength;if(F===0)return 0;if(F===1)return C.indexOf(d[0]);if(F>N-b)return-1;const M=O.value;M.fill(d.length);for(let Y=0;Y<d.length;Y++)M[d[Y]]=d.length-Y-1;let V=b+d.length-1,W=V,L=-1;for(;V<N;)if(C[V]===d[W]){if(W===0){L=V;break}V--,W--}else V+=Math.max(d.length-W,M[C[V]]),W=d.length-1;return L}function R(C,d){return C[d+0]<<0>>>0|C[d+1]<<8>>>0}function y(C,d,b){C[b+0]=d&255,d=d>>>8,C[b+1]=d&255}function c(C,d){return C[d]*2**24+C[d+1]*2**16+C[d+2]*2**8+C[d+3]}function D(C,d,b){C[b+3]=d,d=d>>>8,C[b+2]=d,d=d>>>8,C[b+1]=d,d=d>>>8,C[b]=d}function f(C,d){return C[d+0]<<0>>>0|C[d+1]<<8>>>0|C[d+2]<<16>>>0|C[d+3]<<24>>>0}function n(C,d,b){C[b+0]=d&255,d=d>>>8,C[b+1]=d&255,d=d>>>8,C[b+2]=d&255,d=d>>>8,C[b+3]=d&255}function o(C,d){return C[d]}function s(C,d,b){C[b]=d}function l(C){return P.$Ae(C,d=>$.concat(d))}function i(C){return P.$He(C)}function r(C){return P.$Ce(C,d=>$.concat(d))}async function t(C){return C.ended?$.concat(C.buffer):$.concat([...C.buffer,await r(C.stream)])}function g(C){return P.$Fe(C,d=>$.concat(d))}function u(C){return P.$Ie(C,{data:d=>typeof d=="string"?$.fromString(d):$.wrap(d)},d=>$.concat(d))}function p(C){return P.$ze(d=>$.concat(d),C)}function m(C,d){return P.$Je(C,d,b=>$.concat(b))}function h(C,d){return P.$Ke(C,d,b=>$.concat(b))}function E(C){let d=0,b=0,F=0;const N=new Uint8Array(Math.floor(C.length/4*3)),M=W=>{switch(b){case 3:N[F++]=d|W,b=0;break;case 2:N[F++]=d|W>>>2,d=W<<6,b=3;break;case 1:N[F++]=d|W>>>4,d=W<<4,b=2;break;default:d=W<<2,b=1}};for(let W=0;W<C.length;W++){const L=C.charCodeAt(W);if(L>=65&&L<=90)M(L-65);else if(L>=97&&L<=122)M(L-97+26);else if(L>=48&&L<=57)M(L-48+52);else if(L===43||L===45)M(62);else if(L===47||L===95)M(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${C[W]}`)}}const V=F;for(;b>0;)M(0);return $.wrap(N).slice(0,V)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:C},d=!0,b=!1){const F=b?w:S;let N="";const M=C.byteLength%3;let V=0;for(;V<C.byteLength-M;V+=3){const W=C[V+0],L=C[V+1],Y=C[V+2];N+=F[W>>>2],N+=F[(W<<4|L>>>4)&63],N+=F[(L<<2|Y>>>6)&63],N+=F[Y&63]}if(M===1){const W=C[V+0];N+=F[W>>>2],N+=F[W<<4&63],d&&(N+="==")}else if(M===2){const W=C[V+0],L=C[V+1];N+=F[W>>>2],N+=F[(W<<4|L>>>4)&63],N+=F[L<<2&63],d&&(N+="=")}return N}}),define(Oe[147],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(Oe[34],Ne([1,0,97]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=I;var P;(function(A){function T($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=T})(P||(e.ThemeColor=P={}));function I(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(l){const i=T.exec(l.id);if(!i)return $(v.$2j.error);const[,r,t]=i,g=["codicon","codicon-"+r];return t&&g.push("codicon-modifier-"+t.substring(1)),g}A.asClassNameArray=$;function a(l){return $(l).join(" ")}A.asClassName=a;function R(l){return"."+$(l).join(".")}A.asCSSSelector=R;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||P.isThemeColor(l.color))}A.isThemeIcon=y;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function D(l){const i=c.exec(l);if(!i)return;const[,r]=i;return{id:r}}A.fromString=D;function f(l){return{id:l}}A.fromId=f;function n(l,i){let r=l.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}A.modify=n;function o(l){const i=l.id.lastIndexOf("~");if(i!==-1)return l.id.substring(i+1)}A.getModifier=o;function s(l,i){return l.id===i.id&&l.color?.id===i.color?.id}A.isEqual=s})(O||(e.ThemeIcon=O={}))}),define(Oe[51],Ne([1,0,27,19,20,12,14]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=T,e.$vg=$,e.$wg=a,e.$xg=R,e.$yg=y,e.$zg=n,e.$Ag=o,e.$Bg=s,e.$Cg=l,e.$Dg=i,e.$Eg=r,e.$Fg=t,e.$Gg=g,e.$Hg=u,e.$Ig=p,e.$Jg=m,e.$Kg=S;function T(w){return w===v.CharCode.Slash||w===v.CharCode.Backslash}function $(w){return w.replace(/[\\/]/g,P.$fc.sep)}function a(w){return w.indexOf("/")===-1&&(w=$(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function R(w,k=P.$fc.sep){if(!w)return"";const C=w.length,d=w.charCodeAt(0);if(T(d)){if(T(w.charCodeAt(1))&&!T(w.charCodeAt(2))){let F=3;const N=F;for(;F<C&&!T(w.charCodeAt(F));F++);if(N!==F&&!T(w.charCodeAt(F+1))){for(F+=1;F<C;F++)if(T(w.charCodeAt(F)))return w.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(l(d)&&w.charCodeAt(1)===v.CharCode.Colon)return T(w.charCodeAt(2))?w.slice(0,2)+k:w.slice(0,2);let b=w.indexOf("://");if(b!==-1){for(b+=3;b<C;b++)if(T(w.charCodeAt(b)))return w.slice(0,b+1)}return""}function y(w){if(!I.$j||!w||w.length<5)return!1;let k=w.charCodeAt(0);if(k!==v.CharCode.Backslash||(k=w.charCodeAt(1),k!==v.CharCode.Backslash))return!1;let C=2;const d=C;for(;C<w.length&&(k=w.charCodeAt(C),k!==v.CharCode.Backslash);C++);return!(d===C||(k=w.charCodeAt(C+1),isNaN(k)||k===v.CharCode.Backslash))}const c=/[\\/:\*\?"<>\|]/g,D=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(w,k=I.$j){const C=k?c:D;return!(!w||w.length===0||/^\s+$/.test(w)||(C.lastIndex=0,C.test(w))||k&&f.test(w)||w==="."||w===".."||k&&w[w.length-1]==="."||k&&w.length!==w.trim().length||w.length>255)}function o(w,k,C){const d=w===k;return!C||d?d:!w||!k?!1:(0,O.$Df)(w,k)}function s(w,k,C,d=P.sep){if(w===k)return!0;if(!w||!k||k.length>w.length)return!1;if(C){if(!(0,O.$Ef)(w,k))return!1;if(k.length===w.length)return!0;let F=k.length;return k.charAt(k.length-1)===d&&F--,w.charAt(F)===d}return k.charAt(k.length-1)!==d&&(k+=d),w.indexOf(k)===0}function l(w){return w>=v.CharCode.A&&w<=v.CharCode.Z||w>=v.CharCode.a&&w<=v.CharCode.z}function i(w,k){return I.$j&&w.endsWith(":")&&(w+=P.sep),(0,P.$hc)(w)||(w=(0,P.$ic)(k,w)),w=(0,P.$gc)(w),r(w)}function r(w){return I.$j?(w=(0,O.$lf)(w,P.sep),w.endsWith(":")&&(w+=P.sep)):(w=(0,O.$lf)(w,P.sep),w||(w=P.sep)),w}function t(w){const k=(0,P.$gc)(w);return I.$j?w.length>3?!1:g(k)&&(w.length===2||k.charCodeAt(2)===v.CharCode.Backslash):k===P.$fc.sep}function g(w,k=I.$j){return k?l(w.charCodeAt(0))&&w.charCodeAt(1)===v.CharCode.Colon:!1}function u(w,k=I.$j){return g(w,k)?w[0]:void 0}function p(w,k,C){return k.length>w.length?-1:w===k?0:(C&&(w=w.toLowerCase(),k=k.toLowerCase()),w.indexOf(k))}function m(w){const k=w.split(":");let C,d,b;for(const F of k){const N=Number(F);(0,A.$gg)(N)?d===void 0?d=N:b===void 0&&(b=N):C=C?[C,F].join(":"):F}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:d!==void 0?d:void 0,column:b!==void 0?b:d!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(w,k,C=8){let d="";for(let F=0;F<C;F++){let N;F===0&&I.$j&&!k&&(C===3||C===4)?N=E:N=h,d+=N.charAt(Math.floor(Math.random()*N.length))}let b;return k?b=`${k}-${d}`:b=d,w?(0,P.$ic)(w,b):b}}),define(Oe[148],Ne([1,0,27,28,138,12]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.FuzzyScore=e.$Fk=e.$Ek=void 0,e.or=A,e.$Gk=$,e.$Hk=a,e.$Ik=c,e.$Jk=S,e.$Kk=w,e.$Lk=N,e.$Mk=M,e.$Nk=V,e.$Ok=W,e.$Pk=te,e.$Rk=ue,e.$Sk=me,e.$Tk=pe,O=qe(O);function A(...ke){return function(Pe,Te){for(let U=0,B=ke.length;U<B;U++){const K=ke[U](Pe,Te);if(K)return K}return null}}e.$Ek=T.bind(void 0,!1),e.$Fk=T.bind(void 0,!0);function T(ke,Pe,Te){if(!Te||Te.length<Pe.length)return null;let U;return ke?U=O.$Ef(Te,Pe):U=Te.indexOf(Pe)===0,U?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(ke,Pe){const Te=Pe.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function a(ke,Pe){return R(ke.toLowerCase(),Pe.toLowerCase(),0,0)}function R(ke,Pe,Te,U){if(Te===ke.length)return[];if(U===Pe.length)return null;if(ke[Te]===Pe[U]){let B=null;return(B=R(ke,Pe,Te+1,U+1))?t({start:U,end:U+1},B):null}return R(ke,Pe,Te,U+1)}function y(ke){return v.CharCode.a<=ke&&ke<=v.CharCode.z}function c(ke){return v.CharCode.A<=ke&&ke<=v.CharCode.Z}function D(ke){return v.CharCode.Digit0<=ke&&ke<=v.CharCode.Digit9}function f(ke){return ke===v.CharCode.Space||ke===v.CharCode.Tab||ke===v.CharCode.LineFeed||ke===v.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>n.add(ke.charCodeAt(0)));function o(ke){return f(ke)||n.has(ke)}function s(ke,Pe){return ke===Pe||o(ke)&&o(Pe)}const l=new Map;function i(ke){if(l.has(ke))return l.get(ke);let Pe;const Te=(0,I.$Ck)(ke);return Te&&(Pe=Te),l.set(ke,Pe),Pe}function r(ke){return y(ke)||c(ke)||D(ke)}function t(ke,Pe){return Pe.length===0?Pe=[ke]:ke.end===Pe[0].start?Pe[0].start=ke.start:Pe.unshift(ke),Pe}function g(ke,Pe){for(let Te=Pe;Te<ke.length;Te++){const U=ke.charCodeAt(Te);if(c(U)||D(U)||Te>0&&!r(ke.charCodeAt(Te-1)))return Te}return ke.length}function u(ke,Pe,Te,U){if(Te===ke.length)return[];if(U===Pe.length)return null;if(ke[Te]!==Pe[U].toLowerCase())return null;{let B=null,K=U+1;for(B=u(ke,Pe,Te+1,U+1);!B&&(K=g(Pe,K))<Pe.length;)B=u(ke,Pe,Te+1,K),K++;return B===null?null:t({start:U,end:U+1},B)}}function p(ke){let Pe=0,Te=0,U=0,B=0,K=0;for(let Ue=0;Ue<ke.length;Ue++)K=ke.charCodeAt(Ue),c(K)&&Pe++,y(K)&&Te++,r(K)&&U++,D(K)&&B++;const G=Pe/ke.length,ie=Te/ke.length,de=U/ke.length,Ie=B/ke.length;return{upperPercent:G,lowerPercent:ie,alphaPercent:de,numericPercent:Ie}}function m(ke){const{upperPercent:Pe,lowerPercent:Te}=ke;return Te===0&&Pe>.6}function h(ke){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:U,numericPercent:B}=ke;return Te>.2&&Pe<.8&&U>.6&&B<.2}function E(ke){let Pe=0,Te=0,U=0,B=0;for(let K=0;K<ke.length;K++)U=ke.charCodeAt(K),c(U)&&Pe++,y(U)&&Te++,f(U)&&B++;return(Pe===0||Te===0)&&B===0?ke.length<=30:Pe<=5}function S(ke,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!E(ke))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=p(Pe);if(!h(Te)){if(!m(Te))return null;Pe=Pe.toLowerCase()}let U=null,B=0;for(ke=ke.toLowerCase();B<Pe.length&&(U=u(ke,Pe,0,B))===null;)B=g(Pe,B+1);return U}function w(ke,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let U=null,B=0;for(ke=ke.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(U=k(ke,Pe,0,B,Te),U===null);)B=C(Pe,B+1);return U}function k(ke,Pe,Te,U,B){let K=0;if(Te===ke.length)return[];if(U===Pe.length)return null;if(!s(ke.charCodeAt(Te),Pe.charCodeAt(U))){const de=i(ke.charCodeAt(Te));if(!de)return null;for(let Ie=0;Ie<de.length;Ie++)if(!s(de[Ie],Pe.charCodeAt(U+Ie)))return null;K+=de.length-1}let G=null,ie=U+K+1;if(G=k(ke,Pe,Te+1,ie,B),!B)for(;!G&&(ie=C(Pe,ie))<Pe.length;)G=k(ke,Pe,Te+1,ie,B),ie++;if(!G)return null;if(ke.charCodeAt(Te)!==Pe.charCodeAt(U)){const de=i(ke.charCodeAt(Te));if(!de)return G;for(let Ie=0;Ie<de.length;Ie++)if(de[Ie]!==Pe.charCodeAt(U+Ie))return G}return t({start:U,end:U+K+1},G)}function C(ke,Pe){for(let Te=Pe;Te<ke.length;Te++)if(o(ke.charCodeAt(Te))||Te>0&&o(ke.charCodeAt(Te-1)))return Te;return ke.length}const d=A(e.$Fk,S,$),b=A(e.$Fk,S,a),F=new P.$Cc(1e4);function N(ke,Pe,Te=!1){if(typeof ke!="string"||typeof Pe!="string")return null;let U=F.get(ke);U||(U=new RegExp(O.$mf(ke),"i"),F.set(ke,U));const B=U.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Te?b(ke,Pe):d(ke,Pe)}function M(ke,Pe){const Te=ue(ke,ke.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?W(Te):null}function V(ke,Pe,Te,U,B,K){const G=Math.min(13,ke.length);for(;Te<G;Te++){const ie=ue(ke,Pe,Te,U,B,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ie)return ie}return[0,K]}function W(ke){if(typeof ke>"u")return[];const Pe=[],Te=ke[1];for(let U=ke.length-1;U>1;U--){const B=ke[U]+Te,K=Pe[Pe.length-1];K&&K.end===B?K.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const L=128;function Y(){const ke=[],Pe=[];for(let Te=0;Te<=L;Te++)Pe[Te]=0;for(let Te=0;Te<=L;Te++)ke.push(Pe.slice(0));return ke}function Z(ke){const Pe=[];for(let Te=0;Te<=ke;Te++)Pe[Te]=0;return Pe}const ge=Z(2*L),_=Z(2*L),fe=Y(),se=Y(),ce=Y(),$e=!1;function oe(ke,Pe,Te,U,B){function K(ie,de,Ie=" "){for(;ie.length<de;)ie=Ie+ie;return ie}let G=` |   |${U.split("").map(ie=>K(ie,3)).join("|")}
`;for(let ie=0;ie<=Te;ie++)ie===0?G+=" |":G+=`${Pe[ie-1]}|`,G+=ke[ie].slice(0,B+1).map(de=>K(de.toString(),3)).join("|")+`
`;return G}function Ce(ke,Pe,Te,U){ke=ke.substr(Pe),Te=Te.substr(U),console.log(oe(se,ke,ke.length,Te,Te.length)),console.log(oe(ce,ke,ke.length,Te,Te.length)),console.log(oe(fe,ke,ke.length,Te,Te.length))}function Le(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;const Te=ke.codePointAt(Pe);switch(Te){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Wf(Te)}}function X(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;switch(ke.charCodeAt(Pe)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function q(ke,Pe,Te){return Pe[ke]!==Te[ke]}function te(ke,Pe,Te,U,B,K,G=!1){for(;Pe<Te&&B<K;)ke[Pe]===U[B]&&(G&&(ge[Pe]=B),Pe+=1),B+=1;return Pe===Te}var ve;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ae;(function(ke){ke.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Pe})(ae||(e.FuzzyScore=ae={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Qk=be;function ue(ke,Pe,Te,U,B,K,G=be.default){const ie=ke.length>L?L:ke.length,de=U.length>L?L:U.length;if(Te>=ie||K>=de||ie-Te>de-K||!te(Pe,Te,ie,B,K,de,!0))return;J(ie,de,Te,K,Pe,B);let Ie=1,Ue=1,Ke=Te,_e=K;const tt=[!1];for(Ie=1,Ke=Te;Ke<ie;Ie++,Ke++){const lt=ge[Ke],st=_[Ke],ct=Ke+1<ie?_[Ke+1]:de;for(Ue=lt-K+1,_e=lt;_e<ct;Ue++,_e++){let ft=Number.MIN_SAFE_INTEGER,pt=!1;_e<=st&&(ft=x(ke,Pe,Ke,Te,U,B,_e,de,K,fe[Ie-1][Ue-1]===0,tt));let We=0;ft!==Number.MAX_SAFE_INTEGER&&(pt=!0,We=ft+se[Ie-1][Ue-1]);const je=_e>lt,ee=je?se[Ie][Ue-1]+(fe[Ie][Ue-1]>0?-5:0):0,Q=_e>lt+1&&fe[Ie][Ue-1]>0,Se=Q?se[Ie][Ue-2]+(fe[Ie][Ue-2]>0?-5:0):0;if(Q&&(!je||Se>=ee)&&(!pt||Se>=We))se[Ie][Ue]=Se,ce[Ie][Ue]=ve.LeftLeft,fe[Ie][Ue]=0;else if(je&&(!pt||ee>=We))se[Ie][Ue]=ee,ce[Ie][Ue]=ve.Left,fe[Ie][Ue]=0;else if(pt)se[Ie][Ue]=We,ce[Ie][Ue]=ve.Diag,fe[Ie][Ue]=fe[Ie-1][Ue-1]+1;else throw new Error("not possible")}}if($e&&Ce(ke,Te,U,K),!tt[0]&&!G.firstMatchCanBeWeak)return;Ie--,Ue--;const nt=[se[Ie][Ue],K];let et=0,rt=0;for(;Ie>=1;){let lt=Ue;do{const st=ce[Ie][lt];if(st===ve.LeftLeft)lt=lt-2;else if(st===ve.Left)lt=lt-1;else break}while(lt>=1);et>1&&Pe[Te+Ie-1]===B[K+Ue-1]&&!q(lt+K-1,U,B)&&et+1>fe[Ie][lt]&&(lt=Ue),lt===Ue?et++:et=1,rt||(rt=lt),Ie--,Ue=lt-1,nt.push(Ue)}de-K===ie&&G.boostFullMatch&&(nt[0]+=2);const mt=rt-ie;return nt[0]-=mt,nt}function J(ke,Pe,Te,U,B,K){let G=ke-1,ie=Pe-1;for(;G>=Te&&ie>=U;)B[G]===K[ie]&&(_[G]=ie,G--),ie--}function x(ke,Pe,Te,U,B,K,G,ie,de,Ie,Ue){if(Pe[Te]!==K[G])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return G===Te-U?Ke=ke[Te]===B[G]?7:5:q(G,B,K)&&(G===0||!q(G-1,B,K))?(Ke=ke[Te]===B[G]?7:5,_e=!0):Le(K,G)&&(G===0||!Le(K,G-1))?Ke=5:(Le(K,G-1)||X(K,G-1))&&(Ke=5,_e=!0),Ke>1&&Te===U&&(Ue[0]=!0),_e||(_e=q(G,B,K)||Le(K,G-1)||X(K,G-1)),Te===U?G>de&&(Ke-=_e?3:5):Ie?Ke+=_e?2:0:Ke+=_e?0:1,G+1===ie&&(Ke-=_e?3:5),Ke}function me(ke,Pe,Te,U,B,K,G){return Ae(ke,Pe,Te,U,B,K,!0,G)}function pe(ke,Pe,Te,U,B,K,G){return Ae(ke,Pe,Te,U,B,K,!1,G)}function Ae(ke,Pe,Te,U,B,K,G,ie){let de=ue(ke,Pe,Te,U,B,K,ie);if(de&&!G)return de;if(ke.length>=3){const Ie=Math.min(7,ke.length-1);for(let Ue=Te+1;Ue<Ie;Ue++){const Ke=ze(ke,Ue);if(Ke){const _e=ue(Ke,Ke.toLowerCase(),Te,U,B,K,ie);_e&&(_e[0]-=3,(!de||_e[0]>de[0])&&(de=_e))}}}return de}function ze(ke,Pe){if(Pe+1>=ke.length)return;const Te=ke[Pe],U=ke[Pe+1];if(Te!==U)return ke.slice(0,Pe)+U+Te+ke.slice(Pe+2)}}),define(Oe[98],Ne([1,0,148,12,34]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=$,e.$Vk=R,e.$Wk=c,e.$Xk=D,e.$Yk=n,e.$Zk=o;const O="$(",A=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function $(s){return s.replace(T,(l,i)=>i?l:`\\${l}`)}const a=new RegExp(`\\\\${A.source}`,"g");function R(s){return s.replace(a,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(s){return s.indexOf(O)===-1?s:s.replace(y,(l,i,r,t)=>r?l:i||t||"")}function D(s){return s?s.replace(/\$\((.*?)\)/g,(l,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(s){f.lastIndex=0;let l="";const i=[];let r=0;for(;;){const t=f.lastIndex,g=f.exec(s),u=s.substring(t,g?.index);if(u.length>0){l+=u;for(let p=0;p<u.length;p++)i.push(r)}if(!g)break;r+=g[0].length}return{text:l,iconOffsets:i}}function o(s,l,i=!1){const{text:r,iconOffsets:t}=l;if(!t||t.length===0)return(0,v.$Lk)(s,r,i);const g=(0,P.$kf)(r," "),u=r.length-g.length,p=(0,v.$Lk)(s,g,i);if(p)for(const m of p){const h=t[m.start+u]+u;m.start+=h,m.end+=h}return p}}),define(Oe[35],Ne([1,0,12]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=qe(v);var P;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(P||(P={})),function(I){const O="error",A="warning",T="warn",$="info",a="ignore";function R(c){return c?v.$Df(O,c)?I.Error:v.$Df(A,c)||v.$Df(T,c)?I.Warning:v.$Df($,c)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function y(c){switch(c){case I.Error:return O;case I.Warning:return A;case I.Info:return $;default:return a}}I.toString=y}(P||(P={})),e.default=P}),define(Oe[58],Ne([1,0,17,27,12]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class O{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const n=f.charCodeAt(0),o=this.b.charCodeAt(this.c);return n-o}value(){return this.b[this.c]}}e.$Ei=O;class A{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===P.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,I.$xf)(f,this.b,0,f.length,this.c,this.d):(0,I.$zf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=A;class T{constructor(f=!0,n=!0){this.f=f,this.g=n}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let n=f.length-1;n>=0;n--,this.c--){const o=this.b.charCodeAt(n);if(!(o===P.CharCode.Slash||this.f&&o===P.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===P.CharCode.Slash||this.f&&n===P.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,I.$xf)(f,this.b,0,f.length,this.d,this.e):(0,I.$zf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=T;var $;(function(D){D[D.Scheme=1]="Scheme",D[D.Authority=2]="Authority",D[D.Path=3]="Path",D[D.Query=4]="Query",D[D.Fragment=5]="Fragment"})($||($={}));class a{constructor(f,n){this.f=f,this.g=n,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new T(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push($.Path)),this.g(f)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===$.Scheme)return(0,I.$yf)(f,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,I.$yf)(f,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(f);if(this.d[this.e]===$.Query)return(0,I.$wf)(f,this.c.query);if(this.d[this.e]===$.Fragment)return(0,I.$wf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Hi=a;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(D){D[D.Left=-1]="Left",D[D.Mid=0]="Mid",D[D.Right=1]="Right"})(y||(y={}));class c{static forUris(f=()=>!1,n=()=>!1){return new c(new a(f,n))}static forPaths(f=!1){return new c(new T(void 0,!f))}static forStrings(){return new c(new O)}static forConfigKeys(){return new c(new A)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,n){if(n){const o=n.slice(0);(0,v.$Vb)(o);for(const s of o)this.set(s,f)}else{const o=f.slice(0);(0,v.$Vb)(o);for(const s of o)this.set(s[0],s[1])}}set(f,n){const o=this.b.reset(f);let s;this.c||(this.c=new R,this.c.segment=o.value());const l=[];for(s=this.c;;){const r=o.cmp(s.segment);if(r>0)s.left||(s.left=new R,s.left.segment=o.value()),l.push([y.Left,s]),s=s.left;else if(r<0)s.right||(s.right=new R,s.right.segment=o.value()),l.push([y.Right,s]),s=s.right;else if(o.hasNext())o.next(),s.mid||(s.mid=new R,s.mid.segment=o.value()),l.push([y.Mid,s]),s=s.mid;else break}const i=s.value;s.value=n,s.key=f;for(let r=l.length-1;r>=0;r--){const t=l[r][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const u=l[r][0],p=l[r+1][0];if(u===y.Right&&p===y.Right)l[r][1]=t.rotateLeft();else if(u===y.Left&&p===y.Left)l[r][1]=t.rotateRight();else if(u===y.Right&&p===y.Left)t.right=l[r+1][1]=l[r+1][1].rotateRight(),l[r][1]=t.rotateLeft();else if(u===y.Left&&p===y.Right)t.left=l[r+1][1]=l[r+1][1].rotateLeft(),l[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(l[r-1][0]){case y.Left:l[r-1][1].left=l[r][1];break;case y.Right:l[r-1][1].right=l[r][1];break;case y.Mid:l[r-1][1].mid=l[r][1];break}else this.c=l[0][1]}}return i}get(f){return this.d(f)?.value}d(f){const n=this.b.reset(f);let o=this.c;for(;o;){const s=n.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(f){const n=this.d(f);return!(n?.value===void 0&&n?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,n){const o=this.b.reset(f),s=[];let l=this.c;for(;l;){const i=o.cmp(l.segment);if(i>0)s.push([y.Left,l]),l=l.left;else if(i<0)s.push([y.Right,l]),l=l.right;else if(o.hasNext())o.next(),s.push([y.Mid,l]),l=l.mid;else break}if(l){if(n?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this.f(l.right);if(i.key){const{key:r,value:t,segment:g}=i;this.e(i.key,!1),l.key=r,l.value=t,l.segment=g}}else{const i=l.left??l.right;if(s.length>0){const[r,t]=s[s.length-1];switch(r){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=s.length-1;i>=0;i--){const r=s[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),s[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),s[i][1]=r.rotateRight()),i>0)switch(s[i-1][0]){case y.Left:s[i-1][1].left=s[i][1];break;case y.Right:s[i-1][1].right=s[i][1];break;case y.Mid:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const n=this.b.reset(f);let o=this.c,s;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),s=o.value||s,o=o.mid;else break}return o&&o.value||s}findSuperstr(f){return this.g(f,!1)}g(f,n){const o=this.b.reset(f);let s=this.c;for(;s;){const l=o.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this.h(s.mid):n?s.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[n,o]of this)f(o,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const n=[];return this.j(f,n),n[Symbol.iterator]()}j(f,n){f&&(f.left&&this.j(f.left,n),f.value&&n.push([f.key,f.value]),f.mid&&this.j(f.mid,n),f.right&&this.j(f.right,n))}_isBalanced(){const f=n=>{if(!n)return!0;const o=n.balanceFactor();return o<-1||o>1?!1:f(n.left)&&f(n.right)};return f(this.c)}}e.$Ii=c}),define(Oe[40],Ne([1,0,22,2,36]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=O,e.$$h=A,e.$_h=$;function O(a){return JSON.stringify(a,T)}function A(a){let R=JSON.parse(a);return R=$(R),R}function T(a,R){return R instanceof RegExp?{$mid:I.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function $(a,R=0){if(!a||R>200)return a;if(typeof a=="object"){switch(a.$mid){case I.MarshalledId.Uri:return P.URI.revive(a);case I.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case I.MarshalledId.Date:return new Date(a.source)}if(a instanceof v.$Le||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let y=0;y<a.length;++y)a[y]=$(a[y],R+1);else for(const y in a)Object.hasOwnProperty.call(a,y)&&(a[y]=$(a[y],R+1))}return a}}),define(Oe[15],Ne([1,0,13,20,12,2,19]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=$,e.$Mg=a,e.$Qg=y,v=qe(v),P=qe(P),A=qe(A);var T;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(T||(e.Schemas=T={}));function $(f,n){return O.URI.isUri(f)?(0,I.$Df)(f.scheme,n):(0,I.$Ef)(f,n+":")}function a(f,...n){return n.some(o=>$(f,o))}e.$Ng="vscode-tkn",e.$Og="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=y(n,o)}getServerRootPath(){return this.f}get g(){return A.$fc.join(this.f,T.vscodeRemoteResource)}set(n,o,s){this.a[n]=o,this.b[n]=s}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return v.$Y(t),n}const o=n.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const l=this.b[o],i=this.c[o];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Og}=${encodeURIComponent(i)}`),O.URI.from({scheme:P.$p?this.d:T.vscodeRemoteResource,authority:`${s}:${l}`,path:this.g,query:r})}}e.$Pg=new R;function y(f,n){return A.$fc.join(n??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class c{static{this.a=e.$Vg}asBrowserUri(n){const o=this.b(n,we);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?e.$Pg.rewrite(n):n.scheme===T.file&&(P.$n||P.$r===`${T.vscodeFileResource}://${c.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||c.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,we);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==c.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return O.URI.isUri(n)?n:O.URI.parse(o.toUrl(n))}}e.$Wg=new c;var D;(function(f){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function s(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:O.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(o);if(t)return n.get(t)}f.getHeadersFromQuery=s;function l(i,r,t){if(!globalThis.crossOriginIsolated)return;const g=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(o,g):i[o]=g}f.addSearchParam=l})(D||(e.COI=D={}))}),define(Oe[23],Ne([1,0,27,51,15,19,20,12,2]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=a,e.$mh=y,e.$nh=D,P=qe(P),O=qe(O);function a(f){return(0,$.$vc)(f,!0)}class R{constructor(n){this.a=n}compare(n,o,s=!1){return n===o?0:(0,T.$wf)(this.getComparisonKey(n,s),this.getComparisonKey(o,s))}isEqual(n,o,s=!1){return n===o?!0:!n||!o?!1:this.getComparisonKey(n,s)===this.getComparisonKey(o,s)}getComparisonKey(n,o=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,o,s=!1){if(n.scheme===o.scheme){if(n.scheme===I.Schemas.file)return P.$Bg(a(n),a(o),this.a(n))&&n.query===o.query&&(s||n.fragment===o.fragment);if((0,e.$ih)(n.authority,o.authority))return P.$Bg(n.path,o.path,this.a(n),"/")&&n.query===o.query&&(s||n.fragment===o.fragment)}return!1}joinPath(n,...o){return $.URI.joinPath(n,...o)}basenameOrAuthority(n){return(0,e.$ah)(n)||n.authority}basename(n){return O.$fc.basename(n.path)}extname(n){return O.$fc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let o;return n.scheme===I.Schemas.file?o=$.URI.file(O.$lc(a(n))).path:(o=O.$fc.dirname(n.path),n.authority&&o.length&&o.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),o="/")),n.with({path:o})}normalizePath(n){if(!n.path.length)return n;let o;return n.scheme===I.Schemas.file?o=$.URI.file(O.$gc(a(n))).path:o=O.$fc.normalize(n.path),n.with({path:o})}relativePath(n,o){if(n.scheme!==o.scheme||!(0,e.$ih)(n.authority,o.authority))return;if(n.scheme===I.Schemas.file){const i=O.$kc(a(n),a(o));return A.$j?P.$vg(i):i}let s=n.path||"/";const l=o.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(s.length,l.length);i<r&&!(s.charCodeAt(i)!==l.charCodeAt(i)&&s.charAt(i).toLowerCase()!==l.charAt(i).toLowerCase());i++);s=l.substr(0,i)+s.substr(i)}return O.$fc.relative(s,l)}resolvePath(n,o){if(n.scheme===I.Schemas.file){const s=$.URI.file(O.$jc(a(n),o));return n.with({authority:s.authority,path:s.path})}return o=P.$wg(o),n.with({path:O.$fc.resolve(n.path,o)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,o){return n===o||n!==void 0&&o!==void 0&&(0,T.$Df)(n,o)}hasTrailingPathSeparator(n,o=O.sep){if(n.scheme===I.Schemas.file){const s=a(n);return s.length>P.$xg(s).length&&s[s.length-1]===o}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,o=O.sep){return(0,e.$jh)(n,o)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,o=O.sep){let s=!1;if(n.scheme===I.Schemas.file){const l=a(n);s=l!==void 0&&l.length===P.$xg(l).length&&l[l.length-1]===o}else{o="/";const l=n.path;s=l.length===1&&l.charCodeAt(l.length-1)===v.CharCode.Slash}return!s&&!(0,e.$jh)(n,o)?n.with({path:n.path+"/"}):n}}e.$5g=R,e.$6g=new R(()=>!1),e.$7g=new R(f=>f.scheme===I.Schemas.file?!A.$l:!0),e.$8g=new R(f=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function y(f,n){const o=[];for(let s=0;s<f.length;s++){const l=n(f[s]);f.some((i,r)=>r===s?!1:(0,e.$0g)(l,n(i)))||o.push(f[s])}return o}var c;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function n(o){const s=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,g]=r.split(":");t&&g&&s.set(t,g)});const i=o.path.substring(0,o.path.indexOf(";"));return i&&s.set(f.META_DATA_MIME,i),s}f.parseMetaData=n})(c||(e.DataUri=c={}));function D(f,n,o){if(n){let s=f.path;return s&&s[0]!==O.$fc.sep&&(s=O.$fc.sep+s),f.with({scheme:o,authority:n,path:s})}return f.with({scheme:o})}}),define(Oe[10],Ne([1,0,21,13,6,4,23,20,147,48]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=R,e.$ph=y,e.$qh=c,e.$rh=D,e.$sh=f,e.$th=n,e.$uh=o,e.$vh=s,e.$Dh=E,e.$Eh=S,e.$Fh=w,e.$Gh=k,e.$Hh=C,e.$Wh=fe,e.$5h=ae;function R(ue){return!!ue&&typeof ue.then=="function"}function y(ue){const J=new v.$ue,x=ue(J.token),me=new Promise((pe,Ae)=>{const ze=J.token.onCancellationRequested(()=>{ze.dispose(),Ae(new P.$4)});Promise.resolve(x).then(ke=>{ze.dispose(),J.dispose(),pe(ke)},ke=>{ze.dispose(),J.dispose(),Ae(ke)})});return new class{cancel(){J.cancel(),J.dispose()}then(pe,Ae){return me.then(pe,Ae)}catch(pe){return this.then(void 0,pe)}finally(pe){return me.finally(pe)}}}function c(ue,J,x){return new Promise((me,pe)=>{const Ae=J.onCancellationRequested(()=>{Ae.dispose(),me(x)});ue.then(me,pe).finally(()=>Ae.dispose())})}function D(ue,J){return new Promise((x,me)=>{const pe=J.onCancellationRequested(()=>{pe.dispose(),me(new P.$4)});ue.then(x,me).finally(()=>pe.dispose())})}async function f(ue){let J=-1;const x=ue.map((me,pe)=>me.then(Ae=>(J=pe,Ae)));try{return await Promise.race(x)}finally{ue.forEach((me,pe)=>{pe!==J&&me.cancel()})}}function n(ue,J,x){let me;const pe=setTimeout(()=>{me?.(void 0),x?.()},J);return Promise.race([ue.finally(()=>clearTimeout(pe)),new Promise(Ae=>me=Ae)])}function o(ue){return new Promise((J,x)=>{const me=ue();R(me)?me.then(J,x):J(me)})}function s(){let ue,J;return{promise:new Promise((me,pe)=>{ue=me,J=pe}),resolve:ue,reject:J}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const x=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(x,x).then(me)})}return new Promise((x,me)=>{this.b.then(x,me)})}return this.a=J(),new Promise((x,me)=>{this.a.then(pe=>{this.a=null,x(pe)},pe=>{this.a=null,me(pe)})})}dispose(){this.f=!0}}e.$wh=l;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$xh=i;class r{constructor(){this.a=new Map}queue(J,x){const pe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(J)===pe&&this.a.delete(J)});return this.a.set(J,pe),pe}}e.$yh=r;const t=(ue,J)=>{let x=!0;const me=setTimeout(()=>{x=!1,J()},ue);return{isTriggered:()=>x,dispose:()=>{clearTimeout(me),x=!1}}},g=ue=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ue())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class u{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,x=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((pe,Ae)=>{this.d=pe,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=x===$.$ee?g(me):t(x,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=u;class p{constructor(J){this.a=new u(J),this.b=new l}trigger(J,x){return this.a.trigger(()=>this.b.queue(J),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=p;class m{constructor(){this.a=!1,this.b=new Promise((J,x)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=m;class h extends m{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Ch=h;function E(ue,J){return J?new Promise((x,me)=>{const pe=setTimeout(()=>{Ae.dispose(),x()},ue),Ae=J.onCancellationRequested(()=>{clearTimeout(pe),Ae.dispose(),me(new P.$4)})}):y(x=>E(ue,x))}function S(ue,J=0,x){const me=setTimeout(()=>{ue(),x&&pe.dispose()},J),pe=(0,O.$Rc)(()=>{clearTimeout(me),x?.deleteAndLeak(pe)});return x?.add(pe),pe}function w(ue){const J=[];let x=0;const me=ue.length;function pe(){return x<me?ue[x++]():null}function Ae(ze){ze!=null&&J.push(ze);const ke=pe();return ke?ke.then(Ae):Promise.resolve(J)}return Promise.resolve(null).then(Ae)}function k(ue,J=me=>!!me,x=null){let me=0;const pe=ue.length,Ae=()=>{if(me>=pe)return Promise.resolve(x);const ze=ue[me++];return Promise.resolve(ze()).then(Pe=>J(Pe)?Promise.resolve(Pe):Ae())};return Ae()}function C(ue,J=me=>!!me,x=null){if(ue.length===0)return Promise.resolve(x);let me=ue.length;const pe=()=>{me=-1;for(const Ae of ue)Ae.cancel?.()};return new Promise((Ae,ze)=>{for(const ke of ue)ke.then(Pe=>{--me>=0&&J(Pe)?(pe(),Ae(Pe)):me===0&&Ae(x)}).catch(Pe=>{--me>=0&&(pe(),ze(Pe))})})}class d{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new I.$je}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,me)=>{this.g.push({factory:J,c:x,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const x=J.factory();x.then(J.c,J.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=d;class b extends d{constructor(){super(1)}}e.$Jh=b;class F{constructor(){this.a=new se,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Kh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new oe;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,x=A.$6g){const me=x.getComparisonKey(J);return this.a.get(me)?.size??0}queueFor(J,x,me=A.$6g){const pe=me.getComparisonKey(J);let Ae=this.a.get(pe);if(!Ae){Ae=new b;const ze=this.f++,ke=I.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$3c),this.d.set(ze,ke),this.a.set(pe,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=N;class M{constructor(J,x){this.b=!1,this.a=-1,typeof J=="function"&&typeof x=="number"&&this.setIfNotSet(J,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,x){if(this.b)throw new P.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},x)}setIfNotSet(J,x){if(this.b)throw new P.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},x))}}e.$Mh=M;class V{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,x,me=globalThis){if(this.f)throw new P.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=me.setInterval(()=>{J()},x);this.d=(0,O.$Rc)(()=>{me.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=V;class W{constructor(J,x){this.b=-1,this.a=J,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=W;class L{constructor(J,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=J,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=L;class Y extends W{constructor(J,x){super(J,x),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Qh=Y;class Z extends O.$Tc{constructor(J,x){super(),this.g=J,this.h=x,this.a=[],this.b=this.B(new O.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of J)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(ue,J)=>{(0,T.$C)(()=>{if(x)return;const me=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Th=(ue,J,x)=>{const me=ue.requestIdleCallback(J,typeof x=="number"?{timeout:x}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,ue.cancelIdleCallback(me))}}},e.$Sh=ue=>(0,e.$Th)(globalThis,ue)}();class ge{constructor(J,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Th)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ge;class _ extends ge{constructor(J){super(globalThis,J)}}e.$Vh=_;async function fe(ue,J,x){let me;for(let pe=0;pe<x;pe++)try{return await ue()}catch(Ae){me=Ae,await E(J)}throw me}class se{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,x,me){return this.a={taskId:J,cancel:()=>me?.(),promise:x},x.then(()=>this.d(J),()=>this.d(J)),x}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:x,resolve:me,reject:pe}=s();this.b={run:J,promise:x,promiseResolve:me,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=se;class ce{constructor(J,x=()=>Date.now()){this.d=J,this.f=x,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Yh=ce;var $e;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})($e||($e={}));class oe{get isRejected(){return this.d?.outcome===$e.Rejected}get isResolved(){return this.d?.outcome===$e.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===$e.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((J,x)=>{this.a=J,this.b=x})}complete(J){return new Promise(x=>{this.a(J),this.d={outcome:$e.Resolved,value:J},x()})}error(J){return new Promise(x=>{this.b(J),this.d={outcome:$e.Rejected,value:J},x()})}cancel(){return this.error(new P.$4)}}e.$Zh=oe;var Ce;(function(ue){async function J(me){let pe;const Ae=await Promise.all(me.map(ze=>ze.then(ke=>ke,ke=>{pe||(pe=ke)})));if(typeof pe<"u")throw pe;return Ae}ue.settled=J;function x(me){return new Promise(async(pe,Ae)=>{try{await me(pe,Ae)}catch(ze){Ae(ze)}})}ue.withAsyncBody=x})(Ce||(e.Promises=Ce={}));class Le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new P.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=Le;class X{constructor(J){this.b=J,this.a=new a.$T(()=>new Le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=X;var q;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(q||(q={}));class te{static fromArray(J){return new te(x=>{x.emitMany(J)})}static fromPromise(J){return new te(async x=>{x.emitMany(await J)})}static fromPromises(J){return new te(async x=>{await Promise.all(J.map(async me=>x.emitOne(await me)))})}static merge(J){return new te(async x=>{await Promise.all(J.map(async me=>{for await(const pe of me)x.emitOne(pe)}))})}static{this.EMPTY=te.fromArray([])}constructor(J,x){this.a=q.Initial,this.b=[],this.d=null,this.f=x,this.g=new I.$je,queueMicrotask(async()=>{const me={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(J(me)),this.k()}catch(pe){this.l(pe)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,x){return new te(async me=>{for await(const pe of J)me.emitOne(x(pe))})}map(J){return te.map(this,J)}static filter(J,x){return new te(async me=>{for await(const pe of J)x(pe)&&me.emitOne(pe)})}filter(J){return te.filter(this,J)}static coalesce(J){return te.filter(J,x=>!!x)}coalesce(){return te.coalesce(this)}static async toPromise(J){const x=[];for await(const me of J)x.push(me);return x}toPromise(){return te.toPromise(this)}h(J){this.a===q.Initial&&(this.b.push(J),this.g.fire())}j(J){this.a===q.Initial&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(J){this.a===q.Initial&&(this.a=q.DoneError,this.d=J,this.g.fire())}}e.$3h=te;class ve extends te{constructor(J,x){super(x),this.m=J}cancel(){this.m.cancel()}}e.$4h=ve;function ae(ue){const J=new v.$ue,x=ue(J.token);return new ve(J,async me=>{const pe=J.token.onCancellationRequested(()=>{pe.dispose(),J.dispose(),me.reject(new P.$4)});try{for await(const Ae of x){if(J.token.isCancellationRequested)return;me.emitOne(Ae)}pe.dispose(),J.dispose()}catch(Ae){pe.dispose(),J.dispose(),me.reject(Ae)}})}class be{constructor(J){this.a=new oe,this.b=new te(pe=>{if(x){pe.reject(x);return}return me&&pe.emitMany(me),this.d=Ae=>pe.reject(Ae),this.f=Ae=>pe.emitOne(Ae),this.a.p},J);let x,me;this.f=pe=>{me||(me=[]),me.push(pe)},this.d=pe=>{x||(x=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$6h=be}),define(Oe[41],Ne([1,0,17,10,27,51,28,19,20,12]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$sk=R,e.$vk=n,e.$wk=F,e.$xk=N,e.$yk=M,e.$zk=V,e.$Ak=W,e.$Bk=ge;function R(){return Object.create(null)}e.$tk="**",e.$uk="/";const y="[/\\\\]",c="[^/\\\\]",D=/\//g;function f(_,fe){switch(_){case 0:return"";case 1:return`${c}*?`;default:return`(?:${y}|${c}+${y}${fe?`|${y}${c}+`:""})*?`}}function n(_,fe){if(!_)return[];const se=[];let ce=!1,$e=!1,oe="";for(const Ce of _){switch(Ce){case fe:if(!ce&&!$e){se.push(oe),oe="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}oe+=Ce}return oe&&se.push(oe),se}function o(_){if(!_)return"";let fe="";const se=n(_,e.$uk);if(se.every(ce=>ce===e.$tk))fe=".*";else{let ce=!1;se.forEach(($e,oe)=>{if($e===e.$tk){if(ce)return;fe+=f(2,oe===se.length-1)}else{let Ce=!1,Le="",X=!1,q="";for(const te of $e){if(te!=="}"&&Ce){Le+=te;continue}if(X&&(te!=="]"||!q)){let ve;te==="-"?ve=te:(te==="^"||te==="!")&&!q?ve="^":te===e.$uk?ve="":ve=(0,a.$ff)(te),q+=ve;continue}switch(te){case"{":Ce=!0;continue;case"[":X=!0;continue;case"}":{const ae=`(?:${n(Le,",").map(be=>o(be)).join("|")})`;fe+=ae,Ce=!1,Le="";break}case"]":{fe+="["+q+"]",X=!1,q="";break}case"?":fe+=c;continue;case"*":fe+=f(1);continue;default:fe+=(0,a.$ff)(te)}}oe<se.length-1&&(se[oe+1]!==e.$tk||oe+2<se.length)&&(fe+=y)}ce=$e===e.$tk})}return fe}const s=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new A.$Cc(1e4),p=function(){return!1},m=function(){return null};function h(_,fe){if(!_)return m;let se;typeof _!="string"?se=_.pattern:se=_,se=se.trim();const ce=`${se}_${!!fe.trimForExclusions}`;let $e=u.get(ce);if($e)return E($e,_);let oe;return s.test(se)?$e=w(se.substr(4),se):(oe=l.exec(S(se,fe)))?$e=k(oe[1],se):(fe.trimForExclusions?r:i).test(se)?$e=C(se,fe):(oe=t.exec(S(se,fe)))?$e=d(oe[1].substr(1),se,!0):(oe=g.exec(S(se,fe)))?$e=d(oe[1],se,!1):$e=b(se),u.set(ce,$e),E($e,_)}function E(_,fe){if(typeof fe=="string")return _;const se=function(ce,$e){return(0,O.$Bg)(ce,fe.base,!$.$l)?_((0,a.$kf)(ce.substr(fe.base.length),T.sep),$e):null};return se.allBasenames=_.allBasenames,se.allPaths=_.allPaths,se.basenames=_.basenames,se.patterns=_.patterns,se}function S(_,fe){return fe.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function w(_,fe){return function(se,ce){return typeof se=="string"&&se.endsWith(_)?fe:null}}function k(_,fe){const se=`/${_}`,ce=`\\${_}`,$e=function(Ce,Le){return typeof Ce!="string"?null:Le?Le===_?fe:null:Ce===_||Ce.endsWith(se)||Ce.endsWith(ce)?fe:null},oe=[_];return $e.basenames=oe,$e.patterns=[fe],$e.allBasenames=oe,$e}function C(_,fe){const se=Z(_.slice(1,-1).split(",").map(Le=>h(Le,fe)).filter(Le=>Le!==m),_),ce=se.length;if(!ce)return m;if(ce===1)return se[0];const $e=function(Le,X){for(let q=0,te=se.length;q<te;q++)if(se[q](Le,X))return _;return null},oe=se.find(Le=>!!Le.allBasenames);oe&&($e.allBasenames=oe.allBasenames);const Ce=se.reduce((Le,X)=>X.allPaths?Le.concat(X.allPaths):Le,[]);return Ce.length&&($e.allPaths=Ce),$e}function d(_,fe,se){const ce=T.sep===T.$fc.sep,$e=ce?_:_.replace(D,T.sep),oe=T.sep+$e,Ce=T.$fc.sep+_;let Le;return se?Le=function(X,q){return typeof X=="string"&&(X===$e||X.endsWith(oe)||!ce&&(X===_||X.endsWith(Ce)))?fe:null}:Le=function(X,q){return typeof X=="string"&&(X===$e||!ce&&X===_)?fe:null},Le.allPaths=[(se?"*/":"./")+_],Le}function b(_){try{const fe=new RegExp(`^${o(_)}$`);return function(se){return fe.lastIndex=0,typeof se=="string"&&fe.test(se)?_:null}}catch{return m}}function F(_,fe,se){return!_||typeof fe!="string"?!1:N(_)(fe,void 0,se)}function N(_,fe={}){if(!_)return p;if(typeof _=="string"||M(_)){const se=h(_,fe);if(se===m)return p;const ce=function($e,oe){return!!se($e,oe)};return se.allBasenames&&(ce.allBasenames=se.allBasenames),se.allPaths&&(ce.allPaths=se.allPaths),ce}return L(_,fe)}function M(_){const fe=_;return fe?typeof fe.base=="string"&&typeof fe.pattern=="string":!1}function V(_){return _.allBasenames||[]}function W(_){return _.allPaths||[]}function L(_,fe){const se=Z(Object.getOwnPropertyNames(_).map(Le=>Y(Le,_[Le],fe)).filter(Le=>Le!==m)),ce=se.length;if(!ce)return m;if(!se.some(Le=>!!Le.requiresSiblings)){if(ce===1)return se[0];const Le=function(te,ve){let ae;for(let be=0,ue=se.length;be<ue;be++){const J=se[be](te,ve);if(typeof J=="string")return J;(0,P.$oh)(J)&&(ae||(ae=[]),ae.push(J))}return ae?(async()=>{for(const be of ae){const ue=await be;if(typeof ue=="string")return ue}return null})():null},X=se.find(te=>!!te.allBasenames);X&&(Le.allBasenames=X.allBasenames);const q=se.reduce((te,ve)=>ve.allPaths?te.concat(ve.allPaths):te,[]);return q.length&&(Le.allPaths=q),Le}const $e=function(Le,X,q){let te,ve;for(let ae=0,be=se.length;ae<be;ae++){const ue=se[ae];ue.requiresSiblings&&q&&(X||(X=(0,T.$mc)(Le)),te||(te=X.substr(0,X.length-(0,T.$nc)(Le).length)));const J=ue(Le,X,te,q);if(typeof J=="string")return J;(0,P.$oh)(J)&&(ve||(ve=[]),ve.push(J))}return ve?(async()=>{for(const ae of ve){const be=await ae;if(typeof be=="string")return be}return null})():null},oe=se.find(Le=>!!Le.allBasenames);oe&&($e.allBasenames=oe.allBasenames);const Ce=se.reduce((Le,X)=>X.allPaths?Le.concat(X.allPaths):Le,[]);return Ce.length&&($e.allPaths=Ce),$e}function Y(_,fe,se){if(fe===!1)return m;const ce=h(_,se);if(ce===m)return m;if(typeof fe=="boolean")return ce;if(fe){const $e=fe.when;if(typeof $e=="string"){const oe=(Ce,Le,X,q)=>{if(!q||!ce(Ce,Le))return null;const te=$e.replace("$(basename)",()=>X),ve=q(te);return(0,P.$oh)(ve)?ve.then(ae=>ae?_:null):ve?_:null};return oe.requiresSiblings=!0,oe}}return ce}function Z(_,fe){const se=_.filter(Le=>!!Le.basenames);if(se.length<2)return _;const ce=se.reduce((Le,X)=>{const q=X.basenames;return q?Le.concat(q):Le},[]);let $e;if(fe){$e=[];for(let Le=0,X=ce.length;Le<X;Le++)$e.push(fe)}else $e=se.reduce((Le,X)=>{const q=X.patterns;return q?Le.concat(q):Le},[]);const oe=function(Le,X){if(typeof Le!="string")return null;if(!X){let te;for(te=Le.length;te>0;te--){const ve=Le.charCodeAt(te-1);if(ve===I.CharCode.Slash||ve===I.CharCode.Backslash)break}X=Le.substr(te)}const q=ce.indexOf(X);return q!==-1?$e[q]:null};oe.basenames=ce,oe.patterns=$e,oe.allBasenames=ce;const Ce=_.filter(Le=>!Le.basenames);return Ce.push(oe),Ce}function ge(_,fe){return(0,v.$tb)(_,fe,(se,ce)=>typeof se=="string"&&typeof ce=="string"?se===ce:typeof se!="string"&&typeof ce!="string"?se.base===ce.base&&se.pattern===ce.pattern:!1)}}),define(Oe[59],Ne([1,0,13,98,23,12,2]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.MarkdownStringTextNewlineStyle=void 0,e.$2k=a,e.$3k=R,e.$4k=y,e.$5k=c,e.$6k=D,e.$7k=f,e.$8k=n,e.$9k=o;var T;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class ${constructor(l="",i=!1){if(this.value=l,typeof this.value!="string")throw(0,v.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(l,i=T.Paragraph){return this.value+=c(this.supportThemeIcons?(0,P.$Uk)(l):l).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,i){return this.value+=`
${D(i,l)}
`,this}appendLink(l,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(l),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(l,i){const r=new RegExp((0,O.$ff)(i),"g");return l.replace(r,(t,g)=>l.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.$1k=$;function a(s){return R(s)?!s.value:Array.isArray(s)?s.every(a):!0}function R(s){return s instanceof $?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function y(s,l){return s===l?!0:!s||!l?!1:s.value===l.value&&s.isTrusted===l.isTrusted&&s.supportThemeIcons===l.supportThemeIcons&&s.supportHtml===l.supportHtml&&(s.baseUri===l.baseUri||!!s.baseUri&&!!l.baseUri&&(0,I.$9g)(A.URI.from(s.baseUri),A.URI.from(l.baseUri)))}function c(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function D(s,l){const i=s.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${l}`,s,`${"`".repeat(r)}`].join(`
`)}function f(s){return s.replace(/"/g,"&quot;")}function n(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const l=[],i=s.split("|").map(t=>t.trim());s=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),g=/width=(\d+)/.exec(r),u=t?t[1]:"",p=g?g[1]:"",m=isFinite(parseInt(p)),h=isFinite(parseInt(u));m&&l.push(`width="${p}"`),h&&l.push(`height="${u}"`)}return{href:s,dimensions:l}}}),define(Oe[99],Ne([1,0,17,51,19,20,23,12]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=$,e.$Xw=R,e.$Yw=c,e.$Zw=D,e.$1w=s,e.$2w=i,e.$3w=r,e.$4w=t,e.$5w=g,e.$6w=u;function $(m,h){const{os:E,tildify:S,relative:w}=h;if(w){const d=a(m,w,E);if(typeof d=="string")return d}let k=m.fsPath;if(E===O.OperatingSystem.Windows&&!O.$j?k=k.replace(/\//g,"\\"):E!==O.OperatingSystem.Windows&&O.$j&&(k=k.replace(/\\/g,"/")),E!==O.OperatingSystem.Windows&&S?.userHome){const d=S.userHome.fsPath;let b;m.scheme!==S.userHome.scheme&&m.path[0]===I.$fc.sep&&m.path[1]!==I.$fc.sep?b=S.userHome.with({path:m.path}).fsPath:b=k,k=c(b,d,E)}return(E===O.OperatingSystem.Windows?I.$ec:I.$fc).normalize(R(k,E===O.OperatingSystem.Windows))}function a(m,h,E){const S=E===O.OperatingSystem.Windows?I.$ec:I.$fc,w=E===O.OperatingSystem.Linux?A.$6g:A.$8g,k=h.getWorkspace(),C=(0,v.$Nb)(k.folders);if(!C)return;m.scheme!==C.uri.scheme&&m.path[0]===I.$fc.sep&&m.path[1]!==I.$fc.sep&&(m=C.uri.with({path:m.path}));const d=h.getWorkspaceFolder(m);if(!d)return;let b;if(w.isEqual(d.uri,m)?b="":b=w.relativePath(d.uri,m)??"",b&&(b=S.normalize(b)),k.folders.length>1&&!h.noPrefix){const F=d.name?d.name:w.basenameOrAuthority(d.uri);b=b?`${F} \u2022 ${b}`:F}return b}function R(m,h=O.$j){return(0,P.$Gg)(m,h)?m.charAt(0).toUpperCase()+m.slice(1):m}let y=Object.create(null);function c(m,h,E=O.OS){if(E===O.OperatingSystem.Windows||!m||!h)return m;let S=y.original===h?y.normalized:void 0;S||(S=h,O.$j&&(S=(0,P.$vg)(S)),S=`${(0,T.$lf)(S,I.$fc.sep)}${I.$fc.sep}`,y={original:h,normalized:S});let w=m;return O.$j&&(w=(0,P.$vg)(w)),(E===O.OperatingSystem.Linux?w.startsWith(S):(0,T.$Ef)(w,S))?`~/${w.substr(S.length)}`:m}function D(m,h){return m.replace(/^~($|\/|\\)/,`${h}$1`)}const f="\u2026",n="\\\\",o="~";function s(m,h=I.sep){const E=new Array(m.length);let S=!1;for(let w=0;w<m.length;w++){const k=m[w];if(k===""){E[w]=`.${h}`;continue}if(!k){E[w]=k;continue}S=!0;let C="",d=k;d.indexOf(n)===0?(C=d.substr(0,d.indexOf(n)+n.length),d=d.substr(d.indexOf(n)+n.length)):d.indexOf(h)===0?(C=d.substr(0,d.indexOf(h)+h.length),d=d.substr(d.indexOf(h)+h.length)):d.indexOf(o)===0&&(C=d.substr(0,d.indexOf(o)+o.length),d=d.substr(d.indexOf(o)+o.length));const b=d.split(h);for(let F=1;S&&F<=b.length;F++)for(let N=b.length-F;S&&N>=0;N--){S=!1;let M=b.slice(N,N+F).join(h);for(let V=0;!S&&V<m.length;V++)if(V!==w&&m[V]&&m[V].indexOf(M)>-1){const W=N+F===b.length,L=N>0&&m[V].indexOf(h)>-1?h+M:M,Y=m[V].endsWith(L);S=!W||Y}if(!S){let V="";(b[0].endsWith(":")||C!=="")&&(N===1&&(N=0,F++,M=b[0]+h+M),N>0&&(V=b[0]+h),V=C+V),N>0&&(V=V+f+h),V=V+M,N+F<b.length&&(V=V+h+f),E[w]=V}}S&&(E[w]=k)}return E}var l;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function i(m,h=Object.create(null)){const E=[];let S=!1,w="";for(const k of m)if(k==="$"||S&&k==="{")w&&E.push({value:w,type:l.TEXT}),w="",S=!0;else if(k==="}"&&S){const C=h[w];if(typeof C=="string")C.length&&E.push({value:C,type:l.VARIABLE});else if(C){const d=E[E.length-1];(!d||d.type!==l.SEPARATOR)&&E.push({value:C.label,type:l.SEPARATOR})}w="",S=!1}else w+=k;return w&&!S&&E.push({value:w,type:l.TEXT}),E.filter((k,C)=>{if(k.type===l.SEPARATOR){const d=E[C-1],b=E[C+1];return[d,b].every(F=>F&&(F.type===l.VARIABLE||F.type===l.TEXT)&&F.value.length>0)}return!0}).map(k=>k.value).join("")}function r(m,h){return O.$k||h?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$k?"&":"&&"):m.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(m,h){return O.$k||h?m.replace(/\(&&\w\)|&&/g,""):O.$j?m.replace(/&&|&/g,E=>E==="&"?"&&":"&"):m.replace(/&&/g,"_")}function g(m){return m.replace(/&/g,"&&")}function u(m){if(m.endsWith("]")){const h=m.lastIndexOf(" [",m.length-2);if(h!==-1){const E=p(m.substring(0,h)),S=m.substring(h);return{name:E.name+S,parentPath:E.parentPath}}}return p(m)}function p(m){const h=m.indexOf("/")!==-1?I.$fc:I.$ec,E=h.basename(m),S=h.dirname(m);return E.length?{name:E,parentPath:S}:{name:S,parentPath:""}}}),define(Oe[149],Ne([1,0,22,36,2]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=$,e.$Mn=R,e.$Nn=y;function O(c){return c.toJSON()}class A{constructor(D){this.a=D}transformIncoming(D){const f=this.a.transformIncoming(D);return f===D?D:O(I.URI.from(f))}transformOutgoing(D){const f=this.a.transformOutgoing(D);return f===D?D:O(I.URI.from(f))}transformOutgoingURI(D){const f=this.a.transformOutgoing(D);return f===D?D:I.URI.from(f)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.$Jn=A,e.$Kn=new class{transformIncoming(c){return c}transformOutgoing(c){return c}transformOutgoingURI(c){return c}transformOutgoingScheme(c){return c}};function T(c,D,f){if(!c||f>200)return null;if(typeof c=="object"){if(c instanceof I.URI)return D.transformOutgoing(c);for(const n in c)if(Object.hasOwnProperty.call(c,n)){const o=T(c[n],D,f+1);o!==null&&(c[n]=o)}}return null}function $(c,D){const f=T(c,D,0);return f===null?c:f}function a(c,D,f,n){if(!c||n>200)return null;if(typeof c=="object"){if(c.$mid===P.MarshalledId.Uri)return f?I.URI.revive(D.transformIncoming(c)):D.transformIncoming(c);if(c instanceof v.$Le)return null;for(const o in c)if(Object.hasOwnProperty.call(c,o)){const s=a(c[o],D,f,n+1);s!==null&&(c[o]=s)}}return null}function R(c,D){const f=a(c,D,!1,0);return f===null?c:f}function y(c,D){const f=a(c,D,!0,0);return f===null?c:f}}),define(Oe[37],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=P;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(I){return v.test(I)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(T){for(let $=0;$<T.length;$++)T[$]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){I(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,a="";return a+=A[O[$++]],a+=A[O[$++]],a+=A[O[$++]],a+=A[O[$++]],a+="-",a+=A[O[$++]],a+=A[O[$++]],a+="-",a+=A[O[$++]],a+=A[O[$++]],a+="-",a+=A[O[$++]],a+=A[O[$++]],a+="-",a+=A[O[$++]],a+=A[O[$++]],a+=A[O[$++]],a+=A[O[$++]],a+=A[O[$++]],a+=A[O[$++]],a}}()}),define(Oe[150],Ne([1,0,17,39,37]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.$ou=void 0,e.$mu=O,e.$nu=A,e.$pu=a;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,c,D){const f={id:(0,I.$Yg)(),name:y,uri:c,data:D};return{asString:async()=>"",asFile:()=>f,value:void 0}}class T{constructor(){this.a=new Map}get size(){let c=0;for(const D of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const D=[...this.a.keys()];return P.Iterable.some(this,([f,n])=>n.asFile())&&D.push("files"),R($(c),D)}get(c){return this.a.get(this.b(c))?.[0]}append(c,D){const f=this.a.get(c);f?f.push(D):this.a.set(this.b(c),[D])}replace(c,D){this.a.set(this.b(c),[D])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,D]of this.a)for(const f of D)yield[c,f]}b(c){return $(c)}}e.$ou=T;function $(y){return y.toLowerCase()}function a(y,c){return R($(y),c.map($))}function R(y,c){if(y==="*/*")return c.length>0;if(c.includes(y))return!0;const D=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!D)return!1;const[f,n,o]=D;return o==="*"?c.some(s=>s.startsWith(n+"/")):!1}e.$qu=Object.freeze({create:y=>(0,v.$Lb)(y.map(c=>c.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$qu.split(y).filter(c=>!c.startsWith("#"))})}),define(Oe[151],Ne([1,0,10,6,4,40,14]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=$;var T;(function(c){c[c.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",c[c.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function $(c){const D=c;return D?.changed instanceof Map||D?.deleted instanceof Set}var a;(function(c){c[c.None=0]="None",c[c.Initialized=1]="Initialized",c[c.Closed=2]="Closed"})(a||(e.StorageState=a={}));class R extends I.$Tc{static{this.a=100}constructor(D,f=Object.create(null)){super(),this.r=D,this.s=f,this.b=this.B(new P.$me),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new v.$Ah(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(D=>this.u(D)))}u(D){this.b.pause();try{D.changed?.forEach((f,n)=>this.w(n,f)),D.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(D,f){if(this.c===a.Closed)return;let n=!1;(0,A.$lg)(f)?n=this.f.delete(D):this.f.get(D)!==f&&(this.f.set(D,f),n=!0),n&&this.b.fire({key:D,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(D,f){const n=this.f.get(D);return(0,A.$lg)(n)?f:n}getBoolean(D,f){const n=this.get(D);return(0,A.$lg)(n)?f:n==="true"}getNumber(D,f){const n=this.get(D);return(0,A.$lg)(n)?f:parseInt(n,10)}getObject(D,f){const n=this.get(D);return(0,A.$lg)(n)?f:(0,O.$$h)(n)}async set(D,f,n=!1){if(this.c===a.Closed)return;if((0,A.$lg)(f))return this.delete(D,n);const o=(0,A.$eg)(f)||Array.isArray(f)?(0,O.$0h)(f):String(f);if(this.f.get(D)!==o)return this.f.set(D,o),this.j.set(D,o),this.h.delete(D),this.b.fire({key:D,external:n}),this.D()}async delete(D,f=!1){if(!(this.c===a.Closed||!this.f.delete(D)))return this.h.has(D)||this.h.add(D),this.j.delete(D),this.b.fire({key:D,external:f}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const D={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(D).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(D){if(!(this.c===a.Closed||this.m))return this.D(D)}async D(D){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),D)}async whenFlushed(){if(this.z)return new Promise(D=>this.n.push(D))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$bq=R;class y{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(D){D.insert?.forEach((f,n)=>this.a.set(n,f)),D.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$cq=y}),define(Oe[152],Ne([1,0,27]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$wu=I;var P;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function I(O){let A=0,T=0,$=0,a=P.Unknown;for(let R=0,y=O.length;R<y;R++){const c=O.charCodeAt(R);c===v.CharCode.CarriageReturn?(A===0&&(T=R),A++,R+1<y&&O.charCodeAt(R+1)===v.CharCode.LineFeed?(a|=P.CRLF,R++):a|=P.Invalid,$=R+1):c===v.CharCode.LineFeed&&(a|=P.LF,A===0&&(T=R),A++,$=R+1)}return A===0&&(T=O.length),[A,T,O.length-$,a]}}),define(Oe[153],Ne([1,0,12,20,22]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=void 0,e.$_t=R,e.$au=y,v=qe(v),P=qe(P),I=qe(I);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function $(){return T||(T=new TextDecoder("UTF-16BE")),T}let a;function R(){return a||(a=P.$E()?A():$()),a}function y(f,n,o){const s=new Uint16Array(f.buffer,n,o);return o>0&&(s[0]===65279||s[0]===65534)?c(f,n,o):A().decode(s)}function c(f,n,o){const s=[];let l=0;for(let i=0;i<o;i++){const r=I.$Ne(f,n);n+=2,s[l++]=String.fromCharCode(r)}return s.join("")}class D{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return R().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||v.$Hf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let s=0;s<o;s++)this.b[this.d++]=n.charCodeAt(s)}}e.$bu=D}),define(Oe[154],Ne([1,0,22,153]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=void 0,e.$du=A,v=qe(v);function I($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,R,y,c){this.oldPosition=a,this.oldText=R,this.newPosition=y,this.newText=c}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,R,y){const c=R.length;v.$Qe(a,c,y),y+=4;for(let D=0;D<c;D++)v.$Oe(a,R.charCodeAt(D),y),y+=2;return y}static d(a,R){const y=v.$Pe(a,R);return R+=4,(0,P.$au)(a,R,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(a,R){return v.$Qe(a,this.oldPosition,R),R+=4,v.$Qe(a,this.newPosition,R),R+=4,R=O.c(a,this.oldText,R),R=O.c(a,this.newText,R),R}static read(a,R,y){const c=v.$Pe(a,R);R+=4;const D=v.$Pe(a,R);R+=4;const f=O.d(a,R);R+=O.a(f);const n=O.d(a,R);return R+=O.a(n),y.push(new O(c,f,D,n)),R}}e.$cu=O;function A($,a){return $===null||$.length===0?a:new T($,a).compress()}class T{constructor(a,R){this.a=a,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,R=0,y=this.n(a),c=this.l(R);for(;a<this.f||R<this.h;){if(y===null){this.k(c),c=this.l(++R);continue}if(c===null){this.m(y),y=this.n(++a);continue}if(c.oldEnd<=y.newPosition){this.k(c),c=this.l(++R);continue}if(y.newEnd<=c.oldPosition){this.m(y),y=this.n(++a);continue}if(c.oldPosition<y.newPosition){const[s,l]=T.r(c,y.newPosition-c.oldPosition);this.k(s),c=l;continue}if(y.newPosition<c.oldPosition){const[s,l]=T.q(y,c.oldPosition-y.newPosition);this.m(s),y=l;continue}let n,o;if(c.oldEnd===y.newEnd)n=y,o=c,y=this.n(++a),c=this.l(++R);else if(c.oldEnd<y.newEnd){const[s,l]=T.q(y,c.oldLength);n=s,o=c,y=l,c=this.l(++R)}else{const[s,l]=T.r(c,y.newLength);n=y,o=s,y=this.n(++a),c=l}this.d[this.e++]=new O(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const D=T.s(this.d);return T.t(D)}k(a){this.d[this.e++]=T.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=T.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,R){return new O(R.oldPosition-a,R.oldText,R.newPosition,R.newText)}static p(a,R){return new O(R.oldPosition,R.oldText,R.newPosition+a,R.newText)}static q(a,R){const y=a.newText.substr(0,R),c=a.newText.substr(R);return[new O(a.oldPosition,a.oldText,a.newPosition,y),new O(a.oldEnd,"",a.newPosition+R,c)]}static r(a,R){const y=a.oldText.substr(0,R),c=a.oldText.substr(R);return[new O(a.oldPosition,y,a.newPosition,a.newText),new O(a.oldPosition+R,c,a.newEnd,"")]}static s(a){if(a.length===0)return a;const R=[];let y=0,c=a[0];for(let D=1;D<a.length;D++){const f=a[D];c.oldEnd===f.oldPosition?c=new O(c.oldPosition,c.oldText+f.oldText,c.newPosition,c.newText+f.newText):(R[y++]=c,c=f)}return R[y++]=c,R}static t(a){if(a.length===0)return a;const R=[];let y=0;for(let c=0;c<a.length;c++){const D=a[c];D.oldText!==D.newText&&(R[y++]=D)}return R}}}),define(Oe[155],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$it={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Oe[156],Ne([1,0,41,19]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=I,e.$uu=O;function I(A,T,$,a,R,y){if(Array.isArray(A)){let c=0;for(const D of A){const f=I(D,T,$,a,R,y);if(f===10)return f;f>c&&(c=f)}return c}else{if(typeof A=="string")return a?A==="*"?5:A===$?10:0:0;if(A){const{language:c,pattern:D,scheme:f,hasAccessToAllModels:n,notebookType:o}=A;if(!a&&!n)return 0;o&&R&&(T=R);let s=0;if(f)if(f===T.scheme)s=10;else if(f==="*")s=5;else return 0;if(c)if(c===$)s=10;else if(c==="*")s=Math.max(s,5);else return 0;if(o)if(o===y)s=10;else if(o==="*"&&y!==void 0)s=Math.max(s,5);else return 0;if(D){let l;if(typeof D=="string"?l=D:l={...D,base:(0,P.$gc)(D.base)},l===T.fsPath||(0,v.$wk)(l,T.fsPath))s=10;else return 0}return s}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Oe[157],Ne([1,0,27,158]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.IndentAction=void 0;var I;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class O{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let R=0,y=a.notIn.length;R<y;R++)switch(a.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case P.StandardTokenType.Other:return!0;case P.StandardTokenType.Comment:return this.c;case P.StandardTokenType.String:return this.b;case P.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,R){if(a.getTokenCount()===0)return!0;const y=a.findTokenIndexAtOffset(R-2),c=a.getStandardTokenType(y);return this.isOK(c)}g(a,R){for(let y=a;y<=R;y++){const c=String.fromCharCode(y);if(!this.open.includes(c)&&!this.close.includes(c))return c}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Tu=O;class A{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of a)T(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),T(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),T(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),T(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&T(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Uu=A;function T($,a,R){$.has(a)?$.get(a).push(R):$.set(a,[R])}}),define(Oe[159],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.NodeColor=e.$3C=void 0,e.$5C=I,e.$6C=O,e.$7C=a,e.$8C=R,e.$9C=y,e.$0C=c,e.$$C=D,e.$_C=f;class v{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$4C)return I(this.right);let o=this;for(;o.parent!==e.$4C&&o.parent.left!==o;)o=o.parent;return o.parent===e.$4C?e.$4C:o.parent}prev(){if(this.left!==e.$4C)return O(this.left);let o=this;for(;o.parent!==e.$4C&&o.parent.right!==o;)o=o.parent;return o.parent===e.$4C?e.$4C:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$3C=v;var P;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(P||(e.NodeColor=P={})),e.$4C=new v(null,P.Black),e.$4C.parent=e.$4C,e.$4C.left=e.$4C,e.$4C.right=e.$4C,e.$4C.color=P.Black;function I(n){for(;n.left!==e.$4C;)n=n.left;return n}function O(n){for(;n.right!==e.$4C;)n=n.right;return n}function A(n){return n===e.$4C?0:n.size_left+n.piece.length+A(n.right)}function T(n){return n===e.$4C?0:n.lf_left+n.piece.lineFeedCnt+T(n.right)}function $(){e.$4C.parent=e.$4C}function a(n,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$4C&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$4C?n.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function R(n,o){const s=o.left;o.left=s.right,s.right!==e.$4C&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$4C?n.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function y(n,o){let s,l;if(o.left===e.$4C?(l=o,s=l.right):o.right===e.$4C?(l=o,s=l.left):(l=I(o.right),s=l.right),l===n.root){n.root=s,s.color=P.Black,o.detach(),$(),n.root.parent=e.$4C;return}const i=l.color===P.Red;if(l===l.parent.left?l.parent.left=s:l.parent.right=s,l===o?(s.parent=l.parent,f(n,s)):(l.parent===o?s.parent=l:s.parent=l.parent,f(n,s),l.left=o.left,l.right=o.right,l.parent=o.parent,l.color=o.color,o===n.root?n.root=l:o===o.parent.left?o.parent.left=l:o.parent.right=l,l.left!==e.$4C&&(l.left.parent=l),l.right!==e.$4C&&(l.right.parent=l),l.size_left=o.size_left,l.lf_left=o.lf_left,f(n,l)),o.detach(),s.parent.left===s){const t=A(s),g=T(s);if(t!==s.parent.size_left||g!==s.parent.lf_left){const u=t-s.parent.size_left,p=g-s.parent.lf_left;s.parent.size_left=t,s.parent.lf_left=g,D(n,s.parent,u,p)}}if(f(n,s.parent),i){$();return}let r;for(;s!==n.root&&s.color===P.Black;)s===s.parent.left?(r=s.parent.right,r.color===P.Red&&(r.color=P.Black,s.parent.color=P.Red,a(n,s.parent),r=s.parent.right),r.left.color===P.Black&&r.right.color===P.Black?(r.color=P.Red,s=s.parent):(r.right.color===P.Black&&(r.left.color=P.Black,r.color=P.Red,R(n,r),r=s.parent.right),r.color=s.parent.color,s.parent.color=P.Black,r.right.color=P.Black,a(n,s.parent),s=n.root)):(r=s.parent.left,r.color===P.Red&&(r.color=P.Black,s.parent.color=P.Red,R(n,s.parent),r=s.parent.left),r.left.color===P.Black&&r.right.color===P.Black?(r.color=P.Red,s=s.parent):(r.left.color===P.Black&&(r.right.color=P.Black,r.color=P.Red,a(n,r),r=s.parent.left),r.color=s.parent.color,s.parent.color=P.Black,r.left.color=P.Black,R(n,s.parent),s=n.root));s.color=P.Black,$()}function c(n,o){for(f(n,o);o!==n.root&&o.parent.color===P.Red;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===P.Red?(o.parent.color=P.Black,s.color=P.Black,o.parent.parent.color=P.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,a(n,o)),o.parent.color=P.Black,o.parent.parent.color=P.Red,R(n,o.parent.parent))}else{const s=o.parent.parent.left;s.color===P.Red?(o.parent.color=P.Black,s.color=P.Black,o.parent.parent.color=P.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,R(n,o)),o.parent.color=P.Black,o.parent.parent.color=P.Red,a(n,o.parent.parent))}n.root.color=P.Black}function D(n,o,s,l){for(;o!==n.root&&o!==e.$4C;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=l),o=o.parent}function f(n,o){let s=0,l=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,s=A(o.left)-o.size_left,l=T(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=l;o!==n.root&&(s!==0||l!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=l),o=o.parent}}}),define(Oe[100],Ne([1,0,27,101,32,52,159,102]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=e.$jD=e.$iD=void 0,e.$gD=y,e.$hD=c;const $=65535;function a(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class R{constructor(i,r,t,g,u){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=g,this.isBasicASCII=u}}function y(l,i=!0){const r=[0];let t=1;for(let g=0,u=l.length;g<u;g++){const p=l.charCodeAt(g);p===v.CharCode.CarriageReturn?g+1<u&&l.charCodeAt(g+1)===v.CharCode.LineFeed?(r[t++]=g+2,g++):r[t++]=g+1:p===v.CharCode.LineFeed&&(r[t++]=g+1)}return i?a(r):r}function c(l,i){l.length=0,l[0]=0;let r=1,t=0,g=0,u=0,p=!0;for(let h=0,E=i.length;h<E;h++){const S=i.charCodeAt(h);S===v.CharCode.CarriageReturn?h+1<E&&i.charCodeAt(h+1)===v.CharCode.LineFeed?(u++,l[r++]=h+2,h++):(t++,l[r++]=h+1):S===v.CharCode.LineFeed?(g++,l[r++]=h+1):p&&S!==v.CharCode.Tab&&(S<32||S>126)&&(p=!1)}const m=new R(a(l),t,g,u,p);return l.length=0,m}class D{constructor(i,r,t,g,u){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=g,this.length=u}}e.$iD=D;class f{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$jD=f;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==A.$4C&&i.iterate(i.root,t=>(t!==A.$4C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let g=0;g<t.length;g++){const u=t[g];if(u.node.parent===null||u.nodeStartOffset>=i){t[g]=null,r=!0;continue}}if(r){const g=[];for(const u of t)u!==null&&g.push(u);this.b=g}}}class s{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new f("",[0])],this.g={line:0,column:0},this.root=A.$4C,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let g=null;for(let u=0,p=i.length;u<p;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=y(i[u].buffer));const m=new D(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this.a.push(i[u]),g=this.S(g,m)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=$,t=r-Math.floor(r/3),g=t*2;let u="",p=0;const m=[];if(this.iterate(this.root,h=>{const E=this.R(h),S=E.length;if(p<=t||p+S<g)return u+=E,p+=S,!0;const w=u.replace(/\r\n|\r|\n/g,i);return m.push(new f(w,y(w))),u=E,p=S,!0}),p>0){const h=u.replace(/\r\n|\r|\n/g,i);m.push(new f(h,y(h)))}this.create(m,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,g=>{if(g===A.$4C)return!0;const u=this.R(g),p=u.length,m=i.G(r),h=i.G(r+p),E=i.getValueInRange2(m,h);return r+=p,u===E})}getOffsetAt(i,r){let t=0,g=this.root;for(;g!==A.$4C;)if(g.left!==A.$4C&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const u=this.B(g,i-g.lf_left-2);return t+=u+r-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const g=i;for(;r!==A.$4C;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const u=this.A(r,i-r.size_left);if(t+=r.lf_left+u.index,u.index===0){const p=this.getOffsetAt(t+1,1),m=g-p;return new P.$Kt(t+1,m+1)}return new P.$Kt(t+1,u.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===A.$4C){const u=this.getOffsetAt(t+1,1),p=g-i-u;return new P.$Kt(t+1,p+1)}else r=r.right;return new P.$Kt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),g=this.H(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,g);return r?r!==this.d||!this.f?u.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?u:u.replace(/\r\n|\r|\n/g,r):u}getValueInRange2(i,r){if(i.node===r.node){const m=i.node,h=this.a[m.piece.bufferIndex].buffer,E=this.u(m.piece.bufferIndex,m.piece.start);return h.substring(E+i.remainder,E+r.remainder)}let t=i.node;const g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);let p=g.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==A.$4C;){const m=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){p+=m.substring(h,h+r.remainder);break}else p+=m.substr(h,t.piece.length);t=t.next()}return p}getLinesContent(){const i=[];let r=0,t="",g=!1;return this.iterate(this.root,u=>{if(u===A.$4C)return!0;const p=u.piece;let m=p.length;if(m===0)return!0;const h=this.a[p.bufferIndex].buffer,E=this.a[p.bufferIndex].lineStarts,S=p.start.line,w=p.end.line;let k=E[S]+p.start.column;if(g&&(h.charCodeAt(k)===v.CharCode.LineFeed&&(k++,m--),i[r++]=t,t="",g=!1,m===0))return!0;if(S===w)return!this.f&&h.charCodeAt(k+m-1)===v.CharCode.CarriageReturn?(g=!0,t+=h.substr(k,m-1)):t+=h.substr(k,m),!0;t+=this.f?h.substring(k,Math.max(k,E[S+1]-this.e)):h.substring(k,E[S+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let C=S+1;C<w;C++)t=this.f?h.substring(E[C],E[C+1]-this.e):h.substring(E[C],E[C+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&h.charCodeAt(E[w]+p.end.column-1)===v.CharCode.CarriageReturn?(g=!0,p.end.column===0?r--:t=h.substr(E[w],p.end.column-1)):t=h.substr(E[w],p.end.column),!0}),g&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],g=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(g)}else{const r=this.a[i.node.piece.bufferIndex],g=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(g)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===A.$4C)return"";const g=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(u,u+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],g=this.u(r.node.piece.bufferIndex,r.node.piece.start),u=g+r.remainder,p=g+r.node.piece.length;return t.buffer.substring(u,p)}}findMatchesInNode(i,r,t,g,u,p,m,h,E,S,w){const k=this.a[i.piece.bufferIndex],C=this.u(i.piece.bufferIndex,i.piece.start),d=this.u(i.piece.bufferIndex,u),b=this.u(i.piece.bufferIndex,p);let F;const N={line:0,column:0};let M,V;r._wordSeparators?(M=k.buffer.substring(d,b),V=W=>W+d,r.reset(0)):(M=k.buffer,V=W=>W,r.reset(d));do if(F=r.next(M),F){if(V(F.index)>=b)return S;this.s(i,V(F.index)-C,N);const W=this.t(i.piece.bufferIndex,u,N),L=N.line===u.line?N.column-u.column+g:N.column+1,Y=L+F[0].length;if(w[S++]=(0,T.$cD)(new I.$Lt(t+W,L,t+W,Y),F,h),V(F.index)+F[0].length>=b||S>=E)return S}while(F);return S}findMatchesLineByLine(i,r,t,g){const u=[];let p=0;const m=new T.$fD(r.wordSeparators,r.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let S=this.s(h.node,h.remainder);const w=this.s(E.node,E.remainder);if(h.node===E.node)return this.findMatchesInNode(h.node,m,i.startLineNumber,i.startColumn,S,w,r,t,g,p,u),u;let k=i.startLineNumber,C=h.node;for(;C!==E.node;){const b=this.t(C.piece.bufferIndex,S,C.piece.end);if(b>=1){const N=this.a[C.piece.bufferIndex].lineStarts,M=this.u(C.piece.bufferIndex,C.piece.start),V=N[S.line+b],W=k===i.startLineNumber?i.startColumn:1;if(p=this.findMatchesInNode(C,m,k,W,S,this.s(C,V-M),r,t,g,p,u),p>=g)return u;k+=b}const F=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(F,i.endColumn-1);return p=this.n(r,m,N,i.endLineNumber,F,p,u,t,g),u}if(p=this.n(r,m,this.getLineContent(k).substr(F),k,F,p,u,t,g),p>=g)return u;k++,h=this.H(k,1),C=h.node,S=this.s(h.node,h.remainder)}if(k===i.endLineNumber){const b=k===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(k).substring(b,i.endColumn-1);return p=this.n(r,m,F,i.endLineNumber,b,p,u,t,g),u}const d=k===i.startLineNumber?i.startColumn:1;return p=this.findMatchesInNode(E.node,m,k,d,S,w,r,t,g,p,u),u}n(i,r,t,g,u,p,m,h,E){const S=i.wordSeparators;if(!h&&i.simpleSearch){const k=i.simpleSearch,C=k.length,d=t.length;let b=-C;for(;(b=t.indexOf(k,b+C))!==-1;)if((!S||(0,T.$eD)(S,t,d,b,C))&&(m[p++]=new O.$bw(new I.$Lt(g,b+1+u,g,b+1+C+u),null),p>=E))return p;return p}let w;r.reset(0);do if(w=r.next(t),w&&(m[p++]=(0,T.$cD)(new I.$Lt(g,w.index+1+u,g,w.index+1+w[0].length+u),w,h),p>=E))return p;while(w);return p}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$4C){const{node:g,remainder:u,nodeStartOffset:p}=this.G(i),m=g.piece,h=m.bufferIndex,E=this.s(g,u);if(g.piece.bufferIndex===0&&m.end.line===this.g.line&&m.end.column===this.g.column&&p+m.length===i&&r.length<$){this.F(g,r),this.y();return}if(p===i)this.o(r,g),this.h.validate(i);else if(p+g.piece.length>i){const S=[];let w=new D(m.bufferIndex,E,m.end,this.t(m.bufferIndex,E,m.end),this.u(h,m.end)-this.u(h,E));if(this.K()&&this.M(r)&&this.I(g,u)===10){const b={line:w.start.line+1,column:0};w=new D(w.bufferIndex,b,w.end,this.t(w.bufferIndex,b,w.end),w.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(g,u-1)===13){const b=this.s(g,u-1);this.C(g,b),r="\r"+r,g.piece.length===0&&S.push(g)}else this.C(g,E);else this.C(g,E);const k=this.w(r);w.length>0&&this.S(g,w);let C=g;for(let d=0;d<k.length;d++)C=this.S(C,k[d]);this.v(S)}else this.q(r,g)}else{const g=this.w(r);let u=this.T(null,g[0]);for(let p=1;p<g.length;p++)u=this.S(u,g[p])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===A.$4C)return;const t=this.G(i),g=this.G(i+r),u=t.node,p=g.node;if(u===p){const k=this.s(u,t.remainder),C=this.s(u,g.remainder);if(t.nodeStartOffset===i){if(r===u.piece.length){const d=u.next();(0,A.$9C)(this,u),this.N(d),this.y();return}this.D(u,C),this.h.validate(i),this.N(u),this.y();return}if(t.nodeStartOffset+u.piece.length===i+r){this.C(u,k),this.O(u),this.y();return}this.E(u,k,C),this.y();return}const m=[],h=this.s(u,t.remainder);this.C(u,h),this.h.validate(i),u.piece.length===0&&m.push(u);const E=this.s(p,g.remainder);this.D(p,E),p.piece.length===0&&m.push(p);const S=u.next();for(let k=S;k!==A.$4C&&k!==p;k=k.next())m.push(k);const w=u.piece.length===0?u.prev():u;this.v(m),this.O(w),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const p=r.piece,m={line:p.start.line+1,column:0},h=new D(p.bufferIndex,m,p.end,this.t(p.bufferIndex,m,p.end),p.length-1);r.piece=h,i+=`
`,(0,A.$$C)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const g=this.w(i);let u=this.T(r,g[g.length-1]);for(let p=g.length-2;p>=0;p--)u=this.T(u,g[p]);this.N(u),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),g=this.S(r,t[0]);let u=g;for(let p=1;p<t.length;p++)u=this.S(u,t[p]);this.N(g)}s(i,r,t){const g=i.piece,u=i.piece.bufferIndex,p=this.a[u].lineStarts,h=p[g.start.line]+g.start.column+r;let E=g.start.line,S=g.end.line,w=0,k=0,C=0;for(;E<=S&&(w=E+(S-E)/2|0,C=p[w],w!==S);)if(k=p[w+1],h<C)S=w-1;else if(h>=k)E=w+1;else break;return t?(t.line=w,t.column=h-C,null):{line:w,column:h-C}}t(i,r,t){if(t.column===0)return t.line-r.line;const g=this.a[i].lineStarts;if(t.line===g.length-1)return t.line-r.line;const u=g[t.line+1],p=g[t.line]+t.column;if(u>p+1)return t.line-r.line;const m=p-1;return this.a[i].buffer.charCodeAt(m)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,A.$9C)(this,i[r])}w(i){if(i.length>$){const S=[];for(;i.length>$;){const k=i.charCodeAt($-1);let C;k===v.CharCode.CarriageReturn||k>=55296&&k<=56319?(C=i.substring(0,$-1),i=i.substring($-1)):(C=i.substring(0,$),i=i.substring($));const d=y(C);S.push(new D(this.a.length,{line:0,column:0},{line:d.length-1,column:C.length-d[d.length-1]},d.length-1,C.length)),this.a.push(new f(C,d))}const w=y(i);return S.push(new D(this.a.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this.a.push(new f(i,w)),S}let r=this.a[0].buffer.length;const t=y(i,!1);let g=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},g=this.g;for(let S=0;S<t.length;S++)t[S]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let S=0;S<t.length;S++)t[S]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const u=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,m=u-this.a[0].lineStarts[p],h={line:p,column:m},E=new D(0,g,h,this.t(0,g,h),u-r);return this.g=h,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,g="";const u=this.h.get2(i);if(u){t=u.node;const p=this.B(t,i-u.nodeStartLineNumber-1),m=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=m.substring(h+p,h+t.piece.length);else{const E=this.B(t,i-u.nodeStartLineNumber);return m.substring(h+p,h+E-r)}}else{let p=0;const m=i;for(;t!==A.$4C;)if(t.left!==A.$4C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),S=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);return p+=t.size_left,this.h.set({node:t,nodeStartOffset:p,nodeStartLineNumber:m-(i-1-t.lf_left)}),S.substring(w+h,w+E-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,S=this.u(t.piece.bufferIndex,t.piece.start);g=E.substring(S+h,S+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,p+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$4C;){const p=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.B(t,0),h=this.u(t.piece.bufferIndex,t.piece.start);return g+=p.substring(h,h+m-r),g}else{const m=this.u(t.piece.bufferIndex,t.piece.start);g+=p.substr(m,t.piece.length)}t=t.next()}return g}y(){let i=this.root,r=1,t=0;for(;i!==A.$4C;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,g=this.s(i,r),u=g.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const p=this.t(i.piece.bufferIndex,t.start,g);if(p!==u)return{index:p,remainder:0}}return{index:u,remainder:g.column}}B(i,r){if(r<0)return 0;const t=i.piece,g=this.a[t.bufferIndex].lineStarts,u=t.start.line+r+1;return u>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[u]-g[t.start.line]-t.start.column}C(i,r){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.end),p=r,m=this.u(t.bufferIndex,p),h=this.t(t.bufferIndex,t.start,p),E=h-g,S=m-u,w=t.length+S;i.piece=new D(t.bufferIndex,t.start,p,h,w),(0,A.$$C)(this,i,S,E)}D(i,r){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.start),p=r,m=this.t(t.bufferIndex,p,t.end),h=this.u(t.bufferIndex,p),E=m-g,S=u-h,w=t.length+S;i.piece=new D(t.bufferIndex,p,t.end,m,w),(0,A.$$C)(this,i,S,E)}E(i,r,t){const g=i.piece,u=g.start,p=g.end,m=g.length,h=g.lineFeedCnt,E=r,S=this.t(g.bufferIndex,g.start,E),w=this.u(g.bufferIndex,r)-this.u(g.bufferIndex,u);i.piece=new D(g.bufferIndex,g.start,E,S,w),(0,A.$$C)(this,i,w-m,S-h);const k=new D(g.bufferIndex,t,p,this.t(g.bufferIndex,t,p),this.u(g.bufferIndex,p)-this.u(g.bufferIndex,t)),C=this.S(i,k);this.N(C)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),g=this.a[0].buffer.length;this.a[0].buffer+=r;const u=y(r,!1);for(let C=0;C<u.length;C++)u[C]+=g;if(t){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:g-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1));const p=this.a[0].lineStarts.length-1,m=this.a[0].buffer.length-this.a[0].lineStarts[p],h={line:p,column:m},E=i.piece.length+r.length,S=i.piece.lineFeedCnt,w=this.t(0,i.piece.start,h),k=w-S;i.piece=new D(i.piece.bufferIndex,i.piece.start,h,w,E),this.g=h,(0,A.$$C)(this,i,r.length,k)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;r!==A.$4C;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){g+=r.size_left;const u={node:r,remainder:i-r.size_left,nodeStartOffset:g};return this.h.set(u),u}else i-=r.size_left+r.piece.length,g+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,g=0;for(;t!==A.$4C;)if(t.left!==A.$4C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.B(t,i-t.lf_left-2),p=this.B(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(u+r-1,p),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.B(t,i-t.lf_left-2);if(u+r-1<=t.piece.length)return{node:t,remainder:u+r-1,nodeStartOffset:g};r-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$4C;){if(t.piece.lineFeedCnt>0){const u=this.B(t,0),p=this.J(t);return{node:t,remainder:Math.min(r-1,u),nodeStartOffset:p}}else if(t.piece.length>=r-1){const u=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:u}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(g)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$4C||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,g=r.start.line,u=t[g]+r.start.column;return g===t.length-1||t[g+1]>u+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(u)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$4C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],g=this.a[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const p=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new D(i.piece.bufferIndex,i.piece.start,u,m,p),(0,A.$$C)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:r.piece.start.line+1,column:0},E=r.piece.length-1,S=this.t(r.piece.bufferIndex,h,r.piece.end);r.piece=new D(r.piece.bufferIndex,h,r.piece.end,S,E),(0,A.$$C)(this,r,-1,-1),r.piece.length===0&&t.push(r);const w=this.w(`\r
`);this.S(i,w[0]);for(let k=0;k<t.length;k++)(0,A.$9C)(this,t[k])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$9C)(this,t);else{const g=t.piece,u={line:g.start.line+1,column:0},p=g.length-1,m=this.t(g.bufferIndex,u,g.end);t.piece=new D(g.bufferIndex,u,g.end,m,p),(0,A.$$C)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===A.$4C)return r(A.$4C);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===A.$4C)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,g=this.u(t.bufferIndex,t.start),u=this.u(t.bufferIndex,t.end);return r.buffer.substring(g,u)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,g)}S(i,r){const t=new A.$3C(r,A.NodeColor.Red);if(t.left=A.$4C,t.right=A.$4C,t.parent=A.$4C,t.size_left=0,t.lf_left=0,this.root===A.$4C)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$4C)i.right=t,t.parent=i;else{const u=(0,A.$5C)(i.right);u.left=t,t.parent=u}return(0,A.$0C)(this,t),t}T(i,r){const t=new A.$3C(r,A.NodeColor.Red);if(t.left=A.$4C,t.right=A.$4C,t.parent=A.$4C,t.size_left=0,t.lf_left=0,this.root===A.$4C)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$4C)i.left=t,t.parent=i;else{const g=(0,A.$6C)(i.left);g.right=t,t.parent=g}return(0,A.$0C)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$kD=s}),define(Oe[160],Ne([1,0,6,12,32,52,100,152,154,4]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=void 0,P=qe(P);class R extends a.$Tc{constructor(c,D,f,n,o,s,l){super(),this.m=this.B(new v.$je),this.onDidChangeContent=this.m.event,this.f=D,this.j=!s,this.g=n,this.h=o,this.c=new A.$kD(c,f,l)}equals(c){return!(c instanceof R)||this.f!==c.f||this.getEOL()!==c.getEOL()?!1:this.c.equal(c.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(c){return this.c.createSnapshot(c?this.f:"")}getOffsetAt(c,D){return this.c.getOffsetAt(c,D)}getPositionAt(c){return this.c.getPositionAt(c)}getRangeAt(c,D){const f=c+D,n=this.getPositionAt(c),o=this.getPositionAt(f);return new I.$Lt(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(c,D=O.EndOfLinePreference.TextDefined){if(c.isEmpty())return"";const f=this.n(D);return this.c.getValueInRange(c,f)}getValueLengthInRange(c,D=O.EndOfLinePreference.TextDefined){if(c.isEmpty())return 0;if(c.startLineNumber===c.endLineNumber)return c.endColumn-c.startColumn;const f=this.getOffsetAt(c.startLineNumber,c.startColumn),n=this.getOffsetAt(c.endLineNumber,c.endColumn);let o=0;const s=this.n(D),l=this.getEOL();if(s.length!==l.length){const i=s.length-l.length,r=c.endLineNumber-c.startLineNumber;o=i*r}return n-f+o}getCharacterCountInRange(c,D=O.EndOfLinePreference.TextDefined){if(this.j){let f=0;const n=c.startLineNumber,o=c.endLineNumber;for(let s=n;s<=o;s++){const l=this.getLineContent(s),i=s===n?c.startColumn-1:0,r=s===o?c.endColumn-1:l.length;for(let t=i;t<r;t++)P.$Hf(l.charCodeAt(t))?(f=f+1,t=t+1):f=f+1}return f+=this.n(D).length*(o-n),f}return this.getValueLengthInRange(c,D)}getNearestChunk(c){return this.c.getNearestChunk(c)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(c){return this.c.getLineContent(c)}getLineCharCode(c,D){return this.c.getLineCharCode(c,D)}getCharCode(c){return this.c.getCharCode(c)}getLineLength(c){return this.c.getLineLength(c)}getLineMinColumn(c){return 1}getLineMaxColumn(c){return this.getLineLength(c)+1}getLineFirstNonWhitespaceColumn(c){const D=P.$sf(this.getLineContent(c));return D===-1?0:D+1}getLineLastNonWhitespaceColumn(c){const D=P.$uf(this.getLineContent(c));return D===-1?0:D+2}n(c){switch(c){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(c){this.c.setEOL(c)}applyEdits(c,D,f){let n=this.g,o=this.h,s=this.j,l=!0,i=[];for(let h=0;h<c.length;h++){const E=c[h];l&&E._isTracked&&(l=!1);const S=E.range;if(E.text){let b=!0;s||(b=!P.$Sf(E.text),s=b),!n&&b&&(n=P.$Rf(E.text)),!o&&b&&(o=P.$Uf(E.text))}let w="",k=0,C=0,d=0;if(E.text){let b;[k,C,d,b]=(0,T.$wu)(E.text);const F=this.getEOL(),N=F===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;b===T.StringEOL.Unknown||b===N?w=E.text:w=E.text.replace(/\r\n|\r|\n/g,F)}i[h]={sortIndex:h,identifier:E.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:w,eolCount:k,firstLineLength:C,lastLineLength:d,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(R.u);let r=!1;for(let h=0,E=i.length-1;h<E;h++){const S=i[h].range.getEndPosition(),w=i[h+1].range.getStartPosition();if(w.isBeforeOrEqual(S)){if(w.isBefore(S))throw new Error("Overlapping ranges are not allowed!");r=!0}}l&&(i=this.s(i));const t=f||D?R._getInverseEditRanges(i):[],g=[];if(D)for(let h=0;h<i.length;h++){const E=i[h],S=t[h];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let w=S.startLineNumber;w<=S.endLineNumber;w++){let k="";w===S.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),P.$sf(k)!==-1)||g.push({lineNumber:w,oldContent:k})}}let u=null;if(f){let h=0;u=[];for(let E=0;E<i.length;E++){const S=i[E],w=t[E],k=this.getValueInRange(S.range),C=S.rangeOffset+h;h+=S.text.length-k.length,u[E]={sortIndex:S.sortIndex,identifier:S.identifier,range:w,text:k,textChange:new $.$cu(S.rangeOffset,k,C,S.text)}}r||u.sort((E,S)=>E.sortIndex-S.sortIndex)}this.g=n,this.h=o,this.j=s;const p=this.t(i);let m=null;if(D&&g.length>0){g.sort((h,E)=>E.lineNumber-h.lineNumber),m=[];for(let h=0,E=g.length;h<E;h++){const S=g[h].lineNumber;if(h>0&&g[h-1].lineNumber===S)continue;const w=g[h].oldContent,k=this.getLineContent(S);k.length===0||k===w||P.$sf(k)!==-1||m.push(S)}}return this.m.fire(),new O.$fw(u,p,m)}s(c){return c.length<1e3?c:[this._toSingleEditOperation(c)]}_toSingleEditOperation(c){let D=!1;const f=c[0].range,n=c[c.length-1].range,o=new I.$Lt(f.startLineNumber,f.startColumn,n.endLineNumber,n.endColumn);let s=f.startLineNumber,l=f.startColumn;const i=[];for(let p=0,m=c.length;p<m;p++){const h=c[p],E=h.range;D=D||h.forceMoveMarkers,i.push(this.getValueInRange(new I.$Lt(s,l,E.startLineNumber,E.startColumn))),h.text.length>0&&i.push(h.text),s=E.endLineNumber,l=E.endColumn}const r=i.join(""),[t,g,u]=(0,T.$wu)(r);return{sortIndex:0,identifier:c[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:g,lastLineLength:u,forceMoveMarkers:D,isAutoWhitespaceEdit:!1}}t(c){c.sort(R.w);const D=[];for(let f=0;f<c.length;f++){const n=c[f],o=n.range.startLineNumber,s=n.range.startColumn,l=n.range.endLineNumber,i=n.range.endColumn;if(o===l&&s===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new I.$Lt(o,s,l,i);D.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return D}findMatchesLineByLine(c,D,f,n){return this.c.findMatchesLineByLine(c,D,f,n)}getPieceTree(){return this.c}static _getInverseEditRange(c,D){const f=c.startLineNumber,n=c.startColumn,[o,s,l]=(0,T.$wu)(D);let i;if(D.length>0){const r=o+1;r===1?i=new I.$Lt(f,n,f,n+s):i=new I.$Lt(f,n,f+r-1,l+1)}else i=new I.$Lt(f,n,f,n);return i}static _getInverseEditRanges(c){const D=[];let f=0,n=0,o=null;for(let s=0,l=c.length;s<l;s++){const i=c[s];let r,t;o?o.range.endLineNumber===i.range.startLineNumber?(r=f,t=n+(i.range.startColumn-o.range.endColumn)):(r=f+(i.range.startLineNumber-o.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const u=i.eolCount+1;u===1?g=new I.$Lt(r,t,r,t+i.firstLineLength):g=new I.$Lt(r,t,r+u-1,i.lastLineLength+1)}else g=new I.$Lt(r,t,r,t);f=g.endLineNumber,n=g.endColumn,D.push(g),o=i}return D}static u(c,D){const f=I.$Lt.compareRangesUsingEnds(c.range,D.range);return f===0?c.sortIndex-D.sortIndex:f}static w(c,D){const f=I.$Lt.compareRangesUsingEnds(c.range,D.range);return f===0?D.sortIndex-c.sortIndex:-f}}e.$lD=R}),define(Oe[161],Ne([1,0,27,12,52,100,160]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0,P=qe(P);class T{constructor(R,y,c,D,f,n,o,s,l){this.a=R,this.b=y,this.c=c,this.d=D,this.e=f,this.f=n,this.g=o,this.h=s,this.j=l}k(R){const y=this.c+this.d+this.e,c=this.c+this.e;return y===0?R===I.DefaultEndOfLine.LF?`
`:`\r
`:c>y/2?`\r
`:`
`}create(R){const y=this.k(R),c=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let f=0,n=c.length;f<n;f++){const o=c[f].buffer.replace(/\r\n|\r|\n/g,y),s=(0,O.$gD)(o);c[f]=new O.$jD(o,s)}const D=new A.$lD(c,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&P.$3f(R)&&(this.b=P.$2f,R=R.substr(1));const y=R.charCodeAt(R.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=y):(this.m(R,!1),this.c=!1,this.d=y)}m(R,y){!y&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const y=(0,O.$hD)(this.e,R);this.a.push(new O.$jD(R,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=P.$Rf(R)),this.k||(this.k=P.$Uf(R)))}finish(R=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const y=(0,O.$gD)(R.buffer);R.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$mD=$}),define(Oe[103],Ne([1,0,22,20]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddb=$,e.$Edb=R,P=qe(P);var I;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(I||(I={}));function O(y){for(let c=0,D=y.length;c<D;c+=4){const f=y[c+0],n=y[c+1],o=y[c+2],s=y[c+3];y[c+0]=s,y[c+1]=o,y[c+2]=n,y[c+3]=f}}function A(y){const c=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return P.$E()||O(c),v.$Le.wrap(c)}function T(y){const c=y.buffer;if(P.$E()||O(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const D=new Uint8Array(c.byteLength);return D.set(c),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function $(y){const c=new Uint32Array(a(y));let D=0;if(c[D++]=y.id,y.type==="full")c[D++]=I.Full,c[D++]=y.data.length,c.set(y.data,D),D+=y.data.length;else{c[D++]=I.Delta,c[D++]=y.deltas.length;for(const f of y.deltas)c[D++]=f.start,c[D++]=f.deleteCount,f.data?(c[D++]=f.data.length,c.set(f.data,D),D+=f.data.length):c[D++]=0}return A(c)}function a(y){let c=0;if(c+=2,y.type==="full")c+=1+y.data.length;else{c+=1,c+=3*y.deltas.length;for(const D of y.deltas)D.data&&(c+=D.data.length)}return c}function R(y){const c=T(y);let D=0;const f=c[D++];if(c[D++]===I.Full){const l=c[D++],i=c.subarray(D,D+l);return D+=l,{id:f,type:"full",data:i}}const o=c[D++],s=[];for(let l=0;l<o;l++){const i=c[D++],r=c[D++],t=c[D++];let g;t>0&&(g=c.subarray(D,D+t),D+=t),s[l]={start:i,deleteCount:r,data:g}}return{id:f,type:"delta",deltas:s}}}),define(Oe[162],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u_=e.$t_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$t_=v;class P{constructor(O){this.identifier=O}}e.$u_=P}),define(Oe[163],Ne([1,0,6,4,9]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=R,I=qe(I);class O extends P.$Tc{constructor(c,D="",f="",n=!0,o){super(),this.j=this.B(new v.$je),this.onDidChange=this.j.event,this.z=!0,this.m=c,this.n=D,this.w=f,this.z=n,this.D=o}get id(){return this.m}get label(){return this.n}set label(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.j.fire({label:c}))}get tooltip(){return this.u||""}set tooltip(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.j.fire({tooltip:c}))}get class(){return this.w}set class(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.j.fire({class:c}))}get enabled(){return this.z}set enabled(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.j.fire({enabled:c}))}get checked(){return this.C}set checked(c){this.J(c)}J(c){this.C!==c&&(this.C=c,this.j.fire({checked:c}))}async run(c,D){this.D&&await this.D(c)}}e.$hj=O;class A extends P.$Tc{constructor(){super(...arguments),this.f=this.B(new v.$je),this.onWillRun=this.f.event,this.m=this.B(new v.$je),this.onDidRun=this.m.event}async run(c,D){if(!c.enabled)return;this.f.fire({action:c});let f;try{await this.u(c,D)}catch(n){f=n}this.m.fire({action:c,error:f})}async u(c,D){await c.run(D)}}e.$ij=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let D=[];for(const f of c)f.length&&(D.length?D=[...D,new T,...f]:D=f);return D}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=T;class ${get actions(){return this.a}constructor(c,D,f,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=D,this.class=n,this.a=f}async run(){}}e.$kj=$;class a extends O{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,I.localize(12885,null),void 0,!1)}}e.$lj=a;function R(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...c)=>y.run(...c)}}}),define(Oe[164],Ne([1,0,9]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=a,e.$Zm=R,e.$1m=y;const P=60,I=P*60,O=I*24,A=O*7,T=O*30,$=O*365;function a(c,D,f,n){typeof c!="number"&&(c=c.getTime());const o=Math.round((new Date().getTime()-c)/1e3);if(o<-30)return(0,v.localize)(12822,null,a(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,v.localize)(12823,null);let s;return o<P?(s=o,D?s===1?f?(0,v.localize)(12824,null,s):(0,v.localize)(12825,null,s):f?(0,v.localize)(12826,null,s):(0,v.localize)(12827,null,s):s===1?f?(0,v.localize)(12828,null,s):(0,v.localize)(12829,null,s):f?(0,v.localize)(12830,null,s):(0,v.localize)(12831,null,s)):o<I?(s=Math.floor(o/P),D?s===1?f?(0,v.localize)(12832,null,s):(0,v.localize)(12833,null,s):f?(0,v.localize)(12834,null,s):(0,v.localize)(12835,null,s):s===1?f?(0,v.localize)(12836,null,s):(0,v.localize)(12837,null,s):f?(0,v.localize)(12838,null,s):(0,v.localize)(12839,null,s)):o<O?(s=Math.floor(o/I),D?s===1?f?(0,v.localize)(12840,null,s):(0,v.localize)(12841,null,s):f?(0,v.localize)(12842,null,s):(0,v.localize)(12843,null,s):s===1?f?(0,v.localize)(12844,null,s):(0,v.localize)(12845,null,s):f?(0,v.localize)(12846,null,s):(0,v.localize)(12847,null,s)):o<A?(s=Math.floor(o/O),D?s===1?(0,v.localize)(12848,null,s):(0,v.localize)(12849,null,s):s===1?(0,v.localize)(12850,null,s):(0,v.localize)(12851,null,s)):o<T?(s=Math.floor(o/A),D?s===1?f?(0,v.localize)(12852,null,s):(0,v.localize)(12853,null,s):f?(0,v.localize)(12854,null,s):(0,v.localize)(12855,null,s):s===1?f?(0,v.localize)(12856,null,s):(0,v.localize)(12857,null,s):f?(0,v.localize)(12858,null,s):(0,v.localize)(12859,null,s)):o<$?(s=Math.floor(o/T),D?s===1?f?(0,v.localize)(12860,null,s):(0,v.localize)(12861,null,s):f?(0,v.localize)(12862,null,s):(0,v.localize)(12863,null,s):s===1?f?(0,v.localize)(12864,null,s):(0,v.localize)(12865,null,s):f?(0,v.localize)(12866,null,s):(0,v.localize)(12867,null,s)):(s=Math.floor(o/$),D?s===1?f?(0,v.localize)(12868,null,s):(0,v.localize)(12869,null,s):f?(0,v.localize)(12870,null,s):(0,v.localize)(12871,null,s):s===1?f?(0,v.localize)(12872,null,s):(0,v.localize)(12873,null,s):f?(0,v.localize)(12874,null,s):(0,v.localize)(12875,null,s))}function R(c,D){const f=Math.abs(c/1e3);return f<1?D?(0,v.localize)(12876,null,c):(0,v.localize)(12877,null,c):f<P?D?(0,v.localize)(12878,null,Math.round(c)/1e3):(0,v.localize)(12879,null,Math.round(c)/1e3):f<I?D?(0,v.localize)(12880,null,Math.round(c/(1e3*P))):(0,v.localize)(12881,null,Math.round(c/(1e3*P))):f<O?D?(0,v.localize)(12882,null,Math.round(c/(1e3*I))):(0,v.localize)(12883,null,Math.round(c/(1e3*I))):(0,v.localize)(12884,null,Math.round(c/(1e3*O)))}function y(c){return c.getFullYear()+"-"+String(c.getMonth()+1).padStart(2,"0")+"-"+String(c.getDate()).padStart(2,"0")+"T"+String(c.getHours()).padStart(2,"0")+":"+String(c.getMinutes()).padStart(2,"0")+":"+String(c.getSeconds()).padStart(2,"0")+"."+(c.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Oe[42],Ne([1,0,17,14,9]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=$,e.$oj=a,e.$pj=R,v=qe(v),P=qe(P),I=qe(I);function O(y,c){return c&&(y.stack||y.stacktrace)?I.localize(12816,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?I.localize(12817,null,y.message):y.message||I.localize(12818,null)}function $(y=null,c=!1){if(!y)return I.localize(12819,null);if(Array.isArray(y)){const D=v.$Gb(y),f=$(D[0],c);return D.length>1?I.localize(12820,null,f,D.length):f}if(P.$cg(y))return y;if(y.detail){const D=y.detail;if(D.error)return O(D.error,c);if(D.exception)return O(D.exception,c)}return y.stack?O(y,c):y.message?y.message:I.localize(12821,null)}function a(y){const c=y;return c instanceof Error&&Array.isArray(c.actions)}function R(y,c){let D;return typeof y=="string"?D=new Error(y):D=y,D.actions=c,D}}),define(Oe[165],Ne([1,0,27,13,9]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var O;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...R){switch(R.length){case 1:return(0,I.localize)(11423,null,R[0]);case 2:return(0,I.localize)(11424,null,R[0],R[1]);case 3:return(0,I.localize)(11425,null,R[0],R[1],R[2]);default:return}}const T=(0,I.localize)(11426,null),$=(0,I.localize)(11427,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(O.LParen);break;case v.CharCode.CloseParen:this.k(O.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const c=this.h(v.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:c})}else this.k(O.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const c=this.h(v.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:c})}else this.h(v.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?O.LtEq:O.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?O.GtEq:O.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const c=this.d,D=this.c.substring(this.d,this.e),f={type:O.Error,offset:this.d,lexeme:D};this.g.push({offset:c,lexeme:D,additionalInfo:y}),this.f.push(f)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const c=this.c.substring(this.d,this.e),D=a.b.get(c);D?this.k(D):this.f.push({type:O.Str,lexeme:c,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,c=!1,D=!1;for(;;){if(y>=this.c.length){this.e=y,this.l($);return}const n=this.c.charCodeAt(y);if(c)c=!1;else if(n===v.CharCode.Slash&&!D){y++;break}else n===v.CharCode.OpenSquareBracket?D=!0:n===v.CharCode.Backslash?c=!0:n===v.CharCode.CloseSquareBracket&&(D=!1);y++}for(;y<this.c.length&&a.a.has(this.c.charCodeAt(y));)y++;this.e=y;const f=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=a}),define(Oe[104],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Oe[73],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class v{constructor(I,O=[],A=!1){this.ctor=I,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$zi=v}),define(Oe[60],Ne([1,0,73]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=O,e.$Ps=A;const P=[];var I;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function O(T,$,a){$ instanceof v.$zi||($=new v.$zi($,[],!!a)),P.push([T,$])}function A(){return P}}),define(Oe[166],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class v{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$rr=v;class P{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const T=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(A);T.outgoing.set($.key,$),$.incoming.set(T.key,T)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let T=this.a.get(A);return T||(T=new v(A,O),this.a.set(A,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,T]of this.a)O.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const T=new Set([O]),$=this.c(A,T);if($)return $}}c(O,A){for(const[T,$]of O.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const a=this.c($,A);if(a)return a;A.delete(T)}}}e.$sr=P}),define(Oe[3],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=I,e.$Di=O;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(v||(e._util=v={})),e.$Bi=I("instantiationService");function P(A,T,$){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:A,index:$}):(T[v.DI_DEPENDENCIES]=[{id:A,index:$}],T[v.DI_TARGET]=T)}function I(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const T=function($,a,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(T,$,R)};return T.toString=()=>A,v.serviceIds.set(A,T),T}function O(A){return A}}),define(Oe[43],Ne([1,0,14,2,3]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=O,e.$$i=A,e.$_i=$,e.$aj=a,e.$bj=R,e.$cj=y,e.$dj=c,e.$ej=f,e.$fj=n,e.$gj=o,v=qe(v),e.$9i=(0,I.$Ci)("configurationService");function O(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof P.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof P.URI)}var T;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function $(s){switch(s){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function a(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function R(s,l){const i=Object.create(null);for(const r in s)y(i,r,s[r],l);return i}function y(s,l,i,r){const t=l.split("."),g=t.pop();let u=s;for(let p=0;p<t.length;p++){const m=t[p];let h=u[m];switch(typeof h){case"undefined":h=u[m]=Object.create(null);break;case"object":if(h===null){r(`Ignoring ${l} as ${t.slice(0,p+1).join(".")} is null`);return}break;default:r(`Ignoring ${l} as ${t.slice(0,p+1).join(".")} is ${JSON.stringify(h)}`);return}u=h}if(typeof u=="object"&&u!==null)try{u[g]=i}catch{r(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}else r(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}function c(s,l){const i=l.split(".");D(s,i)}function D(s,l){const i=l.shift();if(l.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const r=s[i];typeof r=="object"&&!Array.isArray(r)&&(D(r,l),Object.keys(r).length===0&&delete s[i])}}function f(s,l,i){function r(u,p){let m=u;for(const h of p){if(typeof m!="object"||m===null)return;m=m[h]}return m}const t=l.split("."),g=r(s,t);return typeof g>"u"?i:g}function n(s,l,i){Object.keys(l).forEach(r=>{r!=="__proto__"&&(r in s?v.$eg(s[r])&&v.$eg(l[r])?n(s[r],l[r],i):i&&(s[r]=l[r]):s[r]=l[r])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Oe[31],Ne([1,0,27,20,12,165,3,9,13]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=R,e.$Bj=p,e.$Cj=m,e.$Vj=oe;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",P.$k),a.set("isLinux",P.$l),a.set("isWindows",P.$j),a.set("isWeb",P.$p),a.set("isMacNative",P.$k&&!P.$p),a.set("isEdge",P.$I),a.set("isFirefox",P.$G),a.set("isChrome",P.$F),a.set("isSafari",P.$H);function R(X,q){if(a.get(X)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(X,q)}const y=Object.prototype.hasOwnProperty;var c;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(c||(e.ContextKeyExprType=c={}));const D={regexParsingWithErrorRecovery:!0},f=(0,T.localize)(11437,null),n=(0,T.localize)(11438,null),o=(0,T.localize)(11439,null),s=(0,T.localize)(11440,null),l=(0,T.localize)(11441,null),i=(0,T.localize)(11442,null),r=(0,T.localize)(11443,null),t=(0,T.localize)(11444,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=D){this.k=q,this.d=new O.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const ve=this.D(),ae=ve.type===O.TokenType.Str?i:void 0;throw this.h.push({message:l,offset:ve.offset,lexeme:O.$xj.getLexeme(ve),additionalInfo:ae}),g.c}return te}catch(te){if(te!==g.c)throw te;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(O.TokenType.Or);){const te=this.o();q.push(te)}return q.length===1?q[0]:u.or(...q)}o(){const q=[this.s()];for(;this.y(O.TokenType.And);){const te=this.s();q.push(te)}return q.length===1?q[0]:u.and(...q)}s(){if(this.y(O.TokenType.Neg)){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),E.INSTANCE;case O.TokenType.False:return this.z(),S.INSTANCE;case O.TokenType.LParen:{this.z();const te=this.l();return this.A(O.TokenType.RParen,s),te?.negate()}case O.TokenType.Str:return this.z(),F.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),u.true();case O.TokenType.False:return this.z(),u.false();case O.TokenType.LParen:{this.z();const te=this.l();return this.A(O.TokenType.RParen,s),te}case O.TokenType.Str:{const te=q.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==O.TokenType.RegexStr)throw this.B("REGEX",ae);const be=ae.lexeme,ue=be.lastIndexOf("/"),J=ue===be.length-1?void 0:this.w(be.substring(ue+1));let x;try{x=new RegExp(be.substring(1,ue),J)}catch{throw this.B("REGEX",ae)}return Y.create(te,x)}switch(ae.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const be=[ae.lexeme];this.z();let ue=this.D(),J=0;for(let ze=0;ze<ae.lexeme.length;ze++)ae.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?J++:ae.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&J--;for(;!this.E()&&ue.type!==O.TokenType.And&&ue.type!==O.TokenType.Or;){switch(ue.type){case O.TokenType.LParen:J++;break;case O.TokenType.RParen:J--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let ze=0;ze<ue.lexeme.length;ze++)ue.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?J++:ae.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&J--}if(J<0)break;be.push(O.$xj.getLexeme(ue)),this.z(),ue=this.D()}const x=be.join(""),me=x.lastIndexOf("/"),pe=me===x.length-1?void 0:this.w(x.substring(me+1));let Ae;try{Ae=new RegExp(x.substring(1,me),pe)}catch{throw this.B("REGEX",ae)}return u.regex(te,Ae)}case O.TokenType.QuotedStr:{const be=ae.lexeme;this.z();let ue=null;if(!(0,I.$af)(be)){const J=be.indexOf("/"),x=be.lastIndexOf("/");if(J!==x&&J>=0){const me=be.slice(J+1,x),pe=be[x+1]==="i"?"i":"";try{ue=new RegExp(me,pe)}catch{throw this.B("REGEX",ae)}}}if(ue===null)throw this.B("REGEX",ae);return Y.create(te,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,o);const ae=this.u();return u.notIn(te,ae)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ae=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.equals(te,ae);switch(ae){case"true":return u.has(te);case"false":return u.not(te);default:return u.equals(te,ae)}}case O.TokenType.NotEq:{this.z();const ae=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.notEquals(te,ae);switch(ae){case"true":return u.not(te);case"false":return u.has(te);default:return u.notEquals(te,ae)}}case O.TokenType.Lt:return this.z(),W.create(te,this.u());case O.TokenType.LtEq:return this.z(),L.create(te,this.u());case O.TokenType.Gt:return this.z(),M.create(te,this.u());case O.TokenType.GtEq:return this.z(),V.create(te,this.u());case O.TokenType.In:return this.z(),u.in(te,this.u());default:return u.has(te)}}case O.TokenType.EOF:throw this.h.push({message:r,offset:q.offset,lexeme:"",additionalInfo:t}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),q.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,te){if(this.C(q))return this.z();throw this.B(te,this.D())}B(q,te,ve){const ae=(0,T.localize)(11445,null,q,O.$xj.getLexeme(te)),be=te.offset,ue=O.$xj.getLexeme(te);return this.h.push({message:ae,offset:be,lexeme:ue,additionalInfo:ve}),g.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$zj=g;class u{static false(){return E.INSTANCE}static true(){return S.INSTANCE}static has(q){return w.create(q)}static equals(q,te){return k.create(q,te)}static notEquals(q,te){return b.create(q,te)}static regex(q,te){return Y.create(q,te)}static in(q,te){return C.create(q,te)}static notIn(q,te){return d.create(q,te)}static not(q){return F.create(q)}static and(...q){return _.create(q,null,!0)}static or(...q){return fe.create(q,null,!0)}static greater(q,te){return M.create(q,te)}static greaterEquals(q,te){return V.create(q,te)}static smaller(q,te){return W.create(q,te)}static smallerEquals(q,te){return L.create(q,te)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Aj=u;function p(X){const q=new g({regexParsingWithErrorRecovery:!1});return X.map(te=>(q.parse(te),q.lexingErrors.length>0?q.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,T.localize)(11446,null,ve.additionalInfo):(0,T.localize)(11447,null),offset:ve.offset,length:ve.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function m(X,q){const te=X?X.substituteConstants():void 0,ve=q?q.substituteConstants():void 0;return!te&&!ve?!0:!te||!ve?!1:te.equals(ve)}function h(X,q){return X.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=c.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return S.INSTANCE}}e.$Dj=E;class S{static{this.INSTANCE=new S}constructor(){this.type=c.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$Ej=S;class w{static create(q,te=null){const ve=a.get(q);return typeof ve=="boolean"?ve?S.INSTANCE:E.INSTANCE:new w(q,te)}constructor(q,te){this.key=q,this.c=te,this.type=c.Defined}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=a.get(this.key);return typeof q=="boolean"?q?S.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Fj=w;class k{static create(q,te,ve=null){if(typeof te=="boolean")return te?w.create(q,ve):F.create(q,ve);const ae=a.get(q);return typeof ae=="boolean"?te===(ae?"true":"false")?S.INSTANCE:E.INSTANCE:new k(q,te,ve)}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=c.Equals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=a.get(this.c);if(typeof q=="boolean"){const te=q?"true":"false";return this.d===te?S.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Gj=k;class C{static create(q,te){return new C(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=c.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const te=q.getValue(this.f),ve=q.getValue(this.d);return Array.isArray(te)?te.includes(ve):typeof ve=="string"&&typeof te=="object"&&te!==null?y.call(te,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.$Hj=C;class d{static create(q,te){return new d(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=c.NotIn,this.c=C.create(q,te)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=d;class b{static create(q,te,ve=null){if(typeof te=="boolean")return te?F.create(q,ve):w.create(q,ve);const ae=a.get(q);return typeof ae=="boolean"?te===(ae?"true":"false")?E.INSTANCE:S.INSTANCE:new b(q,te,ve)}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=c.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=a.get(this.c);if(typeof q=="boolean"){const te=q?"true":"false";return this.d===te?E.INSTANCE:S.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Jj=b;class F{static create(q,te=null){const ve=a.get(q);return typeof ve=="boolean"?ve?E.INSTANCE:S.INSTANCE:new F(q,te)}constructor(q,te){this.c=q,this.d=te,this.type=c.Not}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=a.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:S.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Kj=F;function N(X,q){if(typeof X=="string"){const te=parseFloat(X);isNaN(te)||(X=te)}return typeof X=="string"||typeof X=="number"?q(X):E.INSTANCE}class M{static create(q,te,ve=null){return N(te,ae=>new M(q,ae,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=c.Greater}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Lj=M;class V{static create(q,te,ve=null){return N(te,ae=>new V(q,ae,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=c.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Mj=V;class W{static create(q,te,ve=null){return N(te,ae=>new W(q,ae,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=c.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Nj=W;class L{static create(q,te,ve=null){return N(te,ae=>new L(q,ae,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=c.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Oj=L;class Y{static create(q,te){return new Y(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=c.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const te=this.f?this.f.source:"",ve=q.f?q.f.source:"";return te<ve?-1:te>ve?1:0}equals(q){if(q.type===this.type){const te=this.f?this.f.source:"",ve=q.f?q.f.source:"";return this.d===q.d&&te===ve}return!1}substituteConstants(){return this}evaluate(q){const te=q.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Pj=Y;class Z{static create(q){return new Z(q)}constructor(q){this.c=q,this.type=c.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new Z(this.c.map(q))}negate(){return this.c}}e.$Qj=Z;function ge(X){let q=null;for(let te=0,ve=X.length;te<ve;te++){const ae=X[te].substituteConstants();if(X[te]!==ae&&q===null){q=[];for(let be=0;be<te;be++)q[be]=X[be]}q!==null&&(q[te]=ae)}return q===null?X:q}class _{static create(q,te,ve){return _.d(q,te,ve)}constructor(q,te){this.expr=q,this.c=te,this.type=c.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ae=h(this.expr[te],q.expr[te]);if(ae!==0)return ae}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(q.expr[te]))return!1;return!0}return!1}substituteConstants(){const q=ge(this.expr);return q===this.expr?this:_.create(q,this.c,!1)}evaluate(q){for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].evaluate(q))return!1;return!0}static d(q,te,ve){const ae=[];let be=!1;for(const ue of q)if(ue){if(ue.type===c.True){be=!0;continue}if(ue.type===c.False)return E.INSTANCE;if(ue.type===c.And){ae.push(...ue.expr);continue}ae.push(ue)}if(ae.length===0&&be)return S.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort(h);for(let ue=1;ue<ae.length;ue++)ae[ue-1].equals(ae[ue])&&(ae.splice(ue,1),ue--);if(ae.length===1)return ae[0];for(;ae.length>1;){const ue=ae[ae.length-1];if(ue.type!==c.Or)break;ae.pop();const J=ae.pop(),x=ae.length===0,me=fe.create(ue.expr.map(pe=>_.create([pe,J],null,ve)),null,x);me&&(ae.push(me),ae.sort(h))}if(ae.length===1)return ae[0];if(ve){for(let ue=0;ue<ae.length;ue++)for(let J=ue+1;J<ae.length;J++)if(ae[ue].negate().equals(ae[J]))return E.INSTANCE;if(ae.length===1)return ae[0]}return new _(ae,te)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const te of this.expr)q.push(...te.keys());return q}map(q){return new _(this.expr.map(te=>te.map(q)),null)}negate(){if(!this.c){const q=[];for(const te of this.expr)q.push(te.negate());this.c=fe.create(q,this,!0)}return this.c}}e.$Rj=_;class fe{static create(q,te,ve){return fe.d(q,te,ve)}constructor(q,te){this.expr=q,this.c=te,this.type=c.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ae=h(this.expr[te],q.expr[te]);if(ae!==0)return ae}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(q.expr[te]))return!1;return!0}return!1}substituteConstants(){const q=ge(this.expr);return q===this.expr?this:fe.create(q,this.c,!1)}evaluate(q){for(let te=0,ve=this.expr.length;te<ve;te++)if(this.expr[te].evaluate(q))return!0;return!1}static d(q,te,ve){let ae=[],be=!1;if(q){for(let ue=0,J=q.length;ue<J;ue++){const x=q[ue];if(x){if(x.type===c.False){be=!0;continue}if(x.type===c.True)return S.INSTANCE;if(x.type===c.Or){ae=ae.concat(x.expr);continue}ae.push(x)}}if(ae.length===0&&be)return E.INSTANCE;ae.sort(h)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let ue=1;ue<ae.length;ue++)ae[ue-1].equals(ae[ue])&&(ae.splice(ue,1),ue--);if(ae.length===1)return ae[0];if(ve){for(let ue=0;ue<ae.length;ue++)for(let J=ue+1;J<ae.length;J++)if(ae[ue].negate().equals(ae[J]))return S.INSTANCE;if(ae.length===1)return ae[0]}return new fe(ae,te)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const te of this.expr)q.push(...te.keys());return q}map(q){return new fe(this.expr.map(te=>te.map(q)),null)}negate(){if(!this.c){const q=[];for(const te of this.expr)q.push(te.negate());for(;q.length>1;){const te=q.shift(),ve=q.shift(),ae=[];for(const be of Le(te))for(const ue of Le(ve))ae.push(_.create([be,ue],null,!1));q.unshift(fe.create(ae,null,!1))}this.c=fe.create(q,this,!0)}return this.c}}e.$Sj=fe;class se extends w{static{this.d=[]}static all(){return se.d.values()}constructor(q,te,ve){super(q,null),this.f=te,typeof ve=="object"?se.d.push({...ve,key:q}):ve!==!0&&se.d.push({key:q,description:ve,type:te!=null?typeof te:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return k.create(this.key,q)}notEqualsTo(q){return b.create(this.key,q)}}e.$Tj=se,e.$Uj=(0,A.$Ci)("contextKeyService");function ce(X,q){return X<q?-1:X>q?1:0}function $e(X,q,te,ve){return X<te?-1:X>te?1:q<ve?-1:q>ve?1:0}function oe(X,q){if(X.type===c.False||q.type===c.True)return!0;if(X.type===c.Or)return q.type===c.Or?Ce(X.expr,q.expr):!1;if(q.type===c.Or){for(const te of q.expr)if(oe(X,te))return!0;return!1}if(X.type===c.And){if(q.type===c.And)return Ce(q.expr,X.expr);for(const te of X.expr)if(oe(te,q))return!0;return!1}return X.equals(q)}function Ce(X,q){let te=0,ve=0;for(;te<X.length&&ve<q.length;){const ae=X[te].cmp(q[ve]);if(ae<0)return!1;ae===0&&te++,ve++}return te===X.length}function Le(X){return X.type===c.Or?X.expr:[X]}}),define(Oe[167],Ne([1,0,31,3]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$pt=e.AccessibilitySupport=e.$ot=void 0,e.$qt=O,e.$ot=(0,P.$Ci)("accessibilityService");var I;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(I||(e.AccessibilitySupport=I={})),e.$pt=new v.$Tj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$rt="ACCESSIBLE_VIEW_SHOWN_"}),define(Oe[105],Ne([1,0,17,25,20,145,279,155,168,9,167]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=h,e.cursorStyleToString=N,e.filterValidationDecorations=Pe,v=qe(v),P=qe(P),I=qe(I),a=qe(a);var y;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class c{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=c;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class f{constructor(Q,Se,Je,xe){this.id=Q,this.name=Se,this.defaultValue=Je,this.schema=xe}applyUpdate(Q,Se){return o(Q,Se)}compute(Q,Se,Je){return Je}}class n{constructor(Q,Se){this.newValue=Q,this.didChange=Se}}e.ApplyUpdateResult=n;function o(ee,Q){if(typeof ee!="object"||typeof Q!="object"||!ee||!Q)return new n(Q,ee!==Q);if(Array.isArray(ee)||Array.isArray(Q)){const Je=Array.isArray(ee)&&Array.isArray(Q)&&v.$tb(ee,Q);return new n(Q,!Je)}let Se=!1;for(const Je in Q)if(Q.hasOwnProperty(Je)){const xe=o(ee[Je],Q[Je]);xe.didChange&&(ee[Je]=xe.newValue,Se=!0)}return new n(ee,Se)}class s{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Se){return o(Q,Se)}validate(Q){return this.defaultValue}}class l{constructor(Q,Se,Je,xe){this.id=Q,this.name=Se,this.defaultValue=Je,this.schema=xe}applyUpdate(Q,Se){return o(Q,Se)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Se,Je){return Je}}function i(ee,Q){return typeof ee>"u"?Q:ee==="false"?!1:!!ee}class r extends l{constructor(Q,Se,Je,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Je),super(Q,Se,Je,xe)}validate(Q){return i(Q,this.defaultValue)}}function t(ee,Q,Se,Je){if(typeof ee>"u")return Q;let xe=parseInt(ee,10);return isNaN(xe)?Q:(xe=Math.max(Se,xe),xe=Math.min(Je,xe),xe|0)}class g extends l{static clampedInt(Q,Se,Je,xe){return t(Q,Se,Je,xe)}constructor(Q,Se,Je,xe,ht,$t=void 0){typeof $t<"u"&&($t.type="integer",$t.default=Je,$t.minimum=xe,$t.maximum=ht),super(Q,Se,Je,$t),this.minimum=xe,this.maximum=ht}validate(Q){return g.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function u(ee,Q,Se,Je){if(typeof ee>"u")return Q;const xe=p.float(ee,Q);return p.clamp(xe,Se,Je)}class p extends l{static clamp(Q,Se,Je){return Q<Se?Se:Q>Je?Je:Q}static float(Q,Se){if(typeof Q=="number")return Q;if(typeof Q>"u")return Se;const Je=parseFloat(Q);return isNaN(Je)?Se:Je}constructor(Q,Se,Je,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Je),super(Q,Se,Je,ht),this.validationFn=xe}validate(Q){return this.validationFn(p.float(Q,this.defaultValue))}}class m extends l{static string(Q,Se){return typeof Q!="string"?Se:Q}constructor(Q,Se,Je,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Je),super(Q,Se,Je,xe)}validate(Q){return m.string(Q,this.defaultValue)}}function h(ee,Q,Se,Je){return typeof ee!="string"?Q:Je&&ee in Je?Je[ee]:Se.indexOf(ee)===-1?Q:ee}class E extends l{constructor(Q,Se,Je,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Je),super(Q,Se,Je,ht),this.c=xe}validate(Q){return h(Q,this.defaultValue,this.c)}}class S extends f{constructor(Q,Se,Je,xe,ht,$t,Nt=void 0){typeof Nt<"u"&&(Nt.type="string",Nt.enum=ht,Nt.default=xe),super(Q,Se,Je,Nt),this.c=ht,this.d=$t}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function w(ee){switch(ee){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class k extends f{constructor(){super(je.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(11613,null),a.localize(11614,null),a.localize(11615,null)],default:"auto",tags:["accessibility"],description:a.localize(11616,null)})}validate(Q){switch(Q){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(Q,Se,Je){return Je===R.AccessibilitySupport.Unknown?Q.accessibilitySupport:Je}}class C extends f{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:a.localize(11617,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:a.localize(11618,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{insertSpace:i(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var d;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(d||(e.TextEditorCursorBlinkingStyle=d={}));function b(ee){switch(ee){case"blink":return d.Blink;case"smooth":return d.Smooth;case"phase":return d.Phase;case"expand":return d.Expand;case"solid":return d.Solid}}var F;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(ee){switch(ee){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function M(ee){switch(ee){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class V extends s{constructor(){super(je.editorClassName)}compute(Q,Se,Je){const xe=["monaco-editor"];return Se.get(je.extraEditorClassName)&&xe.push(Se.get(je.extraEditorClassName)),Q.extraEditorClassName&&xe.push(Q.extraEditorClassName),Se.get(je.mouseStyle)==="default"?xe.push("mouse-default"):Se.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),Se.get(je.showUnused)&&xe.push("showUnused"),Se.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class W extends r{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(11619,null)})}compute(Q,Se,Je){return Je&&Q.emptySelectionClipboard}}class L extends f{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:a.localize(11620,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[a.localize(11621,null),a.localize(11622,null),a.localize(11623,null)],description:a.localize(11624,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[a.localize(11625,null),a.localize(11626,null),a.localize(11627,null)],description:a.localize(11628,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:a.localize(11629,null),included:I.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:a.localize(11630,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:a.localize(11631,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{cursorMoveOnType:i(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":h(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":h(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Se.loop,this.defaultValue.loop)}}}class Y extends f{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",Y.OFF,{anyOf:[{type:"boolean",description:a.localize(11632,null)},{type:"string",description:a.localize(11633,null)}],description:a.localize(11634,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?Y.OFF:Q==="true"?Y.ON:Q:Q?Y.ON:Y.OFF}}e.EditorFontLigatures=Y;class Z extends f{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",Z.OFF,{anyOf:[{type:"boolean",description:a.localize(11635,null)},{type:"string",description:a.localize(11636,null)}],description:a.localize(11637,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?Z.OFF:Q==="true"?Z.TRANSLATE:Q:Q?Z.TRANSLATE:Z.OFF}compute(Q,Se,Je){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=Z;class ge extends s{constructor(){super(je.fontInfo)}compute(Q,Se,Je){return Q.fontInfo}}class _ extends l{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(11638,null)})}validate(Q){const Se=p.float(Q,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(Se,6,100)}compute(Q,Se,Je){return Q.fontInfo.fontSize}}class fe extends f{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:fe.d,maximum:fe.e,errorMessage:a.localize(11639,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:fe.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(11640,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(g.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,fe.d,fe.e))}}class se extends f{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[a.localize(11641,null),a.localize(11642,null),a.localize(11643,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(11644,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(11645,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(11646,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:a.localize(11647,null),...Se},"editor.gotoLocation.multipleImplementations":{description:a.localize(11648,null),...Se},"editor.gotoLocation.multipleReferences":{description:a.localize(11649,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Je,description:a.localize(11650,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Je,description:a.localize(11651,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Je,description:a.localize(11652,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Je,description:a.localize(11653,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Je,description:a.localize(11654,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{multiple:h(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??h(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??h(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??h(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??h(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??h(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends f{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:a.localize(11655,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:a.localize(11656,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:a.localize(11657,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:a.localize(11658,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:a.localize(11659,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),delay:g.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:i(Se.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(Se.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Se.above,this.defaultValue.above)}}}var $e;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})($e||(e.RenderMinimap=$e={}));class oe extends s{constructor(){super(je.layoutInfo)}compute(Q,Se,Je){return oe.computeLayout(Se,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Se=Q.height/Q.lineHeight,Je=Math.floor(Q.paddingTop/Q.lineHeight);let xe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(xe=Math.max(xe,Se-1));const ht=(Je+Q.viewLineCount+xe)/(Q.pixelRatio*Q.height),$t=Math.floor(Q.viewLineCount/ht);return{typicalViewportLineCount:Se,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:$t}}static c(Q,Se){const Je=Q.outerWidth,xe=Q.outerHeight,ht=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:$e.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const $t=Se.stableMinimapLayoutInput,Nt=$t&&Q.outerHeight===$t.outerHeight&&Q.lineHeight===$t.lineHeight&&Q.typicalHalfwidthCharacterWidth===$t.typicalHalfwidthCharacterWidth&&Q.pixelRatio===$t.pixelRatio&&Q.scrollBeyondLastLine===$t.scrollBeyondLastLine&&Q.paddingTop===$t.paddingTop&&Q.paddingBottom===$t.paddingBottom&&Q.minimap.enabled===$t.minimap.enabled&&Q.minimap.side===$t.minimap.side&&Q.minimap.size===$t.minimap.size&&Q.minimap.showSlider===$t.minimap.showSlider&&Q.minimap.renderCharacters===$t.minimap.renderCharacters&&Q.minimap.maxColumn===$t.minimap.maxColumn&&Q.minimap.scale===$t.minimap.scale&&Q.verticalScrollbarWidth===$t.verticalScrollbarWidth&&Q.isViewportWrapping===$t.isViewportWrapping,qt=Q.lineHeight,ri=Q.typicalHalfwidthCharacterWidth,Xt=Q.scrollBeyondLastLine,di=Q.minimap.renderCharacters;let Ye=ht>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Vt=Q.minimap.maxColumn,Gt=Q.minimap.size,gt=Q.minimap.side,Dt=Q.verticalScrollbarWidth,Yt=Q.viewLineCount,Zt=Q.remainingWidth,jt=Q.isViewportWrapping,bt=di?2:3;let Rt=Math.floor(ht*xe);const li=Rt/ht;let Kt=!1,Xe=!1,xt=bt*Ye,ui=Ye/ht,fi=1;if(Gt==="fill"||Gt==="fit"){const{typicalViewportLineCount:ei,extraLinesBeforeFirstLine:Bt,extraLinesBeyondLastLine:Wt,desiredRatio:hi,minimapLineCount:Tt}=oe.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:Xt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:xe,lineHeight:qt,pixelRatio:ht});if(Yt/Tt>1)Kt=!0,Xe=!0,Ye=1,xt=1,ui=Ye/ht;else{let wt=!1,Qt=Ye+1;if(Gt==="fit"){const yt=Math.ceil((Bt+Yt+Wt)*xt);jt&&Nt&&Zt<=Se.stableFitRemainingWidth?(wt=!0,Qt=Se.stableFitMaxMinimapScale):wt=yt>Rt}if(Gt==="fill"||wt){Kt=!0;const yt=Ye;xt=Math.min(qt*ht,Math.max(1,Math.floor(1/hi))),jt&&Nt&&Zt<=Se.stableFitRemainingWidth&&(Qt=Se.stableFitMaxMinimapScale),Ye=Math.min(Qt,Math.max(1,Math.floor(xt/bt))),Ye>yt&&(fi=Math.min(2,Ye/yt)),ui=Ye/ht/fi,Rt=Math.ceil(Math.max(ei,Bt+Yt+Wt)*xt),jt?(Se.stableMinimapLayoutInput=Q,Se.stableFitRemainingWidth=Zt,Se.stableFitMaxMinimapScale=Ye):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const kt=Math.floor(Vt*ui),Mt=Math.min(kt,Math.max(0,Math.floor((Zt-Dt-2)*ui/(ri+ui)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(ht*Mt);const Ft=At/ht;At=Math.floor(At*fi);const si=di?$e.Text:$e.Blocks,_t=gt==="left"?0:Je-Mt-Dt;return{renderMinimap:si,minimapLeft:_t,minimapWidth:Mt,minimapHeightIsEditorHeight:Kt,minimapIsSampling:Xe,minimapScale:Ye,minimapLineHeight:xt,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:li}}static computeLayout(Q,Se){const Je=Se.outerWidth|0,xe=Se.outerHeight|0,ht=Se.lineHeight|0,$t=Se.lineNumbersDigitCount|0,Nt=Se.typicalHalfwidthCharacterWidth,qt=Se.maxDigitWidth,ri=Se.pixelRatio,Xt=Se.viewLineCount,di=Q.get(je.wordWrapOverride2),Ye=di==="inherit"?Q.get(je.wordWrapOverride1):di,Vt=Ye==="inherit"?Q.get(je.wordWrap):Ye,Gt=Q.get(je.wordWrapColumn),gt=Se.isDominatedByLongLines,Dt=Q.get(je.glyphMargin),Yt=Q.get(je.lineNumbers).renderType!==ze.Off,Zt=Q.get(je.lineNumbersMinChars),jt=Q.get(je.scrollBeyondLastLine),bt=Q.get(je.padding),Rt=Q.get(je.minimap),li=Q.get(je.scrollbar),Kt=li.verticalScrollbarSize,Xe=li.verticalHasArrows,xt=li.arrowSize,ui=li.horizontalScrollbarSize,fi=Q.get(je.folding),kt=Q.get(je.showFoldingControls)!=="never";let Mt=Q.get(je.lineDecorationsWidth);fi&&kt&&(Mt+=16);let At=0;if(Yt){const Ht=Math.max($t,Zt);At=Math.round(Ht*qt)}let Ft=0;Dt&&(Ft=ht*Se.glyphMarginDecorationLaneCount);let si=0,_t=si+Ft,ei=_t+At,Bt=ei+Mt;const Wt=Je-Ft-At-Mt;let hi=!1,Tt=!1,Ct=-1;Ye==="inherit"&&gt?(hi=!0,Tt=!0):Vt==="on"||Vt==="bounded"?Tt=!0:Vt==="wordWrapColumn"&&(Ct=Gt);const wt=oe.c({outerWidth:Je,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Nt,pixelRatio:ri,scrollBeyondLastLine:jt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Rt,verticalScrollbarWidth:Kt,viewLineCount:Xt,remainingWidth:Wt,isViewportWrapping:Tt},Se.memory||new D);wt.renderMinimap!==$e.None&&wt.minimapLeft===0&&(si+=wt.minimapWidth,_t+=wt.minimapWidth,ei+=wt.minimapWidth,Bt+=wt.minimapWidth);const Qt=Wt-wt.minimapWidth,yt=Math.max(1,Math.floor((Qt-Kt-2)/Nt)),oi=Xe?xt:0;return Tt&&(Ct=Math.max(1,yt),Vt==="bounded"&&(Ct=Math.min(Ct,Gt))),{width:Je,height:xe,glyphMarginLeft:si,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Se.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:At,decorationsLeft:ei,decorationsWidth:Mt,contentLeft:Bt,contentWidth:Qt,minimap:wt,viewportColumn:yt,isWordWrapMinified:hi,isViewportWrapping:Tt,wrappingColumn:Ct,verticalScrollbarWidth:Kt,horizontalScrollbarHeight:ui,overviewRuler:{top:oi,width:Kt,height:xe-2*oi,right:0}}}}e.EditorLayoutInfoComputer=oe;class Ce extends f{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(11660,null),a.localize(11661,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(11662,null)}})}validate(Q){return h(Q,"simple",["simple","advanced"])}compute(Q,Se,Je){return Se.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Je}}var Le;(function(ee){ee.Off="off",ee.OnCode="onCode",ee.On="on"})(Le||(e.ShowLightbulbIconMode=Le={}));class X extends f{constructor(){const Q={enabled:Le.On};super(je.lightbulb,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Le.Off,Le.OnCode,Le.On],default:Q.enabled,enumDescriptions:[a.localize(11663,null),a.localize(11664,null),a.localize(11665,null)],description:a.localize(11666,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:h(Q.enabled,this.defaultValue.enabled,[Le.Off,Le.OnCode,Le.On])}}}class q extends f{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:a.localize(11667,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:a.localize(11668,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:a.localize(11669,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:a.localize(11670,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Se.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Se.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends f{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:a.localize(11671,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(11672,null),a.localize(11673,null,I.$k?"Ctrl+Option":"Ctrl+Alt"),a.localize(11674,null,I.$k?"Ctrl+Option":"Ctrl+Alt"),a.localize(11675,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:a.localize(11676,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:a.localize(11677,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:a.localize(11678,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:h(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily),padding:i(Se.padding,this.defaultValue.padding)}}}class ve extends f{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):g.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Se,Je){return Je<0?g.clampedInt(-Je*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ae extends p{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>p.clamp(Q,0,150),{markdownDescription:a.localize(11679,null)})}compute(Q,Se,Je){return Q.fontInfo.lineHeight}}class be extends f{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:a.localize(11680,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:a.localize(11681,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(11682,null),a.localize(11683,null),a.localize(11684,null)],default:Q.size,description:a.localize(11685,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:a.localize(11686,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:a.localize(11687,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(11688,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:a.localize(11689,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:a.localize(11690,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Q.showRegionSectionHeaders,description:a.localize(11691,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Q.showMarkSectionHeaders,description:a.localize(11692,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Q.sectionHeaderFontSize,description:a.localize(11693,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:Q.sectionHeaderLetterSpacing,description:a.localize(11694,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),autohide:i(Se.autohide,this.defaultValue.autohide),size:h(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Se.side,this.defaultValue.side,["right","left"]),showSlider:h(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Se.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(Se.scale,1,1,3),maxColumn:g.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Se.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Se.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:p.clamp(Se.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:p.clamp(Se.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(ee){return ee==="ctrlCmd"?I.$k?"metaKey":"ctrlKey":"altKey"}class J extends f{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(11695,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(11696,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{top:g.clampedInt(Se.top,0,0,1e3),bottom:g.clampedInt(Se.bottom,0,0,1e3)}}}class x extends f{constructor(){const Q={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(11697,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:a.localize(11698,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),cycle:i(Se.cycle,this.defaultValue.cycle)}}}class me extends s{constructor(){super(je.pixelRatio)}compute(Q,Se,Je){return Q.pixelRatio}}class pe extends f{constructor(){super(je.placeholder,"placeholder",void 0)}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q:this.defaultValue}}class Ae extends f{constructor(){const Q={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(11699,null),a.localize(11700,null),a.localize(11701,null)]}];super(je.quickSuggestions,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:Q.strings,description:a.localize(11702,null)},comments:{anyOf:Se,default:Q.comments,description:a.localize(11703,null)},other:{anyOf:Se,default:Q.other,description:a.localize(11704,null)}},default:Q,markdownDescription:a.localize(11705,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ri=Q?"on":"off";return{comments:ri,strings:ri,other:ri}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Se,comments:Je,strings:xe}=Q,ht=["on","inline","off"];let $t,Nt,qt;return typeof Se=="boolean"?$t=Se?"on":"off":$t=h(Se,this.defaultValue.other,ht),typeof Je=="boolean"?Nt=Je?"on":"off":Nt=h(Je,this.defaultValue.comments,ht),typeof xe=="boolean"?qt=xe?"on":"off":qt=h(xe,this.defaultValue.strings,ht),{other:$t,comments:Nt,strings:qt}}}var ze;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class ke extends f{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(11706,null),a.localize(11707,null),a.localize(11708,null),a.localize(11709,null)],default:"on",description:a.localize(11710,null)})}validate(Q){let Se=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Se=ze.Custom,Je=Q):Q==="interval"?Se=ze.Interval:Q==="relative"?Se=ze.Relative:Q==="on"?Se=ze.On:Se=ze.Off),{renderType:Se,renderFn:Je}}}function Pe(ee){const Q=ee.get(je.renderValidationDecorations);return Q==="editable"?ee.get(je.readOnly):Q!=="on"}class Te extends f{constructor(){const Q=[],Se={type:"number",description:a.localize(11711,null)};super(je.rulers,"rulers",Q,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:a.localize(11712,null),format:"color-hex"}}}]},default:Q,description:a.localize(11713,null)})}validate(Q){if(Array.isArray(Q)){const Se=[];for(const Je of Q)if(typeof Je=="number")Se.push({column:g.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const xe=Je;Se.push({column:g.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Se.sort((Je,xe)=>Je.column-xe.column),Se}return this.defaultValue}}class U extends f{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function B(ee,Q){if(typeof ee!="string")return Q;switch(ee){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class K extends f{constructor(){const Q={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(11714,null),a.localize(11715,null),a.localize(11716,null)],default:"auto",description:a.localize(11717,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(11718,null),a.localize(11719,null),a.localize(11720,null)],default:"auto",description:a.localize(11721,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:a.localize(11722,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:a.localize(11723,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:a.localize(11724,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:a.localize(11725,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q,Je=g.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=g.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(Se.vertical,this.defaultValue.vertical),horizontal:B(Se.horizontal,this.defaultValue.horizontal),useShadows:i(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:g.clampedInt(Se.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:g.clampedInt(Se.verticalSliderSize,xe,0,1e3),scrollByPage:i(Se.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Se.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends f{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:a.localize(11726,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:a.localize(11727,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:a.localize(11728,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:a.localize(11729,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:a.localize(11730,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:a.localize(11731,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:a.localize(11732,null)}})}applyUpdate(Q,Se){let Je=!1;Se.allowedCharacters&&Q&&(P.$fo(Q.allowedCharacters,Se.allowedCharacters)||(Q={...Q,allowedCharacters:Se.allowedCharacters},Je=!0)),Se.allowedLocales&&Q&&(P.$fo(Q.allowedLocales,Se.allowedLocales)||(Q={...Q,allowedLocales:Se.allowedLocales},Je=!0));const xe=super.applyUpdate(Q,Se);return Je?new n(xe.newValue,!0):xe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{nonBasicASCII:Ke(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,Se){if(typeof Q!="object"||!Q)return Se;const Je={};for(const[xe,ht]of Object.entries(Q))ht===!0&&(Je[xe]=!0);return Je}}class ie extends f{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:a.localize(11733,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(11734,null),a.localize(11735,null),a.localize(11736,null)],description:a.localize(11737,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:a.localize(11738,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:a.localize(11739,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),mode:h(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Se.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Se.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class de extends f{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:a.localize(11740,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(11741,null),a.localize(11742,null),a.localize(11743,null)],description:a.localize(11744,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:a.localize(11745,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),showToolbar:h(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Se.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ie extends f{constructor(){const Q={enabled:T.$it.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$it.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(11746,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:a.localize(11747,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends f{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(11748,null),a.localize(11749,null),a.localize(11750,null)],default:Q.bracketPairs,description:a.localize(11751,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(11752,null),a.localize(11753,null),a.localize(11754,null)],default:Q.bracketPairsHorizontal,description:a.localize(11755,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:a.localize(11756,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:a.localize(11757,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(11758,null),a.localize(11759,null),a.localize(11760,null)],default:Q.highlightActiveIndentation,description:a.localize(11761,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{bracketPairs:Ke(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(ee,Q,Se){const Je=Se.indexOf(ee);return Je===-1?Q:Se[Je]}class _e extends f{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(11762,null),a.localize(11763,null)],default:Q.insertMode,description:a.localize(11764,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:a.localize(11765,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:a.localize(11766,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:a.localize(11767,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(11768,null),a.localize(11769,null),a.localize(11770,null),a.localize(11771,null)],default:Q.selectionMode,markdownDescription:a.localize(11772,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:a.localize(11773,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:a.localize(11774,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:a.localize(11775,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:a.localize(11776,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:a.localize(11777,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(11778,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(11779,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(11780,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(11781,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(11782,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(11783,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(11784,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(11785,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(11786,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(11787,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(11788,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(11789,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(11790,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(11791,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(11792,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(11793,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(11794,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(11795,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(11796,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(11797,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(11798,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(11799,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(11800,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(11801,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(11802,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(11803,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(11804,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(11805,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(11806,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(11807,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(11808,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(11809,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{insertMode:h(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Se.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Se.showIcons,this.defaultValue.showIcons),showStatusBar:i(Se.showStatusBar,this.defaultValue.showStatusBar),preview:i(Se.preview,this.defaultValue.preview),previewMode:h(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Se.showMethods,this.defaultValue.showMethods),showFunctions:i(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Se.showFields,this.defaultValue.showFields),showVariables:i(Se.showVariables,this.defaultValue.showVariables),showClasses:i(Se.showClasses,this.defaultValue.showClasses),showStructs:i(Se.showStructs,this.defaultValue.showStructs),showInterfaces:i(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Se.showModules,this.defaultValue.showModules),showProperties:i(Se.showProperties,this.defaultValue.showProperties),showEvents:i(Se.showEvents,this.defaultValue.showEvents),showOperators:i(Se.showOperators,this.defaultValue.showOperators),showUnits:i(Se.showUnits,this.defaultValue.showUnits),showValues:i(Se.showValues,this.defaultValue.showValues),showConstants:i(Se.showConstants,this.defaultValue.showConstants),showEnums:i(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Se.showKeywords,this.defaultValue.showKeywords),showWords:i(Se.showWords,this.defaultValue.showWords),showColors:i(Se.showColors,this.defaultValue.showColors),showFiles:i(Se.showFiles,this.defaultValue.showFiles),showReferences:i(Se.showReferences,this.defaultValue.showReferences),showFolders:i(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Se.showSnippets,this.defaultValue.showSnippets),showUsers:i(Se.showUsers,this.defaultValue.showUsers),showIssues:i(Se.showIssues,this.defaultValue.showIssues)}}}class tt extends f{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(11810,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(11811,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(Q.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends f{constructor(){const Q=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",Q,{anyOf:[{description:a.localize(11812,null),type:"string"},{description:a.localize(11813,null),type:"array",items:{type:"string"}}]})}validate(Q){if(typeof Q=="string"&&(Q=[Q]),Array.isArray(Q)){const Se=[];for(const Je of Q)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&Se.push(Je)}catch{}return Se}return this.defaultValue}}var et;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends f{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(11814,null),a.localize(11815,null),a.localize(11816,null),a.localize(11817,null)],description:a.localize(11818,null),default:"same"}})}validate(Q){switch(Q){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(Q,Se,Je){return Se.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?et.None:Je}}class mt extends s{constructor(){super(je.wrappingInfo)}compute(Q,Se,Je){const xe=Se.get(je.layoutInfo);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class lt extends f{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(11819,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(11820,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(11821,null),a.localize(11822,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),showDropSelector:h(Se.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends f{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(11823,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(11824,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(11825,null),a.localize(11826,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Se=Q;return{enabled:i(Se.enabled,this.defaultValue.enabled),showPasteSelector:h(Se.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",ft="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$k?ft:I.$l?pt:ct,fontWeight:"normal",fontSize:I.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function We(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var je;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.inlineEdit=63]="inlineEdit",ee[ee.letterSpacing=64]="letterSpacing",ee[ee.lightbulb=65]="lightbulb",ee[ee.lineDecorationsWidth=66]="lineDecorationsWidth",ee[ee.lineHeight=67]="lineHeight",ee[ee.lineNumbers=68]="lineNumbers",ee[ee.lineNumbersMinChars=69]="lineNumbersMinChars",ee[ee.linkedEditing=70]="linkedEditing",ee[ee.links=71]="links",ee[ee.matchBrackets=72]="matchBrackets",ee[ee.minimap=73]="minimap",ee[ee.mouseStyle=74]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=76]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=78]="multiCursorModifier",ee[ee.multiCursorPaste=79]="multiCursorPaste",ee[ee.multiCursorLimit=80]="multiCursorLimit",ee[ee.occurrencesHighlight=81]="occurrencesHighlight",ee[ee.overviewRulerBorder=82]="overviewRulerBorder",ee[ee.overviewRulerLanes=83]="overviewRulerLanes",ee[ee.padding=84]="padding",ee[ee.pasteAs=85]="pasteAs",ee[ee.parameterHints=86]="parameterHints",ee[ee.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ee[ee.placeholder=88]="placeholder",ee[ee.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=90]="quickSuggestions",ee[ee.quickSuggestionsDelay=91]="quickSuggestionsDelay",ee[ee.readOnly=92]="readOnly",ee[ee.readOnlyMessage=93]="readOnlyMessage",ee[ee.renameOnType=94]="renameOnType",ee[ee.renderControlCharacters=95]="renderControlCharacters",ee[ee.renderFinalNewline=96]="renderFinalNewline",ee[ee.renderLineHighlight=97]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=99]="renderValidationDecorations",ee[ee.renderWhitespace=100]="renderWhitespace",ee[ee.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ee[ee.roundedSelection=102]="roundedSelection",ee[ee.rulers=103]="rulers",ee[ee.scrollbar=104]="scrollbar",ee[ee.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=106]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=107]="scrollPredominantAxis",ee[ee.selectionClipboard=108]="selectionClipboard",ee[ee.selectionHighlight=109]="selectionHighlight",ee[ee.selectOnLineNumbers=110]="selectOnLineNumbers",ee[ee.showFoldingControls=111]="showFoldingControls",ee[ee.showUnused=112]="showUnused",ee[ee.snippetSuggestions=113]="snippetSuggestions",ee[ee.smartSelect=114]="smartSelect",ee[ee.smoothScrolling=115]="smoothScrolling",ee[ee.stickyScroll=116]="stickyScroll",ee[ee.stickyTabStops=117]="stickyTabStops",ee[ee.stopRenderingLineAfter=118]="stopRenderingLineAfter",ee[ee.suggest=119]="suggest",ee[ee.suggestFontSize=120]="suggestFontSize",ee[ee.suggestLineHeight=121]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ee[ee.suggestSelection=123]="suggestSelection",ee[ee.tabCompletion=124]="tabCompletion",ee[ee.tabIndex=125]="tabIndex",ee[ee.unicodeHighlighting=126]="unicodeHighlighting",ee[ee.unusualLineTerminators=127]="unusualLineTerminators",ee[ee.useShadowDOM=128]="useShadowDOM",ee[ee.useTabStops=129]="useTabStops",ee[ee.wordBreak=130]="wordBreak",ee[ee.wordSegmenterLocales=131]="wordSegmenterLocales",ee[ee.wordSeparators=132]="wordSeparators",ee[ee.wordWrap=133]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=136]="wordWrapColumn",ee[ee.wordWrapOverride1=137]="wordWrapOverride1",ee[ee.wordWrapOverride2=138]="wordWrapOverride2",ee[ee.wrappingIndent=139]="wrappingIndent",ee[ee.wrappingStrategy=140]="wrappingStrategy",ee[ee.showDeprecated=141]="showDeprecated",ee[ee.inlayHints=142]="inlayHints",ee[ee.editorClassName=143]="editorClassName",ee[ee.pixelRatio=144]="pixelRatio",ee[ee.tabFocusMode=145]="tabFocusMode",ee[ee.layoutInfo=146]="layoutInfo",ee[ee.wrappingInfo=147]="wrappingInfo",ee[ee.defaultColorDecorators=148]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new r(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(11827,null)})),acceptSuggestionOnEnter:We(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(11828,null),""],markdownDescription:a.localize(11829,null)})),accessibilitySupport:We(new k),accessibilityPageSize:We(new g(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(11830,null),tags:["accessibility"]})),ariaLabel:We(new m(je.ariaLabel,"ariaLabel",a.localize(11831,null))),ariaRequired:We(new r(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:We(new r(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(11832,null),tags:["accessibility"]})),autoClosingBrackets:We(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(11833,null),a.localize(11834,null),""],description:a.localize(11835,null)})),autoClosingComments:We(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(11836,null),a.localize(11837,null),""],description:a.localize(11838,null)})),autoClosingDelete:We(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(11839,null),""],description:a.localize(11840,null)})),autoClosingOvertype:We(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(11841,null),""],description:a.localize(11842,null)})),autoClosingQuotes:We(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(11843,null),a.localize(11844,null),""],description:a.localize(11845,null)})),autoIndent:We(new S(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[a.localize(11846,null),a.localize(11847,null),a.localize(11848,null),a.localize(11849,null),a.localize(11850,null)],description:a.localize(11851,null)})),automaticLayout:We(new r(je.automaticLayout,"automaticLayout",!1)),autoSurround:We(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(11852,null),a.localize(11853,null),a.localize(11854,null),""],description:a.localize(11855,null)})),bracketPairColorization:We(new Ie),bracketPairGuides:We(new Ue),stickyTabStops:We(new r(je.stickyTabStops,"stickyTabStops",!1,{description:a.localize(11856,null)})),codeLens:We(new r(je.codeLens,"codeLens",!0,{description:a.localize(11857,null)})),codeLensFontFamily:We(new m(je.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(11858,null)})),codeLensFontSize:We(new g(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(11859,null)})),colorDecorators:We(new r(je.colorDecorators,"colorDecorators",!0,{description:a.localize(11860,null)})),colorDecoratorActivatedOn:We(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(11861,null),a.localize(11862,null),a.localize(11863,null)],description:a.localize(11864,null)})),colorDecoratorsLimit:We(new g(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(11865,null)})),columnSelection:We(new r(je.columnSelection,"columnSelection",!1,{description:a.localize(11866,null)})),comments:We(new C),contextmenu:We(new r(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new r(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(11867,null)})),cursorBlinking:We(new S(je.cursorBlinking,"cursorBlinking",d.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:a.localize(11868,null)})),cursorSmoothCaretAnimation:We(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(11869,null),a.localize(11870,null),a.localize(11871,null)],description:a.localize(11872,null)})),cursorStyle:We(new S(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:a.localize(11873,null)})),cursorSurroundingLines:We(new g(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(11874,null)})),cursorSurroundingLinesStyle:We(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(11875,null),a.localize(11876,null)],markdownDescription:a.localize(11877,null)})),cursorWidth:We(new g(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(11878,null)})),disableLayerHinting:We(new r(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new r(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:We(new r(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:We(new r(je.dragAndDrop,"dragAndDrop",!0,{description:a.localize(11879,null)})),emptySelectionClipboard:We(new W),dropIntoEditor:We(new lt),stickyScroll:We(new q),experimentalWhitespaceRendering:We(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(11880,null),a.localize(11881,null),a.localize(11882,null)],description:a.localize(11883,null)})),extraEditorClassName:We(new m(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:We(new p(je.fastScrollSensitivity,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:a.localize(11884,null)})),find:We(new L),fixedOverflowWidgets:We(new r(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:We(new r(je.folding,"folding",!0,{description:a.localize(11885,null)})),foldingStrategy:We(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(11886,null),a.localize(11887,null)],description:a.localize(11888,null)})),foldingHighlight:We(new r(je.foldingHighlight,"foldingHighlight",!0,{description:a.localize(11889,null)})),foldingImportsByDefault:We(new r(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(11890,null)})),foldingMaximumRegions:We(new g(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(11891,null)})),unfoldOnClickAfterEndOfLine:We(new r(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(11892,null)})),fontFamily:We(new m(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(11893,null)})),fontInfo:We(new ge),fontLigatures2:We(new Y),fontSize:We(new _),fontWeight:We(new fe),fontVariations:We(new Z),formatOnPaste:We(new r(je.formatOnPaste,"formatOnPaste",!1,{description:a.localize(11894,null)})),formatOnType:We(new r(je.formatOnType,"formatOnType",!1,{description:a.localize(11895,null)})),glyphMargin:We(new r(je.glyphMargin,"glyphMargin",!0,{description:a.localize(11896,null)})),gotoLocation:We(new se),hideCursorInOverviewRuler:We(new r(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(11897,null)})),hover:We(new ce),inDiffEditor:We(new r(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:We(new p(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>p.clamp(ee,-5,20),{description:a.localize(11898,null)})),lightbulb:We(new X),lineDecorationsWidth:We(new ve),lineHeight:We(new ae),lineNumbers:We(new ke),lineNumbersMinChars:We(new g(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new r(je.linkedEditing,"linkedEditing",!1,{description:a.localize(11899,null)})),links:We(new r(je.links,"links",!0,{description:a.localize(11900,null)})),matchBrackets:We(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(11901,null)})),minimap:We(new be),mouseStyle:We(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new p(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:a.localize(11902,null)})),mouseWheelZoom:We(new r(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:I.$k?a.localize(11903,null):a.localize(11904,null)})),multiCursorMergeOverlapping:We(new r(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(11905,null)})),multiCursorModifier:We(new S(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[a.localize(11906,null),a.localize(11907,null)],markdownDescription:a.localize(11908,null)})),multiCursorPaste:We(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(11909,null),a.localize(11910,null)],markdownDescription:a.localize(11911,null)})),multiCursorLimit:We(new g(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(11912,null)})),occurrencesHighlight:We(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(11913,null),a.localize(11914,null),a.localize(11915,null)],markdownDescription:a.localize(11916,null)})),overviewRulerBorder:We(new r(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(11917,null)})),overviewRulerLanes:We(new g(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:We(new J),pasteAs:We(new st),parameterHints:We(new x),peekWidgetDefaultFocus:We(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(11918,null),a.localize(11919,null)],description:a.localize(11920,null)})),placeholder:We(new pe),definitionLinkOpensInPeek:We(new r(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(11921,null)})),quickSuggestions:We(new Ae),quickSuggestionsDelay:We(new g(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(11922,null)})),readOnly:We(new r(je.readOnly,"readOnly",!1)),readOnlyMessage:We(new U),renameOnType:We(new r(je.renameOnType,"renameOnType",!1,{description:a.localize(11923,null),markdownDeprecationMessage:a.localize(11924,null)})),renderControlCharacters:We(new r(je.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(11925,null),restricted:!0})),renderFinalNewline:We(new E(je.renderFinalNewline,"renderFinalNewline",I.$l?"dimmed":"on",["off","on","dimmed"],{description:a.localize(11926,null)})),renderLineHighlight:We(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(11927,null)],description:a.localize(11928,null)})),renderLineHighlightOnlyWhenFocus:We(new r(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(11929,null)})),renderValidationDecorations:We(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(11930,null),a.localize(11931,null),a.localize(11932,null),""],description:a.localize(11933,null)})),revealHorizontalRightPadding:We(new g(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:We(new r(je.roundedSelection,"roundedSelection",!0,{description:a.localize(11934,null)})),rulers:We(new Te),scrollbar:We(new K),scrollBeyondLastColumn:We(new g(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(11935,null)})),scrollBeyondLastLine:We(new r(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(11936,null)})),scrollPredominantAxis:We(new r(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(11937,null)})),selectionClipboard:We(new r(je.selectionClipboard,"selectionClipboard",!0,{description:a.localize(11938,null),included:I.$l})),selectionHighlight:We(new r(je.selectionHighlight,"selectionHighlight",!0,{description:a.localize(11939,null)})),selectOnLineNumbers:We(new r(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:We(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(11940,null),a.localize(11941,null),a.localize(11942,null)],description:a.localize(11943,null)})),showUnused:We(new r(je.showUnused,"showUnused",!0,{description:a.localize(11944,null)})),showDeprecated:We(new r(je.showDeprecated,"showDeprecated",!0,{description:a.localize(11945,null)})),inlayHints:We(new te),snippetSuggestions:We(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(11946,null),a.localize(11947,null),a.localize(11948,null),a.localize(11949,null)],description:a.localize(11950,null)})),smartSelect:We(new tt),smoothScrolling:We(new r(je.smoothScrolling,"smoothScrolling",!1,{description:a.localize(11951,null)})),stopRenderingLineAfter:We(new g(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:We(new _e),inlineSuggest:We(new ie),inlineEdit:We(new de),inlineCompletionsAccessibilityVerbose:We(new r(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(11952,null)})),suggestFontSize:We(new g(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(11953,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:We(new g(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(11954,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:We(new r(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(11955,null)})),suggestSelection:We(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(11956,null),a.localize(11957,null),a.localize(11958,null)],description:a.localize(11959,null)})),tabCompletion:We(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(11960,null),a.localize(11961,null),a.localize(11962,null)],description:a.localize(11963,null)})),tabIndex:We(new g(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:We(new G),unusualLineTerminators:We(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(11964,null),a.localize(11965,null),a.localize(11966,null)],description:a.localize(11967,null)})),useShadowDOM:We(new r(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:We(new r(je.useTabStops,"useTabStops",!0,{description:a.localize(11968,null)})),wordBreak:We(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(11969,null),a.localize(11970,null)],description:a.localize(11971,null)})),wordSegmenterLocales:We(new nt),wordSeparators:We(new m(je.wordSeparators,"wordSeparators",$.$jt,{description:a.localize(11972,null)})),wordWrap:We(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(11973,null),a.localize(11974,null),a.localize(11975,null),a.localize(11976,null)],description:a.localize(11977,null)})),wordWrapBreakAfterCharacters:We(new m(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new m(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new g(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(11978,null)})),wordWrapOverride1:We(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:We(new V),defaultColorDecorators:We(new r(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(11979,null)})),pixelRatio:We(new me),tabFocusMode:We(new r(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(11980,null)})),layoutInfo:We(new oe),wrappingInfo:We(new mt),wrappingIndent:We(new rt),wrappingStrategy:We(new Ce)}}),define(Oe[106],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,v.$Ci)("environmentService"),e.$Ki=(0,v.$Di)(e.$Ji)}),define(Oe[29],Ne([1,0,58,19,12,14,2,9,3,20,15,48]),function(we,e,v,P,I,O,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$Cl=e.FileKind=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.FileOperationResult=e.$ul=e.$tl=e.$sl=e.$ql=e.FileChangeType=e.$pl=e.FileOperation=e.$jl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$0k=void 0,e.$$k=c,e.$_k=o,e.$al=l,e.$bl=i,e.$cl=r,e.$dl=t,e.$el=g,e.$fl=u,e.$gl=p,e.$hl=m,e.$il=h,e.$kl=w,e.$ll=k,e.$ml=C,e.$nl=d,e.$ol=b,e.$rl=W,e.$Dl=fe,e.$El=se,e.$Gl=$e,e.$0k=(0,$.$Ci)("fileService");function c(oe){return oe.create===!0}var D;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(D||(e.FileType=D={}));var f;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var n;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function o(oe){const Ce=oe;return!!Ce&&typeof Ce.onDidChange=="function"}var s;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function l(oe){return!!(oe.capabilities&s.FileReadWrite)}function i(oe){return!!(oe.capabilities&s.FileFolderCopy)}function r(oe){return!!(oe.capabilities&s.FileClone)}function t(oe){return!!(oe.capabilities&s.FileOpenReadWriteClose)}function g(oe){return!!(oe.capabilities&s.FileReadStream)}function u(oe){return l(oe)?!!(oe.capabilities&s.FileAtomicRead):!1}function p(oe){return l(oe)?!!(oe.capabilities&s.FileAtomicWrite):!1}function m(oe){return!!(oe.capabilities&s.FileAtomicDelete)}function h(oe){return!!(oe.capabilities&s.Readonly)}var E;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class S extends Error{static create(Ce,Le){const X=new S(Ce.toString(),Le);return C(X,Le),X}constructor(Ce,Le){super(Ce),this.code=Le}}e.$jl=S;function w(oe,Ce){return S.create(oe,Ce)}function k(oe){return oe||w((0,T.localize)(11224,null),E.Unknown)}function C(oe,Ce){return oe.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",oe}function d(oe){if(!oe)return E.Unknown;if(oe instanceof S)return oe.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!Ce)return E.Unknown;switch(Ce[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function b(oe){if(oe instanceof L)return oe.fileOperationResult;switch(d(oe)){case E.FileNotFound:return ge.FILE_NOT_FOUND;case E.FileIsADirectory:return ge.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ge.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ge.FILE_WRITE_LOCKED;case E.NoPermissions:return ge.FILE_PERMISSION_DENIED;case E.FileExists:return ge.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ge.FILE_TOO_LARGE;default:return ge.FILE_OTHER_ERROR}}var F;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(Ce,Le,X){this.resource=Ce,this.operation=Le,this.target=X}isOperation(Ce){return this.operation===Ce}}e.$pl=N;var M;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class V{static{this.a=null}constructor(Ce,Le){this.c=Le,this.b=void 0,this.d=new y.$T(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawAdded.map(q=>[q,!0])),X}),this.f=new y.$T(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawUpdated.map(q=>[q,!0])),X}),this.g=new y.$T(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawDeleted.map(q=>[q,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Ce){switch(X.type){case M.ADDED:this.rawAdded.push(X.resource);break;case M.UPDATED:this.rawUpdated.push(X.resource);break;case M.DELETED:this.rawDeleted.push(X.resource);break}this.b!==V.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(Ce,...Le){return this.h(Ce,{includeChildren:!1},...Le)}affects(Ce,...Le){return this.h(Ce,{includeChildren:!0},...Le)}h(Ce,Le,...X){if(!Ce)return!1;const q=X.length>0;return!!((!q||X.includes(M.ADDED))&&(this.d.value.get(Ce)||Le.includeChildren&&this.d.value.findSuperstr(Ce))||(!q||X.includes(M.UPDATED))&&(this.f.value.get(Ce)||Le.includeChildren&&this.f.value.findSuperstr(Ce))||(!q||X.includes(M.DELETED))&&(this.g.value.findSubstr(Ce)||Le.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$ql=V;function W(oe,Ce,Le){return!oe||!Ce||oe===Ce||Ce.length>oe.length?!1:(Ce.charAt(Ce.length-1)!==P.sep&&(Ce+=P.sep),Le?(0,I.$Ef)(oe,Ce):oe.indexOf(Ce)===0)}class L extends Error{constructor(Ce,Le,X){super(Ce),this.fileOperationResult=Le,this.options=X}}e.$sl=L;class Y extends L{constructor(Ce,Le,X,q){super(Ce,Le,q),this.fileOperationResult=Le,this.size=X}}e.$tl=Y;class Z extends L{constructor(Ce,Le,X){super(Ce,ge.FILE_NOT_MODIFIED_SINCE,X),this.stat=Le}}e.$ul=Z;var ge;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(e.FileOperationResult=ge={})),e.$vl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xl="files.associations",e.$yl="files.exclude",e.$zl="files.readonlyInclude",e.$Al="files.readonlyExclude",e.$Bl="files.readonlyFromPermissions";var _;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.$Cl="";function fe(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function se(oe,Ce){if(!Ce.hasProvider(A.URI.from({scheme:oe.scheme})))return new Promise(Le=>{const X=Ce.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===oe.scheme&&q.added&&(X.dispose(),Le())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Ce){return(0,O.$gg)(Ce)||(Ce=0),Ce<ce.KB?(0,T.localize)(11225,null,Ce.toFixed(0)):Ce<ce.MB?(0,T.localize)(11226,null,(Ce/ce.KB).toFixed(2)):Ce<ce.GB?(0,T.localize)(11227,null,(Ce/ce.MB).toFixed(2)):Ce<ce.TB?(0,T.localize)(11228,null,(Ce/ce.GB).toFixed(2)):(0,T.localize)(11229,null,(Ce/ce.TB).toFixed(2))}}e.$Fl=ce;function $e(oe){const Ce=typeof oe=="string"||oe?.scheme===R.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===R.Schemas.file?1024*ce.MB:Ce?10*ce.MB:a.$p?50*ce.MB:1024*ce.MB}}),define(Oe[74],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class v{constructor(...I){this.a=new Map;for(const[O,A]of I)this.set(O,A)}set(I,O){const A=this.a.get(I);return this.a.set(I,O),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Ai=v}),define(Oe[169],Ne([1,0,10,13,4,73,166,3,74,170]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const R=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class c{constructor(o=new $.$Ai,s=!1,l,i=R){this.i=o,this.j=s,this.k=l,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Bi,this),this._globalGraph=i?l?._globalGraph??new A.$sr(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Oc)(this.h),this.h.clear();for(const o of this.g)(0,I.$Nc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,s){this.m();const l=this,i=new class extends c{dispose(){l.h.delete(i),super.dispose()}}(o,this.j,this,this.l);return this.h.add(i),s?.add(i),i}invokeFunction(o,...s){this.m();const l=f.traceInvocation(this.l,o);let i=!1;try{return o({get:t=>{if(i)throw(0,P.$7)("service accessor is only valid during the invocation of its target method");const g=this.s(t,l);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...s)}finally{i=!0,l.stop()}}createInstance(o,...s){this.m();let l,i;return o instanceof O.$zi?(l=f.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(s),l)):(l=f.traceCreation(this.l,o),i=this.o(o,s,l)),l.stop(),i}o(o,s=[],l){const i=T._util.getServiceDependencies(o).sort((g,u)=>g.index-u.index),r=[];for(const g of i){const u=this.s(g.id,l);u||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${g.id}.`,!1),r.push(u)}const t=i.length>0?i[0].index:s.length;if(s.length!==t){console.trace(`[createInstance] First service dependency of ${o.name} at position ${t+1} conflicts with ${s.length} static arguments`);const g=t-s.length;g>0?s=s.concat(new Array(g)):s=s.slice(0,t)}return Reflect.construct(o,s.concat(r))}q(o,s){if(this.i.get(o)instanceof O.$zi)this.i.set(o,s);else if(this.k)this.k.q(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const s=this.i.get(o);return!s&&this.k?this.k.r(o):s}s(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const l=this.r(o);return l instanceof O.$zi?this.u(o,l,s.branch(o,!0)):(s.branch(o,!1),l)}u(o,s,l){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,s,l)}finally{this.t.delete(o)}}v(o,s,l){const i=new A.$sr(u=>u.id.toString());let r=0;const t=[{id:o,desc:s,_trace:l}],g=new Set;for(;t.length;){const u=t.pop();if(!g.has(String(u.id))){if(g.add(String(u.id)),i.lookupOrInsertNode(u),r++>1e3)throw new y(i);for(const p of T._util.getServiceDependencies(u.desc.ctor)){const m=this.r(p.id);if(m||this.y(`[createInstance] ${o} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(u.id),String(p.id)),m instanceof O.$zi){const h={id:p.id,desc:m,_trace:u._trace.branch(p.id,!0)};i.insertEdge(u,h),t.push(h)}}}}for(;;){const u=i.roots();if(u.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:p}of u){if(this.r(p.id)instanceof O.$zi){const h=this.w(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.q(p.id,h)}i.removeNode(p)}}return this.r(o)}w(o,s,l=[],i,r){if(this.i.get(o)instanceof O.$zi)return this.x(o,s,l,i,r,this.g);if(this.k)return this.k.w(o,s,l,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(o,s,l=[],i,r,t){if(i){const g=new c(void 0,this.j,this,this.l);g.c=String(o);const u=new Map,p=new v.$Vh(()=>{const m=g.o(s,l,r);for(const[h,E]of u){const S=m[h];if(typeof S=="function")for(const w of E)w.disposable=S.apply(m,w.listener)}return u.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,h){if(!p.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let w=u.get(h);return w||(w=new a.$4c,u.set(h,w)),(C,d,b)=>{if(p.isInitialized)return p.value[h](C,d,b);{const F={listener:[C,d,b],disposable:void 0},N=w.push(F);return(0,I.$Rc)(()=>{N(),F.disposable?.dispose()})}}}if(h in m)return m[h];const E=p.value;let S=E[h];return typeof S!="function"||(S=S.bind(E),m[h]=S),S},set(m,h,E){return p.value[h]=E,!0},getPrototypeOf(m){return s.prototype}})}else{const g=this.o(s,l,r);return t.add(g),g}}y(o,s){if(s&&console.warn(o),this.j)throw new Error(o)}}e.$tr=c;var D;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(D||(D={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(D.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new f(D.Invocation,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,s){return o?new f(D.Creation,s.name):f.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const l=new f(D.Branch,o.toString());return this.h.push([o,s,l]),l}stop(){const o=Date.now()-this.g;f.f+=o;let s=!1;function l(r,t){const g=[],u=new Array(r+1).join("	");for(const[p,m,h]of t.h)if(m&&h){s=!0,g.push(`${u}CREATES -> ${p}`);const E=l(r+1,h);E&&g.push(E)}else g.push(`${u}uses -> ${p}`);return g.join(`
`)}const i=[`${this.type===D.Creation?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||s)&&f.all.add(i.join(`
`))}}e.$ur=f}),define(Oe[11],Ne([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$ak=e.LogLevel=e.$$j=e.$0j=void 0,e.$_j=n,e.log=s,e.$lk=S,e.$mk=w,e.$nk=k,e.$ok=C,v=qe(v),e.$0j=(0,D.$Ci)("logService"),e.$$j=(0,D.$Ci)("loggerService");function f(){return new Date().toISOString()}function n(d){return(0,R.$gg)(d)}var o;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$ak=o.Info;function s(d,b,F){switch(b){case o.Trace:d.trace(F);break;case o.Debug:d.debug(F);break;case o.Info:d.info(F);break;case o.Warning:d.warn(F);break;case o.Error:d.error(F);break;case o.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function l(d,b=!1){let F="";for(let N=0;N<d.length;N++){let M=d[N];if(M instanceof Error&&(M=(0,P.$nj)(M,b)),typeof M=="object")try{M=JSON.stringify(M)}catch{}F+=(N>0?" ":"")+M}return F}class i extends A.$Tc{constructor(){super(...arguments),this.b=e.$ak,this.c=this.B(new I.$je),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==o.Off&&this.b<=b}}e.$ck=i;class r extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...F){this.f(o.Trace)&&this.g(o.Trace,l([b,...F],!0))}debug(b,...F){this.f(o.Debug)&&this.g(o.Debug,l([b,...F]))}info(b,...F){this.f(o.Info)&&this.g(o.Info,l([b,...F]))}warn(b,...F){this.f(o.Warning)&&this.g(o.Warning,l([b,...F]))}error(b,...F){if(this.f(o.Error))if(b instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=b.stack,this.g(o.Error,l(N))}else this.g(o.Error,l([b,...F]))}flush(){}}e.$dk=r;class t extends i{constructor(b=e.$ak){super(),this.setLevel(b),this.g=!$.$j}trace(b,...F){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...F):console.log(`[main ${f()}]`,b,...F))}debug(b,...F){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...F):console.log(`[main ${f()}]`,b,...F))}info(b,...F){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...F):console.log(`[main ${f()}]`,b,...F))}warn(b,...F){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,b,...F):console.warn(`[main ${f()}]`,b,...F))}error(b,...F){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,b,...F):console.error(`[main ${f()}]`,b,...F))}flush(){}}e.$ek=t;class g extends i{constructor(b=e.$ak,F=!0){super(),this.g=F,this.setLevel(b)}trace(b,...F){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...F):console.log(b,...F))}debug(b,...F){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...F):console.log(b,...F))}info(b,...F){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...F):console.log(b,...F))}warn(b,...F){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...F):console.log(b,...F))}error(b,...F){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...F):console.error(b,...F))}flush(){}}e.$fk=g;class u extends i{constructor(b,F=e.$ak){super(),this.g=b,this.setLevel(F)}trace(b,...F){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(b),...F])}debug(b,...F){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(b),...F])}info(b,...F){this.f(o.Info)&&this.g.log(o.Info,[this.h(b),...F])}warn(b,...F){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(b),...F])}error(b,...F){this.f(o.Error)&&this.g.log(o.Error,[this.h(b),...F])}h(b){return typeof b=="string"?b:(0,P.$nj)(b,this.f(o.Trace))}flush(){}}e.$gk=u;class p extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const F of this.g)F.setLevel(b);super.setLevel(b)}trace(b,...F){for(const N of this.g)N.trace(b,...F)}debug(b,...F){for(const N of this.g)N.debug(b,...F)}info(b,...F){for(const N of this.g)N.info(b,...F)}warn(b,...F){for(const N of this.g)N.warn(b,...F)}error(b,...F){for(const N of this.g)N.error(b,...F)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$hk=p;class m extends A.$Tc{constructor(b,F,N){if(super(),this.h=b,this.j=F,this.b=new T.$zc,this.c=this.B(new I.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$je),this.onDidChangeVisibility=this.g.event,N)for(const M of N)this.b.set(M.resource,{logger:void 0,info:M})}m(b){return(0,R.$cg)(b)?[...this.b.values()].find(F=>F.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,F){const N=this.n(b),M=(0,R.$cg)(b)?b:F?.id??(0,O.$qj)(N.toString()).toString(16);let V=this.b.get(N)?.logger;const W=F?.logLevel==="always"?o.Trace:F?.logLevel;V||(V=this.s(N,W??this.getLogLevel(N)??this.h,{...F,id:M}));const L={logger:V,info:{resource:N,id:M,logLevel:W,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(L.info),this.b.set(N,L),V}n(b){return(0,R.$cg)(b)?(0,a.$dh)(this.j,`${b}.log`):b}setLogLevel(b,F){if(y.URI.isUri(b)){const N=b,M=F,V=this.b.get(N);V&&M!==V.info.logLevel&&(V.info.logLevel=M===this.h?void 0:M,V.logger?.setLevel(M),this.b.set(V.info.resource,V),this.f.fire([N,M]))}else{this.h=b;for(const[N,M]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,F){const N=this.m(b);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(b){let F;return b&&(F=this.b.get(b)?.info.logLevel),F??this.h}registerLogger(b){const F=this.b.get(b.resource);F?F.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const F=this.b.get(b);F&&(F.logger&&F.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ik=m;class h{constructor(){this.onDidChangeLogLevel=new I.$je().event}setLevel(b){}getLevel(){return o.Info}trace(b,...F){}debug(b,...F){}info(b,...F){}warn(b,...F){}error(b,...F){}critical(b,...F){}dispose(){}flush(){}}e.$jk=h;class E extends h{}e.$kk=E;function S(d){if(d.verbose)return o.Trace;if(typeof d.logLevel=="string"){const b=C(d.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ak}function w(d){switch(d){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function k(d){switch(d){case o.Trace:return{original:"Trace",value:v.localize(11157,null)};case o.Debug:return{original:"Debug",value:v.localize(11158,null)};case o.Info:return{original:"Info",value:v.localize(11159,null)};case o.Warning:return{original:"Warning",value:v.localize(11160,null)};case o.Error:return{original:"Error",value:v.localize(11161,null)};case o.Off:return{original:"Off",value:v.localize(11162,null)}}}function C(d){switch(d){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$pk=new c.$Tj("logLevel",w(o.Info))}),define(Oe[171],Ne([1,0,4,11]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=void 0;class I extends v.$Tc{constructor(A,T=[]){super(),this.a=new P.$hk([A,...T]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$tR=I});var ni=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Oe[107],Ne([1,0,35,9,3]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=ni(v);var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function a(f,n){return n-f}$.compare=a;const R=Object.create(null);R[$.Error]=(0,P.localize)(11154,null),R[$.Warning]=(0,P.localize)(11155,null),R[$.Info]=(0,P.localize)(11156,null);function y(f){return R[f]||""}$.toString=y;function c(f){switch(f){case v.default.Error:return $.Error;case v.default.Warning:return $.Warning;case v.default.Info:return $.Info;case v.default.Ignore:return $.Hint}}$.fromSeverity=c;function D(f){switch(f){case $.Error:return v.default.Error;case $.Warning:return v.default.Warning;case $.Info:return v.default.Info;case $.Hint:return v.default.Ignore}}$.toSeverity=D}(A||(e.MarkerSeverity=A={}));var T;(function($){const a="";function R(c){return y(c,!0)}$.makeKey=R;function y(c,D){const f=[a];return c.source?f.push(c.source.replace("\xA6","\\\xA6")):f.push(a),c.code?typeof c.code=="string"?f.push(c.code.replace("\xA6","\\\xA6")):f.push(c.code.value.replace("\xA6","\\\xA6")):f.push(a),c.severity!==void 0&&c.severity!==null?f.push(A.toString(c.severity)):f.push(a),c.message&&D?f.push(c.message.replace("\xA6","\\\xA6")):f.push(a),c.startLineNumber!==void 0&&c.startLineNumber!==null?f.push(c.startLineNumber.toString()):f.push(a),c.startColumn!==void 0&&c.startColumn!==null?f.push(c.startColumn.toString()):f.push(a),c.endLineNumber!==void 0&&c.endLineNumber!==null?f.push(c.endLineNumber.toString()):f.push(a),c.endColumn!==void 0&&c.endColumn!==null?f.push(c.endColumn.toString()):f.push(a),f.push(a),f.join("\xA6")}$.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Du=(0,I.$Ci)("markerService")});var ni=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Oe[172],Ne([1,0,6,35,3]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$qw=e.Severity=void 0,e.$rw=T,P=ni(P),e.Severity=P.default,e.$qw=(0,I.$Ci)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const c=y;return typeof c.id=="string"&&typeof c.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class a{constructor(){this.progress=new R,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(c){}updateMessage(c){}updateActions(c){}close(){}}e.$sw=a;class R{infinite(){}done(){}total(c){}worked(c){}}e.$tw=R}),define(Oe[108],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$qk=(0,v.$Ci)("productService"),e.$rk="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(we,e,v,P){var I=arguments.length,O=I<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,v):P,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(we,e,v,P);else for(var T=we.length-1;T>=0;T--)(A=we[T])&&(O=(I<3?A(O):I>3?A(e,v,O):A(e,v))||O);return I>3&&O&&Object.defineProperty(e,v,O),O},Ve=this&&this.__param||function(we,e){return function(v,P){e(v,P,we)}};define(Oe[76],Ne([1,0,10,21,4,3]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.ProgressLocation=e.$uw=void 0,e.$uw=(0,O.$Ci)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$vw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(c){this.b=c}report(c){this.a=c,this.b(this.a)}}e.$ww=T;class ${get value(){return this.a}constructor(c){this.e=c}report(c){this.b?this.b.push(c):this.b=[c],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const c=this.b.shift();this.a=c,await this.e(this.a)}}finally{this.c=!1;const c=this.d;this.d=void 0,c?.()}}drain(){return this.c?new Promise(c=>{const D=this.d;this.d=()=>{D?.(),c()}}):Promise.resolve()}}e.$xw=$;let a=class extends I.$Tc{constructor(c,D){super(),this.a=new v.$Zh,D.withProgress(c,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,I.$Rc)(()=>this.a.complete()))}report(c){this.b?this.b.report(c):this.c=c}};e.$yw=a,e.$yw=a=He([Ve(1,e.$uw)],a);class R extends I.$Tc{constructor(c){super(),this.g=c,this.a=0,this.b=this.B(new I.$Sc)}start(c){this.stop();const D=++this.a,f=new P.$ue;return this.f=setTimeout(()=>{D===this.a&&(this.c=this.g.show(!0))},c),this.b.add((0,I.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Rc)(()=>f.cancel())),this.b.add((0,I.$Rc)(()=>this.c?this.c.done():void 0)),{id:D,token:f.token,stop:()=>this.h(D),isCurrent:()=>this.a===D}}stop(){this.h(this.a)}h(c){this.a===c&&this.b.clear()}}e.$zw=R,e.$Aw=(0,O.$Ci)("editorProgressService")}),define(Oe[30],Ne([1,0,61,14]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,v=qe(v),P=qe(P);class I{constructor(){this.a=new Map}add(A,T){v.ok(P.$cg(A)),v.ok(P.$eg(T)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$oo=new I}),define(Oe[77],Ne([1,0,6,30]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,P=qe(P),e.$po={JSONContribution:"base.contributions.json"};function I(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class O{constructor(){this.b=new v.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,a){this.a[I($)]=a,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;P.$oo.add(e.$po.JSONContribution,A)}),define(Oe[53],Ne([1,0,17,6,14,9,43,77,30]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=n,e.$Fo=o,e.$Go=s,e.$Ho=i,e.$Io=r,e.$Jo=t,e.$Ko=g,I=qe(I),O=qe(O);var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$to={Configuration:"base.contributions.configuration"};var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const y=$.$oo.as(T.$po.JSONContribution);class c{constructor(){this.a=[],this.i=new Set,this.j=new P.$je,this.onDidSchemaChange=this.j.event,this.k=new P.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:O.localize(11449,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Ao,this.h),this.z()}registerConfiguration(p,m=!0){this.registerConfigurations([p],m)}registerConfigurations(p,m=!0){const h=new Set;this.r(p,m,h),y.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations(p){const m=new Set;this.s(p,m),y.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:m})}updateConfigurations({add:p,remove:m}){const h=new Set;this.s(m,h),this.r(p,!1,h),y.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations(p){const m=new Set;this.l(p,m),this.j.fire(),this.k.fire({properties:m,defaultsOverrides:!0})}l(p,m){this.a.push(...p);const h=[];for(const{overrides:E,source:S}of p)for(const w in E){m.add(w);const k=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),C=E[w];if(k.configurationDefaultOverrides.push({value:C,source:S}),e.$Do.test(w)){const d=this.o(w,C,S,k.configurationDefaultOverrideValue);if(!d)continue;k.configurationDefaultOverrideValue=d,this.n(w,d,S),h.push(...n(w))}else{const d=this.p(w,C,S,k.configurationDefaultOverrideValue);if(!d)continue;k.configurationDefaultOverrideValue=d;const b=this.e[w];b&&(this.A(w,b),this.w(w,b))}}this.q(h)}deregisterDefaultConfigurations(p){const m=new Set;this.m(p,m),this.j.fire(),this.k.fire({properties:m,defaultsOverrides:!0})}m(p,m){for(const h of p){const E=this.a.indexOf(h);E!==-1&&this.a.splice(E,1)}for(const{overrides:h,source:E}of p)for(const S in h){const w=this.b.get(S);if(!w)continue;const k=w.configurationDefaultOverrides.findIndex(C=>E?C.source?.id===E.id:C.value===h[S]);if(k!==-1){if(w.configurationDefaultOverrides.splice(k,1),w.configurationDefaultOverrides.length===0&&this.b.delete(S),e.$Do.test(S)){let C;for(const d of w.configurationDefaultOverrides)C=this.o(S,d.value,d.source,C);C&&!I.$pg(C.value)?(w.configurationDefaultOverrideValue=C,this.n(S,C,E)):(this.b.delete(S),delete this.e[S],delete this.c.properties[S])}else{let C;for(const b of w.configurationDefaultOverrides)C=this.p(S,b.value,b.source,C);w.configurationDefaultOverrideValue=C;const d=this.e[S];d&&(this.A(S,d),this.w(S,d))}m.add(S)}}this.y()}n(p,m,h){const E={type:"object",default:m.value,description:O.localize(11450,null,(0,A.$gj)(p)),$ref:e.$Ao,defaultDefaultValue:m.value,source:h,defaultValueSource:h};this.e[p]=E,this.c.properties[p]=E}o(p,m,h,E){const S=E?.value||{},w=E?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const k of Object.keys(m)){const C=m[k];if(I.$eg(C)&&(I.$jg(S[k])||I.$eg(S[k]))){if(S[k]={...S[k]??{},...C},h)for(const b in C)w.set(`${k}.${b}`,h)}else S[k]=C,h?w.set(k,h):w.delete(k)}return{value:S,source:w}}p(p,m,h,E){const S=this.e[p],w=E?.value??S?.defaultDefaultValue;let k=h;if(I.$eg(m)&&(S!==void 0&&S.type==="object"||S===void 0&&(I.$jg(w)||I.$eg(w)))){if(k=E?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const d in m)h&&k.set(`${p}.${d}`,h);m={...I.$eg(w)?w:{},...m}}return{value:m,source:k}}deltaConfiguration(p){let m=!1;const h=new Set;p.removedDefaults&&(this.m(p.removedDefaults,h),m=!0),p.addedDefaults&&(this.l(p.addedDefaults,h),m=!0),p.removedConfigurations&&this.s(p.removedConfigurations,h),p.addedConfigurations&&this.r(p.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...p){this.j.fire()}registerOverrideIdentifiers(p){this.q(p),this.j.fire()}q(p){for(const m of p)this.i.add(m);this.y()}r(p,m,h){p.forEach(E=>{this.u(E,m,E.extensionInfo,E.restrictedProperties,void 0,h),this.d.push(E),this.v(E)})}s(p,m){const h=E=>{if(E.properties)for(const S in E.properties){m.add(S);const w=this.e[S];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[S],this.x(S,E.properties[S])}E.allOf?.forEach(S=>h(S))};for(const E of p){h(E);const S=this.d.indexOf(E);S!==-1&&this.d.splice(S,1)}}u(p,m=!0,h,E,S=R.WINDOW,w){S=I.$lg(p.scope)?S:p.scope;const k=p.properties;if(k)for(const d in k){const b=k[d];if(m&&i(d,b)){delete k[d];continue}if(b.source=h,b.defaultDefaultValue=k[d].default,this.A(d,b),e.$Do.test(d)?b.scope=void 0:(b.scope=I.$lg(b.scope)?S:b.scope,b.restricted=I.$lg(b.restricted)?!!E?.includes(d):b.restricted),k[d].hasOwnProperty("included")&&!k[d].included){this.g[d]=k[d],delete k[d];continue}else this.e[d]=k[d],k[d].policy?.name&&this.f.set(k[d].policy.name,d);!k[d].deprecationMessage&&k[d].markdownDeprecationMessage&&(k[d].deprecationMessage=k[d].markdownDeprecationMessage),w.add(d)}const C=p.allOf;if(C)for(const d of C)this.u(d,m,h,E,S,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const p=new Map;for(const[m,h]of this.b)h.configurationDefaultOverrideValue&&p.set(m,h.configurationDefaultOverrideValue);return p}v(p){const m=h=>{const E=h.properties;if(E)for(const w in E)this.w(w,E[w]);h.allOf?.forEach(m)};m(p)}w(p,m){switch(e.$uo.properties[p]=m,m.scope){case R.APPLICATION:e.$vo.properties[p]=m;break;case R.MACHINE:e.$wo.properties[p]=m;break;case R.MACHINE_OVERRIDABLE:e.$xo.properties[p]=m;break;case R.WINDOW:e.$yo.properties[p]=m;break;case R.RESOURCE:e.$zo.properties[p]=m;break;case R.LANGUAGE_OVERRIDABLE:e.$zo.properties[p]=m,this.h.properties[p]=m;break}}x(p,m){switch(delete e.$uo.properties[p],m.scope){case R.APPLICATION:delete e.$vo.properties[p];break;case R.MACHINE:delete e.$wo.properties[p];break;case R.MACHINE_OVERRIDABLE:delete e.$xo.properties[p];break;case R.WINDOW:delete e.$yo.properties[p];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[p],delete this.h.properties[p];break}}y(){for(const p of this.i.values()){const m=`[${p}]`,h={type:"object",description:O.localize(11451,null),errorMessage:O.localize(11452,null),$ref:e.$Ao};this.A(m,h),e.$uo.properties[m]=h,e.$vo.properties[m]=h,e.$wo.properties[m]=h,e.$xo.properties[m]=h,e.$yo.properties[m]=h,e.$zo.properties[m]=h}}z(){const p={type:"object",description:O.localize(11453,null),errorMessage:O.localize(11454,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=p,e.$vo.patternProperties[e.$Co]=p,e.$wo.patternProperties[e.$Co]=p,e.$xo.patternProperties[e.$Co]=p,e.$yo.patternProperties[e.$Co]=p,e.$zo.patternProperties[e.$Co]=p,this.j.fire()}A(p,m){const h=this.b.get(p)?.configurationDefaultOverrideValue;let E,S;h&&(!m.disallowConfigurationDefault||!h.source)&&(E=h.value,S=h.source),I.$jg(E)&&(E=m.defaultDefaultValue,S=void 0),I.$jg(E)&&(E=s(m.type)),m.default=E,m.defaultValueSource=S}}const D="\\[([^\\]]+)\\]",f=new RegExp(D,"g");e.$Co=`^(${D})+$`,e.$Do=new RegExp(e.$Co);function n(u){const p=[];if(e.$Do.test(u)){let m=f.exec(u);for(;m?.length;){const h=m[1].trim();h&&p.push(h),m=f.exec(u)}}return(0,v.$Lb)(p)}function o(u){return u.reduce((p,m)=>`${p}[${m}]`,"")}function s(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new c;$.$oo.add(e.$to.Configuration,l);function i(u,p){return u.trim()?e.$Do.test(u)?O.localize(11456,null,u):l.getConfigurationProperties()[u]!==void 0?O.localize(11457,null,u):p.policy?.name&&l.getPolicyConfigurations().get(p.policy?.name)!==void 0?O.localize(11458,null,u,p.policy?.name,l.getPolicyConfigurations().get(p.policy?.name)):null:O.localize(11455,null)}function r(){const u=[],p=l.getConfigurationProperties();for(const m of Object.keys(p))u.push([m,p[m].scope]);return u.push(["launch",R.RESOURCE]),u.push(["task",R.RESOURCE]),u}function t(u){const p={};for(const m of u){const h=m.properties;if(I.$eg(h))for(const E in h)p[E]=h[E];m.allOf&&Object.assign(p,t(m.allOf))}return p}function g(u){switch(u){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(Oe[173],Ne([1,0,17,6,136,4,28,25,14,2,43,53,29,30]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=r,v=qe(v),I=qe(I),T=qe(T),$=qe($);function f(p){return Object.isFrozen(p)?p:T.$co(p)}class n{static createEmptyModel(m){return new n({},[],[],void 0,m)}constructor(m,h,E,S,w){this.b=m,this.c=h,this.d=E,this.raw=S,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const m=this.raw.map(h=>{if(h instanceof n)return h;const E=new o("",this.f);return E.parseRaw(h),E.configurationModel});this.g=m.reduce((h,E)=>E===h?E:h.merge(E),m[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(m){return m?(0,R.$ej)(this.contents,m):this.contents}inspect(m,h){const E=this;return{get value(){return f(E.rawConfiguration.getValue(m))},get override(){return h?f(E.rawConfiguration.getOverrideValue(m,h)):void 0},get merged(){return f(h?E.rawConfiguration.override(h).getValue(m):E.rawConfiguration.getValue(m))},get overrides(){const S=[];for(const{contents:w,identifiers:k,keys:C}of E.rawConfiguration.overrides){const d=new n(w,C,[],void 0,E.f).getValue(m);d!==void 0&&S.push({identifiers:k,value:d})}return S.length?f(S):void 0}}}getOverrideValue(m,h){const E=this.j(h);return E?m?(0,R.$ej)(E,m):E:void 0}getKeysForOverrideIdentifier(m){const h=[];for(const E of this.overrides)E.identifiers.includes(m)&&h.push(...E.keys);return v.$Lb(h)}getAllOverrideIdentifiers(){const m=[];for(const h of this.overrides)m.push(...h.identifiers);return v.$Lb(m)}override(m){let h=this.a.get(m);return h||(h=this.h(m),this.a.set(m,h)),h}merge(...m){const h=T.$bo(this.contents),E=T.$bo(this.overrides),S=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const k of m)if(w.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(h,k.contents);for(const C of k.overrides){const[d]=E.filter(b=>v.$tb(b.identifiers,C.identifiers));d?(this.i(d.contents,C.contents),d.keys.push(...C.keys),d.keys=v.$Lb(d.keys)):E.push(T.$bo(C))}for(const C of k.keys)S.indexOf(C)===-1&&S.push(C)}return new n(h,S,E,w.every(k=>k instanceof n)?void 0:w,this.f)}h(m){const h=this.j(m);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const E={};for(const S of v.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let w=this.contents[S];const k=h[S];k&&(typeof w=="object"&&typeof k=="object"?(w=T.$bo(w),this.i(w,k)):w=k),E[S]=w}return new n(E,this.keys,this.overrides,void 0,this.f)}i(m,h){for(const E of Object.keys(h)){if(E in m&&$.$eg(m[E])&&$.$eg(h[E])){this.i(m[E],h[E]);continue}m[E]=T.$bo(h[E])}}j(m){let h=null,E=null;const S=w=>{w&&(E?this.i(E,w):E=T.$bo(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===m?h=w.contents:w.identifiers.includes(m)&&S(w.contents);return S(h),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,h){this.k(m,h,!0)}setValue(m,h){this.k(m,h,!1)}removeValue(m){const h=this.keys.indexOf(m);h!==-1&&(this.keys.splice(h,1),(0,R.$dj)(this.contents,m),y.$Do.test(m)&&this.overrides.splice(this.overrides.findIndex(E=>v.$tb(E.identifiers,(0,y.$Eo)(m))),1))}k(m,h,E){if((0,R.$cj)(this.contents,m,h,S=>this.f.error(S)),E=E||this.keys.indexOf(m)===-1,E&&this.keys.push(m),y.$Do.test(m)){const S=(0,y.$Eo)(m),w={identifiers:S,keys:Object.keys(this.contents[m]),contents:(0,R.$bj)(this.contents[m],C=>this.f.error(C))},k=this.overrides.findIndex(C=>v.$tb(C.identifiers,S));k!==-1?this.overrides[k]=w:this.overrides.push(w)}}}e.$Lo=n;class o{constructor(m,h){this.f=m,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(m,h){if(!$.$lg(m)){const E=this.h(m);this.parseRaw(E,h)}}reparse(m){this.a&&this.parseRaw(this.a,m)}parseRaw(m,h){this.a=m;const{contents:E,keys:S,overrides:w,restricted:k,hasExcludedProperties:C}=this.i(m,h);this.b=new n(E,S,w,C?[m]:void 0,this.g),this.c=k||[]}h(m){let h={},E=null,S=[];const w=[],k=[];function C(b){Array.isArray(S)?S.push(b):E!==null&&(S[E]=b)}const d={onObjectBegin:()=>{const b={};C(b),w.push(S),S=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{S=w.pop()},onArrayBegin:()=>{const b=[];C(b),w.push(S),S=b,E=null},onArrayEnd:()=>{S=w.pop()},onLiteralValue:C,onError:(b,F,N)=>{k.push({error:b,offset:F,length:N})}};if(m)try{I.$3n(m,d),h=S[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return h}i(m,h){const E=D.$oo.as(y.$to.Configuration).getConfigurationProperties(),S=this.j(m,E,!0,h);m=S.raw;const w=(0,R.$bj)(m,d=>this.g.error(`Conflict in settings file ${this.f}: ${d}`)),k=Object.keys(m),C=this.l(m,d=>this.g.error(`Conflict in settings file ${this.f}: ${d}`));return{contents:w,keys:k,overrides:C,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(m,h,E,S){let w=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:w};const k={},C=[];for(const d in m)if(y.$Do.test(d)&&E){const b=this.j(m[d],h,!1,S);k[d]=b.raw,w=w||b.hasExcludedProperties,C.push(...b.restricted)}else{const b=h[d],F=b?typeof b.scope<"u"?b.scope:y.ConfigurationScope.WINDOW:void 0;b?.restricted&&C.push(d),!S.exclude?.includes(d)&&(S.include?.includes(d)||(F===void 0||S.scopes===void 0||S.scopes.includes(F))&&!(S.skipRestricted&&b?.restricted))?k[d]=m[d]:w=!0}return{raw:k,restricted:C,hasExcludedProperties:w}}l(m,h){const E=[];for(const S of Object.keys(m))if(y.$Do.test(S)){const w={};for(const k in m[S])w[k]=m[S][k];E.push({identifiers:(0,y.$Eo)(S),keys:Object.keys(w),contents:(0,R.$bj)(w,h)})}return E}}e.$Mo=o;class s extends O.$Tc{constructor(m,h,E,S,w){super(),this.c=m,this.f=h,this.g=S,this.h=w,this.b=this.B(new P.$je),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),w),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(c.FileOperation.CREATE)||k.isOperation(c.FileOperation.COPY)||k.isOperation(c.FileOperation.DELETE)||k.isOperation(c.FileOperation.WRITE))&&E.isEqual(k.resource,m)))(()=>this.b.fire()))}async loadConfiguration(){try{const m=await this.g.readFile(this.c);return this.a.parse(m.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(m){return m&&(this.f=m),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=s;class l{constructor(m,h,E,S,w,k,C,d,b,F,N,M,V){this.a=m,this.b=h,this.c=E,this.overrideIdentifiers=S,this.d=w,this.f=k,this.g=C,this.h=d,this.i=b,this.j=F,this.k=N,this.l=M,this.m=V}get value(){return f(this.c)}n(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(m,h,E,S,w,k,C,d,b,F){this.j=m,this.l=h,this.m=E,this.n=S,this.p=w,this.q=k,this.r=C,this.s=d,this.t=b,this.u=F,this.h=null,this.i=new A.$zc,this.v=null}getValue(m,h,E){return this.w(m,h,E).getValue(m)}updateValue(m,h,E={}){let S;E.resource?(S=this.t.get(E.resource),S||(S=n.createEmptyModel(this.u),this.t.set(E.resource,S))):S=this.s,h===void 0?S.removeValue(m):S.setValue(m,h),E.resource||(this.h=null)}inspect(m,h,E){const S=this.w(m,h,E),w=this.A(h.resource,E),k=h.resource?this.t.get(h.resource)||this.s:this.s,C=new Set;for(const d of S.overrides)for(const b of d.identifiers)S.getOverrideValue(m,b)!==void 0&&C.add(b);return new l(m,h,S.getValue(m),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,w||void 0,k)}keys(m){const h=this.A(void 0,m);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(m){this.j=m,this.h=null,this.i.clear()}updatePolicyConfiguration(m){this.l=m}updateApplicationConfiguration(m){this.m=m,this.h=null,this.i.clear()}updateLocalUserConfiguration(m){this.n=m,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(m){this.p=m,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(m){this.q=m,this.h=null,this.i.clear()}updateFolderConfiguration(m,h){this.r.set(m,h),this.i.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this.i.delete(m)}compareAndUpdateDefaultConfiguration(m,h){const E=[];if(!h){const{added:S,updated:w,removed:k}=g(this.j,m);h=[...S,...w,...k]}for(const S of h)for(const w of(0,y.$Eo)(S)){const k=this.j.getKeysForOverrideIdentifier(w),C=m.getKeysForOverrideIdentifier(w),d=[...C.filter(b=>k.indexOf(b)===-1),...k.filter(b=>C.indexOf(b)===-1),...k.filter(b=>!T.$fo(this.j.override(w).getValue(b),m.override(w).getValue(b)))];E.push([w,d])}return this.updateDefaultConfiguration(m),{keys:h,overrides:E}}compareAndUpdatePolicyConfiguration(m){const{added:h,updated:E,removed:S}=g(this.l,m),w=[...h,...E,...S];return w.length&&this.updatePolicyConfiguration(m),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:h,updated:E,removed:S,overrides:w}=g(this.applicationConfiguration,m),k=[...h,...E,...S];return k.length&&this.updateApplicationConfiguration(m),{keys:k,overrides:w}}compareAndUpdateLocalUserConfiguration(m){const{added:h,updated:E,removed:S,overrides:w}=g(this.localUserConfiguration,m),k=[...h,...E,...S];return k.length&&this.updateLocalUserConfiguration(m),{keys:k,overrides:w}}compareAndUpdateRemoteUserConfiguration(m){const{added:h,updated:E,removed:S,overrides:w}=g(this.remoteUserConfiguration,m),k=[...h,...E,...S];return k.length&&this.updateRemoteUserConfiguration(m),{keys:k,overrides:w}}compareAndUpdateWorkspaceConfiguration(m){const{added:h,updated:E,removed:S,overrides:w}=g(this.workspaceConfiguration,m),k=[...h,...E,...S];return k.length&&this.updateWorkspaceConfiguration(m),{keys:k,overrides:w}}compareAndUpdateFolderConfiguration(m,h){const E=this.folderConfigurations.get(m),{added:S,updated:w,removed:k,overrides:C}=g(E,h),d=[...S,...w,...k];return(d.length||!E)&&this.updateFolderConfiguration(m,h),{keys:d,overrides:C}}compareAndDeleteFolderConfiguration(m){const h=this.folderConfigurations.get(m);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:E,updated:S,removed:w,overrides:k}=g(h,void 0);return{keys:[...E,...S,...w],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(m,h,E){let S=this.x(h,E);return h.overrideIdentifier&&(S=S.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(m)!==void 0&&(S=S.merge(this.l)),S}x({resource:m},h){let E=this.y();if(h&&m){const S=h.getFolder(m);S&&(E=this.z(S.uri)||E);const w=this.t.get(m);w&&(E=E.merge(w))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(m){let h=this.i.get(m);if(!h){const E=this.y(),S=this.r.get(m);S?(h=E.merge(S),this.i.set(m,h)):h=E}return h}A(m,h){if(h&&m){const E=h.getFolder(m);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((m,h)=>{const{contents:E,overrides:S,keys:w}=this.r.get(h);return m.push([h,{contents:E,overrides:S,keys:w}]),m},[])}}allKeys(){const m=new Set;return this.j.keys.forEach(h=>m.add(h)),this.userConfiguration.keys.forEach(h=>m.add(h)),this.q.keys.forEach(h=>m.add(h)),this.r.forEach(h=>h.keys.forEach(E=>m.add(E))),[...m.values()]}B(){const m=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(E=>m.add(E))),[...m.values()]}D(m){const h=new Set;return this.j.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.q.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(m).forEach(S=>h.add(S))),[...h.values()]}static parse(m,h){const E=this.E(m.defaults,h),S=this.E(m.policy,h),w=this.E(m.application,h),k=this.E(m.user,h),C=this.E(m.workspace,h),d=m.folders.reduce((b,F)=>(b.set(a.URI.revive(F[0]),this.E(F[1],h)),b),new A.$zc);return new i(E,S,w,k,n.createEmptyModel(h),C,d,n.createEmptyModel(h),new A.$zc,h)}static E(m,h){return new n(m.contents,m.keys,m.overrides,void 0,h)}}e.$Oo=i;function r(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const m=new Set,h=new Map;for(const S of p)S.keys.forEach(w=>m.add(w)),S.overrides.forEach(([w,k])=>{const C=(0,A.$wc)(h,w,new Set);k.forEach(d=>C.add(d))});const E=[];return h.forEach((S,w)=>E.push([w,[...S.values()]])),{keys:[...m.values()],overrides:E}}class t{constructor(m,h,E,S,w){this.change=m,this.f=h,this.g=E,this.h=S,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of m.keys)this.affectedKeys.add(k);for(const[,k]of m.overrides)for(const C of k)this.affectedKeys.add(C);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(m,h){const E=this.a+m,S=this.d.indexOf(E);if(S<0)return!1;const w=S+E.length;if(w>=this.d.length)return!1;const k=this.d.charCodeAt(w);if(k!==this.b&&k!==this.c)return!1;if(h){const C=this.previousConfiguration?this.previousConfiguration.getValue(m,h,this.f?.workspace):void 0,d=this.g.getValue(m,h,this.h);return!T.$fo(C,d)}return!0}}e.$Qo=t;function g(p,m){const{added:h,removed:E,updated:S}=u(m?.rawConfiguration,p?.rawConfiguration),w=[],k=p?.getAllOverrideIdentifiers()||[],C=m?.getAllOverrideIdentifiers()||[];if(m){const d=C.filter(b=>!k.includes(b));for(const b of d)w.push([b,m.getKeysForOverrideIdentifier(b)])}if(p){const d=k.filter(b=>!C.includes(b));for(const b of d)w.push([b,p.getKeysForOverrideIdentifier(b)])}if(m&&p){for(const d of k)if(C.includes(d)){const b=u({contents:p.getOverrideValue(void 0,d)||{},keys:p.getKeysForOverrideIdentifier(d)},{contents:m.getOverrideValue(void 0,d)||{},keys:m.getKeysForOverrideIdentifier(d)});w.push([d,[...b.added,...b.removed,...b.updated]])}}return{added:h,removed:E,updated:S,overrides:w}}function u(p,m){const h=p?m?p.keys.filter(w=>m.keys.indexOf(w)===-1):[...p.keys]:[],E=m?p?m.keys.filter(w=>p.keys.indexOf(w)===-1):[...m.keys]:[],S=[];if(p&&m){for(const w of m.keys)if(p.keys.indexOf(w)!==-1){const k=(0,R.$ej)(m.contents,w),C=(0,R.$ej)(p.contents,w);T.$fo(k,C)||S.push(w)}}return{added:h,removed:E,updated:S}}}),define(Oe[109],Ne([1,0,13,3]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.RemoteAuthorityResolverErrorCode=e.$Ql=e.$Pl=e.RemoteConnectionType=e.$Ol=void 0,e.$Sl=a,e.$Ol=(0,P.$Ci)("remoteAuthorityResolverService");var I;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class O{constructor(y){this.id=y,this.type=I.Managed}toString(){return`Managed(${this.id})`}}e.$Pl=O;class A{constructor(y,c){this.host=y,this.port=c,this.type=I.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ql=A;var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class $ extends v.$ab{static isNotAvailable(y){return y instanceof $&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,c=T.Unknown,D){super(y),this._message=y,this._code=c,this._detail=D,this.isHandled=c===T.NotAvailable&&D===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Rl=$;function a(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}}),define(Oe[62],Ne([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=P,e.$fn=I,e.$gn=O,e.$hn=A;function P($){return $.scheme===v.Schemas.vscodeRemote?$.authority:void 0}function I($){if(!$)return;const a=$.indexOf("+");return a<0?$:$.substr(0,a)}function O($){const{host:a,port:R}=T($);if(typeof R>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:R}}function A($,a){let{host:R,port:y}=T($);return typeof y>"u"&&(y=a),{host:R,port:y}}function T($){const a=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const R=$.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(Oe[18],Ne([1,0,12,3,62]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$qn=e.$pn=e.$on=e.TargetPlatform=e.ExtensionType=e.$nn=e.$ln=e.$kn=e.$jn=e.$in=void 0,e.$mn=O,e.$rn=y,e.$sn=c,e.$tn=D,e.$un=f,e.$vn=n,e.$wn=o,v=qe(v),e.$in="extensions.user.cache",e.$jn="extensions.builtin.cache",e.$kn="undefined_publisher",e.$ln=["ui","workspace","web"];function O(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class ${constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,i){if(typeof l>"u"||l===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof l=="string"||typeof i=="string"){const r=typeof l=="string"?l:l.value,t=typeof i=="string"?i:i.value;return v.$Df(r,t)}return l._lower===i._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$on=$;class a{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const i of l)this.add(i)}add(l){this.c.add($.toKey(l))}delete(l){return this.c.delete($.toKey(l))}has(l){return this.c.has($.toKey(l))}}e.$pn=a;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete($.toKey(l))}get(l){return this.c.get($.toKey(l))}has(l){return this.c.has($.toKey(l))}set(l,i){this.c.set($.toKey(l),i)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qn=R;function y(s){return c(s)}function c(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function D(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function f(s,l){if(l){const i=`onResolveRemoteAuthority:${(0,I.$fn)(l)}`;return!!s.activationEvents?.includes(i)}return!1}function n(s){return s.map(l=>{const[i,r]=l.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function o(s){return s.map(l=>l.split("@")[0])}e.$xn=(0,P.$Ci)("IBuiltinExtensionsScannerService")}),define(Oe[110],Ne([1,0,20,9,18,3]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=T,e.$dp=$,e.$ep=a,e.$fp=R,e.$gp=y,e.$hp=c,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case I.TargetPlatform.WIN32_X64:return"Windows 64 bit";case I.TargetPlatform.WIN32_ARM64:return"Windows ARM";case I.TargetPlatform.LINUX_X64:return"Linux 64 bit";case I.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case I.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case I.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case I.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case I.TargetPlatform.DARWIN_X64:return"Mac";case I.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case I.TargetPlatform.WEB:return"Web";case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;case I.TargetPlatform.UNKNOWN:return I.TargetPlatform.UNKNOWN;case I.TargetPlatform.UNDEFINED:return I.TargetPlatform.UNDEFINED}}function $(t){switch(t){case I.TargetPlatform.WIN32_X64:return I.TargetPlatform.WIN32_X64;case I.TargetPlatform.WIN32_ARM64:return I.TargetPlatform.WIN32_ARM64;case I.TargetPlatform.LINUX_X64:return I.TargetPlatform.LINUX_X64;case I.TargetPlatform.LINUX_ARM64:return I.TargetPlatform.LINUX_ARM64;case I.TargetPlatform.LINUX_ARMHF:return I.TargetPlatform.LINUX_ARMHF;case I.TargetPlatform.ALPINE_X64:return I.TargetPlatform.ALPINE_X64;case I.TargetPlatform.ALPINE_ARM64:return I.TargetPlatform.ALPINE_ARM64;case I.TargetPlatform.DARWIN_X64:return I.TargetPlatform.DARWIN_X64;case I.TargetPlatform.DARWIN_ARM64:return I.TargetPlatform.DARWIN_ARM64;case I.TargetPlatform.WEB:return I.TargetPlatform.WEB;case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;default:return I.TargetPlatform.UNKNOWN}}function a(t,g){switch(t){case v.Platform.Windows:return g==="x64"?I.TargetPlatform.WIN32_X64:g==="arm64"?I.TargetPlatform.WIN32_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Linux:return g==="x64"?I.TargetPlatform.LINUX_X64:g==="arm64"?I.TargetPlatform.LINUX_ARM64:g==="arm"?I.TargetPlatform.LINUX_ARMHF:I.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?I.TargetPlatform.ALPINE_X64:g==="arm64"?I.TargetPlatform.ALPINE_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Mac:return g==="x64"?I.TargetPlatform.DARWIN_X64:g==="arm64"?I.TargetPlatform.DARWIN_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Web:return I.TargetPlatform.WEB}}function R(t,g){return g===I.TargetPlatform.WEB&&!t.includes(I.TargetPlatform.WEB)}function y(t,g,u){return R(g,u)?!1:t===I.TargetPlatform.UNDEFINED||t===I.TargetPlatform.UNIVERSAL?!0:t===I.TargetPlatform.UNKNOWN?!1:t===u}function c(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var D;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var o;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$ip=(0,O.$Ci)("extensionGalleryService");var s;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(s||(e.ExtensionGalleryErrorCode=s={}));class l extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$jp=l;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$kp=r,e.$lp=(0,O.$Ci)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,O.$Ci)("IGlobalExtensionEnablementService"),e.$pp=(0,O.$Ci)("IExtensionTipsService"),e.$qp=(0,P.localize2)(11339,"Extensions"),e.$rp=(0,P.localize2)(11340,"Preferences")}),define(Oe[111],Ne([1,0,13,18]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.$MG=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const $ of A){const a=this.readActivationEvents($);a.length>0&&(T[P.$on.toKey($.identifier)]=a)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<T.length;$++)T[$]==="onUri"&&(T[$]=`onUri:${P.$on.toKey(A.identifier)}`);if(!A.contributes)return T;for(const $ in A.contributes){const a=this.a.get($);if(!a)continue;const R=A.contributes[$],y=Array.isArray(R)?R:[R];try{a(y,T)}catch(c){(0,v.$Y)(c)}}return T}}e.$MG=I,e.$NG=new I});var ni=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Oe[174],Ne([1,0,23,35,9,280,18,104]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=R,e.$Xp=y,e.$Yp=c,e.$Zp=D,e.$1p=f,e.$2p=n,e.$3p=o,e.$4p=s,P=ni(P),I=qe(I),O=qe(O);const $=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function R(r){return r=r.trim(),r==="*"||$.test(r)}function y(r){if(!R(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match($);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function c(r){if(!r)return null;const t=r.majorBase,g=r.majorMustEqual,u=r.minorBase;let p=r.minorMustEqual;const m=r.patchBase;let h=r.patchMustEqual;r.hasCaret&&(t===0||(p=!1),h=!1);let E=0;if(r.preRelease){const S=a.exec(r.preRelease);if(S){const[,w,k,C]=S;E=Date.UTC(Number(w),Number(k)-1,Number(C))}}return{majorBase:t,majorMustEqual:g,minorBase:u,minorMustEqual:p,patchBase:m,patchMustEqual:h,isMinimum:r.hasGreaterEquals,notBefore:E}}function D(r,t,g){let u;typeof r=="string"?u=c(y(r)):u=r;let p;t instanceof Date?p=t.getTime():typeof t=="string"&&(p=new Date(t).getTime());let m;if(typeof g=="string"?m=c(y(g)):m=g,!u||!m)return!1;const h=u.majorBase,E=u.minorBase,S=u.patchBase;let w=m.majorBase,k=m.minorBase,C=m.patchBase;const d=m.notBefore;let b=m.majorMustEqual,F=m.minorMustEqual,N=m.patchMustEqual;return m.isMinimum?h>w?!0:h<w?!1:E>k?!0:E<k||p&&p<d?!1:S>=C:(h===1&&w===0&&(!b||!F||!N)&&(w=1,k=0,C=0,b=!0,F=!1,N=!1),h<w?!1:h>w?!b:E<k?!1:E>k?!F:S<C?!1:S>C?!N:!(p&&p<d))}function f(r,t,g,u,p,m){const h=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return h.push([P.default.Error,I.localize(11271,null)]),h;if(typeof u.name!="string")return h.push([P.default.Error,I.localize(11272,null,"name")]),h;if(typeof u.version!="string")return h.push([P.default.Error,I.localize(11273,null,"version")]),h;if(!u.engines)return h.push([P.default.Error,I.localize(11274,null,"engines")]),h;if(typeof u.engines.vscode!="string")return h.push([P.default.Error,I.localize(11275,null,"engines.vscode")]),h;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return h.push([P.default.Error,I.localize(11276,null,"extensionDependencies")]),h;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return h.push([P.default.Error,I.localize(11277,null,"activationEvents")]),h;if(typeof u.main>"u"&&typeof u.browser>"u")return h.push([P.default.Error,I.localize(11278,null,"activationEvents","main","browser")]),h}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&h.push([P.default.Warning,I.localize(11279,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return h.push([P.default.Error,I.localize(11280,null,"main")]),h;{const w=(0,v.$dh)(g,u.main);(0,v.$0g)(w,g)||h.push([P.default.Warning,I.localize(11281,null,w.path,g.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return h.push([P.default.Error,I.localize(11282,null,"browser")]),h;{const w=(0,v.$dh)(g,u.browser);(0,v.$0g)(w,g)||h.push([P.default.Warning,I.localize(11283,null,w.path,g.path)])}}if(!O.valid(u.version))return h.push([P.default.Error,I.localize(11284,null)]),h;const E=[];if(!n(r,t,u,p,E))for(const w of E)h.push([P.default.Error,w]);if(m&&u.enabledApiProposals?.length){const w=[];if(!s([...u.enabledApiProposals],w))for(const k of w)h.push([P.default.Error,k])}return h}function n(r,t,g,u,p){return u||typeof g.main>"u"&&typeof g.browser>"u"?!0:l(r,t,g.engines.vscode,p)}function o(r,t,g){return r==="*"||l(t,g,r)}function s(r,t){if(r.length===0)return!0;const g=Array.isArray(t)?t:void 0,u=(g?void 0:t)??T.allApiProposals,p=[],m=(0,A.$vn)(r);for(const{proposalName:h,version:E}of m){const S=u[h];S&&E&&S.version!==E&&p.push(I.localize(11285,null,h))}return g?.push(...p),p.length===0}function l(r,t,g,u=[]){const p=c(y(g));if(!p)return u.push(I.localize(11286,null,g)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return u.push(I.localize(11287,null,g)),!1}else if(!p.majorMustEqual)return u.push(I.localize(11288,null,g)),!1;return D(r,t,p)?!0:(u.push(I.localize(11289,null,r,g)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,g=r.length;t<g;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Oe[175],Ne([1,0,22,13,4,9,53,3,11,30]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=c,e.$8p=D,e.$9p=f,e.$0p=n,e.$$p=o,e.$_p=s,e.$5p=(0,T.$Ci)("requestService");class R{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const g in this.b)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.b[g];this.a=t}return this.a}}class y extends I.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(11058,null),when:$.$pk.isEqualTo((0,$.$mk)($.LogLevel.Trace)).serialize()})}async c(t,g,u){const p=`${t} #${++this.b}: ${g.url}`;this.a.trace(`${p} - begin`,g.type,new R(g.headers??{}));try{const m=await u();return this.a.trace(`${p} - end`,g.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${p} - error`,g.type,(0,P.$9)(m)),m}}}e.$6p=y;function c(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function D(r){return r.res.statusCode===204}async function f(r){return D(r)?null:(await(0,v.$Xe)(r.stream)).toString()}async function n(r){if(!c(r))throw new Error("Server returned "+r.res.statusCode);return f(r)}async function o(r){if(!c(r))throw new Error("Server returned "+r.res.statusCode);if(D(r))return null;const g=(await(0,v.$Xe)(r.stream)).toString();try{return JSON.parse(g)}catch(u){throw u.message+=`:
`+g,u}}function s(r){i(r)}let l;function i(r){const t=a.$oo.as(A.$to.Configuration),g=l;l={id:"http",order:15,title:(0,O.localize)(11059,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(11060,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(11061,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(11062,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(11063,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(11064,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(11065,null),(0,O.localize)(11066,null),(0,O.localize)(11067,null),(0,O.localize)(11068,null)],default:"override",description:(0,O.localize)(11069,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11070,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(11071,null),restricted:!0}}},t.updateConfigurations({add:[l],remove:g?[g]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Oe[176],Ne([1,0,20,78,37]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=A,e.$tp=T;function O($){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,a,R,y,c,D,f,n,o,s){const l=Object.create(null);l["common.machineId"]=D,l["common.sqmId"]=f,l["common.devDeviceId"]=n,l.sessionID=(0,I.$Yg)()+Date.now(),l.commitHash=y,l.version=c,l["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.$i)(v.$v),l["common.nodePlatform"]=P.$cc,l["common.nodeArch"]=R,l["common.product"]=s||"desktop",o&&(l["common.msftInternal"]=o);let i=0;const r=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(l["common.snap"]="true");const t=O(a);return t&&(l["common.platformDetail"]=t),l}function T($){const a=P.env.USERDNSDOMAIN;if(!a)return!1;const R=a.toLowerCase();return $.some(y=>R===y)}}),define(Oe[112],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=(0,v.$Ci)("telemetryService"),e.$0l=(0,v.$Ci)("customEndpointTelemetryService"),e.$$l="telemetry.currentSessionDate",e.$_l="telemetry.firstSessionDate",e.$am="telemetry.lastSessionDate",e.$bm="telemetry.machineId",e.$cm="telemetry.sqmId",e.$dm="telemetry.devDeviceId",e.$em="telemetry",e.$fm="telemetry.telemetryLevel",e.$gm="telemetry.enableCrashReporter",e.$hm="telemetry.enableTelemetry";var P;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var I;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Oe[63],Ne([1,0,25,14,62,176,112]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=R,e.$Cp=y,e.$Dp=c,e.$Ep=D,e.$Fp=n,e.$Gp=s,e.$Hp=l,e.$Ip=t;class T{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$up=T;class ${constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=$,e.$wp=new $;class a{async publicLog(u,p,m){}async publicLogError(u,p,m){}}e.$xp=a,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function R(g,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!g.enableTelemetry)}function y(g,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function c(g){const u=g.getValue(A.$fm),p=g.getValue(A.$gm);if(g.getValue(A.$hm)===!1||p===!1)return A.TelemetryLevel.NONE;switch(u??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function D(g){const u={},p={},m={};o(g,m);for(let h in m){h=h.length>150?h.substr(h.length-149):h;const E=m[h];typeof E=="number"?p[h]=E:typeof E=="boolean"?p[h]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${E.length}`),u[h]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(u[h]=E)}return{properties:u,measurements:p}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(g){if(!g)return"none";const u=(0,I.$fn)(g);return f.has(u)?u:"other"}function o(g,u,p=0,m){if(g)for(const h of Object.getOwnPropertyNames(g)){const E=g[h],S=m?m+h:h;Array.isArray(E)?u[S]=(0,v.$go)(E):E instanceof Date?u[S]=E.toISOString():(0,P.$eg)(E)?p<2?o(E,u,p+1,S+"."):u[S]=(0,v.$go)(E):u[S]=E}}function s(g,u){const p=g.msftInternalDomains||[],m=u.getValue("telemetry.internalTesting");return(0,O.$tp)(p)||m}function l(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,u){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let p=g;const m=[];for(const w of u)for(;;){const k=w.exec(g);if(!k)break;m.push([k.index,w.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(p="";;){const w=E.exec(g);if(!w)break;const k=m.some(([C,d])=>w.index<d&&C<E.lastIndex);!h.test(w[0])&&!k&&(p+=g.substring(S,w.index)+"<REDACTED: user-file-path>",S=E.lastIndex)}return S<g.length&&(p+=g.substr(S)),p}function r(g){if(!g)return g;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const p of u)if(p.regex.test(g))return`<REDACTED: ${p.label}>`;return g}function t(g,u){return(0,v.$do)(g,p=>{if(p instanceof T||Object.hasOwnProperty.call(p,"isTrustedTelemetryValue"))return p.value;if(typeof p=="string"){let m=p.replaceAll("%20"," ");m=i(m,u);for(const h of u)m=m.replace(h,"");return m=r(m),m}})}}),define(Oe[177],Ne([1,0,12,110,18,20,2,13,78,63]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=R,e.$Lp=f,e.$Mp=n,e.$Np=o,e.$Op=s,e.$Pp=l,e.$Qp=i,e.$Rp=r,e.$Tp=t,e.$Up=u;function R(p,m){return p.uuid&&m.uuid?p.uuid===m.uuid:p.id===m.id?!0:(0,v.$yf)(p.id,m.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(m){const h=m.manifest?m.manifest.version:m.version,E=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new c(m.identifier,h,E)}static parse(m){const h=y.exec(m);return h&&h[1]&&h[2]?new c({id:h[1]},h[2],h[4]||void 0):null}constructor(m,h,E=I.TargetPlatform.UNDEFINED){this.identifier=m,this.version=h,this.targetPlatform=E,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==I.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof c?R(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$Kp=c;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(p){const m=D.exec(p);return m&&m[1]?[o(m[1]),m[2]]:[o(p),void 0]}function n(p,m){return`${p}.${m}`}function o(p){return p.toLowerCase()}function s(p,m){return o(n(p??I.$kn,m))}function l(p,m){const h=[],E=S=>{for(const w of h)if(w.some(k=>R(m(k),m(S))))return w;return null};for(const S of p){const w=E(S);w?w.push(S):h.push([S])}return h}function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}function r(p){return{id:new a.$up(p.identifier.id),name:new a.$up(p.name),version:p.version,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),isSigned:p.isSigned,...p.telemetryData}}e.$Sp=new I.$on("pprice.better-merge");function t(p,m){const h=[],E=m.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const S=E.shift();if(S&&h.every(w=>!R(w.identifier,{id:S}))){const w=p.filter(k=>R(k.identifier,{id:S}));w.length===1&&(h.push(w[0]),E.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function g(p,m){if(!O.$l)return!1;let h;try{h=(await p.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await p.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){m.debug("Error while getting the os-release file.",(0,T.$9)(S))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(p,m){const h=await g(p,m),E=(0,P.$ep)(h?"alpine":O.$v,$.$dc);return m.debug("ComputeTargetPlatform:",E),E}}),define(Oe[178],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=v,e.$Ds=P,e.$Es=I,e.$Fs=O,e.$Gs=A,e.$Hs=T;function v($){return[...$.entries()]}function P($){return $?[...$.entries()]:[]}function I($){return new Map($)}function O($){return new Map($??[])}function A($){return Array.from($.entries()).map(a=>[a[0],v(a[1].map),P(a[1].descriptionMap)])}function T($){return new Map($.map(a=>[a[0],{map:I(a[1]),descriptionMap:O(a[2])}]))}}),define(Oe[179],Ne([1,0,3,31,30]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new P.$Tj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var R;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ms=(0,v.$Ci)("ptyService");var c;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(c||(e.HeartbeatConstants=c={}));var D;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(D||(e.TerminalLocation=D={}));var f;(function(t){t.TerminalView="view",t.Editor="editor"})(f||(e.TerminalLocationString=f={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var o;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var s;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var l;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(g){const u=this.b(g.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,g)}getTerminalBackend(g){return this.a.get(this.b(g))}b(g){return g?.toLowerCase()??""}}I.$oo.add(e.$ns.Backend,new r),e.$os=(0,v.$Ci)("localPtyService"),e.$ps=(0,v.$Ci)("terminalLogService")}),define(Oe[180],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xxb=void 0;class v{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,O,A=5){const T=O($=>{const a=typeof $=="string"?$:$.data;let R=this.a.get(I);if(R){R.data.push(a);return}const y=setTimeout(()=>this.flushBuffer(I),A);R={data:[a],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(I),T.dispose()}},this.a.set(I,R)});return T}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const O=this.a.get(I);O&&(this.a.delete(I),this.b(I,O.data.join("")))}}e.$xxb=v}),define(Oe[181],Ne([1,0,10,97,281,34,6,14,2,9,77,30]),function(we,e,v,P,I,O,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.IconFontDefinition=e.IconContribution=e.$xx=void 0,e.$yx=o,e.$zx=s,y=qe(y),e.$xx={IconContribution:"base.contributions.icons"};var c;(function(t){function g(u,p){let m=u.defaults;for(;O.ThemeIcon.isThemeIcon(m);){const h=n.getIcon(m.id);if(!h)return;m=h.defaults}return m}t.getDefinition=g})(c||(e.IconContribution=c={}));var D;(function(t){function g(p){return{weight:p.weight,style:p.style,src:p.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=g;function u(p){const m=h=>(0,T.$cg)(h)?h:void 0;if(p&&Array.isArray(p.src)&&p.src.every(h=>(0,T.$cg)(h.format)&&(0,T.$cg)(h.location)))return{weight:m(p.weight),style:m(p.style),src:p.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}t.fromJSONObject=u})(D||(e.IconFontDefinition=D={}));class f{constructor(){this.a=new A.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(10990,null)},fontCharacter:{type:"string",description:(0,a.localize)(10991,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,u,p,m){const h=this.b[g];if(h){if(p&&!h.description){h.description=p,this.d.properties[g].markdownDescription=`${p} $(${g})`;const w=this.e.enum.indexOf(g);w!==-1&&(this.e.enumDescriptions[w]=p),this.a.fire()}return h}const E={id:g,description:p,defaults:u,deprecationMessage:m};this.b[g]=E;const S={$ref:"#/definitions/icons"};return m&&(S.deprecationMessage=m),p&&(S.markdownDescription=`${p}: $(${g})`),this.d.properties[g]=S,this.e.enum.push(g),this.e.enumDescriptions.push(p||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const u=this.e.enum.indexOf(g);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,u){const p=this.f[g];return p||(this.f[g]=u,this.a.fire(),u)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(h,E)=>h.id.localeCompare(E.id),u=h=>{for(;O.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map(h=>this.b[h]);for(const h of m.filter(E=>!!E.description).sort(g))p.push(`|<i class="${u(h)}"></i>|${h.id}|${O.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const h of m.filter(E=>!O.ThemeIcon.isThemeIcon(E.defaults)).sort(g))p.push(`|<i class="${u(h)}"></i>|${h.id}|`);return p.join(`
`)}}const n=new f;y.$oo.add(e.$xx.IconContribution,n);function o(t,g,u,p){return n.registerIcon(t,g,u,p)}function s(){return n}function l(){const t=(0,I.$Xj)();for(const g in t){const u="\\"+t[g].toString(16);n.registerIcon(g,{fontCharacter:u})}}l(),e.$Ax="vscode://schemas/icons";const i=y.$oo.as(R.$po.JSONContribution);i.registerSchema(e.$Ax,n.getIconSchema());const r=new v.$Oh(()=>i.notifySchemaChanged(e.$Ax),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Bx=o("widget-close",P.$2j.close,(0,a.localize)(10992,null)),e.$Cx=o("goto-previous-location",P.$2j.arrowUp,(0,a.localize)(10993,null)),e.$Dx=o("goto-next-location",P.$2j.arrowDown,(0,a.localize)(10994,null)),e.$Ex=O.ThemeIcon.modify(P.$2j.sync,"spin"),e.$Fx=O.ThemeIcon.modify(P.$2j.loading,"spin")}),define(Oe[182],Ne([1,0,6,4,20,2,43,3,11]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=y,e.$Ew=D,e.$Fw=f,e.$Hw=n,e.$Jw=o,e.$Kw=s,e.$Bw=(0,T.$Ci)("tunnelService"),e.$Cw=(0,T.$Ci)("sharedTunnelsService");var a;(function(r){r.Http="http",r.Https="https"})(a||(e.TunnelProtocol=a={}));var R;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(R||(e.TunnelPrivacyId=R={}));function y(r){return!!r.forwardPort}var c;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function D(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function f(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const g of t){const u=g.split("=")[1];if(/^https?:/.exec(u)){const p=D(O.URI.parse(u));if(p)return p}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Gw.indexOf(r)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(r){return e.$Iw.indexOf(r)>=0}function s(r,t,g,u){if(g===I.OperatingSystem.Windows)return!1;if(g===I.OperatingSystem.Macintosh&&o(t)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(p?.length===4&&parseInt(p[1])>=18)return!1}return r<1024}class l{constructor(t,g,u){this.remoteAddress=t,this.localAddress=g,this.b=u,this.a=new v.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=l;let i=class extends P.$Tc{constructor(t,g){super(),this.r=t,this.s=g,this.a=new v.$je,this.onTunnelOpened=this.a.event,this.b=new v.$je,this.onTunnelClosed=this.b.event,this.c=new v.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],g=Array.from(this.f.values());for(const u of g){const p=Array.from(u.values());for(const m of p){const h=await m.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:g}of t.values())await g.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,g,u,p,m){this.z(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:u,privacy:p,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(o(t)||n(t))&&(t=e.$Gw[0]);const u=this.D(t,g);if(u)return++u.refcount,u.value}openTunnel(t,g,u,p,m,h=!1,E,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${u} on local port ${m}.`);const w=this.g??t;if(!w)return;if(g||(g="localhost"),p||(p=this.t),this.g&&this.n.has(u)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(w,g,u,p,m,h,E,S);return k?k.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(g,u),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(g,u);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.w(C);return(C.tunnelRemoteHost!==g||C.tunnelRemotePort!==u)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&C.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(d),d}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this.f.get(t.tunnelRemoteHost);if(g){const u=g.get(t.tunnelRemotePort);u&&(u.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async y(t,g,u){if(u.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const p=u.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(g),p}}async closeTunnel(t,g){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const u=this.f.get(t);if(u&&u.has(g)){const p=u.get(g);p.refcount=0,await this.y(t,g,p)}}z(t,g,u){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(g,{refcount:1,value:u})}async C(t,g){const u=this.f.get(t);if(u){const p=u.get(g),m=p?await p.value:void 0;(!m||typeof m=="string")&&u.delete(g),u.size===0&&this.f.delete(t)}}D(t,g){const u=[t];n(t)?(u.push(...e.$Gw),u.push(...e.$Iw)):o(t)&&u.push(...e.$Iw);const p=u.map(m=>this.f.get(m));for(const m of p){const h=m?.get(g);if(h)return h}}canTunnel(t){return!!D(t)}G(t,g,u,p,m,h,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${u} on local port ${p}.`);const S=u;this.n.add(S);const w=p===void 0?u:p,k={elevationRequired:m?this.isPortPrivileged(w):!1},C={remoteAddress:{host:g,port:u},localAddressPort:p,privacy:h,public:h?h!==R.Private:void 0,protocol:E},d=t.forwardPort(C,k);return d?(this.z(g,u,d),d.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),d}};e.$Mw=i,e.$Mw=i=He([Ve(0,$.$0j),Ve(1,A.$9i)],i)}),define(Oe[183],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0,e.$Hl=(0,v.$Ci)("IUriIdentityService")}),define(Oe[184],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nw=void 0,e.$Nw=(0,v.$Ci)("editSessionIdentityService");var P;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(P||(e.EditSessionIdentityMatch=P={}))}),define(Oe[185],Ne([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=P,e.$6M=I,e.$7M=O,e.$8M=A,e.$9M=T;function P($){return $.scheme!==v.Schemas.file&&$.scheme!==v.Schemas.vscodeRemote}function I($){if($.folders.length)return $.folders.every(a=>P(a.uri))?$.folders[0].uri:void 0;if($.configuration&&P($.configuration))return $.configuration}function O($){return I($)?.scheme}function A($){return I($)?.authority}function T($){return I($)!==void 0}}),define(Oe[49],Ne([1,0,9,19,58,23,2,3,15]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=a,e.$Ni=R,e.$Qi=y,e.$Ri=c,e.$Si=D,e.$Ti=n,e.$Ui=o,e.$Xi=i,e.$3i=r,e.$4i=t,e.$6i=g,e.$7i=u,e.$8i=p,e.$Li=(0,T.$Ci)("contextService");function a(m){const h=m;return typeof h?.id=="string"&&A.URI.isUri(h.uri)}function R(m){return typeof m?.id=="string"&&!a(m)&&!c(m)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function y(m,h){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,P.$mc)(m)}:h?e.$Oi:e.$Pi;const E=m;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function c(m){const h=m;return typeof h?.id=="string"&&A.URI.isUri(h.configPath)}function D(m){const h=m;if(h?.uri)return{id:h.id,uri:A.URI.revive(h.uri)};const E=m;if(E?.configPath)return{id:E.id,configPath:A.URI.revive(E.configPath)};if(m?.id)return{id:m.id}}var f;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function n(m){const h=m;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function o(m){const h=m;return!!(h&&typeof h=="object"&&A.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class s{constructor(h,E,S,w,k){this.h=h,this.j=S,this.k=w,this.l=k,this.c=I.$Ii.forUris(this.l,()=>!0),this.folders=E}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=I.$Ii.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=s;class l{constructor(h,E){this.raw=E,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,O.$dh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=l;function i(m){return new l({uri:m,index:0,name:(0,O.$_g)(m)},{uri:m.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,v.localize)(10869,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function r(m,h){return O.$7g.isEqualOrParent(m,h.untitledWorkspacesHome)}function t(m){let h;return A.URI.isUri(m)?h=m:h=m.configuration,h?.scheme===$.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(m){return m.id===e.$5i}function u(m,h){return!r(m,h)&&!t(m)}function p(m){return(typeof m=="string"?(0,P.$nc)(m):(0,O.$bh)(m))===e.$Zi}}),define(Oe[113],Ne([1,0,75,6,4,23,2,9,106,29,3,11,49,28,183,10,37,12,14]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Jl=e.ProfileResourceType=void 0,e.$Il=r,e.$Kl=t,e.$Ll=g;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(m){const h=m;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&A.URI.isUri(h.location)&&A.URI.isUri(h.globalStorageHome)&&A.URI.isUri(h.settingsResource)&&A.URI.isUri(h.keybindingsResource)&&A.URI.isUri(h.tasksResource)&&A.URI.isUri(h.snippetsHome)&&A.URI.isUri(h.extensionsResource))}e.$Jl=(0,R.$Ci)("IUserDataProfilesService");function t(m,h){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:h}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:h}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:h}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:h}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:h}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:h}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:h}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:h}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function g(m,h,E,S,w,k){return{id:m,name:h,location:E,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:k&&w?.useDefaultFlags?.globalState?k.globalStorageHome:(0,O.$dh)(E,"globalStorage"),settingsResource:k&&w?.useDefaultFlags?.settings?k.settingsResource:(0,O.$dh)(E,"settings.json"),keybindingsResource:k&&w?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,O.$dh)(E,"keybindings.json"),tasksResource:k&&w?.useDefaultFlags?.tasks?k.tasksResource:(0,O.$dh)(E,"tasks.json"),snippetsHome:k&&w?.useDefaultFlags?.snippets?k.snippetsHome:(0,O.$dh)(E,"snippets"),extensionsResource:k&&w?.useDefaultFlags?.extensions?k.extensionsResource:(0,O.$dh)(E,"extensions.json"),cacheHome:(0,O.$dh)(S,m),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let u=class extends I.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,E,S,w){super(),this.t=h,this.u=E,this.w=S,this.y=w,this.f=!0,this.h=this.B(new P.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new D.$zc,workspaces:new D.$zc,emptyWindows:new Map},this.profilesHome=(0,O.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),E=[h];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,l.$cg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(g((0,O.$ah)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},h))}}catch(k){this.y.error(k)}const S=new D.$zc,w=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[C,d]of Object.entries(k.workspaces)){const b=A.URI.parse(C),F=E.find(N=>N.id===d);F&&S.set(b,F)}if(k.emptyWindows)for(const[C,d]of Object.entries(k.emptyWindows)){const b=E.find(F=>F.id===d);b&&w.set(C,b)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:S,emptyWindows:w}}return this.z}D(){const h=g("__default__profile__",(0,T.localize)(10916,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const E="Temp",S=new RegExp(`${(0,s.$ff)(E)}\\s(\\d+)`);let w=0;for(const C of this.profiles){const d=S.exec(C.name),b=d?parseInt(d[1]):0;w=b>w?b:w}const k=`${E} ${w+1}`;return this.createProfile((0,v.$qj)((0,o.$Yg)()).toString(16),k,{transient:!0},h)}async createNamedProfile(h,E,S){return this.createProfile((0,v.$qj)((0,o.$Yg)()).toString(16),h,E,S)}async createProfile(h,E,S,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(h,E,S);return w&&await this.setProfileForWorkspace(w,k),k}async F(h,E,S){if(!(0,l.$cg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(E);return w||(w=(async()=>{try{if(this.profiles.find(b=>b.name===E||b.id===h))throw new Error(`Profile with ${E} name already exists`);const C=g(h,E,(0,O.$dh)(this.profilesHome,h),this.g,S,this.defaultProfile);await this.u.createFolder(C.location);const d=[];return this.j.fire({profile:C,join(b){d.push(b)}}),await n.Promises.settled(d),this.I([C],[],[]),C}finally{this.r.delete(E)}})(),this.r.set(E,w)),w}async updateProfile(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(w=>w.id===h.id);if(!S)throw new Error(`Profile '${h.name}' does not exist`);return S=g(S.id,E.name??S.name,S.location,this.g,{shortName:E.shortName??S.shortName,icon:E.icon===null?void 0:E.icon??S.icon,transient:E.transient??S.isTransient,useDefaultFlags:E.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(w=>w.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);const S=[];this.m.fire({profile:E,join(w){S.push(w)}});try{await Promise.allSettled(S)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(w){(0,a.$ol)(w)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(w=>w.id===E.id);if(!S)throw new Error(`Profile '${E.name}' does not exist`);this.L(h,S)}unsetWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(E=>E.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(h.map(E=>this.removeProfile(E)))}getProfileForWorkspace(h){const E=this.G(h),S=A.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return S||((0,c.$Mi)(h)?this.s.folders.get(h.uri):(0,c.$Ri)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,c.$Mi)(h)?h.uri:(0,c.$Ri)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,h.location)))}I(h,E,S){const w=[...this.profiles,...h],k=[],C=this.s.profiles;this.s.profiles=[];for(let d of w){if(d.isDefault||E.some(F=>d.id===F.id))continue;d=S.find(F=>d.id===F.id)??d;const b=C.find(F=>d.id===F.id);if(d.isTransient)this.s.profiles.push(d);else{if(b){for(const[F,N]of this.s.emptyWindows.entries())if(d.id===N.id){this.L({id:F},d);break}for(const[F,N]of this.s.workspaces.entries())if(d.id===N.id){this.L({id:"",configPath:F},d);break}for(const[F,N]of this.s.folders.entries())if(d.id===N.id){this.L({id:"",uri:F},d);break}}k.push({location:d.location,name:d.name,shortName:d.shortName,icon:d.icon,useDefaultFlags:d.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(h,E,S)}J(h,E,S){this.h.fire({added:h,removed:E,updated:S,all:this.profiles})}L(h,E,S){if(S=E?.isTransient?!0:S,S)(0,c.$Mi)(h)?(this.s.folders.delete(h.uri),E&&this.s.folders.set(h.uri,E)):(0,c.$Ri)(h)?(this.s.workspaces.delete(h.configPath),E&&this.s.workspaces.set(h.configPath,E)):(this.s.emptyWindows.delete(h.id),E&&this.s.emptyWindows.set(h.id,E));else{this.L(h,void 0,!0);const w=this.G(h);A.URI.isUri(w)?(this.C.workspaces.delete(w),E&&this.C.workspaces.set(w,E)):(this.C.emptyWindows.delete(w),E&&this.C.emptyWindows.set(w,E)),this.M()}}M(){const h={};for(const[S,w]of this.C.workspaces.entries())h[S.toString()]=w.id;const E={};for(const[S,w]of this.C.emptyWindows.entries())E[S.toString()]=w.id;this.R({workspaces:h,emptyWindows:E}),this.z=void 0}N(h){const E={},S=this.D();if(h.workspaces)for(const[k,C]of Object.entries(h.workspaces)){const d=A.URI.parse(C);E[k]=this.w.extUri.isEqual(d,S.location)?S.id:this.w.extUri.basename(d)}const w={};if(h.emptyWindows)for(const[k,C]of Object.entries(h.emptyWindows)){const d=A.URI.parse(C);w[k]=this.w.extUri.isEqual(d,S.location)?S.id:this.w.extUri.basename(d)}return{workspaces:E,emptyWindows:w}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Ml=u,e.$Ml=u=He([Ve(0,$.$Ji),Ve(1,a.$0k),Ve(2,f.$Hl),Ve(3,y.$0j)],u);class p extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Nl=p}),define(Oe[186],Ne([1,0,10,6,4,64,14,151,3,113]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=D,e.$iq=n,e.$kq=s,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,$.$Ci)("storageService");var R;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var y;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var c;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(c||(e.StorageTarget=c={}));function D(l){const i=l.get(e.$eq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class f extends I.$Tc{static{this.a=60*1e3}constructor(i={flushInterval:f.a}){super(),this.m=i,this.b=this.B(new P.$me),this.c=this.B(new P.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$je),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return P.Event.filter(this.b.event,g=>g.scope===i&&(r===void 0||g.key===r),t)}n(){this.j.value=(0,v.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:g}=r;if(t===e.$eq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:g})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,g,u=!1){if((0,A.$lg)(r)){this.remove(i,t,u);return}this.y(()=>{this.z(i,t,g),this.P(t)?.set(i,r,u)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],g=this.J(i);for(const u of Object.keys(g))g[u]===r&&t.push(u);return t}z(i,r,t,g=!1){const u=this.J(r);typeof t=="number"?u[i]!==t&&(u[i]=t,this.P(r)?.set(e.$eq,JSON.stringify(u),g)):typeof u[i]=="number"&&(delete u[i],this.P(r)?.set(e.$eq,JSON.stringify(u),g))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?D(r):Object.create(null)}isNew(i){return this.getBoolean(e.$dq,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const r=this.P(y.APPLICATION),t=this.P(y.PROFILE),g=this.P(y.WORKSPACE);switch(i){case R.NONE:await v.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await v.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,r=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return s(i,r,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(R.NONE),(0,a.$Il)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const g=new Set;for(const[u,p]of i)g.add(u),r.get(u)!==p&&this.u(t,{key:u,external:!0});for(const[u]of r.items)g.has(u)||this.u(t,{key:u,external:!0})})}}e.$hq=f;function n(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class o extends f{constructor(){super(),this.U=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$jq=o;async function s(l,i,r,t,g,u){const p=b=>{try{return JSON.parse(b)}catch{return b}},m=new Map,h=new Map;l.forEach((b,F)=>{m.set(F,b),h.set(F,p(b))});const E=new Map,S=new Map;i.forEach((b,F)=>{E.set(F,b),S.set(F,p(b))});const w=new Map,k=new Map;r.forEach((b,F)=>{w.set(F,b),k.set(F,p(b))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const C=[];if(m.forEach((b,F)=>{C.push({key:F,value:b})}),console.table(C),console.groupEnd(),console.log(h),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const b=[];E.forEach((F,N)=>{b.push({key:N,value:F})}),console.table(b),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${u})`);const d=[];w.forEach((b,F)=>{d.push({key:F,value:b})}),console.table(d),console.groupEnd(),console.log(k)}}),define(Oe[79],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;class v{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const O=this.c++;return this.b.set(O,I),this.e(),O}get(I,O){return this.b.has(I)?this.b.get(I)[O]:void 0}delete(I){this.b.delete(I),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$qoc=v}),define(Oe[50],Ne([1,0,15,23,29,3]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=e.$voc=void 0;class A{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new P.$5g($=>{const a=this.b.get($.scheme);return!(a===void 0||a&I.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,a){a===null?this.b.delete($.scheme):this.b.set($.scheme,a)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$voc=A,e.$woc=(0,O.$Ci)("IExtHostFileSystemInfo")}),define(Oe[26],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=void 0,e.$jQ=(0,v.$Ci)("IExtHostInitDataService")}),define(Oe[187],Ne([1,0,9,11,171,26]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=void 0;let A=class extends I.$tR{constructor($,a,R){const y=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",c=R.remote.isRemote?(0,v.localize)(10669,null):$?(0,v.localize)(10670,null):(0,v.localize)(10671,null);super(a.createLogger(y,{name:c}))}};e.$Eqc=A,e.$Eqc=A=He([Ve(1,P.$$j),Ve(2,O.$jQ)],A)}),define(Oe[188],Ne([1,0,10]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=e.$bpc=void 0;class P{constructor(A,T,$){this.h=new Map,this.a=A,this.b=T,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new v.$Oh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of a.values())R.complete()}catch(R){for(const y of a.values())y.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let $=this.f[A];return typeof $>"u"&&($=T),$}update(A,T){this.f[A]=T;const $=this.h.get(A);if($!==void 0)return $.p;const a=new v.$Zh;return this.h.set(A,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$bpc=P;class I extends P{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$cpc=I}),define(Oe[189],Ne([1,0,6,2]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=void 0;class I{constructor(A){this.c=A,this.a=new v.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,$,a){const y=this.c.getNotebookDocument(P.URI.revive(A)).acceptModelChanged(T.value,$,a);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(P.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(P.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$9pc=I}),define(Oe[16],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0,e.$6P=(0,v.$Ci)("IExtHostRpcService");class P{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$7P=P}),define(Oe[190],Ne([1,0,18,6,4]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=void 0;class O{#e;constructor(T,$){this.disposables=new I.$Sc,this.a=v.$on.toKey(T.identifier),this.#e=$,this.onDidChange=P.Event.map(P.Event.filter(this.#e.onDidChangePassword,a=>a.extensionId===this.a),a=>({key:a.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,$){return this.#e.store(this.a,T,$)}delete(T){return this.#e.delete(this.a,T)}}e.$lpc=O}),define(Oe[65],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=e.$Loc=void 0,e.$Loc=(0,v.$Ci)("IURITransformerService");class P{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Moc=P});var ni=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Oe[114],Ne([1,0,9,14,2,4,3,30,29,15,42,163,35]),function(we,e,v,P,I,O,A,T,$,a,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$fG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$8F=e.EditorInputCapabilities=e.$7F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0,e.$XF=n,e.$YF=o,e.$ZF=s,e.$1F=l,e.$2F=i,e.$3F=r,e.$4F=t,e.$5F=g,e.$6F=u,e.$9F=w,e.$0F=C,e.$$F=d,e.$_F=b,e.$aG=F,e.$bG=N,e.$cG=M,e.$dG=V,e.$eG=_,e.$gG=ce,e.$hG=oe,e.$iG=Ce,e.$jG=Le,c=ni(c),e.$SF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TF={id:"default",displayName:(0,v.localize)(12310,null),providerDisplayName:(0,v.localize)(12311,null)},e.$UF="workbench.editor.sidebysideEditor",e.$VF="workbench.editors.textDiffEditor",e.$WF="workbench.editors.binaryResourceDiffEditor";var D;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(D||(e.EditorPaneSelectionChangeReason=D={}));var f;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function n(X){const q=X;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function o(X){const q=X;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function s(X,q,te){for(const ve of te.visibleEditorPanes)if(ve.group.id===q&&X.matches(ve.input))return ve.getViewState()}function l(X){if(w(X))return!1;const q=X;return I.URI.isUri(q?.resource)}function i(X){if(w(X))return!1;const q=X;return q?.original!==void 0&&q.modified!==void 0}function r(X){if(w(X))return!1;const q=X;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(X){if(w(X)||i(X))return!1;const q=X;return q?.primary!==void 0&&q.secondary!==void 0}function g(X){if(w(X))return!1;const q=X;return q?q.resource===void 0||q.resource.scheme===a.Schemas.untitled||q.forceUntitled===!0:!1}function u(X){if(w(X))return!1;const q=X;return I.URI.isUri(q?.base?.resource)&&I.URI.isUri(q?.input1?.resource)&&I.URI.isUri(q?.input2?.resource)&&I.URI.isUri(q?.result?.resource)}var p;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(p||(e.Verbosity=p={}));var m;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class h{constructor(){this.a=new Map}registerSource(q,te){let ve=this.a.get(q);return ve||(ve={source:q,label:te},this.a.set(q,ve)),ve.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$7F=new h;var E;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class S extends O.$Tc{}e.$8F=S;function w(X){return X instanceof S}function k(X){const q=X;return I.URI.isUri(q?.preferredResource)}function C(X){const q=X;return w(q?.primary)&&w(q?.secondary)}function d(X){const q=X;return w(q?.modified)&&w(q?.original)}function b(X,q,te,ve,ae){return Le(ve,[(0,y.$mj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(12312,null),run:()=>{const be={...te,limits:{size:Number.MAX_VALUE}};X.openEditor(q,be)}}),(0,y.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(12313,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}function F(X){return w(X?.editor)}function N(X){const q=X;return F(X)&&q?.group!==void 0}function M(X){const q=X;return typeof q?.groupId=="number"&&w(q.editor)}function V(X){return typeof X?.groupId=="number"}var W;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var L;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var Y;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(Y||(e.SideBySideEditor=Y={}));class Z{getOriginalUri(q,te){if(!q)return;if(u(q))return e.$fG.getOriginalUri(q.result,te);if(te?.supportSideBySide){const{primary:ae,secondary:be}=this.a(q);if(ae&&be){if(te?.supportSideBySide===Y.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===Y.ANY)return this.getOriginalUri(ae,{filterByScheme:te.filterByScheme})??this.getOriginalUri(be,{filterByScheme:te.filterByScheme});q=te.supportSideBySide===Y.PRIMARY?ae:be}}if(i(q)||r(q)||t(q)||u(q))return;const ve=k(q)?q.preferredResource:q.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}a(q){return C(q)||t(q)?{primary:q.primary,secondary:q.secondary}:d(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,te){if(!q)return;if(u(q))return e.$fG.getCanonicalUri(q.result,te);if(te?.supportSideBySide){const{primary:ae,secondary:be}=this.a(q);if(ae&&be){if(te?.supportSideBySide===Y.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===Y.ANY)return this.getCanonicalUri(ae,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:te.filterByScheme});q=te.supportSideBySide===Y.PRIMARY?ae:be}}if(i(q)||r(q)||t(q)||u(q))return;const ve=q.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}b(q,te){if(Array.isArray(te)){if(te.some(ve=>q.scheme===ve))return q}else if(te===q.scheme)return q}}var ge;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(ge||(e.EditorCloseMethod=ge={}));function _(X,q,te,ve){if(!X.isSticky(q))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return te===ge.MOUSE||te===ge.KEYBOARD;case"mouse":return te===ge.MOUSE;case"keyboard":return te===ge.KEYBOARD}return!1}e.$fG=new Z;var fe;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(fe||(e.CloseDirection=fe={}));class se{constructor(){this.c=new Map,this.d=new Map}start(q){const te=this.a=q.get(A.$Bi);for(const[ve,ae]of this.c)this.e(ve,ae,te);this.c.clear()}e(q,te,ve){const ae=ve.createInstance(te);this.d.set(q,ae)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,P.$ng)(this.b)}registerEditorSerializer(q,te){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,te,this.a):this.c.set(q,te),(0,O.$Rc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}T.$oo.add(e.$SF.EditorFactory,new se);async function ce(X,q,te){return!X||!X.length?[]:await Promise.all(X.map(async ve=>{const ae=I.URI.revive(ve.fileUri);if(!ae){te.info("Cannot resolve the path because it is not valid.",ve);return}if(!await q.canHandleResource(ae)){te.info("Cannot resolve the path because it cannot be handled",ve);return}let ue=ve.exists,J=ve.type;if(typeof ue!="boolean"||typeof J!="number")try{J=(await q.stat(ae)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ue=!0}catch(me){te.error(me),ue=!1}if(!ue&&ve.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",ve);return}if(J===$.FileType.Directory){te.info("Cannot resolve the path because it is a directory",ve);return}const x={...ve.options,pinned:!0};return ue?{resource:ae,options:x}:{resource:ae,options:x,forceUntitled:!0}}))}var $e;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function oe(X){const q=X;if(!q)return!1;const te=q;if(te.modified)return oe(te.modified);const ve=q;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Ce(X){return(0,R.$oj)(X)}function Le(X,q,te){const ve=(0,R.$pj)(X,q);return ve.forceMessage=te?.forceMessage,ve.forceSeverity=te?.forceSeverity,ve.allowDialog=te?.allowDialog,ve}}),define(Oe[191],Ne([1,0,6,9,3,4,28,30,25,97,181]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$pG=e.ViewContentGroups=e.$nG=e.ViewContainerLocation=e.Extensions=e.$mG=e.$lG=e.$kG=void 0,e.$oG=D,e.$kG="views",e.$lG=(0,P.localize)(12150,null),e.$mG=(0,R.$yx)("default-view-icon",a.$2j.window,(0,P.localize)(12151,null));var y;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var c;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(c||(e.ViewContainerLocation=c={})),e.$nG=[c.Sidebar,c.Panel,c.AuxiliaryBar];function D(g){switch(g){case c.Sidebar:return"sidebar";case c.Panel:return"panel";case c.AuxiliaryBar:return"auxiliarybar"}}class f extends O.$Tc{constructor(){super(...arguments),this.c=this.B(new v.$je),this.onDidRegister=this.c.event,this.f=this.B(new v.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,p,m){const h=this.get(u.id);if(h)return h;const E=u;return E.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$wc)(this.g,p,[]).push(E),m?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:p}),E}deregisterViewContainer(u){for(const p of this.g.keys()){const m=this.g.get(p),h=m?.indexOf(u);if(h!==-1){m?.splice(h,1),m.length===0&&this.g.delete(p),this.f.fire({viewContainer:u,viewContainerLocation:p});return}}}get(u){return this.all.filter(p=>p.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(p=>this.getViewContainers(p).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(p=>this.getViewContainerLocation(p)===u)}}T.$oo.add(y.ViewContainersRegistry,new f);var n;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(n||(e.ViewContentGroups=n={}));function o(g,u){const p=g.group??n.More,m=u.group??n.More;return p!==m?p.localeCompare(m):(g.order??5)-(u.order??5)}class s extends O.$Tc{constructor(){super(...arguments),this.c=this.B(new v.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(u,p){this.registerViews2([{views:u,viewContainer:p}])}registerViews2(u){u.forEach(({views:p,viewContainer:m})=>this.r(p,m)),this.c.fire(u)}deregisterViews(u,p){const m=this.s(u,p);m.length&&this.f.fire({views:m,viewContainer:p})}moveViews(u,p){for(const m of this.m.keys())if(m!==p){const h=this.s(u,m);h.length&&(this.r(h,p),this.g.fire({views:h,from:m,to:p}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const p of this.j){const m=(this.m.get(p)||[]).filter(h=>h.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const p of this.j)if((this.m.get(p)||[]).filter(h=>h.id===u)[0])return p;return null}registerViewWelcomeContent(u,p){return this.n.add(u,p),this.h.fire(u),(0,O.$Rc)(()=>{this.n.delete(u,p),this.h.fire(u)})}registerViewWelcomeContent2(u,p){const m=new Map;for(const[h,E]of p)this.n.add(u,E),m.set(h,(0,O.$Rc)(()=>{this.n.delete(u,E),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const p=[];return this.n.forEach(u,m=>p.push(m)),p.sort(o)}r(u,p){let m=this.m.get(p);m||(m=[],this.m.set(p,m),this.j.push(p));for(const h of u){if(this.getView(h.id)!==null)throw new Error((0,P.localize)(12152,null,h.id));m.push(h)}}s(u,p){const m=this.m.get(p);if(!m)return[];const h=[],E=[];for(const S of m)u.includes(S)?h.push(S):E.push(S);return h.length&&(E.length?this.m.set(p,E):(this.m.delete(p),this.j.splice(this.j.indexOf(p),1))),h}}T.$oo.add(y.ViewsRegistry,new s),e.$pG=(0,I.$Ci)("viewDescriptorService");var l;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(l||(e.ViewVisibilityState=l={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(u,p){this.c=!1,this.d=!1,(0,$.$eo)(this,u),this.d=!!p,this.resolve=async m=>{if(p&&!this.c){const h=await p(m);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$qG=r;class t extends Error{constructor(u){super((0,P.localize)(12153,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$rG=t}),define(Oe[192],Ne([1,0,9,31]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=void 0,e.$vG=new P.$Tj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(8293,null)}),e.$wG=new P.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(8294,null)}),e.$xG=new P.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(8295,null)}),e.$yG=new P.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(8296,null)}),e.$zG=new P.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(8297,null)}),e.$AG=new P.$Tj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(8298,null)}),e.$BG=new P.$Tj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(8299,null)}),e.$CG=new P.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(8300,null)}),e.$DG=new P.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8301,null)}),e.$EG=new P.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(8302,null)}),e.$FG=new P.$Tj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(8303,null)}),e.$GG=new P.$Tj("inChat",!1,{type:"boolean",description:(0,v.localize)(8304,null)}),e.$HG=new P.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(8305,null)}),e.$IG=new P.$Tj("chatCursorAtTop",!1),e.$JG=new P.$Tj("chatInputHasAgent",!1),e.$KG=new P.$Tj("chatLocation",void 0),e.$LG=new P.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(8306,null)})}),define(Oe[115],Ne([1,0,282,10,21,6,39,4,40,142,12,31,18,3,11,108,175,186,192]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.ChatAgentLocation=void 0,e.$PH=p,e.$QH=m;var r;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function(h){function E(S){switch(S){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=E}(r||(e.ChatAgentLocation=r={})),e.$KH=(0,D.$Ci)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new O.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=l.$HG.bindTo(this.f)}registerAgent(E,S){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,C=S.slashCommands;S={...S,get slashCommands(){return C.filter(b=>!b.when||k.f.contextMatchesRules(y.$Aj.deserialize(b.when)))}};const d={data:S};return this.b.set(E,d),(0,T.$Rc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,S){const w=this.b.get(E);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return w.data.isDefault&&this.e.set(!0),w.impl=S,this.d.fire(new g(w.data,S)),(0,T.$Rc)(()=>{w.impl=void 0,this.d.fire(void 0),w.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,S){E.isDynamic=!0;const w={data:E,impl:S};return this.b.set(E.id,w),this.d.fire(new g(E,S)),(0,T.$Rc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,S){return this.g.set(E,S),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,S,w){return await this.g.get(E)?.(S,w)??[]}updateAgent(E,S){const w=this.b.get(E);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);w.data.metadata={...w.data.metadata,...S},this.d.fire(new g(w.data,w.impl))}getDefaultAgent(E){return(0,v.$eb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(E))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const S=this.b.get(E);return!S?.data.when||this.f.contextMatchesRules(y.$Aj.deserialize(S.data.when))}getAgentByFullyQualifiedId(E){const S=A.Iterable.find(this.b.values(),w=>p(w.data)===E)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new g(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(S=>S.name===E)}agentHasDupeName(E){const S=this.getAgent(E);return S?this.getAgentsByName(S.name).filter(w=>w.extensionId.value!==S.extensionId.value).length>0:!1}async invokeAgent(E,S,w,k,C){const d=this.b.get(E);if(!d?.impl)throw new Error(`No activated agent with id "${E}"`);return await d.impl.invoke(S,w,k,C)}async getFollowups(E,S,w,k,C){const d=this.b.get(E);if(!d?.impl)throw new Error(`No activated agent with id "${E}"`);return d.impl?.provideFollowups?d.impl.provideFollowups(S,w,k,C):[]}};e.$LH=t,e.$LH=t=He([Ve(0,y.$Uj)],t);class g{constructor(E,S){this.b=E,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,S,w,k){return this.d.invoke(E,S,w,k)}async provideFollowups(E,S,w,k){return this.d.provideFollowups?this.d.provideFollowups(E,S,w,k):[]}provideWelcomeMessage(E,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,S)}provideSampleQuestions(E,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,S)}}e.$MH=g,e.$NH=(0,D.$Ci)("chatAgentNameService");let u=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,S,w,k){if(this.g=S,this.h=w,this.i=k,this.e=(0,a.$4d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const C=k.get(i.b,s.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{k.remove(i.b,s.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,P.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},I.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,o.$$p)(E);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const w=S.restrictedChatParticipants;this.e.set(w,void 0),this.i.store(i.b,JSON.stringify(w),s.StorageScope.APPLICATION,s.StorageTarget.MACHINE)}getAgentNameRestriction(E){const S=this.l(E.name,E).get(),w=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return S&&w}l(E,S){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(C=>(0,R.$Df)(C,C.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$OH=u,e.$OH=u=i=He([Ve(0,n.$qk),Ve(1,o.$5p),Ve(2,f.$0j),Ve(3,s.$fq)],u);function p(h){return`${h.extensionId.value}.${h.id}`}function m(h){const E="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new c.$on("")),(0,$.$_h)(E)}}),define(Oe[193],Ne([1,0,2,32,3]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jH=e.$iH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$gH=O,e.$hH=A;function O(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof v.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(P.$Lt.isIRange)}function A(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(O)}var T;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var $;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$iH=(0,I.$Ci)("IChatService"),e.$jH="accessibility.voice.keywordActivation"}),define(Oe[194],Ne([1,0,6,10,9]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jtb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new v.$je,this.o=new v.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,$,a,R){const y={command:T};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof R=="number"){const c=setTimeout(()=>{clearTimeout(c);const D=this.f.get(y.seq);if(D){this.f.delete(y.seq);const f={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,I.localize)(7431,null,R,T)};D(f)}},R)}return a&&this.f.set(y.seq,a),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,$){return T.type!=="event"||$.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,P.$Dh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const $=T,a=this.f.get($.request_seq);a&&(this.f.delete($.request_seq),a($));break}}}}u(T,$){$.type=T,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach(($,a)=>T.set(a,$)),await(0,P.$Dh)(500),T.forEach(($,a)=>{$({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Jtb=O}),define(Oe[80],Ne([1,0,2,9,31,3]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$DK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$BK=e.MemoryRangeType=e.State=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=void 0,e.$AK=$,e.$CK=R,P=qe(P),e.$oJ="workbench.view.debug",e.$pJ="workbench.debug.variablesView",e.$qJ="workbench.debug.watchExpressionsView",e.$rJ="workbench.debug.callStackView",e.$sJ="workbench.debug.loadedScriptsView",e.$tJ="workbench.debug.breakPointsView",e.$uJ="workbench.debug.disassemblyView",e.$vJ="workbench.panel.repl",e.$wJ="workbench.panel.repl.view",e.$xJ=new I.$Tj("debugType",void 0,{type:"string",description:P.localize(7368,null)}),e.$yJ=new I.$Tj("debugConfigurationType",void 0,{type:"string",description:P.localize(7369,null)}),e.$zJ=new I.$Tj("debugState","inactive",{type:"string",description:P.localize(7370,null)}),e.$AJ="debugUx",e.$BJ=new I.$Tj(e.$AJ,"default",{type:"string",description:P.localize(7371,null)}),e.$CJ=new I.$Tj("hasDebugged",!1,{type:"boolean",description:P.localize(7372,null)}),e.$DJ=new I.$Tj("inDebugMode",!1,{type:"boolean",description:P.localize(7373,null)}),e.$EJ=new I.$Tj("inDebugRepl",!1,{type:"boolean",description:P.localize(7374,null)}),e.$FJ=new I.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:P.localize(7375,null)}),e.$GJ=new I.$Tj("inBreakpointWidget",!1,{type:"boolean",description:P.localize(7376,null)}),e.$HJ=new I.$Tj("breakpointsFocused",!0,{type:"boolean",description:P.localize(7377,null)}),e.$IJ=new I.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:P.localize(7378,null)}),e.$JJ=new I.$Tj("watchExpressionsExist",!1,{type:"boolean",description:P.localize(7379,null)}),e.$KJ=new I.$Tj("variablesFocused",!0,{type:"boolean",description:P.localize(7380,null)}),e.$LJ=new I.$Tj("expressionSelected",!1,{type:"boolean",description:P.localize(7381,null)}),e.$MJ=new I.$Tj("breakpointInputFocused",!1,{type:"boolean",description:P.localize(7382,null)}),e.$NJ=new I.$Tj("callStackItemType",void 0,{type:"string",description:P.localize(7383,null)}),e.$OJ=new I.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:P.localize(7384,null)}),e.$PJ=new I.$Tj("callStackItemStopped",!1,{type:"boolean",description:P.localize(7385,null)}),e.$QJ=new I.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:P.localize(7386,null)}),e.$RJ=new I.$Tj("watchItemType",void 0,{type:"string",description:P.localize(7387,null)}),e.$SJ=new I.$Tj("canViewMemory",void 0,{type:"boolean",description:P.localize(7388,null)}),e.$TJ=new I.$Tj("breakpointItemType",void 0,{type:"string",description:P.localize(7389,null)}),e.$UJ=new I.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:P.localize(7390,null)}),e.$VJ=new I.$Tj("breakpointHasModes",!1,{type:"boolean",description:P.localize(7391,null)}),e.$WJ=new I.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:P.localize(7392,null)}),e.$XJ=new I.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:P.localize(7393,null)}),e.$YJ=new I.$Tj("loadedScriptsItemType",void 0,{type:"string",description:P.localize(7394,null)}),e.$ZJ=new I.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:P.localize(7395,null)}),e.$1J=new I.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:P.localize(7396,null)}),e.$2J=new I.$Tj("stepBackSupported",!1,{type:"boolean",description:P.localize(7397,null)}),e.$3J=new I.$Tj("restartFrameSupported",!1,{type:"boolean",description:P.localize(7398,null)}),e.$4J=new I.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:P.localize(7399,null)}),e.$5J=new I.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:P.localize(7400,null)}),e.$6J=new I.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:P.localize(7401,null)}),e.$7J=new I.$Tj("breakpointsExist",!1,{type:"boolean",description:P.localize(7402,null)}),e.$8J=new I.$Tj("debuggersAvailable",!1,{type:"boolean",description:P.localize(7403,null)}),e.$9J=new I.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:P.localize(7404,null)}),e.$0J=new I.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:P.localize(7405,null)}),e.$$J=new I.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:P.localize(7406,null)}),e.$_J=new I.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:P.localize(7407,null)}),e.$aK=new I.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:P.localize(7408,null)}),e.$bK=new I.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:P.localize(7409,null)}),e.$cK=new I.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:P.localize(7410,null)}),e.$dK=new I.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:P.localize(7411,null)}),e.$eK=new I.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:P.localize(7412,null)}),e.$fK=new I.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:P.localize(7413,null)}),e.$gK=new I.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:P.localize(7414,null)}),e.$hK=new I.$Tj("variableIsReadonly",!1,{type:"boolean",description:P.localize(7415,null)}),e.$iK=new I.$Tj("variableValue",!1,{type:"string",description:P.localize(7416,null)}),e.$jK=new I.$Tj("variableType",!1,{type:"string",description:P.localize(7417,null)}),e.$kK=new I.$Tj("variableInterfaces",!1,{type:"array",description:P.localize(7418,null)}),e.$lK=new I.$Tj("variableName",!1,{type:"string",description:P.localize(7419,null)}),e.$mK=new I.$Tj("variableLanguage",!1,{type:"string",description:P.localize(7420,null)}),e.$nK=new I.$Tj("variableExtensionId",!1,{type:"string",description:P.localize(7421,null)}),e.$oK=new I.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:P.localize(7422,null)}),e.$pK=new I.$Tj("multiSessionRepl",!1,{type:"boolean",description:P.localize(7423,null)}),e.$qK=new I.$Tj("multiSessionDebug",!1,{type:"boolean",description:P.localize(7424,null)}),e.$rK=new I.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:P.localize(7425,null)}),e.$sK=new I.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:P.localize(7426,null)}),e.$tK=new I.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:P.localize(7427,null)}),e.$uK=new I.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:P.localize(7428,null)});const A=i=>P.localize(7429,null,i);e.$vK=A,e.$wK="editor.contrib.debug",e.$xK="editor.contrib.breakpoint",e.$yK="debug",e.$zK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:P.localize(7430,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function $(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var a;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$BK="vscode-debug-memory";function R(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var c;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(c||(e.DebugConfigurationProviderTriggerKind=c={}));var D;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$DK=(0,O.$Ci)("debugService");var f;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(s||(e.IDebugVisualizationTreeItem=s={}));var l;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:v.URI.revive(r.iconPath.light),dark:v.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(l||(e.IDebugVisualization=l={}))}),define(Oe[195],Ne([1,0,12,2,19,25,15,32,21,17]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8H=void 0,e.$VH=y,e.$WH=c,e.$XH=D,e.$YH=f,e.$ZH=n,e.$1H=o,e.$2H=s,e.$3H=i,e.$4H=g,e.$5H=u,e.$6H=m,e.$7H=E;const R=/{([^}]+)}/g;function y(w,k,C){return w.replace(R,function(d,b){return k&&b.length>0&&b[0]!=="_"?d:C&&C.hasOwnProperty(b)?C[b]:d})}function c(w){const k={};for(const C of Object.keys(w))C.startsWith("!")||(k[C]=w[C]);return k}function D(w){return w.configuration.request==="attach"&&!f(w)&&(!w.parentSession||D(w.parentSession))}function f(w){let k=w.configuration.type;if(k)return k==="vslsShare"&&(k=w.configuration.adapterProxy.configuration.type),(0,v.$Df)(k,"extensionhost")||(0,v.$Df)(k,"pwa-extensionhost")?w:w.parentSession?f(w.parentSession):void 0}function n(w){return w.type&&(w.label||w.program||w.runtime)}function o(w,k,C){let d,b=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(w);){const M=N.index+1,V=M+N[0].length;if(M<=k&&V>=C){d=N[0],b=M;break}}if(d){const M=/(\w|\p{L})+/gu;let V=null;for(;(V=M.exec(d))&&!(V.index+1+b+V[0].length>=C););V&&(d=d.substring(0,M.lastIndex))}return d?{start:b,end:b+d.length-1}:{start:0,end:0}}async function s(w,k,C,d){if(w.evaluatableExpressionProvider.has(k)){const b=w.evaluatableExpressionProvider.ordered(k),F=(0,a.$Gb)(await Promise.all(b.map(async N=>{try{return await N.provideEvaluatableExpression(k,C,d??$.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const M=F[0].range;return N||(N=k.getLineContent(C.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:N}}}else{const b=k.getLineContent(C.lineNumber),{start:F,end:N}=o(b,C.column,C.column),M=b.substring(F-1,N);return{matchingExpression:M,range:new T.$Lt(C.lineNumber,F,C.lineNumber,F+M.length)}}return null}const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(w){return!!(w&&w.match(l))}function r(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(i(w.path))return P.URI.parse(w.path);if((0,I.$hc)(w.path))return P.URI.file(w.path)}return w.path}function t(w){if(typeof w.path=="object"){const k=P.URI.revive(w.path);if(k)return k.scheme===A.Schemas.file?k.fsPath:k.toString()}return w.path}function g(w,k){const C=k?r:t,d=(0,O.$bo)(w);return p(d,(b,F)=>{b&&F&&(F.path=C(F))}),d}function u(w,k){const C=k?r:t,d=(0,O.$bo)(w);return p(d,(b,F)=>{!b&&F&&(F.path=C(F))}),d}function p(w,k){switch(w.type){case"event":{const C=w;switch(C.event){case"output":k(!1,C.body.source);break;case"loadedSource":k(!1,C.body.source);break;case"breakpoint":k(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=w;switch(C.command){case"setBreakpoints":k(!0,C.arguments.source);break;case"breakpointLocations":k(!0,C.arguments.source);break;case"source":k(!0,C.arguments.source);break;case"gotoTargets":k(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(d=>k(!1,d));break;default:break}break}case"response":{const C=w;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(d=>k(!1,d.source));break;case"loadedSources":C.body.sources.forEach(d=>k(!1,d));break;case"scopes":C.body.scopes.forEach(d=>k(!1,d.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(d=>k(!1,d.source));break;case"setBreakpoints":C.body.breakpoints.forEach(d=>k(!1,d.source));break;case"disassemble":C.body?.instructions.forEach(b=>k(!1,b.location));break;default:break}break}}}function m(w){return w.filter(k=>!k.presentation?.hidden).sort((k,C)=>k.presentation?C.presentation?k.presentation.group?C.presentation.group?k.presentation.group!==C.presentation.group?k.presentation.group.localeCompare(C.presentation.group):h(k.presentation.order,C.presentation.order):-1:C.presentation.group?1:h(k.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function h(w,k){return typeof w!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:w-k}async function E(w,k){const C=w.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(C!=="none"&&(await k.saveAll(),C==="allEditorsInActiveGroup")){const d=k.activeEditorPane;d&&d.input.resource?.scheme===A.Schemas.untitled&&await k.save({editor:d.input,groupId:d.group.id})}await w.reloadConfiguration()}const S=(w,k)=>!w||!k?w===k:w.name===k.name&&w.path===k.path&&w.sourceReference===k.sourceReference;e.$8H=S}),define(Oe[196],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.CellExecutionUpdateType=void 0;var P;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(P||(e.CellExecutionUpdateType=P={})),e.$LK=(0,v.$Ci)("INotebookExecutionService")}),define(Oe[197],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$OK=e.ProxyKernelState=e.$NK=void 0,e.$NK=100;var P;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(P||(e.ProxyKernelState=P={})),e.$OK=(0,v.$Ci)("INotebookKernelService"),e.$PK=(0,v.$Ci)("INotebookKernelHistoryService")}),define(Oe[198],Ne([1,0,4,32,52,161,102]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DZb=void 0;class T extends v.$Tc{constructor(a,R,y){super(),this._source=a,this.b=R,this.c=y,this.a=void 0}f(a){const R=a.getLineCount();return new P.$Lt(1,1,R,this.g(a,R))}g(a,R){if(R<1||R>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const a=new O.$mD;a.acceptChunk(this._source);const R=a.finish(!0),{textBuffer:y,disposable:c}=R.create(I.DefaultEndOfLine.LF);this.b=y,this.B(c)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const R=new O.$mD;R.acceptChunk(a);const y=R.finish(!0),{textBuffer:c,disposable:D}=y.create(I.DefaultEndOfLine.LF);return this.B(D),c})),this.a}findInInputs(a){const y=new A.$aD(a,!1,!1,null).parseSearchRequest();if(!y)return[];const c=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(c,y,!0,5e3)}findInOutputs(a){const y=new A.$aD(a,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(c=>{const D=c.findMatchesLineByLine(this.f(c),y,!0,5e3);if(D.length!==0)return{textBuffer:c,matches:D}}).filter(c=>!!c):[]}}e.$DZb=T}),define(Oe[54],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(O){O.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var P;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(P||(e.TestPosition=P={}));class I{static fromExtHostTestItem(A,T,$=A.parent){if(A._isRoot)return new I([T]);const a=[A.id];for(let R=$;R&&R.id!==T;R=R.parent)a.push(R.id);return a.push(T),new I(a.reverse())}static isRoot(A){return!A.includes(v.Delimiter)}static root(A){const T=A.indexOf(v.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new I(A.split(v.Delimiter))}static join(A,T){return new I([...A.path,T])}static joinToString(A,T){return A.toString()+v.Delimiter+T}static parentId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?A:A.slice(T+v.Delimiter.length)}static isChild(A,T){return T[A.length]===v.Delimiter&&T.startsWith(A)}static compare(A,T){return A===T?P.IsSame:I.isChild(A,T)?P.IsChild:I.isChild(T,A)?P.IsParent:P.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let $=0;for(;$<A-1;){for(let a=1;a<A;a++){const R=T(a-1),y=T(a);if(R.path[$]!==y.path[$])return $}$++}return $}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new I(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return P.Disconnected;return A.d>this.d?P.IsChild:A.d<this.d?P.IsParent:P.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=v.Delimiter,this.c+=this.path[A]}return this.c}}e.$UI=I}),define(Oe[55],Ne([1,0,2,101,32,54]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$3I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$2I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$1I=e.$ZI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$YI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$XI=e.$WI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$VI=e.TestResultState=void 0;var A;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$VI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var $;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$WI=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const a=W=>"runId"in W;e.$XI=a;var R;(function(W){W.serialize=L=>({range:L.range.toJSON(),uri:L.uri.toJSON()}),W.deserialize=(L,Y)=>({range:I.$Lt.lift(Y.range),uri:L.asCanonicalUri(v.URI.revive(Y.uri))})})(R||(e.IRichLocation=R={}));var y;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(y||(e.TestMessageType=y={}));var c;(function(W){W.serialize=L=>({message:L.message,type:y.Error,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&R.serialize(L.location)}),W.deserialize=(L,Y)=>({message:Y.message,type:y.Error,expected:Y.expected,actual:Y.actual,contextValue:Y.contextValue,location:Y.location&&R.deserialize(L,Y.location)})})(c||(e.ITestErrorMessage=c={}));const D=(W,L)=>`${L?"s":"e"}${W}`;e.$YI=D;var f;(function(W){W.serialize=L=>({message:L.message,type:y.Output,offset:L.offset,length:L.length,location:L.location&&R.serialize(L.location)}),W.deserialize=(L,Y)=>({message:Y.message,type:y.Output,offset:Y.offset,length:Y.length,location:Y.location&&R.deserialize(L,Y.location)})})(f||(e.ITestOutputMessage=f={}));var n;(function(W){W.serialize=L=>L.type===y.Error?c.serialize(L):f.serialize(L),W.deserialize=(L,Y)=>Y.type===y.Error?c.deserialize(L,Y):f.deserialize(L,Y)})(n||(e.ITestMessage=n={}));var o;(function(W){W.serializeWithoutMessages=L=>({state:L.state,duration:L.duration,messages:[]}),W.serialize=L=>({state:L.state,duration:L.duration,messages:L.messages.map(n.serialize)}),W.deserialize=(L,Y)=>({state:Y.state,duration:Y.duration,messages:Y.messages.map(Z=>n.deserialize(L,Z))})})(o||(e.ITestTaskState=o={}));const s="\0",l=(W,L)=>W+s+L;e.$ZI=l;const i=W=>{const L=W.indexOf(s);return{ctrlId:W.slice(0,L),tagId:W.slice(L+1)}};e.$1I=i;var r;(function(W){W.serialize=L=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?.toJSON(),range:L.range?.toJSON()||null,description:L.description,error:L.error,sortText:L.sortText}),W.deserialize=(L,Y)=>({extId:Y.extId,label:Y.label,tags:Y.tags,busy:Y.busy,children:void 0,uri:Y.uri?L.asCanonicalUri(v.URI.revive(Y.uri)):void 0,range:Y.range?I.$Lt.lift(Y.range):null,description:Y.description,error:Y.error,sortText:Y.sortText})})(r||(e.ITestItem=r={}));var t;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var g;(function(W){W.serialize=L=>({expand:L.expand,item:r.serialize(L.item)}),W.deserialize=(L,Y)=>({controllerId:O.$UI.root(Y.item.extId),expand:Y.expand,item:r.deserialize(L,Y.item)})})(g||(e.InternalTestItem=g={}));var u;(function(W){W.serialize=L=>{let Y;return L.item&&(Y={},L.item.label!==void 0&&(Y.label=L.item.label),L.item.tags!==void 0&&(Y.tags=L.item.tags),L.item.busy!==void 0&&(Y.busy=L.item.busy),L.item.uri!==void 0&&(Y.uri=L.item.uri?.toJSON()),L.item.range!==void 0&&(Y.range=L.item.range?.toJSON()),L.item.description!==void 0&&(Y.description=L.item.description),L.item.error!==void 0&&(Y.error=L.item.error),L.item.sortText!==void 0&&(Y.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:Y}},W.deserialize=L=>{let Y;return L.item&&(Y={},L.item.label!==void 0&&(Y.label=L.item.label),L.item.tags!==void 0&&(Y.tags=L.item.tags),L.item.busy!==void 0&&(Y.busy=L.item.busy),L.item.range!==void 0&&(Y.range=L.item.range?I.$Lt.lift(L.item.range):null),L.item.description!==void 0&&(Y.description=L.item.description),L.item.error!==void 0&&(Y.error=L.item.error),L.item.sortText!==void 0&&(Y.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:Y}}})(u||(e.ITestItemUpdate=u={}));const p=(W,L)=>{L.expand!==void 0&&(W.expand=L.expand),L.item!==void 0&&(W.item=W.item?Object.assign(W.item,L.item):L.item)};e.$2I=p;var m;(function(W){W.serializeWithoutMessages=L=>({...g.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serializeWithoutMessages)}),W.serialize=L=>({...g.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serialize)}),W.deserialize=(L,Y)=>({...g.deserialize(L,Y),ownComputedState:Y.ownComputedState,computedState:Y.computedState,tasks:Y.tasks.map(Z=>o.deserialize(L,Z)),retired:!0})})(m||(e.TestResultItem=m={}));var h;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(L,Y)=>{L.covered+=Y.covered,L.total+=Y.total}})(h||(e.ICoverageCount=h={}));var E;(function(W){W.serialize=L=>({id:L.id,statement:L.statement,branch:L.branch,declaration:L.declaration,testIds:L.testIds,uri:L.uri.toJSON()}),W.deserialize=(L,Y)=>({id:Y.id,statement:Y.statement,branch:Y.branch,declaration:Y.declaration,testIds:Y.testIds,uri:L.asCanonicalUri(v.URI.revive(Y.uri))}),W.empty=(L,Y)=>({id:L,uri:Y,statement:h.empty()})})(E||(e.IFileCoverage=E={}));function S(W){return{...W,location:W.location?.toJSON()}}function w(W){return W.location=W.location?P.$Kt.isIPosition(W.location)?P.$Kt.lift(W.location):I.$Lt.lift(W.location):void 0,W}e.$3I=3;var k;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(k||(e.DetailType=k={}));var C;(function(W){W.serialize=L=>L.type===k.Declaration?b.serialize(L):F.serialize(L),W.deserialize=L=>L.type===k.Declaration?b.deserialize(L):F.deserialize(L)})(C||(e.CoverageDetails=C={}));var d;(function(W){W.serialize=S,W.deserialize=w})(d||(e.IBranchCoverage=d={}));var b;(function(W){W.serialize=S,W.deserialize=w})(b||(e.IDeclarationCoverage=b={}));var F;(function(W){W.serialize=L=>({...S(L),branches:L.branches?.map(d.serialize)}),W.deserialize=L=>({...w(L),branches:L.branches?.map(d.deserialize)})})(F||(e.IStatementCoverage=F={}));var N;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var M;(function(W){W.deserialize=(L,Y)=>Y.op===N.Add?{op:Y.op,item:g.deserialize(L,Y.item)}:Y.op===N.Update?{op:Y.op,item:u.deserialize(Y.item)}:Y.op===N.DocumentSynced?{op:Y.op,uri:L.asCanonicalUri(v.URI.revive(Y.uri)),docv:Y.docv}:Y,W.serialize=L=>L.op===N.Add?{op:L.op,item:g.serialize(L.item)}:L.op===N.Update?{op:L.op,item:u.serialize(L.item)}:L})(M||(e.TestsDiffOp=M={}));class V{constructor(L){this.k=L,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(L){const Y=this.w();for(const Z of L)switch(Z.op){case N.Add:this.l(g.deserialize(this.k,Z.item),Y);break;case N.Update:this.p(u.deserialize(Z.item),Y);break;case N.Remove:this.q(Z.itemId,Y);break;case N.Retire:this.v(Z.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(Z.amount);break;case N.AddTag:this.c.set(Z.tag.id,Z.tag);break;case N.RemoveTag:this.c.delete(Z.id);break}Y.complete?.()}l(L,Y){const Z=O.$UI.parentId(L.item.extId)?.toString();let ge;if(!Z)ge=this.x(L),this.g.add(ge),this.f.set(L.item.extId,ge);else if(this.f.has(Z)){const _=this.f.get(Z);_.children.add(L.item.extId),ge=this.x(L,_),this.f.set(L.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(L)}`);return}return Y.add?.(ge),L.expand===t.BusyExpanding&&this.h++,ge}p(L,Y){const Z=this.f.get(L.extId);if(Z)return L.expand!==void 0&&(Z.expand===t.BusyExpanding&&this.h--,L.expand===t.BusyExpanding&&this.h++),(0,e.$2I)(Z,L),Y.update?.(Z),Z}q(L,Y){const Z=this.f.get(L);if(!Z)return;const ge=O.$UI.parentId(Z.item.extId)?.toString();ge?this.f.get(ge).children.delete(Z.item.extId):this.g.delete(Z);const _=[[L]];for(;_.length;)for(const fe of _.pop()){const se=this.f.get(fe);se&&(_.push(se.children),this.f.delete(fe),Y.remove?.(se,se!==Z),se.expand===t.BusyExpanding&&this.h--)}}v(L){}updatePendingRoots(L){this.j+=L}w(){return{}}}e.$4I=V}),define(Oe[199],Ne([1,0,98,9,55]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$mGb=e.$lGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const $={[I.TestResultState.Errored]:(0,P.localize)(3114,null),[I.TestResultState.Failed]:(0,P.localize)(3115,null),[I.TestResultState.Passed]:(0,P.localize)(3116,null),[I.TestResultState.Queued]:(0,P.localize)(3117,null),[I.TestResultState.Running]:(0,P.localize)(3118,null),[I.TestResultState.Skipped]:(0,P.localize)(3119,null),[I.TestResultState.Unset]:(0,P.localize)(3120,null)},a=(y,c)=>(0,P.localize)(3121,null,(0,v.$Wk)(y),$[c]);e.$lGb=a,e.$mGb={[I.TestRunProfileBitset.Debug]:(0,P.localize)(3122,null),[I.TestRunProfileBitset.Run]:(0,P.localize)(3123,null),[I.TestRunProfileBitset.Coverage]:(0,P.localize)(3124,null)};var R;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(Oe[81],Ne([1,0,10,6,4,61,55,54]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.TestItemEventOp=void 0;var $;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const a=(l,i)=>l===i,y=Object.entries({range:(l,i)=>l===i?!0:!l||!i?!1:l.equalsRange(i),busy:a,label:a,description:a,error:a,sortText:a,tags:(l,i)=>!(l.length!==i.length||l.some(r=>!i.includes(r)))}),c=(l,i)=>{let r;for(const[t,g]of y)g(l[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class D extends I.$Tc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new P.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===A.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===A.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,A.$2I)(r.item,i.item);return}if(r.op===A.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,A.$2I)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===A.TestItemExpandState.Expandable){const g=this.M(t);return g.isOpen()?this.L(t,r-1):g.wait().then(()=>this.L(t,r-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case $.RemoveChild:this.O(T.$UI.joinToString(i.fullId,r.id));break;case $.Upsert:this.z(r.item,i);break;case $.Bulk:for(const t of r.ops)this.w(i,t);break;case $.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(i);break;case $.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case $.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$dd)(r)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=T.$UI.fromExtHostTestItem(i,this.root.id,r?.actual),g=this.s.getApiFor(i);g.parent&&g.parent!==r?.actual&&this.s.getChildren(g.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,r),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,r);return}if(u.actual===i){this.H(i,u,r);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const p=this.s.getChildren(u.actual),m=u.actual,h=c(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=A.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,t.toString()),delete h.tags),this.w(u,{op:$.SetProp,update:h})),this.I(i,u,r);for(const[S,w]of p)this.s.getChildren(i).get(w.id)||this.O(T.$UI.joinToString(t,w.id));const E=u.expandLevels;E!==void 0&&queueMicrotask(()=>{u.expand===A.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(u.actual.uri)}C(i,r,t){const g=new Set(r.map(u=>u.id));for(const u of i)g.delete(u.id)||this.D(u);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,A.$ZI)(this.s.controllerId,u.id))}}}),g.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$ZI)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$ZI)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const g=this.s.getApiFor(i);g.parent=t?.actual,g.listener=u=>this.w(r,u),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[g,u]of this.s.getChildren(i))this.z(u,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:r=A.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[g,u]of this.s.getChildren(i.actual)){const p=this.expand(T.$UI.joinToString(i.fullId,u.id),r);(0,v.$oh)(p)&&t.push(p)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new v.$Bh;return u.open(),u}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new v.$Bh,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let g;try{g=this.h(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,v.$oh)(g)?g.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const g=t.pop();if(g){this.s.getApiFor(g.actual).listener=void 0;for(const u of g.actual.tags)this.F(u.id);this.tree.delete(g.fullId.toString());for(const[u,p]of this.s.getChildren(g.actual))t.push(this.tree.get(T.$UI.joinToString(g.fullId,p.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$VP=D;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$WP=f;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$XP=n;class o extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$YP=o;const s=(l,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(g,u){for(const p of t.values())g.call(u,p,this)},[Symbol.iterator](){return t.entries()},replace(g){const u=new Map,p=new Set(t.keys()),m={op:$.Bulk,ops:[]};for(const h of g){if(!(h instanceof r))throw new n(h.id);const E=i(h).controllerId;if(E!==l.controllerId)throw new o(h.id,E,l.controllerId);if(u.has(h.id))throw new f(h.id);u.set(h.id,h),p.delete(h.id),m.ops.push({op:$.Upsert,item:h})}for(const h of p.keys())m.ops.push({op:$.RemoveChild,id:h});l.listener?.(m),t=u},add(g){if(!(g instanceof r))throw new n(g.id);t.set(g.id,g),l.listener?.({op:$.Upsert,item:g})},delete(g){t.delete(g)&&l.listener?.({op:$.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.$ZP=s}),define(Oe[116],Ne([1,0,81]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0;const P=new WeakMap,I=(A,T)=>{const $={controllerId:T};return P.set(A,$),$};e.$1P=I;const O=A=>{const T=P.get(A);if(!T)throw new v.$XP(A?.id||"<unknown>");return T};e.$2P=O}),define(Oe[82],Ne([1,0,27,15,2]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fDb=e.$eDb=e.$dDb=void 0,e.$gDb=O,e.$hDb=T,e.$dDb="vscode-cdn.net",e.$eDb=`vscode-resource.${e.$dDb}`,e.$fDb=`'self' https://*.${e.$dDb}`;function O($,a){return $.scheme===P.Schemas.http||$.scheme===P.Schemas.https?$:(a&&a.authority&&a.isRemote&&$.scheme===P.Schemas.file&&($=I.URI.from({scheme:P.Schemas.vscodeRemote,authority:a.authority,path:$.path})),I.URI.from({scheme:P.Schemas.https,authority:`${$.scheme}+${A($.authority)}.${e.$eDb}`,path:$.path,fragment:$.fragment,query:$.query}))}function A($){return $.replace(/./g,a=>{const R=a.charCodeAt(0);return R>=v.CharCode.a&&R<=v.CharCode.z||R>=v.CharCode.A&&R<=v.CharCode.Z||R>=v.CharCode.Digit0&&R<=v.CharCode.Digit9?a:"-"+R.toString(16).padStart(4,"0")})}function T($){return $.replace(/-([0-9a-f]{4})/g,(a,R)=>String.fromCharCode(parseInt(R,16)))}}),define(Oe[200],Ne([1,0,6,4,82]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;class O{constructor(T,$,a){this.d=T,this.e=$,this.f=a,this.a=0,this.b=new P.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const y of this.c.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,$,a,R,y){let c;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){c=i;break}if(!c)throw new Error("not a visible editor");const D=this,f=this.a++,n=new v.$je,o=new v.$je,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,I.$gDb)(i,D.f)}get cspSource(){return I.$fDb}set options(i){this.b=i,D.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,D.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return D.d.$postMessage(f,i)}},l=new class{constructor(){this.editor=T,this.line=$,this.height=a,this.webview=s,this.onDidDispose=o.event}dispose(){D.c.has(f)&&(D.c.delete(f),D.d.$disposeEditorInset(f),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(f,c.id,c.value.document.uri,$+1,a,R||{},y.identifier,y.extensionLocation),this.c.set(f,{editor:T,inset:l,onDidReceiveMessage:n}),l}$onDidDispose(T){const $=this.c.get(T);$&&$.inset.dispose()}$onDidReceiveMessage(T,$){this.c.get(T)?.onDidReceiveMessage.fire($)}}e.$Joc=O}),define(Oe[117],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.$yM=e.$xM=void 0,e.$xM="__",e.$yM=(0,v.$Ci)("IAuthenticationService"),e.$zM=(0,v.$Ci)("IAuthenticationExtensionsService")}),define(Oe[201],Ne([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=e.VariableKind=e.$TQ=void 0,e.$TQ=(0,v.$Ci)("configurationResolverService");var P;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class I extends Error{constructor(A,T){super(T),this.variable=A}}e.$UQ=I}),define(Oe[202],Ne([1,0,19,78,14,25,20,99,9,201,12]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=void 0,v=qe(v),P=qe(P),I=qe(I),O=qe(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(D,f,n,o){this.h=new Map,this.a=D,this.b=f,this.g=n,o&&(this.c=o.then(s=>this.i(s)))}i(D){if(A.$j){const f=Object.create(null);return Object.keys(D).forEach(n=>{f[n.toLowerCase()]=D[n]}),f}return D}resolveWithEnvironment(D,f,n){return this.l({env:this.i(D),userHome:void 0},f?f.uri:void 0,n)}async resolveAsync(D,f){const n={env:await this.c,userHome:await this.g};return this.l(n,D?D.uri:void 0,f)}async j(D,f,n,o){const s=O.$bo(f);A.$j&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):A.$k&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):A.$l&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,D?D.uri:void 0,s,n,o)}async resolveAnyAsync(D,f,n){return this.j(D,f,n)}async resolveAnyMap(D,f,n){const o=new Map;return{newConfig:await this.j(D,f,n,o),resolvedVariables:o}}resolveWithInteractionReplace(D,f,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,f,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,f){if(this.h.has(D))throw new Error("Variable "+D+" is contributed twice.");this.h.set(D,f)}async l(D,f,n,o,s){if(I.$cg(n))return this.m(D,f,n,o,s);if(Array.isArray(n))return Promise.all(n.map(l=>this.l(D,f,l,o,s)));if(I.$eg(n)){const l=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(D,f,r,o,s),await this.l(D,f,n[r],o,s)]));for(const[r,t]of i)l[r]=t;return l}return n}m(D,f,n,o,s){return(0,R.$vf)(n,y.VARIABLE_REGEXP,async(l,i)=>{if(i.includes(y.VARIABLE_LHS))return l;let r=await this.o(D,l,i,f,o);return s?.set(i,r),r!==l&&I.$cg(r)&&r.match(y.VARIABLE_REGEXP)&&(r=await this.m(D,f,r,o,s)),r})}n(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async o(D,f,n,o,s){let l;const i=n.split(":");i.length>1&&(n=i[0],l=i[1]);const r=u=>{const p=this.a.getFilePath();if(p)return(0,T.$Xw)(p);throw new a.$UQ(u,(0,$.localize)(2029,null,f))},t=u=>{const p=r(u);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,T.$Xw)(m)}throw new a.$UQ(u,(0,$.localize)(2030,null,f,v.$mc(p)))},g=u=>{if(l){const p=this.a.getFolderUri(l);if(p)return p;throw new a.$UQ(u,(0,$.localize)(2031,null,f,l))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new a.$UQ(u,(0,$.localize)(2032,null,f)):new a.$UQ(u,(0,$.localize)(2033,null,f))};switch(n){case"env":if(l){if(D.env){const u=D.env[A.$j?l.toLowerCase():l];if(I.$cg(u))return u}return""}throw new a.$UQ(a.VariableKind.Env,(0,$.localize)(2034,null,f));case"config":if(l){const u=this.a.getConfigurationValue(o,l);if(I.$lg(u))throw new a.$UQ(a.VariableKind.Config,(0,$.localize)(2035,null,f,l));if(I.$eg(u))throw new a.$UQ(a.VariableKind.Config,(0,$.localize)(2036,null,f,l));return u}throw new a.$UQ(a.VariableKind.Config,(0,$.localize)(2037,null,f));case"command":return this.p(a.VariableKind.Command,f,l,s,"command");case"input":return this.p(a.VariableKind.Input,f,l,s,"input");case"extensionInstallFolder":if(l){const u=await this.a.getExtension(l);if(!u)throw new a.$UQ(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(2038,null,f,l));return this.n(u.extensionLocation)}throw new a.$UQ(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(2039,null,f));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,T.$Xw)(this.n(g(a.VariableKind.WorkspaceFolder)));case"cwd":return o||l?(0,T.$Xw)(this.n(g(a.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Xw)(v.$mc(this.n(g(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new a.$UQ(a.VariableKind.UserHome,(0,$.localize)(2040,null,f))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new a.$UQ(a.VariableKind.LineNumber,(0,$.localize)(2041,null,f))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new a.$UQ(a.VariableKind.SelectedText,(0,$.localize)(2042,null,f))}case"file":return r(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$mc(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||l?v.$kc(this.n(g(a.VariableKind.RelativeFile)),r(a.VariableKind.RelativeFile)):r(a.VariableKind.RelativeFile);case"relativeFileDirname":{const u=v.$lc(r(a.VariableKind.RelativeFileDirname));if(o||l){const p=v.$kc(this.n(g(a.VariableKind.RelativeFileDirname)),u);return p.length===0?".":p}return u}case"fileDirname":return v.$lc(r(a.VariableKind.FileDirname));case"fileExtname":return v.$nc(r(a.VariableKind.FileExtname));case"fileBasename":return v.$mc(r(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=v.$mc(r(a.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-v.$nc(u).length)}case"fileDirnameBasename":return v.$mc(v.$lc(r(a.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||f}case"execInstallFolder":{const u=this.a.getAppRoot();return u||f}case"pathSeparator":case"/":return v.sep;default:try{const u=l?`${n}:${l}`:n;return this.p(a.VariableKind.Unknown,f,u,s,void 0)}catch{return f}}}}p(D,f,n,o,s){if(n&&o){const l=s===void 0?o[n]:o[s+":"+n];if(typeof l=="string")return l;throw new a.$UQ(D,(0,$.localize)(2043,null,f))}return f}}e.$0Q=y}),define(Oe[118],Ne([1,0,3,114]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$jE=void 0,e.$kE=a,e.$lE=c,e.$mE=D,e.$jE=(0,v.$Ci)("editorGroupsService");var I;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var O;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var $;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function a(f){const n=f;return(0,P.$9F)(n?.editor)&&(0,P.$9F)(n?.replacement)}var R;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var y;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function c(f){const n=f;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function D(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?I.DOWN:I.RIGHT}}),define(Oe[203],Ne([1,0,3,118]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.$oE=e.$nE=void 0,e.$rE=I,e.$nE=(0,v.$Ci)("editorService"),e.$oE=-1,e.$pE=-2,e.$qE=-3;function I(O){const A=O;return typeof O=="number"||(0,P.$lE)(A)}}),define(Oe[204],Ne([1,0,3,106]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=void 0,e.$SM=(0,v.$Di)(P.$Ji)}),define(Oe[119],Ne([1,0,18,6,19,4,10]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=e.$Rcc=e.$Qcc=e.$Pcc=void 0,I=qe(I);class T{constructor(l,i){this.versionId=l,this.removedDueToLooping=i}}e.$Pcc=T;class ${static isHostExtension(l,i,r){if(i.getExtensionDescription(l))return!1;const t=r.getExtensionDescription(l);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(l,i){this.j=l,this.c=new P.$je,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new v.$qn,this.g=[],this.h=new Map;for(const l of this.e){if(this.f.has(l.identifier)){console.error("Extension `"+l.identifier.value+"` is already registered");continue}this.f.set(l.identifier,l),this.g.push(l);const i=this.j.readActivationEvents(l);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(l)}}set(l){return this.e=l,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(l,i){this.e=o(this.e,i),this.e=this.e.concat(l);const r=$.l(this.e);return this.e=o(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,r)}static l(l){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(p){this.d.has(p)||(this.d.add(p),this.e.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this.c.has(p)?this.c.get(p).push(m):this.c.set(p,[m])}getArcs(p){return this.c.has(p)?this.c.get(p):[]}hasOnlyGoodArcs(p,m){const h=i.getArcs(p);for(let E=0;E<h.length;E++)if(!m.has(h[E]))return!1;return!0}getNodes(){return this.e}},r=new v.$qn;for(const p of l)if(r.set(p.identifier,p),p.extensionDependencies)for(const m of p.extensionDependencies)i.addArc(v.$on.toKey(p.identifier),v.$on.toKey(m));const t=new Set;i.getNodes().filter(p=>i.getArcs(p).length===0).forEach(p=>t.add(p));const g=i.getNodes().filter(p=>!t.has(p));let u;do{u=!1;for(let p=0;p<g.length;p++){const m=g[p];i.hasOnlyGoodArcs(m,t)&&(g.splice(p,1),p--,t.add(m),u=!0)}}while(u);return g.map(p=>r.get(p))}containsActivationEvent(l){return this.h.has(l)}containsExtension(l){return this.f.has(l)}getExtensionDescriptionsForActivationEvent(l){const i=this.h.get(l);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(l){const i=this.f.get(l);return i||void 0}getExtensionDescriptionByUUID(l){for(const i of this.g)if(i.uuid===l)return i}getExtensionDescriptionByIdOrUUID(l,i){return this.getExtensionDescription(l)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Qcc=$;class a{constructor(l,i){this.versionId=l,this.extensions=i}}e.$Rcc=a;class R{constructor(l){this.d=new D,this.c=new $(l,[])}async acquireLock(l){const i=await this.d.acquire(l);return new y(this,i)}deltaExtensions(l,i,r){if(!l.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(l){return this.c.containsActivationEvent(l)}containsExtension(l){return this.c.containsExtension(l)}getExtensionDescriptionsForActivationEvent(l){return this.c.getExtensionDescriptionsForActivationEvent(l)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(l){return this.c.getExtensionDescription(l)}getExtensionDescriptionByUUID(l){return this.c.getExtensionDescriptionByUUID(l)}getExtensionDescriptionByIdOrUUID(l,i){return this.c.getExtensionDescriptionByIdOrUUID(l,i)}}e.$Scc=R;class y extends O.$Tc{constructor(l,i){super(),this.f=l,this.c=!1,this.B(i)}isAcquiredFor(l){return!this.c&&this.f===l}}e.$Tcc=y;class c{constructor(l){this.name=l;const i=(0,A.$vh)();this.promise=i.promise,this.c=i.resolve}resolve(l){this.c(l)}}class D{constructor(){this.c=[],this.d=!1}async acquire(l){const i=new c(l);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const l=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${l.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};l.resolve((0,O.$Rc)(t))}}var f;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(f||(f={}));function n(s,l){const i=s.isBuiltin?f.Builtin:s.isUnderDevelopment?f.Dev:f.User,r=l.isBuiltin?f.Builtin:l.isUnderDevelopment?f.Dev:f.User;if(i!==r)return i-r;const t=I.$fc.basename(s.extensionLocation.path),g=I.$fc.basename(l.extensionLocation.path);return t<g?-1:t>g?1:0}function o(s,l){const i=new v.$pn(l);return s.filter(r=>!i.has(r.identifier))}}),define(Oe[83],Ne([1,0,22]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$yn=A,e.$zn=T;var P;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(P||(e.UIKind=P={}));var I;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var O;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(a){const R=v.$Le.alloc(1);switch(a){case O.Initialized:R.writeUInt8(1,0);break;case O.Ready:R.writeUInt8(2,0);break;case O.Terminate:R.writeUInt8(3,0);break}return R}function T(a,R){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return R===O.Initialized;case 2:return R===O.Ready;case 3:return R===O.Terminate;default:return!1}}var $;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Oe[66],Ne([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$lQ=e.$kQ=void 0,e.$mQ=o;let f=class extends c.$Tc{constructor(l,i){super(),this.s=l,this.t=i,this.a=this.B(new P.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new P.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=I.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:a.$zp,name:(0,D.localize)(10664,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,O.$_j)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===I.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=I.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=I.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=I.TelemetryLevel.USAGE:!1}}instantiateLogger(l,i,r){const t=this.getTelemetryDetails(),g=new n(i,r,l,this.n,this.j,this.getBuiltInCommonProperties(l),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this.r.get(l.identifier.value)??[];return this.r.set(l.identifier.value,[...u,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(l,i,r){this.f=l,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,$.$fn)((0,a.$Fp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const g=r.filter(u=>!u.isDisposed);g.length===0?this.r.delete(t):this.r.set(t,g)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(l,i){const t=this.r.get(l.value)?.filter(u=>!u.isDisposed);if(!t)return this.r.delete(l.value),!1;let g=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),g=!0);return g}};e.$kQ=f,e.$kQ=f=He([Ve(0,A.$jQ),Ve(1,O.$$j)],f);class n{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,r,t,g,u,p){this.g=r,this.h=t,this.i=g,this.j=u,this.a=new P.$je,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(l,i){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,a.$Ip)(i,[]),this.c&&(i=(0,R.$eo)(i,this.c)),this.b||(i=(0,R.$eo)(i,this.j)),"properties"in l?l.properties=i:l=i,l}k(l,i){this.f&&(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(l,i),this.h.trace(l,i))}logUsage(l,i){this.d.isUsageEnabled&&this.k(l,i)}logError(l,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof l=="string")this.k(l,i);else{const r={name:l.name,message:l.message,stack:l.stack,cause:l.cause},t=(0,a.$Ip)(r,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(g,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let l=this.f;this.f=void 0,Promise.resolve(l.flush()).then(l=void 0),this.e=void 0}else this.f=void 0}}e.$lQ=n;function o(s){const l=Date.now()-new Date(s).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.$nQ=(0,v.$Ci)("IExtHostTelemetry")}),define(Oe[24],Ne([1,0,6,2,177,111,18,3]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.ActivationKind=e.$0G=e.$9G=e.$6G=e.ExtensionHostStartup=e.$5G=e.$4G=e.$3G=e.$2G=void 0,e.$7G=c,e.$8G=D,e.$$G=s,e.$_G=l,e.$2G=Object.freeze({identifier:new A.$on("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$3G="extensions.webWorker",e.$4G=(0,T.$Ci)("extensionService");class ${constructor(t){this.dependency=t}}e.$5G=$;var a;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,g,u){this.c=t,this.d=g.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$NG.createActivationEventsMap(this.d)}}set(t,g,u){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const p=[],m=[],h=[],E=[],S=y(this.d),w=y(g),k=(N,M)=>N.extensionLocation.toString()===M.extensionLocation.toString()||N.isBuiltin===M.isBuiltin||N.isUserBuiltin===M.isUserBuiltin||N.isUnderDevelopment===M.isUnderDevelopment;for(const N of this.d){const M=w.get(N.identifier);if(!M){p.push(N.identifier),S.delete(N.identifier);continue}if(!k(N,M)){p.push(N.identifier),S.delete(N.identifier);continue}}for(const N of g){const M=S.get(N.identifier);if(!M){m.push(N);continue}if(!k(M,N)){p.push(M.identifier),S.delete(M.identifier);continue}}const C=new A.$pn(this.e),d=new A.$pn(u);for(const N of this.e)d.has(N)||h.push(N);for(const N of u)C.has(N)||E.push(N);const b=O.$NG.createActivationEventsMap(m),F={versionId:t,toRemove:p,toAdd:m,addActivationEvents:b,myToRemove:h,myToAdd:E};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:g,toAdd:u,myToRemove:p,myToAdd:m}=t,h=new A.$pn(g),E=new A.$pn(p);for(let S=0;S<this.d.length;S++)h.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)E.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of u)this.d.push(S);for(const S of m)this.e.push(S);return this.f=null,t}containsExtension(t){for(const g of this.e)if(A.$on.equals(g,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const g of this.d){if(!this.containsExtension(g.identifier))continue;const u=O.$NG.readActivationEvents(g);for(const p of u)t.add(p)}return t}}e.$6G=R;function y(r){const t=new A.$qn;for(const g of r)t.set(g.identifier,g);return t}function c(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function D(r,t){if(!c(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class f{constructor(t,g,u,p){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=u,this.activationReason=p}}e.$9G=f;class n{constructor(t,g){this.description=t,this.value=g}}e.$0G=n;var o;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(r){return{type:r.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,I.$Op)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function l(r,t){const g=(0,I.$Mp)(r.manifest.publisher,r.manifest.name);return{id:g,identifier:new A.$on(g),isBuiltin:r.type===A.ExtensionType.System,isUserBuiltin:r.type===A.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$aH=i}),define(Oe[205],Ne([1,0,13,119,18,24,11,10]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=e.$0oc=e.$9oc=e.$8oc=e.$7oc=e.$6oc=void 0,v=qe(v);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,l,i,r){this.startup=s,this.codeLoadingTime=l,this.activateCallTime=i,this.activateResolvedTime=r}}e.$6oc=$;class a{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,l){return s===-1||l===-1?-1:l-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$7oc=a;class R{constructor(s,l,i,r,t,g){this.activationFailed=s,this.activationFailedError=l,this.activationTimes=i,this.module=r,this.exports=t,this.subscriptions=g}}e.$8oc=R;class y extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9oc=y;class c extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0oc=c;class D extends R{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(s,l,i,r){this.g=r,this.a=s,this.b=l,this.c=i,this.d=new I.$qn,this.f=Object.create(null)}dispose(){for(const[s,l]of this.d)l.dispose()}async waitForActivatingExtensions(){const s=[];for(const[l,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const l=this.d.get(s);return!!(l&&l.value)}getActivatedExtension(s){const l=this.d.get(s);if(!l||!l.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return l.value}async activateByEvent(s,l){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(r=>({id:r.identifier,reason:{startup:l,extensionId:r.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,l){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:i.identifier,reason:l}])}async h(s){const l=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(l.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const l=this.a.getExtensionDescription(s.id);if(!l){const t=new Error(`Cannot activate unknown extension '${s.id.value}'`),g=this.k(s,null,[],new D(t));return this.c.onExtensionActivationError(s.id,t,new O.$5G(s.id.value)),g}const i=[],r=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const t of r){if(this.m(t))continue;const g=this.d.get(t);if(g){i.push(g);continue}if(this.l(t)){i.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:s.reason}));continue}const u=this.a.getExtensionDescription(t);if(u){if(!u.main&&!u.browser)continue;i.push(this.j({id:u.identifier,reason:s.reason}));continue}const p=l.displayName||l.identifier.value,m=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${t}'`),h=this.k(s,l.displayName,[],new D(m));return this.c.onExtensionActivationError(l.identifier,m,new O.$5G(t)),h}return this.k(s,l.displayName,i,null)}k(s,l,i,r){const t=new n(s.id,l,s.reason,i,r,this.c,this.g);return this.d.set(s.id,t),t}l(s){return P.$Qcc.isHostExtension(s,this.a,this.b)}m(s){const l=this.b.getExtensionDescription(s);return l?!l.main&&!l.browser:!1}};e.$$oc=f,e.$$oc=f=He([Ve(3,A.$0j)],f);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,l,i,r,t,g,u){this.c=s,this.d=l,this.f=i,this.g=r,this.h=t,this.j=g,this.k=u,this.a=new T.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const l=this.g[s];if(l.value&&!l.value.activationFailed){this.g.splice(s,1),s--;continue}if(l.value&&l.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);i.detail=l.value.activationFailedError,this.h=new D(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const l=new Error;if(s&&s.name&&(l.name=s.name),s&&s.message?l.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:l.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(l.stack=s.stack),this.h=new D(l),this.b&&v.$3(s))return;this.j.onExtensionActivationError(this.c,l,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};n=He([Ve(6,A.$0j)],n)});var ni=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Oe[120],Ne([1,0,9,13,35,110,77,30,18,108,111,104]),function(we,e,v,P,I,O,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=void 0,v=qe(v),I=ni(I);const c=T.$oo.as(A.$po.JSONContribution);class D{constructor(t,g,u){this.a=t,this.b=g,this.c=u}d(t,g){this.a({type:t,message:g,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(I.default.Error,t)}warn(t){this.d(I.default.Warning,t)}info(t){this.d(I.default.Info,t)}}e.$VG=D;class f{static a(t){const g=new $.$pn;for(let u=0,p=t.length;u<p;u++)g.add(t[u].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new f(g,[]);if(!g||!g.length)return new f([],t);const u=this.a(t),p=this.a(g),m=g.filter(E=>!u.has(E.description.identifier)),h=t.filter(E=>!p.has(E.description.identifier));return new f(m,h)}constructor(t,g){this.added=t,this.removed=g}}e.$WG=f;class n{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=f.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,P.$Y)(t)}}}e.$XG=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(1794,null),v.localize(1795,null)]},s="vscode://schemas/vscode-extensions";e.$YG={properties:{engines:{type:"object",description:v.localize(1796,null),properties:{vscode:{type:"string",description:v.localize(1797,null),default:"^1.22.0"}}},publisher:{description:v.localize(1798,null),type:"string"},displayName:{description:v.localize(1799,null),type:"string"},categories:{description:v.localize(1800,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$nn},{type:"string",const:"Languages",deprecationMessage:v.localize(1801,null)}]}},galleryBanner:{type:"object",description:v.localize(1802,null),properties:{color:{description:v.localize(1803,null),type:"string"},theme:{description:v.localize(1804,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(1805,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(1806,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(1807,null)},enabledApiProposals:{markdownDescription:v.localize(1808,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:v.localize(1809,null),type:"string",enum:["none"],enumDescriptions:[v.localize(1810,null)]},activationEvents:{description:v.localize(1811,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(1812,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(1813,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(1814,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(1815,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(1816,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(1817,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(1818,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(1819,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(1820,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(1821,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(1822,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(1823,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(1824,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(1825,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(1826,null)},{label:"onUri",body:"onUri",description:v.localize(1827,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(1828,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(1829,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(1830,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(1831,null)},{label:"onRenderer",description:v.localize(1832,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(1833,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(1834,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(1835,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(1836,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(1837,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(1838,null)},{label:"*",description:v.localize(1839,null),body:"*"}]}},badges:{type:"array",description:v.localize(1840,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(1841,null)},href:{type:"string",description:v.localize(1842,null)},description:{type:"string",description:v.localize(1843,null)}}}},markdown:{type:"string",description:v.localize(1844,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(1845,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(1846,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionPack:{description:v.localize(1847,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionKind:{description:v.localize(1848,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(1849,null)},{body:["workspace"],description:v.localize(1850,null)},{body:["ui","workspace"],description:v.localize(1851,null)},{body:["workspace","ui"],description:v.localize(1852,null)},{body:[],description:v.localize(1853,null)}]},capabilities:{description:v.localize(1854,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(1855,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(1856,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1857,null),v.localize(1858,null),v.localize(1859,null)]},description:{type:"string",markdownDescription:v.localize(1860,null)}}},untrustedWorkspaces:{description:v.localize(1861,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(1862,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1863,null),v.localize(1864,null),v.localize(1865,null)]},restrictedConfigurations:{description:v.localize(1866,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(1867,null)}}}}},sponsor:{description:v.localize(1868,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(1869,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(1870,null),type:"string"},"vscode:uninstall":{description:v.localize(1871,null),type:"string"}}},icon:{type:"string",description:v.localize(1872,null)},l10n:{type:"string",description:v.localize(1873,null)},pricing:{type:"string",markdownDescription:v.localize(1874,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,g),t.activationEventsGenerator&&R.$NG.register(t.extensionPoint,t.activationEventsGenerator),e.$YG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,c.registerSchema(s,e.$YG),g}getExtensionPoints(){return Array.from(this.a.values())}}e.$ZG=l;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$oo.add(i.ExtensionsRegistry,new l),e.$1G=T.$oo.as(i.ExtensionsRegistry),c.registerSchema(s,e.$YG),c.registerSchema(a.$rk,{properties:{extensionEnabledApiProposals:{description:v.localize(1875,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Oe[206],Ne([1,0,6,39,4,12,9,18,3,11,24,120]),function(we,e,v,P,I,O,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.$bH=e.ChatMessageRole=void 0;var c;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(c||(e.ChatMessageRole=c={})),e.$bH=(0,$.$Ci)("ILanguageModelsService");const D={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(8283,null)}}};e.$cH=y.$1G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(8284,null),oneOf:[D,{type:"array",items:D}]},activationEventsGenerator:(n,o)=>{for(const s of n)o.push(`onLanguageModelChat:${s.vendor}`)}});let f=class{constructor(o,s){this.e=o,this.f=s,this.a=new I.$Sc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$cH.setHandler(l=>{this.c.clear();for(const r of l){if(!(0,R.$7G)(r.description,"chatProvider")){r.collector.error((0,A.localize)(8285,null));continue}for(const t of P.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,A.localize)(8286,null,t.vendor));continue}if((0,O.$af)(t.vendor)){r.collector.error((0,A.localize)(8287,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,A.localize)(8288,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const l=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(l)}const s=[];for(const[l,i]of this.b)(o.vendor===void 0||i.metadata.vendor===o.vendor)&&(o.family===void 0||i.metadata.family===o.family)&&(o.version===void 0||i.metadata.version===o.version)&&(o.identifier===void 0||i.metadata.id===o.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>T.$on.equals(r,o.extension)))&&s.push(l);return this.f.trace("[LM] selected language models",o,s),s}registerLanguageModelChat(o,s){if(this.f.trace("[LM] registering language model chat",o,s.metadata),!this.c.has(s.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${s.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,s),this.d.fire({added:[{identifier:o,metadata:s.metadata}]}),(0,I.$Rc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,s.metadata))})}async sendChatRequest(o,s,l,i,r){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.sendChatRequest(l,s,i,r)}computeTokenLength(o,s,l){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideTokenCount(s,l)}};e.$dH=f,e.$dH=f=He([Ve(0,R.$4G),Ve(1,a.$0j)],f)}),define(Oe[207],Ne([1,0,9,14,25,120,31,6]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$II=void 0,v=qe(v),P=qe(P),I=qe(I);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(3864,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(3865,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(3866,null),default:""}}};var a;(function(c){function D(f,n,o){if(!f)return;const s=P.$cg(f.type)?f.type:void 0;if(!s||s.length===0){o.error(v.localize(3867,null));return}const l=[];if(Array.isArray(f.required))for(const i of f.required)P.$cg(i)&&l.push(i);return{extensionId:n.value,taskType:s,required:l,properties:f.properties?I.$bo(f.properties):{},when:f.when?A.$Aj.deserialize(f.when):void 0}}c.from=D})(a||(a={}));const R=O.$1G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,D)=>{for(const f of c)f.type&&D.push(`onTaskType:${f.type}`)},jsonSchema:{description:v.localize(3868,null),type:"array",items:$}});class y{constructor(){this.d=new T.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,f)=>{R.setHandler((n,o)=>{this.c=void 0;try{for(const s of o.removed){const l=s.value;for(const i of l)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const l=s.value;for(const i of l){const r=a.from(i,s.description.identifier,s.collector);r&&(this.a[r.taskType]=r)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const f of this.all()){const n={type:"object",additionalProperties:!1};f.required.length>0&&(n.required=f.required.slice(0)),f.properties!==void 0?n.properties=I.$bo(f.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[f.taskType]},D.push(n)}this.c={oneOf:D}}return this.c}}e.$II=new y}),define(Oe[208],Ne([1,0,9,14,23,25,31,207,43]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$SI=e.JsonSchemaVersion=e.ExecutionEngine=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$MI=e.ShellQuoting=e.$LI=e.$KI=e.$JI=void 0,v=qe(v),P=qe(P),I=qe(I),O=qe(O),e.$JI="settings",e.$KI=new A.$Tj("taskRunning",!1,v.localize(3852,null)),e.$LI=v.localize2(3854,"Tasks");var a;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$MI="$customized",function(L){function Y(Z){if(!Z)return L.Strong;switch(Z.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=Y}(a||(e.ShellQuoting=a={}));var R;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var y;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(y||(e.RevealKind=y={})),function(L){function Y(Z){switch(Z.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=Y}(y||(e.RevealKind=y={}));var c;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(c||(e.RevealProblemKind=c={})),function(L){function Y(Z){switch(Z.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=Y}(c||(e.RevealProblemKind=c={}));var D;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(D||(e.PanelKind=D={})),function(L){function Y(Z){switch(Z.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=Y}(D||(e.PanelKind=D={}));var f;(function(L){L.defaults={echo:!0,reveal:y.Always,revealProblems:c.Never,focus:!1,panel:D.Shared,showReuseMessage:!0,clear:!1}})(f||(e.PresentationOptions=f={}));var n;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(L){function Y(ge){switch(ge.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=Y;function Z(ge){switch(ge){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=Z}(n||(e.RuntimeType=n={}));var o;(function(L){function Y(Z){return P.$cg(Z)?Z:Z.value}L.value=Y})(o||(e.CommandString=o={}));var s;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function Y(ge){return ge===L.Clean._id||ge===L.Build._id||ge===L.Rebuild._id||ge===L.Test._id}L.is=Y;function Z(ge){if(ge!==void 0)return P.$cg(ge)?Y(ge)?{_id:ge,isDefault:!1}:void 0:ge}L.from=Z})(s||(e.TaskGroup=s={}));var l;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function Y(Z){switch(Z){case L.User:return $.ConfigurationTarget.USER;case L.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}L.toConfigurationTarget=Y})(i||(e.TaskSourceKind=i={}));var r;(function(L){L.parallel="parallel",L.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class u{constructor(Y,Z,ge,_,fe,se){this._label="",this._id=Y,Z&&(this._label=Z),ge&&(this.type=ge),this.runOptions=_,this.configurationProperties=fe,this._source=se}getDefinition(Y){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const Y={folder:this.d(),id:this._id};return JSON.stringify(Y)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(Y,Z=!1){if(Y===void 0)return!1;if(P.$cg(Y))return Y===this._label||Y===this.configurationProperties.identifier||Z&&Y===this._id;const ge=this.getDefinition(!0);return ge!==void 0&&ge._key===Y._key}getQualifiedLabel(){const Y=this.getWorkspaceFolder();return Y?`${this._label} (${Y.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(Y){this.c===void 0&&(this.c=[]),Y&&(this.c=this.c.concat(Y))}get taskLoadMessages(){return this.c}}e.$NI=u;class p extends u{constructor(Y,Z,ge,_,fe,se,ce,$e){super(Y,ge,void 0,ce,$e,Z),this.command={},this._source=Z,this.hasDefinedMatchers=se,fe&&(this.command=fe)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(Y=!1){if(Y&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case n.Shell:Z="shell";break;case n.Process:Z="process";break;case n.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(Y){return Y instanceof p}getMapKey(){const Y=this._source.config.workspaceFolder;return Y?`${Y.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$JI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const Y=this.d();if(!Y)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const ge={type:e.$MI,folder:Y,id:Z};return JSON.stringify(ge)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(Y){return new p(Y._id,Y._source,Y._label,Y.type,Y.command,Y.hasDefinedMatchers,Y.runOptions,Y.configurationProperties)}}e.$OI=p;class m extends u{constructor(Y,Z,ge,_,fe,se,ce){super(Y,ge,_,se,ce,Z),this._source=Z,this.configures=fe}static is(Y){return Y instanceof m}f(Y){return Y}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$JI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const Y=this.d();if(!Y)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const ge={type:e.$MI,folder:Y,id:Z};return JSON.stringify(ge)}}e.$PI=m;class h extends u{constructor(Y,Z,ge,_,fe,se,ce,$e,oe){super(Y,ge,_,$e,oe,Z),this.defines=fe,this.hasDefinedMatchers=ce,this.command=se,this.icon=oe.icon,this.hide=oe.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(Y){return Y instanceof h}getMapKey(){const Y=this._source.workspaceFolder;return Y?`${this._source.scope.toString()}|${Y.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===l.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const Y={type:"contributed",scope:this._source.scope,id:this._id};return Y.folder=this.d(),JSON.stringify(Y)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(Y){return new h(Y._id,Y._source,Y._label,Y.type,Y.defines,Y.command,Y.hasDefinedMatchers,Y.runOptions,Y.configurationProperties)}}e.$QI=h;class E extends u{constructor(Y,Z,ge,_,fe,se){super(Y,ge,_,fe,se,Z),this._source=Z}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(Y){return Y instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(Y){return new E(Y._id,Y._source,Y._label,Y.type,Y.runOptions,Y.configurationProperties)}}e.$RI=E;var S;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(L){L._default=L.Terminal}(S||(e.ExecutionEngine=S={}));var w;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class k{constructor(Y){this.c=new Map;for(let Z=0;Z<Y.length;Z++)this.c.set(Y[Z].uri.toString(),Z)}compare(Y,Z){const ge=Y.getWorkspaceFolder(),_=Z.getWorkspaceFolder();if(ge&&_){let fe=this.c.get(ge.uri.toString());fe=fe===void 0?0:fe+1;let se=this.c.get(_.uri.toString());return se=se===void 0?0:se+1,fe===se?Y._label.localeCompare(Z._label):fe-se}else return!ge&&_?-1:ge&&!_?1:0}}e.$SI=k;var C;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(C||(e.TaskEventKind=C={}));var d;(function(L){L.SingleRun="singleRun",L.Background="background"})(d||(e.TaskRunType=d={}));var b;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var F;(function(L){function Y($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?d.Background:d.SingleRun,group:$e.configurationProperties.group,__task:$e}}function Z($e,oe,Ce){return{...Y($e),kind:C.Start,terminalId:oe,resolvedVariables:Ce}}L.start=Z;function ge($e,oe,Ce){return{...Y($e),kind:C.ProcessStarted,terminalId:oe,processId:Ce}}L.processStarted=ge;function _($e,oe,Ce){return{...Y($e),kind:C.ProcessEnded,terminalId:oe,exitCode:Ce}}L.processEnded=_;function fe($e,oe,Ce){return{...Y($e),kind:C.Terminated,exitReason:Ce,terminalId:oe}}L.terminated=fe;function se($e,oe,Ce){return{...Y(oe),kind:$e,terminalId:Ce}}L.general=se;function ce(){return{kind:C.Changed}}L.changed=ce})(F||(e.TaskEvent=F={}));var N;(function(L){function Y(ge){const _=Object.keys(ge).sort();let fe="";for(const se of _){let ce=ge[se];ce instanceof Object?ce=Y(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),fe+=se+","+ce+","}return fe}function Z(ge){const fe={_key:Y(ge),type:ge.taskType};return Object.assign(fe,ge),fe}L.create=Z})(N||(e.KeyedTaskIdentifier=N={}));var M;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var V;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var W;(function(L){function Y(Z,ge){const _=T.$II.get(Z.type);if(_===void 0){const $e=O.$bo(Z);return delete $e._key,N.create($e)}const fe=Object.create(null);fe.type=_.taskType;const se=new Set;_.required.forEach($e=>se.add($e));const ce=_.properties;for(const $e of Object.keys(ce)){const oe=Z[$e];if(oe!=null)fe[$e]=oe;else if(se.has($e)){const Ce=ce[$e];if(Ce.default!==void 0)fe[$e]=O.$bo(Ce.default);else switch(Ce.type){case"boolean":fe[$e]=!1;break;case"number":case"integer":fe[$e]=0;break;case"string":fe[$e]="";break;default:ge.error(v.localize(3853,null,JSON.stringify(Z,void 0,0),$e));return}}}return N.create(fe)}L.createTaskIdentifier=Y})(W||(e.TaskDefinition=W={}))}),define(Oe[209],Ne([1,0,13]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$Y)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Ucc=P;class I extends P{constructor(){super(),this.h=!0,this.i=new v.$4}}e.$Vcc=I}),define(Oe[38],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Rw=void 0,e.$Sw=I,e.$Tw=O;class v{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++v.count}}e.$Rw=v;const P=[];function I(T){const $=new v(T);return P[$.nid]=$,$}function O(T){return P[T].sid}class A{constructor($){this.value=$}}e.$Uw=A}),define(Oe[5],Ne([1,0,38]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(P||(e.TextEditorRevealType=P={}));var I;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var $;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var a;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var R;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$uN=y;var c;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var D;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(D||(e.ISuggestResultDtoField=D={}));var f;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$vN={MainThreadAuthentication:(0,v.$Sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Sw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Sw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Sw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Sw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Sw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Sw)("MainThreadCommands"),MainThreadComments:(0,v.$Sw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Sw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Sw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Sw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Sw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Sw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Sw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Sw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Sw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Sw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Sw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Sw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Sw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Sw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Sw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Sw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Sw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Sw)("MainThreadSCM"),MainThreadSearch:(0,v.$Sw)("MainThreadSearch"),MainThreadShare:(0,v.$Sw)("MainThreadShare"),MainThreadTask:(0,v.$Sw)("MainThreadTask"),MainThreadWindow:(0,v.$Sw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Sw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Sw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Sw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Sw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Sw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Sw)("MainThreadAiEmbeddingVector")},e.$wN={ExtHostCommands:(0,v.$Sw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Sw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Sw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Sw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Sw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Sw)("ExtHostSCM"),ExtHostSearch:(0,v.$Sw)("ExtHostSearch"),ExtHostTask:(0,v.$Sw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Sw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Sw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Sw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Sw)("ExtHostProgress"),ExtHostComments:(0,v.$Sw)("ExtHostComments"),ExtHostSecretState:(0,v.$Sw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Sw)("ExtHostStorage"),ExtHostUrls:(0,v.$Sw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Sw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Sw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Sw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Sw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Sw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Sw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Sw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Sw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Sw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Sw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Sw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Sw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Sw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Sw)("ExtHostLocalization")}}),define(Oe[84],Ne([1,0,3,11,5,16]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=e.$toc=e.$soc=void 0,I=qe(I),e.$soc=(0,v.$Ci)("IExtHostApiDeprecationService");let A=class{constructor($,a){this.c=a,this.a=new Set,this.b=$.getProxy(I.$vN.MainThreadTelemetry)}report($,a,R){const y=this.d($,a);this.a.has(y)||(this.a.add(y),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:$}))}d($,a){return`${$}-${a.identifier.value}`}};e.$toc=A,e.$toc=A=He([Ve(0,O.$6P),Ve(1,P.$0j)],A),e.$uoc=Object.freeze(new class{report(T,$,a){}})}),define(Oe[210],Ne([1,0,5]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=void 0;class P{constructor(O){const A=O.getProxy(v.$vN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$Hoc=P}),define(Oe[211],Ne([1,0,25,5,26,16]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0;let A=class{constructor(R,y){this.a=R.getProxy(P.$vN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,y){const c=this,D=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){c.e(R,y,D,arguments)}})}e(R,y,c,D){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(D,this.b)}),this.c&&this.f(R,c,D)}};e.$Dqc=A,e.$Dqc=A=He([Ve(0,O.$6P),Ve(1,I.$jQ)],A);const T=1e5;function $(a,R){const y=[];if(a.length)for(let c=0;c<a.length;c++){let D=a[c];if(typeof D>"u")D="undefined";else if(D instanceof Error){const f=D;f.stack?D=f.stack:D=f.toString()}y.push(D)}if(R){const c=new Error().stack;c&&y.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,v.$go)(y);return c.length>T?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Oe[212],Ne([1,0,2,5,24]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;class O{constructor(T){this.a=T.getProxy(P.$vN.MainThreadDialogs)}showOpenDialog(T,$){return $?.allowUIResources&&(0,I.$8G)(T,"showLocal"),this.a.$showOpenDialog($).then(a=>a?a.map(R=>v.URI.revive(R)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then($=>$?v.URI.revive($):void 0)}}e.$Jpc=O}),define(Oe[213],Ne([1,0,21,6,4,5]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0;class A{constructor($){this.b=new Map,this.c=new P.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(O.$vN.MainThreadEmbeddings)}registerEmbeddingsProvider($,a,R){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,a),this.b.set(y,{id:a,provider:R}),(0,I.$Rc)(()=>{this.d.delete(a),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings($,a,R){R??=v.CancellationToken.None;let y=!1;typeof a=="string"&&(a=[a],y=!0);const c=await this.a.$computeEmbeddings($,a,R);if(c.length!==a.length)throw new Error;if(y){if(c.length!==1)throw new Error;return c[0]}return c}async $provideEmbeddings($,a,R){const y=this.b.get($);if(!y)return[];const c=await y.provider.provideEmbeddings(a,R);return c||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$Mpc=A}),define(Oe[214],Ne([1,0,4,5]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=void 0;class I{constructor(A){this.b=0,this.a=A.getProxy(P.$vN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,v.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$4pc=I}),define(Oe[85],Ne([1,0,20,12,2,3,11,5,26,16]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=e.$mpc=void 0;let R=class{constructor(c,D,f){this.f=f,this.d=new Map,this.a=D.getProxy(T.$vN.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===v.$h}getMessage(c,D){const{message:f,args:n,comment:o}=D;if(this.c)return(0,P.$cf)(f,n??{});let s=f;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const l=this.d.get(c)?.contents[s];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,P.$cf)(l??f,n??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let D;const f=await this.g(c);if(!f){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(f),o=JSON.parse(n);D=c.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${c.identifier.value} from ${f}: ${n.message}`);return}D&&this.d.set(c.identifier.value,{contents:D,uri:f})}async g(c){if(c.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return I.URI.revive(D)}return c.l10n?I.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$mpc=R,e.$mpc=R=He([Ve(0,$.$jQ),Ve(1,a.$6P),Ve(2,A.$0j)],R),e.$npc=(0,O.$Ci)("IExtHostLocalizationService")}),define(Oe[215],Ne([1,0,11,5,26,16,2,40]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0;let $=class extends v.$ik{constructor(y,c){super(c.logLevel,c.logsLocation,c.loggers.map(D=>(0,T.$_h)(D))),this.r=y.getProxy(P.$vN.MainThreadLogger)}$setLogLevel(y,c){c?this.setLogLevel(A.URI.revive(c),y):this.setLogLevel(y)}setVisibility(y,c){super.setVisibility(y,c),this.r.$setVisibility(y,c)}s(y,c,D){return new a(this.r,y,c,D)}};e.$Cqc=$,e.$Cqc=$=He([Ve(0,O.$6P),Ve(1,I.$jQ)],$);class a extends v.$dk{constructor(y,c,D,f){super(f?.logLevel==="always"),this.r=y,this.s=c,this.m=!1,this.n=[],this.setLevel(D),this.r.$createLogger(c,f).then(()=>{this.u(this.n),this.m=!0})}g(y,c){const D=[[y,c]];this.m?this.u(D):this.n.push(...D)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Oe[86],Ne([1,0,5,3,4,16,22]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=void 0,e.$opc=(0,P.$Ci)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$vN.MainThreadManagedSockets)}setFactory(y,c){for(const D of this.d.values())D.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const c=++this.b,D=await this.c.makeConnection(),f=new I.$Sc;return this.d.set(c,new a(c,D,f)),f.add((0,I.$Rc)(()=>this.d.delete(c))),f.add(D.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),f.dispose()})),f.add(D.onDidClose(n=>{this.a.$onDidManagedSocketClose(c,n?.stack??n?.message),f.dispose()})),f.add(D.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(c,A.$Le.wrap(n)))),c}$remoteSocketWrite(y,c){this.d.get(y)?.actual.send(c.buffer)}$remoteSocketEnd(y){const c=this.d.get(y);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$ppc=T,e.$ppc=T=He([Ve(0,O.$6P)],T);class ${constructor(y,c){this.socketFactoryId=y,this.makeConnection=c}}class a extends I.$Tc{constructor(y,c,D){super(),this.socketId=y,this.actual=c,this.B(D)}}}),define(Oe[216],Ne([1,0,5,11,24]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0;function O(T){return T&&T.title}let A=class{constructor($,a){this.b=a,this.a=$.getProxy(v.$vN.MainThreadMessageService)}showMessage($,a,R,y,c){const D={source:{identifier:$.identifier,label:$.displayName||$.name}};let f;typeof y=="string"||O(y)?f=[y,...c]:(D.modal=y?.modal,D.useCustom=y?.useCustom,D.detail=y?.detail,f=c),D.useCustom&&(0,I.$8G)($,"resolvers");const n=[];let o=!1;for(let s=0;s<f.length;s++){const l=f[s];if(typeof l=="string")n.push({title:l,handle:s,isCloseAffordance:!1});else if(typeof l=="object"){const{title:i,isCloseAffordance:r}=l;n.push({title:i,isCloseAffordance:!!r,handle:s}),r&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,l):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,l)}return this.a.$showMessage(a,R,D,n).then(s=>{if(typeof s=="number")return f[s]})}};e.$7pc=A,e.$7pc=A=He([Ve(1,P.$0j)],A)}),define(Oe[217],Ne([1,0,4,14,2,24,5]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=void 0;class T{constructor(a){this.b=new Map,this.a=a.getProxy(A.$vN.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,R,y){if((0,O.$8G)(a,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,y),this.a.$registerProfileContentHandler(R,y.name,y.description,a.identifier.value),(0,v.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(a,R,y,c){const D=this.b.get(a);if(!D)throw new Error(`Unknown handler with id: ${a}`);return D.saveProfile(R,y,c)}async $readProfile(a,R,y){const c=this.b.get(a);if(!c)throw new Error(`Unknown handler with id: ${a}`);return c.readProfile((0,P.$cg)(R)?R:I.URI.revive(R),y)}}e.$dqc=T}),define(Oe[87],Ne([1,0,5,6,3]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=void 0;class O{constructor(T){this.b=new P.$je,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$vN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,$){return this.a.$getPassword(T,$)}store(T,$,a){return this.a.$setPassword(T,$,a)}delete(T,$){return this.a.$deletePassword(T,$)}}e.$jpc=O,e.$kpc=(0,I.$Ci)("IExtHostSecretState")}),define(Oe[218],Ne([1,0,21,4,5]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(I.$vN.MainThreadSpeech)}async $createSpeechToTextSession(T,$,a){const R=this.c.get(T);if(!R)return;const y=new P.$Sc,c=new v.$ue;this.d.set($,c);const D=await R.provideSpeechToTextSession(c.token,a?{language:a}:void 0);D&&(y.add(D.onDidChange(f=>{c.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,f)})),y.add(c.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,$,a){const R=this.c.get(T);if(!R)return;const y=new P.$Sc,c=new v.$ue;this.d.set($,c);const D=await R.provideTextToSpeechSession(c.token,a?{language:a}:void 0);D&&(this.f.set($,D),y.add(D.onDidChange(f=>{c.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,f)})),y.add(c.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,$){this.f.get(T)?.synthesize($)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,$){const a=this.c.get(T);if(!a)return;const R=new P.$Sc,y=new v.$ue;this.d.set($,y);const c=await a.provideKeywordRecognitionSession(y.token);c&&(R.add(c.onDidChange(D=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,D)})),R.add(y.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,$,a){const R=O.a++;return this.c.set(R,a),this.b.$registerProvider(R,$,{extension:T,displayName:T.value}),(0,P.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$kqc=O}),define(Oe[88],Ne([1,0,5,6,3]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=e.$_oc=void 0;class O{constructor(T,$){this.c=$,this.b=new P.$je,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$vN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,$){this.a.$registerExtensionStorageKeysToSync(T,$)}async initializeExtensionStorage(T,$,a){const R=await this.a.$initializeExtensionStorage(T,$);let y;return R&&(y=this.d(T,$,R)),y||a}setValue(T,$,a){return this.a.$setValue(T,$,a)}$acceptValue(T,$,a){const R=this.d(T,$,a);R&&this.b.fire({shared:T,key:$,value:R})}d(T,$,a){try{return JSON.parse(a)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${T}): ${R}`)}}}e.$_oc=O,e.$apc=(0,I.$Ci)("IExtHostStorage")}),define(Oe[219],Ne([1,0,4,15,2,5]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0;class A{static{this.a=new Set([P.Schemas.http,P.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(O.$vN.MainThreadUriOpeners)}registerExternalUriOpener($,a,R,y){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const c=y.schemes.find(D=>!A.a.has(D));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set(a,R),this.b.$registerUriOpener(a,y.schemes,$,y.label),(0,v.$Rc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri($,a,R){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const c=I.URI.revive(a);return y.canOpenExternalUri(c,R)}async $openUri($,a,R){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(I.URI.revive(a.resolvedUri),{sourceUri:I.URI.revive(a.sourceUri)},R)}}e.$wqc=A}),define(Oe[220],Ne([1,0,5,2,4,13,18]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;class T{static{this.a=0}constructor(a){this.c=new A.$pn,this.d=new Map,this.b=a.getProxy(v.$vN.MainThreadUrls)}registerUriHandler(a,R){const y=a.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const c=T.a++;return this.c.add(y),this.d.set(c,R),this.b.$registerUriHandler(c,y,a.displayName||a.name),(0,I.$Rc)(()=>{this.c.delete(y),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri(a,R){const y=this.d.get(a);if(!y)return Promise.resolve(void 0);try{y.handleUri(P.URI.revive(R))}catch(c){(0,O.$Y)(c)}return Promise.resolve(void 0)}async createAppUri(a){return P.URI.revive(await this.b.$createAppUri(a))}}e.$xqc=T}),define(Oe[221],Ne([1,0,22,5]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wtb=O,e.$xtb=T,P=qe(P);class I{constructor(){this.buffers=[]}add(a){let R=this.buffers.indexOf(a);return R<0&&(R=this.buffers.length,this.buffers.push(a)),R}}function O($,a){if(a.serializeBuffersForPostMessage){const R=new I,c=JSON.stringify($,(f,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n)};if(ArrayBuffer.isView(n)){const o=A(n);if(o)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n.buffer),view:{type:o,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),D=R.buffers.map(f=>{const n=new Uint8Array(f);return v.$Le.wrap(n)});return{message:c,buffers:D}}else return{message:JSON.stringify($),buffers:[]}}function A($){switch($.constructor.name){case"Int8Array":return P.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return P.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return P.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return P.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return P.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return P.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return P.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return P.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return P.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return P.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return P.WebviewMessageArrayBufferViewType.BigUint64Array}}function T($,a){const R=a.map(D=>{const f=new ArrayBuffer(D.byteLength);return new Uint8Array(f).set(D.buffer),f}),y=a.length?(D,f)=>{if(f&&typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const n=f,{index:o}=n,s=R[o];if(n.view)switch(n.view.type){case P.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(s,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(s,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(s,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(s,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(s,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(s,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(s,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(s,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(s,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(s,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(s,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return f}:void 0;return{message:JSON.parse($,y),arrayBuffers:R}}}),define(Oe[67],Ne([1,0,6,4,15,25,2,174,221,82,5]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=e.$Woc=void 0,e.$Xoc=c,e.$Zoc=n,e.$1oc=o,O=qe(O),R=qe(R);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(r,t,g,u,p,m,h){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$je,this._onDidDispose=this.#h.event,this.#e=r,this.#t=t,this.#o=g,this.#n=u,this.#s=p,this.#r=m,this.#u=c(m),this.#d=D(m),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#l=!0,(0,a.$gDb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===I.Schemas.https||r.scheme===I.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+a.$fDb}return a.$fDb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),O.$fo(this.#o,r)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const t=(0,$.$wtb)(r,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const t=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,p,m,h,E,S)=>{const w=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),k=(0,a.$gDb)(w,{isRemote:t,authority:g}).toString();return`${p}${k}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,p,m,h,E,S)=>{const w=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),k=(0,a.$gDb)(w,{isRemote:t,authority:g}).toString();return`${p}${k}${S}`})}}e.$Woc=y;function c(i){try{const r=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function D(i){try{const r=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class f extends P.$Tc{constructor(r,t,g,u,p){super(),this.c=t,this.f=g,this.g=u,this.h=p,this.b=new Map,this.a=r.getProxy(R.$vN.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,t,g){const u=this.j(r);if(u){const{message:p}=(0,$.$xtb)(t,g.value);u._onMessageEmitter.fire(p)}}$onMissingCsp(r,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,g){const u=new y(r,this.a,s(t),this.c,this.f,g,this.h);this.b.set(r,u);const p=u._onDidDispose(()=>{p.dispose(),this.deleteWebview(r)});return u}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Yoc=f;function n(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||l(i,r)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function l(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Oe[121],Ne([1,0,6,15,12,2,3,16,5]),function(we,e,v,P,I,O,A,T,$){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=e.$zqc=void 0;let R=class{static{a=this}static{this.a={focused:!0,active:!0}}getState(){const c=this.d;return{get focused(){return c.focused},get active(){return c.active}}}constructor(c){this.c=new v.$je,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=c.getProxy($.$vN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:f})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,D){D!==this.d[c]&&(this.d={...this.d,[c]:D},this.c.fire(this.d))}openUri(c,D){let f;if(typeof c=="string"){f=c;try{c=O.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,I.$af)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this.b.$openUri(c,f,D)}async asExternalUri(c,D){if((0,I.$af)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(c,D);return O.URI.from(f)}};e.$zqc=R,e.$zqc=R=a=He([Ve(0,T.$6P)],R),e.$Aqc=(0,A.$Ci)("IExtHostWindow")}),define(Oe[222],Ne([1,0,211,26,16]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nsc=void 0;let O=class extends v.$Dqc{constructor(T,$){super(T,$)}f(T,$,a){$.apply(console,a)}};e.$Nsc=O,e.$Nsc=O=He([Ve(0,I.$6P),Ve(1,P.$jQ)],O)}),define(Oe[223],Ne([1,0,10,22,21,27,13,6,4,36,149,209,38]),function(we,e,v,P,I,O,A,T,$,a,R,y,c){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Wcc=l,e.$Xcc=i,A=qe(A);function f(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const n="$$ref$$",o={[n]:-1};class s{constructor(N,M){this.jsonString=N,this.referencedBuffers=M}}function l(F,N=null,M=!1){const V=[];return{jsonString:(M?f:JSON.stringify)(F,(L,Y)=>{if(typeof Y>"u")return o;if(typeof Y=="object"){if(Y instanceof P.$Le){const Z=V.push(Y)-1;return{[n]:Z}}if(N)return N(L,Y)}return Y}),referencedBuffers:V}}function i(F,N,M){return JSON.parse(F,(V,W)=>{if(W){const L=W[n];if(typeof L=="number")return N[L];if(M&&W.$mid===a.MarshalledId.Uri)return M.transformIncoming(W)}return W})}function r(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,M)=>M&&M.$mid===a.MarshalledId.Uri?F.transformOutgoing(M):M:null}var g;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const p=()=>{},m=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class E extends $.$Tc{static{D=m}static{this.a=3*1e3}constructor(N,M=null,V=null){super(),this[D]=!0,this.b=this.B(new T.$je),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=M,this.g=V,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,L=c.$Rw.count;W<L;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=u.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(W=>this.L(W)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const M=this.w[N];delete this.w[N],M.resolveErr(A.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(u.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(u.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,R.$Mn)(N,this.g):N}getProxy(N){const{nid:M,sid:V}=N;return this.s[M]||(this.s[M]=this.J(M,V)),this.s[M]}J(N,M){const V={get:(W,L)=>(typeof L=="string"&&!W[L]&&L.charCodeAt(0)===O.CharCode.DollarSign&&(W[L]=(...Y)=>this.U(N,L,Y)),L===h?M:W[L])};return new Proxy(Object.create(null),V)}set(N,M){return this.m[N.nid]=M,M}assertRegistered(N){for(let M=0,V=N.length;M<V;M++){const W=N[M];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(N){if(this.j)return;const M=N.byteLength,V=w.read(N,0),W=V.readUInt8(),L=V.readUInt32();switch(W){case d.RequestJSONArgs:case d.RequestJSONArgsWithCancellation:{let{rpcId:Y,method:Z,args:ge}=C.deserializeRequestJSONArgs(V);this.g&&(ge=(0,R.$Mn)(ge,this.g)),this.M(M,L,Y,Z,ge,W===d.RequestJSONArgsWithCancellation);break}case d.RequestMixedArgs:case d.RequestMixedArgsWithCancellation:{let{rpcId:Y,method:Z,args:ge}=C.deserializeRequestMixedArgs(V);this.g&&(ge=(0,R.$Mn)(ge,this.g)),this.M(M,L,Y,Z,ge,W===d.RequestMixedArgsWithCancellation);break}case d.Acknowledged:{this.f?.logIncoming(M,L,g.LocalSide,"ack"),this.G(L);break}case d.Cancel:{this.N(M,L);break}case d.ReplyOKEmpty:{this.O(M,L,void 0);break}case d.ReplyOKJSON:{let Y=C.deserializeReplyOKJSON(V);this.g&&(Y=(0,R.$Mn)(Y,this.g)),this.O(M,L,Y);break}case d.ReplyOKJSONWithBuffers:{const Y=C.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(M,L,Y);break}case d.ReplyOKVSBuffer:{const Y=C.deserializeReplyOKVSBuffer(V);this.O(M,L,Y);break}case d.ReplyErrError:{let Y=C.deserializeReplyErrError(V);this.g&&(Y=(0,R.$Mn)(Y,this.g)),this.P(M,L,Y);break}case d.ReplyErrEmpty:{this.P(M,L,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,M,V,W,L,Y){this.f?.logIncoming(N,M,g.OtherSide,`receiveRequest ${(0,c.$Tw)(V)}.${W}(`,L);const Z=String(M);let ge,_;if(Y){const se=new I.$ue;L.push(se.token),ge=this.Q(V,W,L),_=()=>se.cancel()}else ge=this.Q(V,W,L),_=p;this.u[Z]=_;const fe=C.serializeAcknowledged(M);this.f?.logOutgoing(fe.byteLength,M,g.OtherSide,"ack"),this.c.send(fe),ge.then(se=>{delete this.u[Z];const ce=C.serializeReplyOK(M,se,this.h);this.f?.logOutgoing(ce.byteLength,M,g.OtherSide,"reply:",se),this.c.send(ce)},se=>{delete this.u[Z];const ce=C.serializeReplyErr(M,se);this.f?.logOutgoing(ce.byteLength,M,g.OtherSide,"replyErr:",se),this.c.send(ce)})}N(N,M){this.f?.logIncoming(N,M,g.OtherSide,"receiveCancel");const V=String(M);this.u[V]?.()}O(N,M,V){this.f?.logIncoming(N,M,g.LocalSide,"receiveReply:",V);const W=String(M);if(!this.w.hasOwnProperty(W))return;const L=this.w[W];delete this.w[W],L.resolveOk(V)}P(N,M,V){this.f?.logIncoming(N,M,g.LocalSide,"receiveReplyErr:",V);const W=String(M);if(!this.w.hasOwnProperty(W))return;const L=this.w[W];delete this.w[W];let Y;V&&(V.$isError?(Y=new Error,Y.name=V.name,Y.message=V.message,Y.stack=V.stack):Y=V),L.resolveErr(Y)}Q(N,M,V){try{return Promise.resolve(this.S(N,M,V))}catch(W){return Promise.reject(W)}}S(N,M,V){const W=this.m[N];if(!W)throw new Error("Unknown actor "+(0,c.$Tw)(N));const L=W[M];if(typeof L!="function")throw new Error("Unknown method "+M+" on actor "+(0,c.$Tw)(N));return L.apply(W,V)}U(N,M,V){if(this.j)return new y.$Vcc;let W=null;if(V.length>0&&I.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(A.$5());const L=C.serializeRequestArguments(V,this.h),Y=++this.t,Z=String(Y),ge=new y.$Ucc,_=new $.$Sc;W&&_.add(W.onCancellationRequested(()=>{const se=C.serializeCancel(Y);this.f?.logOutgoing(se.byteLength,Y,g.LocalSide,"cancel"),this.c.send(C.serializeCancel(Y))})),this.w[Z]=new S(ge,_),this.F(Y);const fe=C.serializeRequest(Y,N,M,L,!!W);return this.f?.logOutgoing(fe.byteLength,Y,g.LocalSide,`request: ${(0,c.$Tw)(N)}.${M}(`,V),this.c.send(fe),ge}}e.$Ycc=E;class S{constructor(N,M){this.a=N,this.b=M}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class w{static alloc(N,M,V){const W=new w(P.$Le.alloc(V+1+4),0);return W.writeUInt8(N),W.writeUInt32(M),W}static read(N,M){return new w(N,M)}get buffer(){return this.a}constructor(N,M){this.a=N,this.b=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+N).toString();return this.b+=N,V}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+N).toString();return this.b+=N,V}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+N);return this.b+=N,M}static sizeMixedArray(N){let M=0;M+=1;for(let V=0,W=N.length;V<W;V++){const L=N[V];switch(M+=1,L.type){case b.String:M+=this.sizeLongString(L.value);break;case b.VSBuffer:M+=this.sizeVSBuffer(L.value);break;case b.SerializedObjectWithBuffers:M+=this.sizeUInt32,M+=this.sizeLongString(L.value);for(let Y=0;Y<L.buffers.length;++Y)M+=this.sizeVSBuffer(L.buffers[Y]);break;case b.Undefined:break}}return M}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let M=0,V=N.length;M<V;M++){const W=N[M];switch(W.type){case b.String:this.writeUInt8(b.String),this.writeLongString(W.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(W.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let L=0;L<W.buffers.length;++L)this.writeBuffer(W.buffers[L]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const M=new Array(N);for(let V=0;V<N;V++)switch(this.readUInt8()){case b.String:M[V]=this.readLongString();break;case b.VSBuffer:M[V]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const L=this.readUInt32(),Y=this.readLongString(),Z=[];for(let ge=0;ge<L;++ge)Z.push(this.readVSBuffer());M[V]=new c.$Uw(i(Y,Z,null));break}case b.Undefined:M[V]=void 0;break}return M}}var k;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(k||(k={}));class C{static a(N){for(let M=0,V=N.length;M<V;M++)if(N[M]instanceof P.$Le||N[M]instanceof c.$Uw||typeof N[M]>"u")return!0;return!1}static serializeRequestArguments(N,M){if(this.a(N)){const V=[];for(let W=0,L=N.length;W<L;W++){const Y=N[W];if(Y instanceof P.$Le)V[W]={type:b.VSBuffer,value:Y};else if(typeof Y>"u")V[W]={type:b.Undefined};else if(Y instanceof c.$Uw){const{jsonString:Z,referencedBuffers:ge}=l(Y.value,M);V[W]={type:b.SerializedObjectWithBuffers,value:P.$Le.fromString(Z),buffers:ge}}else V[W]={type:b.String,value:P.$Le.fromString(r(Y,M))}}return{type:k.Mixed,args:V}}return{type:k.Simple,args:r(N,M)}}static serializeRequest(N,M,V,W,L){switch(W.type){case k.Simple:return this.b(N,M,V,W.args,L);case k.Mixed:return this.c(N,M,V,W.args,L)}}static b(N,M,V,W,L){const Y=P.$Le.fromString(V),Z=P.$Le.fromString(W);let ge=0;ge+=w.sizeUInt8(),ge+=w.sizeShortString(Y),ge+=w.sizeLongString(Z);const _=w.alloc(L?d.RequestJSONArgsWithCancellation:d.RequestJSONArgs,N,ge);return _.writeUInt8(M),_.writeShortString(Y),_.writeLongString(Z),_.buffer}static deserializeRequestJSONArgs(N){const M=N.readUInt8(),V=N.readShortString(),W=N.readLongString();return{rpcId:M,method:V,args:JSON.parse(W)}}static c(N,M,V,W,L){const Y=P.$Le.fromString(V);let Z=0;Z+=w.sizeUInt8(),Z+=w.sizeShortString(Y),Z+=w.sizeMixedArray(W);const ge=w.alloc(L?d.RequestMixedArgsWithCancellation:d.RequestMixedArgs,N,Z);return ge.writeUInt8(M),ge.writeShortString(Y),ge.writeMixedArray(W),ge.buffer}static deserializeRequestMixedArgs(N){const M=N.readUInt8(),V=N.readShortString(),W=N.readMixedArray(),L=new Array(W.length);for(let Y=0,Z=W.length;Y<Z;Y++){const ge=W[Y];typeof ge=="string"?L[Y]=JSON.parse(ge):L[Y]=ge}return{rpcId:M,method:V,args:L}}static serializeAcknowledged(N){return w.alloc(d.Acknowledged,N,0).buffer}static serializeCancel(N){return w.alloc(d.Cancel,N,0).buffer}static serializeReplyOK(N,M,V){if(typeof M>"u")return this.d(N);if(M instanceof P.$Le)return this.e(N,M);if(M instanceof c.$Uw){const{jsonString:W,referencedBuffers:L}=l(M.value,V,!0);return this.g(N,W,L)}else return this.f(N,f(M,V))}static d(N){return w.alloc(d.ReplyOKEmpty,N,0).buffer}static e(N,M){let V=0;V+=w.sizeVSBuffer(M);const W=w.alloc(d.ReplyOKVSBuffer,N,V);return W.writeVSBuffer(M),W.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,M){const V=P.$Le.fromString(M);let W=0;W+=w.sizeLongString(V);const L=w.alloc(d.ReplyOKJSON,N,W);return L.writeLongString(V),L.buffer}static g(N,M,V){const W=P.$Le.fromString(M);let L=0;L+=w.sizeUInt32,L+=w.sizeLongString(W);for(const Z of V)L+=w.sizeVSBuffer(Z);const Y=w.alloc(d.ReplyOKJSONWithBuffers,N,L);Y.writeUInt32(V.length),Y.writeLongString(W);for(const Z of V)Y.writeBuffer(Z);return Y.buffer}static deserializeReplyOKJSON(N){const M=N.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(N,M){const V=N.readUInt32(),W=N.readLongString(),L=[];for(let Y=0;Y<V;++Y)L.push(N.readVSBuffer());return new c.$Uw(i(W,L,M))}static serializeReplyErr(N,M){const V=M?f(A.$1(M),null):void 0;if(typeof V!="string")return this.h(N);const W=P.$Le.fromString(V);let L=0;L+=w.sizeLongString(W);const Y=w.alloc(d.ReplyErrError,N,L);return Y.writeLongString(W),Y.buffer}static deserializeReplyErrError(N){const M=N.readLongString();return JSON.parse(M)}static h(N){return w.alloc(d.ReplyErrEmpty,N,0).buffer}}var d;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var b;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(b||(b={}))}),define(Oe[224],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Psc=void 0;const v=function(O){const A=T=>{globalThis.removeEventListener("message",A);const $=T.data;Object.defineProperties(globalThis,{postMessage:{value(a,R){$.postMessage(a,R)}},onmessage:{get(){return $.onmessage},set(a){$.onmessage=a}}}),$.addEventListener("message",a=>{globalThis.dispatchEvent(new MessageEvent("message",{data:a.data,ports:a.ports?[...a.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class P extends EventTarget{constructor(O,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${v})('${A}'))`,a=new Blob([$],{type:"application/javascript"}),R=URL.createObjectURL(a),y=new MessageChannel,c=R,D={type:"_newWorker",id:c,port:y.port2,url:R,options:T};O(D,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:c}),URL.revokeObjectURL(R),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(f){y.port1.onmessage=f}},onmessageerror:{get(){return y.port1.onmessageerror},set(f){y.port1.onmessageerror=f}}}),y.port1.addEventListener("messageerror",f=>{const n=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",f=>{const n=new MessageEvent("message",{data:f.data});this.dispatchEvent(n)}),y.port1.start()}}e.$Psc=P}),define(Oe[225],Ne([1,0,22,28,15,60,3]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.$fL=void 0,e.$gL=R,e.$hL=y,e.$fL=(0,A.$Ci)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${T.join("")}]+`),a=7;function R(D){if(D.scheme!==I.Schemas.vscodeNotebookCell)return;const f=D.fragment.indexOf("s");if(f<0)return;const n=parseInt(D.fragment.substring(0,f).replace($,""),a),o=(0,v.$5e)(D.fragment.substring(f+1)).toString();if(!isNaN(n))return{handle:n,notebook:D.with({scheme:o,fragment:null})}}function y(D,f){const n=f.toString(a),s=`${n.length<T.length?T[n.length-1]:"z"}${n}s${(0,v.$6e)(v.$Le.fromString(D.scheme),!0,!0)}`;return D.with({scheme:I.Schemas.vscodeNotebookCell,fragment:s})}class c{constructor(){this.a=new P.$zc}getNotebook(f){if(f.scheme===I.Schemas.vscodeNotebookCell){const n=R(f);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$iL=c,(0,O.$Os)(e.$fL,c,O.InstantiationType.Delayed)}),define(Oe[89],Ne([1,0,22,41,39,72,15,19,20,31,225]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$zL=e.CellStatusbarAlignment=e.$yL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$vL=e.$uL=e.$sL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$rL=e.$qL=e.$pL=e.$oL=e.CellKind=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=void 0,e.$tL=u,e.$wL=h,e.$xL=E,e.$AL=k,e.$BL=d,P=qe(P),e.$jL="workbench.editor.notebook",e.$kL="workbench.editor.notebookTextDiffEditor",e.$lL="workbench.editor.interactive",e.$mL="workbench.editor.repl",e.$nL="replNotebook.input.execute";var y;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(y||(e.CellKind=y={})),e.$oL=["application/json","application/javascript","text/html","image/svg+xml",O.$8s.latex,O.$8s.markdown,"image/png","image/jpeg",O.$8s.text],e.$pL=[O.$8s.latex,O.$8s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$8s.text],e.$qL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$rL="_notAvailable";var c;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(c||(e.NotebookRunState=c={}));var D;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(D||(e.NotebookCellExecutionState=D={}));var f;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var n;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var l;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var i;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(Z){Z.scheme=A.Schemas.vscodeNotebookCell;function ge(oe,Ce){return(0,R.$hL)(oe,Ce)}Z.generate=ge;function _(oe){return(0,R.$gL)(oe)}Z.parse=_;function fe(oe,Ce){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Ce??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}Z.generateCellOutputUri=fe;function se(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!Ce)return;const Le=Ce[1]&&Ce[1]!==""?Ce[1]:void 0,X=Ce[2];return{outputId:Le,notebook:oe.with({scheme:X||A.Schemas.file,fragment:null})}}Z.parseCellOutputUri=se;function ce(oe,Ce,Le){return Z.generate(oe,Ce).with({scheme:Le})}Z.generateCellPropertyUri=ce;function $e(oe,Ce){if(oe.scheme===Ce)return Z.parse(oe.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=$e})(r||(e.CellUri=r={}));const t=Z=>$.$j?Z.replace(/\//g,"\\"):Z;class g{constructor(ge=[],_=e.$oL){this.e=_,this.d=[...new Set(ge)].map(fe=>({pattern:fe,matches:P.$xk(t(fe))}))}sort(ge){const _=new Map(I.Iterable.map(ge,se=>[se,t(se)]));let fe=[];for(const{matches:se}of this.d)for(const[ce,$e]of _)if(se($e)){fe.push(ce),_.delete(ce);break}return _.size&&(fe=fe.concat([..._.keys()].sort((se,ce)=>this.e.indexOf(se)-this.e.indexOf(ce)))),fe}prioritize(ge,_){const fe=this.f(ge);if(fe===-1){this.d.unshift({pattern:ge,matches:P.$xk(t(ge))});return}const se=new Set(_.map($e=>this.f($e,fe)));se.delete(-1);const ce=Array.from(se).sort();this.d.splice(fe+1,0,...ce.map($e=>this.d[$e]));for(let $e=ce.length-1;$e>=0;$e--)this.d.splice(ce[$e],1)}toArray(){return this.d.map(ge=>ge.pattern)}f(ge,_=this.d.length){const fe=t(ge);for(let se=0;se<_;se++)if(this.d[se].matches(fe))return se;return-1}}e.$sL=g;function u(Z,ge,_,fe=(se,ce)=>se===ce){const se=[];function ce(Ce,Le,X){if(Le===0&&X.length===0)return;const q=se[se.length-1];q&&q.start+q.deleteCount===Ce?(q.deleteCount+=Le,q.toInsert.push(...X)):se.push({start:Ce,deleteCount:Le,toInsert:X})}let $e=0,oe=0;for(;;){if($e===Z.length){ce($e,0,ge.slice(oe));break}if(oe===ge.length){ce($e,Z.length-$e,[]);break}const Ce=Z[$e],Le=ge[oe];if(fe(Ce,Le)){$e+=1,oe+=1;continue}_(Le)?(ce($e,1,[]),$e+=1):(ce($e,0,[Le]),oe+=1)}return se}e.$uL=new a.$Tj("notebookEditorCursorAtBoundary","none"),e.$vL=new a.$Tj("notebookEditorCursorAtLineBoundary","none");var p;(function(Z){Z.default="default",Z.option="option"})(p||(e.NotebookEditorPriority=p={}));var m;(function(Z){Z.Cells="cells",Z.Text="text",Z.None="none"})(m||(e.NotebookFindScopeType=m={}));function h(Z){const ge=Z;return!!((typeof ge.include=="string"||P.$yk(ge.include))&&(typeof ge.exclude=="string"||P.$yk(ge.exclude)))}function E(Z,ge,_){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(ge)>=0||Z.viewType===ge)return!0;if(Z.filenamePattern){const fe=h(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,se=h(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(P.$wk(fe,(0,T.$mc)(_.fsPath).toLowerCase()))return!(se&&P.$wk(se,(0,T.$mc)(_.fsPath).toLowerCase()))}return!1}e.$yL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class w{static{this.d="notebook/"}static create(ge){return`${w.d}${ge}`}static parse(ge){if(ge.startsWith(w.d))return ge.substring(w.d.length)}}e.$zL=w;function k(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}const C=new TextDecoder;function d(Z){const ge=[];let _=!1;for(const $e of Z)(ge.length===0||_)&&(ge.push($e),_=!0);let fe=N(ge);const se=v.$Le.concat(ge.map($e=>v.$Le.wrap($e))),ce=Y(se);return fe=fe||ce.byteLength!==se.byteLength,{data:ce,didCompression:fe}}e.$CL="\x1B[A";const b=e.$CL.split("").map(Z=>Z.charCodeAt(0)),F=10;function N(Z){let ge=!1;return Z.forEach((_,fe)=>{if(fe===0||_.length<e.$CL.length)return;const se=Z[fe-1],ce=_.subarray(0,e.$CL.length);if(ce[0]===b[0]&&ce[1]===b[1]&&ce[2]===b[2]){const $e=se.lastIndexOf(F);if($e===-1)return;ge=!0,Z[fe-1]=se.subarray(0,$e),Z[fe]=_.subarray(e.$CL.length)}}),ge}function M(Z){let ge=Z;do Z=ge,ge=Z.replace(/[^\n]\x08/gm,"");while(ge.length<Z.length);return Z}function V(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const ge=Z.match(/^(.*)\r+/m)[1];let _=Z.match(/\r+(.*)$/m)[1];_=_+ge.slice(_.length,ge.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,_)}return Z}const W=8,L=13;function Y(Z){return!Z.buffer.includes(W)&&!Z.buffer.includes(L)?Z:v.$Le.fromString(V(M(C.decode(Z.buffer))))}}),define(Oe[7],Ne([1,0,17,13,59,28,72,12,14,2,37,18,29,109,89]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f){"use strict";var n,o,s,l,i,r,t,g,u,p,m,h,E,S,w,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$UP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.LanguageModelChatMessageRole=e.$LP=e.$KP=e.ChatLocation=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$vP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$uP=e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$iP=e.$hP=e.$gP=e.$fP=e.$dP=e.$cP=e.$bP=e.$aP=e.TestRunProfileKind=e.TestResultState=e.$_O=e.$$O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$0O=e.NotebookVariablesRequestKind=e.$9O=e.$8O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$7O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.ColorThemeKind=e.$1O=e.$ZO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$YO=e.$XO=e.DebugConsoleMode=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$RO=e.$QO=e.FileChangeType=e.$PO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$OO=e.$NO=e.$MO=e.$LO=e.InlineCompletionTriggerKind=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$yO=e.ConfigurationTarget=e.$xO=e.$wO=e.$vO=e.$uO=e.DocumentPasteTriggerKind=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$nO=e.ViewBadge=e.ProgressLocation=e.$mO=e.$lO=e.TaskScope=e.ShellQuoting=e.$kO=e.$jO=e.$iO=e.TaskPanelKind=e.TaskRevealKind=e.$hO=e.TerminalLocation=e.$gO=e.$fO=e.$eO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$dO=e.$cO=e.$bO=e.$aO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$$N=e.$0N=e.$9N=e.$8N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$7N=e.$6N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.LanguageStatusSeverity=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.CodeActionTriggerKind=e.$TN=e.$SN=e.SymbolTag=e.SymbolKind=e.$RN=e.$QN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.DiagnosticSeverity=e.DiagnosticTag=e.$KN=e.$JN=e.FileEditType=e.$IN=e.$HN=e.$GN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$FN=e.$EN=e.$DN=e.$AN=e.$zN=e.$yN=e.$xN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$BN=L,e.$CN=Y,e.$_N=$t,e.$zO=Li,e.$eP=Cn;function d(j){return Object.assign(j,{apply:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const De=re.length===1?[]:re[1];return Reflect.construct(j,De,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const[De,...Qe]=re;return Reflect.construct(j,Qe,De.constructor)}}})}var b;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var F;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=n=class{static from(...z){let re=z;return new n(function(){if(re){for(const De of re)De&&typeof De.dispose=="function"&&De.dispose();re=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$xN=N,e.$xN=N=n=He([d],N);let M=o=class{static Min(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let De=1;De<z.length;De++){const Qe=z[De];Qe.isBefore(re)&&(re=Qe)}return re}static Max(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let De=1;De<z.length;De++){const Qe=z[De];Qe.isAfter(re)&&(re=Qe)}return re}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:re,character:De}=z;return typeof re=="number"&&typeof De=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,re){if(z<0)throw(0,P.$6)("line must be non-negative");if(re<0)throw(0,P.$6)("character must be non-negative");this.c=z,this.e=re}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,re=0){if(z===null||re===null)throw(0,P.$6)();let De;return typeof z>"u"?De=0:typeof z=="number"?De=z:(De=typeof z.lineDelta=="number"?z.lineDelta:0,re=typeof z.characterDelta=="number"?z.characterDelta:0),De===0&&re===0?this:new o(this.line+De,this.character+re)}with(z,re=this.character){if(z===null||re===null)throw(0,P.$6)();let De;return typeof z>"u"?De=this.line:typeof z=="number"?De=z:(De=typeof z.line=="number"?z.line:this.line,re=typeof z.character=="number"?z.character:this.character),De===this.line&&re===this.character?this:new o(De,re)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$yN=M,e.$yN=M=o=He([d],M);let V=s=class{static isRange(z){return z instanceof s?!0:z?M.isPosition(z.start)&&M.isPosition(z.end):!1}static of(z){if(z instanceof s)return z;if(this.isRange(z))return new s(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,re,De,Qe){let it,dt;if(typeof z=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Qe=="number"?(it=new M(z,re),dt=new M(De,Qe)):M.isPosition(z)&&M.isPosition(re)&&(it=M.of(z),dt=M.of(re)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(z){return s.isRange(z)?this.contains(z.start)&&this.contains(z.end):M.isPosition(z)?!(M.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const re=M.Max(z.start,this.c),De=M.Min(z.end,this.e);if(!re.isAfter(De))return new s(re,De)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const re=M.Min(z.start,this.c),De=M.Max(z.end,this.end);return new s(re,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,re=this.end){if(z===null||re===null)throw(0,P.$6)();let De;return z?M.isPosition(z)?De=z:(De=z.start||this.start,re=z.end||this.end):De=this.start,De.isEqual(this.c)&&re.isEqual(this.end)?this:new s(De,re)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return L(this)}};e.$zN=V,e.$zN=V=s=He([d],V);let W=l=class extends V{static isSelection(z){return z instanceof l?!0:z?V.isRange(z)&&M.isPosition(z.anchor)&&M.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,re,De,Qe){let it,dt;if(typeof z=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Qe=="number"?(it=new M(z,re),dt=new M(De,Qe)):M.isPosition(z)&&M.isPosition(re)&&(it=M.of(z),dt=M.of(re)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return Y(this)}};e.$AN=W,e.$AN=W=l=He([d],W);function L(j){return j.isEmpty?`[${j.start.line}:${j.start.character})`:`[${j.start.line}:${j.start.character} -> ${j.end.line}:${j.end.character})`}function Y(j){let z=L(j);return j.isEmpty||(j.active.isEqual(j.start)?z=`|${z}`:z=`${z}|`),z}const Z=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,P.$6)("connectionToken")};class ge{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re,De){if(typeof z!="string"||z.length===0)throw(0,P.$6)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,P.$6)("port");typeof De<"u"&&Z(De),this.host=z,this.port=Math.round(re),this.connectionToken=De}}e.$DN=ge;class _{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re){this.makeConnection=z,this.connectionToken=re,typeof re<"u"&&Z(re)}}e.$EN=_;class fe extends Error{static NotAvailable(z,re){return new fe(z,D.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(z){return new fe(z,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,re=D.RemoteAuthorityResolverErrorCode.Unknown,De){super(z),this._message=z,this._code=re,this._detail=De,Object.setPrototypeOf(this,fe.prototype)}}e.$FN=fe;var se;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(se||(e.EndOfLine=se={}));var ce;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ce||(e.EnvironmentVariableMutatorType=ce={}));let $e=i=class{static isTextEdit(z){return z instanceof i?!0:z?V.isRange(z)&&typeof z.newText=="string":!1}static replace(z,re){return new i(z,re)}static insert(z,re){return i.replace(new V(z,z),re)}static delete(z){return i.replace(z,"")}static setEndOfLine(z){const re=new i(new V(new M(0,0),new M(0,0)),"");return re.newEol=z,re}get range(){return this.c}set range(z){if(z&&!V.isRange(z))throw(0,P.$6)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,P.$6)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,P.$6)("newEol");this.f=z}constructor(z,re){this.c=z,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$GN=$e,e.$GN=$e=i=He([d],$e);let oe=r=class{static isNotebookCellEdit(z){return z instanceof r?!0:z?yi.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,re){return new r(z,re)}static insertCells(z,re){return new r(new yi(z,z),re)}static deleteCells(z){return new r(z,[])}static updateCellMetadata(z,re){const De=new r(new yi(z,z),[]);return De.newCellMetadata=re,De}static updateNotebookMetadata(z){const re=new r(new yi(0,0),[]);return re.newNotebookMetadata=z,re}constructor(z,re){this.range=z,this.newCells=re}};e.$HN=oe,e.$HN=oe=r=He([d],oe);class Ce{static isSnippetTextEdit(z){return z instanceof Ce?!0:z?V.isRange(z.range)&&q.isSnippetString(z.snippet):!1}static replace(z,re){return new Ce(z,re)}static insert(z,re){return Ce.replace(new V(z,z),re)}constructor(z,re){this.range=z,this.snippet=re}}e.$IN=Ce;var Le;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(Le||(e.FileEditType=Le={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,re,De,Qe){this.c.push({_type:Le.File,from:z,to:re,options:De,metadata:Qe})}createFile(z,re,De){this.c.push({_type:Le.File,from:void 0,to:z,options:re,metadata:De})}deleteFile(z,re,De){this.c.push({_type:Le.File,from:z,to:void 0,options:re,metadata:De})}e(z,re,De){this.c.push({_type:Le.Cell,metadata:De,uri:z,edit:{editType:f.CellEditType.DocumentMetadata,metadata:re},notebookMetadata:re})}f(z,re,De,Qe){const it=re.start,dt=re.end;(it!==dt||De.length>0)&&this.c.push({_type:Le.CellReplace,uri:z,index:it,count:dt-it,cells:De,metadata:Qe})}g(z,re,De,Qe){this.c.push({_type:Le.Cell,metadata:Qe,uri:z,edit:{editType:f.CellEditType.Metadata,index:re,metadata:De}})}replace(z,re,De,Qe){this.c.push({_type:Le.Text,uri:z,edit:new $e(re,De),metadata:Qe})}insert(z,re,De,Qe){this.replace(z,new V(re,re),De,Qe)}delete(z,re,De){this.replace(z,re,"",De)}has(z){return this.c.some(re=>re._type===Le.Text&&re.uri.toString()===z.toString())}set(z,re){if(re)for(const De of re){if(!De)continue;let Qe,it;Array.isArray(De)?(Qe=De[0],it=De[1]):Qe=De,oe.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(z,Qe.range.start,Qe.newCellMetadata,it):Qe.newNotebookMetadata?this.e(z,Qe.newNotebookMetadata,it):this.f(z,Qe.range,Qe.newCells,it):Ce.isSnippetTextEdit(Qe)?this.c.push({_type:Le.Snippet,uri:z,range:Qe.range,edit:Qe.snippet,metadata:it}):this.c.push({_type:Le.Text,uri:z,edit:Qe,metadata:it})}else{for(let De=0;De<this.c.length;De++){const Qe=this.c[De];switch(Qe._type){case Le.Text:case Le.Snippet:case Le.Cell:case Le.CellReplace:Qe.uri.toString()===z.toString()&&(this.c[De]=void 0);break}}(0,v.$Hb)(this.c)}}get(z){const re=[];for(const De of this.c)De._type===Le.Text&&De.uri.toString()===z.toString()&&re.push(De.edit);return re}entries(){const z=new O.$zc;for(const re of this.c)if(re._type===Le.Text){let De=z.get(re.uri);De||(De=[re.uri,[]],z.set(re.uri,De)),De[1].push(re.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$JN=X,e.$JN=X=He([d],X);let q=t=class{static isSnippetString(z){return z instanceof t?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=t.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,re=this.e++){if(typeof z=="function"){const De=new t;De.e=this.e,z(De),this.e=De.e,z=De.value}else z=t.c(z);return this.value+="${",this.value+=re,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,re=this.e++){const De=z.map(Qe=>Qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(z,re){if(typeof re=="function"){const De=new t;De.e=this.e,re(De),this.e=De.e,re=De.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$KN=q,e.$KN=q=t=He([d],q);var te;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var ve;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let ae=g=class{static isLocation(z){return z instanceof g?!0:z?V.isRange(z.range)&&a.URI.isUri(z.uri):!1}constructor(z,re){if(this.uri=z,re)if(V.isRange(re))this.range=V.of(re);else if(M.isPosition(re))this.range=new V(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$LN=ae,e.$LN=ae=g=He([d],ae);let be=class{static is(z){return z?typeof z.message=="string"&&z.location&&V.isRange(z.location.range)&&a.URI.isUri(z.location.uri):!1}constructor(z,re){this.location=z,this.message=re}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.location.range.isEqual(re.location.range)&&z.location.uri.toString()===re.location.uri.toString()}};e.$MN=be,e.$MN=be=He([d],be);let ue=class{constructor(z,re,De=ve.Error){if(!V.isRange(z))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=z,this.message=re,this.severity=De}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.severity===re.severity&&z.code===re.code&&z.severity===re.severity&&z.source===re.source&&z.range.isEqual(re.range)&&(0,v.$tb)(z.tags,re.tags)&&(0,v.$tb)(z.relatedInformation,re.relatedInformation,be.isEqual)}};e.$NN=ue,e.$NN=ue=He([d],ue);let J=class{constructor(z,re){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=re}};e.$ON=J,e.$ON=J=He([d],J);let x=class extends J{constructor(z,re,De,Qe){super(z,re),this.canIncreaseHover=De,this.canDecreaseHover=Qe}};e.$PN=x,e.$PN=x=He([d],x);var me;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(me||(e.HoverVerbosityAction=me={}));var pe;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(pe||(e.DocumentHighlightKind=pe={}));let Ae=class{constructor(z,re=pe.Text){this.range=z,this.kind=re}toJSON(){return{range:this.range,kind:pe[this.kind]}}};e.$QN=Ae,e.$QN=Ae=He([d],Ae);let ze=class{constructor(z,re){this.uri=z,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$RN=ze,e.$RN=ze=He([d],ze);var ke;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var Pe;(function(j){j[j.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Te=u=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,re,De,Qe,it){this.name=z,this.kind=re,this.containerName=it,typeof De=="string"&&(this.containerName=De),Qe instanceof ae?this.location=Qe:De instanceof V&&(this.location=new ae(Qe,De)),u.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.$SN=Te,e.$SN=Te=u=He([d],Te);let U=p=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(p.validate)}constructor(z,re,De,Qe,it){this.name=z,this.detail=re,this.kind=De,this.range=Qe,this.selectionRange=it,this.children=[],p.validate(this)}};e.$TN=U,e.$TN=U=p=He([d],U);var B;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let K=class{constructor(z,re){this.title=z,this.kind=re}};e.$UN=K,e.$UN=K=He([d],K);let G=class{static{m=this}static{this.c="."}constructor(z){this.value=z}append(z){return new m(this.value?this.value+m.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+m.c)}};e.$VN=G,e.$VN=G=m=He([d],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let ie=class{constructor(z,re){if(this.range=z,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$WN=ie,e.$WN=ie=He([d],ie);class de{constructor(z,re,De,Qe,it,dt){this.kind=z,this.name=re,this.detail=De,this.uri=Qe,this.range=it,this.selectionRange=dt}}e.$XN=de;class Ie{constructor(z,re){this.fromRanges=re,this.from=z}}e.$YN=Ie;class Ue{constructor(z,re){this.fromRanges=re,this.to=z}}e.$ZN=Ue;var Ke;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ke||(e.LanguageStatusSeverity=Ke={}));let _e=class{constructor(z,re){this.range=z,this.command=re}get isResolved(){return!!this.command}};e.$1N=_e,e.$1N=_e=He([d],_e);let tt=h=class{#e;static isMarkdownString(z){return z instanceof h?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,re=!1){this.#e=new I.$1k(z,{supportThemeIcons:re})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,re){return this.#e.appendCodeblock(re??"",z),this}};e.$2N=tt,e.$2N=tt=h=He([d],tt);let nt=class{constructor(z,re){this.label=z,this.documentation=re}};e.$3N=nt,e.$3N=nt=He([d],nt);let et=class{constructor(z,re){this.label=z,this.documentation=re,this.parameters=[]}};e.$4N=et,e.$4N=et=He([d],et);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$5N=rt,e.$5N=rt=He([d],rt);var mt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(mt||(e.SignatureHelpTriggerKind=mt={}));var lt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let st=class{constructor(z){this.value=z}};e.$6N=st,e.$6N=st=He([d],st);let ct=class{constructor(z,re,De){this.position=z,this.label=re,this.kind=De}};e.$7N=ct,e.$7N=ct=He([d],ct);var ft;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft||(e.CompletionTriggerKind=ft={}));var pt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var We;(function(j){j[j.Deprecated=1]="Deprecated"})(We||(e.CompletionItemTag=We={}));let je=class{constructor(z,re){this.label=z,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$8N=je,e.$8N=je=He([d],je);let ee=class{constructor(z=[],re=!1){this.items=z,this.isIncomplete=re}};e.$9N=ee,e.$9N=ee=He([d],ee);let Q=class{constructor(z,re,De){this.insertText=z,this.range=re,this.command=De}};e.$0N=Q,e.$0N=Q=He([d],Q);let Se=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$$N=Se,e.$$N=Se=He([d],Se);var Je;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(Je||(e.PartialAcceptTriggerKind=Je={}));var xe;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var ht;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ht||(e.StatusBarAlignment=ht={}));function $t(j,z){return`${y.$on.toKey(j)}.${z}`}var Nt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Nt||(e.TextEditorLineNumbersStyle=Nt={}));var qt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(qt||(e.TextDocumentSaveReason=qt={}));var ri;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ri||(e.TextEditorRevealType=ri={}));var Xt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var di;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(di||(e.TextDocumentChangeReason=di={}));var Ye;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ye||(e.DecorationRangeBehavior=Ye={})),function(j){function z(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var Vt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(j){function z(re){switch(re){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=z}(Vt||(e.SyntaxTokenType=Vt={}));let Gt=class{constructor(z,re){if(re&&!a.URI.isUri(re))throw(0,P.$6)("target");if(!V.isRange(z)||z.isEmpty)throw(0,P.$6)("range");this.range=z,this.target=re}};e.$aO=Gt,e.$aO=Gt=He([d],Gt);let gt=class{constructor(z,re,De,Qe){this.red=z,this.green=re,this.blue=De,this.alpha=Qe}};e.$bO=gt,e.$bO=gt=He([d],gt);let Dt=class{constructor(z,re){if(re&&!(re instanceof gt))throw(0,P.$6)("color");if(!V.isRange(z)||z.isEmpty)throw(0,P.$6)("range");this.range=z,this.color=re}};e.$cO=Dt,e.$cO=Dt=He([d],Dt);let Yt=class{constructor(z){if(!z||typeof z!="string")throw(0,P.$6)("label");this.label=z}};e.$dO=Yt,e.$dO=Yt=He([d],Yt);var Zt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Zt||(e.ColorFormat=Zt={}));var jt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(jt||(e.SourceControlInputBoxValidationType=jt={}));var bt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));var Rt;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(Rt||(e.TerminalShellExecutionCommandLineConfidence=Rt={}));class li{constructor(z,re,De){if(this.startIndex=z,this.length=re,this.tooltip=De,typeof z!="number"||z<0)throw(0,P.$6)("startIndex");if(typeof re!="number"||re<1)throw(0,P.$6)("length");if(De!==void 0&&typeof De!="string")throw(0,P.$6)("tooltip")}}e.$eO=li;class Kt{constructor(z){this.uri=z}}e.$fO=Kt;class Xe{constructor(z){this.terminalCommand=z}}e.$gO=Xe;var xt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(xt||(e.TerminalLocation=xt={}));class ui{constructor(z){if(this.options=z,typeof z!="object")throw(0,P.$6)("options")}}e.$hO=ui;var fi;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(fi||(e.TaskRevealKind=fi={}));var kt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Mt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(z){switch(z){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(z,re){if(this.label=re,typeof z!="string"||typeof re!="string")throw(0,P.$6)("name");this.c=z}get id(){return this.c}};e.$iO=Mt,e.$iO=Mt=E=He([d],Mt);function At(j){let z="";for(let re=0;re<j.length;re++)z+=j[re].replace(/,/g,",,")+",";return z}let Ft=class{constructor(z,re,De){if(typeof z!="string")throw(0,P.$6)("process");this.e=[],this.c=z,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=De):this.f=re)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,P.$6)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const re of this.e)z.push(re);return At(z)}};e.$jO=Ft,e.$jO=Ft=He([d],Ft);let si=class{constructor(z,re,De){if(this.f=[],Array.isArray(re)){if(!z)throw(0,P.$6)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,P.$6)("command");this.e=z,this.f=re,this.g=De}else{if(typeof z!="string")throw(0,P.$6)("commandLine");this.c=z,this.g=re}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,P.$6)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,P.$6)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)z.push(typeof re=="string"?re:re.value);return At(z)}};e.$kO=si,e.$kO=si=He([d],si);var _t;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(_t||(e.ShellQuoting=_t={}));var ei;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ei||(e.TaskScope=ei={}));class Bt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,R.$Yg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$lO=Bt;let Wt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,re,De,Qe,it,dt){this.k=!1,this.l=this.definition=z;let vt;typeof re=="string"?(this.o=this.name=re,this.w=this.source=De,this.execution=Qe,vt=it,this.k=!0):re===ei.Global||re===ei.Workspace?(this.target=re,this.o=this.name=De,this.w=this.source=Qe,this.execution=it,vt=dt):(this.target=re,this.o=this.name=De,this.w=this.source=Qe,this.execution=it,vt=dt),typeof vt=="string"?(this.r=[vt],this.t=!0):Array.isArray(vt)?(this.r=vt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ft?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof si?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof Bt?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,R.$Yg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,P.$6)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,P.$6)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const re=this.l.type;(S.g===re||S.e===re||S.f===re||S.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,P.$6)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$mO=Wt,e.$mO=Wt=S=He([d],Wt);var hi;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(hi||(e.ProgressLocation=hi={}));var Tt;(function(j){function z(re){const De=re;return(0,$.$gg)(De.value)?De.tooltip&&!(0,$.$cg)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}j.isViewBadge=z})(Tt||(e.ViewBadge=Tt={}));let Ct=w=class{static isTreeItem(z,re){const De=z;if(De.checkboxState!==void 0){const Qe=(0,$.$gg)(De.checkboxState)?De.checkboxState:(0,$.$eg)(De.checkboxState)&&(0,$.$gg)(De.checkboxState.state)?De.checkboxState.state:void 0,it=!(0,$.$gg)(De.checkboxState)&&(0,$.$eg)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Qt.Checked&&Qe!==Qt.Unchecked||it!==void 0&&!(0,$.$cg)(it))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(z instanceof w)return!0;if(De.label!==void 0&&!(0,$.$cg)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,$.$cg)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,$.$cg)(De.iconPath)&&!a.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,$.$cg)(De.iconPath.id))){const Qe=De.iconPath;if(!Qe||!(0,$.$cg)(Qe.light)&&!a.URI.isUri(Qe.light)&&!(0,$.$cg)(Qe.dark)&&!a.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,$.$cg)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!a.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,$.$cg)(De.tooltip)&&!(De.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<wt.None&&De.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,$.$cg)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(z,re=wt.None){this.collapsibleState=re,a.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$nO=Ct,e.$nO=Ct=w=He([d],Ct);var wt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var Qt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Qt||(e.TreeItemCheckboxState=Qt={}));let yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$oO=yt,e.$oO=yt=He([d],yt);class oi extends yt{}e.$pO=oi;class Ht extends oi{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$qO=Ht;class Pi{constructor(z,re,De,Qe){this.name=z,this.uri=re,this._itemId=De,this.c=Qe}data(){return this.c()}}e.$rO=Pi;let pi=class{#e=new Map;constructor(z){for(const[re,De]of z??[]){const Qe=this.#e.get(this.#t(re));Qe?Qe.push(De):this.#e.set(this.#t(re),[De])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,re){this.#e.set(this.#t(z),[re])}forEach(z,re){for(const[De,Qe]of this.#e)for(const it of Qe)z.call(re,it,De,this)}*[Symbol.iterator](){for(const[z,re]of this.#e)for(const De of re)yield[z,De]}#t(z){return z.toLowerCase()}};e.$sO=pi,e.$sO=pi=He([d],pi);let Si=class{constructor(z,re,De){this.insertText=z,this.title=re,this.kind=De}};e.$tO=Si,e.$tO=Si=He([d],Si);var zt;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(zt||(e.DocumentPasteTriggerKind=zt={}));class gi{static{this.c="."}constructor(z){this.value=z}append(...z){return new gi((this.value?[this.value,...z]:z).join(gi.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+gi.c)}}e.$uO=gi,gi.Empty=new gi("");class Ni{constructor(z,re,De){this.title=re,this.insertText=z,this.kind=De}}e.$vO=Ni;let It=class{constructor(z,re){this.id=z,this.color=re}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$wO=It,e.$wO=It=He([d],It),It.File=new It("file"),It.Folder=new It("folder");let Di=class{constructor(z){this.id=z}};e.$xO=Di,e.$xO=Di=He([d],Di);var Ri;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ri||(e.ConfigurationTarget=Ri={}));let $i=class{get base(){return this.c}set base(z){this.c=z,this.e=a.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,re){if(typeof z!="string"&&(!z||!a.URI.isUri(z)&&!a.URI.isUri(z.uri)))throw(0,P.$6)("base");if(typeof re!="string")throw(0,P.$6)("pattern");typeof z=="string"?this.baseUri=a.URI.file(z):a.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$yO=$i,e.$yO=$i=He([d],$i);const Ai=new WeakMap;function Li(j,z){Ai.set(j,z)}let Lt=class{constructor(z,re,De,Qe,it){this.enabled=typeof z=="boolean"?z:!0,typeof re=="string"&&(this.condition=re),typeof De=="string"&&(this.hitCondition=De),typeof Qe=="string"&&(this.logMessage=Qe),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Ai.get(this)??(0,R.$Yg)()),this.c}};e.$AO=Lt,e.$AO=Lt=He([d],Lt);let ye=class extends Lt{constructor(z,re,De,Qe,it,dt){if(super(re,De,Qe,it,dt),z===null)throw(0,P.$6)("location");this.location=z}};e.$BO=ye,e.$BO=ye=He([d],ye);let Re=class extends Lt{constructor(z,re,De,Qe,it,dt){super(re,De,Qe,it,dt),this.functionName=z}};e.$CO=Re,e.$CO=Re=He([d],Re);let le=class extends Lt{constructor(z,re,De,Qe,it,dt,vt,Jt){if(super(Qe,it,dt,vt,Jt),!re)throw(0,P.$6)("dataId");this.label=z,this.dataId=re,this.canPersist=De}};e.$DO=le,e.$DO=le=He([d],le);let H=class{constructor(z,re,De){this.command=z,this.args=re||[],this.options=De}};e.$EO=H,e.$EO=H=He([d],H);let Ee=class{constructor(z,re){this.port=z,this.host=re}};e.$FO=Ee,e.$FO=Ee=He([d],Ee);let Be=class{constructor(z){this.path=z}};e.$GO=Be,e.$GO=Be=He([d],Be);let Ze=class{constructor(z){this.implementation=z}};e.$HO=Ze,e.$HO=Ze=He([d],Ze);class Ge{constructor(z,re,De){this.session=z,this.threadId=re,this.frameId=De}}e.$IO=Ge;class ut{constructor(z,re){this.session=z,this.threadId=re}}e.$JO=ut;let Pt=class{constructor(z,re){this.range=z,this.expression=re}};e.$KO=Pt,e.$KO=Pt=He([d],Pt);var ti;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ti||(e.InlineCompletionTriggerKind=ti={}));let ai=class{constructor(z,re){this.range=z,this.text=re}};e.$LO=ai,e.$LO=ai=He([d],ai);let Ut=class{constructor(z,re,De=!0){this.range=z,this.variableName=re,this.caseSensitiveLookup=De}};e.$MO=Ut,e.$MO=Ut=He([d],Ut);let ii=class{constructor(z,re){this.range=z,this.expression=re}};e.$NO=ii,e.$NO=ii=He([d],ii);let Mi=class{constructor(z,re){this.frameId=z,this.stoppedLocation=re}};e.$OO=Mi,e.$OO=Mi=He([d],Mi);var xi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(xi||(e.NewSymbolNameTag=xi={}));var Fi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Fi||(e.NewSymbolNameTriggerKind=Fi={}));class qi{constructor(z,re){this.newSymbolName=z,this.tags=re}}e.$PO=qi;var _i;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(_i||(e.FileChangeType=_i={}));let Vi=k=class extends Error{static FileExists(z){return new k(z,c.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(z){return new k(z,c.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(z){return new k(z,c.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(z){return new k(z,c.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(z){return new k(z,c.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(z){return new k(z,c.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(z,re=c.FileSystemProviderErrorCode.Unknown,De){super(a.URI.isUri(z)?z.toString(!0):z),this.code=De?.name??"Unknown",(0,c.$ml)(this,re),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$QO=Vi,e.$QO=Vi=k=He([d],Vi);let vi=class{constructor(z,re,De){this.start=z,this.end=re,this.kind=De}};e.$RO=vi,e.$RO=vi=He([d],vi);var en;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(en||(e.FoldingRangeKind=en={}));var tn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(tn||(e.CommentThreadCollapsibleState=tn={}));var zi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(zi||(e.CommentMode=zi={}));var nn;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(nn||(e.CommentState=nn={}));var Ui;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Ui||(e.CommentThreadState=Ui={}));var Gi;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(Gi||(e.CommentThreadApplicability=Gi={}));class wn{constructor(z,re=[]){this.tokenTypes=z,this.tokenModifiers=re}}e.$SO=wn;function rn(j){return typeof j>"u"||(0,$.$dg)(j)}class Ki{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let re=0,De=z.tokenTypes.length;re<De;re++)this.k.set(z.tokenTypes[re],re);for(let re=0,De=z.tokenModifiers.length;re<De;re++)this.l.set(z.tokenModifiers[re],re)}}push(z,re,De,Qe,it){if(typeof z=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Qe=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(z,re,De,Qe,it);if(V.isRange(z)&&typeof re=="string"&&rn(De))return this.o(z,re,De);throw(0,P.$6)()}o(z,re,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const Qe=z.start.line,it=z.start.character,dt=z.end.character-z.start.character,vt=this.k.get(re);let Jt=0;if(De)for(const mi of De){if(!this.l.has(mi))throw new Error("`tokenModifier` is not in the provided legend");const bi=this.l.get(mi);Jt|=1<<bi>>>0}this.q(Qe,it,dt,vt,Jt)}q(z,re,De,Qe,it){if(this.f&&(z<this.c||z===this.c&&re<this.e)){this.f=!1;const Jt=this.g.length/5|0;let mi=0,bi=0;for(let Ei=0;Ei<Jt;Ei++){let Ii=this.g[5*Ei],Yi=this.g[5*Ei+1];Ii===0?(Ii=mi,Yi+=bi):Ii+=mi,this.g[5*Ei]=Ii,this.g[5*Ei+1]=Yi,mi=Ii,bi=Yi}}let dt=z,vt=re;this.f&&this.j>0&&(dt-=this.c,dt===0&&(vt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=vt,this.g[this.j++]=De,this.g[this.j++]=Qe,this.g[this.j++]=it,this.c=z,this.e=re}static r(z){const re=[],De=z.length/5|0;for(let vt=0;vt<De;vt++)re[vt]=vt;re.sort((vt,Jt)=>{const mi=z[5*vt],bi=z[5*Jt];if(mi===bi){const Ei=z[5*vt+1],Ii=z[5*Jt+1];return Ei-Ii}return mi-bi});const Qe=new Uint32Array(z.length);let it=0,dt=0;for(let vt=0;vt<De;vt++){const Jt=5*re[vt],mi=z[Jt+0],bi=z[Jt+1],Ei=z[Jt+2],Ii=z[Jt+3],Yi=z[Jt+4],Wn=mi-it,Rr=Wn===0?bi-dt:bi,Zi=5*vt;Qe[Zi+0]=Wn,Qe[Zi+1]=Rr,Qe[Zi+2]=Ei,Qe[Zi+3]=Ii,Qe[Zi+4]=Yi,it=mi,dt=bi}return Qe}build(z){return this.f?new ki(new Uint32Array(this.g),z):new ki(Ki.r(this.g),z)}}e.$TO=Ki;class ki{constructor(z,re){this.resultId=re,this.data=z}}e.$UO=ki;class bn{constructor(z,re,De){this.start=z,this.deleteCount=re,this.data=De}}e.$VO=bn;class vn{constructor(z,re){this.resultId=re,this.edits=z}}e.$WO=vn;var sn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(sn||(e.DebugConsoleMode=sn={}));class Qi{constructor(z){this.name=z}}e.$XO=Qi;let ji=class{static{this.Back={iconPath:new It("arrow-left")}}constructor(){}};e.$YO=ji,e.$YO=ji=He([d],ji);var Fe;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Fe||(e.QuickPickItemKind=Fe={}));var wi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(wi||(e.InputBoxValidationSeverity=wi={}));var Hi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Hi||(e.ExtensionKind=Hi={}));class ot{static validate(z){if(typeof z.badge=="string"){let re=(0,T.$Nf)(z.badge,0);if(re<z.badge.length&&(re+=(0,T.$Nf)(z.badge,re)),z.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!It.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,re,De){this.badge=z,this.tooltip=re,this.color=De}}e.$ZO=ot;let Et=class{constructor(z){this.kind=z}};e.$1O=Et,e.$1O=Et=He([d],Et);var on;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(on||(e.ColorThemeKind=on={}));class yi{static isNotebookRange(z){return z instanceof yi?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,re){if(z<0)throw(0,P.$6)("start must be positive");if(re<0)throw(0,P.$6)("end must be positive");z<=re?(this.c=z,this.e=re):(this.c=re,this.e=z)}with(z){let re=this.c,De=this.e;return z.start!==void 0&&(re=z.start),z.end!==void 0&&(De=z.end),re===this.c&&De===this.e?this:new yi(re,De)}}e.$2O=yi;class Oi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(re=>Oi.isNotebookCellData(re))}static isNotebookCellData(z){return!0}constructor(z,re,De,Qe,it,dt,vt){this.kind=z,this.value=re,this.languageId=De,this.mime=Qe,this.outputs=it??[],this.metadata=dt,this.executionSummary=vt,Oi.validate(this)}}e.$3O=Oi;class yn{constructor(z){this.cells=z}}e.$4O=yn;class ci{static isNotebookCellOutputItem(z){return z instanceof ci?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const re={name:z.name,message:z.message,stack:z.stack};return ci.json(re,"application/vnd.code.notebook.error")}static stdout(z){return ci.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return ci.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,re="application/octet-stream"){return new ci(z,re)}static#e=new TextEncoder;static text(z,re=A.$8s.text){const De=ci.#e.encode(String(z));return new ci(De,re)}static json(z,re="text/x-json"){const De=JSON.stringify(z,void 0,"	");return ci.text(De,re)}constructor(z,re){this.data=z,this.mime=re;const De=(0,A.$_s)(re,!0);if(!De)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$5O=ci;class Bi{static isNotebookCellOutput(z){return z instanceof Bi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,re=!1){const De=new Set,Qe=new Set;for(let it=0;it<z.length;it++){const dt=z[it],vt=(0,A.$_s)(dt.mime);if(!De.has(vt)||(0,f.$AL)(vt)){De.add(vt);continue}Qe.add(it),re&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Qe.size===0?z:z.filter((it,dt)=>!Qe.has(dt))}constructor(z,re,De){this.items=Bi.ensureUniqueMimeTypes(z,!0),typeof re=="string"?(this.id=re,this.metadata=De):(this.id=(0,R.$Yg)(),this.metadata=re??De)}}e.$6O=Bi;var an;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(an||(e.NotebookCellKind=an={}));var cn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var Ji;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var ln;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ln||(e.NotebookEditorRevealType=ln={}));class En{constructor(z,re){this.text=z,this.alignment=re}}e.$7O=En;var un;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(un||(e.NotebookControllerAffinity=un={}));var hn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(hn||(e.NotebookControllerAffinity2=hn={}));class Sn{constructor(z,re=[]){this.uri=z,this.provides=(0,v.$1b)(re)}}e.$8O=Sn;class Dn{constructor(z){this.label=z}}e.$9O=Dn;var dn;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(dn||(e.NotebookVariablesRequestKind=dn={}));let Xi=class{constructor(z,re){this.label=z,this.timestamp=re}};e.$0O=Xi,e.$0O=Xi=He([d],Xi);var fn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(fn||(e.ExtensionMode=fn={}));var gn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(gn||(e.ExtensionRuntime=gn={}));var mn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(mn||(e.StandardTokenType=mn={}));class ne{constructor(z,re){this.ranges=z,this.wordPattern=re}}e.$$O=ne;class he{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$_O=he;var Me;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Me||(e.TestResultState=Me={}));var at;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(at||(e.TestRunProfileKind=at={}));let St=class{constructor(z=void 0,re=void 0,De=void 0,Qe=!1,it=!0){this.include=z,this.exclude=re,this.profile=De,this.continuous=Qe,this.preserveFocus=it}};e.$aP=St,e.$aP=St=He([d],St);let Ot=C=class{static diff(z,re,De){const Qe=new C(z);return Qe.expectedOutput=re,Qe.actualOutput=De,Qe}constructor(z){this.message=z}};e.$bP=Ot,e.$bP=Ot=C=He([d],Ot);let Ci=class{constructor(z){this.id=z}};e.$cP=Ci,e.$cP=Ci=He([d],Ci);class Wi{constructor(z,re){this.covered=z,this.total=re,Cn(this)}}e.$dP=Wi;function Cn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class kn{static fromDetails(z,re){const De=new Wi(0,0),Qe=new Wi(0,0),it=new Wi(0,0);for(const vt of re)if("branches"in vt){De.total+=1,De.covered+=vt.executed?1:0;for(const Jt of vt.branches)Qe.total+=1,Qe.covered+=Jt.executed?1:0}else it.total+=1,it.covered+=vt.executed?1:0;const dt=new kn(z,De,Qe.total>0?Qe:void 0,it.total>0?it:void 0);return dt.detailedCoverage=re,dt}constructor(z,re,De,Qe,it=[]){this.uri=z,this.statementCoverage=re,this.branchCoverage=De,this.declarationCoverage=Qe,this.fromTests=it}}e.$fP=kn;class Gn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,De=[]){this.executed=z,this.location=re,this.branches=De}}e.$gP=Gn;class Kn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,De){this.executed=z,this.location=re,this.label=De}}e.$hP=Kn;class Qn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,De){this.name=z,this.executed=re,this.location=De}}e.$iP=Qn;var In;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(In||(e.ExternalUriOpenerPriority=In={}));var Pn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Pn||(e.WorkspaceTrustState=Pn={}));var Rn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Rn||(e.PortAutoForwardAction=Rn={}));class Hn{constructor(z,re,De,Qe,it,dt){this.kind=z,this.name=re,this.detail=De,this.uri=Qe,this.range=it,this.selectionRange=dt}}e.$jP=Hn;class Jn{constructor(z){this.uri=z}}e.$kP=Jn;class Xn{constructor(z,re){this.original=z,this.modified=re}}e.$lP=Xn;class Yn{constructor(z,re,De,Qe){this.base=z,this.input1=re,this.input2=De,this.result=Qe}}e.$mP=Yn;class Zn{constructor(z,re){this.uri=z,this.viewType=re}}e.$nP=Zn;class xn{constructor(z){this.viewType=z}}e.$oP=xn;class _n{constructor(z,re){this.uri=z,this.notebookType=re}}e.$pP=_n;class er{constructor(z,re,De){this.original=z,this.modified=re,this.notebookType=De}}e.$qP=er;class tr{constructor(){}}e.$rP=tr;class ir{constructor(z,re){this.uri=z,this.inputBoxUri=re}}e.$sP=ir;class nr{constructor(){}}e.$tP=nr;class rr{constructor(z){this.textDiffs=z}}e.$uP=rr;var An;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(An||(e.InteractiveSessionVoteDirection=An={}));var Tn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Tn||(e.ChatCopyKind=Tn={}));var On;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(On||(e.ChatVariableLevel=On={}));class sr{constructor(z,re,De){this.id=z,this.label=re,this.values=De}}e.$vP=sr;var Nn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Nn||(e.InteractiveEditorResponseFeedbackKind=Nn={}));var Ln;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Ln||(e.ChatResultFeedbackKind=Ln={}));class or{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new tt(z):z}}e.$wP=or;class ar{constructor(z,re){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new tt(z):z,this.vulnerabilities=re}}e.$xP=ar;class cr{constructor(z,re){this.participant=z,this.command=re}}e.$yP=cr;class lr{constructor(z,re,De,Qe){this.title=z,this.message=re,this.data=De,this.buttons=Qe}}e.$zP=lr;class ur{constructor(z,re){this.value=z,this.baseUri=re}}e.$AP=ur;class hr{constructor(z,re){this.value=z,this.title=re}}e.$BP=hr;class dr{constructor(z){this.value=z}}e.$CP=dr;class fr{constructor(z,re){this.value=z,this.task=re}}e.$DP=fr;class gr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new tt(z):z}}e.$EP=gr;class mr{constructor(z){this.value=z}}e.$FP=mr;class pr{constructor(z,re){this.value=z,this.iconPath=re}}e.$GP=pr;class $r{constructor(z,re){this.uri=z,this.edits=Array.isArray(re)?re:[re]}}e.$HP=$r;class wr{constructor(z,re,De,Qe){this.prompt=z,this.command=re,this.references=De,this.participant=Qe}}e.$IP=wr;class br{constructor(z,re,De,Qe){this.response=z,this.result=re,this.participant=De,this.command=Qe}}e.$JP=br;var Mn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Mn||(e.ChatLocation=Mn={}));class vr{constructor(z,re,De){this.document=z,this.selection=re,this.wholeRange=De}}e.$KP=vr;class yr{constructor(z){this.cell=z}}e.$LP=yr;var pn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Er{constructor(z,re,De){this.name=z,this.content=re,this.isError=De??!1}}e.$MP=Er;class $n{static User(z,re){const De=new $n(pn.User,typeof z=="string"?z:"",re);return De.content2=z,De}static Assistant(z,re){return new $n(pn.Assistant,z,re)}constructor(z,re,De){this.role=z,this.content=re,this.content2=re,this.name=De}}e.$NP=$n;class Sr{constructor(z,re){this.name=z,this.parameters=re}}e.$OP=Sr;class Dr{constructor(z){this.value=z}}e.$PP=Dr;class kr{constructor(z){this.content=z}}e.$QP=kr;class Cr{constructor(z,re){this.content=z,this.name=re}}e.$RP=Cr;class Ir{constructor(z,re){this.content=z,this.name=re}}e.$SP=Ir;class Ti extends Error{static NotFound(z){return new Ti(z,Ti.NotFound.name)}static NoPermissions(z){return new Ti(z,Ti.NoPermissions.name)}static Blocked(z){return new Ti(z,Ti.Blocked.name)}constructor(z,re,De){super(z,{cause:De}),this.name="LanguageModelError",this.code=re??""}}e.$TP=Ti;var Fn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Fn||(e.RelatedInformationType=Fn={}));var zn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(zn||(e.SpeechToTextStatus=zn={}));var Un;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Un||(e.TextToSpeechStatus=Un={}));var jn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Pr{constructor(z,re){this.text=z,this.range=re}}e.$UP=Pr;var Bn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Bn||(e.InlineEditTriggerKind=Bn={}))}),define(Oe[226],Ne([1,0,5,7]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$vN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,$){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(A);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(T,$)??[]}getRelatedInformation(A,T,$){return this.c.$getAiRelatedInformation(T,$)}registerRelatedInformationProvider(A,T,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiRelatedInformationProvider(a,T),new P.$xN(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$roc=I}),define(Oe[90],Ne([1,0,6,5,7,18,117,3,16]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0,e.$Coc=(0,T.$Ci)("IExtHostAuthentication");let a=class{constructor(c){this.b=new Map,this.c=new v.$je,this.onDidChangeSessions=this.c.event,this.d=new R,this.a=c.getProxy(P.$vN.MainThreadAuthentication)}async getSession(c,D,f,n={}){const o=O.$on.toKey(c.identifier),s=[...f].sort().join(" ");return await this.d.getOrCreate(`${o} ${D} ${s}`,async()=>{await this.a.$ensureProvider(D);const l=c.displayName||c.name;return this.a.$getSession(D,f,o,l,n)})}async getAccounts(c){return await this.a.$ensureProvider(c),await this.a.$getAccounts(c)}async removeSession(c,D){const f=this.b.get(c);return f?f.provider.removeSession(D):this.a.$removeSession(c,D)}registerAuthenticationProvider(c,D,f,n){if(this.b.get(c))throw new Error(`An authentication provider with id '${c}' is already registered.`);this.b.set(c,{label:D,provider:f,options:n??{supportsMultipleAccounts:!1}});const o=f.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(c,s));return this.a.$registerAuthenticationProvider(c,D,n?.supportsMultipleAccounts??!1),new I.$xN(()=>{o.dispose(),this.b.delete(c),this.a.$unregisterAuthenticationProvider(c)})}async $createSession(c,D,f){const n=this.b.get(c);if(n)return await n.provider.createSession(D,f);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $removeSession(c,D){const f=this.b.get(c);if(f)return await f.provider.removeSession(D);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $getSessions(c,D,f){const n=this.b.get(c);if(n)return await n.provider.getSessions(D,f);throw new Error(`Unable to find authentication provider with handle: ${c}`)}$onDidChangeAuthenticationSessions(c,D){return c.startsWith(A.$xM)||this.c.fire({provider:{id:c,label:D}}),Promise.resolve()}};e.$Doc=a,e.$Doc=a=He([Ve(0,$.$6P)],a);class R{constructor(){this.a=new Map}getOrCreate(c,D){const f=this.a.get(c);if(f)return f;const n=D().finally(()=>this.a.delete(c));return this.a.set(c,n),n}}}),define(Oe[122],Ne([1,0,2,5,7,3,16,11,17,12,19,24]),function(we,e,v,P,I,O,A,T,$,a,R,y){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=e.$Hpc=void 0;let D=class{static{c=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(P.$vN.MainThreadDecorations)}registerFileDecorationProvider(n,o){const s=c.c++;this.f.set(s,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const l=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const r=(0,$.$1b)(i);if(r.length<=c.d){this.g.$onDidChange(s,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,r.length);const t=r.map(p=>({uri:p,rank:(0,a.$gf)(p.path,"/")})),g=(0,$.$yb)(t,(p,m)=>p.rank-m.rank||(0,a.$wf)(p.uri.path,m.uri.path)),u=[];e:for(const p of g){let m;for(const h of p){const E=(0,R.$lc)(h.uri.path);if(m!==E&&(m=E,u.push(h.uri)>=c.d))break e}}this.g.$onDidChange(s,u)});return new I.$xN(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(n,o,s){if(!this.f.has(n))return Object.create(null);const l=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(o.map(async t=>{try{const{uri:g,id:u}=t,p=await Promise.resolve(i.provideFileDecoration(v.URI.revive(g),s));if(!p)return;try{I.$ZO.validate(p),p.badge&&typeof p.badge!="string"&&(0,y.$8G)(r,"codiconDecoration"),l[u]=[p.propagate,p.tooltip,p.badge,p.color]}catch(m){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${m}`)}}catch(g){this.h.error(g)}})),l}};e.$Hpc=D,e.$Hpc=D=c=He([Ve(0,A.$6P),Ve(1,T.$0j)],D),e.$Ipc=(0,O.$Ci)("IExtHostDecorations")}),define(Oe[227],Ne([1,0,13,2,7,5,15,21,12]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0;class a{static{this.a=0}constructor(y,c,D){this.d=c,this.e=D,this.b=new Map,this.c=y.getProxy(O.$vN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,c){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const D=a.a++;this.b.set(D,c),this.c.$registerTextContentProvider(D,y);let f;if(typeof c.onDidChange=="function"){let n;f=c.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const s=this.$provideTextDocumentContent(D,o).then(async l=>{if(!l&&typeof l!="string")return;const i=this.d.getDocument(o);if(!i)return;const r=(0,$.$qf)(l);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(o,l)}).catch(v.$Y).finally(()=>{n===s&&(n=void 0)});n=s})}return new I.$xN(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(y,c){const D=this.b.get(y);return D?Promise.resolve(D.provideTextDocumentContent(P.URI.revive(c),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.$Kpc=a}),define(Oe[123],Ne([1,0,61,15,12,283,168,7,17]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=void 0,e.$8P=R;const a=new Map;function R(f,n){n?a.set(f,n):a.delete(f)}function y(f){return a.get(f)}class c extends O.$mw{constructor(n,o,s,l,i,r,t){super(o,s,l,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,$.$tb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===P.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,s){return n.y(o,s)},[Symbol.for("debug.description")](){return`TextDocument(${n.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,v.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,v.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,l=o.start.line,i=o.end.line,r=[];r.push(this.f[l].substring(o.start.character));for(let t=l+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,o.end.character)),r.join(s)}t(n){let o;if(n instanceof T.$yN?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new D(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),s=this.f[o.index].length;return new T.$yN(o.index,Math.min(o.remainder,s))}w(n){if(!(n instanceof T.$zN))throw new Error("Invalid argument");const o=this.x(n.start),s=this.x(n.end);return o===n.start&&s===n.end?n:new T.$zN(o.line,o.character,s.line,s.character)}x(n){if(!(n instanceof T.$yN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:s}=n,l=!1;if(o<0)o=0,s=0,l=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,l=!0;else{const i=this.f[o].length;s<0?(s=0,l=!0):s>i&&(s=i,l=!0)}return l?new T.$yN(o,s):n}y(n,o){const s=this.x(n);if(!o)o=y(this.m);else if((0,I.$pf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const l=(0,A.$nt)(s.character+1,(0,A.$lt)(o),this.f[s.line],0);if(l)return new T.$zN(s.line,l.startColumn-1,s.line,l.endColumn-1)}}e.$9P=c;class D{constructor(n,o,s){this.a=n,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$zN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$zN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$0P=D}),define(Oe[228],Ne([1,0,5,7]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$vN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(A);if(!a)throw new Error("Embedding vector provider not found");const R=await a.provideEmbeddingVector(T,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,T,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiEmbeddingVectorProvider(T,a),new P.$xN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$Npc=I}),define(Oe[68],Ne([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(we,e,v,P,I,O,A,T,$,a,R,y,c){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=e.$Soc=void 0,P=qe(P);let f=D=class{constructor(o,s){this.b=new Map,this.c=new R.$Lh,this.a=o.getProxy(v.$vN.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(i){try{let r;const t=l.b.get(i.scheme);return t?(await l.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await l.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===P.FilePermission.Readonly?1:void 0}}catch(r){D.e(r)}},async readDirectory(i){try{const r=l.b.get(i.scheme);return r?(await l.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await l.a.$readdir(i)}catch(r){return D.e(r)}},async createDirectory(i){try{const r=l.b.get(i.scheme);return r&&!r.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(r.impl,r.extUri,i)):await l.a.$mkdir(i)}catch(r){return D.e(r)}},async readFile(i){try{const r=l.b.get(i.scheme);return r?(await l.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await l.a.$readFile(i)).buffer}catch(r){return D.e(r)}},async writeFile(i,r){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(t.impl,t.extUri,t.extUri.dirname(i)),await l.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await l.a.$writeFile(i,O.$Le.wrap(r))}catch(t){return D.e(t)}},async delete(i,r){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await l.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await l.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return D.e(t)}},async rename(i,r,t){try{return await l.a.$rename(i,r,{overwrite:!1,...t})}catch(g){return D.e(g)}},async copy(i,r,t){try{return await l.a.$copy(i,r,{overwrite:!1,...t})}catch(g){return D.e(g)}},isWritableFileSystem(i){const r=s.getCapabilities(i);if(typeof r=="number")return!(r&P.FileSystemProviderCapabilities.Readonly)}})}async d(o,s,l){const i=[];for(;!s.isEqual(l,s.dirname(l));)try{if(!((await o.stat(l)).type&P.FileType.Directory))throw I.$QO.FileExists(`Unable to create folder '${l.scheme===c.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(P.$nl(r)!==P.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(s.basename(l)),l=s.dirname(l)}for(let r=i.length-1;r>=0;r--){l=s.joinPath(l,i[r]);try{await o.createDirectory(l)}catch(t){if(P.$nl(t)!==P.FileSystemProviderErrorCode.FileExists)throw t}}}static e(o){if(o instanceof I.$QO)throw o;if(o instanceof P.$jl)switch(o.code){case P.FileSystemProviderErrorCode.FileExists:throw I.$QO.FileExists(o.message);case P.FileSystemProviderErrorCode.FileNotFound:throw I.$QO.FileNotFound(o.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw I.$QO.FileNotADirectory(o.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw I.$QO.FileIsADirectory(o.message);case P.FileSystemProviderErrorCode.NoPermissions:throw I.$QO.NoPermissions(o.message);case P.FileSystemProviderErrorCode.Unavailable:throw I.$QO.Unavailable(o.message);default:throw new I.$QO(o.message,o.name)}if(!(o instanceof Error))throw new I.$QO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$QO.Unavailable(o.message);switch(o.name){case P.FileSystemProviderErrorCode.FileExists:throw I.$QO.FileExists(o.message);case P.FileSystemProviderErrorCode.FileNotFound:throw I.$QO.FileNotFound(o.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw I.$QO.FileNotADirectory(o.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw I.$QO.FileIsADirectory(o.message);case P.FileSystemProviderErrorCode.NoPermissions:throw I.$QO.NoPermissions(o.message);case P.FileSystemProviderErrorCode.Unavailable:throw I.$QO.Unavailable(o.message);default:throw new I.$QO(o.message,o.name)}}addFileSystemProvider(o,s,l){return this.b.set(o,{impl:s,extUri:l?.isCaseSensitive?y.$6g:y.$8g,isReadonly:!!l?.isReadonly}),(0,a.$Rc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$6g}};e.$Soc=f,e.$Soc=f=D=He([Ve(0,T.$6P),Ve(1,$.$woc)],f),e.$Toc=(0,A.$Ci)("IExtHostConsumerFileSystem")}),define(Oe[91],Ne([1,0,3,26,11,68,2]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=void 0,e.$Uoc=(0,v.$Ci)("IExtensionStoragePaths");let T=class{constructor(a,R,y){this.d=R,this.f=y,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(c=>this.c=c)}async g(a){return A.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,R=await this.g(a);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(a){if(this.c)return A.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return A.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Voc=T,e.$Voc=T=He([Ve(0,P.$jQ),Ve(1,I.$0j),Ve(2,O.$Toc)],T)}),define(Oe[229],Ne([1,0,7,16,6]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=void 0;let O=class{constructor(T){this.a=new v.$1O(v.ColorThemeKind.Dark),this.b=new I.$je}get activeColorTheme(){return this.a}$onColorThemeChange(T){let $;switch(T){case"light":$=v.ColorThemeKind.Light;break;case"hcDark":$=v.ColorThemeKind.HighContrast;break;case"hcLight":$=v.ColorThemeKind.HighContrastLight;break;default:$=v.ColorThemeKind.Dark}this.a=new v.$1O($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$sqc=O,e.$sqc=O=He([Ve(0,P.$6P)],O)}),define(Oe[92],Ne([1,0,21,6,4,9,3,11,182,5,26,16,7]),function(we,e,v,P,I,O,A,T,$,a,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VFb=e.$UFb=e.TunnelDtoConverter=void 0,O=qe(O),c=qe(c);class D extends $.$Lw{}var f;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function l(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=l})(f||(e.TunnelDtoConverter=f={})),e.$UFb=(0,A.$Ci)("IExtHostTunnelService");let n=class extends I.$Tc{constructor(s,l,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new P.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(a.$vN.MainThreadTunnelService)}async openTunnel(s,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const i=await this.a.$openTunnel(l,s.displayName);if(i){const r=new D(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,l){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:l}),this.a.$registerPortsAttributesProvider(s,i),new c.$xN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,l,i,r,t){const g=[];for(const p of s){const m=this.r.get(p);if(!m)return[];g.push(...await Promise.all(l.map(async h=>{let E;try{E=await m.provider.providePortAttributes({port:h,pid:i,commandLine:r},t)}catch{E=await m.provider.providePortAttributes(h,i,r,t)}return{providedAttributes:E,port:h}})))}const u=g.filter(p=>!!p.providedAttributes);return u.length>0?u.map(p=>({autoForwardAction:p.providedAttributes.autoForwardAction,port:p.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await s.provideTunnel(r,t,v.CancellationToken.None)??void 0;const i=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions,protocol:l.tunnelFeatures.protocol===void 0?!0:l.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,I.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,l){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(l?this.w(l):void 0);if(i){this.b=i;let r=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:O.localize(10660,null),themeIcon:"lock"},{id:"public",label:O.localize(10661,null),themeIcon:"eye"}]);const t=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,I.$Rc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,l){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(l&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:r,disposeListener:t}),f.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const l=await Promise.all(s.map(r=>this.f(r.host,r.port,r.detail??""))),i=s.filter((r,t)=>l[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$VFb=n,e.$VFb=n=He([Ve(0,y.$6P),Ve(1,R.$jQ),Ve(2,T.$0j)],n)}),define(Oe[8],Ne([1,0,17,22,150,230,59,28,137,40,72,25,143,23,34,14,2,105,32,158,93,52,107,76,116,114,115,206,80,89,54,55,203,7]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u,p,m,h,E,S,w,k,C,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$3P=ce,e.$4P=oe,e.$5P=Ce,A=qe(A),l=qe(l),i=qe(i),r=qe(r),E=qe(E),w=qe(w),b=qe(b);var F;(function(ye){function Re(H){const{selectionStartLineNumber:Ee,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:Ge}=H,ut=new b.$yN(Ee-1,Be-1),Pt=new b.$yN(Ze-1,Ge-1);return new b.$AN(ut,Pt)}ye.to=Re;function le(H){const{anchor:Ee,active:Be}=H;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}ye.from=le})(F||(e.Selection=F={}));var N;(function(ye){function Re(H){if(!H)return;const{start:Ee,end:Be}=H;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}ye.from=Re;function le(H){if(!H)return;const{startLineNumber:Ee,startColumn:Be,endLineNumber:Ze,endColumn:Ge}=H;return new b.$zN(Ee-1,Be-1,Ze-1,Ge-1)}ye.to=le})(N||(e.Range=N={}));var M;(function(ye){function Re(H){return{uri:H.uri,range:N.from(H.range)}}ye.from=Re;function le(H){return new b.$LN(o.URI.revive(H.uri),N.to(H.range))}ye.to=le})(M||(e.Location=M={}));var V;(function(ye){function Re(le){switch(le){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}ye.to=Re})(V||(e.TokenType=V={}));var W;(function(ye){function Re(H){return new b.$yN(H.lineNumber-1,H.column-1)}ye.to=Re;function le(H){return{lineNumber:H.line+1,column:H.character+1}}ye.from=le})(W||(e.Position=W={}));var L;(function(ye){function Re(Ee,Be,Ze){return(0,v.$Gb)((0,v.$1b)(Ee).map(Ge=>le(Ge,Be,Ze)))}ye.from=Re;function le(Ee,Be,Ze){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ze?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:H(Ee.scheme,Be),pattern:xe.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ze?.isBuiltin}}function H(Ee,Be){return Be&&typeof Ee=="string"?Be.transformOutgoingScheme(Ee):Ee}})(L||(e.DocumentSelector=L={}));var Y;(function(ye){function Re(H){switch(H){case b.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}ye.from=Re;function le(H){switch(H){case g.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}ye.to=le})(Y||(e.DiagnosticTag=Y={}));var Z;(function(ye){function Re(H){let Ee;return H.code&&((0,n.$cg)(H.code)||(0,n.$gg)(H.code)?Ee=String(H.code):Ee={value:String(H.code.value),target:H.code.target}),{...N.from(H.range),message:H.message,source:H.source,code:Ee,severity:_.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(ge.from),tags:Array.isArray(H.tags)?(0,v.$Gb)(H.tags.map(Y.from)):void 0}}ye.from=Re;function le(H){const Ee=new b.$NN(N.to(H),H.message,_.to(H.severity));return Ee.source=H.source,Ee.code=(0,n.$cg)(H.code)?H.code:H.code?.value,Ee.relatedInformation=H.relatedInformation&&H.relatedInformation.map(ge.to),Ee.tags=H.tags&&(0,v.$Gb)(H.tags.map(Y.to)),Ee}ye.to=le})(Z||(e.Diagnostic=Z={}));var ge;(function(ye){function Re(H){return{...N.from(H.location.range),message:H.message,resource:H.location.uri}}ye.from=Re;function le(H){return new b.$MN(new b.$LN(H.resource,N.to(H)),H.message)}ye.to=le})(ge||(e.DiagnosticRelatedInformation=ge={}));var _;(function(ye){function Re(H){switch(H){case b.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ye.from=Re;function le(H){switch(H){case g.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ye.to=le})(_||(e.DiagnosticSeverity=_={}));var fe;(function(ye){function Re(H){return typeof H=="number"&&H>=b.ViewColumn.One?H-1:H===b.ViewColumn.Beside?d.$pE:d.$oE}ye.from=Re;function le(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=le})(fe||(e.ViewColumn=fe={}));function se(ye){return typeof ye.range<"u"}function ce(ye){return ye.length===0?!0:!!se(ye[0])}var $e;(function(ye){function Re(Ge){return Ge.map(ye.from)}ye.fromMany=Re;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function H(Ge){let ut;if(le(Ge)){const{language:Ut,value:ii}=Ge;ut={value:"```"+Ut+`
`+ii+"\n```\n"}}else b.$2N.isMarkdownString(Ge)?ut={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ut={value:Ge}:ut={value:""};const Pt=Object.create(null);ut.uris=Pt;const ti=Ut=>{try{let ii=o.URI.parse(Ut,!0);ii=ii.with({query:Ee(ii.query,Pt)}),Pt[Ut]=ii}catch{}return""},ai=new $.marked.Renderer;return ai.link=ti,ai.image=Ut=>typeof Ut=="string"?ti(A.$9k(Ut).href):"",(0,$.marked)(ut.value,{renderer:ai}),ut}ye.from=H;function Ee(Ge,ut){if(!Ge)return Ge;let Pt;try{Pt=(0,a.$$h)(Ge)}catch{}if(!Pt)return Ge;let ti=!1;return Pt=(0,y.$do)(Pt,ai=>{if(o.URI.isUri(ai)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ut]=ai,ti=!0,Ut}else return}),ti?JSON.stringify(Pt):Ge}function Be(Ge){const ut=new b.$2N(Ge.value,Ge.supportThemeIcons);return ut.isTrusted=Ge.isTrusted,ut.supportHtml=Ge.supportHtml,ut.baseUri=Ge.baseUri?o.URI.from(Ge.baseUri):void 0,ut}ye.to=Be;function Ze(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Ze})($e||(e.MarkdownString=$e={}));function oe(ye){return ce(ye)?ye.map(Re=>({range:N.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?$e.fromMany(Re.hoverMessage):Re.hoverMessage?$e.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):ye.map(Re=>({range:N.from(Re)}))}function Ce(ye){return typeof ye>"u"?ye:typeof ye=="string"?o.URI.file(ye):ye}var Le;(function(ye){function Re(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?Ce(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ye.from=Re})(Le||(e.ThemableDecorationAttachmentRenderOptions=Le={}));var X;(function(ye){function Re(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Ce(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Le.from(le.before):void 0,after:le.after?Le.from(le.after):void 0}}ye.from=Re})(X||(e.ThemableDecorationRenderOptions=X={}));var q;(function(ye){function Re(le){if(typeof le>"u")return le;switch(le){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Re})(q||(e.DecorationRangeBehavior=q={}));var te;(function(ye){function Re(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?q.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?X.from(le.light):void 0,dark:le.dark?X.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Ce(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Le.from(le.before):void 0,after:le.after?Le.from(le.after):void 0}}ye.from=Re})(te||(e.DecorationRenderOptions=te={}));var ve;(function(ye){function Re(H){return{text:H.newText,eol:H.newEol&&je.from(H.newEol),range:N.from(H.range)}}ye.from=Re;function le(H){const Ee=new b.$GN(N.to(H.range),H.text);return Ee.newEol=typeof H.eol>"u"?void 0:je.to(H.eol),Ee}ye.to=le})(ve||(e.TextEdit=ve={}));var ae;(function(ye){function Re(H,Ee){const Be={edits:[]};if(H instanceof b.$JN){const Ze=new T.$Ac;for(const Ge of H._allEntries())Ge._type===b.FileEditType.File&&o.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of H._allEntries())if(Ge._type===b.FileEditType.File){let ut;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ut={type:"base64",value:(0,P.$6e)(P.$Le.wrap(Ge.options.contents))}:ut={type:"dataTransferItem",id:Ge.options.contents._itemId}),Be.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ut},metadata:Ge.metadata})}else Ge._type===b.FileEditType.Text?Be.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Snippet?Be.edits.push({resource:Ge.uri,textEdit:{range:N.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Cell?Be.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===b.FileEditType.CellReplace&&Be.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:w.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Ye.from)}})}return Be}ye.from=Re;function le(H){const Ee=new b.$JN,Be=new T.$zc;for(const Ze of H.edits)if(Ze.textEdit){const Ge=Ze,ut=o.URI.revive(Ge.resource),Pt=N.to(Ge.textEdit.range),ti=Ge.textEdit.text,ai=Ge.textEdit.insertAsSnippet;let Ut;ai?Ut=b.$IN.replace(Pt,new b.$KN(ti)):Ut=b.$GN.replace(Pt,ti);const ii=Be.get(ut);ii?ii.push(Ut):Be.set(ut,[Ut])}else Ee.renameFile(o.URI.revive(Ze.oldResource),o.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ge]of Be)Ee.set(Ze,Ge);return Ee}ye.to=le})(ae||(e.WorkspaceEdit=ae={}));var be;(function(ye){const Re=Object.create(null);Re[b.SymbolKind.File]=r.SymbolKind.File,Re[b.SymbolKind.Module]=r.SymbolKind.Module,Re[b.SymbolKind.Namespace]=r.SymbolKind.Namespace,Re[b.SymbolKind.Package]=r.SymbolKind.Package,Re[b.SymbolKind.Class]=r.SymbolKind.Class,Re[b.SymbolKind.Method]=r.SymbolKind.Method,Re[b.SymbolKind.Property]=r.SymbolKind.Property,Re[b.SymbolKind.Field]=r.SymbolKind.Field,Re[b.SymbolKind.Constructor]=r.SymbolKind.Constructor,Re[b.SymbolKind.Enum]=r.SymbolKind.Enum,Re[b.SymbolKind.Interface]=r.SymbolKind.Interface,Re[b.SymbolKind.Function]=r.SymbolKind.Function,Re[b.SymbolKind.Variable]=r.SymbolKind.Variable,Re[b.SymbolKind.Constant]=r.SymbolKind.Constant,Re[b.SymbolKind.String]=r.SymbolKind.String,Re[b.SymbolKind.Number]=r.SymbolKind.Number,Re[b.SymbolKind.Boolean]=r.SymbolKind.Boolean,Re[b.SymbolKind.Array]=r.SymbolKind.Array,Re[b.SymbolKind.Object]=r.SymbolKind.Object,Re[b.SymbolKind.Key]=r.SymbolKind.Key,Re[b.SymbolKind.Null]=r.SymbolKind.Null,Re[b.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Re[b.SymbolKind.Struct]=r.SymbolKind.Struct,Re[b.SymbolKind.Event]=r.SymbolKind.Event,Re[b.SymbolKind.Operator]=r.SymbolKind.Operator,Re[b.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function le(Ee){return typeof Re[Ee]=="number"?Re[Ee]:r.SymbolKind.Property}ye.from=le;function H(Ee){for(const Be in Re)if(Re[Be]===Ee)return Number(Be);return b.SymbolKind.Property}ye.to=H})(be||(e.SymbolKind=be={}));var ue;(function(ye){function Re(H){switch(H){case b.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}ye.from=Re;function le(H){switch(H){case r.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}ye.to=le})(ue||(e.SymbolTag=ue={}));var J;(function(ye){function Re(H){return{name:H.name,kind:be.from(H.kind),tags:H.tags&&H.tags.map(ue.from),containerName:H.containerName,location:ze.from(H.location)}}ye.from=Re;function le(H){const Ee=new b.$SN(H.name,be.to(H.kind),H.containerName,ze.to(H.location));return Ee.tags=H.tags&&H.tags.map(ue.to),Ee}ye.to=le})(J||(e.WorkspaceSymbol=J={}));var x;(function(ye){function Re(H){const Ee={name:H.name||"!!MISSING: name!!",detail:H.detail,range:N.from(H.range),selectionRange:N.from(H.selectionRange),kind:be.from(H.kind),tags:H.tags?.map(ue.from)??[]};return H.children&&(Ee.children=H.children.map(Re)),Ee}ye.from=Re;function le(H){const Ee=new b.$TN(H.name,H.detail,be.to(H.kind),N.to(H.range),N.to(H.selectionRange));return(0,v.$Kb)(H.tags)&&(Ee.tags=H.tags.map(ue.to)),H.children&&(Ee.children=H.children.map(le)),Ee}ye.to=le})(x||(e.DocumentSymbol=x={}));var me;(function(ye){function Re(H){const Ee=new b.$XN(be.to(H.kind),H.name,H.detail||"",o.URI.revive(H.uri),N.to(H.range),N.to(H.selectionRange));return Ee._sessionId=H._sessionId,Ee._itemId=H._itemId,Ee}ye.to=Re;function le(H,Ee,Be){if(Ee=Ee??H._sessionId,Be=Be??H._itemId,Ee===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Be,name:H.name,detail:H.detail,kind:be.from(H.kind),uri:H.uri,range:N.from(H.range),selectionRange:N.from(H.selectionRange),tags:H.tags?.map(ue.from)}}ye.from=le})(me||(e.CallHierarchyItem=me={}));var pe;(function(ye){function Re(le){return new b.$YN(me.to(le.from),le.fromRanges.map(H=>N.to(H)))}ye.to=Re})(pe||(e.CallHierarchyIncomingCall=pe={}));var Ae;(function(ye){function Re(le){return new b.$ZN(me.to(le.to),le.fromRanges.map(H=>N.to(H)))}ye.to=Re})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var ze;(function(ye){function Re(H){return{range:H.range&&N.from(H.range),uri:H.uri}}ye.from=Re;function le(H){return new b.$LN(o.URI.revive(H.uri),N.to(H.range))}ye.to=le})(ze||(e.location=ze={}));var ke;(function(ye){function Re(H){const Ee=H,Be=H;return{originSelectionRange:Ee.originSelectionRange?N.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Be.uri,range:N.from(Ee.targetRange?Ee.targetRange:Be.range),targetSelectionRange:Ee.targetSelectionRange?N.from(Ee.targetSelectionRange):void 0}}ye.from=Re;function le(H){return{targetUri:o.URI.revive(H.uri),targetRange:N.to(H.range),targetSelectionRange:H.targetSelectionRange?N.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?N.to(H.originSelectionRange):void 0}}ye.to=le})(ke||(e.DefinitionLink=ke={}));var Pe;(function(ye){function Re(H){return{range:N.from(H.range),contents:$e.fromMany(H.contents),canIncreaseVerbosity:H.canIncreaseVerbosity,canDecreaseVerbosity:H.canDecreaseVerbosity}}ye.from=Re;function le(H){const Ee=H.contents.map($e.to),Be=N.to(H.range),Ze=H.canIncreaseVerbosity,Ge=H.canDecreaseVerbosity;return new b.$PN(Ee,Be,Ze,Ge)}ye.to=le})(Pe||(e.Hover=Pe={}));var Te;(function(ye){function Re(H){return{range:N.from(H.range),expression:H.expression}}ye.from=Re;function le(H){return new b.$KO(N.to(H.range),H.expression)}ye.to=le})(Te||(e.EvaluatableExpression=Te={}));var U;(function(ye){function Re(H){if(H instanceof b.$LO)return{type:"text",range:N.from(H.range),text:H.text};if(H instanceof b.$MO)return{type:"variable",range:N.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof b.$NO)return{type:"expression",range:N.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Re;function le(H){switch(H.type){case"text":return{range:N.to(H.range),text:H.text};case"variable":return{range:N.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:N.to(H.range),expression:H.expression}}}ye.to=le})(U||(e.InlineValue=U={}));var B;(function(ye){function Re(H){return{frameId:H.frameId,stoppedLocation:N.from(H.stoppedLocation)}}ye.from=Re;function le(H){return new b.$OO(H.frameId,N.to(H.stoppedLocation))}ye.to=le})(B||(e.InlineValueContext=B={}));var K;(function(ye){function Re(H){return{range:N.from(H.range),kind:H.kind}}ye.from=Re;function le(H){return new b.$QN(N.to(H.range),H.kind)}ye.to=le})(K||(e.DocumentHighlight=K={}));var G;(function(ye){function Re(H){return{uri:H.uri,highlights:H.highlights.map(K.from)}}ye.from=Re;function le(H){return new b.$RN(o.URI.revive(H.uri),H.highlights.map(K.to))}ye.to=le})(G||(e.MultiDocumentHighlight=G={}));var ie;(function(ye){function Re(le){switch(le){case r.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}ye.to=Re})(ie||(e.CompletionTriggerKind=ie={}));var de;(function(ye){function Re(le){return{triggerKind:ie.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ye.to=Re})(de||(e.CompletionContext=de={}));var Ie;(function(ye){function Re(H){switch(H){case b.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}ye.from=Re;function le(H){switch(H){case r.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}ye.to=le})(Ie||(e.CompletionItemTag=Ie={}));var Ue;(function(ye){const Re=new Map([[b.CompletionItemKind.Method,r.CompletionItemKind.Method],[b.CompletionItemKind.Function,r.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,r.CompletionItemKind.Field],[b.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[b.CompletionItemKind.Class,r.CompletionItemKind.Class],[b.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[b.CompletionItemKind.Module,r.CompletionItemKind.Module],[b.CompletionItemKind.Property,r.CompletionItemKind.Property],[b.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[b.CompletionItemKind.Value,r.CompletionItemKind.Value],[b.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,r.CompletionItemKind.Text],[b.CompletionItemKind.Color,r.CompletionItemKind.Color],[b.CompletionItemKind.File,r.CompletionItemKind.File],[b.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[b.CompletionItemKind.Event,r.CompletionItemKind.Event],[b.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[b.CompletionItemKind.User,r.CompletionItemKind.User]]);function le(Be){return Re.get(Be)??r.CompletionItemKind.Property}ye.from=le;const H=new Map([[r.CompletionItemKind.Method,b.CompletionItemKind.Method],[r.CompletionItemKind.Function,b.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,b.CompletionItemKind.Field],[r.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[r.CompletionItemKind.Class,b.CompletionItemKind.Class],[r.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[r.CompletionItemKind.Module,b.CompletionItemKind.Module],[r.CompletionItemKind.Property,b.CompletionItemKind.Property],[r.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[r.CompletionItemKind.Value,b.CompletionItemKind.Value],[r.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,b.CompletionItemKind.Text],[r.CompletionItemKind.Color,b.CompletionItemKind.Color],[r.CompletionItemKind.File,b.CompletionItemKind.File],[r.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[r.CompletionItemKind.Event,b.CompletionItemKind.Event],[r.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,b.CompletionItemKind.User],[r.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ee(Be){return H.get(Be)??b.CompletionItemKind.Property}ye.to=Ee})(Ue||(e.CompletionItemKind=Ue={}));var Ke;(function(ye){function Re(le,H){const Ee=new b.$8N(le.label);return Ee.insertText=le.insertText,Ee.kind=Ue.to(le.kind),Ee.tags=le.tags?.map(Ie.to),Ee.detail=le.detail,Ee.documentation=A.$3k(le.documentation)?$e.to(le.documentation):le.documentation,Ee.sortText=le.sortText,Ee.filterText=le.filterText,Ee.preselect=le.preselect,Ee.commitCharacters=le.commitCharacters,l.$Lt.isIRange(le.range)?Ee.range=N.to(le.range):typeof le.range=="object"&&(Ee.range={inserting:N.to(le.range.insert),replacing:N.to(le.range.replace)}),Ee.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new b.$KN(le.insertText):(Ee.insertText=le.insertText,Ee.textEdit=Ee.range instanceof b.$zN?new b.$GN(Ee.range,Ee.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ee.additionalTextEdits=le.additionalTextEdits.map(Be=>ve.to(Be))),Ee.command=H&&le.command?H.fromInternal(le.command):void 0,Ee}ye.to=Re})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ye){function Re(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:$e.fromStrict(H.documentation)}}ye.from=Re;function le(H){return{label:H.label,documentation:A.$3k(H.documentation)?$e.to(H.documentation):H.documentation}}ye.to=le})(_e||(e.ParameterInformation=_e={}));var tt;(function(ye){function Re(H){return{label:H.label,documentation:$e.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(_e.from):[],activeParameter:H.activeParameter}}ye.from=Re;function le(H){return{label:H.label,documentation:A.$3k(H.documentation)?$e.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(_e.to):[],activeParameter:H.activeParameter}}ye.to=le})(tt||(e.SignatureInformation=tt={}));var nt;(function(ye){function Re(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(tt.from):[]}}ye.from=Re;function le(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(tt.to):[]}}ye.to=le})(nt||(e.SignatureHelp=nt={}));var et;(function(ye){function Re(le,H){const Ee=new b.$7N(W.to(H.position),typeof H.label=="string"?H.label:H.label.map(rt.to.bind(void 0,le)),H.kind&&mt.to(H.kind));return Ee.textEdits=H.textEdits&&H.textEdits.map(ve.to),Ee.tooltip=A.$3k(H.tooltip)?$e.to(H.tooltip):H.tooltip,Ee.paddingLeft=H.paddingLeft,Ee.paddingRight=H.paddingRight,Ee}ye.to=Re})(et||(e.InlayHint=et={}));var rt;(function(ye){function Re(le,H){const Ee=new b.$6N(H.label);return Ee.tooltip=A.$3k(H.tooltip)?$e.to(H.tooltip):H.tooltip,r.Command.is(H.command)&&(Ee.command=le.fromInternal(H.command)),H.location&&(Ee.location=ze.to(H.location)),Ee}ye.to=Re})(rt||(e.InlayHintLabelPart=rt={}));var mt;(function(ye){function Re(H){return H}ye.from=Re;function le(H){return H}ye.to=le})(mt||(e.InlayHintKind=mt={}));var lt;(function(ye){function Re(H){return{range:N.from(H.range),url:H.target,tooltip:H.tooltip}}ye.from=Re;function le(H){let Ee;if(H.url)try{Ee=typeof H.url=="string"?o.URI.parse(H.url,!0):o.URI.revive(H.url)}catch{}const Be=new b.$aO(N.to(H.range),Ee);return Be.tooltip=H.tooltip,Be}ye.to=le})(lt||(e.DocumentLink=lt={}));var st;(function(ye){function Re(H){const Ee=new b.$dO(H.label);return H.textEdit&&(Ee.textEdit=ve.to(H.textEdit)),H.additionalTextEdits&&(Ee.additionalTextEdits=H.additionalTextEdits.map(Be=>ve.to(Be))),Ee}ye.to=Re;function le(H){return{label:H.label,textEdit:H.textEdit?ve.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}ye.from=le})(st||(e.ColorPresentation=st={}));var ct;(function(ye){function Re(H){return new b.$bO(H[0],H[1],H[2],H[3])}ye.to=Re;function le(H){return[H.red,H.green,H.blue,H.alpha]}ye.from=le})(ct||(e.Color=ct={}));var ft;(function(ye){function Re(H){return{range:N.from(H.range)}}ye.from=Re;function le(H){return new b.$WN(N.to(H.range))}ye.to=le})(ft||(e.SelectionRange=ft={}));var pt;(function(ye){function Re(le){switch(le){case m.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}ye.to=Re})(pt||(e.TextDocumentSaveReason=pt={}));var We;(function(ye){function Re(H){switch(H){case b.TextEditorLineNumbersStyle.Off:return s.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return s.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return s.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return s.RenderLineNumbersType.On}}ye.from=Re;function le(H){switch(H){case s.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case s.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case s.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case s.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}ye.to=le})(We||(e.TextEditorLineNumbersStyle=We={}));var je;(function(ye){function Re(H){if(H===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(H===b.EndOfLine.LF)return t.EndOfLineSequence.LF}ye.from=Re;function le(H){if(H===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(H===t.EndOfLineSequence.LF)return b.EndOfLine.LF}ye.to=le})(je||(e.EndOfLine=je={}));var ee;(function(ye){function Re(le){if(typeof le=="object")return le.viewId;switch(le){case b.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case b.ProgressLocation.Window:return u.ProgressLocation.Window;case b.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Re})(ee||(e.ProgressLocation=ee={}));var Q;(function(ye){function Re(H){const Ee={start:H.start+1,end:H.end+1};return H.kind&&(Ee.kind=Se.from(H.kind)),Ee}ye.from=Re;function le(H){const Ee={start:H.start-1,end:H.end-1};return H.kind&&(Ee.kind=Se.to(H.kind)),Ee}ye.to=le})(Q||(e.FoldingRange=Q={}));var Se;(function(ye){function Re(H){if(H)switch(H){case b.FoldingRangeKind.Comment:return r.$Mu.Comment;case b.FoldingRangeKind.Imports:return r.$Mu.Imports;case b.FoldingRangeKind.Region:return r.$Mu.Region}}ye.from=Re;function le(H){if(H)switch(H.value){case r.$Mu.Comment.value:return b.FoldingRangeKind.Comment;case r.$Mu.Imports.value:return b.FoldingRangeKind.Imports;case r.$Mu.Region.value:return b.FoldingRangeKind.Region}}ye.to=le})(Se||(e.FoldingRangeKind=Se={}));var Je;(function(ye){function Re(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?N.from(le.selection):void 0,override:typeof le.override=="boolean"?m.$TF.id:void 0}}ye.from=Re})(Je||(e.TextEditorOpenOptions=Je={}));var xe;(function(ye){function Re(Be){return Be instanceof b.$yO?Be.toJSON():typeof Be=="string"?Be:le(Be)||H(Be)?new b.$yO(Be.baseUri??Be.base,Be.pattern).toJSON():Be}ye.from=Re;function le(Be){const Ze=Be;return Ze?o.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function H(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ee(Be){return typeof Be=="string"?Be:new b.$yO(o.URI.revive(Be.baseUri),Be.pattern)}ye.to=Ee})(xe||(e.GlobPattern=xe={}));var ht;(function(ye){function Re(le){if(le){if(Array.isArray(le))return le.map(Re);if(typeof le=="string")return le;{const H=le;return{language:H.language,scheme:H.scheme,pattern:xe.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}ye.from=Re})(ht||(e.LanguageSelector=ht={}));var $t;(function(ye){function Re(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&o.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ze=>Ze instanceof b.$zN)))}ye.is=Re;function le(H){return{documents:H.documents.map(Ee=>Ee.map(Be=>({uri:o.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>N.from(Ze))})))}}ye.from=le})($t||(e.MappedEditsContext=$t={}));var Nt;(function(ye){function Re(H){return{start:H.start,end:H.end}}ye.from=Re;function le(H){return new b.$2O(H.start,H.end)}ye.to=le})(Nt||(e.NotebookRange=Nt={}));var qt;(function(ye){function Re(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}ye.to=Re;function le(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}ye.from=le})(qt||(e.NotebookCellExecutionSummary=qt={}));var ri;(function(ye){function Re(le){if(le===w.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(le===w.NotebookCellExecutionState.Pending)return;if(le===w.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}ye.to=Re})(ri||(e.NotebookCellExecutionState=ri={}));var Xt;(function(ye){function Re(H){switch(H){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ye.from=Re;function le(H){switch(H){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ye.to=le})(Xt||(e.NotebookCellKind=Xt={}));var di;(function(ye){function Re(H){const Ee={metadata:H.metadata??Object.create(null),cells:[]};for(const Be of H.cells)b.$3O.validate(Be),Ee.cells.push(Ye.from(Be));return Ee}ye.from=Re;function le(H){const Ee=new b.$4O(H.cells.map(Ye.to));return(0,n.$pg)(H.metadata)||(Ee.metadata=H.metadata),Ee}ye.to=le})(di||(e.NotebookData=di={}));var Ye;(function(ye){function Re(H){return{cellKind:Xt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:qt.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Gt.from):[]}}ye.from=Re;function le(H){return new b.$3O(Xt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Gt.to):void 0,H.metadata,H.internalMetadata?qt.to(H.internalMetadata):void 0)}ye.to=le})(Ye||(e.NotebookCellData=Ye={}));var Vt;(function(ye){function Re(H){return{mime:H.mime,valueBytes:P.$Le.wrap(H.data)}}ye.from=Re;function le(H){return new b.$5O(H.valueBytes.buffer,H.mime)}ye.to=le})(Vt||(e.NotebookCellOutputItem=Vt={}));var Gt;(function(ye){function Re(H){return{outputId:H.id,items:H.items.map(Vt.from),metadata:H.metadata}}ye.from=Re;function le(H){const Ee=H.items.map(Vt.to);return new b.$6O(Ee,H.outputId,H.metadata)}ye.to=le})(Gt||(e.NotebookCellOutput=Gt={}));var gt;(function(ye){function Re(Ee){return H(Ee)?{include:xe.from(Ee.include)??void 0,exclude:xe.from(Ee.exclude)??void 0}:xe.from(Ee)??void 0}ye.from=Re;function le(Ee){return H(Ee)?{include:xe.to(Ee.include),exclude:xe.to(Ee.exclude)}:xe.to(Ee)}ye.to=le;function H(Ee){const Be=Ee;return Be?!(0,n.$lg)(Be.include)&&!(0,n.$lg)(Be.exclude):!1}})(gt||(e.NotebookExclusiveDocumentPattern=gt={}));var Dt;(function(ye){function Re(le,H,Ee){const Be=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===b.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:H.toInternal(Be,Ee),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ye.from=Re})(Dt||(e.NotebookStatusBarItem=Dt={}));var Yt;(function(ye){function Re(le,H,Ee){const Be=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:H.toInternal(Be,Ee),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}ye.from=Re})(Yt||(e.NotebookKernelSourceAction=Yt={}));var Zt;(function(ye){function Re(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}ye.from=Re})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var jt;(function(ye){function Re(H){return{uri:H.uri,provides:H.provides}}ye.from=Re;function le(H){return new b.$8O(o.URI.revive(H.uri),H.provides)}ye.to=le})(jt||(e.NotebookRendererScript=jt={}));var bt;(function(ye){function Re(H){return{message:$e.fromStrict(H.message)||"",type:C.TestMessageType.Error,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:N.from(H.location.range),uri:H.location.uri}}}ye.from=Re;function le(H){const Ee=new b.$bP(typeof H.message=="string"?H.message:$e.to(H.message));return Ee.actualOutput=H.actual,Ee.expectedOutput=H.expected,Ee.contextValue=H.contextValue,Ee.location=H.location?ze.to(H.location):void 0,Ee}ye.to=le})(bt||(e.TestMessage=bt={}));var Rt;(function(ye){ye.namespace=C.$ZI,ye.denamespace=C.$1I})(Rt||(e.TestTag=Rt={}));var li;(function(ye){function Re(H){const Ee=(0,p.$2P)(H).controllerId;return{extId:k.$UI.fromExtHostTestItem(H,Ee).toString(),label:H.label,uri:o.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Be=>Rt.namespace(Ee,Be.id)),range:l.$Lt.lift(N.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&$e.fromStrict(H.error)||null}}ye.from=Re;function le(H){return{parent:void 0,error:void 0,id:k.$UI.fromString(H.extId).localId,label:H.label,uri:o.URI.revive(H.uri),tags:(H.tags||[]).map(Ee=>{const{tagId:Be}=Rt.denamespace(Ee);return new b.$cP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}ye.toPlain=le})(li||(e.TestItem=li={})),function(ye){function Re(H){return{id:H.id}}ye.from=Re;function le(H){return new b.$cP(H.id)}ye.to=le}(Rt||(e.TestTag=Rt={}));var Kt;(function(ye){const Re=(H,Ee)=>{const Be=H.value;if(!Be)return;const Ze={...li.toPlain(Be.item),parent:Ee,taskStates:Be.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ut=>ut.type===C.TestMessageType.Error).map(bt.to)})),children:[]};if(H.children)for(const Ge of H.children.values()){const ut=Re(Ge,Ze);ut&&Ze.children.push(ut)}return Ze};function le(H){const Ee=new c.$TI;for(const Ge of H.items)Ee.insert(k.$UI.fromString(Ge.item.extId).path,Ge);const Be=[Ee.nodes],Ze=[];for(;Be.length;)for(const Ge of Be.pop())Ge.value?Ze.push(Ge):Ge.children&&Be.push(Ge.children.values());return{completedAt:H.completedAt,results:Ze.map(Ge=>Re(Ge)).filter(n.$kg)}}ye.to=le})(Kt||(e.TestResults=Kt={}));var Xe;(function(ye){function Re(Be){return{covered:Be.covered,total:Be.total}}function le(Be){return"line"in Be?W.from(Be):N.from(Be)}function H(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:le(Be.location),type:C.DetailType.Statement,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&le(Ze.location),label:Ze.label})):void 0}:{type:C.DetailType.Declaration,name:Be.name,count:Be.executed,location:le(Be.location)}}ye.fromDetails=H;function Ee(Be,Ze,Ge){return b.$eP(Ge.statementCoverage),b.$eP(Ge.branchCoverage),b.$eP(Ge.declarationCoverage),{id:Ze,uri:Ge.uri,statement:Re(Ge.statementCoverage),branch:Ge.branchCoverage&&Re(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Re(Ge.declarationCoverage),testIds:Ge instanceof b.$fP&&Ge.fromTests.length?Ge.fromTests.map(ut=>k.$UI.fromExtHostTestItem(ut,Be).toString()):void 0}}ye.fromFile=Ee})(Xe||(e.TestCoverage=Xe={}));var xt;(function(ye){function Re(le){switch(le){case r.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}ye.to=Re})(xt||(e.CodeActionTriggerKind=xt={}));var ui;(function(ye){function Re(H){const Ee=new b.$jP(be.to(H.kind),H.name,H.detail||"",o.URI.revive(H.uri),N.to(H.range),N.to(H.selectionRange));return Ee._sessionId=H._sessionId,Ee._itemId=H._itemId,Ee}ye.to=Re;function le(H,Ee,Be){if(Ee=Ee??H._sessionId,Be=Be??H._itemId,Ee===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Be,kind:be.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:N.from(H.range),selectionRange:N.from(H.selectionRange),tags:H.tags?.map(ue.from)}}ye.from=le})(ui||(e.TypeHierarchyItem=ui={}));var fi;(function(ye){function Re(le){if(le)return{value:le.value,tooltip:le.tooltip}}ye.from=Re})(fi||(e.ViewBadge=fi={}));var kt;(function(ye){function Re(Be,Ze,Ge){const ut=Ze.fileData;return ut?new b.$qO(new b.$rO(ut.name,o.URI.revive(ut.uri),ut.id,(0,O.$cb)(()=>Ge(ut.id)))):Be===R.$8s.uriList&&Ze.uriListData?new b.$pO(Ee(Ze.uriListData)):new b.$pO(Ze.asString)}ye.to=Re;async function le(Be,Ze){const Ge=await Ze.asString();if(Be===R.$8s.uriList)return{asString:Ge,fileData:void 0,uriListData:H(Ge)};const ut=Ze.asFile();return{asString:Ge,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}ye.from=le;function H(Be){return I.$qu.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return o.URI.parse(Ze)}catch{}return Ze})}function Ee(Be){return I.$qu.create(Be.map(Ze=>typeof Ze=="string"?Ze:o.URI.revive(Ze)))}})(kt||(e.DataTransferItem=kt={}));var Mt;(function(ye){function Re(H,Ee){const Be=H.items.map(([Ze,Ge])=>[Ze,kt.to(Ze,Ge,Ee)]);return new b.$sO(Be)}ye.toDataTransfer=Re;async function le(H){const Ee={items:[]},Be=[];for(const[Ze,Ge]of H)Be.push((async()=>{Ee.items.push([Ze,await kt.from(Ze,Ge)])})());return await Promise.all(Be),Ee}ye.from=le})(Mt||(e.DataTransfer=Mt={}));var At;(function(ye){function Re(H,Ee){return{kind:"reply",agentId:H.participant??Ee?.agentId??"",subCommand:H.command??Ee?.command,message:H.prompt,title:H.label}}ye.from=Re;function le(H){return{prompt:H.message,label:H.title,participant:H.agentId,command:H.subCommand}}ye.to=le})(At||(e.ChatFollowup=At={}));var Ft;(function(ye){function Re(H){switch(H){case E.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}ye.to=Re;function le(H){switch(H){case b.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}ye.from=le})(Ft||(e.LanguageModelChatMessageRole=Ft={}));var si;(function(ye){function Re(H){let Ee="",Be;H.content.type==="text"?Ee=H.content.value:Be=new b.$MP(H.content.name,H.content.value,H.content.isError);const Ze=Ft.to(H.role),Ge=new b.$NP(Ze,Ee,H.name);return Be!==void 0&&(Ge.content2=Be),Ge}ye.to=Re;function le(H){const Ee=Ft.from(H.role),Be=H.name;let Ze;return H.content2 instanceof b.$MP?Ze={type:"function_result",name:H.content2.name,value:H.content2.content,isError:H.content2.isError}:Ze={type:"text",value:H.content},{role:Ee,name:Be,content:Ze}}ye.from=le})(si||(e.LanguageModelChatMessage=si={}));var _t;(function(ye){function Re(H){return{kind:"markdownContent",content:$e.from(H.value)}}ye.from=Re;function le(H){return new b.$wP($e.to(H.content))}ye.to=le})(_t||(e.ChatResponseMarkdownPart=_t={}));var ei;(function(ye){function Re(H){return{kind:"markdownVuln",content:$e.from(H.value),vulnerabilities:H.vulnerabilities}}ye.from=Re;function le(H){return new b.$xP($e.to(H.content),H.vulnerabilities)}ye.to=le})(ei||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ei={}));var Bt;(function(ye){function Re(H){return{kind:"agentDetection",agentId:H.participant,command:H.command}}ye.from=Re;function le(H){return new b.$yP(H.agentId,H.command)}ye.to=le})(Bt||(e.ChatResponseDetectedParticipantPart=Bt={}));var Wt;(function(ye){function Re(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data,buttons:le.buttons}}ye.from=Re})(Wt||(e.ChatResponseConfirmationPart=Wt={}));var hi;(function(ye){function Re(H){const{value:Ee,baseUri:Be}=H;function Ze(Ge,ut){return Ge.map(Pt=>{const ti=o.URI.joinPath(ut,Pt.name);return{label:Pt.name,uri:ti,children:Pt.children&&Ze(Pt.children,ti)}})}return{kind:"treeData",treeData:{label:(0,D.$ah)(Be),uri:Be,children:Ze(Ee,Be)}}}ye.from=Re;function le(H){const Ee=(0,a.$_h)(H.treeData);function Be(ut){return ut.map(Pt=>({name:Pt.label,children:Pt.children&&Be(Pt.children)}))}const Ze=Ee.uri,Ge=Ee.children?Be(Ee.children):[];return new b.$AP(Ge,Ze)}ye.to=le})(hi||(e.ChatResponseFilesPart=hi={}));var Tt;(function(ye){function Re(H){const Ee=Be=>o.URI.isUri(Be);return{kind:"inlineReference",name:H.title,inlineReference:Ee(H.value)?H.value:M.from(H.value)}}ye.from=Re;function le(H){const Ee=(0,a.$_h)(H);return new b.$BP(o.URI.isUri(Ee.inlineReference)?Ee.inlineReference:M.to(Ee.inlineReference),H.name)}ye.to=le})(Tt||(e.ChatResponseAnchorPart=Tt={}));var Ct;(function(ye){function Re(H){return{kind:"progressMessage",content:$e.from(H.value)}}ye.from=Re;function le(H){return new b.$CP(H.content.value)}ye.to=le})(Ct||(e.ChatResponseProgressPart=Ct={}));var wt;(function(ye){function Re(H){return{kind:"warning",content:$e.from(H.value)}}ye.from=Re;function le(H){return new b.$EP(H.content.value)}ye.to=le})(wt||(e.ChatResponseWarningPart=wt={}));var Qt;(function(ye){function Re(le){return{kind:"progressTask",content:$e.from(le.value)}}ye.from=Re})(Qt||(e.ChatTask=Qt={}));var yt;(function(ye){function Re(le){return{kind:"progressTaskResult",content:typeof le=="string"?$e.from(le):void 0}}ye.from=Re})(yt||(e.ChatTaskResult=yt={}));var oi;(function(ye){function Re(H,Ee,Be){return{kind:"command",command:Ee.toInternal(H.value,Be)??{command:H.value.command,title:H.value.title}}}ye.from=Re;function le(H,Ee){return new b.$FP(Ee.fromInternal(H.command)??{command:H.command.id,title:H.command.title})}ye.to=le})(oi||(e.ChatResponseCommandButtonPart=oi={}));var Ht;(function(ye){function Re(H){return{kind:"textEdit",uri:H.uri,edits:H.edits.map(Ee=>ve.from(Ee))}}ye.from=Re;function le(H){return new b.$HP(o.URI.revive(H.uri),H.edits.map(Ee=>ve.to(Ee)))}ye.to=le})(Ht||(e.ChatResponseTextEditPart=Ht={}));var Pi;(function(ye){function Re(H){const Ee=f.ThemeIcon.isThemeIcon(H.iconPath)?H.iconPath:o.URI.isUri(H.iconPath)?{light:o.URI.revive(H.iconPath)}:H.iconPath&&"light"in H.iconPath&&"dark"in H.iconPath&&o.URI.isUri(H.iconPath.light)&&o.URI.isUri(H.iconPath.dark)?{light:o.URI.revive(H.iconPath.light),dark:o.URI.revive(H.iconPath.dark)}:void 0;return"variableName"in H.value?{kind:"reference",reference:{variableName:H.value.variableName,value:o.URI.isUri(H.value.value)||!H.value.value?H.value.value:M.from(H.value.value)},iconPath:Ee}:{kind:"reference",reference:o.URI.isUri(H.value)?H.value:M.from(H.value),iconPath:Ee}}ye.from=Re;function le(H){const Ee=(0,a.$_h)(H),Be=Ze=>o.URI.isUri(Ze)?Ze:M.to(Ze);return new b.$GP("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&Be(Ee.reference.value)}:Be(Ee.reference))}ye.to=le})(Pi||(e.ChatResponseReferencePart=Pi={}));var pi;(function(ye){function Re(Ee,Be,Ze){return Ee instanceof b.$wP?_t.from(Ee):Ee instanceof b.$BP?Tt.from(Ee):Ee instanceof b.$GP?Pi.from(Ee):Ee instanceof b.$CP?Ct.from(Ee):Ee instanceof b.$AP?hi.from(Ee):Ee instanceof b.$FP?oi.from(Ee,Be,Ze):Ee instanceof b.$HP?Ht.from(Ee):Ee instanceof b.$xP?ei.from(Ee):Ee instanceof b.$yP?Bt.from(Ee):Ee instanceof b.$EP?wt.from(Ee):Ee instanceof b.$zP?Wt.from(Ee):{kind:"markdownContent",content:$e.from("")}}ye.from=Re;function le(Ee,Be){switch(Ee.kind){case"reference":return Pi.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return H(Ee,Be)}}ye.to=le;function H(Ee,Be){switch(Ee.kind){case"markdownContent":return _t.to(Ee);case"inlineReference":return Tt.to(Ee);case"progressMessage":return;case"treeData":return hi.to(Ee);case"command":return oi.to(Ee,Be)}}ye.toContent=H})(pi||(e.ChatResponsePart=pi={}));var Si;(function(ye){function Re(le,H){return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,references:le.variables.variables.map(gi.to),location:zt.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData,location2:H}}ye.to=Re})(Si||(e.ChatAgentRequest=Si={}));var zt;(function(ye){function Re(H){switch(H){case h.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}ye.to=Re;function le(H){switch(H){case b.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}ye.from=le})(zt||(e.ChatLocation=zt={}));var gi;(function(ye){function Re(le){const H=le.value;if(!H)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,o.$uc)(H)?o.URI.revive(H):H&&typeof H=="object"&&"uri"in H&&"range"in H&&(0,o.$uc)(H.uri)?M.to((0,a.$_h)(H)):H,modelDescription:le.modelDescription}}ye.to=Re})(gi||(e.ChatAgentValueReference=gi={}));var Ni;(function(ye){function Re(le,H,Ee){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:H.toInternal(le.command,Ee)}}ye.from=Re})(Ni||(e.ChatAgentCompletionItem=Ni={}));var It;(function(ye){function Re(le){return{errorDetails:le.errorDetails,metadata:le.metadata}}ye.to=Re})(It||(e.ChatAgentResult=It={}));var Di;(function(ye){function Re(le,H,Ee){if(H.action.kind==="vote")return;const Be=It.to(le);if(H.action.kind==="command"){const Ze=H.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Be}}else return H.action.kind==="followUp"?{action:{kind:"followUp",followup:At.to(H.action.followup)},result:Be}:H.action.kind==="inlineChat"?{action:{kind:"editor",accepted:H.action.action==="accepted"},result:Be}:{action:H.action,result:Be}}ye.to=Re})(Di||(e.ChatAgentUserActionEvent=Di={}));var Ri;(function(ye){function Re(le,H,Ee){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:H.toInternal(le,Ee)}ye.from=Re})(Ri||(e.TerminalQuickFix=Ri={}));var $i;(function(ye){function Re(le){return{kind:Ai.to(le.kind)}}ye.to=Re})($i||(e.PartialAcceptInfo=$i={}));var Ai;(function(ye){function Re(le){switch(le){case r.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}ye.to=Re})(Ai||(e.PartialAcceptTriggerKind=Ai={}));var Li;(function(ye){function Re(le,H){return{id:H,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}ye.from=Re})(Li||(e.DebugTreeItem=Li={}));var Lt;(function(ye){function Re(le){return{name:le.name,description:le.description,parametersSchema:le.parametersSchema}}ye.to=Re})(Lt||(e.LanguageModelToolDescription=Lt={}))}),define(Oe[231],Ne([1,0,5,16,8,38]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;let A=class{constructor($,a){this.a=$.getProxy(v.$vN.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>a.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,a,R){const y=new O.$Uw(I.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,R?.isRefactoring??!1)}};e.$Eoc=A,e.$Eoc=A=He([Ve(0,P.$6P)],A)}),define(Oe[232],Ne([1,0,17,10,42,6,39,4,40,69,14,2,18,5,8,7,115,193,24]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0,f=qe(f),n=qe(n);class i{constructor(u,p,m,h,E){this.j=u,this.k=p,this.l=m,this.m=h,this.n=E,this.b=a.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let p=function(h){if(u.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,h),E}};const u=this;this.b.reset();const m=(h,E)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),E){const S=this.l.$handleProgressChunk(this.k.requestId,h),w={report:k=>{S?.then(C=>{C&&(n.$2N.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseWarningPart.from(k),C):this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseReferencePart.from(k),C))})}};Promise.all([S,E?.(w)]).then(([k,C])=>{k!==void 0&&C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,f.ChatTaskResult.from(C),k)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){p(this.markdown);const E=new n.$wP(h),S=f.ChatResponseMarkdownPart.from(E);return m(S),this},markdownWithVulnerabilities(h,E){p(this.markdown),E&&(0,l.$8G)(u.j,"chatParticipantAdditions");const S=new n.$xP(h,E),w=f.ChatResponseMarkdownWithVulnerabilitiesPart.from(S);return m(w),this},filetree(h,E){p(this.filetree);const S=new n.$AP(h,E),w=f.ChatResponseFilesPart.from(S);return m(w),this},anchor(h,E){p(this.anchor);const S=new n.$BP(h,E),w=f.ChatResponseAnchorPart.from(S);return m(w),this},button(h){p(this.anchor);const E=new n.$FP(h),S=f.ChatResponseCommandButtonPart.from(E,u.m,u.n);return m(S),this},progress(h,E){p(this.progress);const S=new n.$DP(h,E),w=E?f.ChatTask.from(S):f.ChatResponseProgressPart.from(S);return m(w,E),this},warning(h){p(this.progress),(0,l.$8G)(u.j,"chatParticipantAdditions");const E=new n.$EP(h),S=f.ChatResponseWarningPart.from(E);return m(S),this},reference(h,E){if(p(this.reference),"variableName"in h&&(0,l.$8G)(u.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const S=u.k.variables.variables.find(w=>w.name===h.variableName);if(S){let w;if(S.references?.length)w=S.references.map(k=>({kind:"reference",reference:{variableName:h.variableName,value:k.reference}}));else{const k=new n.$GP(h,E);w=[f.ChatResponseReferencePart.from(k)]}return w.forEach(k=>m(k)),this}}else{const S=new n.$GP(h,E),w=f.ChatResponseReferencePart.from(S);m(w)}return this},textEdit(h,E){p(this.textEdit),(0,l.$8G)(u.j,"chatParticipantAdditions");const S=new n.$HP(h,E),w=f.ChatResponseTextEditPart.from(S);return m(w),this},detectedParticipant(h,E){p(this.detectedParticipant),(0,l.$8G)(u.j,"chatParticipantAdditions");const S=new n.$yP(h,E),w=f.ChatResponseDetectedParticipantPart.from(S);return m(w),this},confirmation(h,E,S,w){p(this.confirmation),(0,l.$8G)(u.j,"chatParticipantAdditions");const k=new n.$zP(h,E,S,w),C=f.ChatResponseConfirmationPart.from(k);return m(C),this},push(h){if(p(this.push),(h instanceof n.$HP||h instanceof n.$xP||h instanceof n.$yP||h instanceof n.$EP||h instanceof n.$zP)&&(0,l.$8G)(u.j,"chatParticipantAdditions"),h instanceof n.$GP)this.reference(h.value,h.iconPath);else{const E=f.ChatResponsePart.from(h,u.m,u.n);m(E)}return this}}}return this.g}}class r extends T.$Tc{static{this.b=0}constructor(u,p,m,h){super(),this.n=p,this.s=m,this.t=h,this.c=new Map,this.j=this.B(new T.$3c),this.m=this.B(new T.$3c),this.g=u.getProxy(D.$vN.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,p,m){const h=r.b++,E=new t(u,p,this.g,h,m);return this.c.set(h,E),this.g.$registerAgent(h,u.identifier,p,{},void 0),E.apiAgent}createDynamicChatAgent(u,p,m,h){const E=r.b++,S=new t(u,p,this.g,E,h);return this.c.set(E,S),this.g.$registerAgent(E,u.identifier,p,{isSticky:!0},m),S.apiAgent}async $invokeAgent(u,p,m,h){const E=this.c.get(u);if(!E)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);const S=(0,$.$_h)(p);let w=this.j.get(S.sessionId);w||(w=new T.$Sc,this.j.set(S.sessionId,w));const k=new i(E.extension,S,this.g,this.s.converter,w);try{const C=await this.u(S.agentId,m);let d;if(S.locationData?.type===o.ChatAgentLocation.Editor){const F=this.t.getDocument(S.locationData.document);d=new n.$KP(F,f.Selection.to(S.locationData.selection),f.Range.to(S.locationData.wholeRange))}else if(S.locationData?.type===o.ChatAgentLocation.Notebook){const F=this.t.getDocument(S.locationData.sessionInputUri);d=new n.$LP(F)}else S.locationData?.type,o.ChatAgentLocation.Terminal;const b=E.invoke(f.ChatAgentRequest.to(S,d),{history:C},k.apiObject,h);return await(0,P.$qh)(Promise.resolve(b).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(M){const V=`result.metadata MUST be JSON.stringify-able. Got error: ${M.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${V}`,E.extension),{errorDetails:{message:V},timings:k.timings}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,l.$8G)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:k.timings,metadata:F?.metadata}}),h)}catch(C){return this.n.error(C,E.extension),C instanceof n.$TP&&C.cause&&(C=C.cause),{errorDetails:{message:(0,I.$nj)(C),responseIsIncomplete:!0}}}finally{k.close()}}async u(u,p){const m=[];for(const h of p.history){const E=f.ChatAgentResult.to(h.result),S=u===h.request.agentId?E:{...E,metadata:void 0};m.push(new n.$IP(h.request.message,h.request.command,h.request.variables.variables.map(f.ChatAgentValueReference.to),h.request.agentId));const w=(0,v.$Gb)(h.response.map(k=>f.ChatResponsePart.toContent(k,this.s.converter)));m.push(new n.$JP(w,S,h.request.agentId,h.request.command))}return m}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,p,m,h,E){const S=this.c.get(p);if(!S)return Promise.resolve([]);const w=(0,$.$_h)(u),k=await this.u(S.id,h),C=f.ChatAgentResult.to(m);return(await S.provideFollowups(C,{history:k},E)).filter(d=>{const b=!d.participant||A.Iterable.some(this.c.values(),F=>F.id===d.participant&&c.$on.equals(F.extension.identifier,S.extension.identifier));return b||this.n.warn(`[@${S.id}] ChatFollowup refers to an unknown participant: ${d.participant}`),b}).map(d=>f.ChatFollowup.from(d,w))}$acceptFeedback(u,p,m,h){const E=this.c.get(u);if(!E)return;const S=f.ChatAgentResult.to(p);let w;switch(m){case s.ChatAgentVoteDirection.Down:w=n.ChatResultFeedbackKind.Unhelpful;break;case s.ChatAgentVoteDirection.Up:w=n.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(h?{result:S,kind:w,reportIssue:h}:{result:S,kind:w}))}$acceptAction(u,p,m){const h=this.c.get(u);if(!h||m.action.kind==="vote")return;const E=f.ChatAgentUserActionEvent.to(p,m,this.s.converter);E&&h.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(u,p,m){const h=this.c.get(u);if(!h)return[];let E=this.m.get(u);return E?E.clear():(E=new T.$Sc,this.m.set(u,E)),(await h.invokeCompletionProvider(p,m)).map(w=>f.ChatAgentCompletionItem.from(w,this.s.converter,E))}async $provideWelcomeMessage(u,p,m){const h=this.c.get(u);if(h)return await h.provideWelcomeMessage(f.ChatLocation.to(p),m)}async $provideSampleQuestions(u,p,m){const h=this.c.get(u);if(h)return(await h.provideSampleQuestions(f.ChatLocation.to(p),m)).map(E=>f.ChatFollowup.from(E,void 0))}}e.$Foc=r;class t{constructor(u,p,m,h,E){this.extension=u,this.id=p,this.w=m,this.x=h,this.y=E,this.m=new O.$je,this.n=new O.$je}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,p){return this.q?await this.q.provider.provideCompletionItems(u,p)??[]:[]}async provideFollowups(u,p,m){if(!this.b)return[];const h=await this.b.provideFollowups(u,p,m);return h?h.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(u,p){if(!this.s)return[];const m=await this.s.provideWelcomeMessage(u,p);return m?m.map(h=>typeof h=="string"?h:f.MarkdownString.from(h)):[]}async provideSampleQuestions(u,p){if(!this.s||!this.s.provideSampleQuestions)return[];const m=await this.s.provideSampleQuestions(u,p);return m||[]}get apiAgent(){let u=!1,p=!1;const m=()=>{u||p||(p=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof n.$wO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:f.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:f.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:f.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),p=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(E){h.c=E,m()},get requestHandler(){return h.y},set requestHandler(E){(0,R.$mg)(typeof E=="function","Invalid request handler"),h.y=E},get followupProvider(){return h.b},set followupProvider(E){h.b=E,m()},get isDefault(){return(0,l.$8G)(h.extension,"defaultChatParticipant"),h.d},set isDefault(E){(0,l.$8G)(h.extension,"defaultChatParticipant"),h.d=E,m()},get helpTextPrefix(){return(0,l.$8G)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(E){(0,l.$8G)(h.extension,"defaultChatParticipant"),h.g=E,m()},get helpTextVariablesPrefix(){return(0,l.$8G)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(E){(0,l.$8G)(h.extension,"defaultChatParticipant"),h.j=E,m()},get helpTextPostfix(){return(0,l.$8G)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(E){(0,l.$8G)(h.extension,"defaultChatParticipant"),h.k=E,m()},get isSecondary(){return(0,l.$8G)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(E){(0,l.$8G)(h.extension,"defaultChatParticipant"),h.l=E,m()},get supportIssueReporting(){return(0,l.$8G)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(E){(0,l.$8G)(h.extension,"chatParticipantPrivate"),h.o=E,m()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(E){if((0,l.$8G)(h.extension,"chatParticipantAdditions"),h.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,h.id,E.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x,h.id)},get participantVariableProvider(){return(0,l.$8G)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(E){(0,l.$8G)(h.extension,"defaultChatParticipant"),h.s=E,m()},get welcomeMessageProvider(){return(0,l.$8G)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,l.$7G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){h.t=E,m()},get requester(){return h.t},set supportsSlowReferences(E){(0,l.$8G)(h.extension,"chatParticipantPrivate"),h.u=E,m()},get supportsSlowReferences(){return(0,l.$8G)(h.extension,"chatParticipantPrivate"),h.u},dispose(){u=!0,h.b=void 0,h.m.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(u,p,m,h){return this.y(u,p,m,h)}}}),define(Oe[233],Ne([1,0,13,4,34,5,8,7,24]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0,A=qe(A),T=qe(T);class a{static{this.a=0}constructor(c){this.b=new Map,this.c=c.getProxy(O.$vN.MainThreadChatVariables)}async $resolveVariable(c,D,f,n){const o=this.b.get(c);if(o)try{if(o.resolver.resolve2){(0,$.$8G)(o.extension,"chatParticipantAdditions");const s=new R(D,this.c),l=await o.resolver.resolve2(o.data.name,{prompt:f},s.apiObject,n);if(l&&l[0])return l[0].value}else{const s=await o.resolver.resolve(o.data.name,{prompt:f},n);if(s&&s[0])return s[0].value}}catch(s){(0,v.$Z)(s)}}registerVariableResolver(c,D,f,n,o,s,l,i,r){const t=a.a++,g=r?I.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:c,data:{id:D,name:f,description:n,modelDescription:o,icon:g},resolver:l}),this.c.$registerVariable(t,{id:D,name:f,description:n,modelDescription:o,isSlow:s,fullName:i,icon:g}),(0,P.$Rc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Goc=a;class R{constructor(c,D){this.c=c,this.d=D,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let D=function(n){if(c.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,n),o}};const c=this,f=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){D(this.progress);const o=new T.$CP(n),s=A.ChatResponseProgressPart.from(o);return f(s),this},reference(n){D(this.reference);const o=new T.$GP(n),s=A.ChatResponseReferencePart.from(o);return f(s),this},push(n){return D(this.push),n instanceof T.$GP?f(A.ChatResponseReferencePart.from(n)):n instanceof T.$CP&&f(A.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(Oe[234],Ne([1,0,10,71,6,4,36,2,93,18,8,7,5,24]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=f,$=qe($),R=qe(R),y=qe(y);function f(n,o,s){const l=n.getProxy(c.$vN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new a.$qn,o.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===A.MarshalledId.CommentController){const k=this.b.get(w.handle);return k?k.value:w}else if(w&&w.$mid===A.MarshalledId.CommentThread){const k=w,C=this.b.get(k.commentControlHandle);if(!C)return k;const d=C.getCommentThread(k.commentThreadHandle);return d?d.value:k}else if(w&&(w.$mid===A.MarshalledId.CommentThreadReply||w.$mid===A.MarshalledId.CommentThreadInstance)){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const C=k.getCommentThread(w.thread.commentThreadHandle);return C?w.$mid===A.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:w.text}:w}else if(w&&w.$mid===A.MarshalledId.CommentNode){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const C=k.getCommentThread(w.thread.commentThreadHandle);if(!C)return w;const d=w.commentUniqueId,b=C.getCommentByUniqueId(d);return b||w}else if(w&&w.$mid===A.MarshalledId.CommentThreadNode){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const C=k.getCommentThread(w.thread.commentThreadHandle);if(!C)return w;const d=w.text,b=w.commentUniqueId,F=C.getCommentByUniqueId(b);return F?(typeof F.body=="string"?F.body=d:F.body=new y.$2N(d),F):w}return w}})}createCommentController(w,k,C){const d=i.a++,b=new t(w,d,k,C);this.b.set(b.handle,b);const F=this.c.get(w.identifier)||[];return F.push(b),this.c.set(w.identifier,F),b.value}async $createCommentThreadTemplate(w,k,C,d){const b=this.b.get(w);b&&b.$createCommentThreadTemplate(k,C,d)}async $setActiveComment(w,k){const C=this.b.get(w);C&&C.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(w,k,C){const d=this.b.get(w);d&&d.$updateCommentThreadTemplate(k,C)}$deleteCommentThread(w,k){this.b.get(w)?.$deleteCommentThread(k)}async $provideCommentingRanges(w,k,C){const d=this.b.get(w);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const b=await s.ensureDocumentData(T.URI.revive(k));return(0,v.$uh)(async()=>{const F=await d.commentingRangeProvider.provideCommentingRanges(b.document,C);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(M=>R.Range.from(M)),fileComments:F.fileComments}),N})}$toggleReaction(w,k,C,d,b){const F=this.b.get(w);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,v.$uh)(()=>{const N=F.getCommentThread(k);if(N){const M=N.getCommentByUniqueId(d.uniqueIdInThread);if(F!==void 0&&M&&F.reactionHandler)return F.reactionHandler(M,p(b))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,D.$8G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,k,C,d,b,F,N,M,V){this.m=k,this.n=C,this.o=d,this.p=b,this.q=F,this.extensionDescription=N,this.r=M,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Uc,this.l.value=new O.$Sc,this.n===void 0&&(this.n=`${w}.${this.handle}`),l.$createCommentThread(k,this.handle,this.n,this.o,R.Range.from(this.p),this.q.map(L=>g(this,L,this.k,this.extensionDescription)),N.identifier,this.r,V),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{l.$deleteCommentThread(k,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(L){W.range=L},get comments(){return W.comments},set comments(L){W.comments=L},get collapsibleState(){return W.collapsibleState},set collapsibleState(L){W.collapsibleState=L},get canReply(){return W.canReply},set canReply(L){W.canReply=L},get contextValue(){return W.contextValue},set contextValue(L){W.contextValue=L},get label(){return W.label},set label(L){W.label=L},get state(){return W.state},set state(L){W.state=L},reveal:L=>W.reveal(L),dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Sc);const w=C=>Object.prototype.hasOwnProperty.call(this.b,C),k={};w("range")&&(k.range=R.Range.from(this.p)),w("label")&&(k.label=this.label),w("contextValue")&&(k.contextValue=this.contextValue??null),w("comments")&&(k.comments=this.q.map(C=>g(this,C,this.k,this.extensionDescription))),w("collapsibleState")&&(k.collapseState=m(this.g)),w("canReply")&&(k.canReply=this.canReply),w("state")&&(k.state=h(this.h)),w("applicability")&&(k.applicability=E(this.h)),w("isTemplate")&&(k.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(w){for(const k of this.k){const C=k[0],d=k[1];if(w===d)return C}}async reveal(w){return(0,D.$8G)(this.extensionDescription,"commentReveal"),l.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...w})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}He([(0,P.$8h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,D.$8G)(this.h,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,D.$8G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,D.$8G)(this.h,"activeComment"),this.f}constructor(w,k,C,d){this.h=w,this.i=k,this.j=C,this.k=d,this.a=new Map,l.$registerCommentController(this.handle,C,d,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(F){b.options=F},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(F){b.commentingRangeProvider=F},get reactionHandler(){return b.reactionHandler},set reactionHandler(F){b.reactionHandler=F},get activeCommentThread(){return b.activeCommentThread},createCommentThread(F,N,M){return b.createCommentThread(F,N,M).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(w,k,C){k===void 0&&(0,D.$8G)(this.h,"fileComments");const d=new r(this.id,this.handle,void 0,w,k,C,this.h,!1);return this.a.set(d.handle,d),d}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const k=this.a.get(w.commentThreadHandle);k&&(this.e=w.uniqueIdInThread?k.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(w,k,C){const d=new r(this.id,this.handle,void 0,T.URI.revive(w),R.Range.to(k),[],this.h,!0,C);return d.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(d.handle,d),d}$updateCommentThreadTemplate(w,k){const C=this.a.get(w);C&&(C.range=R.Range.to(k))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function g(S,w,k,C){let d=k.get(w);return d||(d=++S.commentHandle,k.set(w,d)),w.state!==void 0&&(0,D.$8G)(C,"commentsDraftState"),w.reactions?.some(b=>b.reactors!==void 0)&&(0,D.$8G)(C,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:d,body:typeof w.body=="string"?w.body:R.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(b=>u(b)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function u(S){return{label:S.label,iconPath:S.iconPath?R.$5P(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(w=>w.name):S.reactors}}function p(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?T.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(w=>({name:w}))}}function m(S){if(S!==void 0)switch(S){case y.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(S){let w;if(typeof S=="object"?w=S.resolved:w=S,w!==void 0)switch(w){case y.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function E(S){let w;if(typeof S=="object"&&(w=S.applicability),w!==void 0)switch(w){case y.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new i}}),define(Oe[235],Ne([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(we,e,v,P,I,O,A,T,$,a,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3oc=void 0,$=qe($),y=qe(y),c=qe(c);class D{constructor(u,p){this.document=u,this.b=p,this.a=1,this.c=new R.$qoc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,p){await this.f(u).undo(),p||this.disposeBackup()}async redo(u,p){await this.f(u).redo(),p||this.disposeBackup()}disposeEdits(u){for(const p of u)this.c.delete(p)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this.a++;return(0,A.$dh)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const p=this.c.get(u,0);if(!p)throw new Error("No edit found");return p}}class f{constructor(){this.a=new Map}get(u,p){return this.a.get(this.b(u,p))}add(u,p,m){const h=this.b(u,p.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${u} resource:${p.uri}`);const E=new D(p,m);return this.a.set(h,E),E}delete(u,p){const m=this.b(u,p.uri);this.a.delete(m)}b(u,p){return`${u}@@@${p}`}}var n;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(u,p,m){return this.b(u,{type:n.Text,extension:p,provider:m})}addCustomProvider(u,p,m){return this.b(u,{type:n.Custom,extension:p,provider:m})}get(u){return this.a.get(u)}b(u,p){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,p),new c.$xN(()=>this.a.delete(u))}}class s{constructor(u,p,m,h,E){this.d=p,this.f=m,this.g=h,this.h=E,this.b=new o,this.c=new f,this.a=u.getProxy(y.$vN.MainThreadCustomEditors)}registerCustomEditorProvider(u,p,m,h){const E=new I.$Sc;return i(m)?(E.add(this.b.addTextProvider(p,u,m)),this.a.$registerTextEditorProvider((0,a.$Zoc)(u),p,h.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,a.$Xoc)(u))):(E.add(this.b.addCustomProvider(p,u,m)),l(m)&&E.add(m.onDidChangeCustomDocument(S=>{const w=this.i(p,S.document.uri);if(r(S)){const k=w.addEdit(S);this.a.$onDidEdit(S.document.uri,p,k,S.label)}else this.a.$onContentChange(S.document.uri,p)})),this.a.$registerCustomEditorProvider((0,a.$Zoc)(u),p,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,a.$Xoc)(u))),c.$xN.from(E,new c.$xN(()=>{this.a.$unregisterEditorProvider(p)}))}async $createCustomDocument(u,p,m,h,E){const S=this.b.get(p);if(!S)throw new Error(`No provider found for '${p}'`);if(S.type!==n.Custom)throw new Error(`Invalid provide type for '${p}'`);const w=T.URI.revive(u),k=await S.provider.openCustomDocument(w,{backupId:m,untitledDocumentData:h?.buffer},E);let C;return l(S.provider)&&this.f&&(C=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(p,k,C),{editable:l(S.provider)}}async $disposeCustomDocument(u,p){const m=this.b.get(p);if(!m)throw new Error(`No provider found for '${p}'`);if(m.type!==n.Custom)throw new Error(`Invalid provider type for '${p}'`);const h=T.URI.revive(u),{document:E}=this.i(p,h);this.c.delete(p,E),E.dispose()}async $resolveCustomEditor(u,p,m,h,E,S){const w=this.b.get(m);if(!w)throw new Error(`No provider found for '${m}'`);const k=$.ViewColumn.to(E),C=this.g.createNewWebview(p,h.contentOptions,w.extension),d=this.h.createNewWebviewPanel(p,m,h.title,k,h.options,C,h.active),b=T.URI.revive(u);switch(w.type){case n.Custom:{const{document:F}=this.i(m,b);return w.provider.resolveCustomEditor(F,d,S)}case n.Text:{const F=this.d.getDocument(b);return w.provider.resolveCustomTextEditor(F,d,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,p,m){this.i(p,u).disposeEdits(m)}async $onMoveCustomEditor(u,p,m){const h=this.b.get(m);if(!h)throw new Error(`No provider found for '${m}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const E=this.h.getWebviewPanel(u);if(!E)throw new Error("No webview found");const S=T.URI.revive(p),w=this.d.getDocument(S);await h.provider.moveCustomTextEditor(w,E,v.CancellationToken.None)}async $undo(u,p,m,h){return this.i(p,u).undo(m,h)}async $redo(u,p,m,h){return this.i(p,u).redo(m,h)}async $revert(u,p,m){const h=this.i(p,u);await this.j(p).revertCustomDocument(h.document,m),h.disposeBackup()}async $onSave(u,p,m){const h=this.i(p,u);await this.j(p).saveCustomDocument(h.document,m),h.disposeBackup()}async $onSaveAs(u,p,m,h){const E=this.i(p,u);return this.j(p).saveCustomDocumentAs(E.document,T.URI.revive(m),h)}async $backup(u,p,m){const h=this.i(p,u),S=await this.j(p).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},m);return h.updateBackup(S),S.id}i(u,p){const m=this.c.get(u,T.URI.revive(p));if(!m)throw new Error("No custom document found");return m}j(u){const m=this.b.get(u)?.provider;if(!m||!l(m))throw new Error("Custom document is not editable");return m}}e.$3oc=s;function l(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function r(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const u=g.scheme===O.Schemas.file||g.scheme===O.Schemas.untitled?g.fsPath:g.toString();return(0,P.$qj)(u)+""}}),define(Oe[236],Ne([1,0,9,107,2,5,7,8,6,11,28,50]),function(we,e,v,P,I,O,A,T,$,a,R,y){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=e.$xoc=void 0,T=qe(T);class D{#e;#t;#i;constructor(o,s,l,i,r,t,g,u){this.d=o,this.e=s,this.f=l,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,l),this.#i=new R.$zc(p=>t.getComparisonKey(p)),this.#e=g,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let l=[];if(I.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),l=[o]}else if(Array.isArray(o)){l=[];let t;o=[...o].sort(D.k);for(const g of o){const[u,p]=g;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,l.push(u),this.#i.set(u,[])),p)this.#i.get(u)?.push(...p);else{const m=this.#i.get(u);m&&(m.length=0)}}}if(this.#t.fire(l),!this.#e)return;const i=[];let r=0;for(const t of l){let g=[];const u=this.#i.get(t);if(u)if(u.length>this.g){g=[];const p=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const h of u)if(h.severity===p[m]&&g.push({...T.Diagnostic.from(h),modelVersionId:this.h(t)})===this.g)break e;g.push({severity:P.MarkerSeverity.Info,message:(0,v.localize)(10677,null,u.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=u.map(p=>({...T.Diagnostic.from(p),modelVersionId:this.h(t)}));if(i.push([t,g]),r+=g.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[l,i]of this)o.call(s,l,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$xoc=D;let f=class{static{c=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(o){const s=new R.$zc;for(const l of o)s.set(l,l);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,l,i){this.j=s,this.k=l,this.l=i,this.g=new Map,this.h=new $.$ne({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,c._mapper),this.f=o.getProxy(O.$vN.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:l,f:i,h:r,j:t,k:g,l:u}=this,p=new class{$changeMany(E,S){i.$changeMany(E,S),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,E,S.length===0?"CLEARING":S)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,E)}dispose(){i.dispose()}};let m;if(!s)s="_generated_diagnostic_collection_name_#"+c.c++,m=s;else if(!l.has(s))m=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do m=s+c.c++;while(l.has(m))}return new class extends D{constructor(){super(s,m,c.e,c.d,E=>u.getDocument(E)?.version,g.extUri,p,r),l.set(m,this)}dispose(){super.dispose(),l.delete(m)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,l=[];for(const i of this.g.values())i.forEach((r,t)=>{let g=s.get(r.toString());typeof g>"u"&&(g=l.length,s.set(r.toString(),g),l.push([r,[]])),l[g][1]=l[g][1].concat(...t)});return l}}m(o){let s=[];for(const l of this.g.values())l.has(o)&&(s=s.concat(l.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",l=new D(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,l),this.n=l}for(const[s,l]of o)this.n.set(I.URI.revive(s),l.map(T.Diagnostic.to))}};e.$yoc=f,e.$yoc=f=c=He([Ve(1,a.$0j),Ve(2,y.$woc)],f)}),define(Oe[237],Ne([1,0,2,13,7,8,170,38]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0;class ${constructor(R,y,c,D={timeout:1500,errors:3}){this.c=R,this.d=y,this.f=c,this.g=D,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(y,c,D)=>{const n={dispose:this.a.push([y,c,R])};return Array.isArray(D)&&D.push(n),n}}async $participateInSave(R,y){const c=v.URI.revive(R);let D=!1;const f=setTimeout(()=>D=!0,this.g.timeout),n=[];try{for(const o of[...this.a]){if(D)break;const s=this.d.getDocument(c),l=await this.h(o,{document:s,reason:O.TextDocumentSaveReason.to(y)});n.push(l)}}finally{clearTimeout(f)}return n}h([R,y,c],D){const f=this.b.get(R);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(c,R,y,D).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const o=this.b.get(R);this.b.set(R,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,y,c,D){const f=[],n=Date.now(),{document:o,reason:s}=D,{version:l}=o,i=Object.freeze({document:o,reason:s,waitUntil(r){if(Object.isFrozen(f))throw(0,P.$7)("waitUntil can not be called async");f.push(Promise.resolve(r))}});try{y.apply(c,[i])}catch(r){return Promise.reject(r)}return Object.freeze(f),new Promise((r,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(f).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(g),r(u)}).catch(u=>{clearTimeout(g),t(u)})}).then(r=>{const t={edits:[]};for(const g of r)if(Array.isArray(g)&&g.every(u=>u instanceof I.$GN))for(const{newText:u,newEol:p,range:m}of g)t.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:m&&O.Range.from(m),text:u,eol:p&&O.EndOfLine.from(p)}});if(t.edits.length!==0)return l===o.version?this.f.$tryApplyWorkspaceEdit(new T.$Uw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Lpc=$}),define(Oe[238],Ne([1,0,6,4,2,5,123,8,14,25,7]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0,T=qe(T);class y{constructor(D,f){this.a=new v.$je,this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.$Sc,this.h=new Map,this.f=D.getProxy(O.$vN.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const f=this.g.getDocument(D);if(f)return f}getDocument(D){const f=this.getDocumentData(D);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return f.document}ensureDocumentData(D){const f=this.g.getDocument(D);if(f)return Promise.resolve(f);let n=this.h.get(D.toString());return n||(n=this.f.$tryOpenDocument(D).then(o=>{this.h.delete(D.toString());const s=I.URI.revive(o);return(0,$.$ng)(this.g.getDocument(s))},o=>(this.h.delete(D.toString()),Promise.reject(o))),this.h.set(D.toString(),n)),n}createDocumentData(D){return this.f.$tryCreateDocument(D).then(f=>I.URI.revive(f))}$acceptModelLanguageChanged(D,f){const n=I.URI.revive(D),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(D){const f=I.URI.revive(D),n=this.g.getDocument(f);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(D,f){const n=I.URI.revive(D),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,f,n){const o=I.URI.revive(D),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(n),s.onEvents(f);let l;f.isUndoing?l=R.TextDocumentChangeReason.Undo:f.isRedoing&&(l=R.TextDocumentChangeReason.Redo),this.c.fire((0,a.$co)({document:s.document,contentChanges:f.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:l}))}setWordDefinitionFor(D,f){(0,A.$8P)(D,f)}}e.$zoc=y}),define(Oe[70],Ne([1,0,239,6,14,2,3,5,16,8,7]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5oc=e.$4oc=void 0,a=qe(a),e.$4oc=(0,A.$Ci)("IExtHostEditorTabs");class y{constructor(o,s,l){this.e=l,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new R.$kP(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new R.$lP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new R.$mP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new R.$nP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new R.$oP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new R.$pP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new R.$qP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new R.$rP;case T.TabInputKind.InteractiveEditorInput:return new R.$sP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new R.$tP;case T.TabInputKind.MultiDiffEditorInput:return new R.$uP(this.b.input.diffEditors.map(o=>new R.$lP(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class c{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const l of o.tabs)l.isActive&&(this.d=l.id),this.c.push(new y(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return a.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(l=>l.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(l=>l.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===T.TabModelOperationKind.TAB_OPEN){const l=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,l),o.tabDto.isActive&&(this.d=l.tabId),l}else if(o.kind===T.TabModelOperationKind.TAB_CLOSE){const l=this.c.splice(o.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(o.kind===T.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(o.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,l),l}const s=this.c.find(l=>l.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let D=class{constructor(o){this.b=new P.$je,this.c=new P.$je,this.e=[],this.a=o.getProxy(T.$vN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(l=>l.apiObject))},get activeTabGroup(){const l=o.d;return(0,I.$ng)(o.e.find(r=>r.groupId===l)?.apiObject)},close:async(l,i)=>{const r=Array.isArray(l)?l:[l];return r.length?f(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(p=>p.groupId)),l=new Set(o.map(p=>p.groupId)),i=(0,v.$d)(s,l),r=this.e.filter(p=>i.removed.includes(p.groupId)).map(p=>p.apiObject),t=[],g=[];this.e=o.map(p=>{const m=new c(p,()=>this.d);return i.added.includes(m.groupId)?t.push(m.apiObject):g.push(m.apiObject),m});const u=(0,I.$ng)(o.find(p=>p.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:t,closed:r,changed:g}))}$acceptTabGroupUpdate(o){const s=this.e.find(l=>l.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const l=s.acceptTabOperation(o);switch(o.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(o){for(const s of this.e)for(const l of s.tabs)if(l.apiObject===o)return l}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const l=[];for(const i of o){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");l.push(r.tabId)}return this.a.$closeTab(l,s)}async j(o,s){const l=[];for(const i of o){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");l.push(r.groupId)}return this.a.$closeGroup(l,s)}};e.$5oc=D,e.$5oc=D=He([Ve(0,$.$6P)],D);function f(n){return n.tabs!==void 0}}),define(Oe[240],Ne([1,0,2,5,29,4,7,8,284,12,27,22,24,59]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=void 0,I=qe(I),T=qe(T);class f{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const l=this.a.indexOf(s);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),l=[];let i,r,t=$.State.LastKnownState,g=$.State.LastKnownState;for(const u of s){let p=i?(0,a.$Ff)(i,u):0;for(p===0?r=$.State.Start:r=g;p<u.length;p++)p+1===u.length?(t=g,g=$.State.BeforeColon):g+=1,l.push([r,u.toUpperCase().charCodeAt(p),g]),l.push([r,u.toLowerCase().charCodeAt(p),g]),r=g;i=u,g=t}l.push([$.State.BeforeColon,R.CharCode.Colon,$.State.AfterColon]),l.push([$.State.AfterColon,R.CharCode.Slash,$.State.End]),this.b=new $.$m4(l)}}provideDocumentLinks(s){this.c();const l=[],i=$.$n4.computeLinks({getLineContent(r){return s.lineAt(r-1).text},getLineCount(){return s.lineCount}},this.b);for(const r of i){const t=T.DocumentLink.to(r);t.target&&l.push(t)}return l}}class n{constructor(s,l){this.i=l,this.b=new f,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(P.$vN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,l,i,r={}){if(n.j(i),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const t=this.h++;this.b.add(l),this.d.add(l),this.c.set(t,i);let g=I.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(g+=I.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(g+=I.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=I.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,c.$8G)(s,"fsChunks"),g+=I.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;r.isReadonly&&(0,D.$3k)(r.isReadonly)&&r.isReadonly.value!==""&&(u={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,l,g,u).catch(m=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${l}`),console.error(m)});const p=i.onDidChangeFile(m=>{const h=[];for(const E of m){const{uri:S,type:w}=E;if(S.scheme!==l)continue;let k;switch(w){case A.FileChangeType.Changed:k=I.FileChangeType.UPDATED;break;case A.FileChangeType.Created:k=I.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:k=I.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:S,type:k})}this.a.$onFileSystemChange(t,h)});return(0,O.$Rc)(()=>{p.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:l,ctime:i,mtime:r,size:t,permissions:g}=s;return{type:l,ctime:i,mtime:r,size:t,permissions:g}}$stat(s,l){return Promise.resolve(this.l(s).stat(v.URI.revive(l))).then(i=>n.k(i))}$readdir(s,l){return Promise.resolve(this.l(s).readDirectory(v.URI.revive(l)))}$readFile(s,l){return Promise.resolve(this.l(s).readFile(v.URI.revive(l))).then(i=>y.$Le.wrap(i))}$writeFile(s,l,i,r){return Promise.resolve(this.l(s).writeFile(v.URI.revive(l),i.buffer,r))}$delete(s,l,i){return Promise.resolve(this.l(s).delete(v.URI.revive(l),i))}$rename(s,l,i,r){return Promise.resolve(this.l(s).rename(v.URI.revive(l),v.URI.revive(i),r))}$copy(s,l,i,r){const t=this.l(s);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(l),v.URI.revive(i),r))}$mkdir(s,l){return Promise.resolve(this.l(s).createDirectory(v.URI.revive(l)))}$watch(s,l,i,r){const t=this.l(s).watch(v.URI.revive(i),r);this.f.set(l,t)}$unwatch(s,l){const i=this.f.get(l);i&&(i.dispose(),this.f.delete(l))}$open(s,l,i){const r=this.l(s);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(v.URI.revive(l),i))}$close(s,l){const i=this.l(s);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(l))}$read(s,l,i,r){const t=this.l(s);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=y.$Le.alloc(r);return Promise.resolve(t.read(l,i,g.buffer,0,r)).then(u=>g.slice(0,u))}$write(s,l,i,r){const t=this.l(s);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(l,i,r.buffer,0,r.byteLength))}l(s){const l=this.c.get(s);if(!l){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return l}}e.$Opc=n}),define(Oe[241],Ne([1,0,6,41,2,5,8,7,29,48]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0,A=qe(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(f,n,o,s,l,i){this.a=Math.random(),this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,P.$xk)(l),t=typeof l=="string",g=i?.correlate,u=s(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(g&&typeof p.session>"u")){if(!i?.ignoreCreateEvents)for(const m of p.created){const h=I.URI.revive(m);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const m of p.changed){const h=I.URI.revive(m);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const m of p.deleted){const h=I.URI.revive(m);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=T.$xN.from(this.i(f,o,l,i,i?.correlate),this.b,this.c,this.d,u)}i(f,n,o,s,l){const i=T.$xN.from();if(typeof o=="string"||s?.ignoreChangeEvents&&s?.ignoreCreateEvents&&s?.ignoreDeleteEvents)return i;const r=f.getProxy(O.$vN.MainThreadFileSystemEventService);let t=!1;(o.pattern.includes(P.$tk)||o.pattern.includes(P.$uk))&&(t=!0);let g;return l&&(s?.ignoreChangeEvents||s?.ignoreCreateEvents||s?.ignoreDeleteEvents)&&(g=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,s?.ignoreChangeEvents&&(g&=~$.FileChangeFilter.UPDATED),s?.ignoreCreateEvents&&(g&=~$.FileChangeFilter.ADDED),s?.ignoreDeleteEvents&&(g&=~$.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,o.baseUri,{recursive:t,excludes:s?.excludes??[],filter:g},!!l),T.$xN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(f){this.a=f,this.session=this.a.session,this.b=new a.$T(()=>this.a.created.map(I.URI.revive)),this.c=new a.$T(()=>this.a.changed.map(I.URI.revive)),this.d=new a.$T(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class c{constructor(f,n,o){this.j=f,this.k=n,this.l=o,this.a=new v.$je,this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.g=new v.$le,this.h=new v.$le,this.i=new v.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(f,n,o,s){return new R(this.j,f,n,this.a.event,A.GlobPattern.from(o),s)}$onFileEvent(f){this.a.fire(new y(f))}$onDidRunFileOperation(f,n){switch(f){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(o=>({oldUri:I.URI.revive(o.source),newUri:I.URI.revive(o.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(o=>I.URI.revive(o.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(o=>I.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(f){return this.m(f,this.g)}getOnWillCreateFileEvent(f){return this.m(f,this.h)}getOnWillDeleteFileEvent(f){return this.m(f,this.i)}m(f,n){return(o,s,l)=>{const i=function(t){o.call(s,t)};return i.extension=f,n.event(i,void 0,l)}}async $onWillRunFileOperation(f,n,o,s){switch(f){case $.FileOperation.MOVE:return await this.n(this.g,{files:n.map(l=>({oldUri:I.URI.revive(l.source),newUri:I.URI.revive(l.target)}))},o,s);case $.FileOperation.DELETE:return await this.n(this.i,{files:n.map(l=>I.URI.revive(l.target))},o,s);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:n.map(l=>I.URI.revive(l.target))},o,s)}}async n(f,n,o,s){const l=new Set,i=[];if(await f.fireAsync(n,s,async(t,g)=>{const u=Date.now(),p=await Promise.resolve(t);p instanceof T.$JN&&(i.push([g.extension,p]),l.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-u>o&&this.k.warn("SLOW file-participant",g.extension.identifier)}),s.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:g}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this.l.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(g)}return{edit:r,extensionNames:Array.from(l)}}}e.$Ppc=c}),define(Oe[242],Ne([1,0,17,10,21,13,96,4,25,69,12,14,2,32,285,93,103,9,18,8,7,24,79,5]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0,n=qe(n),i=qe(i),u=qe(u);class p{constructor(U,B){this.d=U,this.e=B}async provideDocumentSymbols(U,B){const K=this.d.getDocument(U),G=await this.e.provideDocumentSymbols(K,B);if(!(0,v.$Jb)(G))return G[0]instanceof r.$TN?G.map(i.DocumentSymbol.from):p.f(G)}static f(U){U=U.slice(0).sort((G,ie)=>{let de=G.location.range.start.compareTo(ie.location.range.start);return de===0&&(de=ie.location.range.end.compareTo(G.location.range.end)),de});const B=[],K=[];for(const G of U){const ie={name:G.name||"!!MISSING: name!!",kind:i.SymbolKind.from(G.kind),tags:G.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:i.Range.from(G.location.range),selectionRange:i.Range.from(G.location.range),children:[]};for(;;){if(K.length===0){K.push(ie),B.push(ie);break}const de=K[K.length-1];if(D.$Lt.containsRange(de.range,ie.range)&&!D.$Lt.equalsRange(de.range,ie.range)){de.children?.push(ie),K.push(ie);break}K.pop()}}return B}}class m{constructor(U,B,K,G,ie,de){this.f=U,this.g=B,this.h=K,this.j=G,this.k=ie,this.l=de,this.d=new g.$qoc("CodeLens"),this.e=new Map}async provideCodeLenses(U,B){const K=this.f.getDocument(U),G=await this.h.provideCodeLenses(K,B);if(!G||B.isCancellationRequested)return;const ie=this.d.add(G),de=new T.$Sc;this.e.set(ie,de);const Ie={cacheId:ie,lenses:[]};for(let Ue=0;Ue<G.length;Ue++)Ie.lenses.push({cacheId:[ie,Ue],range:i.Range.from(G[Ue].range),command:this.g.toInternal(G[Ue].command,de)});return Ie}async resolveCodeLens(U,B){const K=U.cacheId&&this.d.get(...U.cacheId);if(!K)return;let G;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?G=K:G=await this.h.resolveCodeLens(K,B),G||(G=K),B.isCancellationRequested)return;const ie=U.cacheId&&this.e.get(U.cacheId[0]);if(ie){if(!G.command){const de=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,de),this.l.error(de);return}return U.command=this.g.toInternal(G.command,ie),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function h(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class E{constructor(U,B){this.d=U,this.e=B}async provideDefinition(U,B,K){const G=this.d.getDocument(U),ie=i.Position.to(B),de=await this.e.provideDefinition(G,ie,K);return h(de)}}class S{constructor(U,B){this.d=U,this.e=B}async provideDeclaration(U,B,K){const G=this.d.getDocument(U),ie=i.Position.to(B),de=await this.e.provideDeclaration(G,ie,K);return h(de)}}class w{constructor(U,B){this.d=U,this.e=B}async provideImplementation(U,B,K){const G=this.d.getDocument(U),ie=i.Position.to(B),de=await this.e.provideImplementation(G,ie,K);return h(de)}}class k{constructor(U,B){this.d=U,this.e=B}async provideTypeDefinition(U,B,K){const G=this.d.getDocument(U),ie=i.Position.to(B),de=await this.e.provideTypeDefinition(G,ie,K);return h(de)}}class C{static{this.f=10}constructor(U,B){this.g=U,this.h=B,this.d=0,this.e=new Map}async provideHover(U,B,K,G){const ie=this.g.getDocument(U),de=i.Position.to(B);let Ie;if(K&&K.verbosityRequest){const tt=K.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:nt};Ie=await this.h.provideHover(ie,de,G,et)}else Ie=await this.h.provideHover(ie,de,G);if(!Ie||(0,v.$Jb)(Ie.contents))return;Ie.range||(Ie.range=ie.getWordRangeAtPosition(de)),Ie.range||(Ie.range=new r.$zN(de,de));const Ue=i.Hover.from(Ie),Ke=this.d;if(this.e.size===C.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ke,Ie),this.d+=1,{...Ue,id:Ke}}releaseHover(U){this.e.delete(U)}}class d{constructor(U,B){this.d=U,this.e=B}async provideEvaluatableExpression(U,B,K){const G=this.d.getDocument(U),ie=i.Position.to(B),de=await this.e.provideEvaluatableExpression(G,ie,K);if(de)return i.EvaluatableExpression.from(de)}}class b{constructor(U,B){this.d=U,this.e=B}async provideInlineValues(U,B,K,G){const ie=this.d.getDocument(U),de=await this.e.provideInlineValues(ie,i.Range.to(B),i.InlineValueContext.to(K),G);if(Array.isArray(de))return de.map(Ie=>i.InlineValue.from(Ie))}}class F{constructor(U,B){this.d=U,this.e=B}async provideDocumentHighlights(U,B,K){const G=this.d.getDocument(U),ie=i.Position.to(B),de=await this.e.provideDocumentHighlights(G,ie,K);if(Array.isArray(de))return de.map(i.DocumentHighlight.from)}}class N{constructor(U,B){this.d=U,this.e=B}async provideMultiDocumentHighlights(U,B,K,G){const ie=this.d.getDocument(U),de=K.map(Ke=>this.d.getDocument(Ke)),Ie=i.Position.to(B),Ue=await this.e.provideMultiDocumentHighlights(ie,Ie,de,G);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class M{constructor(U,B){this.d=U,this.e=B}async provideLinkedEditingRanges(U,B,K){const G=this.d.getDocument(U),ie=i.Position.to(B),de=await this.e.provideLinkedEditingRanges(G,ie,K);if(de&&Array.isArray(de.ranges))return{ranges:(0,v.$Gb)(de.ranges.map(i.Range.from)),wordPattern:de.wordPattern}}}class V{constructor(U,B){this.d=U,this.e=B}async provideReferences(U,B,K,G){const ie=this.d.getDocument(U),de=i.Position.to(B),Ie=await this.e.provideReferences(ie,de,K,G);if(Array.isArray(Ie))return Ie.map(i.location.from)}}class W{static{this.d=1e3}constructor(U,B,K,G,ie,de,Ie){this.g=U,this.h=B,this.j=K,this.k=G,this.l=ie,this.m=de,this.n=Ie,this.e=new g.$qoc("CodeAction"),this.f=new Map}async provideCodeActions(U,B,K,G){const ie=this.g.getDocument(U),de=f.$Nt.isISelection(B)?i.Selection.to(B):i.Range.to(B),Ie=[];for(const et of this.j.getDiagnostics(U))if(de.intersection(et.range)&&Ie.push(et)>W.d)break;const Ue={diagnostics:Ie,only:K.only?new r.$VN(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Ke=await this.k.provideCodeActions(ie,de,Ue,G);if(!(0,v.$Kb)(Ke)||G.isCancellationRequested)return;const _e=this.e.add(Ke),tt=new T.$Sc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Ke.length;et++){const rt=Ke[et];if(rt)if(W.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{Ue.only&&(rt.kind?Ue.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$7G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$7G)(this.m,"codeActionRanges")?(0,v.$Gb)(mt.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(U,B){const[K,G]=U,ie=this.e.get(K,G);if(!ie||W.o(ie))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(ie,B)??ie;let Ie;de.edit&&(Ie=i.WorkspaceEdit.from(de.edit,void 0));let Ue;if(de.command){const Ke=this.f.get(K);Ke&&(Ue=this.h.toInternal(de.command,Ke))}return{edit:Ie,command:Ue}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class L{constructor(U,B,K,G,ie){this.e=U,this.f=B,this.g=K,this.h=G,this.j=ie,this.d=new g.$qoc("DocumentPasteEdit")}async prepareDocumentPaste(U,B,K,G){if(!this.g.prepareDocumentPaste)return;const ie=this.f.getDocument(U),de=B.map(Ke=>i.Range.to(Ke)),Ie=i.DataTransfer.toDataTransfer(K,()=>{throw new O.$0});if(await this.g.prepareDocumentPaste(ie,de,Ie,G),G.isCancellationRequested)return;const Ue=Array.from(Ie).filter(([,Ke])=>!(Ke instanceof r.$pO));return i.DataTransfer.from(Ue)}async providePasteEdits(U,B,K,G,ie,de){if(!this.g.provideDocumentPasteEdits)return[];const Ie=this.f.getDocument(B),Ue=K.map(nt=>i.Range.to(nt)),Ke=i.DataTransfer.toDataTransfer(G,async nt=>(await this.e.$resolvePasteFileData(this.h,U,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ie,Ue,Ke,{only:ie.only?new r.$uO(ie.only):void 0,triggerKind:ie.triggerKind},de);if(!_e||de.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,s.localize)(10673,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,B){const[K,G]=U,ie=this.d.get(K,G);if(!ie||!this.g.resolveDocumentPasteEdit)return{};const de=await this.g.resolveDocumentPasteEdit(ie,B)??ie;return{additionalEdit:de.additionalEdit?i.WorkspaceEdit.from(de.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class Y{constructor(U,B){this.d=U,this.e=B}async provideDocumentFormattingEdits(U,B,K){const G=this.d.getDocument(U),ie=await this.e.provideDocumentFormattingEdits(G,B,K);if(Array.isArray(ie))return ie.map(i.TextEdit.from)}}class Z{constructor(U,B){this.d=U,this.e=B}async provideDocumentRangeFormattingEdits(U,B,K,G){const ie=this.d.getDocument(U),de=i.Range.to(B),Ie=await this.e.provideDocumentRangeFormattingEdits(ie,de,K,G);if(Array.isArray(Ie))return Ie.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,B,K,G){(0,y.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ie=this.d.getDocument(U),de=B.map(i.Range.to),Ie=await this.e.provideDocumentRangesFormattingEdits(ie,de,K,G);if(Array.isArray(Ie))return Ie.map(i.TextEdit.from)}}class ge{constructor(U,B){this.d=U,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,B,K,G,ie){const de=this.d.getDocument(U),Ie=i.Position.to(B),Ue=await this.e.provideOnTypeFormattingEdits(de,Ie,K,G,ie);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class _{constructor(U,B){this.e=U,this.f=B,this.d=new g.$qoc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,B){const K=await this.e.provideWorkspaceSymbols(U,B);if(!(0,v.$Kb)(K))return{symbols:[]};const G=this.d.add(K),ie={cacheId:G,symbols:[]};for(let de=0;de<K.length;de++){const Ie=K[de];if(!Ie||!Ie.name){this.f.warn("INVALID SymbolInformation",Ie);continue}ie.symbols.push({...i.WorkspaceSymbol.from(Ie),cacheId:[G,de]})}return ie}async resolveWorkspaceSymbol(U,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const K=this.d.get(...U.cacheId);if(K){const G=await this.e.resolveWorkspaceSymbol(K,B);return G&&(0,$.$eo)(U,i.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class fe{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,B,K){this.d=U,this.e=B,this.f=K}async provideRenameEdits(U,B,K,G){const ie=this.d.getDocument(U),de=i.Position.to(B);try{const Ie=await this.e.provideRenameEdits(ie,de,K,G);return Ie?i.WorkspaceEdit.from(Ie):void 0}catch(Ie){const Ue=fe.g(Ie);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(U,B,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(U),ie=i.Position.to(B);try{const de=await this.e.prepareRename(G,ie,K);let Ie,Ue;if(r.$zN.isRange(de)?(Ie=de,Ue=G.getText(de)):(0,y.$eg)(de)&&(Ie=de.range,Ue=de.placeholder),!Ie||!Ue)return;if(Ie.start.line>ie.line||Ie.end.line<ie.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ie),text:Ue}}catch(de){const Ie=fe.g(de);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(de)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class se{static{this.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(U,B,K){this.e=U,this.f=B,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,B,K,G){const ie=this.e.getDocument(U),de=i.Range.to(B);try{const Ie=se.d[K],Ue=await this.f.provideNewSymbolNames(ie,de,Ie,G);return Ue?Ue.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ie){this.g.error(se.h(Ie)??JSON.stringify(Ie,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ce{constructor(U,B){this.resultId=U,this.tokens=B}}class $e{constructor(U,B){this.f=U,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,B,K){const G=this.f.getDocument(U),ie=B!==0?this.d.get(B):null;let de=typeof ie?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,ie.resultId,K):await this.g.provideDocumentSemanticTokens(G,K);return ie&&this.d.delete(B),de?(de=$e.h(de),this.o($e.n(ie,de),de)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return $e.j(U)?$e.k(U)?U:new r.$UO(new Uint32Array(U.data),U.resultId):$e.l(U)?$e.m(U)?U:new r.$WO(U.edits.map(B=>new r.$VO(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const B of U.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(U,B){if(!$e.j(B)||!U||!U.tokens)return B;const K=U.tokens,G=K.length,ie=B.data,de=ie.length;let Ie=0;const Ue=Math.min(G,de);for(;Ie<Ue&&K[Ie]===ie[Ie];)Ie++;if(Ie===G&&Ie===de)return new r.$WO([],B.resultId);let Ke=0;const _e=Ue-Ie;for(;Ke<_e&&K[G-Ke-1]===ie[de-Ke-1];)Ke++;return new r.$WO([{start:Ie,deleteCount:G-Ie-Ke,data:ie.subarray(Ie,de-Ke)}],B.resultId)}o(U,B){if($e.j(U)){const K=this.e++;return this.d.set(K,new ce(U.resultId,U.data)),(0,o.$Ddb)({id:K,type:"full",data:U.data})}if($e.l(U)){const K=this.e++;return $e.j(B)?this.d.set(K,new ce(B.resultId,B.data)):this.d.set(K,new ce(U.resultId)),(0,o.$Ddb)({id:K,type:"delta",deltas:(U.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class oe{constructor(U,B){this.d=U,this.e=B}async provideDocumentRangeSemanticTokens(U,B,K){const G=this.d.getDocument(U),ie=await this.e.provideDocumentRangeSemanticTokens(G,i.Range.to(B),K);return ie?this.f(ie):null}f(U){return(0,o.$Ddb)({id:0,type:"full",data:U.data})}}class Ce{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,B,K,G,ie){this.f=U,this.g=B,this.h=K,this.j=G,this.k=ie,this.d=new g.$qoc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,B,K,G){const ie=this.f.getDocument(U),de=i.Position.to(B),Ie=ie.getWordRangeAtPosition(de)||new r.$zN(de,de),Ue=Ie.with({end:de}),Ke=new a.$de,_e=await this.h.provideCompletionItems(ie,de,G,i.CompletionContext.to(K));if(!_e||G.isCancellationRequested)return;const tt=Array.isArray(_e)?new r.$9N(_e):_e,nt=Ce.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Sc;this.e.set(nt,et);const rt=[],mt={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ie),insert:i.Range.from(Ue)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let lt=0;lt<tt.items.length;lt++){const st=tt.items[lt],ct=this.l(st,[nt,lt],Ue,Ie);rt.push(ct)}return mt}async resolveCompletionItem(U,B){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...U);if(!K)return;const G=this.l(K,U),ie=await this.h.resolveCompletionItem(K,B);if(!ie)return;const de=this.l(ie,U);return(G[u.ISuggestDataDtoField.insertText]!==de[u.ISuggestDataDtoField.insertText]||G[u.ISuggestDataDtoField.insertTextRules]!==de[u.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G[u.ISuggestDataDtoField.commandIdent]!==de[u.ISuggestDataDtoField.commandIdent]||G[u.ISuggestDataDtoField.commandId]!==de[u.ISuggestDataDtoField.commandId]||!(0,$.$fo)(G[u.ISuggestDataDtoField.commandArguments],de[u.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,[u.ISuggestDataDtoField.documentation]:de[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:de[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:de[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:de[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:de[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:de[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:de[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:de[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,B,K,G){const ie=this.e.get(B[0]);if(!ie)throw Error("DisposableStore is missing...");const de=this.g.toInternal(U.command,ie),Ie={x:B,[u.ISuggestDataDtoField.label]:U.label,[u.ISuggestDataDtoField.kind]:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:U.detail,[u.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),[u.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[u.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[u.ISuggestDataDtoField.preselect]:U.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:de?.$ident,[u.ISuggestDataDtoField.commandId]:de?.id,[u.ISuggestDataDtoField.commandArguments]:de?.$ident?void 0:de?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ie[u.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Ie[u.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof r.$KN&&(Ie[u.ISuggestDataDtoField.insertText]=U.insertText.value,Ie[u.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return U.textEdit?Ue=U.textEdit.range:U.range&&(Ue=U.range),r.$zN.isRange(Ue)?Ie[u.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!K?.isEqual(Ue.inserting)||!G?.isEqual(Ue.replacing))&&(Ie[u.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),Ie}}class Le{async provideInlineCompletions(U,B,K,G){}async provideInlineEdits(U,B,K,G){}disposeCompletions(U){}handleDidShowCompletionItem(U,B,K){}handlePartialAccept(U,B,K,G){}}class X extends Le{constructor(U,B,K,G){super(),this.f=U,this.g=B,this.h=K,this.j=G,this.d=new te,this.e=(0,t.$7G)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$7G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,B,K,G){const ie=this.g.getDocument(U),de=i.Position.to(B),Ie=await this.h.provideInlineCompletionItems(ie,de,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},G);if(!Ie||G.isCancellationRequested)return;const Ue=Array.isArray(Ie)?Ie:Ie.items,Ke=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[],_e=this.e&&!Array.isArray(Ie)?Ie.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let mt;et.command&&(tt||(tt=new T.$Sc),mt=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:mt,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Sc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(U,B,K,G){if(!this.h.provideInlineEdits)return;(0,t.$8G)(this.f,"inlineCompletionsAdditions");const ie=this.g.getDocument(U),de=i.Range.to(B),Ie=await this.h.provideInlineEdits(ie,de,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind],userPrompt:K.userPrompt},G);if(!Ie||G.isCancellationRequested)return;const Ue=Array.isArray(Ie)?Ie:Ie.items,Ke=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[],_e=this.e&&!Array.isArray(Ie)?Ie.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let mt;et.command&&(tt||(tt=new T.$Sc),mt=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:mt,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Sc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,B,K){const G=this.d.get(U)?.items[B];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,K)}handlePartialAccept(U,B,K,G){const ie=this.d.get(U)?.items[B];ie&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ie,K),this.h.handleDidPartiallyAcceptCompletionItem(ie,i.PartialAcceptInfo.to(G)))}}class q{async provideInlineEdits(U,B,K){const G=this.f.getDocument(U),ie=await this.g.provideInlineEdit(G,{triggerKind:this.e[B.triggerKind]},K);if(!ie||K.isCancellationRequested)return;let de;const Ie=this.d.createReferenceId({dispose(){de?.dispose()},item:ie});let Ue;ie.accepted&&(de||(de=new T.$Sc),Ue=this.h.toInternal(ie.accepted,de));let Ke;return ie.rejected&&(de||(de=new T.$Sc),Ke=this.h.toInternal(ie.rejected,de)),{pid:Ie,text:ie.text,range:i.Range.from(ie.range),accepted:Ue,rejected:Ke}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,B,K,G){this.f=B,this.g=K,this.h=G,this.d=new te,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const B=this.e++;return this.d.set(B,U),B}disposeReferenceId(U){const B=this.d.get(U);return this.d.delete(U),B}get(U){return this.d.get(U)}}class ve{constructor(U,B){this.e=U,this.f=B,this.d=new g.$qoc("SignatureHelp")}async provideSignatureHelp(U,B,K,G){const ie=this.e.getDocument(U),de=i.Position.to(B),Ie=this.g(K),Ue=await this.f.provideSignatureHelp(ie,de,G,Ie);if(Ue){const Ke=this.d.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Ke}}}g(U){let B;if(U.activeSignatureHelp){const K=i.SignatureHelp.to(U.activeSignatureHelp),G=this.d.get(U.activeSignatureHelp.id,0);G?(B=G,B.activeSignature=K.activeSignature,B.activeParameter=K.activeParameter):B=K}return{...U,activeSignatureHelp:B}}releaseSignatureHelp(U){this.d.delete(U)}}class ae{constructor(U,B,K,G,ie){this.f=U,this.g=B,this.h=K,this.j=G,this.k=ie,this.d=new g.$qoc("InlayHints"),this.e=new Map}async provideInlayHints(U,B,K){const G=this.f.getDocument(U),ie=i.Range.to(B),de=await this.h.provideInlayHints(G,ie,K);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(K.isCancellationRequested)return;const Ie=this.d.add(de);this.e.set(Ie,new T.$Sc);const Ue={hints:[],cacheId:Ie};for(let Ke=0;Ke<de.length;Ke++)this.l(de[Ke],ie)&&Ue.hints.push(this.m(de[Ke],[Ie,Ke]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),Ue}async resolveInlayHint(U,B){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...U);if(!K)return;const G=await this.h.resolveInlayHint(K,B);if(G&&this.l(G))return this.m(G,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,B){return U.label.length===0||Array.isArray(U.label)&&U.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(B&&!B.contains(U.position))}m(U,B){const K=this.e.get(B[0]);if(!K)throw Error("DisposableStore is missing...");const G={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")G.label=U.label;else{const ie=[];G.label=ie;for(const de of U.label){if(!de.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ie={label:de.value,tooltip:i.MarkdownString.fromStrict(de.tooltip)};r.$LN.isLocation(de.location)&&(Ie.location=i.location.from(de.location)),de.command&&(Ie.command=this.g.toInternal(de.command,K)),ie.push(Ie)}}return G}}class be{constructor(U,B){this.e=U,this.f=B,this.d=new g.$qoc("DocumentLink")}async provideLinks(U,B){const K=this.e.getDocument(U),G=await this.f.provideDocumentLinks(K,B);if(!(!Array.isArray(G)||G.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(be.g).map(i.DocumentLink.from)};{const ie=this.d.add(G),de={links:[],cacheId:ie};for(let Ie=0;Ie<G.length;Ie++){if(!be.g(G[Ie]))continue;const Ue=i.DocumentLink.from(G[Ie]);Ue.cacheId=[ie,Ie],de.links.push(Ue)}return de}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,B){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...U);if(!K)return;const G=await this.f.resolveDocumentLink(K,B);if(!(!G||!be.g(G)))return i.DocumentLink.from(G)}releaseLinks(U){this.d.delete(U)}}class ue{constructor(U,B){this.d=U,this.e=B}async provideColors(U,B){const K=this.d.getDocument(U),G=await this.e.provideDocumentColors(K,B);return Array.isArray(G)?G.map(de=>({color:i.Color.from(de.color),range:i.Range.from(de.range)})):[]}async provideColorPresentations(U,B,K){const G=this.d.getDocument(U),ie=i.Range.to(B.range),de=i.Color.to(B.color),Ie=await this.e.provideColorPresentations(de,{document:G,range:ie},K);if(Array.isArray(Ie))return Ie.map(i.ColorPresentation.from)}}class J{constructor(U,B){this.d=U,this.e=B}async provideFoldingRanges(U,B,K){const G=this.d.getDocument(U),ie=await this.e.provideFoldingRanges(G,B,K);if(Array.isArray(ie))return ie.map(i.FoldingRange.from)}}class x{constructor(U,B,K){this.d=U,this.e=B,this.f=K}async provideSelectionRanges(U,B,K){const G=this.d.getDocument(U),ie=B.map(i.Position.to),de=await this.e.provideSelectionRanges(G,ie,K);if(!(0,v.$Kb)(de))return[];if(de.length!==ie.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let Ue=0;Ue<ie.length;Ue++){const Ke=[];Ie.push(Ke);let _e=ie[Ue],tt=de[Ue];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ie}}class me{constructor(U,B){this.f=U,this.g=B,this.d=new A.$$P(""),this.e=new Map}async prepareSession(U,B,K){const G=this.f.getDocument(U),ie=i.Position.to(B),de=await this.g.prepareCallHierarchy(G,ie,K);if(!de)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(de)?de.map(Ue=>this.h(Ie,Ue)):[this.h(Ie,de)]}async provideCallsTo(U,B,K){const G=this.j(U,B);if(!G)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyIncomingCalls(G,K);if(ie)return ie.map(de=>({from:this.h(U,de.from),fromRanges:de.fromRanges.map(Ie=>i.Range.from(Ie))}))}async provideCallsFrom(U,B,K){const G=this.j(U,B);if(!G)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyOutgoingCalls(G,K);if(ie)return ie.map(de=>({to:this.h(U,de.to),fromRanges:de.fromRanges.map(Ie=>i.Range.from(Ie))}))}releaseSession(U){this.e.delete(U)}h(U,B){const K=this.e.get(U),G=i.CallHierarchyItem.from(B,U,K.size.toString(36));return K.set(G._itemId,B),G}j(U,B){return this.e.get(U)?.get(B)}}class pe{constructor(U,B){this.f=U,this.g=B,this.d=new A.$$P(""),this.e=new Map}async prepareSession(U,B,K){const G=this.f.getDocument(U),ie=i.Position.to(B),de=await this.g.prepareTypeHierarchy(G,ie,K);if(!de)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(de)?de.map(Ue=>this.h(Ie,Ue)):[this.h(Ie,de)]}async provideSupertypes(U,B,K){const G=this.j(U,B);if(!G)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySupertypes(G,K);if(ie)return ie.map(de=>this.h(U,de))}async provideSubtypes(U,B,K){const G=this.j(U,B);if(!G)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySubtypes(G,K);if(ie)return ie.map(de=>this.h(U,de))}releaseSession(U){this.e.delete(U)}h(U,B){const K=this.e.get(U),G=i.TypeHierarchyItem.from(B,U,K.size.toString(36));return K.set(G._itemId,B),G}j(U,B){return this.e.get(U)?.get(B)}}class Ae{constructor(U,B,K,G,ie){this.e=U,this.f=B,this.g=K,this.h=G,this.j=ie,this.d=new g.$qoc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,B,K,G,ie){const de=this.f.getDocument(B),Ie=i.Position.to(K),Ue=i.DataTransfer.toDataTransfer(G,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(de,Ie,Ue,ie);if(!Ke)return;const _e=(0,v.$1b)(Ke),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,s.localize)(10674,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,B){const[K,G]=U,ie=this.d.get(K,G);if(!ie||!this.g.resolveDocumentDropEdit)return{};const de=await this.g.resolveDocumentDropEdit(ie,B)??ie;return{additionalEdit:de.additionalEdit?i.WorkspaceEdit.from(de.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class ze{constructor(U,B){this.d=U,this.e=B}async provideMappedEdits(U,B,K,G){const ie=c.URI.revive(U),de=this.d.getDocument(ie),Ie=K.documents.map(_e=>_e.map(tt=>({uri:c.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),Ue={documents:Ie,selections:Ie[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(de,B,Ue,G);return Ke?i.WorkspaceEdit.from(Ke):null}}class ke{constructor(U,B){this.adapter=U,this.extension=B}}class Pe{static{this.d=0}constructor(U,B,K,G,ie,de,Ie,Ue){this.g=B,this.h=K,this.j=G,this.k=ie,this.l=de,this.m=Ie,this.n=Ue,this.f=new Map,this.e=U.getProxy(u.$vN.MainThreadLanguageFeatures)}o(U,B){return i.DocumentSelector.from(U,this.g,B)}p(U){return new r.$xN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Pe.d++}async s(U,B,K,G,ie,de=!1){const Ie=this.f.get(U);if(!Ie||!(Ie.adapter instanceof B))return G;const Ue=Date.now();de||this.l.trace(`[${Ie.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Ie.adapter,Ie.extension);return Promise.resolve(Ke).catch(_e=>{(0,O.$3)(_e)||(this.l.error(`[${Ie.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ie.extension.identifier,_e))}).finally(()=>{de||this.l.trace(`[${Ie.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),I.CancellationToken.isCancellationToken(ie)?(0,P.$rh)(Ke,ie):Ke}t(U,B){const K=this.q();return this.f.set(K,new ke(U,B)),K}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,B,K,G){const ie=this.t(new p(this.h,K),U),de=G&&G.label||Pe.u(U);return this.e.$registerDocumentSymbolProvider(ie,this.o(B,U),de),this.p(ie)}$provideDocumentSymbols(U,B,K){return this.s(U,p,G=>G.provideDocumentSymbols(c.URI.revive(B),K),void 0,K)}registerCodeLensProvider(U,B,K){const G=this.q(),ie=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new ke(new m(this.h,this.j.converter,K,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(G,this.o(B,U),ie);let de=this.p(G);if(ie!==void 0){const Ie=K.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(ie));de=r.$xN.from(de,Ie)}return de}$provideCodeLenses(U,B,K){return this.s(U,m,G=>G.provideCodeLenses(c.URI.revive(B),K),void 0,K)}$resolveCodeLens(U,B,K){return this.s(U,m,G=>G.resolveCodeLens(B,K),void 0,void 0)}$releaseCodeLenses(U,B){this.s(U,m,K=>Promise.resolve(K.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(U,B,K){const G=this.t(new E(this.h,K),U);return this.e.$registerDefinitionSupport(G,this.o(B,U)),this.p(G)}$provideDefinition(U,B,K,G){return this.s(U,E,ie=>ie.provideDefinition(c.URI.revive(B),K,G),[],G)}registerDeclarationProvider(U,B,K){const G=this.t(new S(this.h,K),U);return this.e.$registerDeclarationSupport(G,this.o(B,U)),this.p(G)}$provideDeclaration(U,B,K,G){return this.s(U,S,ie=>ie.provideDeclaration(c.URI.revive(B),K,G),[],G)}registerImplementationProvider(U,B,K){const G=this.t(new w(this.h,K),U);return this.e.$registerImplementationSupport(G,this.o(B,U)),this.p(G)}$provideImplementation(U,B,K,G){return this.s(U,w,ie=>ie.provideImplementation(c.URI.revive(B),K,G),[],G)}registerTypeDefinitionProvider(U,B,K){const G=this.t(new k(this.h,K),U);return this.e.$registerTypeDefinitionSupport(G,this.o(B,U)),this.p(G)}$provideTypeDefinition(U,B,K,G){return this.s(U,k,ie=>ie.provideTypeDefinition(c.URI.revive(B),K,G),[],G)}registerHoverProvider(U,B,K,G){const ie=this.t(new C(this.h,K),U);return this.e.$registerHoverProvider(ie,this.o(B,U)),this.p(ie)}$provideHover(U,B,K,G,ie){return this.s(U,C,de=>de.provideHover(c.URI.revive(B),K,G,ie),void 0,ie)}$releaseHover(U,B){this.s(U,C,K=>Promise.resolve(K.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(U,B,K,G){const ie=this.t(new d(this.h,K),U);return this.e.$registerEvaluatableExpressionProvider(ie,this.o(B,U)),this.p(ie)}$provideEvaluatableExpression(U,B,K,G){return this.s(U,d,ie=>ie.provideEvaluatableExpression(c.URI.revive(B),K,G),void 0,G)}registerInlineValuesProvider(U,B,K,G){const ie=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new b(this.h,K),U);this.e.$registerInlineValuesProvider(de,this.o(B,U),ie);let Ie=this.p(de);if(ie!==void 0){const Ue=K.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ie));Ie=r.$xN.from(Ie,Ue)}return Ie}$provideInlineValues(U,B,K,G,ie){return this.s(U,b,de=>de.provideInlineValues(c.URI.revive(B),K,G,ie),void 0,ie)}registerDocumentHighlightProvider(U,B,K){const G=this.t(new F(this.h,K),U);return this.e.$registerDocumentHighlightProvider(G,this.o(B,U)),this.p(G)}registerMultiDocumentHighlightProvider(U,B,K){const G=this.t(new N(this.h,K),U);return this.e.$registerMultiDocumentHighlightProvider(G,this.o(B,U)),this.p(G)}$provideDocumentHighlights(U,B,K,G){return this.s(U,F,ie=>ie.provideDocumentHighlights(c.URI.revive(B),K,G),void 0,G)}$provideMultiDocumentHighlights(U,B,K,G,ie){return this.s(U,N,de=>de.provideMultiDocumentHighlights(c.URI.revive(B),K,G.map(Ie=>c.URI.revive(Ie)),ie),void 0,ie)}registerLinkedEditingRangeProvider(U,B,K){const G=this.t(new M(this.h,K),U);return this.e.$registerLinkedEditingRangeProvider(G,this.o(B,U)),this.p(G)}$provideLinkedEditingRanges(U,B,K,G){return this.s(U,M,async ie=>{const de=await ie.provideLinkedEditingRanges(c.URI.revive(B),K,G);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?Pe.y(de.wordPattern):void 0}},void 0,G)}registerReferenceProvider(U,B,K){const G=this.t(new V(this.h,K),U);return this.e.$registerReferenceSupport(G,this.o(B,U)),this.p(G)}$provideReferences(U,B,K,G,ie){return this.s(U,V,de=>de.provideReferences(c.URI.revive(B),K,G,ie),void 0,ie)}registerCodeActionProvider(U,B,K,G){const ie=new T.$Sc,de=this.t(new W(this.h,this.j.converter,this.k,K,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(de,this.o(B,U),{providedKinds:G?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:G?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this.j.converter.toInternal(Ie.command,ie)}))},Pe.u(U),Pe.w(U),!!K.resolveCodeAction),ie.add(this.p(de)),ie}$provideCodeActions(U,B,K,G,ie){return this.s(U,W,de=>de.provideCodeActions(c.URI.revive(B),K,G,ie),void 0,ie)}$resolveCodeAction(U,B,K){return this.s(U,W,G=>G.resolveCodeAction(B,K),{},void 0)}$releaseCodeActions(U,B){this.s(U,W,K=>Promise.resolve(K.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(U,B,K){const G=this.t(new Y(this.h,K),U);return this.e.$registerDocumentFormattingSupport(G,this.o(B,U),U.identifier,U.displayName||U.name),this.p(G)}$provideDocumentFormattingEdits(U,B,K,G){return this.s(U,Y,ie=>ie.provideDocumentFormattingEdits(c.URI.revive(B),K,G),void 0,G)}registerDocumentRangeFormattingEditProvider(U,B,K){const G=typeof K.provideDocumentRangesFormattingEdits=="function",ie=this.t(new Z(this.h,K),U);return this.e.$registerRangeFormattingSupport(ie,this.o(B,U),U.identifier,U.displayName||U.name,G),this.p(ie)}$provideDocumentRangeFormattingEdits(U,B,K,G,ie){return this.s(U,Z,de=>de.provideDocumentRangeFormattingEdits(c.URI.revive(B),K,G,ie),void 0,ie)}$provideDocumentRangesFormattingEdits(U,B,K,G,ie){return this.s(U,Z,de=>de.provideDocumentRangesFormattingEdits(c.URI.revive(B),K,G,ie),void 0,ie)}registerOnTypeFormattingEditProvider(U,B,K,G){const ie=this.t(new ge(this.h,K),U);return this.e.$registerOnTypeFormattingSupport(ie,this.o(B,U),G,U.identifier),this.p(ie)}$provideOnTypeFormattingEdits(U,B,K,G,ie,de){return this.s(U,ge,Ie=>Ie.provideOnTypeFormattingEdits(c.URI.revive(B),K,G,ie,de),void 0,de)}registerWorkspaceSymbolProvider(U,B){const K=this.t(new _(B,this.l),U);return this.e.$registerNavigateTypeSupport(K,typeof B.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(U,B,K){return this.s(U,_,G=>G.provideWorkspaceSymbols(B,K),{symbols:[]},K)}$resolveWorkspaceSymbol(U,B,K){return this.s(U,_,G=>G.resolveWorkspaceSymbol(B,K),void 0,void 0)}$releaseWorkspaceSymbols(U,B){this.s(U,_,K=>K.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(U,B,K){const G=this.t(new fe(this.h,K,this.l),U);return this.e.$registerRenameSupport(G,this.o(B,U),fe.supportsResolving(K)),this.p(G)}$provideRenameEdits(U,B,K,G,ie){return this.s(U,fe,de=>de.provideRenameEdits(c.URI.revive(B),K,G,ie),void 0,ie)}$resolveRenameLocation(U,B,K,G){return this.s(U,fe,ie=>ie.resolveRenameLocation(c.URI.revive(B),K,G),void 0,G)}registerNewSymbolNamesProvider(U,B,K){const G=this.t(new se(this.h,K,this.l),U);return this.e.$registerNewSymbolNamesProvider(G,this.o(B,U)),this.p(G)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,se,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,B,K,G,ie){return this.s(U,se,de=>de.provideNewSymbolNames(c.URI.revive(B),K,G,ie),void 0,ie)}registerDocumentSemanticTokensProvider(U,B,K,G){const ie=this.t(new $e(this.h,K),U),de=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ie,this.o(B,U),G,de);let Ie=this.p(ie);if(de){const Ue=K.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(de));Ie=r.$xN.from(Ie,Ue)}return Ie}$provideDocumentSemanticTokens(U,B,K,G){return this.s(U,$e,ie=>ie.provideDocumentSemanticTokens(c.URI.revive(B),K,G),null,G)}$releaseDocumentSemanticTokens(U,B){this.s(U,$e,K=>K.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,B,K,G){const ie=this.t(new oe(this.h,K),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ie,this.o(B,U),G),this.p(ie)}$provideDocumentRangeSemanticTokens(U,B,K,G){return this.s(U,oe,ie=>ie.provideDocumentRangeSemanticTokens(c.URI.revive(B),K,G),null,G)}registerCompletionItemProvider(U,B,K,G){const ie=this.t(new Ce(this.h,this.j.converter,K,this.m,U),U);return this.e.$registerCompletionsProvider(ie,this.o(B,U),G,Ce.supportsResolving(K),U.identifier),this.p(ie)}$provideCompletionItems(U,B,K,G,ie){return this.s(U,Ce,de=>de.provideCompletionItems(c.URI.revive(B),K,G,ie),void 0,ie)}$resolveCompletionItem(U,B,K){return this.s(U,Ce,G=>G.resolveCompletionItem(B,K),void 0,K)}$releaseCompletionItems(U,B){this.s(U,Ce,K=>K.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(U,B,K,G){const ie=new X(U,this.h,K,this.j.converter),de=this.t(ie,U);return this.e.$registerInlineCompletionsSupport(de,this.o(B,U),ie.supportsHandleEvents,l.$on.toKey(U.identifier.value),G?.yieldTo?.map(Ie=>l.$on.toKey(Ie))||[]),this.p(de)}$provideInlineCompletions(U,B,K,G,ie){return this.s(U,Le,de=>de.provideInlineCompletions(c.URI.revive(B),K,G,ie),void 0,ie)}$provideInlineEdits(U,B,K,G,ie){return this.s(U,Le,de=>de.provideInlineEdits(c.URI.revive(B),K,G,ie),void 0,ie)}$handleInlineCompletionDidShow(U,B,K,G){this.s(U,Le,async ie=>{ie.handleDidShowCompletionItem(B,K,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,B,K,G,ie){this.s(U,Le,async de=>{de.handlePartialAccept(B,K,G,ie)},void 0,void 0)}$freeInlineCompletionsList(U,B){this.s(U,Le,async K=>{K.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(U,B,K){const G=new q(U,this.h,K,this.j.converter),ie=this.t(G,U);return this.e.$registerInlineEditProvider(ie,this.o(B,U),U.identifier),this.p(ie)}$provideInlineEdit(U,B,K,G){return this.s(U,q,ie=>ie.provideInlineEdits(c.URI.revive(B),K,G),void 0,G)}$freeInlineEdit(U,B){this.s(U,q,async K=>{K.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(U,B,K,G){const ie=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,de=this.t(new ve(this.h,K),U);return this.e.$registerSignatureHelpProvider(de,this.o(B,U),ie),this.p(de)}$provideSignatureHelp(U,B,K,G,ie){return this.s(U,ve,de=>de.provideSignatureHelp(c.URI.revive(B),K,G,ie),void 0,ie)}$releaseSignatureHelp(U,B){this.s(U,ve,K=>K.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(U,B,K){const G=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ie=this.t(new ae(this.h,this.j.converter,K,this.l,U),U);this.e.$registerInlayHintsProvider(ie,this.o(B,U),typeof K.resolveInlayHint=="function",G,Pe.u(U));let de=this.p(ie);if(G!==void 0){const Ie=K.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(G));de=r.$xN.from(de,Ie)}return de}$provideInlayHints(U,B,K,G){return this.s(U,ae,ie=>ie.provideInlayHints(c.URI.revive(B),K,G),void 0,G)}$resolveInlayHint(U,B,K){return this.s(U,ae,G=>G.resolveInlayHint(B,K),void 0,K)}$releaseInlayHints(U,B){this.s(U,ae,K=>K.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(U,B,K){const G=this.t(new be(this.h,K),U);return this.e.$registerDocumentLinkProvider(G,this.o(B,U),typeof K.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(U,B,K){return this.s(U,be,G=>G.provideLinks(c.URI.revive(B),K),void 0,K,B.scheme==="output")}$resolveDocumentLink(U,B,K){return this.s(U,be,G=>G.resolveLink(B,K),void 0,void 0,!0)}$releaseDocumentLinks(U,B){this.s(U,be,K=>K.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(U,B,K){const G=this.t(new ue(this.h,K),U);return this.e.$registerDocumentColorProvider(G,this.o(B,U)),this.p(G)}$provideDocumentColors(U,B,K){return this.s(U,ue,G=>G.provideColors(c.URI.revive(B),K),[],K)}$provideColorPresentations(U,B,K,G){return this.s(U,ue,ie=>ie.provideColorPresentations(c.URI.revive(B),K,G),void 0,G)}registerFoldingRangeProvider(U,B,K){const G=this.q(),ie=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new ke(new J(this.h,K),U)),this.e.$registerFoldingRangeProvider(G,this.o(B,U),U.identifier,ie);let de=this.p(G);if(ie!==void 0){const Ie=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ie));de=r.$xN.from(de,Ie)}return de}$provideFoldingRanges(U,B,K,G){return this.s(U,J,ie=>ie.provideFoldingRanges(c.URI.revive(B),K,G),void 0,G)}registerSelectionRangeProvider(U,B,K){const G=this.t(new x(this.h,K,this.l),U);return this.e.$registerSelectionRangeProvider(G,this.o(B,U)),this.p(G)}$provideSelectionRanges(U,B,K,G){return this.s(U,x,ie=>ie.provideSelectionRanges(c.URI.revive(B),K,G),[],G)}registerCallHierarchyProvider(U,B,K){const G=this.t(new me(this.h,K),U);return this.e.$registerCallHierarchyProvider(G,this.o(B,U)),this.p(G)}$prepareCallHierarchy(U,B,K,G){return this.s(U,me,ie=>Promise.resolve(ie.prepareSession(c.URI.revive(B),K,G)),void 0,G)}$provideCallHierarchyIncomingCalls(U,B,K,G){return this.s(U,me,ie=>ie.provideCallsTo(B,K,G),void 0,G)}$provideCallHierarchyOutgoingCalls(U,B,K,G){return this.s(U,me,ie=>ie.provideCallsFrom(B,K,G),void 0,G)}$releaseCallHierarchy(U,B){this.s(U,me,K=>Promise.resolve(K.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(U,B,K){const G=this.t(new pe(this.h,K),U);return this.e.$registerTypeHierarchyProvider(G,this.o(B,U)),this.p(G)}$prepareTypeHierarchy(U,B,K,G){return this.s(U,pe,ie=>Promise.resolve(ie.prepareSession(c.URI.revive(B),K,G)),void 0,G)}$provideTypeHierarchySupertypes(U,B,K,G){return this.s(U,pe,ie=>ie.provideSupertypes(B,K,G),void 0,G)}$provideTypeHierarchySubtypes(U,B,K,G){return this.s(U,pe,ie=>ie.provideSubtypes(B,K,G),void 0,G)}$releaseTypeHierarchy(U,B){this.s(U,pe,K=>Promise.resolve(K.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(U,B,K,G){const ie=this.q();return this.f.set(ie,new ke(new Ae(this.e,this.h,K,ie,U),U)),this.e.$registerDocumentOnDropEditProvider(ie,this.o(B,U),(0,t.$7G)(U,"documentPaste")&&G?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:G.dropMimeTypes}:void 0),this.p(ie)}$provideDocumentOnDropEdits(U,B,K,G,ie,de){return this.s(U,Ae,Ie=>Promise.resolve(Ie.provideDocumentOnDropEdits(B,c.URI.revive(K),G,ie,de)),void 0,void 0)}$resolveDropEdit(U,B,K){return this.s(U,Ae,G=>G.resolveDropEdit(B,K),{},void 0)}$releaseDocumentOnDropEdits(U,B){this.s(U,Ae,K=>Promise.resolve(K.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(U,B,K){const G=this.t(new ze(this.h,K),U);return this.e.$registerMappedEditsProvider(G,this.o(B,U)),this.p(G)}$provideMappedEdits(U,B,K,G,ie){return this.s(U,ze,de=>Promise.resolve(de.provideMappedEdits(B,K,G,ie)),null,ie)}registerDocumentPasteEditProvider(U,B,K,G){const ie=this.q();return this.f.set(ie,new ke(new L(this.e,this.h,K,ie,U),U)),this.e.$registerPasteEditProvider(ie,this.o(B,U),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:G.providedPasteEditKinds?.map(de=>de.value),copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(ie)}$prepareDocumentPaste(U,B,K,G,ie){return this.s(U,L,de=>de.prepareDocumentPaste(c.URI.revive(B),K,G,ie),void 0,ie)}$providePasteEdits(U,B,K,G,ie,de,Ie){return this.s(U,L,Ue=>Ue.providePasteEdits(B,c.URI.revive(K),G,ie,de,Ie),void 0,Ie)}$resolvePasteEdit(U,B,K){return this.s(U,L,G=>G.resolvePasteEdit(B,K),{},void 0)}$releasePasteEdits(U,B){this.s(U,L,K=>Promise.resolve(K.releasePasteEdits(B)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Pe.y(U.decreaseIndentPattern),increaseIndentPattern:Pe.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Pe.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Pe.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Pe.y(U.beforeText),afterText:U.afterText?Pe.y(U.afterText):void 0,previousLineText:U.previousLineText?Pe.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Pe.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(B=>r.SyntaxTokenType.toString(B)):void 0}}static E(U){return U.map(Pe.D)}setLanguageConfiguration(U,B,K){const{wordPattern:G}=K;if(G&&(0,R.$pf)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(B,G):this.h.setWordDefinitionFor(B,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ie=this.q(),de={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Pe.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Pe.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Pe.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Pe.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ie,B,de),this.p(ie)}$setWordDefinitions(U){for(const B of U)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$Aoc=Pe}),define(Oe[243],Ne([1,0,4,5,8]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=void 0,I=qe(I);class O{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(P.$vN.MainThreadLanguageModelTools),this.b.$getTools().then($=>{for(const a of $)this.c.set(a.name,a)})}async invokeTool(T,$,a){return await this.b.$invokeTool(T,$,a)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>I.LanguageModelToolDescription.to(T))}async $invokeTool(T,$,a){const R=this.a.get(T);if(!R)throw new Error(`Unknown tool ${T}`);return await R.tool.invoke($,a)}registerTool(T,$,a){return this.a.set($,{extension:T,tool:a}),this.b.$registerTool($),(0,v.$Rc)(()=>{this.a.delete($),this.b.$unregisterTool($)})}}e.$5pc=O}),define(Oe[94],Ne([1,0,10,21,42,13,6,39,4,9,18,3,11,76,5,90,16,8,7,117,24]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=e.$hpc=void 0,s=qe(s),l=qe(l),e.$hpc=(0,y.$Ci)("IExtHostLanguageModels");class g{constructor(h,E){this.option=h,this.stream=new v.$6h,this.stream=E??new v.$6h}}class u{constructor(){this.a=new Map,this.b=new v.$6h,this.c=!1;const h=this;this.apiObject={get stream(){return h.b.asyncIterable},get text(){return v.$3h.map(h.b.asyncIterable,E=>{if(E instanceof l.$PP)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;let E=this.a.get(h.index);E||(this.a.size===0?E=new g(h.index,this.b):E=new g(h.index),this.a.set(h.index,E));let S;h.part.type==="text"?S=new l.$PP(h.part.value):S=new l.$OP(h.part.name,h.part.parameters),E.stream.emitOne(S)}reject(h){this.c=!0;for(const E of this.d())E.reject(h)}resolve(){this.c=!0;for(const h of this.d())h.resolve()}}let p=class{static{t=this}static{this.a=1}constructor(h,E,S){this.j=E,this.k=S,this.c=new A.$je,this.d=new A.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new R.$qn,this.i=new Map,this.s=new Set,this.b=h.getProxy(f.$vN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,E,S,w){const k=t.a++;this.f.set(k,{extension:h.identifier,provider:S,languageModelId:E});let C;w.auth&&(C={providerLabel:h.displayName||h.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${R.$on.toKey(h.identifier)}/${k}/${E}`,{extension:h.identifier,id:E,vendor:w.vendor??R.$on.toKey(h.identifier),name:w.name??"",family:w.family??"",version:w.version,maxInputTokens:w.maxInputTokens,maxOutputTokens:w.maxOutputTokens,auth:C,targetExtensions:w.extensions});const d=S.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new R.$on(b),F,N)});return(0,$.$Rc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),d?.dispose()})}async $startChatRequest(h,E,S,w,k,C){const d=this.f.get(h);if(!d)throw new Error("Provider not found");const b=new D.$ww(async N=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${d.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let M;if(N.part instanceof l.$OP?M={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof l.$PP&&(M={type:"text",value:N.part.value}),!M){this.j.warn(`[CHAT](${d.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:M})});let F;if(d.provider.provideLanguageModelResponse2)F=Promise.resolve(d.provider.provideLanguageModelResponse2(w.map(s.LanguageModelChatMessage.to),k,R.$on.toKey(S),b,C));else{const N=new D.$ww(async M=>{b.report({index:M.index,part:new l.$PP(M.part)})});F=Promise.resolve(d.provider.provideLanguageModelResponse(w.map(s.LanguageModelChatMessage.to),k?.modelOptions??{},R.$on.toKey(S),N,C))}F.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,O.$1)(N))})}$provideTokenLength(h,E,S){const w=this.f.get(h);return w?Promise.resolve(w.provider.provideTokenCount(E,S)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:E,metadata:S}of h.added)this.g.set(E,{metadata:S,apiObjects:new R.$qn});if(h.removed)for(const E of h.removed){this.g.delete(E);for(const[S,w]of this.i)w.languageModelId===E&&(w.res.reject(new O.$4),this.i.delete(S))}h.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(h,E){const S=await this.b.$selectChatModels({...E,extension:h.identifier}),w=[],k=this;for(const C of S){const d=this.g.get(C);if(!d)continue;this.o(h.identifier,d.metadata)&&await this.q(d.metadata);let b=d.apiObjects.get(h.identifier);b||(b={id:C,vendor:d.metadata.vendor,family:d.metadata.family,version:d.metadata.version,name:d.metadata.name,maxInputTokens:d.metadata.maxInputTokens,countTokens(F,N){if(!k.g.has(C))throw l.$TP.NotFound(C);return k.r(C,F,N??P.CancellationToken.None)},sendRequest(F,N,M){if(!k.g.has(C))throw l.$TP.NotFound(C);return k.l(h,C,F,N??{},M??P.CancellationToken.None)}},Object.freeze(b),d.apiObjects.set(h.identifier,b)),w.push(b)}return w}async l(h,E,S,w,k){const C=this.m(h,S),d=h.identifier,b=this.g.get(E)?.metadata;if(!b||!this.g.has(E))throw l.$TP.NotFound(`Language model '${E}' is unknown.`);if(this.o(d,b)&&(!await this.n(h,{identifier:b.extension,displayName:b.auth.providerLabel},w.justification,!1)||!this.h.get(d)?.has(b.extension)))throw l.$TP.NoPermissions(`Language model '${E}' cannot be used by '${d.value}'.`);try{const F=Math.random()*1e6|0,N=new u;this.i.set(F,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(d,E,F,C,w,k)}catch(M){throw this.i.delete(F),M}return N.apiObject}catch(F){throw F.name===l.$TP.name?F:new l.$TP(`Language model '${E}' errored: ${(0,I.$nj)(F)}`,"Unknown",F)}}m(h,E){const S=[];for(const w of E)w.role===l.LanguageModelChatMessageRole.System&&(0,r.$8G)(h,"languageModelSystem"),w.content2 instanceof l.$MP&&(0,r.$8G)(h,"lmTools"),S.push(s.LanguageModelChatMessage.from(w));return S}async $acceptResponsePart(h,E){const S=this.i.get(h);S&&S.res.handleFragment(E)}async $acceptResponseDone(h,E){const S=this.i.get(h);S&&(this.i.delete(h),E?S.res.reject((0,O.$2)(E)):S.res.resolve())}async n(h,E,S,w){const k=i.$xM+E.identifier.value;if(await this.k.getSession(h,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0;if(w)return!1;try{const d=S?(0,a.localize)(10672,null,E.displayName,S):void 0;return await this.k.getSession(h,k,[],{forceNewSession:{detail:d}}),this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(h,E){return!!E.auth&&!R.$on.equals(E.extension,h)}async q(h){if(h.auth)for(const E of this.s)try{await this.n(E,{identifier:h.extension,displayName:""},void 0,!0)}catch(S){this.j.error("Fake Auth request failed"),this.j.error(S)}}async r(h,E,S){if(!this.g.get(h))throw l.$TP.NotFound(`Language model '${h}' is unknown.`);const k=T.Iterable.find(this.f.values(),C=>C.languageModelId===h);return k?k.provider.provideTokenCount(E,S):this.b.$countTokens(h,typeof E=="string"?E:s.LanguageModelChatMessage.from(E),S)}$updateModelAccesslist(h){const E=new Array;for(const{from:S,to:w,enabled:k}of h){const C=this.h.get(S)??new R.$pn;if(C.has(w)!==k){k?C.add(w):C.delete(w),this.h.set(S,C);const b={from:S,to:w};E.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(h){this.s.add(h);const E=this,S=A.Event.signal(A.Event.filter(this.c.event,k=>R.$on.equals(k.from,h.identifier))),w=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(S,w)},canSendRequest(k){let C;e:for(const[b,F]of E.g)for(const N of F.apiObjects.values())if(N===k){C=F.metadata;break e}if(!C)return;if(!E.o(h.identifier,C))return!0;const d=E.h.get(h.identifier);if(d)return d.has(C.extension)}}}};e.$ipc=p,e.$ipc=p=t=He([Ve(0,o.$6P),Ve(1,c.$0j),Ve(2,n.$Coc)],p)});var ni=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Oe[244],Ne([1,0,5,8,7,35,10,4,24]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0,P=qe(P),O=ni(O);class a{constructor(y,c,D,f){this.c=c,this.d=D,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$vN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,c){await this.a.$changeLanguage(y,c);const D=this.c.getDocumentData(y);if(!D)throw new Error(`document '${y.toString()}' NOT found`);return D.document}async tokenAtPosition(y,c){const D=y.version,f=P.Position.from(c),n=await this.a.$tokensAtPosition(y.uri,f),o={type:I.StandardTokenType.Other,range:y.getWordRangeAtPosition(c)??new I.$zN(c.line,c.character,c.line,c.character)};if(!n)return o;const s={range:P.Range.to(n.range),type:P.TokenType.to(n.type)};return!s.range.contains(c)||D!==y.version?o:s}createLanguageStatusItem(y,c,D){const f=this.f++,n=this.a,o=this.g,s=`${y.identifier.value}/${c}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${c}' ALREADY exists`);o.add(s);const l={selector:D,id:c,name:y.displayName??y.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new T.$Sc,t=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${c}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Eh)(()=>{r.clear(),this.a.$setLanguageStatus(f,{id:s,name:l.name??y.displayName??y.name,source:y.displayName??y.name,selector:P.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===I.LanguageStatusSeverity.Error?O.default.Error:l.severity===I.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:l.command&&this.d.toInternal(l.command,r),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},g={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(f),o.delete(s)},get id(){return l.id},get name(){return l.name},set name(u){l.name=u,t()},get selector(){return l.selector},set selector(u){l.selector=u,t()},get text(){return l.text},set text(u){l.text=u,t()},set text2(u){(0,$.$8G)(y,"languageStatusText"),l.text=u,t()},get text2(){return(0,$.$8G)(y,"languageStatusText"),l.text},get detail(){return l.detail},set detail(u){l.detail=u,t()},get severity(){return l.severity},set severity(u){l.severity=u,t()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(u){l.accessibilityInformation=u,t()},get command(){return l.command},set command(u){l.command=u,t()},get busy(){return l.busy},set busy(u){l.busy=u,t()}};return t(),g}}e.$6pc=a}),define(Oe[245],Ne([1,0,15,2,8,7,89]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=e.$Qpc=void 0,I=qe(I),A=qe(A);class T{constructor(y,c,D,f){this.start=y,this.deletedCount=c,this.deletedItems=D,this.items=f}asApiEvent(){return{range:new O.$2O(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,c,D){this.notebook=y,this.h=c,this.j=D,this.handle=D.handle,this.uri=P.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(I.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return y.g},set mime(f){y.g=f},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(D)}return this.f}setOutputs(y){this.a=y.map(I.NotebookCellOutput.to)}setOutputItems(y,c,D){const f=D.map(I.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===y);if(n&&(c||(n.items.length=0),n.items.push(...f),n.items.length>1&&n.items.every(o=>A.$AL(o.mime)))){const o=new Map,s=[];n.items.forEach(l=>{let i;o.has(l.mime)?i=o.get(l.mime):(i=[],o.set(l.mime,i),s.push(l.mime)),i.push(l.data)}),n.items.length=0,s.forEach(l=>{const i=A.$BL(o.get(l));n.items.push({mime:l,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Qpc=$;class a{static{this.a=0}constructor(y,c,D,f,n){this.k=y,this.l=c,this.m=D,this.uri=f,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,c={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(D){return D=y.n(D),y.b[D].apiCell},getCells(D){return(D?y.p(D):y.b).map(n=>n.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,c,D){this.g=y.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:D});const f={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},n=[];for(const s of y.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,f.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,f.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),n.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),n.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<n.length;s++){const l=n[s],i=o.get(l.cell);if(i===void 0){const r=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});o.set(l.cell,r-1)}else f.cellChanges[i]={...f.cellChanges[i],...l}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let c=y.start|0,D=y.end|0;return c<0&&(c=0),D>this.b.length&&(D=this.b.length),y.with({start:c,end:D})}p(y){y=this.o(y);const c=[];for(let D=y.start;D<y.end;D++)c.push(this.b[D]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,c,D){if(this.j)return;const f=[],n=[],o=[];if(y.reverse().forEach(s=>{const i=s[2].map(g=>{const u=new $(this,this.l,g);return c||n.push($.asModelAddData(g)),u}),r=new T(s[0],s[1],[],i),t=this.b.splice(s[0],s[1],...i);for(const g of t)o.push(g.uri),r.deletedItems.push(g.apiCell);f.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),D)for(const s of f)D.push(s.asApiEvent())}s(y,c,D,f){const n=this.b.splice(y,c);this.b.splice(D,0,...n);const o=[new T(y,c,n.map(s=>s.apiCell),[]),new T(D,0,[],n)];for(const s of o)f.push(s.asApiEvent())}t(y,c){this.b[y].setOutputs(c)}u(y,c,D,f){this.b[y].setOutputItems(c,D,f)}v(y,c){const D=this.b[y];D.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(D.uri,c)}w(y,c){const D=this.b[y];D.apiCell.mime=c}x(y,c){this.b[y].setMetadata(c)}y(y,c){this.b[y].setInternalMetadata(c)}getCellFromApiCell(y){return this.b.find(c=>c.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(c=>c.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Rpc=a}),define(Oe[246],Ne([1,0,6,2,8,7,38]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class T{constructor(a,R,y,c={timeout:1500,errors:3}){this.b=a,this.c=R,this.d=y,this.f=c,this.a=new v.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(R,y,c)=>{const D=function(n){R.call(y,n)};return D.extension=a,this.a.event(D,void 0,c)}}async $participateInSave(a,R,y){const c=P.URI.revive(a),D=this.c.getNotebookDocument(c);if(!D)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:D.apiNotebook,reason:I.TextDocumentSaveReason.to(R)},y,async(o,s)=>{const l=Date.now(),i=await await Promise.resolve(o);Date.now()-l>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$JN?f.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(f.length===0)return!0;const n={edits:[]};for(const o of f){const{edits:s}=I.WorkspaceEdit.from(o);n.edits=n.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new A.$Uw(n))}}e.$8pc=T}),define(Oe[124],Ne([1,0,13,8,7]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0,P=qe(P),I=qe(I);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,$,a,R,y,c){this.id=T,this.f=$,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=R,this.c=c}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection($){this.selections=[$]},get selections(){return T.a},set selections($){if(!Array.isArray($)||!$.every(I.$2O.isNotebookRange))throw(0,v.$6)("selections");T.a=$,T.g($)},get visibleRanges(){return T.b},revealRange($,a){T.f.$tryRevealRange(T.id,P.NotebookRange.from($),a??I.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(P.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Spc=O}),define(Oe[247],Ne([1,0,6,11,8]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=void 0,I=qe(I);let O=class{constructor(T,$){this.c=T,this.d=$,this.a=new v.$je,this.b=new v.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,$);const a=this.d.getEditorById(T);$.visibleRanges&&a._acceptVisibleRanges($.visibleRanges.ranges.map(I.NotebookRange.to)),$.selections&&a._acceptSelections($.selections.selections.map(I.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const $ in T)this.d.getEditorById($)._acceptViewColumn(I.ViewColumn.to(T[$]))}};e.$0pc=O,e.$0pc=O=He([Ve(0,P.$0j)],O)}),define(Oe[248],Ne([1,0,6,5,124]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class O{constructor(T,$){this.c=$,this.a=new Map,this.b=T.getProxy(P.$vN.MainThreadNotebookRenderers)}$postRendererMessage(T,$,a){const R=this.c.getEditorById(T);this.a.get($)?.fire({editor:R.apiEditor,message:a})}createRendererMessaging(T,$){if(!T.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,y,c)=>this.d($).event(R,y,c),postMessage:(R,y)=>{I.$Spc.apiEditorsToExtHost.has(R)&&([R,y]=[y,R]);const c=y&&I.$Spc.apiEditorsToExtHost.get(y);return this.b.$postMessage(c?.id,$,R)}}}d(T){let $=this.a.get(T);return $||($=new v.$je({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(T)}}),this.a.set(T,$),$)}}e.$aqc=O}),define(Oe[249],Ne([1,0,8,76,21,71,13]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,c,D){const f=this.b++,{title:n,location:o,cancellable:s}=c,l={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(f,{location:v.ProgressLocation.from(o),title:n,source:l,cancellable:s},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$Z),this.d(f,D,!!s)}d(y,c,D){let f;D&&(f=new I.$ue,this.c.set(y,f));const n=s=>{this.a.$progressEnd(s),this.c.delete(s),f?.dispose()};let o;try{o=c(new a(this.a,y),D&&f?f.token:I.CancellationToken.None)}catch(s){throw n(y),s}return o.then(s=>n(y),s=>n(y)),o}$acceptProgressCanceled(y){const c=this.c.get(y);c&&(c.cancel(),this.c.delete(y))}}e.$eqc=T;function $(R,y){return R.message=y.message,typeof y.increment=="number"&&(typeof R.increment=="number"?R.increment+=y.increment:R.increment=y.increment),R}class a extends P.$ww{constructor(y,c){super(D=>this.throttledReport(D)),this.c=y,this.d=c}throttledReport(y){this.c.$progressReport(this.d,y)}}He([(0,O.$9h)(100,(R,y)=>$(R,y),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(Oe[250],Ne([1,0,2,5,10,8]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class A{static{this.a=0}constructor($,a){this.d=a,this.c=new Map,this.b=$.getProxy(P.$vN.MainThreadQuickDiff)}$provideOriginalResource($,a,R){const y=v.URI.revive(a),c=this.c.get($);return c?(0,I.$uh)(()=>c.provideOriginalResource(y,R)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider($,a,R,y){const c=A.a++;return this.c.set(c,a),this.b.$registerQuickDiffProvider(c,O.DocumentSelector.from($,this.d),R,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.$fqc=A});var ni=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Oe[251],Ne([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=f,R=ni(R);function f(n,o,s){const l=n.getProxy(O.$vN.MainThreadQuickOpen);class i{constructor(S,w){this.e=new Map,this.f=0,this.a=S,this.b=w}showQuickPick(S,w,k,C=v.CancellationToken.None){this.c=void 0;const d=Promise.resolve(w),b=++this.f,F=l.$show(b,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},C),N={},M=F.then(()=>N);return Promise.race([M,d]).then(V=>{if(V===N)return;const W=(0,c.$7G)(S,"quickPickItemTooltip");return d.then(L=>{const Y=[];for(let Z=0;Z<L.length;Z++){const ge=L[Z];if(typeof ge=="string")Y.push({label:ge,handle:Z});else if(ge.kind===T.QuickPickItemKind.Separator)Y.push({type:"separator",label:ge.label});else{ge.tooltip&&!W&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const _=ge.iconPath?p(ge.iconPath):void 0;Y.push({label:ge.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:W?D.MarkdownString.fromStrict(ge.tooltip):void 0,handle:Z})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=Z=>{k.onDidSelectItem(L[Z])}),l.$setItems(b,Y),F.then(Z=>{if(typeof Z=="number")return L[Z];if(Array.isArray(Z))return Z.map(ge=>L[ge])})})}).then(void 0,V=>{if(!(0,$.$3)(V))return l.$setError(b,V),Promise.reject(V)})}$onItemSelected(S){this.c?.(S)}showInput(S,w=v.CancellationToken.None){return this.d=S?.validateInput,l.$input(S,typeof this.d=="function",w).then(void 0,k=>{if(!(0,$.$3)(k))return Promise.reject(k)})}async $validateInput(S){if(!this.d)return;const w=await this.d(S);if(!w||typeof w=="string")return w;let k;switch(w.severity){case T.InputBoxValidationSeverity.Info:k=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:k=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:k=R.default.Error;break;default:k=w.message?R.default.Error:R.default.Ignore;break}return{content:w.message,severity:k}}async showWorkspaceFolderPick(S,w=v.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!k)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(d=>d.uri.toString()===k.uri.toString())}createQuickPick(S){const w=new m(S,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}createInputBox(S){const w=new h(S,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}$onDidChangeValue(S,w){this.e.get(S)?._fireDidChangeValue(w)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,w){const k=this.e.get(S);k instanceof m&&k._fireDidChangeActive(w)}$onDidChangeSelection(S,w){const k=this.e.get(S);k instanceof m&&k._fireDidChangeSelection(w)}$onDidTriggerButton(S,w){this.e.get(S)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(S,w,k){const C=this.e.get(S);C instanceof m&&C._fireDidTriggerItemButton(w,k)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class r{static{this.a=1}constructor(S,w){this.x=S,this.y=w,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.$je,this.q=new P.$je,this.r=new P.$je,this.s=new P.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((w,k)=>{const C=w===T.$YO.Back?-1:k;this.o.set(C,w)}),this.z({buttons:S.map((w,k)=>({...p(w.iconPath),tooltip:w.tooltip,handle:w===T.$YO.Back?-1:k}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const w=this.o.get(S);w&&this.r.fire(w)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(S){if(!this.v){for(const w of Object.keys(S)){const k=S[w];this.u[w]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$wO)return{id:E.id};const S=u(E),w=g(E);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof w=="string"?A.URI.file(w):w}}function g(E){return typeof E=="object"&&"light"in E?E.light:E}function u(E){return typeof E=="object"&&"dark"in E?E.dark:E}function p(E){const S=t(E);let w,k;return"id"in S?k=y.ThemeIcon.asClassName(S):w=S,{iconPath:w,iconClass:k}}class m extends r{constructor(S,w){super(S.identifier,w),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.$je,this.L=[],this.M=new P.$je,this.N=new P.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((C,d)=>{this.C.set(d,C),this.D.set(C,d)});const w=(0,c.$7G)(this.O,"quickPickItemTooltip"),k=[];for(let C=0;C<S.length;C++){const d=S[C];if(d.kind===T.QuickPickItemKind.Separator)k.push({type:"separator",label:d.label});else{d.tooltip&&!w&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const b=d.iconPath?p(d.iconPath):void 0;k.push({handle:C,label:d.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,tooltip:w?D.MarkdownString.fromStrict(d.tooltip):void 0,buttons:d.buttons?.map((F,N)=>({...p(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(w=>this.D.has(w)),this.z({activeItems:this.J.map(w=>this.D.get(w))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(w=>this.D.has(w)),this.z({selectedItems:this.L.map(w=>this.D.get(w))})}_fireDidChangeActive(S){const w=(0,a.$Gb)(S.map(k=>this.C.get(k)));this.J=w,this.K.fire(w)}_fireDidChangeSelection(S){const w=(0,a.$Gb)(S.map(k=>this.C.get(k)));this.L=w,this.M.fire(w)}_fireDidTriggerItemButton(S,w){const k=this.C.get(S);if(!k||!k.buttons||!k.buttons.length)return;const C=k.buttons[w];C&&this.N.fire({button:C,item:k})}}class h extends r{constructor(S,w){super(S.identifier,w),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:R.default.Error}):this.z({validationMessage:S.message,severity:S.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(o,s)}}),define(Oe[252],Ne([1,0,2,6,71,4,10,5,17,144,11,18,36,34,8,24,15,20]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=e.$hqc=void 0;function i(N){return N instanceof v.URI}function r(N,M){return N.scheme===o.Schemas.file&&M.scheme===o.Schemas.file&&s.$l?N.toString()===M.toString():N.toString().toLowerCase()===M.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?v.URI.file(N.iconPath):v.URI.isUri(N.iconPath)||D.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function g(N){if(N){if(v.URI.isUri(N))return N;if(D.ThemeIcon.isThemeIcon(N))return N;{const M=N;return{light:M.light,dark:M.dark}}}else return}function u(N){const M=g(N.icon),V=N.labels?.map(W=>({title:W.title,icon:g(W.icon)}));return{...N,icon:M,labels:V}}function p(N,M){if(!N.iconPath&&!M.iconPath)return 0;if(N.iconPath){if(!M.iconPath)return 1}else return-1;const V=typeof N.iconPath=="string"?N.iconPath:v.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,W=typeof M.iconPath=="string"?M.iconPath:v.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,a.$Hr)(V,W)}function m(N,M){let V=0;if(N.strikeThrough!==M.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==M.faded)return N.faded?1:-1;if(N.tooltip!==M.tooltip)return(N.tooltip||"").localeCompare(M.tooltip||"");if(V=p(N,M),V!==0)return V;if(N.light&&M.light)V=p(N.light,M.light);else{if(N.light)return 1;if(M.light)return-1}if(V!==0)return V;if(N.dark&&M.dark)V=p(N.dark,M.dark);else{if(N.dark)return 1;if(M.dark)return-1}return V}function h(N,M){if(N.command!==M.command)return N.command<M.command?-1:1;if(N.title!==M.title)return N.title<M.title?-1:1;if(N.tooltip!==M.tooltip){if(N.tooltip!==void 0&&M.tooltip!==void 0)return N.tooltip<M.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(N.arguments===M.arguments)return 0;if(N.arguments)if(M.arguments){if(N.arguments.length!==M.arguments.length)return N.arguments.length-M.arguments.length}else return 1;else return-1;for(let V=0;V<N.arguments.length;V++){const W=N.arguments[V],L=M.arguments[V];if(W!==L&&!(i(W)&&i(L)&&r(W,L)))return W<L?-1:1}return 0}function E(N,M){let V=(0,a.$Hr)(N.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(V!==0)return V;if(N.command&&M.command)V=h(N.command,M.command);else{if(N.command)return 1;if(M.command)return-1}if(V!==0)return V;if(N.decorations&&M.decorations)V=m(N.decorations,M.decorations);else{if(N.decorations)return 1;if(M.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&M.multiFileDiffEditorModifiedUri)V=(0,a.$Hr)(N.multiFileDiffEditorModifiedUri.fsPath,M.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(M.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&M.multiDiffEditorOriginalUri)V=(0,a.$Hr)(N.multiDiffEditorOriginalUri.fsPath,M.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(M.multiDiffEditorOriginalUri)return-1}return V}function S(N,M){for(let V=0;V<N.length;V++)if(N[V]!==M[V])return!1;return!0}function w(N,M){return N.command===M.command&&N.title===M.title&&N.tooltip===M.tooltip&&(N.arguments&&M.arguments?S(N.arguments,M.arguments):N.arguments===M.arguments)}function k(N,M){return(0,$.$tb)(N,M,w)}class C{#e;#t;get value(){return this.d}set value(M){M=M??"",this.#e.$setInputBoxValue(this.m,M),this.o(M)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(M){this.#e.$setInputBoxPlaceholder(this.m,M),this.f=M}get validateInput(){return(0,n.$8G)(this.k,"scmValidation"),this.g}set validateInput(M){if((0,n.$8G)(this.k,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=M,this.#e.$setValidationProviderIsEnabled(this.m,!!M)}get enabled(){return this.h}set enabled(M){M=!!M,this.h!==M&&(this.h=M,this.#e.$setInputBoxEnablement(this.m,M))}get visible(){return this.j}set visible(M){M=!!M,this.j!==M&&(this.j=M,this.#e.$setInputBoxVisibility(this.m,M))}get document(){return(0,n.$8G)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(M,V,W,L,Y){this.k=M,this.m=L,this.n=Y,this.d="",this.e=new P.$je,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(M,V){(0,n.$8G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,M,V)}$onInputBoxValueChange(M){this.o(M)}o(M){this.d=M,this.e.fire(M)}}e.$hqc=C;class d{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(M){this.w=M,this.s.$updateGroupLabel(this.u,this.handle,M)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(M){this.q=M,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(M){this.f=[...M],this.k.fire()}constructor(M,V,W,L,Y,Z,ge){this.s=M,this.t=V,this.u=W,this.v=L,this.w=Y,this.multiDiffEditorEnableViewChanges=Z,this.x=ge,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.$je,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new P.$je,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=d.d++}getResourceState(M){return this.g.get(M)}$executeResourceCommand(M,V){const W=this.h.get(M);return W?(0,A.$uh)(()=>this.t.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this.f].sort(E),W=(0,$.$Cb)(this.p,M,E).map(Z=>{const ge=Z.toInsert.map(_=>{const fe=this.e++;this.g.set(fe,_);const se=_.resourceUri;let ce;if(_.command)if(_.command.command==="vscode.open"||_.command.command==="vscode.diff"||_.command.command==="vscode.changes"){const x=new O.$Sc;ce=this.t.converter.toInternal(_.command,x),this.j.set(fe,x)}else this.h.set(fe,_.command);const $e=(0,n.$7G)(this.x,"scmMultiDiffEditor"),oe=$e?_.multiDiffEditorOriginalUri:void 0,Ce=$e?_.multiFileDiffEditorModifiedUri:void 0,Le=t(_.decorations),X=_.decorations&&t(_.decorations.light)||Le,q=_.decorations&&t(_.decorations.dark)||Le,te=[X,q],ve=_.decorations&&_.decorations.tooltip||"",ae=_.decorations&&!!_.decorations.strikeThrough,be=_.decorations&&!!_.decorations.faded,ue=_.contextValue||"";return{rawResource:[fe,se,te,ve,ae,be,ue,ce,oe,Ce],handle:fe}});return{start:Z.start,deleteCount:Z.deleteCount,toInsert:ge}}),L=W.map(({start:Z,deleteCount:ge,toInsert:_})=>[Z,ge,_.map(fe=>fe.rawResource)]),Y=W.reverse();for(const{start:Z,deleteCount:ge,toInsert:_}of Y){const fe=_.map(ce=>ce.handle),se=this.o.splice(Z,ge,...fe);for(const ce of se)this.g.delete(ce),this.h.delete(ce),this.j.get(ce)?.dispose(),this.j.delete(ce)}return this.p=M,L}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(M){this.g!==M&&(this.g=M,this.#e.$updateSourceControl(this.x,{count:M}))}get quickDiffProvider(){return this.h}set quickDiffProvider(M){this.h=M;let V;(0,n.$7G)(this.y,"quickDiffProvider")&&(V=M?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!M,quickDiffLabel:V})}get historyProvider(){return(0,n.$8G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(M){(0,n.$8G)(this.y,"scmHistoryProvider"),this.j=M,this.k.value=new O.$Sc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!M}),M&&this.k.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this.m=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(M){M!==this.n&&(this.n=M,this.#e.$updateSourceControl(this.x,{commitTemplate:M}))}get acceptInputCommand(){return this.p}set acceptInputCommand(M){this.o.value=new O.$Sc,this.p=M;const V=this.z.converter.toInternal(M,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:V})}get actionButton(){return(0,n.$8G)(this.y,"scmActionButton"),this.s}set actionButton(M){(0,n.$8G)(this.y,"scmActionButton"),this.q.value=new O.$Sc,this.s=M;const V=M!==void 0?{command:this.z.converter.toInternal(M.command,this.q.value),secondaryCommands:M.secondaryCommands?.map(W=>W.map(L=>this.z.converter.toInternal(L,this.q.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:V??null})}get statusBarCommands(){return this.u}set statusBarCommands(M){if(this.u&&M&&k(this.u,M))return;this.t.value=new O.$Sc,this.u=M;const V=(M||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:V})}get selected(){return this.v}constructor(M,V,W,L,Y,Z,ge){this.y=M,this.z=L,this.A=Y,this.B=Z,this.C=ge,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Uc,this.n=void 0,this.o=new O.$Uc,this.p=void 0,this.q=new O.$Uc,this.t=new O.$Uc,this.u=void 0,this.v=!1,this.w=new P.$je,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=W;const _=v.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${Y}/scm${this.x}/input`,query:ge?`rootUri=${encodeURIComponent(ge.toString())}`:void 0});this.f=new C(M,V,this.#e,this.x,_),this.#e.$registerSourceControl(this.x,Y,Z,ge,_)}createResourceGroup(M,V,W){const L=(0,n.$7G)(this.y,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,Y=new d(this.#e,this.z,this.x,M,V,L,this.y),Z=P.Event.once(Y.onDidDispose)(()=>this.D.delete(Y));return this.D.set(Y,Z),this.eventuallyAddResourceGroups(),Y}eventuallyAddResourceGroups(){const M=[],V=[];for(const[W,L]of this.D){L.dispose();const Y=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});P.Event.once(W.onDidDispose)(()=>{this.E.delete(W),Y.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),M.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const Z=W._takeResourceStateSnapshot();Z.length>0&&V.push([W.handle,Z]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,M,V),this.D.clear()}eventuallyUpdateResourceStates(){const M=[];this.E.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&M.push([V.handle,W])}),M.length>0&&this.#e.$spliceResourceStates(this.x,M),this.E.clear()}getResourceGroup(M){return this.e.get(M)}setSelectionState(M){this.v=M,this.w.fire(M)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,I.$8h)(100)],b.prototype,"eventuallyAddResourceGroups",null),He([(0,I.$8h)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(M,V,W,L){this.m=V,this.n=W,this.o=L,this.g=new Map,this.h=new y.$qn,this.j=new P.$je,this.e=M.getProxy(T.$vN.MainThreadSCM),this.f=M.getProxy(T.$vN.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:Y=>{if(Y&&Y.$mid===c.MarshalledId.ScmResource){const Z=this.g.get(Y.sourceControlHandle);if(!Z)return Y;const ge=Z.getResourceGroup(Y.groupHandle);return ge?ge.getResourceState(Y.handle):Y}else if(Y&&Y.$mid===c.MarshalledId.ScmResourceGroup){const Z=this.g.get(Y.sourceControlHandle);return Z?Z.getResourceGroup(Y.groupHandle):Y}else if(Y&&Y.$mid===c.MarshalledId.ScmProvider){const Z=this.g.get(Y.handle);return Z||Y}return Y}})}createSourceControl(M,V,W,L){this.o.trace("ExtHostSCM#createSourceControl",M.identifier.value,V,W,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const Y=l.d++,Z=new b(M,this.n,this.e,this.m,V,W,L);this.g.set(Y,Z);const ge=this.h.get(M.identifier)||[];return ge.push(Z),this.h.set(M.identifier,ge),Z}getLastInputBox(M){this.o.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const V=this.h.get(M.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(M,V,W){const L=v.URI.revive(V);this.o.trace("ExtHostSCM#$provideOriginalResource",M,L.toString());const Y=this.g.get(M);return!Y||!Y.quickDiffProvider||!Y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$uh)(()=>Y.quickDiffProvider.provideOriginalResource(L,W)).then(Z=>Z||null)}$onInputBoxValueChange(M,V){this.o.trace("ExtHostSCM#$onInputBoxValueChange",M);const W=this.g.get(M);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(M,V,W,L){this.o.trace("ExtHostSCM#$executeResourceCommand",M,V,W);const Y=this.g.get(M);if(!Y)return Promise.resolve(void 0);const Z=Y.getResourceGroup(V);return Z?Z.$executeResourceCommand(W,L):Promise.resolve(void 0)}$validateInput(M,V,W){this.o.trace("ExtHostSCM#$validateInput",M);const L=this.g.get(M);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,A.$uh)(()=>L.inputBox.validateInput(V,W)).then(Y=>{if(!Y)return Promise.resolve(void 0);const Z=f.MarkdownString.fromStrict(Y.message);return Z?Promise.resolve([Z,Y.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this.g.get(M)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(M,V,W,L){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,L)??void 0}async $provideHistoryItems(M,V,W,L){return(await this.g.get(M)?.historyProvider?.provideHistoryItems(V,W,L))?.map(ge=>u(ge))??void 0}async $provideHistoryItems2(M,V,W){return(await this.g.get(M)?.historyProvider?.provideHistoryItems2(V,W))?.map(Z=>u(Z))??void 0}async $provideHistoryItemSummary(M,V,W,L){const Y=this.g.get(M)?.historyProvider;if(typeof Y?.provideHistoryItemSummary!="function")return;const Z=await Y.provideHistoryItemSummary(V,W,L);return Z?u(Z):void 0}async $provideHistoryItemChanges(M,V,W,L){return await this.g.get(M)?.historyProvider?.provideHistoryItemChanges(V,W,L)??void 0}};e.$iqc=F,e.$iqc=F=l=He([Ve(3,R.$0j)],F)}),define(Oe[253],Ne([1,0,5,8,2]),function(we,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=void 0;class O{static{this.a=0}constructor(T,$){this.d=$,this.c=new Map,this.b=T.getProxy(v.$vN.MainThreadShare)}async $provideShare(T,$,a){return await this.c.get(T)?.provideShare({selection:P.Range.to($.selection),resourceUri:I.URI.revive($.resourceUri)},a)??void 0}registerShareProvider(T,$){const a=O.a++;return this.c.set(a,$),this.b.$registerShareProvider(a,P.DocumentSelector.from(T,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$jqc=O}),define(Oe[254],Ne([1,0,7,5,9,4,8,14]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=e.$lqc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$xO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$xO("statusBarItem.warningForeground")]])}#e;#t;constructor(c,D,f,n,o,s=v.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new O.$Sc,this.#e=c,this.#t=D,o&&n){this.c=(0,v.$_N)(n.identifier,o);const i=f.get(this.c);i&&(s=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,l=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=n,this.f=o,this.g=s,this.h=this.u(l)}u(c){if((0,T.$gg)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(c){this.k=c,this.v()}set name(c){this.m=c,this.v()}set tooltip(c){this.l=c,this.v()}set color(c){this.n=c,this.v()}set backgroundColor(c){c&&!$.b.has(c.id)&&(c=void 0),this.o=c,this.v()}set command(c){this.r?.fromApi!==c&&(this.p&&this.q.add(this.p),this.p=new O.$Sc,typeof c=="string"?this.r={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this.p)}:c?this.r={fromApi:c,internal:this.#t.toInternal(c,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(c){this.t=c,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let c;this.e?this.f?c=`${this.e.identifier.value}.${this.f}`:c=this.e.identifier.value:c=this.f;let D;this.m?D=this.m:D=(0,I.localize)(10665,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=$.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,c,this.e?.identifier.value,D,this.k,n,this.r?.internal,f,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$lqc=$;class a{constructor(c){this.b=[],this.a=c.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(10666,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(c){const D={message:c};return this.b.unshift(D),this.c(),new v.$xN(()=>{const f=this.b.indexOf(D);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(c,D){this.e=new Map,this.a=c.getProxy(P.$vN.MainThreadStatusBar),this.b=D,this.c=new a(this)}$acceptStaticEntries(c){for(const D of c)this.e.set(D.entryId,D)}createStatusBarEntry(c,D,f,n){return new $(this.a,this.b,this.e,c,D,f,n)}setStatusBarMessage(c,D){const f=this.c.setMessage(c);let n;return typeof D=="number"?n=setTimeout(()=>f.dispose(),D):typeof D<"u"&&D.then(()=>f.dispose(),()=>f.dispose()),new v.$xN(()=>{f.dispose(),clearTimeout(n)})}}e.$mqc=R}),define(Oe[125],Ne([1,0,32,116,54,81,55,8,2]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=e.$gQ=e.$fQ=void 0,v=qe(v),T=qe(T);const a=(i,r,t,g)=>{let u=r;return{enumerable:!0,configurable:!1,get(){return u},set(p){if(!t(u,p)){const m=u;u=p,i.listener?.(g(p,m))}}}},R=(i,r)=>i===r,y={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(g=>t.id===g.id)))},c=i=>r=>({op:O.TestItemEventOp.SetProp,update:i(r)}),D=(i,r)=>({range:(()=>{let t;const g=c(u=>({range:v.$Lt.lift(T.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,u)||(t=u,i.listener?.(g(u)))}}})(),label:a(i,r,y.label,c(t=>({label:t}))),description:a(i,void 0,y.description,c(t=>({description:t}))),sortText:a(i,void 0,y.sortText,c(t=>({sortText:t}))),canResolveChildren:a(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(i,!1,y.busy,c(t=>({busy:t}))),error:a(i,void 0,y.error,c(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:a(i,[],y.tags,(t,g)=>({op:O.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:g.map(T.TestTag.from)}))}),f=i=>{const r=I.$UI.fromString(i.extId),t=new o(r.controllerId,r.localId,i.label,$.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>T.TestTag.to({id:(0,A.$1I)(g).tagId})),t},n=i=>{let r;for(const t of i.tests){const g=f(t.item);(0,P.$2P)(g).parent=r,r=g}return r};e.$fQ=n;class o{constructor(r,t,g,u){if(t.includes(I.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const p=(0,P.$1P)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return p.parent instanceof s?void 0:p.parent}},children:{value:(0,O.$ZP)(p,P.$2P,o),enumerable:!0,writable:!1},...D(p,g)})}}e.$gQ=o;class s extends o{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$hQ=s;class l extends O.$VP{constructor(r,t,g){super({controllerId:r,getDocumentVersion:u=>u&&g.getDocument(u)?.version,getApiFor:P.$2P,getChildren:u=>u.children,root:new s(r,t),toITestItem:T.TestItem.from})}}e.$iQ=l}),define(Oe[33],Ne([1,0,14,7,8,25,5,17,11,40,32,101,2,4,3,16,125,22,38,42,69,63,66,37]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=e.$sQ=e.$rQ=e.$qQ=e.$pQ=e.$oQ=void 0,P=qe(P),I=qe(I);let p=class{#e;#t;#i;constructor(k,C,d){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$vN.MainThreadCommands),this.d=C,this.#i=d,this.#t=k.getProxy(A.$vN.MainThreadTelemetry),this.converter=new m(this,b=>{const F=this.c.get(b);return F?.result===E.Void?F:void 0},C),this.f=[{processArgument(b){return(0,a.$_h)(b)}},{processArgument(b){return(0,O.$do)(b,function(F){if(R.$Lt.isIRange(F))return I.Range.to(F);if(y.$Kt.isIPosition(F))return I.Position.to(F);if(R.$Lt.isIRange(F.range)&&c.URI.isUri(F.uri))return I.location.to(F);if(F instanceof s.$Le)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const C=this.registerCommand(!1,k.id,async(...d)=>{const b=k.args.map((N,M)=>{if(!N.validate(d[M]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof d[M]=="object"?JSON.stringify(d[M],null,"	"):d[M]} `);return N.convert(d[M])}),F=await this.executeCommand(k.internalId,...b);return k.result.convert(F,d,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new P.$xN(()=>{C.dispose(),this.c.delete(k.id)})}registerCommand(k,C,d,b,F,N){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:d,thisArg:b,metadata:F,extension:N}),k&&this.#e.$registerCommand(C),new P.$xN(()=>{this.b.delete(C)&&k&&this.#e.$unregisterCommand(C)})}executeCommand(k,...C){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,C,!0)}async g(k,C,d){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,C,!1);{let b=!1;const F=(0,O.$do)(C,function(N){if(N instanceof P.$yN)return I.Position.from(N);if(N instanceof P.$zN)return I.Range.from(N);if(N instanceof P.$LN)return I.location.from(N);if(P.$2O.isNotebookRange(N))return I.NotebookRange.from(N);if(N instanceof ArrayBuffer)return b=!0,s.$Le.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return b=!0,s.$Le.wrap(N);if(N instanceof s.$Le)return b=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,b?new l.$Uw(F):F,d);return(0,a.$_h)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,C,!1);throw N}}}async h(k,C,d){const b=this.b.get(k);if(!b)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:M}=b;if(M?.args)for(let W=0;W<M.args.length;W++)try{(0,v.$tg)(C[W],M.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${M.args[W].name}' - ${M.args[W].description}`)}const V=r.$de.create();try{return await F.apply(N,C)}catch(W){if(k===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...C);L&&(k=L.command)}if(this.d.error(W,k,b.extension?.identifier),!d)throw W;if(b.extension?.identifier){const L=this.#i.onExtensionError(b.extension.identifier,W);this.d.trace("forwarded error to extension?",L,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$nj)(W)),this.id=k,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,k,V.elapsed())}}j(k,C,d){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$up(C),duration:d})}$executeContributedCommand(k,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const d=this.b.get(k);return d?(C=C.map(b=>this.f.reduce((F,N)=>N.processArgument(F,d.extension?.identifier),b)),this.h(k,C,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(C=>(k&&(C=C.filter(d=>d[0]!=="_")),C))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[C,d]of this.b){const{metadata:b}=d;b&&(k[C]=b)}return Promise.resolve(k)}};e.$oQ=p,e.$oQ=p=He([Ve(0,n.$6P),Ve(1,$.$0j),Ve(2,g.$nQ)],p),e.$pQ=(0,f.$Ci)("IExtHostCommands");class m{constructor(k,C,d){this.d=k,this.f=C,this.g=d,this.delegatingCommandId=`__vsc${(0,u.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,C){if(!k)return;const d={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return d;const b=this.f(k.command);if(b)d.id=b.internalId,d.arguments=b.args.map((F,N)=>F.convert(k.arguments&&k.arguments[N]));else if((0,T.$Kb)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),C.add((0,D.$Rc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),d.$ident=F,d.id=this.delegatingCommandId,d.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return d}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const C=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$qQ=m;class h{static{this.Uri=new h("uri","Uri of a text document",k=>c.URI.isUri(k),k=>k)}static{this.Position=new h("position","A position in a text document",k=>P.$yN.isPosition(k),I.Position.from)}static{this.Range=new h("range","A range in a text document",k=>P.$zN.isRange(k),I.Range.from)}static{this.Selection=new h("selection","A selection in a text document",k=>P.$AN.isSelection(k),I.Selection.from)}static{this.Number=new h("number","",k=>typeof k=="number",k=>k)}static{this.String=new h("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=h.Arr(h.String)}static Arr(k){return new h(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,C=>Array.isArray(C)&&C.every(d=>k.validate(d)),C=>C.map(d=>k.convert(d)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",k=>k instanceof P.$XN,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",k=>k instanceof P.$jP,I.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",k=>k instanceof o.$gQ,I.TestItem.from)}constructor(k,C,d,b){this.name=k,this.description=C,this.validate=d,this.convert=b}optional(){return new h(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,C){return new h(k??this.name,C??this.description,this.validate,this.convert)}}e.$rQ=h;class E{static{this.Void=new E("no result",k=>k)}constructor(k,C){this.description=k,this.convert=C}}e.$sQ=E;class S{constructor(k,C,d,b,F){this.id=k,this.internalId=C,this.description=d,this.args=b,this.result=F}}e.$tQ=S}),define(Oe[255],Ne([1,0,17,15,2,93,103,31,33,8,7]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0,O=qe(O),a=qe(a),R=qe(R);const y=[new $.$tQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of DocumentHighlight-instances.",D(a.DocumentHighlight.to))),new $.$tQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$rQ.Uri],new $.$sQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,v.$Jb)(n))return;class s extends R.$SN{static to(i){const r=new s(i.name,a.SymbolKind.to(i.kind),i.containerName||"",new R.$LN(o[0],a.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=a.Range.to(i.selectionRange),r.children=i.children?i.children.map(s.to):[],r}}return n.map(s.to)})),new $.$tQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$rQ.Uri,new $.$rQ("options","Formatting options",n=>!0,n=>n)],new $.$sQ("A promise that resolves to an array of TextEdits.",D(a.TextEdit.to))),new $.$tQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$rQ.Uri,$.$rQ.Range,new $.$rQ("options","Formatting options",n=>!0,n=>n)],new $.$sQ("A promise that resolves to an array of TextEdits.",D(a.TextEdit.to))),new $.$tQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$rQ.Uri,$.$rQ.Position,new $.$rQ("ch","Trigger character",n=>typeof n=="string",n=>n),new $.$rQ("options","Formatting options",n=>!0,n=>n)],new $.$sQ("A promise that resolves to an array of TextEdits.",D(a.TextEdit.to))),new $.$tQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new $.$tQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new $.$tQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new $.$tQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new $.$tQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of Location-instances.",D(a.location.to))),new $.$tQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of Hover-instances.",D(a.Hover.to))),new $.$tQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$rQ.Uri,new $.$rQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>R.$yN.isPosition(o)),n=>n.map(a.Position.from))],new $.$sQ("A promise that resolves to an array of ranges.",n=>n.map(o=>{let s;for(const l of o.reverse())s=new R.$WN(a.Range.to(l),s);return s}))),new $.$tQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$rQ.String.with("query","Search string")],new $.$sQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new $.$tQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(a.CallHierarchyItem.to))),new $.$tQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$rQ.CallHierarchyItem],new $.$sQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(a.CallHierarchyIncomingCall.to))),new $.$tQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$rQ.CallHierarchyItem],new $.$sQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(a.CallHierarchyOutgoingCall.to))),new $.$tQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:a.Range.to(n.range),placeholder:n.text}})),new $.$tQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$rQ.Uri,$.$rQ.Position,$.$rQ.String.with("newName","The new symbol name")],new $.$sQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new $.$tQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$rQ.Uri,$.$rQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$sQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new $.$tQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$rQ.Uri],new $.$sQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$SO(n.tokenTypes,n.tokenModifiers)})),new $.$tQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$rQ.Uri],new $.$sQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$Edb)(n);if(o.type==="full")return new R.$UO(o.data,void 0)})),new $.$tQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$rQ.Uri,$.$rQ.Range.optional()],new $.$sQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$SO(n.tokenTypes,n.tokenModifiers)})),new $.$tQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$rQ.Uri,$.$rQ.Range],new $.$sQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$Edb)(n);if(o.type==="full")return new R.$UO(o.data,void 0)})),new $.$tQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$rQ.Uri,$.$rQ.Position,$.$rQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$rQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$sQ("A promise that resolves to a CompletionList-instance.",(n,o,s)=>{if(!n)return new R.$9N([]);const l=n.suggestions.map(i=>a.CompletionItem.to(i,s));return new R.$9N(l,n.incomplete)})),new $.$tQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$rQ.Uri,$.$rQ.Position,$.$rQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$sQ("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new $.$tQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$rQ.Uri,$.$rQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$sQ("A promise that resolves to an array of CodeLens-instances.",(n,o,s)=>D(l=>new R.$1N(a.Range.to(l.range),l.command&&s.fromInternal(l.command)))(n))),new $.$tQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$rQ.Uri,new $.$rQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>R.$zN.isRange(n),n=>R.$AN.isSelection(n)?a.Selection.from(n):a.Range.from(n)),$.$rQ.String.with("kind","Code action kind to return code actions for").optional(),$.$rQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$sQ("A promise that resolves to an array of Command-instances.",(n,o,s)=>D(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(l.command)}else{const i=new R.$UN(l.title,l.kind?new R.$VN(l.kind):void 0);return l.edit&&(i.edit=a.WorkspaceEdit.to(l.edit)),l.command&&(i.command=s.fromInternal(l.command)),i.isPreferred=l.isPreferred,i}})(n))),new $.$tQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$rQ.Uri],new $.$sQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new R.$cO(a.Range.to(o.range),a.Color.to(o.color))):[])),new $.$tQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$rQ("color","The color to show and insert",n=>n instanceof R.$bO,a.Color.from),new $.$rQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new $.$sQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new $.$tQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$rQ.Uri,$.$rQ.Range],new $.$sQ("A promise that resolves to an array of Inlay objects",(n,o,s)=>n.map(a.InlayHint.to.bind(void 0,s)))),new $.$tQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$rQ.Uri],new $.$sQ("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(a.FoldingRange.to)})),new $.$tQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$sQ("A promise that resolves to an array of NotebookContentProvider static info objects.",D(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>a.NotebookExclusiveDocumentPattern.to(o))})))),new $.$tQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$rQ.Uri,$.$rQ.Range,new $.$rQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof R.$zN,n=>a.InlineValueContext.from(n))],new $.$sQ("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new $.$tQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$rQ("uriOrString","Uri-instance or string (only http/https)",n=>I.URI.isUri(n)||typeof n=="string"&&(0,P.$Mg)(n,P.Schemas.http,P.Schemas.https),n=>n),new $.$rQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),$.$rQ.String.with("label","").optional()],$.$sQ.Void),new $.$tQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$rQ.Uri.with("resource","Resource to open"),$.$rQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$rQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],$.$sQ.Void),new $.$tQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$rQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$rQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$rQ.String.with("title","Human readable title for the diff editor").optional(),new $.$rQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],$.$sQ.Void),new $.$tQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$rQ.String.with("title","Human readable title for the changes editor"),new $.$rQ("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[s,l,i]=o;if(!I.URI.isUri(s)||!I.URI.isUri(l)&&l!==void 0&&l!==null||!I.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],$.$sQ.Void),new $.$tQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$rQ.Uri,$.$rQ.Position],new $.$sQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new $.$tQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$rQ.TypeHierarchyItem],new $.$sQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new $.$tQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$rQ.TypeHierarchyItem],new $.$sQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new $.$tQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$rQ.TestItem],$.$sQ.Void),new $.$tQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$rQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$sQ.Void),new $.$tQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$rQ.String.with("name","The context key name"),new $.$rQ("value","The context key value",()=>!0,n=>n)],$.$sQ.Void),new $.$tQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$rQ.Uri,$.$rQ.StringArray,new $.$rQ("MappedEditsContext","Mapped Edits Context",n=>a.MappedEditsContext.is(n),n=>a.MappedEditsContext.from(n))],new $.$sQ("A promise that resolves to a workspace edit or null",n=>n?a.WorkspaceEdit.to(n):null)),new $.$tQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$rQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?a.Range.from(n.initialRange):void 0,initialSelection:R.$AN.isSelection(n.initialSelection)?a.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?a.Position.from(n.position):void 0}})],$.$sQ.Void)];class c{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",T.$Bj)}}e.$Boc=c;function D(n){return o=>{if(Array.isArray(o))return o.map(n)}}function f(n){if(!Array.isArray(n))return;const o=[];for(const s of n)O.$Iu(s)?o.push(a.DefinitionLink.to(s)):o.push(a.location.to(s));return o}}),define(Oe[256],Ne([1,0,2,33]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0;class I{constructor(A,T,$,a,R){this.a=T,this.b=$,this.c=a;const y=new P.$tQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.$rQ("showOptions","Show Options",c=>!0,c=>c),new P.$rQ("resource","Interactive resource Uri",c=>!0,c=>c),new P.$rQ("controllerId","Notebook controller Id",c=>!0,c=>c),new P.$rQ("title","Interactive editor title",c=>!0,c=>c)],new P.$sQ("Notebook and input URI",c=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const D=this.a.getEditorById(c.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:v.URI.revive(c.notebookUri),inputUri:v.URI.revive(c.inputUri),notebookEditor:D.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:v.URI.revive(c.notebookUri),inputUri:v.URI.revive(c.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,$,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$3pc=I}),define(Oe[257],Ne([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,196,24,38,197]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=void 0,e.$_pc=h,D=qe(D);let r=class{constructor(S,w,k,C,d){this.m=w,this.n=k,this.o=C,this.q=d,this.b=new T.$zc,this.c=new T.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(y.$vN.MainThreadNotebookKernels);const b=new c.$tQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.$rQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const M=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:M}}else if(N&&"notebookEditor"in N){const M=this.n.getIdByEditor(N.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return N})],c.$sQ.Void),F=new c.$tQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[c.$rQ.Uri],new c.$sQ("A promise that resolves to an array of variables",(N,M)=>N.map(V=>({variable:{name:V.name,value:V.value,expression:V.expression,type:V.type,language:V.language},hasNamedChildren:V.hasNamedChildren,indexedChildrenCount:V.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(F)}createNotebookController(S,w,k,C,d,b){for(const oe of this.j.values())if(oe.controller.id===w&&a.$on.equals(S.identifier,oe.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${S.identifier.value}, ${w}`);const M=()=>console.warn(`NO execute handler from notebook controller '${Y.id}' of extension: '${S.identifier}'`);let V=!1;const W=new O.$je,L=new O.$je,Y={id:h(S.identifier,w),notebookType:k,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:C||S.identifier.value,preloads:b?b.map(D.NotebookRendererScript.from):[]};let Z=d??M,ge,_;this.a.$addKernel(F,Y).catch(oe=>{console.log(oe),V=!0});let fe=0;const se=()=>{if(V)return;const oe=++fe;Promise.resolve().then(()=>{oe===fe&&this.a.$updateKernel(F,Y)})},ce=new T.$zc,$e={get id(){return w},get notebookType(){return Y.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return Y.label},set label(oe){Y.label=oe??S.displayName??S.name,se()},get detail(){return Y.detail??""},set detail(oe){Y.detail=oe,se()},get description(){return Y.description??""},set description(oe){Y.description=oe,se()},get supportedLanguages(){return Y.supportedLanguages},set supportedLanguages(oe){Y.supportedLanguages=oe,se()},get supportsExecutionOrder(){return Y.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){Y.supportsExecutionOrder=oe,se()},get rendererScripts(){return Y.preloads?Y.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(oe){Z=oe??M},get interruptHandler(){return ge},set interruptHandler(oe){ge=oe,Y.supportsInterrupt=!!oe,se()},set variableProvider(oe){(0,s.$8G)(S,"notebookVariableProvider"),_=oe,Y.hasVariableProvider=!!oe,oe?.onDidChangeVariables(Ce=>N.a.$variablesUpdated(Ce.uri)),se()},get variableProvider(){return _},createNotebookCellExecution(oe){if(V)throw new Error("notebook controller is DISPOSED");if(!ce.has(oe.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,h(S.identifier,this.id))},createNotebookExecution(oe){if((0,s.$8G)(S,"notebookExecution"),V)throw new Error("notebook controller is DISPOSED");if(!ce.has(oe.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return N._createNotebookExecution(oe,h(S.identifier,this.id))},dispose:()=>{V||(this.q.trace(`NotebookController[${F}], DISPOSED`),V=!0,this.j.delete(F),W.dispose(),L.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(oe,Ce){Ce===f.NotebookControllerAffinity2.Hidden&&(0,s.$8G)(S,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,oe.uri,Ce)},onDidReceiveMessage:L.event,postMessage(oe,Ce){return(0,s.$8G)(S,"notebookMessaging"),N.a.$postMessage(F,Ce&&N.n.getIdByEditor(Ce),oe)},asWebviewUri(oe){return(0,s.$8G)(S,"notebookMessaging"),(0,n.$gDb)(oe,N.m.remote)}};return this.j.set(F,{extensionId:S.identifier,controller:$e,onDidReceiveMessage:L,onDidChangeSelection:W,associatedNotebooks:ce}),$e}getIdByController(S){for(const[w,k]of this.j)if(k.controller===S)return h(k.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,w){const k=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(k,w);const d={dispose:()=>{this.f.delete(k),C.a.$removeKernelDetectionTask(k)}};return this.f.set(k,d),d}registerKernelSourceActionProvider(S,w,k){const C=this.i++,d=typeof k.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,b=this;this.h.set(C,k),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,w);let F;return d!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(d))),{dispose:()=>{this.h.delete(C),b.a.$removeKernelSourceActionProvider(C,C),F?.dispose()}}}async $provideKernelSourceActions(S,w){const k=this.h.get(S);if(k){const C=new A.$Sc;return(await k.provideNotebookKernelSourceActions(w)??[]).map(b=>D.NotebookKernelSourceAction.from(b,this.o.converter,C))}return[]}$acceptNotebookAssociation(S,w,k){const C=this.j.get(S);if(C){const d=this.n.getNotebookDocument($.URI.revive(w));k?C.associatedNotebooks.set(d.uri,!0):C.associatedNotebooks.delete(d.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,d.uri.toString(),k),C.onDidChangeSelection.fire({selected:k,notebook:d.apiNotebook})}}async $executeCells(S,w,k){const C=this.j.get(S);if(!C)return;const d=this.n.getNotebookDocument($.URI.revive(w)),b=[];for(const F of k){const N=d.getCell(F);N&&b.push(N.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,d.uri.toString(),b.length),await C.controller.executeHandler.call(C.controller,b,d.apiNotebook,C.controller)}catch(F){this.q.error(`NotebookController[${S}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(S,w,k){const C=this.j.get(S);if(!C)return;const d=this.n.getNotebookDocument($.URI.revive(w));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,d.apiNotebook);else for(const b of k){const F=d.getCell(b);F&&this.b.get(F.uri)?.cancel()}if(C.controller.interruptHandler){const b=this.c.get(d.uri);this.c.delete(d.uri),k.length&&Array.isArray(b)&&b.length&&b.forEach(F=>F.dispose())}}async $provideVariables(S,w,k,C,d,b,F){const N=this.j.get(S);if(!N)return;const M=this.n.getNotebookDocument($.URI.revive(k)),V=N.controller.variableProvider;if(!V)return;let W;if(C!==void 0){if(W=this.s[C],!W)return}else this.s={};const L=d==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,Y=V.provideVariables(M.apiNotebook,W,L,b,F);let Z=0;for await(const ge of Y){if(F.isCancellationRequested)return;const _={id:this.r++,name:ge.variable.name,value:ge.variable.value,type:ge.variable.type,interfaces:ge.variable.interfaces,language:ge.variable.language,expression:ge.variable.expression,hasNamedChildren:ge.hasNamedChildren,indexedChildrenCount:ge.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[_.id]=ge.variable,this.a.$receiveVariable(w,_),Z++>=i.$NK)return}}$acceptKernelMessageFromRenderer(S,w,k){const C=this.j.get(S);if(!C)return;const d=this.n.getEditorById(w);C.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:k}))}$cellExecutionChanged(S,w,k){const d=this.n.getNotebookDocument($.URI.revive(S)).getCell(w);if(d){const b=k?D.NotebookCellExecutionState.to(k):f.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:d.apiCell,state:b})}}_createNotebookCellExecution(S,w){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const d=new g(w,C,this.a);this.b.set(C.uri,d);const b=d.onDidChangeState(()=>{d.state===t.Resolved&&(d.dispose(),b.dispose(),this.b.delete(C.uri))});return d.asApiObject()}_createNotebookExecution(S,w){const k=this.n.getNotebookDocument(S.uri),C=S.getCells().find(F=>{const N=k.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const d=new p(w,k,this.a),b=d.onDidChangeState(()=>{d.state===u.Resolved&&(d.dispose(),b.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[d,b]),d.asApiObject()}};e.$$pc=r,e.$$pc=r=He([Ve(4,R.$0j)],r);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class g extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(S,w,k){super(),this.m=w,this.n=k,this.b=g.a++,this.c=new O.$je,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new I.$ue),this.h=new m(10,C=>this.s(C)),this.j=w.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const w=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new l.$Uw(w))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let w=this.m;if(S&&(w=this.m.notebook.getCellFromApiCell(S)),!w)throw new Error("INVALID cell");return w.handle}y(S){return S.map(w=>{const k=f.$6O.ensureUniqueMimeTypes(w.items,!0);return k===w.items?D.NotebookCellOutput.from(w):D.NotebookCellOutput.from({items:k,id:w.id,metadata:w.metadata})})}async z(S,w,k){const C=this.w(w),d=this.y((0,v.$1b)(S));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:C,append:k,outputs:d})}async C(S,w,k){return S=f.$6O.ensureUniqueMimeTypes((0,v.$1b)(S),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:S.map(D.NotebookCellOutputItem.from),outputId:w.id,append:k})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(k){S.j=k,S.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(k){if(S.f===t.Resolved||S.f===t.Started)throw new Error("Cannot call start again");S.f=t.Started,S.c.fire(),S.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,C,d){if(S.f===t.Resolved)throw new Error("Cannot call resolve twice");S.f=t.Resolved,S.c.fire(),S.h.flush();const b=d?{message:d.message,stack:d.stack,location:d?.location?{startLineNumber:d.location.start.line,startColumn:d.location.start.character,endLineNumber:d.location.end.line,endColumn:d.location.end.character}:void 0,uri:d.uri}:void 0;S.n.$completeExecution(S.b,new l.$Uw({runEndTime:C,lastRunSuccess:k,error:b}))},clearOutput(k){return S.t(),S.z([],k,!1)},appendOutput(k,C){return S.t(),S.z(k,C,!0)},replaceOutput(k,C){return S.t(),S.z(k,C,!1)},appendOutputItems(k,C){return S.t(),S.C(k,C,!0)},replaceOutputItems(k,C){return S.t(),S.C(k,C,!1)}})}}var u;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(u||(u={}));class p extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(S,w,k){super(),this.h=w,this.j=k,this.b=p.a++,this.c=new O.$je,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new I.$ue),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(S,w){this.f=S,this.g=w,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new P.$Zh,this.b=Date.now(),(0,P.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const w=this.a;return this.a=[],this.g(w).finally(()=>S.complete())}}function h(E,S){return`${E.value}/${S}`}}),define(Oe[56],Ne([1,0,6,5,3,2,16,4,7,9,13,178,21,37,179,180,34,10,8,33,36]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=e.$fpc=e.$epc=e.$dpc=void 0,e.$dpc=(0,I.$Ci)("IExtHostTerminalService");class t extends T.$Tc{constructor(d,b,F,N){super(),this.u=d,this._id=b,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const M=this;this.value={get name(){return M.y||""},get processId(){return M.b},get creationOptions(){return M.w},get exitStatus(){return M.j},get state(){return M.m},get selection(){return M.n},get shellIntegration(){return M.shellIntegration},sendText(V,W=!0){M.C(),M.u.$sendText(M._id,V,W)},show(V){M.C(),M.u.$show(M._id,V)},hide(){M.C(),M.u.$hide(M._id)},dispose(){M.a||(M.a=!0,M.u.$dispose(M._id))},get dimensions(){if(!(M.f===void 0||M.h===void 0))return{columns:M.f,rows:M.h}}}}dispose(){this.s.fire(),super.dispose()}async create(d,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??b?.cwd??void 0,env:d.env??void 0,icon:S(d.iconPath)??void 0,color:o.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(d.location,b?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,b,F,N,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:o.ThemeColor.isThemeColor(M)?M.id:void 0,location:b?.location||this.z(d,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(d,b){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in d?{viewColumn:l.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.y=d}setExitStatus(d,b){this.j=Object.freeze({code:d,reason:b})}setDimensions(d,b){return d===this.f&&b===this.h||d===0||b===0?!1:(this.f=d,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(d){this.n=d}_setProcessId(d){this.g?(this.g(d),this.g=void 0):this.b.then(b=>{b!==d&&(this.b=Promise.resolve(d))})}}e.$epc=t;class g{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new v.$je,this.onProcessData=this.a.event,this.b=new v.$je,this.d=new v.$je,this.onDidChangeProperty=this.d.event,this.f=new v.$je,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,b){this.g.setDimensions?.({columns:d,rows:b})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:f.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:f.ProcessPropertyType.Title,value:b})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,p=class extends T.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,b,F){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$je,this.onDidCloseTerminal=this.H.event,this.I=new v.$je,this.onDidOpenTerminal=this.I.event,this.J=new v.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$je,this.onDidChangeTerminalState=this.M.event,this.N=new v.$je,this.onDidChangeShell=this.N.event,this.O=new v.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(P.$vN.MainThreadTerminalService),this.y=new n.$xxb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:N=>{const M=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(N?.$mid){case r.MarshalledId.TerminalContext:return M(N);default:{if(Array.isArray(N))for(let V=0;V<N.length&&N[V].$mid===r.MarshalledId.TerminalContext;V++)N[V]=M(N[V]);return N}}}}),this.B({dispose:()=>{for(const[N,M]of this.g)M.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,b){const F=new t(this.a,(0,D.$Yg)(),d,d.name),N=new g(d.pty);return F.createExtensionTerminal(d.location,b,this.R(d,b).resolvedExtHostIdentifier,S(d.iconPath),w(d.color)).then(M=>{const V=this.S(M,N);this.h[M]=V}),this.f.push(F),F.value}R(d,b){if(b=b||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const F=d.location.parentTerminal;if(F){const N=this.f.find(M=>M.value===F);N&&(b.resolvedExtHostIdentifier=N._id)}}else d.location&&typeof d.location!="object"?b.location=d.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(d,b){if(!this.getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const N=new g(b),M=this.S(d,N);this.h[d]=M}async $acceptActiveTerminalChanged(d){const b=this.b;if(d===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(d);F&&(this.b=F,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,b){const F=this.getTerminalById(d);F&&this.O.fire({terminal:F.value,data:b})}async $acceptTerminalDimensions(d,b,F){const N=this.getTerminalById(d);N&&N.setDimensions(b,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(d,b){const F=this.getTerminalById(d);F&&this.P.fire({terminal:F.value,...b})}async $acceptTerminalMaximumDimensions(d,b,F){this.g.get(d)?.resize(b,F)}async $acceptTerminalTitleChange(d,b){const F=this.getTerminalById(d);F&&(F.name=b)}async $acceptTerminalClosed(d,b,F){const N=this.X(this.f,d);if(N!==null){const M=this.f.splice(N,1)[0];M.setExitStatus(b,F),this.H.fire(M.value)}}$acceptTerminalOpened(d,b,F,N){if(b){const W=this.X(this.f,b);if(W!==null){this.f[W]._id=d,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const M={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},V=new t(this.a,d,M,F);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(d,b){this.getTerminalById(d)?._setProcessId(b)}async $startExtensionTerminal(d,b){const F=this.getTerminalById(d);if(!F)return{message:(0,a.localize)(10663,null,d)};F.isOpen||await new Promise(M=>{const V=this.onDidOpenTerminal(async W=>{W===F.value&&(V.dispose(),M())})});const N=this.g.get(d);N?N.startSendingEvents(b):this.j[d]={initialDimensions:b}}S(d,b){const F=new T.$Sc;F.add(b.onProcessReady(M=>this.a.$sendProcessReady(d,M.pid,M.cwd,M.windowsPty))),F.add(b.onDidChangeProperty(M=>this.a.$sendProcessProperty(d,M))),this.y.startBuffering(d,b.onProcessData),F.add(b.onProcessExit(M=>this.U(d,M))),this.g.set(d,b);const N=this.j[d];return N&&b instanceof g&&(b.startSendingEvents(N.initialDimensions),delete this.j[d]),F}$acceptProcessAckDataEvent(d,b){this.g.get(d)?.acknowledgeDataEvent(b)}$acceptProcessInput(d,b){this.g.get(d)?.input(b)}$acceptTerminalInteraction(d){const b=this.getTerminalById(d);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(d,b){this.getTerminalById(d)?.setSelection(b)}$acceptProcessResize(d,b,F){try{this.g.get(d)?.resize(b,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(d,b){this.g.get(d)?.shutdown(b)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(d,{type:f.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(b=>this.a.$sendProcessProperty(d,{type:f.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new $.$xN(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,b,F){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,F),this.a.$registerProfileProvider(b,d.identifier.value),new $.$xN(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(d,b,F){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,F),this.a.$registerQuickFixProvider(d,b),new $.$xN(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,b){const F=new c.$ue().token;if(F.isCancellationRequested)return;const N=this.D.get(d);if(!N)return;const M=await N.provideTerminalQuickFixes(b,F);if(M===null||Array.isArray(M)&&M.length===0)return;const V=new T.$Sc;if(this.w.value=V,!Array.isArray(M))return M?l.TerminalQuickFix.from(M,this.Q.converter,V):void 0;const W=[];for(const L of M){const Y=l.TerminalQuickFix.from(L,this.Q.converter,V);Y&&W.push(Y)}return W}async $createContributedProfileTerminal(d,b){const F=new c.$ue().token;let N=await this.C.get(d)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,b);return}this.createTerminalFromOptions(N.options,b)}}async $provideLinks(d,b){const F=this.getTerminalById(d);if(!F)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const M=new c.$ue;this.G.set(d,M);const V=[],W={terminal:F.value,line:b},L=[];for(const ge of this.z)L.push(s.Promises.withAsyncBody(async _=>{M.token.onCancellationRequested(()=>_({provider:ge,links:[]}));const fe=await ge.provideTerminalLinks(W,M.token)||[];M.token.isCancellationRequested||_({provider:ge,links:fe})}));const Y=await Promise.all(L);if(M.token.isCancellationRequested)return[];const Z=new Map;for(const ge of Y)ge&&ge.links.length>0&&V.push(...ge.links.map(_=>{const fe={id:u++,startIndex:_.startIndex,length:_.length,label:_.tooltip};return Z.set(fe.id,{provider:ge.provider,link:_}),fe}));return this.F.set(d,Z),V}$activateLink(d,b){const F=this.F.get(d)?.get(b);F&&F.provider.handleTerminalLink(F.link)}U(d,b){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const F=this.h[d];F&&(F.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,b)}getTerminalById(d){return this.W(this.f,d)}getTerminalIdByApiObject(d){const b=this.f.findIndex(F=>F.value===d);return b>=0?b:null}W(d,b){const F=this.X(d,b);return F!==null?d[F]:null}X(d,b){const F=d.findIndex(N=>N._id===b);return F>=0?F:null}getEnvironmentVariableCollection(d){let b=this.n.get(d.identifier.value);return b||(b=this.B(new m),this.Z(d.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(d,b){const F=(0,y.$Cs)(b.map),N=(0,y.$Ds)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(d,b.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(d){d.forEach(b=>{const F=b[0],N=this.B(new m(b[1]));this.Z(F,N)})}$acceptDefaultProfile(d,b){const F=this.s;this.s=d,this.u=b,F?.path!==d.path&&this.N.fire(d.path)}Z(d,b){this.n.set(d,b),this.B(b.onDidChangeCollection(()=>{this.Y(d,b)}))}};e.$fpc=p,e.$fpc=p=He([Ve(1,i.$pQ),Ve(2,A.$6P)],p);class m extends T.$Tc{get persistent(){return this.b}set persistent(d){this.b=d,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(d){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$je,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const b=this.j(d);let F=this.a.get(b);return F||(F=new h(this,d),this.a.set(b,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(d,b,F,N){this.g(d,{value:b,type:$.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(d,b,F,N){this.g(d,{value:b,type:$.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(d,b,F,N){this.g(d,{value:b,type:$.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(d,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(d,b.scope),N=this.map.get(F),M=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==b.value||N.type!==b.type||N.options?.applyAtProcessCreation!==M.applyAtProcessCreation||N.options?.applyAtShellIntegration!==M.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const V=this.h(d,b.scope),W={variable:d,...b,options:M};this.map.set(V,W),this.f.fire()}}get(d,b){const F=this.h(d,b),N=this.map.get(F);return N?k(N):void 0}h(d,b){const F=this.j(b);return F.length?`${d}:::${F}`:d}j(d){return this.m(d?.workspaceFolder)??""}m(d){return d?d.uri.toString():void 0}getVariableMap(d){const b=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(d)&&b.set(N.variable,k(N));return b}delete(d,b){const F=this.h(d,b);this.map.delete(F),this.f.fire()}clear(d){if(d?.workspaceFolder){for(const[b,F]of this.map)F.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(b);this.n(d)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(d,b){const F=this.j(b),N=this.descriptionMap.get(F);if(!N||N.description!==d){let M;typeof d=="string"?M=d:M=d?.value.split(`

`)[0];const V={description:M,scope:b};this.descriptionMap.set(F,V),this.f.fire()}}getDescription(d){const b=this.j(d);return this.descriptionMap.get(b)?.description}n(d){const b=this.j(d);this.descriptionMap.delete(b)}}class h{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,b){this.b=d,this.d=b,this.a=new v.$je}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,b,F){this.b.replace(d,b,F,this.d)}append(d,b,F){this.b.append(d,b,F,this.d)}prepend(d,b,F){this.b.prepend(d,b,F,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,b){this.b.getVariableMap(this.d).forEach((F,N)=>d.call(b,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends p{constructor(d,b){super(!1,d,b)}createTerminal(d,b,F){throw new R.$$}createTerminalFromOptions(d,b){throw new R.$$}};e.$gpc=E,e.$gpc=E=He([Ve(0,i.$pQ),Ve(1,A.$6P)],E);function S(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function w(C){return o.ThemeColor.isThemeColor(C)?C:void 0}function k(C){const d={...C};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Oe[126],Ne([1,0,7,4,3,5,16,56,6,2,10]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=void 0,e.$qqc=(0,I.$Ci)("IExtHostTerminalShellIntegration");let y=class extends P.$Tc{constructor(o,s){super(),this.h=s,this.b=new Map,this.c=new $.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$vN.MainThreadTerminalShellIntegration),this.B((0,P.$Rc)(()=>{for(const[l,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(o){const s=this.h.getTerminalById(o);if(!s)return;const l=s.value;let i=this.b.get(o);i||(i=new c(s.value,this.f),this.b.set(o,i),i.store.add(s.onWillDispose(()=>this.b.get(o)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(o,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),s.shellIntegration=i.value),this.c.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(o,s,l,i,r){this.b.has(o)||this.$shellIntegrationChange(o);const t={value:s,confidence:l,isTrusted:i};this.b.get(o)?.startShellExecution(t,r)}$shellExecutionEnd(o,s,l,i,r){const t={value:s,confidence:l,isTrusted:i};this.b.get(o)?.endShellExecution(t,r)}$shellExecutionData(o,s){this.b.get(o)?.emitData(s)}$cwdChange(o,s){this.b.get(o)?.setCwd((0,a.$uc)(s)?a.URI.revive(s):s)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$rqc=y,e.$rqc=y=He([Ve(0,A.$6P),Ve(1,T.$dpc)],y);class c extends P.$Tc{get currentExecution(){return this.a}constructor(o,s){super(),this.j=o,this.m=s,this.b=!1,this.store=this.B(new P.$Sc),this.f=this.B(new $.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$je),this.onDidRequestEndExecution=this.h.event;const l=this;this.value={get cwd(){return l.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(p=>`${p.replaceAll('"','\\"')}`).join('" "')}"`),l.g.fire(t);const g={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=l.startShellExecution(g,l.c,!0).value;return l.b=!0,u}}}startShellExecution(o,s,l){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new D(o,s);l?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,s){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:s}),this.a=void 0)}setCwd(o){let s=!1;a.URI.isUri(this.c)?s=!a.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(s=!0),s&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class D{constructor(o,s){this.c=o,this.cwd=s,this.b=!1;const l=this;this.value={get commandLine(){return l.c},get cwd(){return l.cwd},read(){return l.d()}}}d(){if(!this.a){if(this.b)return R.$3h.EMPTY;this.a=new f}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends P.$Tc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Bh);const o=this.a;return new R.$3h(async l=>{this.b.push(l),await o.wait()})}emitData(o){for(const s of this.b)s.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Oe[127],Ne([1,0,61,13,96,8,7]),function(we,e,v,P,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=e.$bQ=e.$aQ=void 0,O=qe(O);class T{static{this.c=new I.$$P("TextEditorDecorationType")}constructor(c,D,f){const n=T.c.nextId();c.$registerTextEditorDecorationType(D.identifier,n,O.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:n,dispose(){c.$removeTextEditorDecorationType(n)}})}}e.$aQ=T;class ${constructor(c,D){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,D){this.k();let f=null;if(c instanceof A.$yN)f=new A.$zN(c,c);else if(c instanceof A.$zN)f=c;else throw new Error("Unrecognized location");this.l(f,D,!1)}insert(c,D){this.k(),this.l(new A.$zN(c,c),D,!0)}delete(c){this.k();let D=null;if(c instanceof A.$zN)D=c;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(c,D,f){const n=this.c.validateRange(c);this.g.push({range:n,text:D,forceMoveMarkers:f})}setEndOfLine(c){if(this.k(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,P.$6)("endOfLine");this.h=c}}class a{constructor(c,D,f,n){this.c=c,this.d=D,this._accept(f),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.originalIndentSize,this.j=c.insertSpaces,this.k=c.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(c.lineNumbers)}m(c){if(c==="auto")return"auto";if(typeof c=="number"){const D=Math.floor(c);return D>0?D:null}if(typeof c=="string"){const D=parseInt(c,10);return isNaN(D)?null:D>0?D:null}return null}n(c){const D=this.m(c);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}o(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const D=Math.floor(c);return D>0?D:null}if(typeof c=="string"){const D=parseInt(c,10);return isNaN(D)?null:D>0?D:null}return null}p(c){const D=this.o(c);if(D!==null){if(typeof D=="number"){if(this.h===D)return;this.g=D,this.h=D}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}q(c){return c==="auto"?"auto":c==="false"?!1:!!c}s(c){const D=this.q(c);if(typeof D=="boolean"){if(this.j===D)return;this.j=D}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}t(c){this.k!==c&&(this.k=c,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}u(c){this.l!==c&&(this.l=c,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(c)})))}assign(c){const D={};let f=!1;if(typeof c.tabSize<"u"){const n=this.m(c.tabSize);n==="auto"?(f=!0,D.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,f=!0,D.tabSize=n)}if(typeof c.indentSize<"u"){const n=this.o(c.indentSize);n==="tabSize"?(f=!0,D.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,f=!0,D.indentSize=n)}if(typeof c.insertSpaces<"u"){const n=this.q(c.insertSpaces);n==="auto"?(f=!0,D.insertSpaces=n):this.j!==n&&(this.j=n,f=!0,D.insertSpaces=n)}typeof c.cursorStyle<"u"&&this.k!==c.cursorStyle&&(this.k=c.cursorStyle,f=!0,D.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.l!==c.lineNumbers&&(this.l=c.lineNumbers,f=!0,D.lineNumbers=O.TextEditorLineNumbersStyle.from(c.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,D))}v(c,D){D.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn(f)})}}e.$bQ=a;class R{constructor(c,D,f,n,o,s,l,i){this.id=c,this.j=D,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new a(this.j,this.id,s,f),this.e=l,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new P.$8("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof A.$AN))throw(0,P.$6)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof A.$AN)))throw(0,P.$6)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new P.$8("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new P.$8("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(n.value,g);return t(u),r.m(u)},insertSnippet(t,g,u={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let p;if(!g||Array.isArray(g)&&g.length===0)p=r.c.map(m=>O.Range.from(m));else if(g instanceof A.$yN){const{lineNumber:m,column:h}=O.Position.from(g);p=[{startLineNumber:m,startColumn:h,endLineNumber:m,endColumn:h}]}else if(g instanceof A.$zN)p=[O.Range.from(g)];else{p=[];for(const m of g)if(m instanceof A.$zN)p.push(O.Range.from(m));else{const{lineNumber:h,column:E}=O.Position.from(m);p.push({startLineNumber:h,startColumn:E,endLineNumber:h,endColumn:E})}}return D.$tryInsertSnippet(c,n.value.version,t.value,p,u)},setDecorations(t,g){const u=g.length===0;u&&!r.h.has(t.key)||(u?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(O.$3P(g))return D.$trySetDecorations(c,t.key,O.$4P(g));{const p=new Array(4*g.length);for(let m=0,h=g.length;m<h;m++){const E=g[m];p[4*m]=E.start.line+1,p[4*m+1]=E.start.character+1,p[4*m+2]=E.end.line+1,p[4*m+3]=E.end.character+1}return D.$trySetDecorationsFast(c,t.key,p)}}))},revealRange(t,g){r.n(()=>D.$tryRevealRange(c,O.Range.from(t),g||A.TextEditorRevealType.Default))},show(t){D.$tryShowEditor(c,O.ViewColumn.from(t))},hide(){D.$tryHideEditor(c)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,v.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,v.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,v.ok)(!this.g),this.f=c}_acceptSelections(c){(0,v.ok)(!this.g),this.c=c}async l(){const c=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const D=c.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const f=D.edits.map(o=>o.range);f.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=f.length-1;o<s;o++){const l=f[o].end;if(f[o+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=D.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,n,{setEndOfLine:typeof D.setEndOfLine=="number"?O.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.$cQ=R}),define(Oe[57],Ne([1,0,61,6,4,2,3,5,123,16,127,8,11,28,15,39,48]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=void 0,v=qe(v),y=qe(y);class s{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new D.$zc,this.d=new P.$je,this.e=new P.$je,this.f=new P.$je,this.g=new P.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],g=[],u=[];if(r.removedDocuments)for(const p of r.removedDocuments){const m=O.URI.revive(p),h=this.c.get(m);h?.unref()&&(this.c.delete(m),t.push(h.value))}if(r.addedDocuments)for(const p of r.addedDocuments){const m=O.URI.revive(p.uri);let h=this.c.get(m);if(h&&m.scheme!==f.Schemas.vscodeNotebookCell&&m.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);h||(h=new s(new $.$9P(this.h.getProxy(T.$vN.MainThreadDocuments),m,p.lines,p.EOL,p.versionId,p.languageId,p.isDirty)),this.c.set(m,h),g.push(h.value)),h.ref()}if(r.removedEditors)for(const p of r.removedEditors){const m=this.b.get(p);this.b.delete(p),m&&u.push(m)}if(r.addedEditors)for(const p of r.addedEditors){const m=O.URI.revive(p.documentUri);v.ok(this.c.has(m),`document '${m}' does not exist`),v.ok(!this.b.has(p.id),`editor '${p.id}' already exists!`);const h=this.c.get(m).value,E=new R.$cQ(p.id,this.h.getProxy(T.$vN.MainThreadTextEditors),this.i,new o.$T(()=>h.document),p.selections.map(y.Selection.to),p.options,p.visibleRanges.map(S=>y.Range.to(S)),typeof p.editorPosition=="number"?y.ViewColumn.to(p.editorPosition):void 0);this.b.set(p.id,E)}r.newActiveEditor!==void 0&&(v.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,I.$Oc)(t),(0,I.$Oc)(u),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(g),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(p=>p.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$dQ=l,e.$dQ=l=He([Ve(0,a.$6P),Ve(1,c.$0j)],l),e.$eQ=(0,A.$Ci)("IExtHostDocumentsAndEditors")}),define(Oe[95],Ne([1,0,10,22,21,6,230,75,4,36,14,37,3,11,5,33,57,16,125,8,7,199,54,81,55,24]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=e.$Apc=e.$zpc=e.$ypc=e.$xpc=void 0,i=qe(i);let h=0;const E=new WeakMap;e.$xpc=(0,c.$Ci)("IExtHostTesting");let S=class extends $.$Tc{constructor(_,fe,se,ce){super(),this.C=fe,this.D=se,this.F=ce,this.f=this.B(new O.$je),this.g=new Map,this.w=this.B(new O.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(f.$vN.MainThreadTesting),this.m=new V(this.h),this.j=new d(this.h,fe),se.registerArgumentProcessor({processArgument:$e=>{switch($e?.$mid){case a.MarshalledId.TestItemContext:{const oe=$e,Ce=oe.tests[oe.tests.length-1].item.extId;return this.g.get(g.$UI.root(Ce))?.collection.tree.get(Ce)?.actual??(0,l.$fQ)($e)}case a.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:Ce}=$e,Le=oe.item.extId;return{test:this.g.get(g.$UI.root(Le))?.collection.tree.get(Le)?.actual??(0,l.$fQ)({$mid:a.MarshalledId.TestItemContext,tests:[oe]}),message:i.TestMessage.to(Ce)}}default:return $e}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const $e=await se.executeCommand(t.TestCommandId.GetExplorerSelection),oe=Ce=>{const Le=this.g.get(g.$UI.root(Ce));if(Le)return g.$UI.isRoot(Ce)?Le.controller:Le.collection.tree.get(Ce)?.actual};return{include:$e?.include.map(oe).filter(R.$kg)||[],exclude:$e?.exclude.map(oe).filter(R.$kg)||[]}})}createTestController(_,fe,se,ce){if(this.g.has(fe))throw new Error(`Attempt to insert a duplicate controller with ID "${fe}"`);const $e=new $.$Sc,oe=$e.add(new l.$iQ(fe,se,this.F));oe.root.label=se;const Ce=new Map,Le=new Set,X=this.h,q={items:oe.root.children,get label(){return se},set label(ve){se=ve,oe.root.label=ve,X.$updateController(fe,{label:se})},get refreshHandler(){return ce},set refreshHandler(ve){ce=ve,X.$updateController(fe,{canRefresh:!!ve})},get id(){return fe},createRunProfile:(ve,ae,be,ue,J,x)=>{let me=(0,T.$qj)(ve);for(;Ce.has(me);)me++;return new L(this.h,Ce,Le,this.w.event,fe,me,ve,ae,be,ue,J,x)},createTestItem(ve,ae,be){return new l.$gQ(fe,ve,ae,be)},createTestRun:(ve,ae,be=!0)=>this.j.createTestRun(_,fe,oe,ve,ae,be),invalidateTestResults:ve=>{if(ve===void 0)this.h.$markTestRetired(void 0);else{const ae=ve instanceof Array?ve:[ve];this.h.$markTestRetired(ae.map(be=>g.$UI.fromExtHostTestItem(be,fe).toString()))}},set resolveHandler(ve){oe.resolveHandler=ve},get resolveHandler(){return oe.resolveHandler},dispose:()=>{$e.dispose()}};X.$registerTestController(fe,se,!!ce),$e.add((0,$.$Rc)(()=>X.$unregisterTestController(fe)));const te={controller:q,collection:oe,profiles:Ce,extension:_,activeProfiles:Le};return this.g.set(fe,te),$e.add((0,$.$Rc)(()=>this.g.delete(fe))),$e.add(oe.onDidGenerateDiff(ve=>X.$publishDiff(fe,ve.map(p.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(_,fe=I.CancellationToken.None){const se=b(_);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(se.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:Y[se.kind],targets:[{testIds:_.include?.map($e=>g.$UI.fromExtHostTestItem($e,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:_.exclude?.map($e=>$e.id)},fe)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,fe,se){return(await this.j.getCoverageDetails(_,fe,se))?.map(i.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,fe){this.g.get(_)?.profiles.get(fe)?.configureHandler?.()}$setDefaultRunProfiles(_){const fe=new Map;for(const[se,ce]of Object.entries(_)){const $e=this.g.get(se);if(!$e)continue;const oe=new Map,Ce=ce.filter(X=>!$e.activeProfiles.has(X)),Le=[...$e.activeProfiles].filter(X=>!ce.includes(X));for(const X of Ce)oe.set(X,!0),$e.activeProfiles.add(X);for(const X of Le)oe.set(X,!1),$e.activeProfiles.delete(X);oe.size&&fe.set(se,oe)}this.w.fire(fe)}async $refreshTests(_,fe){await this.g.get(_)?.controller.refreshHandler?.(fe)}$publishTestResults(_){this.results=Object.freeze(_.map(fe=>{const se=i.TestResults.to(fe);return E.set(se,fe.id),se}).concat(this.results).sort((fe,se)=>se.completedAt-fe.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,fe){const se=this.g.get(g.$UI.fromString(_).controllerId)?.collection;se&&(await se.expand(_,fe<0?1/0:fe),se.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(fe=>p.TestsDiffOp.deserialize({asCanonicalUri:se=>se},fe)))}async $runControllerTests(_,fe){return Promise.all(_.map(se=>this.G(se,!1,fe)))}async $startContinuousRun(_,fe){const se=new I.$ue(fe),ce=await Promise.all(_.map($e=>this.G($e,!0,se.token)));return!fe.isCancellationRequested&&!ce.some($e=>$e.error)&&await new Promise($e=>fe.onCancellationRequested($e)),se.dispose(!0),ce}async $provideTestFollowups(_,fe){const se=this.results.find(oe=>E.get(oe)===_.resultId),ce=se&&Z(g.$UI.fromString(_.extId),se?.results);if(!ce)return[];let $e=[];return await Promise.all([...this.y].map(async oe=>{try{const Ce=await oe.provideFollowup(se,ce,_.taskIndex,_.messageIndex,fe);Ce&&($e=$e.concat(Ce))}catch(Ce){this.C.error("Error thrown while providing followup for test message",Ce)}})),fe.isCancellationRequested?[]:$e.map(oe=>{const Ce=h++;return this.z.set(Ce,oe),{title:oe.title,id:Ce}})}$disposeTestFollowups(_){for(const fe of _)this.z.delete(fe)}$executeTestFollowup(_){const fe=this.z.get(_);return fe?this.D.executeCommand(fe.command,...fe.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_)}getMetadataForRun(_){for(const fe of this.j.trackers){const se=fe.getTaskIdForRun(_);if(se)return{taskId:se,runId:fe.id}}}async G(_,fe,se){const ce=this.g.get(_.controllerId);if(!ce)return{};const{collection:$e,profiles:oe,extension:Ce}=ce,Le=oe.get(_.profileId);if(!Le)return{};const X=_.testIds.map(ae=>$e.tree.get(ae)).filter(R.$kg),q=_.excludeExtIds.map(ae=>ce.collection.tree.get(ae)).filter(R.$kg).filter(ae=>X.some(be=>be.fullId.compare(ae.fullId)===g.TestPosition.IsChild));if(!X.length)return{};const te=new r.$aP(X.some(ae=>ae.actual instanceof l.$hQ)?void 0:X.map(ae=>ae.actual),q.map(ae=>ae.actual),Le,fe),ve=(0,p.$XI)(_)&&this.j.prepareForMainThreadTestRun(Ce,te,F.fromInternal(_,ce.collection),Le,se);try{return await Le.runHandler(te,se),{}}catch(ae){return{error:String(ae)}}finally{ve&&ve.hasRunningTasks&&!se.isCancellationRequested&&await O.Event.toPromise(ve.onEnd)}}};e.$ypc=S,e.$ypc=S=He([Ve(0,s.$6P),Ve(1,D.$0j),Ve(2,n.$pQ),Ve(3,o.$eQ)],S);const w=1e4;var k;(function(ge){ge[ge.Running=0]="Running",ge[ge.Cancelling=1]="Cancelling",ge[ge.Ended=2]="Ended"})(k||(k={}));class C extends $.$Tc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(_,fe,se,ce,$e,oe){super(),this.z=_,this.C=fe,this.D=se,this.F=ce,this.G=$e,this.c=k.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new I.$ue(oe));const Ce=this.B(new v.$Oh(()=>this.H(),w));this.B(this.j.token.onCancellationRequested(()=>Ce.schedule()));const Le=new O.$je;this.w=Le.event,this.B((0,$.$Rc)(()=>{Le.fire(),Le.dispose()}))}getTaskIdForRun(_){for(const[fe,{run:se}]of this.g)if(se===_)return fe}cancel(){this.c===k.Running?(this.j.cancel(),this.c=k.Cancelling):this.c===k.Cancelling&&this.H()}async getCoverageDetails(_,fe,se){const[,ce]=g.$UI.fromString(_).path,$e=this.y.get(_);if(!$e)return[];const{report:oe,extIds:Ce}=$e,Le=this.g.get(ce);if(!Le)throw new Error("unreachable: run task was not found");let X;if(fe&&oe instanceof r.$fP){const te=Ce.indexOf(fe);if(te===-1)return[];X=oe.fromTests[te]}return await(X?this.F?.loadDetailedCoverageForTest?.(Le.run,oe,X,se):this.F?.loadDetailedCoverage?.(Le.run,oe,se))??[]}createRun(_){const fe=this.z.id,se=this.z.controllerId,ce=(0,y.$Yg)(),$e=X=>(q,...te)=>{if(Ce){this.D.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.J(q),X(q,...te)},oe=(X,q)=>{const te=q instanceof Array?q.map(i.TestMessage.from):[i.TestMessage.from(q)];if(X.uri&&X.range){const ve={range:i.Range.from(X.range),uri:X.uri};for(const ae of te)ae.location=ae.location||ve}this.C.$appendTestMessagesInRun(fe,ce,g.$UI.fromExtHostTestItem(X,se).toString(),te)};let Ce=!1;const Le={isPersisted:this.z.isPersisted,token:this.j.token,name:_,onDidDispose:this.w,addCoverage:X=>{if(Ce)return;const q=X instanceof r.$fP?X.fromTests:[];if(q.length){(0,m.$8G)(this.G,"attributableCoverage");for(const ae of q)this.J(ae)}const te=X.uri.toString(),ve=new g.$UI([fe,ce,te]).toString();this.y.set(ve,{report:X,extIds:q.map(ae=>g.$UI.fromExtHostTestItem(ae,se).toString())}),this.C.$appendCoverage(fe,ce,i.TestCoverage.fromFile(se,ve,X))},enqueued:$e(X=>{this.C.$updateTestStateInRun(fe,ce,g.$UI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Queued)}),skipped:$e(X=>{this.C.$updateTestStateInRun(fe,ce,g.$UI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Skipped)}),started:$e(X=>{this.C.$updateTestStateInRun(fe,ce,g.$UI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Running)}),errored:$e((X,q,te)=>{oe(X,q),this.C.$updateTestStateInRun(fe,ce,g.$UI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Errored,te)}),failed:$e((X,q,te)=>{oe(X,q),this.C.$updateTestStateInRun(fe,ce,g.$UI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Failed,te)}),passed:$e((X,q)=>{this.C.$updateTestStateInRun(fe,ce,g.$UI.fromExtHostTestItem(X,this.z.controllerId).toString(),p.TestResultState.Passed,q)}),appendOutput:(X,q,te)=>{Ce||(te&&this.J(te),this.C.$appendOutputToRun(fe,ce,P.$Le.fromString(X),q&&i.location.from(q),te&&g.$UI.fromExtHostTestItem(te,se).toString()))},end:()=>{Ce||(Ce=!0,this.C.$finishedTestRunTask(fe,ce),--this.f||this.I())}};return this.f++,this.g.set(ce,{run:Le}),this.C.$startedTestRunTask(fe,{id:ce,name:_,running:!0}),Le}H(){for(const{run:_}of this.g.values())_.end()}I(){this.c!==k.Ended&&(this.c=k.Ended,this.m.fire())}J(_){if(!(_ instanceof l.$gQ))throw new u.$XP(_.id);if(this.h.has(g.$UI.fromExtHostTestItem(_,this.z.controllerId).toString()))return;const fe=[],se=this.z.colllection.root;for(;;){const ce=i.TestItem.from(_);if(fe.unshift(ce),this.h.has(ce.extId)||(this.h.add(ce.extId),_===se))break;_=_.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,fe)}dispose(){this.I(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(_,fe){this.g=_,this.h=fe,this.c=new Map,this.f=new Map}getCoverageDetails(_,fe,se){const ce=g.$UI.root(_);return this.f.get(ce)?.getCoverageDetails(_,fe,se)||[]}disposeTestRun(_){this.f.get(_)?.dispose(),this.f.delete(_);for(const[fe,{id:se}]of this.c)se===_&&this.c.delete(fe)}prepareForMainThreadTestRun(_,fe,se,ce,$e){return this.j(fe,se,ce,_,$e)}cancelRunById(_){this.f.get(_)?.cancel()}cancelAllRuns(){for(const _ of this.c.values())_.cancel()}createTestRun(_,fe,se,ce,$e,oe){const Ce=this.c.get(ce);if(Ce)return Ce.createRun($e);const Le=F.fromPublic(fe,se,ce,oe),X=b(ce);this.g.$startedExtensionTestRun({controllerId:fe,continuous:!!ce.continuous,profile:X&&{group:Y[X.kind],id:X.profileId},exclude:ce.exclude?.map(te=>g.$UI.fromExtHostTestItem(te,se.root.id).toString())??[],id:Le.id,include:ce.include?.map(te=>g.$UI.fromExtHostTestItem(te,se.root.id).toString())??[se.root.id],preserveFocus:ce.preserveFocus??!0,persist:oe});const q=this.j(ce,Le,ce.profile,_);return O.Event.once(q.onEnd)(()=>{this.g.$finishedExtensionTestRun(Le.id)}),q.createRun($e)}j(_,fe,se,ce,$e){const oe=new C(fe,this.g,this.h,se,ce,$e);return this.c.set(_,oe),this.f.set(oe.id,oe),oe}}e.$zpc=d;const b=ge=>{if(ge.profile){if(!(ge.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ge.profile}};class F{static fromPublic(_,fe,se,ce){return new F(_,(0,y.$Yg)(),ce,fe)}static fromInternal(_,fe){return new F(_.controllerId,_.runId,!0,fe)}constructor(_,fe,se,ce){this.controllerId=_,this.id=fe,this.isPersisted=se,this.colllection=ce}}e.$Apc=F;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(_){this.j=_,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(_){this.c.add(_)}update(_){Object.assign(_.revived,i.TestItem.toPlain(_.item)),this.c.has(_)||this.f.add(_)}remove(_){if(this.c.has(_)){this.c.delete(_);return}this.f.delete(_);const fe=g.$UI.parentId(_.item.extId);if(fe&&this.h.has(fe.toString())){this.h.add(_.item.extId);return}this.g.add(_)}getChangeEvent(){const{c:_,f:fe,g:se}=this;return{get added(){return[..._].map(ce=>ce.revived)},get updated(){return[...fe].map(ce=>ce.revived)},get removed(){return[...se].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class M extends p.$4I{constructor(){super(...arguments),this.y=new O.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(_){return this.f.get(_)}getMirroredTestDataByReference(_){return this.f.get(_.id)}x(_,fe){return{..._,revived:i.TestItem.toPlain(_.item),depth:fe?fe.depth+1:0,children:new Set}}w(){return new N(this.y)}}class V{constructor(_){this.f=_}checkout(){this.c||(this.c=this.g());const _=this.c;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(fe=>fe.revived)},dispose:(0,A.$cb)(()=>{--_.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(_){return this.c?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.c?.tests.apply(_)}g(){const _=new M({asCanonicalUri:fe=>fe});return this.f.$subscribeToDiffs(),{observers:0,tests:_}}}const W=(ge,_,fe,se)=>{fe?Object.assign(fe,se):_.$updateTestRunConfig(ge.controllerId,ge.profileId,se)};class L{#e;#t;#i;#n;#s;get label(){return this.f}set label(_){_!==this.f&&(this.f=_,W(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(_){_!==this.g&&(this.g=_,W(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),W(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,W(this,this.#e,this.#n,{tag:_?i.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.c}set configureHandler(_){_!==this.c&&(this.c=_,W(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return O.Event.chain(this.#i,_=>_.map(fe=>fe.get(this.controllerId)?.get(this.profileId)).filter(R.$kg))}constructor(_,fe,se,ce,$e,oe,Ce,Le,X,q=!1,te=void 0,ve=!1){this.controllerId=$e,this.profileId=oe,this.f=Ce,this.kind=Le,this.runHandler=X,this._tag=te,this.g=ve,this.#e=_,this.#s=fe,this.#t=se,this.#i=ce,fe.set(oe,this);const ae=Y[Le];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Le}`);q&&se.add(oe),this.#n={profileId:oe,controllerId:$e,tag:te?i.TestTag.namespace(this.controllerId,te.id):null,label:Ce,group:ae,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:ve},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Bpc=L;const Y={[r.TestRunProfileKind.Coverage]:p.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:p.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:p.TestRunProfileBitset.Run};function Z(ge,_){for(let fe=0;fe<ge.path.length;fe++){const se=_.find(ce=>ce.id===ge.path[fe]);if(!se)return;if(fe===ge.path.length-1)return se;_=se.children}}}),define(Oe[258],Ne([1,0,17,6,4,5,127,8,7]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=void 0,v=qe(v),T=qe(T);class a extends I.$Tc{constructor(y,c){super(),this.m=c,this.a=new P.$je,this.b=new P.$je,this.c=new P.$je,this.f=new P.$je,this.g=new P.$je,this.h=new P.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$vN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(D=>this.h.fire(D))),this.B(this.m.onDidChangeActiveTextEditor(D=>this.g.fire(D)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const c=this.m.allEditors();return y?c:c.map(D=>D.value)}async showTextDocument(y,c,D){let f;typeof c=="number"?f={position:T.ViewColumn.from(c),preserveFocus:D}:typeof c=="object"?f={position:T.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?T.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:f={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(y.uri,f),o=n&&this.m.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,c){return new A.$aQ(this.j,y,c).value}$acceptEditorPropertiesChanged(y,c){const D=this.m.getEditor(y);if(!D)throw new Error("unknown text editor");if(c.options&&D._acceptOptions(c.options),c.selections){const f=c.selections.selections.map(T.Selection.to);D._acceptSelections(f)}if(c.visibleRanges){const f=v.$Gb(c.visibleRanges.map(T.Range.to));D._acceptVisibleRanges(f)}if(c.options&&this.b.fire({textEditor:D.value,options:{...c.options,lineNumbers:T.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const f=$.TextEditorSelectionChangeKind.fromValue(c.selections.source),n=c.selections.selections.map(T.Selection.to);this.a.fire({textEditor:D.value,selections:n,kind:f})}if(c.visibleRanges){const f=v.$Gb(c.visibleRanges.map(T.Range.to));this.c.fire({textEditor:D.value,visibleRanges:f})}}$acceptEditorPositionData(y){for(const c in y){const D=this.m.getEditor(c);if(!D)throw new Error("Unknown text editor");const f=T.ViewColumn.to(y[c]);D.value.viewColumn!==f&&(D._acceptViewColumn(f),this.f.fire({textEditor:D.value,viewColumn:f}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$Ioc=a}),define(Oe[259],Ne([1,0,2,3,5,4,7,8,18,36,14]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=void 0,e.$tqc=(0,P.$Ci)("IExtHostTimeline");class y{constructor(f,n){this.b=new Map,this.c=new Map,this.a=f.getProxy(I.$vN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(o,s)=>{if(o&&o.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&$.$on.equals(s,this.b.get(o.source)?.extension)){const l=o.uri===void 0?void 0:v.URI.revive(o.uri);return this.c.get(o.source)?.get(c(l))?.get(o.handle)}else return;return o}})}async $getTimeline(f,n,o,s){return this.b.get(f)?.provider.provideTimeline(v.URI.revive(n),o,s)}registerTimelineProvider(f,n,o,s){const l=new O.$Sc,i=this.d(n.id,s,l).bind(this);let r;n.onDidChange&&(r=n.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:n.id}),this));const t=this.c;return this.f({...n,scheme:f,onDidChange:void 0,async provideTimeline(g,u,p){u?.resetCache&&(l.clear(),t.get(n.id)?.clear());const m=await n.provideTimeline(g,u,p);if(m==null)return;const h=i(g,u);return{...m,source:n.id,items:m.items.map(h)}},dispose(){for(const g of t.values())g.get(n.id)?.clear();r?.dispose(),l.dispose()}},o)}d(f,n,o){return(s,l)=>{let i;if(l?.cacheResults){let r=this.c.get(f);r===void 0&&(r=new Map,this.c.set(f,r));const t=c(s);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...g}=r,u=`${f}|${r.id??r.timestamp}`;i?.set(u,r);let p,m,h;r.iconPath&&(t instanceof A.$wO?h={id:t.id,color:t.color}:v.URI.isUri(t)?(p=t,m=t):{light:p,dark:m}=t);let E;return A.$2N.isMarkdownString(g.tooltip)?E=T.MarkdownString.from(g.tooltip):(0,R.$cg)(g.tooltip)?E=g.tooltip:A.$2N.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(g.detail)):(0,R.$cg)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.detail),{...g,id:g.id??void 0,handle:u,source:f,command:r.command?n.toInternal(r.command,o):void 0,icon:p,iconDark:m,themeIcon:h,tooltip:E,accessibilityInformation:r.accessibilityInformation}}}}f(f,n){if(this.b.get(f.id))throw new Error(`Timeline Provider ${f.id} already exists.`);return this.a.$registerTimelineProvider({id:f.id,label:f.label,scheme:f.scheme}),this.b.set(f.id,{provider:f,extension:n}),(0,O.$Rc)(()=>{for(const s of this.c.values())s.get(f.id)?.clear();this.b.delete(f.id),this.a.$unregisterTimelineProvider(f.id),f.dispose()})}}e.$uqc=y;function c(D){return D?.toString()}}),define(Oe[260],Ne([1,0,9,23,2,6,4,191,10,7,14,17,8,59,21,162,24]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0,a=qe(a);function s(r,t){if((0,R.$cg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let g;return Array.isArray(r.highlights)&&(g=r.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),g=g.length?g:void 0),{label:r.label,highlights:g}}}class l extends A.$Tc{constructor(t,g,u){super(),this.f=t,this.g=g,this.h=u,this.a=new Map,this.b=new n.$t_;function p(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:m=>p(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map(h=>p(h)?this.r(h):h):m})}registerTreeDataProvider(t,g,u){const p=this.createTreeView(t,{treeDataProvider:g},u);return{dispose:()=>p.dispose()}}createTreeView(t,g,u){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const p=g.dragAndDropController?.dropMimeTypes??[],m=g.dragAndDropController?.dragMimeTypes??[],h=!!g.dragAndDropController?.handleDrag,E=!!g.dragAndDropController?.handleDrop,S=this.m(t,g,u),w={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:p,dragMimeTypes:m,hasHandleDrag:h,hasHandleDrop:E,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,w),C={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$8G)(u,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$8G)(u,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(d){(0,D.$3k)(d)&&(0,o.$8G)(u,"treeViewMarkdownMessage"),S.message=d},get title(){return S.title},set title(d){S.title=d},get description(){return S.description},set description(d){S.description=d},get badge(){return S.badge},set badge(d){d!==void 0&&a.ViewBadge.isViewBadge(d)?S.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(S.badge=void 0)},reveal:(d,b)=>S.reveal(d,b),dispose:async()=>{await k,this.a.delete(t),S.dispose()}};return this.B(C),C}$getChildren(t,g){const u=this.a.get(t);return u?u.getChildren(g):Promise.reject(new T.$rG(t))}async $handleDrop(t,g,u,p,m,h,E,S){const w=this.a.get(t);if(!w)return Promise.reject(new T.$rG(t));const k=c.DataTransfer.toDataTransfer(u,async C=>(await this.f.$resolveDropFileData(t,g,C)).buffer);return E===t&&S&&await this.j(k,w,S,m,h),w.onDrop(k,p,m)}async j(t,g,u,p,m){const h=this.b.removeDragOperationTransfer(m);if(h)(await h)?.forEach((E,S)=>{E&&t.set(S,E)});else if(m&&g.handleDrag){const E=g.handleDrag(u,t,p);this.b.addDragOperationTransfer(m,E),await E}return t}async $handleDrag(t,g,u,p){const m=this.a.get(t);if(!m)return Promise.reject(new T.$rG(t));const h=await this.j(new a.$sO,m,g,p,u);if(!(!h||p.isCancellationRequested))return c.DataTransfer.from(h)}async $hasResolve(t){const g=this.a.get(t);if(!g)throw new T.$rG(t);return g.hasResolve}$resolve(t,g,u){const p=this.a.get(t);if(!p)throw new T.$rG(t);return p.resolveTreeItem(g,u)}$setExpanded(t,g,u){const p=this.a.get(t);if(!p)throw new T.$rG(t);p.setExpanded(g,u)}$setSelectionAndFocus(t,g,u){const p=this.a.get(t);if(!p)throw new T.$rG(t);p.setSelectionAndFocus(g,u)}$setVisible(t,g){const u=this.a.get(t);if(!u){if(!g)return;throw new T.$rG(t)}u.setVisible(g)}$changeCheckboxState(t,g){const u=this.a.get(t);if(!u)throw new T.$rG(t);u.setCheckboxState(g)}m(t,g,u){const p=this.B(new i(t,g,this.f,this.g.converter,this.h,u));return this.a.set(t,p),p}r(t){const g=this.a.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.$vqc=l;class i extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,R.$lg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,g,u,p,m,h){if(super(),this.I=t,this.J=u,this.L=p,this.M=m,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$ue,h.contributes&&h.contributes.views)for(const k in h.contributes.views)for(const C of h.contributes.views[k])C.id===t&&(this.P=C.name);this.f=g.treeDataProvider,this.g=g.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,S;const w=O.Event.debounce(this.F.event,(k,C)=>(k||(k={message:!1,elements:[]}),C.element!==!1&&(E||(E=new Promise(d=>S=d),this.G=this.G.then(()=>E)),Array.isArray(C.element)?k.elements.push(...C.element):k.elements.push(C.element)),C.message&&(k.message=!0),k),200,!0);this.B(w(({message:k,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const d=S;return E=null,this.$(C).then(()=>d())})),k&&this.J.$setMessage(this.I,c.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.X(t);return u||(u=await this.Y(g)),u?u.map(p=>p.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const u=(0,R.$lg)(g.select)?!0:g.select,p=(0,R.$lg)(g.focus)?!1:g.focus,m=(0,R.$lg)(g.expand)?!1:g.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(h=>this.W(t,h[h.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:h.map(S=>S.item)},{select:u,focus:p,expand:m})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:u,focus:p,expand:m})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=c.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,g){const u=this.getExtensionElement(t);u&&(g?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,g){const u=!(0,y.$tb)(this.s,t);this.s=t;const p=this.t!==g;this.t=g,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),p&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async u=>{const p=this.getExtensionElement(u.treeItemHandle);return p?{extensionItem:p,treeItem:await this.f.getTreeItem(p),newState:u.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);g.forEach(u=>{u.treeItem.checkboxState=u.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:g.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,g,u){const p=[];for(const m of t){const h=this.getExtensionElement(m);h&&p.push(h)}if(!(!this.g?.handleDrag||p.length===0))return await this.g.handleDrag(p,g,u),g}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,g,u){const p=g?this.getExtensionElement(g):void 0;if(!(!p&&g||!this.g?.handleDrop))return(0,$.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(p,t,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,g){if(!this.f.resolveTreeItem)return;const u=this.j.get(t);if(u){const p=this.m.get(u);if(p){const m=await this.f.resolveTreeItem(p.extensionItem,u,g)??p.extensionItem;return this.hb(m),p.item.tooltip=this.eb(m.tooltip),p.item.command=this.fb(p.disposableStore,m.command),p.item}}}S(t){return this.U(t).then(g=>g?this.S(g).then(u=>this.W(g,u[u.length-1]).then(p=>(u.push(p),u))):Promise.resolve([]))}U(t){const g=this.m.get(t);return g?Promise.resolve(g.parent?this.j.get(g.parent.item.handle):void 0):(0,$.$uh)(()=>this.f.getParent(t))}W(t,g){const u=this.m.get(t);return u?Promise.resolve(u):(0,$.$uh)(()=>this.f.getTreeItem(t)).then(p=>this.kb(t,p,g,!0)).then(p=>this.getChildren(g?g.item.handle:void 0).then(()=>{const m=this.getExtensionElement(p);if(m){const h=this.m.get(m);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${p} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let g;if(typeof t=="string"){const u=this.getExtensionElement(t);g=u?this.m.get(u):void 0}else g=t;return g&&g.children||void 0}return this.h}async Y(t){this.rb(t);const g=new f.$ue(this.Z.token);try{const u=t?this.m.get(t):void 0,p=await this.f.getChildren(t);if(g.token.isCancellationRequested)return;const m=(0,y.$Gb)(p||[]),h=await Promise.all((0,y.$Gb)(m).map(S=>this.f.getTreeItem(S)));if(g.token.isCancellationRequested)return;const E=h.map((S,w)=>S?this.db(m[w],S,u):null);return(0,y.$Gb)(E)}finally{g.dispose()}}$(t){if(t.some(u=>!u))return this.Z.dispose(!0),this.Z=new f.$ue,this.tb(),this.J.$refresh(this.I);{const u=this.ab(t);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(t){const g=new Set,u=t.map(m=>this.m.get(m));for(const m of u)if(m&&!g.has(m.item.handle)){let h=m;for(;h&&h.parent&&u.findIndex(E=>h&&h.parent&&E&&E.item.handle===h.parent.item.handle)===-1;){const E=this.j.get(h.parent.item.handle);h=E?this.m.get(E):void 0}h&&!h.parent&&g.add(m.item.handle)}const p=[];return g.forEach(m=>{const h=this.j.get(m);if(h){const E=this.m.get(h);E&&(!E.parent||!g.has(E.parent.item.handle))&&p.push(m)}}),p}bb(t){const g={};return Promise.all(t.map(u=>this.cb(u).then(p=>{p&&(g[u]=p.item)}))).then(()=>Object.keys(g).length?this.J.$refresh(this.I,g):void 0)}cb(t){const g=this.getExtensionElement(t);if(g){const u=this.m.get(g);if(u)return this.rb(g),(0,$.$uh)(()=>this.f.getTreeItem(g)).then(p=>{if(p){const m=this.ib(g,p,u.parent);return this.pb(g,m,u,u.parent),u.dispose(),m}return null})}return Promise.resolve(null)}db(t,g,u){const p=this.ib(t,g,u);if(g.id&&this.j.has(p.item.handle))throw new Error((0,v.localize)(10662,null,g.id));return this.ob(t,p),this.qb(p,u),p}eb(t){return a.$2N.isMarkdownString(t)?c.MarkdownString.from(t):t}fb(t,g){return g?{...this.L.toInternal(g,t),originalId:g.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let g,u,p;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,u=t.checkboxState.tooltip,p=t.checkboxState.accessibilityInformation),{isChecked:g===a.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:p}}hb(t){if(!a.$nO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,g,u){this.hb(g);const p=this.B(new A.$Sc),m=this.kb(t,g,u),h=this.lb(g);return{item:{handle:m,parentHandle:u?u.item.handle:void 0,label:s(g.label,this.N),description:g.description,resourceUri:g.resourceUri,tooltip:this.eb(g.tooltip),command:this.fb(p,g.command),contextValue:g.contextValue,icon:h,iconDark:this.mb(g)||h,themeIcon:this.jb(g),collapsibleState:(0,R.$lg)(g.collapsibleState)?a.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.gb(g)},extensionItem:g,parent:u,children:void 0,disposableStore:p,dispose(){p.dispose()}}}jb(t){return t.iconPath instanceof a.$wO?t.iconPath:void 0}kb(t,{id:g,label:u,resourceUri:p},m,h){if(g)return`${i.b}/${g}`;const E=s(u,this.N),S=m?m.item.handle:i.a;let w=E?E.label:p?(0,P.$ah)(p):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,C=this.X(m)||[];let d,b=0;do{if(d=`${S}/${b}:${w}`,h||!this.j.has(d)||k===d)break;b++}while(b<=C.length);return d}lb(t){if(t.iconPath&&!(t.iconPath instanceof a.$wO))return typeof t.iconPath=="string"||I.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof a.$wO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return I.URI.isUri(t)?t:I.URI.file(t)}ob(t,g){this.j.set(g.item.handle,t),this.m.set(t,g)}pb(t,g,u,p){this.j.delete(g.item.handle),this.m.delete(t),g.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(t,g);const m=this.X(p)||[],h=m.filter(E=>E.item.handle===u.item.handle)[0];h&&m.splice(m.indexOf(h),1,g)}qb(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const p=this.j.get(u.item.handle);p&&this.sb(p)}g.children=void 0}}else this.tb()}sb(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const p=this.j.get(u.item.handle);p&&this.sb(p)}this.m.delete(t),this.j.delete(g.item.handle),g.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Oe[261],Ne([1,0,6,4,2,37,8,67,5,7]),function(we,e,v,P,I,O,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=void 0,A=qe(A),$=qe($),a=qe(a);class R extends P.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(f,n,o,s){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$je),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=n,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#l=s.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,I.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(f){this.#u||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#l=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:A.ViewColumn.from(f),preserveFocus:!!n})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends P.$Tc{static c(){return(0,O.$Yg)()}constructor(f,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=f.getProxy($.$vN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,n,o,s,l={}){const i=typeof s=="object"?s.viewColumn:s,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},t=(0,T.$Xoc)(f),g=y.c();this.f.$createWebviewPanel((0,T.$Zoc)(f),g,n,{title:o,panelOptions:c(l),webviewOptions:(0,T.$1oc)(f,this.m,l),serializeBuffersForPostMessage:t},r);const u=this.j.createNewWebview(g,l,f);return this.createNewWebviewPanel(g,n,o,i,l,u,!0)}$onDidChangeWebviewPanelViewStates(f){const n=Object.keys(f);n.sort((o,s)=>{const l=f[o],i=f[s];return l.active?1:i.active?-1:+l.visible-+i.visible});for(const o of n){const s=this.getWebviewPanel(o);if(!s)continue;const l=f[o];s._updateViewState({active:l.active,visible:l.visible,viewColumn:A.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:f}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.$Xoc)(f)}),new a.$xN(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(f,n,o,s){const l=this.h.get(n);if(!l)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=l,t=this.j.createNewWebview(f,o.webviewOptions,r),g=this.createNewWebviewPanel(f,n,o.title,s,o.panelOptions,t,o.active);await i.deserializeWebviewPanel(g,o.state)}createNewWebviewPanel(f,n,o,s,l,i,r){const t=new R(f,this.f,i,{viewType:n,title:o,viewColumn:s,panelOptions:l,active:r});return this.g.set(f,t),t}getWebviewPanel(f){return this.g.get(f)}}e.$2oc=y;function c(D){return{enableFindWidget:D.enableFindWidget,retainContextWhenHidden:D.retainContextWhenHidden}}}),define(Oe[262],Ne([1,0,6,4,67,8,5,7]),function(we,e,v,P,I,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0,A=qe(A),T=qe(T);class $ extends P.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,c,D,f,n,o){super(),this.#s=!1,this.#l=this.B(new v.$je),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$je),this.onDidDispose=this.#u.event,this.#i=D,this.#a=f,this.#e=y,this.#t=c,this.#n=n,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(y,c){this.d=c,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$vN.MainThreadWebviewViews)}registerWebviewViewProvider(y,c,D,f){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:D,extension:y}),this.a.$registerWebviewViewProvider((0,I.$Zoc)(y),c,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Xoc)(y)}),new T.$xN(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(y,c,D,f,n){const o=this.b.get(c);if(!o)throw new Error(`No view provider found for '${c}'`);const{provider:s,extension:l}=o,i=this.d.createNewWebview(y,{},l),r=new $(y,this.a,c,D,i,!0);this.c.set(y,r),await s.resolveWebviewView(r,{state:f},n)}async $onDidChangeWebviewViewVisibility(y,c){this.e(y)._setVisible(c)}async $disposeWebviewView(y){const c=this.e(y);this.c.delete(y),c.dispose(),this.d.deleteWebview(y)}e(y){const c=this.c.get(y);if(!c)throw new Error("No webview found");return c}}e.$yqc=a}),define(Oe[263],Ne([1,0,6,30,31,3]),function(we,e,v,P,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.OutputChannelUpdateMode=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=void 0,e.$DM="text/x-code-output",e.$EM="output",e.$FM="Log",e.$GM="text/x-code-log-output",e.$HM="log",e.$IM="workbench.panel.output",e.$JM=new I.$Tj("inOutput",!1),e.$KM=new I.$Tj("activeLogOutput",!1),e.$LM=new I.$Tj("activeLogOutput.levelSettable",!1),e.$MM=new I.$Tj("activeLogOutput.level",""),e.$NM=new I.$Tj("activeLogOutput.levelIsDefault",!1),e.$OM=new I.$Tj("outputView.scrollLock",!1),e.$PM=(0,O.$Ci)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$QM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$je,this.onDidRegisterChannel=this.b.event,this.c=new v.$je,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(R=>a.push(R)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}P.$oo.add(e.$QM.OutputChannels,new T),e.$RM=new I.$Tj("activeOutputChannel","")}),define(Oe[128],Ne([1,0,5,3,16,18,11,263,68,26,50,164,22,14,29,6,4]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=e.$bqc=void 0;class s extends A.$dk{get disposed(){return this.n}constructor(t,g,u,p,m){super(),this.id=t,this.name=g,this.r=u,this.s=p,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,g),this.visible&&this.r.flush()}show(t,g){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.s.$close(this.id)}g(t,g){this.m+=c.$Le.fromString(g).byteLength,(0,A.log)(this.r,t,g),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends s{appendLine(t){this.append(t)}}let i=class{constructor(t,g,u,p,m,h){this.i=g,this.j=u,this.k=p,this.l=m,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$vN.MainThreadOutputService),this.b=this.k.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[g,u]of this.g)u.visible=g===this.h}createOutputChannel(t,g,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const p=typeof g=="object"&&g.log,m=(0,D.$cg)(g)?g:void 0;if((0,D.$cg)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const E=this.i.environment.extensionLogLevel?.find(([w])=>O.$on.equals(u.identifier,w))?.[1];E&&(h=(0,A.$ok)(E));const S=p?this.o(t,h,u):this.n(t,m,u);return S.then(w=>{this.g.set(w.id,w),w.visible=w.id===this.h}),p?this.r(t,h??this.m.getLevel(),S):this.q(t,S)}async n(t,g,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const p=await this.c,m=this.k.extUri.joinPath(p,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,m,g,u.identifier.value);return new s(E,t,h,this.a,u)}async o(t,g,u){const p=await this.p(u),m=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(p,`${m}.log`),E=`${u.identifier.value}.${m}`,S=this.l.createLogger(h,{id:E,name:t,logLevel:g,extensionId:u.identifier.value});return new l(E,t,S,this.a,u)}p(t){let g=this.d.get(t.identifier.value);if(!g){const u=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,g=(async()=>{try{await this.j.value.createDirectory(u)}catch(p){if((0,f.$nl)(p)!==f.FileSystemProviderErrorCode.FileExists)throw p}return u})())}return g}q(t,g){let u=!1;const p=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(m){p(),g.then(h=>h.append(m))},appendLine(m){p(),g.then(h=>h.appendLine(m))},clear(){p(),g.then(m=>m.clear())},replace(m){p(),g.then(h=>h.replace(m))},show(m,h){p(),g.then(E=>E.show(m,h))},hide(){p(),g.then(m=>m.hide())},dispose(){u=!0,g.then(m=>m.dispose())}}}r(t,g,u){const p=new o.$Sc,m=()=>{if(p.isDisposed)throw new Error("Channel has been closed")},h=p.add(new n.$je);function E(S){g=S,h.fire(S)}return u.then(S=>{p.add(S),S.logLevel!==g&&E(S.logLevel),p.add(S.onDidChangeLogLevel(w=>E(w)))}),{...this.q(t,u),get logLevel(){return g},onDidChangeLogLevel:h.event,trace(S,...w){m(),u.then(k=>k.trace(S,...w))},debug(S,...w){m(),u.then(k=>k.debug(S,...w))},info(S,...w){m(),u.then(k=>k.info(S,...w))},warn(S,...w){m(),u.then(k=>k.warn(S,...w))},error(S,...w){m(),u.then(k=>k.error(S,...w))},dispose(){p.dispose()}}}};e.$bqc=i,e.$bqc=i=He([Ve(0,I.$6P),Ve(1,a.$jQ),Ve(2,$.$Toc),Ve(3,R.$woc),Ve(4,A.$$j),Ve(5,A.$0j)],i),e.$cqc=(0,P.$Ci)("IExtHostOutputService")}),define(Oe[129],Ne([1,0,3,10]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=void 0,e.$Tm=(0,v.$Ci)("remoteAgentService"),e.$Um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const $=await I.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,P.$Dh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((T,$)=>T+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((T,$)=>T+$,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Oe[264],Ne([1,0,9,53,30,49,43,4,6,129,20,25,10,113]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=void 0,e.$4K=Object.freeze({id:"application",order:100,title:(0,v.localize)(12384,null),type:"object"}),e.$5K=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(12385,null),type:"object"}),e.$6K=Object.freeze({id:"security",scope:P.ConfigurationScope.APPLICATION,title:(0,v.localize)(12386,null),type:"object",order:7}),e.$7K=Object.freeze({id:"problems",title:(0,v.localize)(12387,null),type:"object",order:101}),e.$8K=Object.freeze({id:"window",order:8,title:(0,v.localize)(12388,null),type:"object"}),e.$9K={ConfigurationMigration:"base.contributions.configuration.migration"};class f{constructor(){this.migrations=[],this.a=new $.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new f;I.$oo.add(e.$9K.ConfigurationMigration,n);let o=class extends T.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const u of g.added)await this.f(u,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(g=>this.g(g,r?.uri))])}async g(r,t){const g=this.a.inspect(r.key,{resource:t}),u=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[p,m]of u){const h=g[p];if(!h)continue;const E=[];if(h.value!==void 0){const S=await this.h(r,p,h.value,t,void 0);for(const w of S??[])E.push([w,[]])}for(const{identifiers:S,value:w}of h.overrides??[])if(w!==void 0){const k=await this.h(r,p,w,t,S);for(const C of k??[])E.push([C,S])}E.length&&await Promise.allSettled(E.map(async([[S,w],k])=>this.a.updateValue(S,w.value,{resource:t,overrideIdentifiers:k},m)))}}async h(r,t,g,u,p){const m=E=>{const w=this.a.inspect(E,{resource:u})[t];if(w)return p?w.overrides?.find(({identifiers:k})=>(0,y.$fo)(k,p))?.value:w.value},h=await r.migrateFn(g,m);return Array.isArray(h)?h:[[r.key,h]]}};e.$0K=o,e.$0K=o=He([Ve(0,A.$9i),Ve(1,O.$Li)],o);let s=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new c.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$j&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;I.$oo.as(P.$to.Configuration).registerConfiguration({...e.$6K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(12389,null)},default:[],markdownDescription:(0,v.localize)(12390,null),scope:P.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(12391,null),scope:P.ConfigurationScope.MACHINE}}})}};e.$$K=s,e.$$K=s=He([Ve(0,a.$Tm)],s),e.$_K="window.newWindowProfile";let l=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.$_K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=I.$oo.as(P.$to.Configuration),t={...e.$8K,properties:{[e.$_K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,v.localize)(12392,null)],description:(0,v.localize)(12393,null),scope:P.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$_K);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$_K);if(!r)return;const t=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$_K,t?.name)}};e.$aL=l,e.$aL=l=He([Ve(0,D.$Jl),Ve(1,A.$9i)],l)}),define(Oe[265],Ne([1,0,41,15,19,23,9,264,53,3,30]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$cL=e.$bL=void 0,e.$dL=n,e.$eL=o,v=qe(v),e.$bL=(0,a.$Ci)("editorResolverService"),e.$cL="workbench.editorAssociations";const y=R.$oo.as($.$to.Configuration),c={...T.$5K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(1976,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(c);var D;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(D||(e.RegisteredEditorPriority=D={}));var f;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function n(s){switch(s){case D.exclusive:return 5;case D.default:return 4;case D.builtin:return 3;case D.option:default:return 1}}function o(s,l){if(new Set([P.Schemas.extension,P.Schemas.webviewPanel,P.Schemas.vscodeWorkspaceTrust,P.Schemas.vscodeSettings]).has(l.scheme))return!1;const t=typeof s=="string"&&s.indexOf(I.$fc.sep)>=0?`${l.scheme}:${l.path}`:(0,O.$ah)(l);return v.$wk(typeof s=="string"?s.toLowerCase():s,t.toLowerCase())}}),define(Oe[266],Ne([1,0,51,15,19,20,23,2,3,185,49,204,129]),function(we,e,v,P,I,O,A,T,$,a,R,y,c){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=void 0,e.$0M=(0,$.$Ci)("pathService");let f=D=class{constructor(o,s,l,i){this.d=o,this.e=s,this.f=l,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??o})()}hasValidBasename(o,s,l){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,l)}h(o,s,l){return o.scheme===P.Schemas.file||o.scheme===P.Schemas.vscodeRemote?(0,v.$zg)(l??(0,A.$ah)(o),s===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return D.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return P.Schemas.vscodeRemote;const l=(0,a.$7M)(s.getWorkspace());if(l)return l;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=s.getWorkspace().configuration;return r?r.scheme:P.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===O.OperatingSystem.Windows?I.$ec:I.$fc)}async fileURI(o){let s="";if(await this.a===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return T.URI.from({scheme:P.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$$M=f,e.$$M=f=D=He([Ve(1,c.$Tm),Ve(2,y.$SM),Ve(3,R.$Li)],f)}),define(Oe[130],Ne([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$LL=e.$KL=void 0;class v{constructor(A,T){this.line=A,this.character=T}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,T){return new v(0,0)}with(A){return new v(0,0)}}e.$KL=v;class P{constructor(A,T,$,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,T),this.end=new v($,a)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new P(0,0,0,0)}with(A){return new P(0,0,0,0)}}e.$LL=P;var I;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Oe[44],Ne([1,0,17,41,25,51,12,3,19,13,130,10]),function(we,e,v,P,I,O,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$0L=e.$3L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$ZL=e.$YL=e.$XL=e.$WL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.TextSearchCompleteMessageType=void 0,e.$TL=s,e.$UL=l,e.$VL=i,e.$1L=S,e.$2L=w,e.$4L=d,e.$5L=b,e.$6L=F,e.$7L=N,e.$8L=M,e.$9L=V,e.$$L=L,e.$aM=ge,e.$bM=_,P=qe(P),I=qe(I),O=qe(O),$=qe($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$ML="workbench.view.search",e.$NL="workbench.panel.search",e.$OL="workbench.view.search",e.$PL="search-result",e.$QL="search.exclude",e.$RL=2e4;const c="\u27EA ",D=" characters skipped \u27EB",f=(c.length+D.length+5)*2;e.$SL=(0,T.$Ci)("searchService");var n;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(se){return!!se.preview}function l(se){return!!se.resource}function i(se){return!!se.message}var r;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$WL=t;class g{constructor(ce,$e,oe,Ce){this.ranges=$e,this.webviewIndex=Ce;const Le=Array.isArray($e)?$e:[$e];if(oe&&oe.matchLines===1&&u(Le)){ce=(0,A.$8f)(ce,oe.matchLines);let X="",q=0,te=0;const ve=Math.floor(oe.charsPerLine/5),ae=[];for(const be of Le){const ue=Math.max(be.startColumn-ve,0),J=be.startColumn+oe.charsPerLine;if(ue>te+ve+f){const x=c+(ue-te)+D;X+=x+ce.slice(ue,J),q+=ue-(te+x.length)}else X+=ce.slice(te,J);ae.push(new m(0,be.startColumn-q,be.endColumn-q)),te=J}this.preview={text:X,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const X=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:ce,matches:(0,v.$Zb)($e,q=>new p(q.startLineNumber-X,q.startColumn,q.endLineNumber-X,q.endColumn))}}}}e.$XL=g;function u(se){const ce=se[0].startLineNumber;for(const $e of se)if($e.startLineNumber!==ce||$e.endLineNumber!==ce)return!1;return!0}class p{constructor(ce,$e,oe,Ce){this.startLineNumber=ce,this.startColumn=$e,this.endLineNumber=oe,this.endColumn=Ce}}e.$YL=p;class m extends p{constructor(ce,$e,oe){super(ce,$e,ce,oe)}}e.$ZL=m;var h;(function(se){se.List="list",se.Tree="tree"})(h||(e.ViewMode=h={}));var E;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function S(se,ce=!0){const $e=se&&se.files&&se.files.exclude,oe=ce&&se&&se.search&&se.search.exclude;if(!$e&&!oe)return;if(!$e||!oe)return $e||oe||void 0;let Ce=Object.create(null);return Ce=I.$eo(Ce,I.$bo($e)),Ce=I.$eo(Ce,I.$bo(oe),!0),Ce}function w(se,ce){return se.excludePattern&&P.$wk(se.excludePattern,ce)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&P.$wk(se.includePattern,ce)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some($e=>{const oe=$e.folder.fsPath;if(O.$Bg(ce,oe)){const Ce=$.$kc(oe,ce);return!$e.includePattern||!!P.$wk($e.includePattern,Ce)}else return!1}):!1:!0}var k;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class C extends Error{constructor(ce,$e){super(ce),this.code=$e}}e.$3L=C;function d(se){const ce=se.message;if((0,a.$3)(se))return new C(ce,k.canceled);try{const $e=JSON.parse(ce);return new C($e.message,$e.code)}catch{return new C(ce,k.other)}}function b(se){const ce={message:se.message,code:se.code};return new Error(JSON.stringify(ce))}function F(se){return se.type==="error"?!0:se.type==="success"}function N(se){return se.type==="success"}function M(se){return!!se.path}function V(se,ce,$e=!0){const oe=se.searchPath?se.searchPath:se.relativePath;return $e?(0,A.$5f)(oe,ce):P.$wk(ce,oe)}class W{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$0L=W;function L(se,ce){const $e={...se||{},...ce||{}};return Object.keys($e).filter(oe=>{const Ce=$e[oe];return typeof Ce=="boolean"&&Ce})}class Y{constructor(ce,$e){this.c=null,this.a={...ce.excludePattern||{},...$e.excludePattern||{}},this.b=P.$xk(this.a);let oe=ce.includePattern;$e.includePattern&&(oe?oe={...oe,...$e.includePattern}:oe=$e.includePattern),oe&&(this.c=P.$xk(oe))}matchesExcludesSync(ce,$e,oe){return!!(this.b&&this.b(ce,$e,oe))}includedInQuerySync(ce,$e,oe){return!(this.b&&this.b(ce,$e,oe)||this.c&&!this.c(ce,$e,oe))}includedInQuery(ce,$e,oe){const Ce=this.b(ce,$e,oe),Le=()=>this.c?!!this.c(ce,$e,oe):!0;return(0,y.$oh)(Ce)?Ce.then(X=>X?!1:Le()):Le()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$_L=Y;function Z(se){for(const ce in se)if(typeof se[ce]!="boolean")return!0;return!1}function ge(se){if(!se)return;let ce;return $e=>(ce||(ce=(se()||Promise.resolve([])).then(oe=>oe?fe(oe):{})),ce.then(oe=>!!oe[$e]))}function _(se){if(!se)return;let ce;return $e=>{if(!ce){const oe=se();ce=oe?fe(oe):{}}return!!ce[$e]}}function fe(se){const ce={};for(const $e of se)ce[$e]=!0;return ce}}),define(Oe[45],Ne([1,0,17,10,21,6,4,58,15,139,23,12,2,9,29,3,11,172,49,50,26,16,8,7,65,44,5,40]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u,p,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=void 0;function S(M,V,W){return new R.$5g(L=>d(L,W)).isEqual(M,V)}function w(M,V,W){return S(M.uri,V.uri,W)?0:(0,y.$wf)(M.uri.toString(),V.uri.toString())}function k(M,V,W){return M.index!==V.index?M.index<V.index?-1:1:S(M.uri,V.uri,W)?(0,y.$wf)(M.name,V.name):(0,y.$wf)(M.uri.toString(),V.uri.toString())}function C(M,V,W,L){const Y=M.slice(0).sort((ge,_)=>W(ge,_,L)),Z=V.slice(0).sort((ge,_)=>W(ge,_,L));return(0,v.$Db)(Y,Z,(ge,_)=>W(ge,_,L))}function d(M,V){const W=V.getCapabilities(M.scheme);return!(W&&W&f.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends l.$Vi{static toExtHostWorkspace(V,W,L,Y){if(!V)return{workspace:null,added:[],removed:[]};const{id:Z,name:ge,folders:_,configuration:fe,transient:se,isUntitled:ce}=V,$e=[],oe=W;W?_.forEach((q,te)=>{const ve=c.URI.revive(q.uri),ae=b.o(L||W,ve,Y);ae?(ae.name=q.name,ae.index=q.index,$e.push(ae)):$e.push({uri:ve,name:q.name,index:te})}):$e.push(..._.map(({uri:q,name:te,index:ve})=>({uri:c.URI.revive(q),name:te,index:ve}))),$e.sort((q,te)=>q.index<te.index?-1:1);const Ce=new b(Z,ge,$e,!!se,fe?c.URI.revive(fe):null,!!ce,q=>d(q,Y)),{added:Le,removed:X}=C(oe?oe.workspaceFolders:[],Ce.workspaceFolders,w,Y);return{workspace:Ce,added:Le,removed:X}}static o(V,W,L){for(let Y=0;Y<V.folders.length;Y++){const Z=V.workspaceFolders[Y];if(S(Z.uri,W,L))return Z}}constructor(V,W,L,Y,Z,ge,_){super(V,L.map(fe=>new l.$Wi(fe)),Y,Z,_),this.t=W,this.u=ge,this.q=[],this.s=T.$Ii.forUris(_,()=>!0),L.forEach(fe=>{this.q.push(fe),this.s.set(fe.uri,fe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,W){return W&&this.s.get(V)&&(V=(0,R.$ch)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let F=class{constructor(V,W,L,Y,Z){this.c=new O.$je,this.onDidChangeWorkspace=this.c.event,this.g=new O.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$le,this.C=new Map,this.h=Y,this.s=L,this.t=Z,this.j=new a.$Km,this.k=new P.$Bh,this.o=V.getProxy(h.$vN.MainThreadWorkspace),this.q=V.getProxy(h.$vN.MainThreadMessageService);const ge=W.workspace;this.l=ge?new b(ge.id,ge.name,[],!!ge.transient,ge.configuration?c.URI.revive(ge.configuration):null,!!ge.isUntitled,_=>d(_,L)):void 0}$initializeWorkspace(V,W){this.v=W,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?c.URI.from({scheme:$.Schemas.untitled,path:(0,R.$ah)((0,R.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,W,L,...Y){const Z=[];if(Array.isArray(Y)&&Y.forEach(ce=>{c.URI.isUri(ce.uri)&&!Z.some($e=>S($e.uri,ce.uri,this.s))&&Z.push({uri:ce.uri,name:ce.name||(0,R.$_g)(ce.uri)})}),this.n||[W,L].some(ce=>typeof ce!="number"||ce<0)||L===0&&Z.length===0)return!1;const ge=this.x?this.x.workspaceFolders:[];if(W+L>ge.length)return!1;const _=ge.slice(0);_.splice(W,L,...Z.map(ce=>({uri:ce.uri,name:ce.name||(0,R.$_g)(ce.uri),index:void 0})));for(let ce=0;ce<_.length;ce++){const $e=_[ce];if(_.some((oe,Ce)=>Ce!==ce&&S($e.uri,oe.uri,this.s)))return!1}_.forEach((ce,$e)=>ce.index=$e);const{added:fe,removed:se}=C(ge,_,k,this.s);if(fe.length===0&&se.length===0)return!1;if(this.o){const ce=V.displayName||V.name;this.o.$updateWorkspaceFolders(ce,W,L,Z).then(void 0,$e=>{this.n=void 0;const oe={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(s.Severity.Error,(0,D.localize)(10659,null,ce,$e.toString()),oe,[])})}return this.y(_),!0}getWorkspaceFolder(V,W){if(this.x)return this.x.getWorkspaceFolder(V,W)}async getWorkspaceFolder2(V,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,W)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,W){let L,Y="";if(typeof V=="string"?(L=c.URI.file(V),Y=V):typeof V<"u"&&(L=V,Y=V.fsPath),!L)return Y;const Z=this.getWorkspaceFolder(L,!0);if(!Z)return Y;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ge=(0,R.$fh)(Z.uri,L);return W&&Z.name&&(ge=`${Z.name}/${ge}`),ge}y(V){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:W,added:L,removed:Y}=b.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:Y}))}findFiles(V,W,L,Y,Z=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Y.value}, entryPoint: findFiles`);let ge="",_=!0;return W===null?_=!1:W!==void 0&&(typeof W=="string"?ge=W:ge=W.pattern),this.z(V,void 0,{exclude:ge,maxResults:L,useDefaultExcludes:_,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Z)}findFiles2(V,W={},L,Y=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${L.value}, entryPoint: findFiles2`),this.z(void 0,V,W,Y)}async z(V,W,L,Y=I.CancellationToken.None){if(Y&&Y.isCancellationRequested)return Promise.resolve([]);const Z=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,ge={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof L.useDefaultSearchExcludes=="boolean"?!L.useDefaultSearchExcludes:!1,maxResults:L.maxResults,excludePattern:Z,shouldGlobSearch:typeof L.fuzzy=="boolean"?!L.fuzzy:!0,_reason:"startFileSearch"};let _;if(V){const{includePattern:fe,folder:se}=N(g.GlobPattern.from(V));_=se,ge.includePattern=fe}else{const{includePattern:fe,folder:se}=N(g.GlobPattern.from(W));_=se,ge.filePattern=fe}return this.o.$startFileSearch(_??null,ge,Y).then(fe=>Array.isArray(fe)?fe.map(se=>c.URI.revive(se)):[])}async findTextInFiles(V,W,L,Y,Z=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Y.value}, entryPoint: findTextInFiles`);const ge=this.j.getNext(),_=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:fe,folder:se}=N(g.GlobPattern.from(W.include)),ce=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,$e={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:_,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:fe,excludePattern:ce},oe=!1;if(this.u[ge]=Ce=>{if(oe)return;const Le=c.URI.revive(Ce.resource);Ce.results.forEach(X=>{const q=(0,E.$_h)(X);(0,m.$TL)(q)?L({uri:Le,preview:{text:q.preview.text,matches:(0,v.$Zb)(q.preview.matches,te=>new u.$zN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,v.$Zb)(q.ranges,te=>new u.$zN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):L({uri:Le,text:q.text,lineNumber:q.lineNumber})})},Z.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(V,se??null,$e,ge,Z);return delete this.u[ge],Ce||{}}catch(Ce){throw delete this.u[ge],Ce}}$handleTextSearchResult(V,W){this.u[W]?.(V)}async save(V){const W=await this.o.$save(V,{saveAs:!1});return c.URI.revive(W)}async saveAs(V){const W=await this.o.$save(V,{saveAs:!0});return c.URI.revive(W)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}lookupAuthorization(V){return this.o.$lookupAuthorization(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,W){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,W);const L=this.t.transformOutgoingScheme(V),Y=this.A++;return this.o.$registerEditSessionIdentityProvider(Y,L),(0,A.$Rc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(Y)})}async $getEditSessionIdentifier(V,W){this.h.info("Getting edit session identifier for workspaceFolder",V);const L=await this.resolveWorkspaceFolder(c.URI.revive(V));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const Y=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!Y),!Y)return;const Z=await Y.provideEditSessionIdentity(L,W);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(V,W,L,Y){this.h.info("Getting edit session identifier for workspaceFolder",V);const Z=await this.resolveWorkspaceFolder(c.URI.revive(V));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const ge=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!ge),!ge)return;const _=await ge.provideEditSessionIdentityMatch?.(W,L,Y);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(V){return(W,L,Y)=>{const Z=function(_){W.call(L,_)};return Z.extension=V,this.B.event(Z,void 0,Y)}}async $onWillCreateEditSessionIdentity(V,W,L){const Y=await this.resolveWorkspaceFolder(c.URI.revive(V));if(Y===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:Y},W,async(Z,ge)=>{const _=Date.now();await Promise.resolve(Z),Date.now()-_>L&&this.h.warn("SLOW edit session create-participant",ge.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(V,W){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,W);const L=this.t.transformOutgoingScheme(V),Y=this.A++;return this.o.$registerCanonicalUriProvider(Y,L),(0,A.$Rc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(Y)})}async provideCanonicalUri(V,W,L){const Y=this.C.get(V.scheme);if(!Y)return;const Z=await Y.provideCanonicalUri?.(c.URI.revive(V),W,L);if(Z)return Z}async $provideCanonicalUri(V,W,L){return this.provideCanonicalUri(c.URI.revive(V),{targetScheme:W},L)}};e.$Noc=F,e.$Noc=F=He([Ve(0,t.$6P),Ve(1,r.$jQ),Ve(2,i.$woc),Ve(3,o.$0j),Ve(4,p.$Loc)],F),e.$Ooc=(0,n.$Ci)("IExtHostWorkspace");function N(M){let V,W;return M&&(typeof M=="string"?V=M:(V=M.pattern,W=c.URI.revive(M.baseUri))),{includePattern:V,folder:W}}}),define(Oe[46],Ne([1,0,25,6,45,5,7,43,173,53,14,10,3,16,11,2]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=e.$Qoc=e.$Poc=void 0;function o(p,m){if(m){const h=m.split(".");let E=p;for(let S=0;E&&S<h.length;S++)E=E[h[S]];return E}}function s(p){return p instanceof n.URI}function l(p){return p&&p.uri instanceof n.URI&&p.languageId&&typeof p.languageId=="string"}function i(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function r(p){return p&&p.uri instanceof n.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function t(p){if(s(p))return{resource:p};if(l(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(i(p))return{overrideIdentifier:p.languageId};if(r(p))return{resource:p.uri};if(p===null)return{resource:null}}let g=class{constructor(m,h,E){this.a=m.getProxy(O.$vN.MainThreadConfiguration),this.c=h,this.b=E,this.d=new y.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(m=>this.e)}$initializeConfiguration(m){this.e=new u(this.a,this.c,m,this.b),this.d.open()}$acceptConfigurationChanged(m,h){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(m,h))}};e.$Poc=g,e.$Poc=g=He([Ve(0,D.$6P),Ve(1,I.$Ooc),Ve(2,f.$0j)],g);class u{constructor(m,h,E,S){this.a=new P.$je,this.b=m,this.f=S,this.c=h,this.e=$.$Oo.parse(E,S),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(m,h){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Oo.parse(m,this.f),this.d=this.k(m.configurationScopes),this.a.fire(this.j(h,E))}getConfiguration(m,h,E){const S=t(h)||{},w=this.g(m?o(this.e.getValue(void 0,S,this.c.workspace),m):this.e.getValue(void 0,S,this.c.workspace));m&&this.h(m,S,E?.identifier);function k(d){if(d==null)return null;if(typeof d=="boolean")return d?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(d){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(d){return typeof o(w,d)<"u"},get:(d,b)=>{this.h(m?`${m}.${d}`:d,S,E?.identifier);let F=o(w,d);if(typeof F>"u")F=b;else{let N;const M=(V,W)=>{if((0,R.$eg)(V)){let L;const Y=()=>{N=N||(0,v.$bo)(w),L=L||o(N,W)};return new Proxy(V,{get:(Z,ge)=>{if(typeof ge=="string"&&ge.toLowerCase()==="tojson")return Y(),()=>L;if(N)return L=L||o(N,W),L[ge];const _=Z[ge];return typeof ge=="string"?M(_,`${W}.${ge}`):_},set:(Z,ge,_)=>(Y(),L&&(L[ge]=_),!0),deleteProperty:(Z,ge)=>(Y(),L&&delete L[ge],!0),defineProperty:(Z,ge,_)=>(Y(),L&&Object.defineProperty(L,ge,_),!0)})}return Array.isArray(V)?(0,v.$bo)(V):V};F=M(F,d)}return F},update:(d,b,F,N)=>{d=m?`${m}.${d}`:d;const M=k(F);return b!==void 0?this.b.$updateConfigurationOption(M,d,b,S,N):this.b.$removeConfigurationOption(M,d,S,N)},inspect:d=>{d=m?`${m}.${d}`:d;const b=this.e.inspect(d,S,this.c.workspace);if(b)return{key:d,defaultValue:(0,v.$bo)(b.policy?.value??b.default?.value),globalValue:(0,v.$bo)(b.user?.value??b.application?.value),workspaceValue:(0,v.$bo)(b.workspace?.value),workspaceFolderValue:(0,v.$bo)(b.workspaceFolder?.value),defaultLanguageValue:(0,v.$bo)(b.default?.override),globalLanguageValue:(0,v.$bo)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,v.$bo)(b.workspace?.override),workspaceFolderLanguageValue:(0,v.$bo)(b.workspaceFolder?.override),languageIds:(0,v.$bo)(b.overrideIdentifiers)}}};return typeof w=="object"&&(0,v.$eo)(C,w,!1),Object.freeze(C)}g(m){const h=E=>(0,R.$eg)(E)?new Proxy(E,{get:(S,w)=>h(S[w]),set:(S,w,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(S,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(S,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return h(m)}h(m,h,E){const S=a.$Do.test(m)?a.ConfigurationScope.RESOURCE:this.d.get(m),w=E?`[${E.value}] `:"";if(a.ConfigurationScope.RESOURCE===S){typeof h?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===S){h?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(m,h){const E=new $.$Qo(m,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,w)=>E.affectsConfiguration(S,t(w))})}k(m){return m.reduce((h,E)=>(h.set(E[0],E[1]),h),new Map)}}e.$Qoc=u,e.$Roc=(0,c.$Ci)("IExtHostConfiguration")}),define(Oe[131],Ne([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,208,13]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=e.$nqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=qe(A),o=qe(o);var t;(function(N){function M(W){if(W!=null)return W}N.from=M;function V(W){if(W!=null)return W}N.to=V})(t||(t={}));var g;(function(N){function M(W){if(W!=null)return W}N.from=M;function V(W){if(W!=null)return W}N.to=V})(g||(g={}));var u;(function(N){function M(W){if(W!=null)return W}N.from=M;function V(W){if(W!=null)return W}N.to=V})(u||(u={}));var p;(function(N){function M(L){if(L){const Y=L;return Y&&!!Y.process}else return!1}N.is=M;function V(L){if(L==null)return;const Y={process:L.process,args:L.args};return L.options&&(Y.options=u.from(L.options)),Y}N.from=V;function W(L){if(L!=null)return new A.$jO(L.process,L.args,L.options)}N.to=W})(p||(p={}));var m;(function(N){function M(W){if(W!=null)return W}N.from=M;function V(W){if(W!=null)return W}N.to=V})(m||(m={}));var h;(function(N){function M(L){if(L){const Y=L;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}N.is=M;function V(L){if(L==null)return;const Y={};return L.commandLine!==void 0?Y.commandLine=L.commandLine:(Y.command=L.command,Y.args=L.args),L.options&&(Y.options=m.from(L.options)),Y}N.from=V;function W(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new A.$kO(L.commandLine,L.options):new A.$kO(L.command,L.args?L.args:[],L.options)}N.to=W})(h||(h={}));var E;(function(N){function M(L){if(L){const Y=L;return Y&&Y.customExecution==="customExecution"}else return!1}N.is=M;function V(L){return{customExecution:"customExecution"}}N.from=V;function W(L,Y){return Y.get(L)}N.to=W})(E||(e.CustomExecutionDTO=E={}));var S;(function(N){function M(V,W){let L;return V.scope!==void 0&&typeof V.scope!="number"?L=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?L=W.workspaceFile:L=i.$JI),{id:V._id,workspaceFolder:L}}N.from=M})(S||(e.TaskHandleDTO=S={}));var w;(function(N){function M(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}N.from=M})(w||(w={}));var k;(function(N){function M(L,Y){if(L==null)return[];const Z=[];for(const ge of L){const _=V(ge,Y);_&&Z.push(_)}return Z}N.fromMany=M;function V(L,Y){if(L==null)return;let Z;L.execution instanceof A.$jO?Z=p.from(L.execution):L.execution instanceof A.$kO?Z=h.from(L.execution):L.execution&&L.execution instanceof A.$lO&&(Z=E.from(L.execution));const ge=t.from(L.definition);let _;return L.scope?typeof L.scope=="number"?_=L.scope:_=L.scope.uri:_=A.TaskScope.Workspace,!ge||!_?void 0:{_id:L._id,definition:ge,name:L.name,source:{extensionId:Y.identifier.value,label:L.source,scope:_},execution:Z,isBackground:L.isBackground,group:w.from(L.group),presentationOptions:g.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}N.from=V;async function W(L,Y,Z){if(L==null)return;let ge;p.is(L.execution)?ge=p.to(L.execution):h.is(L.execution)?ge=h.to(L.execution):E.is(L.execution)&&(ge=E.to(L._id,Z));const _=t.to(L.definition);let fe;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?fe=L.source.scope:fe=await Y.resolveWorkspaceFolder(v.URI.revive(L.source.scope)):fe=A.TaskScope.Workspace),!_||!fe)return;const se=new A.$mO(_,fe,L.name,L.source.label,ge,L.problemMatchers);return L.isBackground!==void 0&&(se.isBackground=L.isBackground),L.group!==void 0&&(se.group=A.$iO.from(L.group._id),se.group&&L.group.isDefault&&(se.group=new A.$iO(se.group.id,se.group.label),L.group.isDefault===!0&&(se.group.isDefault=L.group.isDefault))),L.presentationOptions&&(se.presentationOptions=g.to(L.presentationOptions)),L._id&&(se._id=L._id),L.detail&&(se.detail=L.detail),se}N.to=W})(k||(e.TaskDTO=k={}));var C;(function(N){function M(W){return W}N.from=M;function V(W){if(W)return Object.assign(Object.create(null),W)}N.to=V})(C||(C={}));class d{#e;constructor(M,V,W){this._id=V,this.a=W,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let b=class{constructor(M,V,W,L,Y,Z,ge,_){this.q=new I.$je,this.r=new I.$je,this.s=new I.$je,this.u=new I.$je,this.a=M.getProxy(O.$vN.MainThreadTask),this.b=W,this.c=L,this.d=Y,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,V,W){if(!W)return new A.$xN(()=>{});const L=this.x();return this.j.set(L,{type:V,provider:W,extension:M}),this.a.$registerTaskProvider(L,V),new A.$xN(()=>{this.j.delete(L),this.a.$unregisterTaskProvider(L)})}registerTaskSystem(M,V){this.a.$registerTaskSystem(M,V)}fetchTasks(M){return this.a.$fetchTasks(C.from(M)).then(async V=>{const W=[];for(const L of V){const Y=await k.to(L,this.b,this.m);Y&&W.push(Y)}return W})}get taskExecutions(){const M=[];return this.k.forEach(V=>M.push(V)),M}terminateTask(M){if(!(M instanceof d))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,V,W){const L=this.m.get(M.id);L&&(this.o.set(M.id,L),this.e.attachPtyToTerminal(V,await L.callback(W))),this.p=M.id,this.q.fire({execution:await this.z(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){if(!this.l.has(M.id))return;const V=await this.z(M);this.l.delete(M.id),this.k.delete(M.id),this.B(M),this.r.fire({execution:V})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const V=await this.z(M.id);this.s.fire({execution:V,processId:M.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(M){const V=await this.z(M.id);this.u.fire({execution:V,exitCode:M.exitCode})}$provideTasks(M,V){const W=this.j.get(M);if(!W)return Promise.reject(new Error("no handler found"));const L=[],Y=(0,P.$uh)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(Z=>this.v(V,L,W,Z));return new Promise(Z=>{Y.then(ge=>{Promise.all(L).then(()=>{Z(ge)})})})}async $resolveTask(M,V){const W=this.j.get(M);if(!W)return Promise.reject(new Error("no handler found"));if(V.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${W.type}].`);const L=await k.to(V,this.b,this.m);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const Y=await W.provider.resolveTask(L,R.CancellationToken.None);if(!Y)return;this.A(Y,W);const Z=k.from(Y,W.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Z.execution)&&await this.y(Z,Y,!0),await this.w(Z)}x(){return this.h++}async y(M,V,W){const L=await this.a.$createTaskId(M);!W&&!this.m.has(L)&&(this.n.add(L),this.o.set(L,V.execution)),this.m.set(L,V.execution)}async z(M,V){if(typeof M=="string"){const Y=this.l.get(M);if(!Y)throw new r.$ab("Unexpected: The specified task is missing an execution");return Y}const W=this.l.get(M.id);if(W)return W;let L;return V?L=Promise.resolve(new d(this,M.id,V)):L=k.to(M.task,this.b,this.m).then(Y=>{if(!Y)throw new r.$ab("Unexpected: Task does not exist.");return new d(this,M.id,Y)}),this.l.set(M.id,L),L.then(Y=>(this.k.set(M.id,Y),Y))}A(M,V){M._deprecated&&this.g.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}B(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const W=this.n.values();let L=W.next();for(;!L.done;)!this.o.has(L.value)&&this.p!==L.value&&(this.m.delete(L.value),this.n.delete(L.value)),L=W.next()}};e.$nqc=b,e.$nqc=b=He([Ve(0,c.$6P),Ve(1,D.$jQ),Ve(2,T.$Ooc),Ve(3,$.$eQ),Ve(4,a.$Roc),Ve(5,y.$dpc),Ve(6,s.$0j),Ve(7,l.$soc)],b);let F=class extends b{constructor(M,V,W,L,Y,Z,ge,_){super(M,V,W,L,Y,Z,ge,_),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$i(o.Platform.Web)})}async executeTask(M,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const W=k.from(V,M);if(W===void 0)throw new Error("Task is not valid");if(E.is(W.execution))await this.y(W,V,!1);else throw new r.$$;const L=await this.z(await this.a.$getTaskExecution(W),V);return this.a.$executeTask(W).catch(Y=>{throw new Error(Y)}),L}v(M,V,W,L){const Y=[];if(L)for(const Z of L){if(this.A(Z,W),!Z.definition||!M[Z.definition.type]){const _=Z.source?Z.source:"No task source";this.f.warn(`The task [${_}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=k.from(Z,W.extension);ge&&E.is(ge.execution)?(Y.push(ge),V.push(this.y(ge,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:W.extension}}async w(M){if(E.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,V,W){}};e.$oqc=F,e.$oqc=F=He([Ve(0,c.$6P),Ve(1,D.$jQ),Ve(2,T.$Ooc),Ve(3,$.$eQ),Ve(4,a.$Roc),Ve(5,y.$dpc),Ve(6,s.$0j),Ve(7,l.$soc)],F),e.$pqc=(0,f.$Ci)("IExtHostTask")}),define(Oe[267],Ne([1,0,44,32]),function(we,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=void 0,e.$hM=I,e.$jM=O;function I(A){return"cellResults"in A}e.$iM="rawCell#";function O(A,T){let $=-1;const a=[];let R=[];return A.forEach(c=>{c.range.startLineNumber!==$&&R.length>0&&(a.push([...R]),R=[]),R.push(c),$=c.range.endLineNumber}),R.length>0&&a.push([...R]),a.map(c=>{const D=[],f=c[0].range.startLineNumber,n=c[c.length-1].range.endLineNumber;for(let o=f;o<=n;o++)D.push(T.getLineContent(o));return new v.$XL(D.join(`
`)+`
`,c.map(o=>new P.$Lt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Oe[268],Ne([1,0,9,22,6,4,28,36,12,14,2,29,79,5,33,8,7,38,245,124,25,15,44,198,267,265]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0,y=qe(y),n=qe(n),o=qe(o);class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,w,k,C,d,b,F){this.q=k,this.r=C,this.s=d,this.t=b,this.u=F,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new I.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new c.$qoc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(D.$vN.MainThreadNotebook),this.c=S.getProxy(D.$vN.MainThreadNotebookDocuments),this.d=S.getProxy(D.$vN.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const M=N.notebookEditor?.notebookUri,V=N.cell.handle,L=this.g.get(M)?.getCell(V);if(L)return L.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const M=N.uri,V=this.g.get(M);if(V)return V.apiNotebook}return N}}),h.C(w)}getEditorById(S){const w=this.h.get(S);if(!w)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(S){for(const[w,k]of this.h)if(k.apiEditor===S)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,w){const k=this.g.get(S);if(!k&&!w)throw new Error(`NO notebook document for '${S}'`);return k}static w(S,w){if(!w)return;const k=w.filenamePattern.map(C=>n.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(w.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:w.displayName,filenamePattern:k,priority:w.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(S,w,k){const C=h.a++,d=typeof k.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(C,k),this.b.$registerNotebookCellStatusBarItemProvider(C,d,w);let b;return d!==void 0&&(b=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(d))),new o.$xN(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,d),b?.dispose()})}async createNotebookDocument(S){const w=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&n.NotebookData.from(S.content)});return R.URI.revive(w)}async openNotebookDocument(S){const w=this.g.get(S);if(w)return w.apiNotebook;const k=await this.c.$tryOpenNotebook(S),C=this.g.get(R.URI.revive(k));return(0,a.$ng)(C?.apiNotebook)}async showNotebookDocument(S,w){R.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let k;typeof w=="object"?k={position:n.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(n.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:k={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,k),d=C&&this.h.get(C)?.apiEditor;if(d)return d;throw C?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,w,k,C){const d=this.f.get(S),b=R.URI.revive(w),F=this.g.get(b);if(!F||!d)return;const N=F.getCellFromIndex(k);if(!N)return;const M=await d.provideCellStatusBarItems(N.apiCell,C);if(!M)return;const V=new O.$Sc,W=this.p.add([V]),Y=(Array.isArray(M)?M:[M]).map(Z=>n.NotebookStatusBarItem.from(Z,this.i,V));return{cacheId:W,items:Y}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,w,k,C,d){if((0,$.$af)(w))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:w,serializer:k,options:C}),this.b.$registerNotebookSerializer(b,{id:S.identifier,location:S.extensionLocation},w,n.NotebookDocumentContentOptions.from(C),h.w(S,d)),(0,O.$Rc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(S,w,k){const C=this.y.get(S);if(!C)throw new Error("NO serializer found");const d=await C.serializer.deserializeNotebook(w.buffer,k);return new s.$Uw(n.NotebookData.from(d))}async $notebookToData(S,w,k){const C=this.y.get(S);if(!C)throw new Error("NO serializer found");const d=await C.serializer.serializeNotebook(n.NotebookData.to(w.value),k);return P.$Le.wrap(d)}async $saveNotebook(S,w,k,C,d){const b=R.URI.revive(w),F=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${k}, ${b.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(b);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new y.$sl((0,v.localize)(10667,null,this.A(b)),y.FileOperationResult.FILE_PERMISSION_DENIED);const M={metadata:(0,r.$jo)(N.apiNotebook.metadata,Z=>!(F.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of N.apiNotebook.getCells()){const ge=new o.$3O(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,F.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);ge.metadata=(0,r.$jo)(Z.metadata,_=>!(F.options?.transientCellMetadata??{})[_]),M.cells.push(ge)}if(await this.z(b,C),d.isCancellationRequested)throw new Error("canceled");const V=await F.serializer.serializeNotebook(M,d);if(d.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${b.toString()}`),await this.s.value.writeFile(b,V),this.D(`Finished write versionId: ${k} ${b.toString()}`);const W=this.s.getFileSystemProviderExtUri(b.scheme),L=await this.s.value.stat(b),Y={name:W.basename(b),isFile:(L.type&y.FileType.File)!==0,isDirectory:(L.type&y.FileType.Directory)!==0,isSymbolicLink:(L.type&y.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((L.permissions??0)&y.FilePermission.Locked),etag:y.$Dl({mtime:L.mtime,size:L.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${b.toString()})`),Y}async $searchInNotebooks(S,w,k,C,d){const b=this.y.get(S)?.serializer;if(!b)return{limitHit:!1,results:[]};const F=new A.$Ac;await(async(L,Y,Z)=>{await Promise.all(L.map(async ge=>await Promise.all(ge.filenamePatterns.map(_=>{const fe={_reason:Z._reason,folderQueries:Z.folderQueries,includePattern:Z.includePattern,excludePattern:Z.excludePattern,maxResults:Z.maxResults,type:g.QueryType.File,filePattern:_};return this.t.doInternalFileSearchWithCustomCallback(fe,Y,se=>{se.forEach(ce=>{F.has(ce)||C.some(oe=>ge.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(Ce=>(0,m.$eL)(Ce,ce)))||F.add(ce)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(k,d,w);const M=new A.$zc;let V=!1;const W=Array.from(F).map(async L=>{const Y=[];try{if(d.isCancellationRequested)return;if(w.maxResults&&[...M.values()].reduce((fe,se)=>fe+se.cellResults.length,0)>w.maxResults){V=!0;return}const Z=[],ge=this.g.get(L);if(ge)ge.apiNotebook.getCells().forEach(se=>Z.push({input:se.document.getText(),outputs:se.outputs.flatMap(ce=>ce.items.map($e=>$e.data.toString()))}));else{const fe=await this.s.value.readFile(L),se=P.$Le.fromString(fe.toString()),ce=await b.deserializeNotebook(se.buffer,d);if(d.isCancellationRequested)return;n.NotebookData.from(ce).cells.forEach(oe=>Z.push({input:oe.source,outputs:oe.outputs.flatMap(Ce=>Ce.items.map(Le=>Le.valueBytes.toString()))}))}if(d.isCancellationRequested)return;Z.forEach((fe,se)=>{const ce=w.contentPattern.pattern,$e=new u.$DZb(fe.input,void 0,fe.outputs),oe=$e.findInInputs(ce),Ce=$e.findInOutputs(ce),Le=Ce.flatMap(X=>(0,p.$jM)(X.matches,X.textBuffer)).map((X,q)=>(X.webviewIndex=q,X));if(oe.length>0||Ce.length>0){const X={index:se,contentResults:(0,p.$jM)(oe,$e.inputTextBuffer),webviewResults:Le};Y.push(X)}});const _={resource:L,cellResults:Y};M.set(L,_);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...M.values()]}}async z(S,w){const k=await this.s.value.stat(S);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==y.$Cl&&typeof k.mtime=="number"&&typeof k.size=="number"&&w.mtime<k.mtime&&w.etag!==y.$Dl({mtime:w.mtime,size:k.size}))throw new y.$sl((0,v.localize)(10668,null),y.FileOperationResult.FILE_MODIFIED_SINCE,w)}A(S){return S.scheme===t.Schemas.file?S.fsPath:S.toString()}B(S,w,k){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const C=new i.$Spc(w,this.d,S,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this.h.set(w,C)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const k of S.value.removedDocuments){const C=R.URI.revive(k),d=this.g.get(C);d&&(d.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(d.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===C.toString()&&this.h.delete(b.id)}if(S.value.addedDocuments){const k=[];for(const C of S.value.addedDocuments){const d=R.URI.revive(C.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const b=new l.$Rpc(this.c,this.q,this.r,d,C);k.push(...C.cells.map(F=>l.$Qpc.asModelAddData(F))),this.g.get(d)?.dispose(),this.g.set(d,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(b.apiNotebook)}}if(S.value.addedEditors)for(const k of S.value.addedEditors){if(this.h.has(k.id))return;const C=R.URI.revive(k.documentUri),d=this.g.get(C);d&&this.B(d,k.id,k)}const w=[];if(S.value.removedEditors)for(const k of S.value.removedEditors){const C=this.h.get(k);C&&(this.h.delete(k),this.k?.id===C.id&&(this.k=void 0),w.push(C))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const k=new Set;this.l.forEach(C=>k.add(C.id));for(const C of this.h.values()){const d=k.has(C.id);C._acceptVisibility(d)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const w=f.$rQ.String.with("notebookType","A notebook type"),k=new f.$tQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new f.$rQ("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>P.$Le.wrap(d))],new f.$sQ("Notebook Data",d=>n.NotebookData.to(d.value))),C=new f.$tQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new f.$rQ("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new s.$Uw(n.NotebookData.from(d)))],new f.$sQ("Bytes",d=>d.buffer));S.registerApiCommand(k),S.registerApiCommand(C)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$2pc=h}),define(Oe[269],Ne([1,0,19,21,42,41,23,69,44]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=void 0,v=qe(v),O=qe(O),A=qe(A);class a{constructor(c,D,f){this.k=c,this.l=D,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&O.$xk(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&O.$xk(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const D=this.k.folderQueries||[];return new Promise((f,n)=>{const o=s=>{this.f++,c(s)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const l=s.toString(),i=v.$mc(l);this.j&&this.j(l,i)||this.v(o,{base:s,basename:i})}),Promise.all(D.map(s=>this.p(s,o))).then(s=>{f({limitHit:this.e,stats:s[0]||void 0})},s=>{n(new Error((0,I.$nj)(s)))})})}async p(c,D){const f=new P.$ue,n=this.q(c),o=this.r(),s=new $.$_L(this.k,c),l=!s.hasSiblingExcludeClauses();let i;try{this.h.add(f),i=T.$de.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,f.token),t=i.elapsed(),g=T.$de.create();return this.g&&!this.e||(r&&r.forEach(u=>{const p=v.$fc.relative(c.folder.path,u.path);if(l){const m=v.$mc(u.path);this.v(D,{base:c.folder,relativePath:p,basename:m});return}this.s(o,c.folder,p,D)}),this.g&&!this.e)?null:(this.u(o,s,D),{providerTime:t,postProcessTime:g.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(c){const D=(0,$.$$L)(this.k.includePattern,c.includePattern),f=(0,$.$$L)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:f,includes:D,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},D,f,n){if(f===this.a){const s=v.$mc(this.a);this.v(n,{base:D,relativePath:this.a,basename:s})}function o(s){const l=v.$mc(s),i=v.$lc(s);let r=c[i];r||(r=c[i]=[],o(i)),r.push({base:D,relativePath:s,basename:l})}o(f)}u({rootEntries:c,pathToEntries:D},f,n){const o=this,s=this.a;function l(i){const r=(0,$.$bM)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const u=i[t],{relativePath:p,basename:m}=u;if(f.matchesExcludesSync(p,m,s!==m?r:void 0))continue;const h=D[p];if(h)l(h);else{if(p===s)continue;o.v(n,u)}if(o.e)break}}l(c)}v(c,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(D))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(c,D,f,n){const o=this.c(c.cacheKey),s=new a(c,D,o&&o.token);let l=0;const i=r=>{l+=r.length,f(r.map(t=>this.d(t)))};return this.e(s,R.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:r.stats}:void 0,messages:[]}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new P.$ue),this.b.get(c)}d(c){return c.relativePath?{resource:A.$dh(c.base,c.relativePath)}:{resource:c.base}}e(c,D,f,n){const o=n.onCancellationRequested(()=>{c.cancel()}),s=i=>{i&&(l.push(i),D>0&&l.length>=D&&(f(l),l=[]))};let l=[];return c.search(s).then(i=>(l.length&&f(l),o.dispose(),i),i=>(l.length&&f(l),o.dispose(),Promise.reject(i)))}}e.$Tpc=R}),define(Oe[270],Ne([1,0,17,239,41,99,28,15,19,23,12,14,2,102,9,43,11,49,118,266,44]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0,e.$aN=w,v=qe(v),P=qe(P),I=qe(I),$=qe($),R=qe(R),f=qe(f);let t=class{constructor(C,d,b,F,N){this.a=C,this.b=d,this.c=b,this.d=F,this.e=N}text(C,d,b={}){C=this.f(C,b);const F=this.a.getValue(),N=d&&d.some(V=>!this.a.getValue({resource:V}).search.useRipgrep);return{...this.h(d?.map(s.$Xi),b),type:r.QueryType.Text,contentPattern:C,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(C,d){const b=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const F={...C,wordSeparators:b.editor.wordSeparators};return this.j(C,d)&&(F.isCaseSensitive=!0),this.k(C)&&(F.isMultiline=!0),d.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=d.notebookSearchConfig.includeMarkupInput),d.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=d.notebookSearchConfig.includeMarkupPreview),d.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=d.notebookSearchConfig.includeCodeInput),d.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=d.notebookSearchConfig.includeOutput),F}file(C,d={}){return{...this.h(C,d),type:r.QueryType.File,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey,shouldGlobMatchFilePattern:d.shouldGlobSearch}}g(C,d){return C?(C=Array.isArray(C)?C.map(h):h(C),d?this.parseSearchPaths(C):{pattern:u(...Array.isArray(C)?C:[C])}):{}}h(C=[],d={}){const b=this.g(d.includePattern,d.expandPatterns),F=this.g(d.excludePattern,d.expandPatterns),N=C.length>1,M=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(L=>this.q(L,d,F)):C.map(L=>this.r(L,d,F,N))).filter(L=>!!L),V={_reason:d._reason,folderQueries:M,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:F.pattern,includePattern:b.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const L=v.$Gb(this.c.groups.flatMap(ge=>ge.editors.map(_=>_.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const Y=L.filter(ge=>(0,r.$2L)(V,ge.fsPath)),Z=this.i(Y);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...V,...Z}}const W=d.extraFileResources&&d.extraFileResources.filter(L=>(0,r.$2L)(V,L.fsPath));return V.extraFileResources=W&&W.length?W:void 0,V}i(C){const d=[],b=new A.$zc,F={};let N=!1;return C.forEach(M=>{if(M.scheme===T.Schemas.walkThrough)return;if((0,a.$hh)(M)){const W=this.b.getWorkspaceFolder(M)?.uri??M.with({path:$.$lc(M.fsPath)});let L=b.get(W);L||(N=!0,L={folder:W,includePattern:{}},d.push(L),b.set(W,L));const Y=$.$kc(W.fsPath,M.fsPath);(0,y.$ng)(L.includePattern)[Y.replace(/\\/g,"/")]=!0}else M.fsPath&&(N=!0,F[M.fsPath]=!0)}),{folderQueries:d,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(C,d){if(d.isSmartCase){if(C.isRegExp){if(R.$6f(C.pattern,!0))return!0}else if(R.$6f(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,D.$bD)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const d=Z=>$.$hc(Z)||/^\.\.?([\/\\]|$)/.test(Z),F=(Array.isArray(C)?C:p(C)).map(Z=>{const ge=this.e.resolvedUserHome;return ge?(0,O.$Zw)(Z,ge.scheme===T.Schemas.file?ge.fsPath:ge.path):Z}),N=P.$c(F,Z=>d(Z)?"searchPaths":"exprSegments"),M=(N.exprSegments||[]).map(Z=>R.$lf(Z,"/")).map(Z=>R.$lf(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),m(Z))),V={},W=this.m(N.searchPaths||[]);W&&W.length&&(V.searchPaths=W);const L=M.flat(),Y=u(...L);return Y&&(V.pattern=Y),V}l(C,d){return d.disregardExcludeSettings?void 0:(0,r.$1L)(C,!d.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const d=C.flatMap(F=>{let{pathPortion:N,globPortion:M}=g(F);return M&&(M=E(M)),this.n(N).flatMap(W=>this.o(W,M))}),b=new Map;return d.forEach(F=>{const N=F.searchPath.toString(),M=b.get(N);M?F.pattern&&(M.pattern=M.pattern||{},M.pattern[F.pattern]=!0):b.set(N,{searchPath:F.searchPath,pattern:F.pattern?u(F.pattern):void 0})}),Array.from(b.values())}n(C){if($.$hc(C)){const d=this.b.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==T.Schemas.file?[{searchPath:d[0].uri.with({path:C})}]:[{searchPath:c.URI.file($.$gc(C))}]}if(this.b.getWorkbenchState()===s.WorkbenchState.FOLDER){const d=this.b.getWorkspace().folders[0].uri;if(C=h(C),C.startsWith("../")||C===".."){const F=$.$fc.resolve(d.path,C);return[{searchPath:d.with({path:F})}]}const b=E(C);return[{searchPath:d,pattern:b}]}else{if(C==="./"||C===".\\")return[];{const d=C.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const M=d.match(new RegExp(`^${R.$ff(N.name)}(?:/(.*)|$)`));return M?{match:M,folder:N}:null}).filter(y.$kg);if(F.length)return F.map(N=>{const M=N.match[1];return{searchPath:N.folder.uri,pattern:M&&E(M)}});{const N=C.match(/\.[\/\\](.+)[\/\\]?/),M=N?N[1]:C,V=f.localize(1584,null,M);throw new Error(V)}}}}o(C,d){const b=C.pattern&&d?`${C.pattern}/${d}`:C.pattern||d,F=[{searchPath:C.searchPath,pattern:b}];return b&&!b.endsWith("**")&&F.push({searchPath:C.searchPath,pattern:b+"/**"}),F}q(C,d,b){const F=this.r((0,s.$Xi)(C.searchPath),d,b,!1);return F?{...F,includePattern:C.pattern}:null}r(C,d,b,F){let N;const M=c.URI.isUri(C)?C:C.uri;if(b.searchPaths){const Z=b.searchPaths.filter(ge=>(0,a.$9g)(ge.searchPath,M))[0];if(Z&&!Z.pattern)return null;Z&&(N=Z.pattern)}const V=this.a.getValue({resource:M}),L={...this.l(V,d)||{},...N||{}},Y=c.URI.isUri(C)?(0,a.$ah)(C):C.name;return{folder:M,folderName:F?Y:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof d.disregardParentIgnoreFiles=="boolean"?d.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!V.search.followSymlinks}}};e.$_M=t,e.$_M=t=He([Ve(0,n.$9i),Ve(1,s.$Li),Ve(2,l.$jE),Ve(3,o.$0j),Ve(4,i.$0M)],t);function g(k){const C=k.match(/[\*\{\}\(\)\[\]\?]/);if(C){const d=C.index,b=k.substr(0,d).match(/[/|\\][^/\\]*$/);if(b){let F=k.substr(0,b.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:k.substr((b.index||0)+1)}}}return{pathPortion:k}}function u(...k){return k.length?k.reduce((C,d)=>(C[d]=!0,C),Object.create(null)):void 0}function p(k){return I.$vk(k,",").map(C=>C.trim()).filter(C=>!!C.length)}function m(k){return[`**/${k}/**`,`**/${k}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function h(k){return k.replace(/\\/g,"/")}function E(k){return h(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(k){return k.replace(/([?*[\]])/g,"[$1]")}function w(k,C){k=v.$Lb(k,F=>F.toString());const d=[],b=C.getWorkspace();return k&&k.forEach(F=>{let N;if(C.getWorkbenchState()===s.WorkbenchState.FOLDER)N=(0,a.$fh)(b.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const M=C.getWorkspaceFolder(F);if(M){const V=M.name;if(b.folders.filter(L=>L.name===V).length===1){const L=(0,a.$fh)(M.uri,F);L===""?N=`./${M.name}`:N=`./${M.name}/${L}`}else N=F.fsPath}}N&&d.push(S(N))}),d}}),define(Oe[271],Ne([1,0,23,2,21,13,3,270,44,49,10]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dyb=c,e.$eyb=n,v=qe(v),O=qe(O);const y=7e3;function c(o,s){const l=s.activationEvents;if(!l)return Promise.resolve(void 0);const i=[],r=[];for(const h of l)if(/^workspaceContains:/.test(h)){const E=h.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||o.forceUsingSearch?r.push(E):i.push(E)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,R.$vh)(),u=h=>g({activationEvent:h}),p=Promise.all(i.map(h=>D(o,h,u))).then(()=>{}),m=f(o,s.identifier,r,u);return Promise.all([p,m]).then(()=>{g(void 0)}),t}async function D(o,s,l){for(const i of o.folders)if(await o.exists(v.$dh(P.URI.revive(i),s))){l(`workspaceContains:${s}`);return}}async function f(o,s,l,i){if(l.length===0)return Promise.resolve(void 0);const r=new I.$ue,t=o.checkExists(o.folders,l,r.token),g=setTimeout(async()=>{r.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},y);let u=!1;try{u=await t}catch(p){O.$3(p)||O.$Y(p)}r.dispose(),clearTimeout(g),u&&i(`workspaceContains:${l.join(",")}`)}function n(o,s,l,i){const r=o.get(A.$Bi),t=o.get($.$SL),u=r.createInstance(T.$_M).file(s.map(p=>(0,a.$Xi)(P.URI.revive(p))),{_reason:"checkExists",includePattern:l,exists:!0});return t.fileSearch(u,i).then(p=>!!p.limitHit,p=>O.$3(p)?!1:Promise.reject(p))}}),define(Oe[47],Ne([1,0,9,19,64,23,10,4,58,2,11,5,46,205,88,45,24,119,13,18,22,188,7,109,3,26,91,16,74,92,56,94,6,271,87,190,15,85,69,20,86]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u,p,m,h,E,S,w,k,C,d,b,F,N,M,V,W,L,Y){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=e.$tpc=e.$spc=e.$rpc=e.$qpc=void 0,v=qe(v),P=qe(P),I=qe(I),l=qe(l),e.$qpc=(0,p.$Ci)("IHostUtils");let ge=Z=class extends T.$Tc{constructor(X,q,te,ve,ae,be,ue,J,x,me,pe,Ae,ze){super(),this.Y=Ae,this.Z=ze,this.a=this.B(new d.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=te,this.f=ue,this.j=ve,this.m=ae,this.s=be,this.t=x,this.u=me,this.w=pe,this.y=this.g.getProxy(y.$vN.MainThreadWorkspace),this.z=this.g.getProxy(y.$vN.MainThreadTelemetry),this.C=this.g.getProxy(y.$vN.MainThreadExtensionService),this.D=new A.$Bh,this.F=new A.$Bh,this.G=new A.$Bh,this.H=new A.$Bh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new s.$Qcc(this.I,this.f.extensions.allExtensions);const ke=new i.$pn(this.f.extensions.myExtensions);this.J=new s.$Qcc(this.I,$e(this.L,ke)),L.$u&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new f.$_oc(this.g,this.s),this.N=new F.$jpc(this.g),this.O=J,this.h=X.createChild(new S.$Ai([f.$apc,this.M],[F.$kpc,this.N])),this.P=this.B(new D.$$oc(this.J,this.L,{onExtensionActivationError:(Pe,Te,U)=>{this.C.$onExtensionActivationError(Pe,l.$1(Te),U)},actualActivateExtension:async(Pe,Te)=>{if(s.$Qcc.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Te),new D.$0oc;const U=this.J.getExtensionDescription(Pe);return this.fb(U,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){l.$Y(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(X)}terminate(X,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const te=this.$();Promise.race([(0,A.$Dh)(5e3),te]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const q=await this.C.$getExtension(X);return q&&{...q,identifier:new i.$on(q.identifier.value),extensionLocation:a.URI.revive(q.extensionLocation)}}ab(X,q){return this.P.activateByEvent(X,q)}bb(X,q){return this.P.activateById(X,q)}activateByIdWithErrors(X,q){return this.bb(X,q).then(()=>{const te=this.P.getActivatedExtension(X);if(te.activationFailed)return Promise.reject(te.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===M.Schemas.file&&this.c.fsRealpath){const q=X.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const te=await this.R.get(q);return a.URI.file(te)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new oe(X))),this.Q}async db(X){const q=$.$Ii.forUris(te=>O.$7g.ignorePathCasing(te));return await Promise.all(X.map(async te=>{if(this.wb(te)){const ve=await this.cb(te.extensionLocation);q.set(ve,te)}})),q}eb(X){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return q;const te=this.P.getActivatedExtension(X);if(!te)return q;try{typeof te.module.deactivate=="function"&&(q=Promise.resolve(te.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(ve)}try{(0,T.$Oc)(te.subscriptions)}catch(ve){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(ve)}return q}async fb(X,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,q).then(te=>{const ve=te.activationTimes;return this.C.$onDidActivateExtension(X.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,q),this.gb(X,q,"success",ve),te},te=>{throw this.gb(X,q,"failure"),te})}gb(X,q,te,ve){const ae=fe(X,q);this.z.$publicLog2("extensionActivationTimes",{...ae,...ve||{},outcome:te})}hb(X,q){const te=fe(X,q);this.z.$publicLog2("activatePlugin",te);const ve=this.wb(X);if(!ve)return Promise.resolve(new D.$9oc(D.$6oc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${X.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ae=new D.$7oc(q.startup);return Promise.all([this.xb(X,(0,O.$dh)(X.extensionLocation,ve),ae),this.ib(X)]).then(be=>(I.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Z.jb(this.s,X.identifier,be[0],be[1],ae))).then(be=>(I.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),be))}ib(X){const q=this.Z.createLanguageModelAccessInformation(X),te=this.B(new t.$cpc(X,this.M)),ve=this.B(new t.$bpc(X.identifier.value,!1,this.M)),ae=this.B(new N.$lpc(X,this.N)),be=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,ue=this.f.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([te.whenReady,ve.whenReady,this.O.whenReady]).then(()=>{const J=this;let x,me;const pe=(0,o.$7G)(X,"ipc")?this.f.messagePorts?.get(i.$on.toKey(X.identifier)):void 0;return Object.freeze({globalState:te,workspaceState:ve,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return q},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Ae){return P.$ic(X.extensionLocation.fsPath,Ae)},get storagePath(){return J.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return J.O.globalValue(X).fsPath},get logPath(){return P.$ic(J.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return a.URI.joinPath(J.f.logsLocation,X.identifier.value)},get storageUri(){return J.O.workspaceValue(X)},get globalStorageUri(){return J.O.globalValue(X)},get extensionMode(){return be},get extension(){return x===void 0&&(x=new ce(J,X.identifier,X,ue,!1)),x},get extensionRuntime(){return(0,o.$8G)(X,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!me){if(!pe)return;const Ae=d.Event.buffer(d.Event.fromDOMEventEmitter(pe,"message",ze=>ze.data));pe.start(),me={onDidReceiveMessage:Ae,postMessage:pe.postMessage.bind(pe)}}return me}})})}static jb(X,q,te,ve,ae){return te=te||{activate:void 0,deactivate:void 0},this.kb(X,q,te,ve,ae).then(be=>new D.$8oc(!1,null,ae.build(),te,be,ve.subscriptions))}static kb(X,q,te,ve,ae){if(typeof te.activate=="function")try{ae.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${q.value}`);const be=typeof global=="object"?global:self,ue=te.activate.apply(be,[ve]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(ue).then(J=>(ae.activateResolveStop(),J))}catch(be){return Promise.reject(be)}else return Promise.resolve(te)}lb(X,q){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:q}).then(void 0,te=>{this.s.error(te)})}mb(X,q=0){const ve=Date.now();(0,L.$C)(()=>{for(let ae=q;ae<X.length;ae+=1){const be=X[ae];for(const ue of be.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ve>50){this.mb(X,ae);break}else this.lb(be,ue)}})}nb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(X=>{const q=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),te=this.J.getAllExtensionDescriptions();if(q)this.mb(te);else for(const ve of te)if(ve.activationEvents)for(const ae of ve.activationEvents)ae==="onStartupFinished"&&this.lb(ve,ae)})}ob(){const X=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const q=this.j.workspace?this.j.workspace.folders:[],te=this.pb(q),ve=this.rb(),ae=Promise.all([ve,X,te]).then(()=>{});return Promise.race([ae,(0,A.$Dh)(1e4)]).then(()=>{this.nb()}),ae}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(X,q))).then(()=>{})}async qb(X,q){if(this.isActivated(q.identifier))return;const te=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:X.map(be=>be.uri),forceUsingSearch:te||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,ue,J)=>this.y.$checkExists(be,ue,J)},ae=await(0,b.$dyb)(ve,q);if(ae)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ae.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:q}=this.f.environment;if(!X||!q)throw new Error(v.localize(10675,null));const te=await this.xb(null,q,new D.$7oc(!1));if(!te||typeof te.run!="function")throw new Error(v.localize(10676,null,q.toString()));return new Promise((ve,ae)=>{const be=(x,me)=>{x?(L.$u&&this.s.error("Test runner called back with error",x),ae(x)):(L.$u&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof me=="number"&&me>0?1:0))},ue=(0,O.$4g)(q),J=te.run(ue,be);J&&J.then&&J.then(()=>{L.$u&&this.s.info("Test runner finished successfully."),ve(0)}).catch(x=>{L.$u&&this.s.error("Test runner finished with error",x),ae(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,q){return this.S[X]=q,(0,T.$Rc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:q}=await this.ub(X);return q?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const q=X.indexOf("+");if(q===-1)throw new g.$FN("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const te=X.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${te}`,!1),{authorityPrefix:te,resolver:this.S[te]}}async $resolveAuthority(X,q){const te=W.$de.create(!1),ve=()=>`[resolveAuthority(${(0,u.$Sl)(X)},${q})][${te.elapsed()}ms] `,ae=B=>this.s.info(`${ve()}${B}`),be=B=>this.s.warn(`${ve()}${B}`),ue=(B,K=void 0)=>this.s.error(`${ve()}${B}`,K),J=B=>{if(B instanceof g.$FN)return{type:"error",error:{code:B._code,message:B._message,detail:B._detail}};throw B},x=async B=>{ae(`activating resolver for ${B}...`);const{resolver:K,authorityPrefix:G}=await this.ub(B);if(!K)throw ue(`no resolver for ${G}`),new g.$FN(`No remote extension installed to resolve ${G}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:G,remoteAuthority:B}},me=X.split(/@|%40/g).reverse();ae(`activating remote resolvers ${me.join(" -> ")}`);let pe;try{pe=await Promise.all(me.map(x)).catch(async B=>{if(!(B instanceof g.$FN)||B._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw B;return be(`resolving nested authorities failed: ${B.message}`),[await x(X)]})}catch(B){return J(B)}const Ae=new A.$Nh;Ae.cancelAndSet(()=>ae("waiting..."),1e3);let ze,ke;for(const[B,{authorityPrefix:K,resolver:G,remoteAuthority:ie}]of pe.entries())try{if(B===pe.length-1)ae("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${K}`),ze=await G.resolve(ie,{resolveAttempt:q,execServer:ke}),I.mark(`code/extHost/didResolveAuthorityOK/${K}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(G,g.$EN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ae(`invoking resolveExecServer() for ${ie}`),I.mark(`code/extHost/willResolveExecServer/${K}`),ke=await G.resolveExecServer?.(ie,{resolveAttempt:q,execServer:ke}),!ke)throw new g.$FN(`Exec server was not available for ${ie}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(de){return I.mark(`code/extHost/didResolveAuthorityError/${K}`),ue("returned an error",de),Ae.dispose(),J(de)}Ae.dispose();const Pe={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${g.$EN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let U;if(g.$EN.isManagedResolvedAuthority(ze)){const B=q;this.Y.setFactory(B,ze.makeConnection),U={authority:X,connectTo:new u.$Pl(B),connectionToken:ze.connectionToken}}else U={authority:X,connectTo:new u.$Ql(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:U,options:Te,tunnelInformation:Pe}}}async $getCanonicalURI(X,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Sl)(X)})`);const{resolver:te}=await this.ub(X);if(!te)return null;const ve=a.URI.revive(q);if(typeof te.getCanonicalURI>"u")return ve;const ae=await(0,A.$uh)(()=>te.getCanonicalURI(ve));return ae||ve}async $startExtensionHost(X){X.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:q,myExtensions:te}=_(this.I,this.L,this.J,X),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(te),L.$u&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(X,q){return q===o.ActivationKind.Immediate?this.D.wait().then(te=>this.ab(X,!1)):this.G.wait().then(te=>this.ab(X,!1))}async $activate(X,q){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,q),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:q,myExtensions:te}=_(this.I,this.L,this.J,X),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(te),L.$u&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const q=r.$Le.alloc(X),te=Math.random()%256;for(let ve=0;ve<X;ve++)q.writeUInt8(te,ve);return q}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$rpc=ge,e.$rpc=ge=Z=He([Ve(0,p.$Bi),Ve(1,e.$qpc),Ve(2,E.$6P),Ve(3,n.$Ooc),Ve(4,c.$Roc),Ve(5,R.$0j),Ve(6,m.$jQ),Ve(7,h.$Uoc),Ve(8,w.$UFb),Ve(9,k.$dpc),Ve(10,V.$npc),Ve(11,Y.$opc),Ve(12,C.$hpc)],ge);function _(Le,X,q,te){Le.addActivationEvents(te.addActivationEvents);const ve=new s.$Qcc(Le,X.getAllExtensionDescriptions());ve.deltaExtensions(te.toAdd,te.toRemove);const ae=new i.$pn(q.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of te.myToRemove)ae.delete(ue);for(const ue of te.myToAdd)ae.add(ue);const be=$e(ve,ae);return{globalRegistry:ve,myExtensions:be}}function fe(Le,X){return{id:Le.identifier.value,name:Le.name,extensionVersion:Le.version,publisherDisplayName:Le.publisher,activationEvents:Le.activationEvents?Le.activationEvents.join(","):null,isBuiltin:Le.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function se(Le){return Le.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$spc=(0,p.$Ci)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(X,q,te,ve,ae){this.#e=X,this.#t=q,this.#i=te.identifier,this.id=te.identifier.value,this.extensionUri=te.extensionLocation,this.extensionPath=P.$gc((0,O.$4g)(te.extensionLocation)),this.packageJSON=te,this.extensionKind=ve,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$tpc=ce;function $e(Le,X){return Le.getAllExtensionDescriptions().filter(q=>X.has(q.identifier))}class oe{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$upc=oe;class Ce{constructor(X){this.a=new i.$qn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const q of Object.keys(X))this.a.set(q,X[q])}}}),define(Oe[272],Ne([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=void 0,v=qe(v);let n=class{constructor(r,t,g,u,p,m,h){this.c=r,this.d=t,this.e=g,this.f=u,this.g=p,this.h=m,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new s(this.c,t,this.d,r,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,t,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$Fqc=n,e.$Fqc=n=He([Ve(2,R.$Bi),Ve(3,O.$Roc),Ve(4,y.$spc),Ve(5,a.$jQ),Ve(6,c.$0j)],n);let o=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&f.a.size){const t=(0,D.$ff)(this.c(r.environment.appRoot.fsPath)),g="[a-z0-9_.-]",u=`@${g}+\\/${g}+|${g}+`,p="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${p}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,g,u,p]=t,m=f.a.get(u);if(m!==void 0)return console.warn(`${u} as been renamed to ${m}, please update your imports`),g+m+p}c(r){return r.replace(/\\/g,"/")}};o=f=He([Ve(0,a.$jQ)],o);class s{constructor(r,t,g,u,p){this.c=r,this.d=t,this.e=g,this.f=u,this.g=p,this.nodeModuleName="vscode",this.a=new T.$qn}load(r,t){const g=this.d.findSubstr(t);if(g){let u=this.a.get(g.identifier);return u||(u=this.c(g,this.e,this.f),this.a.set(g.identifier,u)),u}if(!this.b){let u="";this.d.forEach((p,m)=>u+=`	${m} -> ${p.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this.b=this.c(A.$2G,this.e,this.f)}return this.b}}let l=class{constructor(r,t,g){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=g.getProxy(I.$vN.MainThreadTelemetry);const u=g.getProxy(I.$vN.MainThreadWindow);this.c=(p,m)=>{const h=P.URI.parse(p);return m?this.g(p,m):h.scheme==="http"||h.scheme==="https"?u.$openUri(h,p,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?u.$openUri(h,p,{}):this.g(p,m)}}load(r,t,g){const u=this.e.findSubstr(t);return u&&(this.a=u.identifier.value,this.h()),this.b=g(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=He([Ve(2,$.$6P)],l)}),define(Oe[132],Ne([1,0,48,4,19,78,3,57,70,47,7,45,202,46]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=e.$vpc=void 0,I=qe(I),O=qe(O),e.$vpc=(0,A.$Ci)("IExtHostVariableResolverProvider");class f extends c.$0Q{constructor(s,l,i,r,t,g,u){function p(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const h=r.tabGroups.all.find(E=>E.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof R.$lP||h.input instanceof R.$qP)return h.input.modified;if(h.input instanceof R.$kP||h.input instanceof R.$pP||h.input instanceof R.$nP)return h.input.uri}}}super({getFolderUri:m=>{const h=g.folders.filter(E=>E.name===m);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(m,h)=>t.getConfiguration(void 0,m).get(h),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=p();if(m)return I.$gc(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const m=p();if(m){const h=l.getWorkspaceFolder(m);if(h)return I.$gc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>s.getExtension(m)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(O.env))}}let n=class extends P.$Tc{constructor(s,l,i,r,t){super(),this.b=s,this.c=l,this.g=i,this.h=r,this.j=t,this.a=new v.$T(async()=>{const g=await this.h.getConfigProvider(),p={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{p.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,g,p,this.m())})}getResolver(){return this.a.value}m(){}};e.$wpc=n,e.$wpc=n=He([Ve(0,a.$spc),Ve(1,y.$Ooc),Ve(2,T.$eQ),Ve(3,D.$Roc),Ve(4,$.$4oc)],n)}),define(Oe[133],Ne([1,0,10,6,2,4,18,3,5,70,47,16,7,45,194,80,195,46,132,34,33,8,17,95]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=e.$Fpc=e.$Epc=e.$Dpc=e.$Cpc=void 0,t=qe(t),e.$Cpc=(0,T.$Ci)("IExtHostDebugService");let p=class extends O.$Tc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(C,d,b,F,N,M,V,W){super(),this.Y=d,this.Z=b,this.$=F,this.ab=N,this.bb=M,this.cb=V,this.db=W,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new P.$je),this.z=this.B(new P.$je),this.C=this.B(new P.$je),this.F=this.B(new P.$je),this.u=C.getProxy($.$vN.MainThreadDebugService),this.I=this.B(new P.$je),this.L=this.B(new P.$je),this.G=new h(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(L=>{this.B(L.onDidChange(Y=>{this.fb(L)})),this.fb(L)})}async $getVisualizerTreeItem(C,d){const b=this.gb(d);if(!b)return;const F=await this.Q.get(C)?.getTreeItem?.(b);return F?this.eb(C,F):void 0}registerDebugVisualizationTree(C,d,b){const F=A.$on.toKey(C.identifier),N=this.ub(F,d);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${d}' is already registered`);return this.Q.set(N,b),this.u.$registerDebugVisualizerTree(N,!!b.editItem),(0,O.$Rc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(d)})}async $getVisualizerTreeItemChildren(C,d){const b=this.S.get(d)?.item;return b?(await this.Q.get(C)?.getChildren?.(b))?.map(N=>this.eb(C,N))||[]:[]}async $editVisualizerTreeItem(C,d){const b=this.S.get(C);if(!b)return;const F=await this.Q.get(b.provider)?.editItem?.(b.item,d);return this.eb(b.provider,F||b.item)}$disposeVisualizedTree(C){const d=this.S.get(C);if(!d)return;const b=[d.children];for(const F of b)if(F)for(const N of F)b.push(this.S.get(N)?.children),this.S.delete(N)}eb(C,d){let b=this.R.get(d);return b||(b=this.O++,this.R.set(d,b),this.S.set(b,{provider:C,item:d})),t.DebugTreeItem.from(d,b)}asDebugSourceUri(C,d){const b=C;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let F=`debug:${encodeURIComponent(b.path||"")}`,N="?";return d&&(F+=`${N}session=${encodeURIComponent(d.id)}`,N="&"),F+=`${N}ref=${b.sourceReference}`,I.URI.parse(F)}else{if(b.path)return I.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(C){const d=[];for(const b of C.getAllExtensionDescriptions())if(b.contributes){const F=b.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,o.$ZH)(N)&&d.push(N.type)}this.u.$registerDebugTypes(d)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const C=[];return this.H.forEach(d=>C.push(d)),C}async $resolveDebugVisualizer(C,d){const b=this.W.get(C);if(!b)throw new Error(`No debug visualizer found with id '${C}'`);let{v:F,provider:N,extensionId:M}=b;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,d)||F,b.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(M,F.visualization)}async $executeDebugVisualizerCommand(C){const d=this.W.get(C);if(!d)throw new Error(`No debug visualizer found with id '${C}'`);const b=d.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(C){const d=this.w.get(C.sessionId);return d&&{session:d.api,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId}}async $provideDebugVisualizers(C,d,b,F){const N=this.gb(b),M=this.ub(C,d),V=this.P.get(M);if(!N||!V)return[];const W=await V.provideDebugVisualization(N,F);return W?W.map(L=>{const Y=++this.X;this.W.set(Y,{v:L,provider:V,extensionId:C});const Z=L.iconPath?this.wb(L.iconPath):void 0;return{id:Y,name:L.name,iconClass:Z?.iconClass,iconPath:Z?.iconPath,visualization:this.vb(C,L.visualization)}}):[]}$disposeDebugVisualizers(C){for(const d of C)this.W.delete(d)}registerDebugVisualizationProvider(C,d,b){if(!C.contributes?.debugVisualizers?.some(M=>M.id===d))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${d})`);const F=A.$on.toKey(C.identifier),N=this.ub(F,d);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${d}' is already registered`);return this.P.set(N,b),this.u.$registerDebugVisualizer(F,d),(0,O.$Rc)(()=>{this.u.$unregisterDebugVisualizer(F,d),this.P.delete(d)})}addBreakpoints(C){const d=C.filter(N=>{const M=N.id;return this.H.has(M)?!1:(this.H.set(M,N),!0)});this.rb(d,[],[]);const b=[],F=new Map;for(const N of d)if(N instanceof c.$BO){let M=F.get(N.location.uri.toString());M||(M={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),M),b.push(M)),M.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof c.$CO&&b.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(C){const d=C.filter(M=>this.H.delete(M.id));this.rb([],d,[]);const b=d.filter(M=>M instanceof c.$BO).map(M=>M.id),F=d.filter(M=>M instanceof c.$CO).map(M=>M.id),N=d.filter(M=>M instanceof c.$DO).map(M=>M.id);return this.u.$unregisterBreakpoints(b,F,N)}startDebugging(C,d,b){const F=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(C?C.uri:void 0,d,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===c.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(C){return this.u.$stopDebugging(C?C.id:void 0)}registerDebugConfigurationProvider(C,d,b){if(!d)return new c.$xN(()=>{});const F=this.f++;return this.g.push({type:C,handle:F,provider:d}),this.u.$registerDebugConfigurationProvider(C,b,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,F),new c.$xN(()=>{this.g=this.g.filter(N=>N.provider!==d),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(C,d,b){if(!b)return new c.$xN(()=>{});if(!this.nb(C,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.kb(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:d,handle:F,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(d,F),new c.$xN(()=>{this.j=this.j.filter(N=>N.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(C,d){if(!d)return new c.$xN(()=>{});const b=this.m++;return this.n.push({type:C,handle:b,factory:d}),new c.$xN(()=>{this.n=this.n.filter(F=>F.factory!==d)})}async $runInTerminal(C,d){return Promise.resolve(void 0)}async $substituteVariables(C,d){let b;const F=await this.tb(C);return F&&(b={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,d)}hb(C,d){if(C.type==="implementation")return new S(C.implementation)}ib(){}async $startDASession(C,d){const b=this,F=await this.sb(d);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const M=this.jb(N),V=this.hb(M,F);if(!V)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const W=V;return this.M.set(C,W),this.ob(F).then(L=>(L&&this.N.set(C,L),W.onMessage(async Y=>{if(Y.type==="request"&&Y.command==="handshake"){const Z=Y,ge={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const _=await this.U.sign(Z.arguments.value);ge.body={signature:_},W.sendResponse(ge)}else throw new Error("no signer")}catch(_){ge.success=!1,ge.message=_.message,W.sendResponse(ge)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(Y),Y=(0,o.$5H)(Y,!0),b.u.$acceptDAMessage(C,Y)}),W.onError(Y=>{L&&L.onError&&L.onError(Y),this.u.$acceptDAError(C,Y.name,Y.message,Y.stack)}),W.onExit(Y=>{L&&L.onExit&&L.onExit(Y??void 0,void 0),this.u.$acceptDAExit(C,Y??void 0,void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),W.startSession()))})}$sendDAMessage(C,d){d=(0,o.$4H)(d,!1);const b=this.N.get(C);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(d),this.M.get(C)?.sendMessage(d)}$stopDASession(C){const d=this.N.get(C);this.N.delete(C),d&&d.onWillStopSession&&d.onWillStopSession();const b=this.M.get(C);return this.M.delete(C),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(C){const d=[],b=[],F=[];if(C.added)for(const N of C.added){const M=N.id;if(M&&!this.H.has(M)){let V;if(N.type==="function")V=new c.$CO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")V=new c.$DO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const W=I.URI.revive(N.uri);V=new c.$BO(new c.$LN(W,new c.$yN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,c.$zO)(V,M),this.H.set(M,V),d.push(V)}}if(C.removed)for(const N of C.removed){const M=this.H.get(N);M&&(this.H.delete(N),b.push(M))}if(C.changed){for(const N of C.changed)if(N.id){const M=this.H.get(N.id);if(M){if(M instanceof c.$CO&&N.type==="function"){const V=M;V.enabled=N.enabled,V.condition=N.condition,V.hitCondition=N.hitCondition,V.logMessage=N.logMessage,V.functionName=N.functionName}else if(M instanceof c.$BO&&N.type==="source"){const V=M;V.enabled=N.enabled,V.condition=N.condition,V.hitCondition=N.hitCondition,V.logMessage=N.logMessage,V.location=new c.$LN(I.URI.revive(N.uri),new c.$yN(N.line,N.character))}F.push(M)}}}this.rb(d,b,F)}async $acceptStackFrameFocus(C){let d;if(C){const b=await this.sb(C.sessionId);C.kind==="thread"?d=new c.$JO(b.api,C.threadId):d=new c.$IO(b.api,C.threadId,C.frameId)}this.J=d,this.L.fire(this.J)}$provideDebugConfigurations(C,d,b){return(0,v.$uh)(async()=>{const F=this.mb(C);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(d);return F.provideDebugConfigurations(N,b)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(C,d,b,F){return(0,v.$uh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.tb(d);return N.resolveDebugConfiguration(M,b,F)})}$resolveDebugConfigurationWithSubstitutedVariables(C,d,b,F){return(0,v.$uh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.tb(d);return N.resolveDebugConfigurationWithSubstitutedVariables(M,b,F)})}async $provideDebugAdapter(C,d){const b=this.lb(C);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(d);return this.pb(b,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(C){const d=await this.sb(C);this.y.fire(d.api)}async $acceptDebugSessionTerminated(C){const d=await this.sb(C);d&&(this.z.fire(d.api),this.w.delete(d.id))}async $acceptDebugSessionActiveChanged(C){this.D=C?await this.sb(C):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(C,d){(await this.sb(C))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(C,d){const F={session:(await this.sb(C)).api,event:d.event,body:d.body};this.F.fire(F)}jb(C){if(C instanceof c.$EO)return{type:"executable",command:C.command,args:C.args,options:C.options};if(C instanceof c.$FO)return{type:"server",port:C.port,host:C.host};if(C instanceof c.$GO)return{type:"pipeServer",path:C.path};if(C instanceof c.$HO)return{type:"implementation",implementation:C.implementation};throw new Error("convertToDto unexpected type")}kb(C){const d=this.j.filter(b=>b.type===C);if(d.length>0)return d[0].factory}lb(C){const d=this.j.filter(b=>b.handle===C);if(d.length>0)return d[0].factory}mb(C){const d=this.g.filter(b=>b.handle===C);if(d.length>0)return d[0].provider}nb(C,d){if(C.contributes){const b=C.contributes.debuggers;if(b&&b.length>0){for(const F of b)if(F.label&&F.type&&F.type===d)return!0}}return!1}ob(C){const b=C.configuration.type,F=this.n.filter(N=>N.type===b||N.type==="*").map(N=>(0,v.$uh)(()=>N.factory.createDebugAdapterTracker(C.api)).then(M=>M,M=>null));return Promise.race([Promise.all(F).then(N=>{const M=(0,g.$Gb)(N);if(M.length>0)return new E(M)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(C,d){const b=d.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new c.$FO(b));if(C){const N=await this.Z.getExtensionRegistry();return(0,v.$uh)(()=>C.createDebugAdapterDescriptor(d.api,this.qb(d,N))).then(M=>{if(M)return M})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(d,F))}qb(C,d){}rb(C,d,b){(C.length>0||d.length>0||b.length>0)&&this.I.fire(Object.freeze({added:C,removed:d,changed:b}))}async sb(C){if(C)if(typeof C=="string"){const d=this.w.get(C);if(d)return d}else{let d=this.w.get(C.id);if(!d){const b=await this.tb(C.folderUri),F=C.parent?this.w.get(C.parent):void 0;d=new m(this.u,C.id,C.type,C.name,b,C.configuration,F?.api),this.w.set(d.id,d),this.u.$sessionCached(d.id)}return d}throw new Error("cannot find session")}tb(C){if(C){const d=I.URI.revive(C);return this.Y.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}ub(C,d){return`${C}\0${d}`}vb(C,d){if(d){if("title"in d&&"command"in d)return{type:n.DebugVisualizationType.Command};if("treeId"in d)return{type:n.DebugVisualizationType.Tree,id:`${C}\0${d.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(C){const d=this.xb(C);let b,F;return"id"in d?F=i.ThemeIcon.asClassName(d):b=d,{iconPath:b,iconClass:F}}xb(C){if(C instanceof c.$wO)return{id:C.id};const d=typeof C=="object"&&"dark"in C?C.dark:C,b=typeof C=="object"&&"light"in C?C.light:C;return{dark:typeof d=="string"?I.URI.file(d):d,light:typeof b=="string"?I.URI.file(b):b}}};e.$Dpc=p,e.$Dpc=p=He([Ve(0,y.$6P),Ve(1,D.$Ooc),Ve(2,R.$spc),Ve(3,s.$Roc),Ve(4,a.$4oc),Ve(5,l.$vpc),Ve(6,r.$pQ),Ve(7,u.$xpc)],p);class m{constructor(C,d,b,F,N,M,V){this.f=C,this.g=d,this.h=b,this.j=F,this.k=N,this.l=M,this.m=V}get api(){const C=this;return this.d??=Object.freeze({id:C.g,type:C.h,get name(){return C.j},set name(d){C.j=d,C.f.$setDebugSessionName(C.g,d)},parentSession:C.m,workspaceFolder:C.k,configuration:C.l,customRequest(d,b){return C.f.$customDebugAdapterRequest(C.g,d,b)},getDebugProtocolBreakpoint(d){return C.f.$getDebugProtocolBreakpoint(C.g,d.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(C){this.j=C}get configuration(){return this.l}}e.$Epc=m;class h{constructor(C){this.value=Object.freeze({append(d){C.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$Fpc=h;class E{constructor(C){this.d=C}onWillStartSession(){this.d.forEach(C=>C.onWillStartSession?C.onWillStartSession():void 0)}onWillReceiveMessage(C){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(C):void 0)}onDidSendMessage(C){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(C):void 0)}onWillStopSession(){this.d.forEach(C=>C.onWillStopSession?C.onWillStopSession():void 0)}onError(C){this.d.forEach(d=>d.onError?d.onError(C):void 0)}onExit(C,d){this.d.forEach(b=>b.onExit?b.onExit(C,d):void 0)}}class S extends f.$Jtb{constructor(C){super(),this.h=C,C.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(C){this.h.handleMessage(C)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends p{constructor(C,d,b,F,N,M,V,W){super(C,d,b,F,N,M,V,W)}};e.$Gpc=w,e.$Gpc=w=He([Ve(0,y.$6P),Ve(1,D.$Ooc),Ve(2,R.$spc),Ve(3,s.$Roc),Ve(4,a.$4oc),Ve(5,l.$vpc),Ve(6,r.$pQ),Ve(7,u.$xpc)],w)}),define(Oe[273],Ne([1,0,13,64,2,5,223,11,60,74,26,169,16,65,47,66]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=e.$Gqc=void 0,v=qe(v),P=qe(P);class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(T.$0j),g=i.get(c.$6P).getProxy(O.$vN.MainThreadErrors);v.setUnexpectedErrorHandler(u=>{r.error(u);const p=v.$1(u);g.$onUnexpectedError(p)})}static async installFullHandler(i){const r=i.get(T.$0j),t=i.get(c.$6P),g=i.get(f.$spc),u=i.get(n.$nQ),p=t.getProxy(O.$vN.MainThreadExtensionService),m=t.getProxy(O.$vN.MainThreadErrors),h=await g.getExtensionPathIndex(),E=new WeakMap;function S(C,d){if(E.has(C))return E.get(C).stack;let b="",F,N;for(const V of d)b+=`
	at ${V.toString()}`,N=V.getFileName(),!F&&N&&(F=h.findSubstr(I.URI.file(N)));const M=`${C.name||"Error"}: ${C.message||""}${b}`;return E.set(C,{extensionIdentifier:F?.identifier,stack:M}),M}const w=Symbol("prepareStackTrace wrapped");let k=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(C){if(C===S||!C||C[w]){k=C||S;return}k=function(d,b){return S(d,b),C.call(Error,d,b)},Object.assign(k,{[w]:!0})}}),v.setUnexpectedErrorHandler(C=>{r.error(C);const d=v.$1(C),b=E.get(C);if(!b?.extensionIdentifier){m.$onUnexpectedError(d);return}p.$onExtensionRuntimeError(b.extensionIdentifier,d);const F=u.onExtensionError(b.extensionIdentifier,C);r.trace("forwarded error to extension?",F,b)})}}e.$Gqc=o;class s{constructor(i,r,t,g,u){this.a=t,this.b=new A.$Ycc(i,null,g),r=s.e(r,this.b);const p=new a.$Ai(...(0,$.$Ps)());p.set(R.$jQ,{_serviceBrand:void 0,...r,messagePorts:u}),p.set(c.$6P,new c.$7P(this.b)),p.set(D.$Loc,new D.$Moc(g)),p.set(f.$qpc,t);const m=new y.$tr(p,!0);m.invokeFunction(o.installEarlyHandler),this.d=m.invokeFunction(h=>h.get(T.$0j)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=m.invokeFunction(h=>h.get(f.$spc)),this.c.initialize(),m.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(O.$vN.MainThreadExtensionService);return I.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=I.URI.revive(r.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=I.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>I.URI.revive(r.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=I.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=I.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=I.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=I.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=I.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=I.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$Hqc=s}),define(Oe[274],Ne([1,0,17,10,21,42,15,19,23,2,44]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=e.$Vpc=e.$Upc=void 0,e.$Wpc=n,T=qe(T),$=qe($);class y{constructor(l,i,r){this.d=l,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(l,i){const r=this.g.folderQueries||[],t=new I.$ue(i);return new Promise((g,u)=>{this.a=new D(l);let p=!1;const m=(h,E)=>{if(!p&&!this.b){const S=this.h(h);n(h)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,p=!0,t.cancel(),h=this.j(h,this.g.maxResults-this.c));const w=this.h(h);this.c+=w,(w>0||!n(h))&&this.a.add(h,E)}};Promise.all(r.map((h,E)=>this.k(h,S=>m(S,E),t.token))).then(h=>{t.dispose(),this.a.flush();const E=h.some(S=>!!S&&!!S.limitHit);g({limitHit:this.b||E,messages:h.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},h=>{t.dispose();const E=(0,O.$nj)(h);u(new Error(E))})})}h(l){return n(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,i){const r=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:l.preview.text},uri:l.uri}}async k(l,i,r){const t=new R.$_L(this.g,l),g=[],u={report:h=>{if(!this.l(h))return;const E=l.folder.scheme===A.Schemas.file?(0,R.$aM)(()=>this.e.readdir($.$ch(h.uri))):void 0,S=$.$fh(l.folder,h.uri);if(S){const w=t.includedInQuery(S,T.$mc(S),E);(0,P.$oh)(w)?g.push(w.then(k=>{k&&i(h)})):w&&i(h)}}},p=this.n(l);let m;return this.d.query.type===R.QueryType.aiText?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,p,u,r):m=await this.d.provider.provideTextSearchResults(c(this.d.query.contentPattern),p,u,r),g.length&&await Promise.all(g),m}l(l){if(n(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const i=(0,R.$$L)(this.g.includePattern,l.includePattern),r=(0,R.$$L)(this.g.excludePattern,l.excludePattern),t={folder:a.URI.from(l.folder),excludes:r,includes:i,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.e.toCanonicalName(l.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$RL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Upc=y;function c(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class D{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(l,i){this.d&&(this.b!==i||!$.$9g(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:l.uri,results:[]}),this.d.results.push(f(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$Vpc=D;function f(s){return n(s)?{preview:{matches:(0,v.$Zb)(s.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:s.preview.text},ranges:(0,v.$Zb)(s.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function n(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(l,i){this.g=l,this.h=i,this.c=0,this.d=[],this.e=0}addItem(l,i){l&&this.j(l,i)}addItems(l,i){l&&this.k(l,i)}j(l,i){this.d.push(l),this.e+=i,this.l()}k(l,i){this.d=this.d.concat(l),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Xpc=o}),define(Oe[134],Ne([1,0,4,5,3,269,16,65,11,2,274]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=e.$Ypc=void 0,e.$1pc=c,e.$Ypc=(0,I.$Ci)("IExtHostSearch");let y=class{constructor(n,o,s){this.n=n,this.o=o,this.q=s,this.c=this.n.getProxy(P.$vN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Tpc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(n)),(0,v.$Rc)(()=>{this.g.delete(n),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(n)),(0,v.$Rc)(()=>{this.i.delete(n),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(n)),(0,v.$Rc)(()=>{this.k.delete(n),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,o,s,l){const i=c(s),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,o,t.map(g=>g.resource))},l);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,s){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,s,l){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=c(s);return this.t(r,i).search(g=>this.c.$handleTextMatch(n,o,g),l)}$provideAITextSearchResults(n,o,s,l){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=c(s);return this.v(r,i).search(g=>this.c.$handleTextMatch(n,o,g),l)}$enableExtensionHostSearch(){}t(n,o){return new R.$Upc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(n,o){return new R.$Upc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$Zpc=y,e.$Zpc=y=He([Ve(0,A.$6P),Ve(1,T.$Loc),Ve(2,$.$0j)],y);function c(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(D),extraFileResources:f.extraFileResources&&f.extraFileResources.map(n=>a.URI.revive(n))}}function D(f){return{...f,folder:a.URI.revive(f.folder)}}});var ni=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Oe[275],Ne([1,0,21,13,6,4,15,35,2,105,156,157,52,18,29,11,62,63,184,5,226,255,84,90,231,232,233,210,200,33,234,46,235,133,122,236,212,227,237,238,57,70,213,228,47,240,68,241,50,26,256,214,242,243,94,244,85,86,216,268,246,189,247,257,248,128,217,249,250,251,16,252,134,87,253,218,254,88,91,131,66,56,126,95,258,229,259,260,92,8,7,219,65,220,67,261,262,121,45,80,83,24,130]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u,p,m,h,E,S,w,k,C,d,b,F,N,M,V,W,L,Y,Z,ge,_,fe,se,ce,$e,oe,Ce,Le,X,q,te,ve,ae,be,ue,J,x,me,pe,Ae,ze,ke,Pe,Te,U,B,K,G,ie,de,Ie,Ue,Ke,_e,tt,nt,et,rt,mt,lt,st,ct,ft,pt,We,je,ee,Q,Se,Je,xe,ht,$t,Nt,qt,ri,Xt,di,Ye,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=Gt,P=qe(P),T=ni(T),y=qe(y),f=qe(f),ee=qe(ee),Q=qe(Q);function Gt(gt){const Dt=gt.get(Ce.$jQ),Yt=gt.get(oe.$woc),Zt=gt.get(ce.$Toc),jt=gt.get(fe.$spc),bt=gt.get(ri.$Ooc),Rt=gt.get(rt.$nQ),li=gt.get(C.$Roc),Kt=gt.get(Je.$Loc),Xe=gt.get(G.$6P),xt=gt.get(tt.$apc),ui=gt.get(nt.$Uoc),fi=gt.get(n.$$j),kt=gt.get(n.$0j),Mt=gt.get(je.$UFb),At=gt.get(g.$soc),Ft=gt.get(qt.$Aqc),si=gt.get(Ie.$kpc),_t=gt.get(Z.$4oc),ei=gt.get(ue.$opc),Bt=gt.get(u.$Coc),Wt=gt.get(ve.$hpc);Xe.set(i.$wN.ExtHostFileSystemInfo,Yt),Xe.set(i.$wN.ExtHostLogLevelServiceShape,fi),Xe.set(i.$wN.ExtHostWorkspace,bt),Xe.set(i.$wN.ExtHostConfiguration,li),Xe.set(i.$wN.ExtHostExtensionService,jt),Xe.set(i.$wN.ExtHostStorage,xt),Xe.set(i.$wN.ExtHostTunnelService,Mt),Xe.set(i.$wN.ExtHostWindow,Ft),Xe.set(i.$wN.ExtHostSecretState,si),Xe.set(i.$wN.ExtHostTelemetry,Rt),Xe.set(i.$wN.ExtHostEditorTabs,_t),Xe.set(i.$wN.ExtHostManagedSockets,ei),Xe.set(i.$wN.ExtHostAuthentication,Bt),Xe.set(i.$wN.ExtHostChatProvider,Wt);const hi=Xe.set(i.$wN.ExtHostDecorations,gt.get(F.$Ipc)),Tt=Xe.set(i.$wN.ExtHostDocumentsAndEditors,gt.get(Y.$eQ)),Ct=Xe.set(i.$wN.ExtHostCommands,gt.get(w.$pQ)),wt=Xe.set(i.$wN.ExtHostTerminalService,gt.get(mt.$dpc)),Qt=Xe.set(i.$wN.ExtHostTerminalShellIntegration,gt.get(lt.$qqc)),yt=Xe.set(i.$wN.ExtHostDebugService,gt.get(b.$Cpc)),oi=Xe.set(i.$wN.ExtHostSearch,gt.get(de.$Ypc)),Ht=Xe.set(i.$wN.ExtHostTask,gt.get(et.$pqc)),Pi=Xe.set(i.$wN.ExtHostOutputService,gt.get(Pe.$cqc)),pi=Xe.set(i.$wN.ExtHostLocalization,gt.get(be.$npc)),Si=Xe.set(i.$wN.ExtHostUrls,new xe.$xqc(Xe)),zt=Xe.set(i.$wN.ExtHostDocuments,new L.$zoc(Xe,Tt)),gi=Xe.set(i.$wN.ExtHostDocumentContentProviders,new V.$Kpc(Xe,Tt,kt)),Ni=Xe.set(i.$wN.ExtHostDocumentSaveParticipant,new W.$Lpc(kt,zt,Xe.getProxy(i.$vN.MainThreadBulkEdits))),It=Xe.set(i.$wN.ExtHostNotebook,new x.$2pc(Xe,Ct,Tt,zt,Zt,oi,kt)),Di=Xe.set(i.$wN.ExtHostNotebookDocuments,new pe.$9pc(It)),Ri=Xe.set(i.$wN.ExtHostNotebookEditors,new Ae.$0pc(kt,It)),$i=Xe.set(i.$wN.ExtHostNotebookKernels,new ze.$$pc(Xe,Dt,It,Ct,kt)),Ai=Xe.set(i.$wN.ExtHostNotebookRenderers,new ke.$aqc(Xe,It)),Li=Xe.set(i.$wN.ExtHostNotebookDocumentSaveParticipant,new me.$8pc(kt,It,Xe.getProxy(i.$vN.MainThreadBulkEdits))),Lt=Xe.set(i.$wN.ExtHostEditors,new ct.$Ioc(Xe,Tt)),ye=Xe.set(i.$wN.ExtHostTreeViews,new We.$vqc(Xe.getProxy(i.$vN.MainThreadTreeViews),Ct,kt)),Re=Xe.set(i.$wN.ExtHostEditorInsets,new S.$Joc(Xe.getProxy(i.$vN.MainThreadEditorInsets),Lt,Dt.remote)),le=Xe.set(i.$wN.ExtHostDiagnostics,new N.$yoc(Xe,kt,Yt,Tt)),H=Xe.set(i.$wN.ExtHostLanguages,new ae.$6pc(Xe,zt,Ct.converter,Kt)),Ee=Xe.set(i.$wN.ExtHostLanguageFeatures,new q.$Aoc(Xe,Kt,zt,Ct,le,kt,At,Rt)),Be=Xe.set(i.$wN.ExtHostFileSystem,new se.$Opc(Xe,Ee)),Ze=Xe.set(i.$wN.ExtHostFileSystemEventService,new $e.$Ppc(Xe,kt,Tt)),Ge=Xe.set(i.$wN.ExtHostQuickOpen,(0,K.$gqc)(Xe,bt,Ct)),ut=Xe.set(i.$wN.ExtHostSCM,new ie.$iqc(Xe,Ct,zt,kt)),Pt=Xe.set(i.$wN.ExtHostQuickDiff,new B.$fqc(Xe,Kt)),ti=Xe.set(i.$wN.ExtHostShare,new Ue.$jqc(Xe,Kt)),ai=Xe.set(i.$wN.ExtHostComments,(0,k.$Koc)(Xe,Ct,zt)),Ut=Xe.set(i.$wN.ExtHostProgress,new U.$eqc(Xe.getProxy(i.$vN.MainThreadProgress))),ii=Xe.set(i.$wN.ExtHostLabelService,new X.$4pc(Xe)),Mi=Xe.set(i.$wN.ExtHostTheming,new ft.$sqc(Xe)),xi=Xe.set(i.$wN.ExtHostTimeline,new pt.$uqc(Xe,Ct)),Fi=Xe.set(i.$wN.ExtHostWebviews,new ht.$Yoc(Xe,Dt.remote,bt,kt,At)),qi=Xe.set(i.$wN.ExtHostWebviewPanels,new $t.$2oc(Xe,Fi,bt)),_i=Xe.set(i.$wN.ExtHostCustomEditors,new d.$3oc(Xe,zt,ui,Fi,qi)),Vi=Xe.set(i.$wN.ExtHostWebviewViews,new Nt.$yqc(Xe,Fi)),vi=Xe.set(i.$wN.ExtHostTesting,gt.get(st.$xpc)),en=Xe.set(i.$wN.ExtHostUriOpeners,new Se.$wqc(Xe)),tn=Xe.set(i.$wN.ExtHostProfileContentHandlers,new Te.$dqc(Xe));Xe.set(i.$wN.ExtHostInteractive,new Le.$3pc(Xe,It,Tt,Ct,kt));const zi=Xe.set(i.$wN.ExtHostChatAgents2,new m.$Foc(Xe,kt,Ct,zt)),nn=Xe.set(i.$wN.ExtHostChatVariables,new h.$Goc(Xe)),Ui=Xe.set(i.$wN.ExtHostLanguageModelTools,new te.$5pc(Xe)),Gi=Xe.set(i.$wN.ExtHostAiRelatedInformation,new r.$roc(Xe)),wn=Xe.set(i.$wN.ExtHostAiEmbeddingVector,new _.$Npc(Xe)),rn=Xe.set(i.$wN.ExtHostStatusBar,new _e.$mqc(Xe,Ct.converter)),Ki=Xe.set(i.$wN.ExtHostSpeech,new Ke.$kqc(Xe)),ki=Xe.set(i.$wN.ExtHostEmbeddings,new ge.$Mpc(Xe)),bn=Object.values(i.$wN);Xe.assertRegistered(bn);const vn=new p.$Eoc(Xe,Tt),sn=new E.$Hoc(Xe),Qi=new J.$7pc(Xe,kt),ji=new M.$Jpc(Xe);return t.$Boc.register(Ct),function(Fe,wi,Hi){function ot(ne){return(he,Me,at)=>{const St=ne(Ot=>{try{he.call(Me,Ot)}catch(Ci){P.$Z(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Ci.toString()}`,{cause:Ci})),Rt.onExtensionError(Fe.identifier,Ci)}});return at?.push(St),St}}const Et=function(){let ne=!Fe.isUnderDevelopment;function he(){ne||(kt.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")he();else{const St=at;typeof St.scheme>"u"&&he(),typeof St.exclusive=="boolean"&&(0,Ye.$8G)(Fe,"documentFiltersExclusive")}return at}}(),on={getSession(ne,he,Me){return typeof Me?.forceNewSession=="object"&&Me.forceNewSession.learnMore&&(0,Ye.$8G)(Fe,"authLearnMore"),Me?.account&&(0,Ye.$8G)(Fe,"authGetSessions"),Bt.getSession(Fe,ne,he,Me)},getAccounts(ne){return(0,Ye.$8G)(Fe,"authGetSessions"),Bt.getAccounts(ne)},async hasSession(ne,he){return(0,Ye.$8G)(Fe,"authSession"),!!await Bt.getSession(Fe,ne,he,{silent:!0})},get onDidChangeSessions(){return ot(Bt.onDidChangeSessions)},registerAuthenticationProvider(ne,he,Me,at){return Bt.registerAuthenticationProvider(ne,he,Me,at)}},yi={registerCommand(ne,he,Me){return Ct.registerCommand(!0,ne,he,Me,void 0,Fe)},registerTextEditorCommand(ne,he,Me){return Ct.registerCommand(!0,ne,(...at)=>{const St=Lt.getActiveTextEditor();if(!St){kt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return St.edit(Ot=>{he.apply(Me,[St,Ot,...at])}).then(Ot=>{Ot||kt.warn("Edits from command "+ne+" were not applied.")},Ot=>{kt.warn("An error occurred while running command "+ne,Ot)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ne,he,Me)=>((0,Ye.$8G)(Fe,"diffCommand"),Ct.registerCommand(!0,ne,async(...at)=>{const St=Tt.activeEditor(!0);if(!St){kt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(St.id);he.apply(Me,[Ot,...at])},void 0,void 0,Fe)),executeCommand(ne,...he){return Ct.executeCommand(ne,...he)},getCommands(ne=!1){return Ct.getCommands(ne)}},Oi={get machineId(){return Dt.telemetryInfo.machineId},get sessionId(){return Dt.telemetryInfo.sessionId},get language(){return Dt.environment.appLanguage},get appName(){return Dt.environment.appName},get appRoot(){return Dt.environment.appRoot?.fsPath??""},get appHost(){return Dt.environment.appHost},get uriScheme(){return Dt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return ot(wt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$8G)(Fe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$8G)(Fe,"telemetry"),ot(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.$mQ)(Dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne,he){return rt.$lQ.validateSender(ne),Rt.instantiateLogger(Fe,ne,he)},openExternal(ne,he){return Ft.openUri(ne,{allowTunneling:!!Dt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===Dt.environment.appUriScheme)return Si.createAppUri(ne);try{return await Ft.asExternalUri(ne,{allowTunneling:!!Dt.remote.authority})}catch(he){if((0,A.$Lg)(ne,A.Schemas.http)||(0,A.$Lg)(ne,A.Schemas.https))return ne;throw he}},get remoteName(){return(0,o.$fn)(Dt.remote.authority)},get remoteAuthority(){return(0,Ye.$8G)(Fe,"resolvers"),Dt.remote.authority},get uiKind(){return Dt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return ot(kt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$8G)(Fe,"resolvers"),Dt.quality},get appCommit(){return(0,Ye.$8G)(Fe,"resolvers"),Dt.commit}};Dt.environment.extensionTestsLocationURI||Object.freeze(Oi);const yn={createTestController(ne,he,Me){return vi.createTestController(Fe,ne,he,Me)},createTestObserver(){return(0,Ye.$8G)(Fe,"testObserver"),vi.createTestObserver()},runTests(ne){return(0,Ye.$8G)(Fe,"testObserver"),vi.runTests(ne)},registerTestFollowupProvider(ne){return(0,Ye.$8G)(Fe,"testObserver"),vi.registerTestFollowupProvider(ne)},get onDidChangeTestResults(){return(0,Ye.$8G)(Fe,"testObserver"),ot(vi.onResultsChanged)},get testResults(){return(0,Ye.$8G)(Fe,"testObserver"),vi.results}},ci=Dt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,Bi={getExtension(ne,he){(0,Ye.$7G)(Fe,"extensionsAny")||(he=!1);const Me=wi.mine.getExtensionDescription(ne);if(Me)return new fe.$tpc(jt,Fe.identifier,Me,ci,!1);if(he){const at=wi.all.getExtensionDescription(ne);if(at)return new fe.$tpc(jt,Fe.identifier,at,ci,!0)}},get all(){const ne=[];for(const he of wi.mine.getAllExtensionDescriptions())ne.push(new fe.$tpc(jt,Fe.identifier,he,ci,!1));return ne},get allAcrossExtensionHosts(){(0,Ye.$8G)(Fe,"extensionsAny");const ne=new D.$pn(wi.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),he=[];for(const Me of wi.all.getAllExtensionDescriptions()){const at=!ne.has(Me.identifier);he.push(new fe.$tpc(jt,Fe.identifier,Me,ci,at))}return he},get onDidChange(){return(0,Ye.$7G)(Fe,"extensionsAny")?ot(I.Event.any(wi.mine.onDidChange,wi.all.onDidChange)):ot(wi.mine.onDidChange)}},an={createDiagnosticCollection(ne){return le.createDiagnosticCollection(Fe.identifier,ne)},get onDidChangeDiagnostics(){return ot(le.onDidChangeDiagnostics)},getDiagnostics:ne=>le.getDiagnostics(ne),getLanguages(){return H.getLanguages()},setTextDocumentLanguage(ne,he){return H.changeLanguage(ne.uri,he)},match(ne,he){const Me=ee.LanguageSelector.from(ne);let at;return(0,R.$uu)(Me)&&(at=It.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Ot=>Ot.document===he))?.apiNotebook),(0,R.$tu)(Me,he.uri,he.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ne,he,Me){return Ee.registerCodeActionProvider(Fe,Et(ne),he,Me)},registerDocumentPasteEditProvider(ne,he,Me){return(0,Ye.$8G)(Fe,"documentPaste"),Ee.registerDocumentPasteEditProvider(Fe,Et(ne),he,Me)},registerCodeLensProvider(ne,he){return Ee.registerCodeLensProvider(Fe,Et(ne),he)},registerDefinitionProvider(ne,he){return Ee.registerDefinitionProvider(Fe,Et(ne),he)},registerDeclarationProvider(ne,he){return Ee.registerDeclarationProvider(Fe,Et(ne),he)},registerImplementationProvider(ne,he){return Ee.registerImplementationProvider(Fe,Et(ne),he)},registerTypeDefinitionProvider(ne,he){return Ee.registerTypeDefinitionProvider(Fe,Et(ne),he)},registerHoverProvider(ne,he){return Ee.registerHoverProvider(Fe,Et(ne),he,Fe.identifier)},registerEvaluatableExpressionProvider(ne,he){return Ee.registerEvaluatableExpressionProvider(Fe,Et(ne),he,Fe.identifier)},registerInlineValuesProvider(ne,he){return Ee.registerInlineValuesProvider(Fe,Et(ne),he,Fe.identifier)},registerDocumentHighlightProvider(ne,he){return Ee.registerDocumentHighlightProvider(Fe,Et(ne),he)},registerMultiDocumentHighlightProvider(ne,he){return Ee.registerMultiDocumentHighlightProvider(Fe,Et(ne),he)},registerLinkedEditingRangeProvider(ne,he){return Ee.registerLinkedEditingRangeProvider(Fe,Et(ne),he)},registerReferenceProvider(ne,he){return Ee.registerReferenceProvider(Fe,Et(ne),he)},registerRenameProvider(ne,he){return Ee.registerRenameProvider(Fe,Et(ne),he)},registerNewSymbolNamesProvider(ne,he){return(0,Ye.$8G)(Fe,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Fe,Et(ne),he)},registerDocumentSymbolProvider(ne,he,Me){return Ee.registerDocumentSymbolProvider(Fe,Et(ne),he,Me)},registerWorkspaceSymbolProvider(ne){return Ee.registerWorkspaceSymbolProvider(Fe,ne)},registerDocumentFormattingEditProvider(ne,he){return Ee.registerDocumentFormattingEditProvider(Fe,Et(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return Ee.registerDocumentRangeFormattingEditProvider(Fe,Et(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Me,...at){return Ee.registerOnTypeFormattingEditProvider(Fe,Et(ne),he,[Me].concat(at))},registerDocumentSemanticTokensProvider(ne,he,Me){return Ee.registerDocumentSemanticTokensProvider(Fe,Et(ne),he,Me)},registerDocumentRangeSemanticTokensProvider(ne,he,Me){return Ee.registerDocumentRangeSemanticTokensProvider(Fe,Et(ne),he,Me)},registerSignatureHelpProvider(ne,he,Me,...at){return typeof Me=="object"?Ee.registerSignatureHelpProvider(Fe,Et(ne),he,Me):Ee.registerSignatureHelpProvider(Fe,Et(ne),he,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(ne,he,...Me){return Ee.registerCompletionItemProvider(Fe,Et(ne),he,Me)},registerInlineCompletionItemProvider(ne,he,Me){return he.handleDidShowCompletionItem&&(0,Ye.$8G)(Fe,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$8G)(Fe,"inlineCompletionsAdditions"),Me&&(0,Ye.$8G)(Fe,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Fe,Et(ne),he,Me)},registerInlineEditProvider(ne,he){return(0,Ye.$8G)(Fe,"inlineEdit"),Ee.registerInlineEditProvider(Fe,Et(ne),he)},registerDocumentLinkProvider(ne,he){return Ee.registerDocumentLinkProvider(Fe,Et(ne),he)},registerColorProvider(ne,he){return Ee.registerColorProvider(Fe,Et(ne),he)},registerFoldingRangeProvider(ne,he){return Ee.registerFoldingRangeProvider(Fe,Et(ne),he)},registerSelectionRangeProvider(ne,he){return Ee.registerSelectionRangeProvider(Fe,ne,he)},registerCallHierarchyProvider(ne,he){return Ee.registerCallHierarchyProvider(Fe,ne,he)},registerTypeHierarchyProvider(ne,he){return Ee.registerTypeHierarchyProvider(Fe,ne,he)},setLanguageConfiguration:(ne,he)=>Ee.setLanguageConfiguration(Fe,ne,he),getTokenInformationAtPosition(ne,he){return(0,Ye.$8G)(Fe,"tokenInformation"),H.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return Ee.registerInlayHintsProvider(Fe,ne,he)},createLanguageStatusItem(ne,he){return H.createLanguageStatusItem(Fe,ne,he)},registerDocumentDropEditProvider(ne,he,Me){return Ee.registerDocumentOnDropEditProvider(Fe,ne,he,(0,Ye.$7G)(Fe,"documentPaste")?Me:void 0)}},cn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(ne,he,Me){$.URI.isUri(ne)&&ne.scheme===A.Schemas.vscodeRemote&&!ne.authority&&At.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await($.URI.isUri(ne)?Promise.resolve(Ji.openTextDocument(ne)):Promise.resolve(ne));return Lt.showTextDocument(at,he,Me)},createTextEditorDecorationType(ne){return Lt.createTextEditorDecorationType(Fe,ne)},onDidChangeActiveTextEditor(ne,he,Me){return ot(Lt.onDidChangeActiveTextEditor)(ne,he,Me)},onDidChangeVisibleTextEditors(ne,he,Me){return ot(Lt.onDidChangeVisibleTextEditors)(ne,he,Me)},onDidChangeTextEditorSelection(ne,he,Me){return ot(Lt.onDidChangeTextEditorSelection)(ne,he,Me)},onDidChangeTextEditorOptions(ne,he,Me){return ot(Lt.onDidChangeTextEditorOptions)(ne,he,Me)},onDidChangeTextEditorVisibleRanges(ne,he,Me){return ot(Lt.onDidChangeTextEditorVisibleRanges)(ne,he,Me)},onDidChangeTextEditorViewColumn(ne,he,Me){return ot(Lt.onDidChangeTextEditorViewColumn)(ne,he,Me)},onDidCloseTerminal(ne,he,Me){return ot(wt.onDidCloseTerminal)(ne,he,Me)},onDidOpenTerminal(ne,he,Me){return ot(wt.onDidOpenTerminal)(ne,he,Me)},onDidChangeActiveTerminal(ne,he,Me){return ot(wt.onDidChangeActiveTerminal)(ne,he,Me)},onDidChangeTerminalDimensions(ne,he,Me){return(0,Ye.$8G)(Fe,"terminalDimensions"),ot(wt.onDidChangeTerminalDimensions)(ne,he,Me)},onDidChangeTerminalState(ne,he,Me){return ot(wt.onDidChangeTerminalState)(ne,he,Me)},onDidWriteTerminalData(ne,he,Me){return(0,Ye.$8G)(Fe,"terminalDataWriteEvent"),ot(wt.onDidWriteTerminalData)(ne,he,Me)},onDidExecuteTerminalCommand(ne,he,Me){return(0,Ye.$8G)(Fe,"terminalExecuteCommandEvent"),ot(wt.onDidExecuteTerminalCommand)(ne,he,Me)},onDidChangeTerminalShellIntegration(ne,he,Me){return(0,Ye.$8G)(Fe,"terminalShellIntegration"),ot(Qt.onDidChangeTerminalShellIntegration)(ne,he,Me)},onDidStartTerminalShellExecution(ne,he,Me){return(0,Ye.$8G)(Fe,"terminalShellIntegration"),ot(Qt.onDidStartTerminalShellExecution)(ne,he,Me)},onDidEndTerminalShellExecution(ne,he,Me){return(0,Ye.$8G)(Fe,"terminalShellIntegration"),ot(Qt.onDidEndTerminalShellExecution)(ne,he,Me)},get state(){return Ft.getState()},onDidChangeWindowState(ne,he,Me){return ot(Ft.onDidChangeWindowState)(ne,he,Me)},showInformationMessage(ne,...he){return Qi.showMessage(Fe,T.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return Qi.showMessage(Fe,T.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return Qi.showMessage(Fe,T.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Me){return Ge.showQuickPick(Fe,ne,he,Me)},showWorkspaceFolderPick(ne){return Ge.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Ge.showInput(ne,he)},showOpenDialog(ne){return ji.showOpenDialog(Fe,ne)},showSaveDialog(ne){return ji.showSaveDialog(ne)},createStatusBarItem(ne,he,Me){let at,St,Ot;return typeof ne=="string"?(at=ne,St=he,Ot=Me):(St=ne,Ot=he),rn.createStatusBarEntry(Fe,at,St,Ot)},setStatusBarMessage(ne,he){return rn.setStatusBarMessage(ne,he)},withScmProgress(ne){return At.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Ut.withProgress(Fe,{location:Q.ProgressLocation.SourceControl},(he,Me)=>ne({report(at){}}))},withProgress(ne,he){return Ut.withProgress(Fe,ne,he)},createOutputChannel(ne,he){return Pi.createOutputChannel(ne,he,Fe)},createWebviewPanel(ne,he,Me,at){return qi.createWebviewPanel(Fe,ne,he,Me,at)},createWebviewTextEditorInset(ne,he,Me,at){return(0,Ye.$8G)(Fe,"editorInsets"),Re.createWebviewEditorInset(ne,he,Me,at,Fe)},createTerminal(ne,he,Me){return typeof ne=="object"?"pty"in ne?wt.createExtensionTerminal(ne):wt.createTerminalFromOptions(ne):wt.createTerminal(ne,he,Me)},registerTerminalLinkProvider(ne){return wt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return wt.registerProfileProvider(Fe,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,Ye.$8G)(Fe,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(ne,Fe.identifier.value,he)},registerTreeDataProvider(ne,he){return ye.registerTreeDataProvider(ne,he,Fe)},createTreeView(ne,he){return ye.createTreeView(ne,he,Fe)},registerWebviewPanelSerializer:(ne,he)=>qi.registerWebviewPanelSerializer(Fe,ne,he),registerCustomEditorProvider:(ne,he,Me={})=>_i.registerCustomEditorProvider(Fe,ne,he,Me),registerFileDecorationProvider(ne){return hi.registerFileDecorationProvider(ne,Fe)},registerUriHandler(ne){return Si.registerUriHandler(Fe,ne)},createQuickPick(){return Ge.createQuickPick(Fe)},createInputBox(){return Ge.createInputBox(Fe)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Me){return ot(Mi.onDidChangeActiveColorTheme)(ne,he,Me)},registerWebviewViewProvider(ne,he,Me){return Vi.registerWebviewViewProvider(Fe,ne,he,Me?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Me){return ot(It.onDidChangeActiveNotebookEditor)(ne,he,Me)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ne,he,Me){return ot(Ri.onDidChangeNotebookEditorSelection)(ne,he,Me)},onDidChangeNotebookEditorVisibleRanges(ne,he,Me){return ot(Ri.onDidChangeNotebookEditorVisibleRanges)(ne,he,Me)},showNotebookDocument(ne,he){return It.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Me){return(0,Ye.$8G)(Fe,"externalUriOpener"),en.registerExternalUriOpener(Fe.identifier,ne,he,Me)},registerProfileContentHandler(ne,he){return(0,Ye.$8G)(Fe,"profileContentHandlers"),tn.registerProfileContentHandler(Fe,ne,he)},registerQuickDiffProvider(ne,he,Me,at){return(0,Ye.$8G)(Fe,"quickDiffProvider"),Pt.registerQuickDiffProvider(Et(ne),he,Me,at)},get tabGroups(){return _t.tabGroups},registerShareProvider(ne,he){return(0,Ye.$8G)(Fe,"shareProvider"),ti.registerShareProvider(Et(ne),he)}},Ji={get rootPath(){return At.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(ne){throw new P.$8("rootPath")},getWorkspaceFolder(ne){return bt.getWorkspaceFolder(ne)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(ne){throw new P.$8("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(ne){throw new P.$8("workspaceFile")},updateWorkspaceFolders:(ne,he,...Me)=>bt.updateWorkspaceFolders(Fe,ne,he||0,...Me),onDidChangeWorkspaceFolders:function(ne,he,Me){return ot(bt.onDidChangeWorkspace)(ne,he,Me)},asRelativePath:(ne,he)=>bt.getRelativePath(ne,he),findFiles:(ne,he,Me,at)=>bt.findFiles(ne,he,Me,Fe.identifier,at),findFiles2:(ne,he,Me)=>((0,Ye.$8G)(Fe,"findFiles2"),bt.findFiles2(ne,he,Fe.identifier,Me)),findTextInFiles:(ne,he,Me,at)=>{(0,Ye.$8G)(Fe,"findTextInFiles");let St,Ot;return typeof he=="object"?(St=he,Ot=Me):(St={},Ot=he,at=Me),bt.findTextInFiles(ne,St||{},Ot,Fe.identifier,at)},save:ne=>bt.save(ne),saveAs:ne=>bt.saveAs(ne),saveAll:ne=>bt.saveAll(ne),applyEdit(ne,he){return vn.applyWorkspaceEdit(ne,Fe,he)},createFileSystemWatcher:(ne,he,Me,at)=>{let St;return typeof he=="boolean"?St={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Me,ignoreDeleteEvents:!!at,correlate:!1}:he&&((0,Ye.$8G)(Fe,"createFileSystemWatcher"),St={...he,correlate:!0}),Ze.createFileSystemWatcher(bt,Fe,ne,St)},get textDocuments(){return zt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw new P.$8("textDocuments")},openTextDocument(ne){let he;const Me=ne;if(typeof ne=="string")he=Promise.resolve($.URI.file(ne));else if($.URI.isUri(ne))he=Promise.resolve(ne);else if(!Me||typeof Me=="object")he=zt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),zt.ensureDocumentData(at).then(St=>St.document)))},onDidOpenTextDocument:(ne,he,Me)=>ot(zt.onDidAddDocument)(ne,he,Me),onDidCloseTextDocument:(ne,he,Me)=>ot(zt.onDidRemoveDocument)(ne,he,Me),onDidChangeTextDocument:(ne,he,Me)=>ot(zt.onDidChangeDocument)(ne,he,Me),onDidSaveTextDocument:(ne,he,Me)=>ot(zt.onDidSaveDocument)(ne,he,Me),onWillSaveTextDocument:(ne,he,Me)=>ot(Ni.getOnWillSaveTextDocumentEvent(Fe))(ne,he,Me),get notebookDocuments(){return It.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Me;if($.URI.isUri(ne))Me=ne,await It.openNotebookDocument(ne);else if(typeof ne=="string")Me=$.URI.revive(await It.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ne,he,Me){return ot(Di.onDidSaveNotebookDocument)(ne,he,Me)},onDidChangeNotebookDocument(ne,he,Me){return ot(Di.onDidChangeNotebookDocument)(ne,he,Me)},onWillSaveNotebookDocument(ne,he,Me){return ot(Li.getOnWillSaveNotebookDocumentEvent(Fe))(ne,he,Me)},get onDidOpenNotebookDocument(){return ot(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(It.onDidCloseNotebookDocument)},registerNotebookSerializer(ne,he,Me,at){return It.registerNotebookSerializer(Fe,ne,he,Me,(0,Ye.$7G)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ne,he,Me)=>ot(Hi.onDidChangeConfiguration)(ne,he,Me),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Hi.getConfiguration(ne,he,Fe)},registerTextDocumentContentProvider(ne,he){return gi.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(At.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Fe,ne,he)),registerFileSystemProvider(ne,he,Me){return(0,O.$Qc)(Be.registerFileSystemProvider(Fe,ne,he,Me),Zt.addFileSystemProvider(ne,he,Me))},get fs(){return Zt.value},registerFileSearchProvider:(ne,he)=>((0,Ye.$8G)(Fe,"fileSearchProvider"),oi.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,Ye.$8G)(Fe,"textSearchProvider"),oi.registerTextSearchProvider(ne,he)),registerAITextSearchProvider:(ne,he)=>((0,Ye.$8G)(Fe,"aiTextSearchProvider"),(0,Ye.$8G)(Fe,"textSearchProvider"),oi.registerAITextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,Ye.$8G)(Fe,"resolvers"),jt.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,Ye.$8G)(Fe,"resolvers"),ii.$registerResourceLabelFormatter(ne)),getRemoteExecServer:ne=>((0,Ye.$8G)(Fe,"resolvers"),jt.getRemoteExecServer(ne)),onDidCreateFiles:(ne,he,Me)=>ot(Ze.onDidCreateFile)(ne,he,Me),onDidDeleteFiles:(ne,he,Me)=>ot(Ze.onDidDeleteFile)(ne,he,Me),onDidRenameFiles:(ne,he,Me)=>ot(Ze.onDidRenameFile)(ne,he,Me),onWillCreateFiles:(ne,he,Me)=>ot(Ze.getOnWillCreateFileEvent(Fe))(ne,he,Me),onWillDeleteFiles:(ne,he,Me)=>ot(Ze.getOnWillDeleteFileEvent(Fe))(ne,he,Me),onWillRenameFiles:(ne,he,Me)=>ot(Ze.getOnWillRenameFileEvent(Fe))(ne,he,Me),openTunnel:ne=>((0,Ye.$8G)(Fe,"tunnels"),Mt.openTunnel(Fe,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ye.$8G)(Fe,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(ne,he,Me)=>((0,Ye.$8G)(Fe,"tunnels"),ot(Mt.onDidChangeTunnels)(ne,he,Me)),registerPortAttributesProvider:(ne,he)=>((0,Ye.$8G)(Fe,"portsAttributes"),Mt.registerPortsAttributesProvider(ne,he)),registerTunnelProvider:(ne,he)=>((0,Ye.$8G)(Fe,"tunnelFactory"),Mt.registerTunnelProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,Ye.$8G)(Fe,"timeline"),xi.registerTimelineProvider(ne,he,Fe.identifier,Ct.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:ne=>((0,Ye.$8G)(Fe,"workspaceTrust"),bt.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Me)=>ot(bt.onDidGrantWorkspaceTrust)(ne,he,Me),registerEditSessionIdentityProvider:(ne,he)=>((0,Ye.$8G)(Fe,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(ne,he)),onWillCreateEditSessionIdentity:(ne,he,Me)=>((0,Ye.$8G)(Fe,"editSessionIdentityProvider"),ot(bt.getOnWillCreateEditSessionIdentityEvent(Fe))(ne,he,Me)),registerCanonicalUriProvider:(ne,he)=>((0,Ye.$8G)(Fe,"canonicalUriProvider"),bt.registerCanonicalUriProvider(ne,he)),getCanonicalUri:(ne,he,Me)=>((0,Ye.$8G)(Fe,"canonicalUriProvider"),bt.provideCanonicalUri(ne,he,Me))},ln={get inputBox(){return At.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Fe)},createSourceControl(ne,he,Me){return ut.createSourceControl(Fe,ne,he,Me)}},En={createCommentController(ne,he){return ai.createCommentController(Fe,ne,he)}},un={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){return yt.activeStackItem},registerDebugVisualizationProvider(ne,he){return(0,Ye.$8G)(Fe,"debugVisualization"),yt.registerDebugVisualizationProvider(Fe,ne,he)},registerDebugVisualizationTreeProvider(ne,he){return(0,Ye.$8G)(Fe,"debugVisualization"),yt.registerDebugVisualizationTree(Fe,ne,he)},onDidStartDebugSession(ne,he,Me){return ot(yt.onDidStartDebugSession)(ne,he,Me)},onDidTerminateDebugSession(ne,he,Me){return ot(yt.onDidTerminateDebugSession)(ne,he,Me)},onDidChangeActiveDebugSession(ne,he,Me){return ot(yt.onDidChangeActiveDebugSession)(ne,he,Me)},onDidReceiveDebugSessionCustomEvent(ne,he,Me){return ot(yt.onDidReceiveDebugSessionCustomEvent)(ne,he,Me)},onDidChangeBreakpoints(ne,he,Me){return ot(yt.onDidChangeBreakpoints)(ne,he,Me)},onDidChangeActiveStackItem(ne,he,Me){return ot(yt.onDidChangeActiveStackItem)(ne,he,Me)},registerDebugConfigurationProvider(ne,he,Me){return yt.registerDebugConfigurationProvider(ne,he,Me||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return yt.registerDebugAdapterDescriptorFactory(Fe,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return yt.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Me){return!Me||typeof Me=="object"&&"configuration"in Me?yt.startDebugging(ne,he,{parentSession:Me}):yt.startDebugging(ne,he,Me||{})},stopDebugging(ne){return yt.stopDebugging(ne)},addBreakpoints(ne){return yt.addBreakpoints(ne)},removeBreakpoints(ne){return yt.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return yt.asDebugSourceUri(ne,he)}},hn={registerTaskProvider:(ne,he)=>Ht.registerTaskProvider(Fe,ne,he),fetchTasks:ne=>Ht.fetchTasks(ne),executeTask:ne=>Ht.executeTask(Fe,ne),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ne,he,Me)=>ot(Ht.onDidStartTask)(ne,he,Me),onDidEndTask:(ne,he,Me)=>ot(Ht.onDidEndTask)(ne,he,Me),onDidStartTaskProcess:(ne,he,Me)=>ot(Ht.onDidStartTaskProcess)(ne,he,Me),onDidEndTaskProcess:(ne,he,Me)=>ot(Ht.onDidEndTaskProcess)(ne,he,Me)},Sn={createNotebookController(ne,he,Me,at,St){return $i.createNotebookController(Fe,ne,he,Me,at,(0,Ye.$7G)(Fe,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>It.registerNotebookCellStatusBarItemProvider(Fe,ne,he),createRendererMessaging(ne){return Ai.createRendererMessaging(Fe,ne)},createNotebookControllerDetectionTask(ne){return(0,Ye.$8G)(Fe,"notebookKernelSource"),$i.createNotebookControllerDetectionTask(Fe,ne)},registerKernelSourceActionProvider(ne,he){return(0,Ye.$8G)(Fe,"notebookKernelSource"),$i.registerKernelSourceActionProvider(Fe,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Me){return(0,Ye.$8G)(Fe,"notebookCellExecutionState"),ot($i.onDidChangeNotebookCellExecutionState)(ne,he,Me)}},Dn={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Me=!ne||typeof ne[0]!="object"?ne:ne[0];return pi.getMessage(Fe.identifier.value,{message:he,args:Me})}return pi.getMessage(Fe.identifier.value,ne[0])},get bundle(){return pi.getBundle(Fe.identifier.value)},get uri(){return pi.getBundleUri(Fe.identifier.value)}},dn={_version:1,transferActiveChat(ne){return(0,Ye.$8G)(Fe,"interactive"),zi.transferActiveChat(ne)}},Xi={getRelatedInformation(ne,he){return(0,Ye.$8G)(Fe,"aiRelatedInformation"),Gi.getRelatedInformation(Fe,ne,he)},registerRelatedInformationProvider(ne,he){return(0,Ye.$8G)(Fe,"aiRelatedInformation"),Gi.registerRelatedInformationProvider(Fe,ne,he)},registerEmbeddingVectorProvider(ne,he){return(0,Ye.$8G)(Fe,"aiRelatedInformation"),wn.registerEmbeddingVectorProvider(Fe,ne,he)}},fn={_version:1,registerChatResponseProvider(ne,he,Me){return(0,Ye.$8G)(Fe,"chatProvider"),Wt.registerLanguageModel(Fe,ne,he,Me)},registerChatVariableResolver(ne,he,Me,at,St,Ot,Ci,Wi){return(0,Ye.$8G)(Fe,"chatVariableResolver"),nn.registerVariableResolver(Fe,ne,he,Me,at,St,Ot,Ci,Wi?.id)},registerMappedEditsProvider(ne,he){return(0,Ye.$8G)(Fe,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Fe,ne,he)},createChatParticipant(ne,he){return zi.createChatAgent(Fe,ne,he)},createDynamicChatParticipant(ne,he,Me){return(0,Ye.$8G)(Fe,"chatParticipantPrivate"),zi.createDynamicChatAgent(Fe,ne,he,Me)}},gn={selectChatModels:ne=>Wt.selectLanguageModels(Fe,ne??{}),onDidChangeChatModels:(ne,he,Me)=>Wt.onDidChangeProviders(ne,he,Me),registerChatModelProvider:(ne,he,Me)=>((0,Ye.$8G)(Fe,"chatProvider"),Wt.registerLanguageModel(Fe,ne,he,Me)),get embeddingModels(){return(0,Ye.$8G)(Fe,"embeddings"),ki.embeddingsModels},onDidChangeEmbeddingModels:(ne,he,Me)=>((0,Ye.$8G)(Fe,"embeddings"),ki.onDidChange(ne,he,Me)),registerEmbeddingsProvider(ne,he){return(0,Ye.$8G)(Fe,"embeddings"),ki.registerEmbeddingsProvider(Fe,ne,he)},async computeEmbeddings(ne,he,Me){return(0,Ye.$8G)(Fe,"embeddings"),ki.computeEmbeddings(ne,he,Me)},registerTool(ne,he){return(0,Ye.$8G)(Fe,"lmTools"),Ui.registerTool(Fe,ne,he)},invokeTool(ne,he,Me){return(0,Ye.$8G)(Fe,"lmTools"),Ui.invokeTool(ne,he,Me)},get tools(){return(0,Ye.$8G)(Fe,"lmTools"),Ui.tools}},mn={registerSpeechProvider(ne,he){return(0,Ye.$8G)(Fe,"speech"),Ki.registerProvider(Fe.identifier,ne,he)}};return{version:Dt.version,ai:Xi,authentication:on,commands:yi,comments:En,chat:fn,debug:un,env:Oi,extensions:Bi,interactive:dn,l10n:Dn,languages:an,lm:gn,notebooks:Sn,scm:ln,speech:mn,tasks:hn,tests:yn,window:cn,workspace:Ji,Breakpoint:Q.$AO,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.$vP,CallHierarchyIncomingCall:Q.$YN,CallHierarchyItem:Q.$XN,CallHierarchyOutgoingCall:Q.$ZN,CancellationError:P.$4,CancellationTokenSource:v.$ue,CandidatePortSource:i.CandidatePortSource,CodeAction:Q.$UN,CodeActionKind:Q.$VN,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$1N,Color:Q.$bO,ColorInformation:Q.$cO,ColorPresentation:Q.$dO,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CompletionItem:Q.$8N,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$9N,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$lO,DebugAdapterExecutable:Q.$EO,DebugAdapterInlineImplementation:Q.$HO,DebugAdapterNamedPipeServer:Q.$GO,DebugAdapterServer:Q.$FO,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.$XO,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$NN,DiagnosticRelatedInformation:Q.$MN,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$xN,DocumentHighlight:Q.$QN,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.$RN,DocumentLink:Q.$aO,DocumentSymbol:Q.$TN,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$KO,InlineValueText:Q.$LO,InlineValueVariableLookup:Q.$MO,InlineValueEvaluatableExpression:Q.$NO,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:I.$je,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$ZO,FileDecoration2:Q.$ZO,FileSystemError:Q.$QO,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:Q.$RO,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$CO,InlineCompletionItem:Q.$0N,InlineCompletionList:Q.$$N,Hover:Q.$ON,VerboseHover:Q.$PN,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:y.IndentAction,Location:Q.$LN,MarkdownString:Q.$2N,OverviewRulerLane:c.OverviewRulerLane,ParameterInformation:Q.$3N,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$yN,ProcessExecution:Q.$jO,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.$YO,Range:Q.$zN,RelativePattern:Q.$yO,Selection:Q.$AN,SelectionRange:Q.$WN,SemanticTokens:Q.$UO,SemanticTokensBuilder:Q.$TO,SemanticTokensEdit:Q.$VO,SemanticTokensEdits:Q.$WO,SemanticTokensLegend:Q.$SO,ShellExecution:Q.$kO,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$5N,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$4N,SnippetString:Q.$KN,SourceBreakpoint:Q.$BO,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$SN,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$mO,TaskGroup:Q.$iO,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$eO,TerminalQuickFixTerminalCommand:Q.$gO,TerminalQuickFixOpener:Q.$fO,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$hO,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$GN,SnippetTextEdit:Q.$IN,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$xO,ThemeIcon:Q.$wO,TreeItem:Q.$nO,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$jP,UIKind:di.UIKind,Uri:$.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$JN,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.$tO,DocumentDropOrPasteEditKind:Q.$uO,DocumentPasteEdit:Q.$vO,InlayHint:Q.$7N,InlayHintLabelPart:Q.$6N,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$FN,ResolvedAuthority:Q.$DN,ManagedResolvedAuthority:Q.$EN,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$0O,NotebookRange:Q.$2O,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$3O,NotebookData:Q.$4O,NotebookRendererScript:Q.$8O,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$6O,NotebookCellOutputItem:Q.$5O,NotebookCellStatusBarItem:Q.$7O,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$HN,NotebookKernelSourceAction:Q.$9O,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.$_O,LinkedEditingRanges:Q.$$O,TestResultState:Q.TestResultState,TestRunRequest:Q.$aP,TestMessage:Q.$bP,TestTag:Q.$cP,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Q.$sO,DataTransferItem:Q.$oO,TestCoverageCount:Q.$dP,FileCoverage:Q.$fP,FileCoverage2:Q.$fP,StatementCoverage:Q.$gP,BranchCoverage:Q.$hP,DeclarationCoverage:Q.$iP,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$kP,TabInputTextDiff:Q.$lP,TabInputTextMerge:Q.$mP,TabInputCustom:Q.$nP,TabInputNotebook:Q.$pP,TabInputNotebookDiff:Q.$qP,TabInputWebview:Q.$oP,TabInputTerminal:Q.$rP,TabInputInteractiveWindow:Q.$sP,TabInputChat:Q.$tP,TabInputTextMultiDiff:Q.$uP,TelemetryTrustedValue:s.$up,LogLevel:n.LogLevel,EditSessionIdentityMatch:l.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.$IO,DebugThread:Q.$JO,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.$wP,ChatResponseFileTreePart:Q.$AP,ChatResponseAnchorPart:Q.$BP,ChatResponseProgressPart:Q.$CP,ChatResponseProgressPart2:Q.$DP,ChatResponseReferencePart:Q.$GP,ChatResponseWarningPart:Q.$EP,ChatResponseTextEditPart:Q.$HP,ChatResponseMarkdownWithVulnerabilitiesPart:Q.$xP,ChatResponseCommandButtonPart:Q.$FP,ChatResponseDetectedParticipantPart:Q.$yP,ChatResponseConfirmationPart:Q.$zP,ChatRequestTurn:Q.$IP,ChatResponseTurn:Q.$JP,ChatLocation:Q.ChatLocation,ChatRequestEditorData:Q.$KP,ChatRequestNotebookData:Q.$LP,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.$NP,LanguageModelChatMessageFunctionResultPart:Q.$MP,LanguageModelChatResponseTextPart:Q.$PP,LanguageModelChatResponseFunctionUsePart:Q.$OP,LanguageModelError:Q.$TP,NewSymbolName:Q.$PO,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.$UP,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(Oe[276],Ne([1,0,60,128,45,122,46,33,57,56,131,133,134,88,92,84,121,68,50,87,66,70,215,11,132,85,86,90,94,126,95]),function(we,e,v,P,I,O,A,T,$,a,R,y,c,D,f,n,o,s,l,i,r,t,g,u,p,m,h,E,S,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Os)(m.$npc,m.$mpc,v.InstantiationType.Delayed),(0,v.$Os)(u.$$j,g.$Cqc,v.InstantiationType.Delayed),(0,v.$Os)(n.$soc,n.$toc,v.InstantiationType.Delayed),(0,v.$Os)(T.$pQ,T.$oQ,v.InstantiationType.Eager),(0,v.$Os)(E.$Coc,E.$Doc,v.InstantiationType.Eager),(0,v.$Os)(S.$hpc,S.$ipc,v.InstantiationType.Eager),(0,v.$Os)(A.$Roc,A.$Poc,v.InstantiationType.Eager),(0,v.$Os)(s.$Toc,s.$Soc,v.InstantiationType.Eager),(0,v.$Os)(k.$xpc,k.$ypc,v.InstantiationType.Eager),(0,v.$Os)(y.$Cpc,y.$Gpc,v.InstantiationType.Eager),(0,v.$Os)(O.$Ipc,O.$Hpc,v.InstantiationType.Eager),(0,v.$Os)($.$eQ,$.$dQ,v.InstantiationType.Eager),(0,v.$Os)(h.$opc,h.$ppc,v.InstantiationType.Eager),(0,v.$Os)(l.$woc,l.$voc,v.InstantiationType.Eager),(0,v.$Os)(P.$cqc,P.$bqc,v.InstantiationType.Delayed),(0,v.$Os)(c.$Ypc,c.$Zpc,v.InstantiationType.Eager),(0,v.$Os)(D.$apc,D.$_oc,v.InstantiationType.Eager),(0,v.$Os)(R.$pqc,R.$oqc,v.InstantiationType.Eager),(0,v.$Os)(a.$dpc,a.$gpc,v.InstantiationType.Eager),(0,v.$Os)(w.$qqc,w.$rqc,v.InstantiationType.Eager),(0,v.$Os)(f.$UFb,f.$VFb,v.InstantiationType.Eager),(0,v.$Os)(o.$Aqc,o.$zqc,v.InstantiationType.Eager),(0,v.$Os)(I.$Ooc,I.$Noc,v.InstantiationType.Eager),(0,v.$Os)(i.$kpc,i.$jpc,v.InstantiationType.Eager),(0,v.$Os)(r.$nQ,r.$kQ,v.InstantiationType.Eager),(0,v.$Os)(t.$4oc,t.$5oc,v.InstantiationType.Eager),(0,v.$Os)(p.$vpc,p.$wpc,v.InstantiationType.Eager)}),define(Oe[277],Ne([1,0,275,47,2,272,7,10,222]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Osc=void 0;class a extends O.$Fqc{j(){}getModule(D,f){for(const n of this.b){const o=n(D);if(o){D=o;break}}if(this.a.has(D))return this.a.get(D).load(D,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends P.$rpc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$Nsc);const D=this.h.invokeFunction(v.$Bqc);this.r=this.h.createInstance(a,D,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(D){return D.browser}async xb(D,f,n){f=f.with({path:y(f.path,".js")});const o=D?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=I.URI.revive(await this.C.$asBrowserUri(f)),l=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),l.status!==200)throw new Error(l.statusText);const i=await l.text(),r=`${f.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let g;try{g=new Function("module","exports","require",t)}catch(h){throw console.error(o?`Loading code for extension ${o} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${f.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}D&&await this.w.initializeLocalizedMessages(D);const u={},p={exports:u},m=h=>{const E=this.r.getModule(h,f);if(E===void 0)throw new Error(`Cannot load module '${h}'`);return E};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),g(p,u,m),p.exports!==u?p.exports:u}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(D){}async Bb(D=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+D;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Dh)(10)}}e.$Osc=R;function y(c,D){return c.endsWith(D)?c:c+D}}),define(Oe[278],Ne([1,0,73,60,11,47,187,91,277]),function(we,e,v,P,I,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.$Os)(I.$0j,new v.$zi(A.$Eqc,[!0],!0)),(0,P.$Os)(O.$spc,$.$Osc,P.InstantiationType.Eager),(0,P.$Os)(T.$Uoc,T.$Voc,P.InstantiationType.Eager)}),define(Oe[286],Ne([1,0,22,6,83,273,224,19,64,15,2,276,278]),function(we,e,v,P,I,O,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=qe(T),$=qe($);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function D(g){return/^(file|vscode-remote):/i.test(g)}const f=fetch.bind(self);function n(g){self.fetch=async function(u,p){return u instanceof Request||D(String(u))&&(u=(await g(R.URI.parse(String(u)))).toString(!0)),f(u,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,p,m,h,E){(async()=>(D(p.toString())&&(p=(await g(R.URI.parse(p.toString()))).toString(!0)),super.open(u,p,m??!0,h,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(u,p){if(/^file:/i.test(u.toString()))u=a.$Wg.uriToBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(k){function C(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const d=fetch.bind(self);self.fetch=function(F,N){return F instanceof Request?d(F,N):d(C(F),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,N,M,V,W){return super.open(F,C(N),M??!0,V,W)}};const b=importScripts.bind(self);self.importScripts=(...F)=>{b(...F.map(C))},b(k)}.toString()}('${u}'))`;p=p||{},p.name=`${name} -> ${p.name||T.$mc(u.toString())}`;const E=new Blob([h],{type:"application/javascript"}),S=URL.createObjectURL(E);return new g(S,p)}}else self.Worker=class extends A.$Psc{constructor(g,u){super(c,g,{name:T.$mc(g.toString()),...u})}};const o=new class{constructor(){this.pid=void 0}exit(g){y()}};class s{constructor(){const u=new MessageChannel,p=new P.$je;let m=!1;c(u.port2,[u.port2]),u.port1.onmessage=h=>{const{data:E}=h;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const S=v.$Le.wrap(new Uint8Array(E,0,E.byteLength));if((0,I.$zn)(S,I.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}p.fire(S)},this.protocol={onMessage:p.event,send:h=>{if(!m){const E=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);u.port1.postMessage(E,[E])}}}}}function l(g){return new Promise(u=>{const p=g.onMessage(m=>{p.dispose();const h=JSON.parse(m.toString());g.send((0,I.$yn)(I.MessageType.Initialized)),u({protocol:g,initData:h})});g.send((0,I.$yn)(I.MessageType.Ready))})}let i=g=>y();function r(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){$.mark("code/extHost/willConnectToRenderer");const g=new s;return{onmessage(u){r(u)&&l(g.protocol).then(p=>{$.mark("code/extHost/didWaitForInitData");const m=new O.$Hqc(p.protocol,p.initData,o,null,u.data);n(h=>m.asBrowserUri(h)),i=h=>m.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/afda215430a3c74eca022a2fea9fea5d906ac8cf/core/vs/workbench/api/worker/extensionHostWorker.js.map
